;-================================================================================;
;-	Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-
;-  file  	: a-4th-design.inc
;-  created	: 23-mai-00
;-  modified	: 17-Apr-01+
;-  version	; 0.6.01+ (re "version.inc" for actual version no.)
;-  assembler	: nasm 0.98-3e, debian-ized GNU licensed version, available: 
;-		:	http://home.snafu.de/phpr/lhputils.html
;-  description	: "lib4th" (l4) Forth language DLL is a self contained sharable
;-		: dynamically loadable library implementing a subroutine threaded
;-		: native code Forth compiler and interpreter, entirely written in
;-		: intel-syntax assembly ("nasm"), w. linux syscalls host access.
;-		: Examples and documentation include a commandline scriptable upn
;-		: calculator, introduction, supplementary system description.
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	: "l4", "lib4th"/"f8"/"calc4th" represent a minimal & supposedly 
;-		: ANS compliant Forth kernel/system.
;-  license	: THE Q PUBLIC LICENSE version 1.0, QT-license.txt, re below!
;-  source	: me, f.i.g., many others and, dpans94.
;-		:	http://home.snafu.de/phpr	/lhpf8.html
;-		: source in intel/nasm syntax assembly. docs include dpans94, f6 
;-		: source (asm, forth for 6800xx & QDOS), w32f 486asm source, etc.
;-  requires	: system: 	i586-pc-linux-ELF, 2.2+, with /proc filesystem
;-		: static prog.:	nothing else, fully self contained
;-		: static lib:	ld-linux
;-		: dyn. lilb:	ld-linux
;-		: programming:	thorough knowledge of Forth... :)
;-		: compiling:	asmutils-0.11(+), bugs-fixed(!) nasm-0.98-3e(+)
;-================================================================================;
;-

;-	

;-
;-================================================================================;
;-
;-	"lib4th" - Copyright (C) 2002 Berlin, H.-Peter Recktenwald (hp),
;-	Patent-, Marken- u. Urheberrechtliche Verwertung vorbehalten.
;-		Tel: ++49 30 85967858, mailto:phpr@snafu.de
;-
;-	Die "lib4th"-Sammlung befindet sich in experimentellem Zustand und 
;-	unterliegt keiner Gewaehrleistung. Verwendung nur auf eigenes Risiko.
;-	Ergaenzende Urheberrechts-Hinweise s. unten und File "QT-lizenz.txt".
;-
;-	"lib4th" IS EXPERIMENTAL SOFTWARE, WITHOUT WARRANTY, which may be used 
;-	at users peril, only. Copyright (C) 2002 Berlin, H.-Peter Recktenwald.
;-	Re below & files LEGAL, QT-license.txt for further copyright information.
;-
;-================================================================================;
;-

;-
;- Content
;-
;-	;- What you (might) get with this package
;-	;- Why Forth?
;-	;-	RPN (UPN, Postfix Notation)
;-	;-	Round "near -ve infinity" ("floor") vs "near zero"
;-	;- Operating "lib4th" supported programs
;-	;- Specific to "lib4th"
;-	;-	Words which don't operate as might be expected
;-	;-	H.W.-Port access
;-	;-	Special kernel data setup
;-	;-	Artithmetics
;-	;-		Signed numbers
;-	;-		Float extn
;-	;-	De-Compiling, debugging
;-	;-	Vectored Words
;-	;- Wordsets
;-	;- Sources & Acknowledgments
;-	;- Nomina
;-	;- Mayor design goals
;-	;- Optimization
;-	;- Relative Addressing
;-	;- Vocabulary Stack
;-	;- Words Structures
;-	;- Assembler
;-	;- Kernel
;-	;- System
;-	;-	Forth Words
;-	;-	Line Editting
;-	;-	Signals (system faults & exceptions)
;-	;-	Assembly, lo.level words, system setup
;-	;-	Adding a hi-level accessible word to "lib4th"
;-	;- Startup sequence for application programs, Assembly level
;-	;- "lib4th" compiling
;-	;- Porting
;-	;- Legal
;-

;-
;-================================================================================;
;-

;-	
;- Pse, consider this text an exposee and a "request for comments" rather than
;- a program documentation. Though I'm fairly certain about the implementation
;- details, because Linux assembly access is quite poorly documented, changing
;- or, yet not even discovered, those deeper details may change, w/o notice.
;-
;- "lib4th" was (shortly) tested w/ several 2.4. kernel versions, successfully.
;- Nevertheless, expect fundamental changes as soon as Linux 2.4 kernel appeares
;- in a sufficiently stable and suitable to RTL and isdnutils extensions version -
;- which seems very unlikely because, apparently there wasn't ever a less 'stable' 
;- development version than those 2.4. 'stable' kernels. even worse, current 
;- (2.5+) devel is just nothing but confusion. X-windows 4+ not better! so expect 
;- L4 referring to Linux-2.2. & X 3+, only, for the foreseeable future...
;-
;-================================================================================;
;-

;-
;- What you (might) get with this package:
;-
;- "lib4th" is a sharable dynamically loadable library
;-	which implements a(n ans-forth compliant) FORTH KERNEL for i586-pc-linux, 
;-	kernel 2.2+, sublevels 5+, not restricted but just not tested elsewhere.
;-	4th programs linked to lib4th require no other library (i.e. no "libc"!).
;-
;- "f8" is a traditional, though executeable code compiling 4th, based on ans-4th
;-	compliant lib4th kernel and extended to suit other requirements.
;-
;- "f8ed" is different to "f8" by it's initial file loading and entering the 
;-	blockfile editor, wich was compiled on the fly.
;-
;- "calc4th" is (supposed to be) a r.p.n. commandline calculator, as a minimal 
;-	application used for feasibility studies to an adequate Forth system.
;-
;- "doc/tests-ok", "answset_idx"
;-	list what actually is implemented, and in which state.
;- "answset_idx"
;-	may further serve as a guideline to strictly ANS compliant programming.
;-
;- "tests/*"
;-	several test input files to "f8"/"calc4th".
;-	"t.sh" executes all those files, sequentially.
;- "4th/*"
;-	'hi-level' Forth system extension files
;- "4th/app/*"
;-	ans core compliance test, 'benchmark', examples, blockfile-editor, 
;-	other applications.
;-	
;-
;- { forth words }
;-	enclosed in curly brackets show single lib4th Forth words or sequences
;-	of words supposed to serve as examples, throughout this text and in the
;-	glossaries. Those examples should be enterd w/o. the "{" "}" brackets.
;-
;-		vocs
;-	displays all available vocabularies,
;-		order
;-	lists {current}, {context}, previous {context} and next wordlists 
;-	in the actually stacked search order.
;-		vocname vlist
;-	listing the words of the rsp wordlist in order of definition; 
;-		words
;-	displays an alphabetically ordered list.
;-		help wordname
;-	displays the resp. glossary section.
;-		v wordname
;-	displays the rsp xec address and, vocabulary which the word belongs to.
;-	In either case, immediates displayed reversed video (black on white bg).
;-
;- author's use of the english language in this text
;-	is the tiny bit of that language which he was taught during a few years 
;-	in London by his friends over there and, (hopefully) no U.S.A.-ish slang.
;-	This text is no "expertise", and well known words which are commonly used 
;-	and understood are supposedly used exactly like that. For instance, a 
;-	"method" remains a "method" and is not an actual implementation of some 
;-	software, a "structure" is anything which might be a repeatable pattern, 
;-	a texture which is subject to some applicable rule, etc., and not a 
;-	specific arrangement of data - which is an "array", a somehow ordered 
;-	group of data w. no implied internal further ordering, etc.
;-	Specific use of words will be described, where appropriate, below.
;-
;-	And, all that only as much as the authors limited skills permit...
;-	(those -from the u.k.- who know, pse, teach me how to do better:)
;-

;-	

;-
;- Why Forth?
;-
;-	Forth is an extendable computer programming environment and a language,
;-	with no hidden details nor design limits, easy to handle as well as to 
;-	learn.
;-	Forth is fast, one reason of which is simply because it doesn't mix data 
;-	and code references nor ever so often just to pass them somehow move 
;-	around those data for each and every "function" call, due to a distinct 
;-	data-stack. It is well suited to hi-rel, safe and secure applications.
;-
;-	I.e. there are applications where simply just one (last) mistake ever 
;-	would be possible - no chance to late "bug" fixes, because some ugly
;-	smell might be your last "bug report", forever! Those applications 
;-	certainly are no subjects to buggy or almost uncontrollable high level 
;-	"protected" by design pseudo-"languages". Which doesn't just apply to 
;-	some outer space oddities but also to plain work as, for instance, with 
;-	hi-energy equipment of any sort of popular radio and electronics stuff, 
;-	or many other common though still dangerous material. 
;-	The other end may be those office applications which deliver important 
;-	data and facts, for future decisions, for taxes and reliably operating, 
;-	in general, which can't be tolerated other than being absolutely exact 
;-	and of ultimate reliability - "finance accounting", &c...
;-
;-	This is where Forth develops it's strength and where I got used to it. 
;-	Consequently, because of high reliability, I like it, thus I do it and, 
;-	recommend you at least honestly try:)
;-
;-
;-	I'd include the tutorial to "pFORTH" by Phil Burk, because it is quite 
;-	easy to understand and almost everything applies to "lib4th", too. 
;-	The complete package is available from
;-		http://music.dartmouth.edu/~phil
;-
;-
;-	No further "explanations" about what Forth is and what to expect (there 
;-	is plenty of exhaustive literature, already) but, another few words on 
;-	the already overly discussed "Reversed Polish Notation":
;-
;- RPN (UPN, Postfix Notation)
;-
;-	Frequently discussed, apparently more as an attempt to somehow justifying 
;-	ignorance than to understanding, is the (not at all!) specific to Forth 
;-	feature of arithmetics with postfix notation. 
;-
;-	Which is not un-common - or, at least, shouldn't be:
;-	"before you make your move, my friend, check how to sail..."
;-	i.e. know what you can do, know what you have, know what you want, then 
;-	do something on that. It is just that simple!
;-
;-	An every day example:
;-			10 kilometres ...
;-	is
;-			10 1000 metre * * ...
;-
;-	Or, for instance, doing some addition
;-
;-	on paper	1000            Forth:  1000    1st to stack
;-			2000 +                  2000    2nd
;-			3000 +                  3000    3rd
;-			-------                  + +     add the bunch
;-			6000                    6000    result on stack
;-
;-	More complicated and, even *because* of RPN much simplified:
;-                   _________________
;-                  |   12 * 6        |
;-        12 + 5 *  |  -------- + 132
;-                 \|   12 - 6
;-
;-	starting with the most deeply nested items, this resolves to 
;-	the sequence of operations
;-		get 12, multiply by 6, get 12, subtract 6,
;-		divide 1st by 2nd intermediate result,
;-		increment by 132, do the sqare root,
;-		multiply result by 5, increment by 12,
;-		write result.
;-
;-	step by step			4th operation,	top on stack
;-		12 * 6 = 72             12 6 *         	72
;-		12 - 6 = 6              12 6 -          72 6
;-		72 / 6 = 12                  /          12
;-		12 + 132 = 144          132  +          144
;-		sqrt(144) = 12          sqrt            12
;-		12 * 5 = 60             5    *          60
;-		60 + 12 = 72            12   +          72
;-
;-	Once the most convenient sequence known a 4th word could be defined
;-	which generally resolves the equation:
;-	            ______________
;-	           |     d * e    |
;-	  a + b *  | c + -------     =  result
;-	          \|     d - e
;-
;-	Forth:
;-	  : result 2dup * rot rot - / + sqrt * + ;
;-
;-	then use
;-		a b c d e result   <enter>
;-	for any such calculation.
;-
;-	Imagine a simpler solution?!
;-	So, do not complain about "difficult" RPN, just wake your mind up:)
;-
;-	
;- Round "near -ve infinity" vs "near zero" mode
;-
;- lib4th operates the 'normal', intuitive way, by rounding near zero.
;-
;- F83 started the fashion of "floored" division mode, which is provided but 
;- not used within standard lib4th words other than in 'rational' vocabulary.
;- Conversion rules are simple:
;-	"r.n.z." division leaves the remainder with the sign of the dividend,
;-	"floored" division leaves the remainder with the sign of the divisor.
;-	"dividend / divisor = quotient * divisor + remainder" always valid.
;- Everything else, however silly it might appear, can be derived from these
;- basic rules, e.g. floored -11/3 returns quot= -4, rmd= 1.
;-

;-	

;-
;-================================================================================;
;-
;- Operating "lib4th" supported programs
;-
;- No "options" exist:
;- "lib4th" based programs receive input by arguments or from stdin with no
;- difference in operation. Any arguments will be passed to the forth interpreter
;- for initial execution. If arguments are exhausted or not passed at all, the
;- program continues interpreting from the <stdin> channel.
;-
;- If stdin and stdout is console, a duplicate console channel will be used and
;- a startup text and all pictured output and input echo sent there. Otherwise,
;- lib4th won't allocate files or tty-s, etc, if not asked to do so, explicitely.
;-
;-	Input	stdin from file/keyboard and/or by arguments.
;-		scripting: use {kbd'} to receive keyboard input if stdin is file
;-	Output	to stdout.
;-		No text output other than by command or if an error occurs.
;-	Error	system messages go to stderr.
;-	Exit code is zero or, signal number if aborted by an error.
;-
;- Initial search order is { local ans forth root } or, { local fig forth root }
;- as set up in (re) "Makefile"; {local} and {root} always included, implicitely, 
;- 1st and last wordlists, rsp.
;- By new definitions extended, {current} wordlist is pre-set to {forth}.
;- {find} is letter-case independently, input defaults to true, non-mapped upper
;- and lower case characters - re {lc-ignore}/{lc-depend} and {uc-map}/{uc-unmap}.
;- Which can all be modified according to actual requirements w. F8INI env-vari,
;- or by command line arguments.
;-
;- Execute (i.e. enter)
;-	echo all-words cr bye | ./f8
;- to receive a(n un-orderd) list of all implemented words or, 
;- re file "lib4words.inc" in lib4th sources, <inc> directory. 
;- Use
;-	help help
;- to receive a notice on how to get the rsp glossary text for a single 4th word.
;-
;- Execution terminates after {bye}, which is always required and can be entered
;- inter-actively or, by argument or file input.
;-
;- Shell execution with "#! /path+progname" requires a blank space after "#!" 
;- and, the additional word {ss} - which is synonym to {include} - being last on 
;- top line, re <tests/f.sh>:
;-    #! /usr/src/Forth/lib4th/f8 { optional initial words } ss
;-    (text of 4th script follows)
;-
;- For convenience, lib4th can be compiled w. an environmental variable being
;- read and {evaluate}d immediately after an application starts, which because
;- it might introduce a security risc is left to a compile-switch in Makefile:
;- If the environment variable F8INI is defined and the pseudo-'option' (which 
;- is a noop word) "--env-ini" is an argument its content will then be used as
;- another initial source of input to the forth interpreter, at startup time of
;- any that user's lib4th applications, prior to execution of passed arguments,
;- and after copying those args to tib.
;- The environment variable is also executeable by {f8ini} of {system} wordlist.
;-

;-	

;-
;-
;-================================================================================;
;-
;- Specific to "lib4th"
;-
;-
;- "lib4th" implements a Forth subroutine threaded native code compiler.
;-
;- Finding whether a program is supported by "lib4th":
;-	c" lib4th" find swap drop	( tf if found )
;- or
;-	ans s" LIB4TH" environment?	( tf if found)
;-
;- If interpreting mode of {C"} cannot be relied upon define and execute:
;-	: l4?  c" lib4th" find swap drop ;
;-	; forget? c" forget" find swap drop ;	( another one, for gforth, etc)
;- In most Forth' l4? could then be removed by FORGET and not waste any valuable
;- memory space. - Executing the {lib4th} word displays actual version number.
;-
;- File or redirected input will not be echoed - as a consequence of using a
;- console window only when i/o isn't redirected (re above):
;-	e=$(echo 10 20 30 \* + . bye|calc4th)
;-	echo $e
;-
;- Standard input is always Linux stdin channel, as passed w. the invoking shell 
;- or program; a console window should explicitely be opened if required and if
;- stdin is not the main console. Independently, keyboard input can be forced with
;- { KBD' name } for the word immediately following KBD', whether in compiling or 
;- in interpreting state.
;-
;-	IF..ELSE.., DO..., BEGIN.. etc,
;- can be used while interpreting: "compiling" is just one (double) increment on
;- "structures nesting" levels, "interpreting" is when nesting levels are zero.
;- Thus any words setting up a structure can be used at either state. Words are
;- compiled and when interpreting execute one by one immediately after compilation,
;- used codespace being re-assigned to the system. Structures may span multiple
;- lines en bloc, executed by the interpreter after all nesting levels resolved.
;-
;-	>BODY
;- Due to the fact that "lib4th" programs use distinct memory areae for code and
;- data >BODY should be used only the way described in ANS standard: With words
;- defined by CREATE, using DOES> to fetch the respective pointer into dataspace.
;- It can - carefully - be used, though, with VARIABLEs and VALUEs, or other
;- words which are explicitely explained to storing data to and/or reading data
;- from alterable memory.
;- While any memory area may be expected readable at any time, the library by 
;- default is set to reading and execution access, only; any attempt to storing
;- into codespace within kernel bounds or pre-loaded program space can leave the 
;- system in an un-recoverable and probably un-safe(!) state, by a 'segfault'.
;-
;- After CREATE, HEAD or ":" (colon) and in "intermediately compiling" state the
;- reference by >BODY points to the 1st available cell in alterable memory.
;- Corresponding DOES> runtime would return that address to defined words;
;- re "tobody-etc-unlisys.msg" in "doc/ans" directory.
;-
;-	>DATA
;- is not a standard word but, is the >BODY aequivalent for kernel supplied 
;- words which refer to supposedly alterable data, transferred to alterable
;- memory (RAM) upon system initialization.
;-
;-	immediate words
;- Several commonly non-immediate words got to immediately execute in "lib4th",
;- re glossary or, {words}/{vlist} which display immediates in reversed video.
;- Those words do not compile themselves. Some other words which involve codespace
;- allocation do also not compile, though not marked "immediate" - re glossary.
;- Display which wordlist/vocabulary a name belongs to (re 4th/misc.f8) by
;-	V name
;-
;-	compile/interpret only words
;- Only those words were explicitely restricted which otherwise would be crashing
;- or irrecoverably corrupting the system, inevitably.
;- Words which store to or fetch from returnstack aren't restricted by definition
;- to "compile only" but, when interpreting should be used very carefully, e.g. 
;- reading current return ptr or pushing a valid executeable address. Other data 
;- would almost for certain end up in a "segfault" or other, erroneous execution.
;-
;-	
;-
;- Names which coincide w. (e.g.) sedecimal numbers,
;- can be prepended with digit "0" to get the number if in any @base > 10 mode:
;-
;-	 c	double cons in {rational cons} wordlist
;-	 e	double cons in {rational cons} wordlist
;- 	c0	ptr to user vari containing base ref into code-space
;- 	d0	ptr to user vari containing base ref into data-space
;-	ed	editor {screen} - (reserved word, n.i.)
;-	ff	<form feed> ascii control action ("page")
;-
;- Numbers defined as a word
;-	compile independently of base or 'double'/'quad' flag settings:
;-	-0			single
;-	-1.  -0.  0.		doubles
;-
;-	
;- Words which don't operate as might be expected (or, unexepectedly do):
;-
;- "top" item on data-stack is most significant, "top" item on return-stack is the
;- least significant part of a multi-cell item. Physical data storage thus always
;- in "litle endian" bytes order, independently of any "type" - with the exception
;- of by ANS-4th required wrt. cells order big-endian operation of 2!, 2@, 2R@, 2>R
;- and 2R>:
;-
;-	byte vs cells order in-consistency
;- by ANS-standard (6.1.0310) required to fetch/store in BIG-ENDIAN cells(!) order,
;- i.e. m.s. cell on tos, being stored to l.s. cell in memory, which is in conflict
;- to the entire x86 environment. Thus lib4th supplies additional ANS mode operands 
;- in {ans} wordlist, a sub-list to {forth}, while any other words consistently
;- implement data access in LITTLE ENDIAN BYTES AND CELLS order, w/o exception!
;-	{ forth also ans }
;- enables ans-mode preference.
;-
;-	{ >r >r } and { 2>r }
;- are equivalent, i.e. data stored to either data- or return-stack organized in 
;- "little endian" byte AND cells order but, because the stacks grow in different 
;- directions the 1st sequence does not change cells order vs double cell operation.
;-
;-	{ [ }, { [[ }, etc. (compile-brackets)
;- While {[} and {]} were made to conforming ANS-4th requirement wrt most common
;- usage by applications there are significant lib4th specific differences.
;- Therfore {[} should not be used by compiling words. Instead, use
;- 	[[ or c[
;- and, always pair ]] with [[.
;-
;-	{count}
;- is not an aequivalent to { 1+ dup 1- c@ }, use {c@+} for that, or for standard
;- conformance, apply the latter example substitute. 
;- lib4th {count} returns what would be expected, though, the pointer to a strings
;- 1st character and, the 1st byte of a standard 'counted string', of up to 255
;- bytes or, any other length value when applied to an asciiz mode string, which
;- begins with a <nul> byte as well as is <nul> terminated.
;- The empty string will only be found if it consists of 2 consecutive <nul> bytes.
;-
;-	{erase}, {blanks} etc.
;- should not be applied to the active area of codespace while interpreting, near 
;- {c-here}, if the compiled <ret>urn from the just executing call could thus be 
;- overwritten. use {c-allot} before any of those words which don't allocate:
;-	c-here 100 c-allot 100 erase -100 c-allot
;-
;-	{leave}
;- is the fig-4th variant, executing the words to follow until the next {loop}.
;- ANS-style {LEAVE} supplied w. file <4th/leav.f8>.
;-
;-	{resize}
;- if orderly implemented implies some elaborate and complete memory management
;- which -imho- is far beyond the scope of the ANS-4th standard. lib4th does not
;- implement a memory management system and thus doesn't supply fully functional
;- {resize}, which consequently can only be applied to most recently {allocate}d
;- memory block. - Use local data-space -re- {>loc} for temporary storage, which 
;- neither requires any "memory management" nor "garbage collecting" garbage...
;-
;-	{while}		-?-
;- will not be resolved by {then} and cannot be used interleaving a {begin} loop.
;- To providing something comparable to the ANS standard {until} and {repeat} do
;- propagate unresolved {if}-s to after the loop structure.
;-
;-
;- Further, for instance, {sign}, {word} and {sp!} are different in fig and ans 
;- style forth to an extent that false use could crash the entire system, which
;- thus are assigned to their respective wordlists, in {ans} or {fig} vocabularies
;- which are sub-vocabularies of {forth}. Others, highly specific to a respective
;- Forth style were also linked to either one of those wordlists, simply to make
;- that fact clearly recognized, e.g. {enclose} in {fig} and {[IF]} etc in {ans}.
;-
;-	{cr}
;- <eol> in-/output compared to/taken from the up to four bytes from user-vari
;- {(eol)}, l.s.byte first - which default to <lf> - ascii 10.
;-
;-
;- Execute
;-		forth fig also also	\ prepare {vlist} and {words} to be found
;-		-vocname- vlist		\ any vocabularies may now be listed
;- to get the words of the respective wordlist of -vocname- displayed, in the order 
;- of definition sequence, use {words} for an alphabetically ordered list.
;-		help wordname
;- displays the resp. glossary section.
;-		v wordname
;- displays xec address and, vocabulary which the word belongs to.
;- In either case, immediates displayed in reversed video (black on white bg).
;- {v} and {help} defined in {root} vocabulary, thus will always be found.
;-
;-	
;---------------------------------------------------------------------------------;
;-
;- Special kernel data setup
;-
;-	system routines w. <pfax> headerflag
;-	[ header ... name | do-word | pfa | ..data... ]
;- kernel words, only, implement access similar to fig-Forth "<BUILDS" construct
;- where the words execution ptr will be called by reference to the name header.
;- A call to <dodoes> will be set up in RAM code-space at startup time which
;- receives the ptr to 'do-word' position and calls the routine kref<@pfa> with
;- ecx := kref'd pfa. ecx is the Forth-VMs' W register, pointing to the header's
;- parameter-field. Header flag <pfax> denotes this calling mode, which is slow
;- but, was required to initially setting up alterable data.
;-
;-	system variables & values w. <varf> headerflag
;-	[ header ... name | do-word | pfa | ..data... ]
;- where @pfa is disp to @d0 in data-space to where the data value initially will
;- be copied and may then be modified. @pfa is disp to data storage wrt @d0:
;-	{ ' name >body @ d0 @ + }
;- points to the data-field in RAM.
;-
;-	
;---------------------------------------------------------------------------------;
;-
;- H.W.-Port access
;-
;- "root" permissions required to setting iopl to level 3, { 3 iopl }, whereafter 
;- the application can revert to normal users rights, e.g. with {real-user} for a 
;- program started in "set-uid" mode. It can then give up it's i/o priority level, 
;- revert to 0 but never after return to level 3, which effectively would inhibit 
;- any further ports i/o - re <MK-perm> in admin directory.
;-	
;-
;---------------------------------------------------------------------------------;
;-
;- Artithmetics
;-
;- Division
;-
;- Division might not be as fast as expected due to extra handling of the cases 
;- where any of those sick division by zero and even overflow "exceptions" would 
;- otherwise throw the entire Forth system out of its environment...
;- v0.4+: Most of arguments checking left to the FPE signals handler, which frees 
;- the div. words from those tests unless the ovf or div0 cases actually occur.
;-
;- Signed numbers
;-
;- There are several explantions and, this is one more, which applies to "lib4th":
;- A "singned number" is a number with a "sign", denoting whether it's value
;- should be taken as "positive" or "negative". Thus (imho) implied is the fact 
;- that each "signed number" exists in it's positive and in it's negative form.
;- Consequently the minimum of any range of "signed numbers" is, for instance, the
;- negative maximum of it's value, e.g. if max = $7fff then min = -$7fff = $8001.
;- Since this should apply oppositely, too, $8000 can not be within that range.
;- I.e., the odd one out is Zero, where +ve and -ve values are the same; Zero is
;- the "neutral element" wrt. signedness. Now, what about -ve signed Zero?
;- It would be written $8000, and computing it's +ve counterpart by negation
;- produce $8000, the same value, again. So this is another "neutral element"
;- which appeares as a consequence of the actual 2-s (or other radix) complement
;- representation of integer numbers in a (this) computer. i.e. the computer does
;- not store _the_number_ but, stores _a_representation_ of a numeric item which
;- only after some (implicit) interpretation can be considered a "signed number". 
;- And, whether "representable" or not, unless _usable_ a "representable" number 
;- can not be considered a "valid number" within the rsp. context. Which applies 
;- to the Zero with Sign-bit-set constellation in 2s-cpl numbers representation. 
;-
;- Wrt ANS requirements consider the following:
;-	0 INVERT 1 RSHIFT INVERT		\ generate 'min-int' the silly way
;-	DUP NEGATE OVER OVER < ROT ROT > = .
;- which by ANS definition must not return TRUE for any non-zero values...!
;-
;- The "negative Zero" - which per definitionem does not exist! - is "Zero with 
;- the sign bit set". Thus, to avoid any confusion, "lib4th" signed arithmetics 
;- is restricted to strictly negatable numbers, consequently excluding $80...00s!
;- The latter, where applicable, is named "negative Zero" througout this text.
;-	
;- Float extn
;-
;- ANS-4th "FLOATING" wordsets are provided as a set of synonymous words from the 
;- "RANUM" vocabulary, which implements fp words by (im)proper real fractions:
;-
;- 1st reason is that for a finance/accounting program which I rely on fp rounding
;- uncertainty isn't tolerable, therefore double integer arithmetics were required.
;- While fp rounding results are somewhat difficult to predict and, numbers visual
;- representation apparently is even more difficult, all integer operations leave
;- rounding as well as overflow conditions under the application's control and 
;- numbers display w/ or w/o fractional parts is not a problem, at all.
;- v0.9.+:
;- The {rational} wordset implements "real numbers" as orderd numerator/denominator 
;- cells pairs, enabling arithmetics and fractional as well as floating point numeric 
;- representation - to any (reasonable) number radix and to any required accuracy. 
;-
;- The next step taken in "lib4th", quad integers precision, is superior to single
;- floats and, range is equal. Finally, lack of floats is compensated by unlimited
;- precision basic operations on multi cell integers ("BIGNUMS") and, by the fact
;- that the MMX registers are free for speeding up other, -imho- more often used
;- basic code sequences - {2over}, etc.
;- Strict use of only integers does also dispense with the requirement of frequently
;- clearing the fp/mmx group of registers (femms, emms op's) which involve some very
;- high execution time penalty and might revert any advantage from fp-op's useage to
;- something quite contra-productive.
;-
;- Nevertheless, provision was taken for a probable future extension, by supplying
;- substitutes to those words which use MMX registers in a functionally equivalent
;- form without, in the {non-mmx} vocabulary/wordlist - with a few, less frequently
;- used exceptions as {vocabulary}, {definitions} etc, substitutes to which can be
;- compiled in the library, with a re<make> - re "Makefile" and "glossary.txt"
;-	
;-
;- De-Compiling, debugging
;-
;- {see} is for use with forth words, {#see} can continue e.g., after a branch
;- or, when debugging a new definition. {see} stores the final code-ptr to {fld},
;- {#see} taking the stored code-ptr for continuation. {s} does 8 times {#see}.
;- {#dcm} can be used to decompile starting at a given pointer.
;- The procedure follows branches and can run into a segfault if supplied with
;- or running into a non-suitable ptr, not in application or library sections.
;-
;- Standard compiled reference to Forth words is by indirect call to true code
;- address at cell in uot (re "constants.inc"), cpl'd in {call-by-disp} mode as
;-	FF 95 dword(disp)
;- with (disp) = (word_index)*4+uv.ultab-(uv.link)
;- which can be back-traced:
;-	( disp ) uot>idx idx>lfa id.
;-
;- If the system hangs, a realtime-signal sent to the 4th job will display the
;- user pointers, after the address where the signal occurred and might thus
;- give some clue to the offending code:
;-	killall -33 f8
;-	killall -9  f8
;- display:
;-	RS>pc>00003339  s<00002690 >p:6CE4
;-	...(other data)...
;- pc> points to where execution was interrupted by the signal, displaying the
;- relative address for reference by PC in the assembly listing file.
;-
;- NOTE:
;- When playing around with un-certain code it might be helpful to having the
;- <killall -9 f8> command ready to immediately <enter>, in another linux console
;- which would keep the system in a safe state even after very bad errors.
;- The script <k> in main directory is provided for an emergency kill of lib4th
;- jobs; <reset>ting the console left to the user to saveing the displayed data.
;-
;- Other debugging means are the linux <strace> utility and the <ald> assembly
;- level debugger - URLs re http://home.snafu.de/phpr/lhplinks.html.
;-

;-	

;-
;-================================================================================;
;-
;- Vectored Words
;-
;- All words, because of indirection via u.o.t. are vectored and, re-directable 
;- by modifying the true address at corresponding to the rsp indices uot entries, 
;- effective dependently on compile-mode, call-by-disp or call-by-uot, at compile 
;- time, only, or even for already compiled programs, at runtime. - Which is a
;- strong reason to "call-by-disp" compiling or, to {mprotect}ing at least those
;- u.o.t. entries which safely should remain in an unmodified state, if it is
;- intended to using the rsp. program in an open to unknown users environment.
;- Some more standard-like redirection further provided to the i/o related words 
;- and for/within interpreter/compiler by ptrs to execution entry-point via the
;- following user-vari (and probably some more):
;-	(>number)	(?error)	(?terminal)	(!sp)
;-	([interpret])	(abort)		(accept)	(block)
;-	(buffer)	(compile)	(debug)		(echo)
;-	(ekey?)		(emit)		(error)		(eval)
;-	(interpret)	(number)	(ok)		(quit)
;-	(source)	(type)		(um/mod)
;- All vectored kernel words can be protected w. {mprotect} to r/o access mode
;- by applying the syscall to u.o.t. memory. With the below mentioned example a
;- protection scheme can further be made non-reversible if {mprotect} redirected 
;- to some noop-word before a last call to mprotect by true address via execute.
;-

;-	

;-
;-================================================================================;
;-
;- Wordsets
;-
;- For ANS compliant interpreting and compiling have {forth} and then {ans} 
;- somewhere in search order, the latter being searched prior to {forth} and,
;- don't insert {forth}/-wordlist, or {fig}, afterwards.
;-
;- Words the syntax of which is specific to ANS version, different from fig/f79
;- versions, belong to {ans} which is a sub-vocabulary of {forth}. 
;- Words specific to fig-style Forth and not of common use, as for instance
;- {vlist}, belong to {fig} sub-vocabulary of {forth}.
;- fig-type aliased words take precedence if {fig} in search order prior to
;- {forth}, which alternatively applies to {ans}.
;- The {forth} and {root} wordlists are made of ANS-mode words and those of other
;- Forth styles which are not of equal names.
;-
;- Execute { tools all-words } for a list of all vocabularies' wordlists,
;- single wordlists can be displayed with { forth -vocname- words }.
;-
;-	re "answset_idx" actual check-list.
;-	n.i.: not supposed to be implemented in the (near) future.
;-	ws.		state/vers
;-	----------------------------------------------------------
;-	BLOCK		dun/1.0.3	(a:b)
;-	BLOCK EXT	dun/1.0.3	(a:bx)	THRU not impl, use "-->", instead
;-	CORE		dun/0.0.45	(a:c)	ANS-std LEAVE in 4th/leav.f8
;-	CORE EXT	dun/0.4.x	(a:cx)
;-	DOUBLE		dun/0.0.51	(a:d)
;-	DOUBLE EXT	dun/0.0.51	(a:dx)
;-	EXCEPTION	0.4.01		(a:x)	ANS-example per 4th/thrw.f8
;-	EXCEPTION EXT	dun/0.0.40	(a:xx)
;-	FACILITY	dun/0.0.42	(a:y)
;-	FACILITY EXT	dun/0.0.42	(a:yx)
;-	FILE		dun/0.0.49	(a:f)
;-	FILE EXT	dun/0.0.45	(a:fx)
;-	FLOATING	dun/1.0.1	(a:e)	RATIONAL numbers provided,
;-	FLOTING EXT	dun/1.0.1	(a:ex)	w/ all FLOATING/EXT opr's.
;-	LOCALS		dun/0.2.02	(a:l)
;-	LOCALS EXT	dun/0.3.01	(a:lx)
;-	MEMORY		dun/0.4.04	(a:m)
;-	SEARCH		dun/0.0.53	(a:v)
;-	SEARCH EXT	dun/0.0.44	(a:vx)
;-	STRING		dun/0.0.44	(a:s)
;-	TOOLS		dun/0.4.x	(a:t)
;-
;-
;- Additional
;-
;-	multi-cell memory and stacks to/from memory and stacks:
;-		m>r m>s n>r nr> ndrop ndup r>m s>m
;-
;-	QUAD Integer (128 bit, +/- 10.7*10^36):
;-		4dup, 4drop, 4not, 4swap, 4over, 4@, 4!, (q.),
;-		q-, q+, q+-, q., q.r, q1+, qabs, qminus, qsm+,
;-		quad, uq., uq.r, uqsm*, uqsm/
;-
;-	ANS
;-	words specific to the ANS-4th standard, or specifically defined.
;-
;-	BIGNUM wordlist
;-	w/ UNLIMITED range, signed multi-cell integer opr & defn:
;-		(n.) (un.) lg(nn) n! n!+ n# n#> n#? n#max n#s n#size n+ n+- 
;-		n- n-> n->n n-top n. n0= n1+ n1- n2dup n<# n= n>number n@ n@+ 
;-		nabs ncmp ndrop	ninteger ninvert nliteral nlshift nminus nn>r
;-		nn>r nndrop nndup nnegate nnorm nnover nnpick nnr> nnroll 
;-		nnrot nnswap nnumber nrshift un->un un. uns* uns/mod
;-
;-	FIG
;-	words specific to the f.i.g pre-79 implementation.
;-
;-	FLOATING
;-		ANS-4th words & conversion 64-bit normal ieee<->rational format.
;-
;-	LINUX wordlist
;-	providing access to the Host System.
;-		Several Linux system calls provided, i.e. {sleep}, {alarm}, 
;-		{mprotect} and, other standard Forth words which are simplified 
;-		syscalls. Further, generic {syscall} for any other system calls.
;-
;-	NOVOC
;-		provided for debugging purposes, words for kernel access, only.
;-
;-	RATIONAL
;-		rational numbers ("relle zahlen"). floating point operations
;-		on ordered cells pairs which represent denominator, numerator
;-		of a(ny) (im)proper fractions representable by a cells pair.
;-		this wordset can achieve absolute precisision for rational and,
;-		any approximate precision for irrational numbers.
;-
;-	VT wordlist
;-		for coloured console and xterm (others not tested) display, 
;-		text appearance and positioning. by vt220/vt102 ctrl-s.
;-
;-	

;-
;-================================================================================;
;-
;-
;- Sources & Acknowledgments
;-
;- basic lib4th is an entirely new implementation, code "borrowed" from nowhere,
;- every  concept, though not necessarily new, thorougly thought over and
;- implemented in a way apparently appropriate to linux/ELF environment. Thus it
;- owes nothing to a particular person or implementation and relies on no third
;- party property, if not explicitely mentioned.
;- It certainly would not have been done without several sources of knowledge:
;-
;- I wouldn't have made it into Linux without many ideas from and discussion 
;-	with my always patient friend, Boris.
;-
;- Linux assembly
;-	was made possible to me by Konstantin Boldishev and his "asmutils", 
;-	and I owe much to the help of those fellows from the linuxassembly 
;-	mailing list... - re http://linuxassembly.org/
;-
;- Charles Moore
;-	who 'discovered' Forth and left it to the public domain.
;-
;- Gordon Charlton
;-	Basic implementation of real numbers -re- vocabulary {rational}
;-	from the Forth Sientific Library, FSL Algorithm #46.
;-
;- Skywave Forth
;-	by H&H Husband, a ROM-ed realtime multitasking native code compiling 
;-	& interpreting system for the Z80 cpu. Never out-performed nor even 
;-	approximately equalled by any other 4th O.S. I know of...
;-	The lib4th interpreter/compiler was designed after this system.
;-
;- Wireless World Forth Computer
;-	an early hard- & software 4th computer design and implementation based 
;-	on the 6502 cpu.
;-
;- LMI Forth
;-	in an implementation by Computer-One for the Sinclair QL (680xx).
;-
;- Artic Forth
;-	a (very early) Z80 implementation in RAM.
;-
;- "Forth 83" and "Die Programmiersprache Forth", by R.Zech,
;-	...most essential sources of information about Forth.
;-
;- ANS-Forth
;-	A standardisation approach. Main reference to recent Forth's semantics.
;-
;- Forth
;-	implementations, literature and even computers (like Rockwell, AIM) were 
;-	many, the names of which I forgot by now or, which are just too many to 
;-	mentioning here.
;- gforth
;-	an example implementation which was taken for 'worst case' reference. 
;-
;- comp.lang.forth news-group
;-	several contributors helped me to get things "fine tuned" and clarified 
;-	uncertain design features.
;-
;-
;-================================================================================;
;-

; <a name="Nomina"></a> ;BGN for the html docs
;-
;- Nomina
;- ------
;-
;- annotations:
;-
;-	(n.i.)
;-		(yet) not implemented
;-	-?-
;-		points to something which the author isn't certain about and, 
;-		whereupon any help would be very welcome: pse, mailto:phpr@snafu.de
;-	( n1 :=	n2 )
;-		n2 assigned to n1 (new value of n1 is n2)
;-	( n1 = n2 )
;-		n1 equal to n2
;-	( n1 == n2 )
;-		n1 and n2 identical (same value, same storage place)
;-	( n1 =/= n2 )
;-		n1 not equal n2
;-	( n1 >/ n2 )
;-		n1 signed greater than or equal to n2
;-	( n1 \< n2 )
;-		n1 signed smaller than or equal to n2
;-	@name
;-		content at address/variable {name}
;-	{name}
;-		Forth words in this text(s) are noted between braces
;-	{?name}
;-		abort if some test not passed
;-	{name?}
;-		ret true flag if some test was successful.
;-	<name>
;-		assembly source label, lib4th internal access, only.
;-	does{ ... }
;-		hi-level aequivalent to described action of a word.
;-	hi-level word
;-		specific to lib4th is a subroutine call by indexed uot-ref. or,
;-		by pc-relative subroutine call, where the latter applies if the 
;-		rsp. call can be replaced by an indexed uot call, w/o. further 
;-		adjustment.
;-	immediacy
;-		A Forth word is 'immediate' if it executes whatever semantics is 
;-		defined for the actual "state", immediately after being found in 
;-		the input strem, regardless of whether the system is in compiling 
;-		or in interpreting state. Immediacy can temporarily be suppressed 
;-		for a single word, e.g. w. {postpone}.
;-	lo-level, "primitive" word
;-		specific to lib4th is a word programmed w. directly executeable 
;-		processor operations instead of subroutine calls to 4th words.
;-	letter case
;-		is consistent within words, i.e. never mixed!
;-		library supplied words are lower case, with the exception
;-		of those required to switching back from upper case and, the group
;-		of ANS defined environmentas queries and query strings.
;-		Initial input state is case independency, thus any Standard ANS 
;-		Forth Program can be compiled w/o. modifications, to this respect.
;-	nos
;-		address of next item on datastack
;-	ovf
;-		"owerflow".
;-	primitive word
;-		re "lo-level", above.
;-	smudged
;-		words cannnot be found w. the usual means, e.g. {find};
;-		the Forth word {smudge} toggles this state.
;-	stack
;-		"last in - first out" memory access method by a single pointer.
;-		Access no other than by the self maintaining "stack pointer".
;-		"top" of a stack is 1st accessible item, regardless of stack's 
;-		direction of growth. Stack "bottom" is address of empty stack.
;-	tor
;-		address of top of returnstack
;-	tos
;-		refers to address of top of datastack
;-	@tos
;-		item (cell) at tos - which in lib4th is content of register eax
;-	use{ .. }
;-		short application example.
;-
;- words origin
;-
;-	(4)
;-		hi-level word (4th subroutine calls vs direct op coding)
;-		those words can also serve as assembly level application 
;-		programming examples.
;-	(79)
;-		79-FORTH word
;-	(83)
;-		FORTH-83 word
;-	(a)
;-		ANS-4th word, as described in DPANS94 standard draft,
;-		e.g,
;-			(a:c)	core
;-		appended 'x' is the rsp extension wordset
;-			(a:cx)	core ext
;-		re above, "Wordsets", for other abbreviations.
;-	(f6)
;-		non-standard word, taken from f6 (for the 680xx)
;-	(f8)
;-		non-standard word, new w/ lib4th/F8.
;-	(fg)
;-		word from f.i.g. model forth (pre-79 'standard').
;-	(h4)
;-		Skywave's real-time multitasking Forth for the Z80.
;-	(l4)
;-		lib4th specific
;-	(w3)
;-		Tom Zimmer's Win32Forth (several "Windows" variants)
;-	
;-
;- words cathegories
;-
;-	(c)
;-		constant (32bit) value
;-
;-	(C)
;-		'compile only' restriction
;-	(e)
;-		word whereafter in compiled code {flg} can be used to 
;-		read eflags reflecting the current operation's result.
;-	(i)
;-		immediate(ly executing) word, which regardless of @state
;-		always executes.
;-	(ix)
;-		special interpreter word, not being compiled, immediate.
;-	(k)
;-		a (currently) headerless word, in library only. Meant for
;-		kernel only access - insert wordheader to "lib4words.inc" 
;-		for common accessiblity.
;-	(kv)
;-		a "value" defined in L4 kernel, {to} applicable.
;-	(m)
;-		"macro": optionally compiles expanded inline code. (n.i.)
;-	(r)
;-		kernel word w/ args passed by reg or by reg ref other than @tos
;-	(s)
;-		word accessing a linux system call; ((s)) secondary call.
;-	(u) or (uninitiated)
;-		lo-level subroutine, can be run after fatal errors
;-		or before system fully initiated, i.e. not relying 
;-		on pointers into user-vari or on kernel reference.
;-	(v)
;-		vectored word/data
;-		can be re-defined, e.g. { ' .s idx>xec 4th>abs (ok) ! }
;-	(w)
;-		word which in interpreting mode executes directly.
;-		(as {bye}, {create}, {evaluate}; currently no other such words)
;-	(x), ((x))
;-		word using one or more of mmx register(s) mm0..mm3,
;-		((x)) secondary call. those words co-exist w/o mmx regs useage in 
;-		{non-mmx} vocabulary, which automatically replace the mmx-ones if
;-		__MMX compile switch in <Makefile> defined. 
;-		mm4..mm7 unused by L4, left to user routines.
;-	(X), ((X))
;-		words the non-mmx alternatives of which should be activated by the 
;-		rsp. compile-switch, at <make> time. they are not accessible as an
;-		alternative, explicitely, if the mmx-variant exists (was cpl'd).
;-
;- memory:
;-
;-	au, address unit
;-		consecutive group of consecutively addressable bits.
;-	byte
;-		no. of bits per address unit, dft = 8
;-	byte order
;-		little endian, inconsistent use of big-endian cells order (but little 
;-		endian bytes) in {ans-vocabulary, for standard compliance.
;-		no other words un-supposedly operate on big-endian byte/cells order.
;-	data items
;-		cells (re below), unless stated
;-	section, segment
;-		a contiguous memory section of equal assets
;-
;- types:
;- data-types by virtue, i.e. Forth does not implement inherent data typing.
;- (Most?) Forth programmers rely on the power of the conscious mind...
;-
;-	a
;-		true address (virtual, specific to the particular Linux job)
;-	c
;-		a single character, dft = one 8-bit byte
;-	ch
;-		"channel" number, index into "channel definition table" (cdt).
;-	ccc
;-		string of characters
;-	cell
;-		group of little endian ordered 4 bytes
;-	d
;-		signed double
;-	df
;-		double floating pt number, by quad ranum, -re- "qv", "ranum".
;-	double
;-		signed integer value represented by two 
;-		consecutive cells, little endian, m.s. cell @tos
;-	dv
;-		double ranum, a pair of doubles, numerator and denominator.
;-	false
;-		cell of all unset bits
;-	fd
;-		Linux file descriptor, a "channel identifier", for internal use, 
;-		only. standard i/o access w/ ref to "channel" numbers and {ch-id}.
;-	ff
;-		condition not met flag (single int 0)
;-		(simplistic "logic" describes this as the {false} flag)
;-	fp, f1, f2...
;-		floating point number, represented by a double ranum
;-		(double f.p.-s represented by quad ranum) -re- "dv", "ranum".
;-	f, flg
;-		flag, any value or sequence of bits, fitting into one cell
;-	tf
;-		condition met flag (single int -1)
;-		(simplistic, binary "logic" describes this as the {true} flag)
;-	n
;-		signed single
;-	.n1..nn N
;-	.n.N
;-		counted, multi-cells sized integer ("bignum")
;-	o
;-		octet, eight cells item, may also represent a quad ranum
;-	p
;-		forth ptr, rel kernel reference (i.e, p is disp to KR = ebx)
;-	..q
;-		quotient of an arithm. division
;-	quad
;-		signed integer value represented by four 
;-		consecutive cells, little endian, m.s. cell @tos
;-	qv
;-		quad ranum, a pair of quads, numerator and denominator.
;-	..r
;-		remainder of an arithm. division
;-	ranum
;-		rational (or "real") number, represented by pairs of sings, 
;-		doubles or quads, interpretted as an (improper) fraction.
;-		-re- {rational} vocabulary for further description.
;-	sing
;-		signed integer value represented by one cell
;-	s
;-		system control item, two cells on compilestack (i.e. datastack)
;-	true
;-		cell of all set bits (though not optimal for i386)
;-	u
;-		unsigned sing
;-	ud
;-		unsigned double
;-	v
;-		sing ranum, pair of integers, numerator(@nos) denominator(@tos).
;-	..xx..
;-		data on respective stack depend on word(s) execution
;-
;-	
;- Glossary notation
;- -----------------
;-
;- wordname	stack(s)		source		callname	wordlist
;-	comment...
;- 
;- wordname	the name by which the Forth word will be found.
;- stack 	the word's data flow on stack(s):
;-			( before -- after )
;-		if word scans for a string <ccc> following in input stream:
;-			ccc( before -- after)
;-		data flow on return-stack:
;-			(R: before -- after)
;-		on compile-stack:
;-			(C: before -- after)
;-		data-stack when interpreting 'immediate's:
;-			(X: before -- after )
;- source 	the word's semantics origin, or original description, plus
;-		'immediacy' and other properties specific to the particular word.
;- callname	library symbol by which the word accessible at lo-level i.e.
;-		in assembly or, from other programs which call the library.
;-		callname is wordname if not explicitely given.
;- wordlist	to which the word belongs.
;- comment	(obvious...)
;-		"xec:" comment applies to executing state,
;-		"cpl:" comment applies to compiling state.
;-
;-	
; <a name="Nomina"></a> ;END for the html docs

;-
;- Mayor design goals
;- -------------------------------------------------------------------------------
;-
;- "lib4th" is a sharable library which implements a(n ans-forth compliant)
;- Forth kernel for i586-pc-linux, kernel 2.2.5(+).
;-
;- "F8" is a traditional, though executeable code compiling Forth based on
;- "lib4th". "traditional" to the respect that it implements basically a pre-79
;- f.i.g. style Forth system, extended by the valuable features of the more
;- recent standards, ANS inclusive. It doesn't restrict programming to ANS-4th
;- style nor is it an "ANS-Fort" though at most, ANS-Forth compliant.
;-
;- "calc4th" is the minimal program to entering the Forth system provided by
;- lib4th - static version is just 16 bytes more than the library.
;-
;- Forth was always designed to support multitasking, so does "lib4th", which
;- further enables real time control with the "rtlinux" extensions. Btw, "real
;- time" is not speed but, precision & timing reliability! and, I won't further
;- go into discussion neither about what else it is (supposed to be) nor what
;- it might be good for: None will ever be forced to using it, so just do - or
;- don't. Anyway, RT control yet is not implemented and won't be, soon.
;-
;- There are Linux specific drawbacks. For instance:
;-	a jobs priority can be de- but not in-creased by any non-root users; 
;-	i/o timeout by sys_select is time-consuming and inflexible.
;- Many more the like, thus "true" and easy to handle multi-tasking of Forth 
;- jobs needs some more design considerations and will not soon be implemented.
;-
;- The entire system is ROMable, location independent, dynamically extendable
;- and re-entrant, to safely multi-tasking/-threading. Running independently
;- of any auxilary code/data, relying on the Linux/ELF kernel, only, i.e. no
;- more libraries required!
;-
;-	
;- Optimization
;-
;- The library code itself is yet not near optimal!
;-
;- What actually is "optimal"?
;- There would be many aspects, some of which exclude others, e.g., wrt memory
;- requirements and executional speed, compile-time and executing speed, assets
;- vs simplicity, probably even source "readability" vs program efficiency, etc.
;-
;- "Optimal" for lib4th is assumed to preferrably applying to
;-	correctness and reliability
;- and,
;-	safety wrt 'outer space'
;-	executional speed
;-	completeness of ANS defined wordsets (no IEEE-style FLOATs, though)
;-	availability, including startup time
;-	maintainability
;-	compiletime
;-	timing exactness (for 'real time' applications)
;-	memory requirements
;- about in that ranking, though certainly mixed because of interdependence and,
;- the limited programming skills of the author :(
;-
;- Nevertheless, a few features worked out to "optimize", by themselves:
;-	Forth
;-	  -!-
;-	assembly source 
;-	  implementation, wrt efficiency, reliability, safety and, simplicity of 
;-	  code and ease of maintainance.
;-	native code compiling
;-	  which was begun because it was the easier way to implementing the 
;-	  scripting facility, e.g. interpretive DO/LOOPs, etc.
;-	@tos item 
;-	  kept in a cpu register, again, was just the easier way to implement, 
;-	  which worked out as another optimizing factor...
;-	register assignation
;-	  dispensing w/ silly, un-efficient datastack-ptr := ESP assignation!
;-	  @tos = EAX, which is the traditional accumulator, the rsp operations
;-	  w/ which are highly optimized in the cpu - re the rsp manuals.
;-	soubroutine threading
;-	  the 'inner interpreter' is the cpu, when executing the <ret> code.
;-	last call modification to <jmp>, to avoiding a <ret> immediately after
;-	  return from subroutine - re intel 586+ docs!
;-	indirections
;-	  as few as possible, most work done at compile-time.
;-	static
;-	  the library code is fully static, contains no variable data nor 
;-	  references which would require relocation, at any time. the very
;-	  simple, straightforwardly arranged initial 'wordlists' generated
;-	  at startup, on the fly, almost instantly...
;-
;- "Tail recursion" optimization, about which lots of texts can be found, where
;- many of those 'system designers' seem overwhelmed of themselves when they'd
;- implement that compiler facility, will just be done as a 'natural factor' of
;- lib4th's "last call resolution" to a JMP instruction. 
;-
;- Expanded code ("macro") compiling will become the real "optimzation" thing,
;- once functional, which is prepared but not yet used. I do not intend to 
;- implement any highly sophisticated optimization stuff - which seems to be
;- pretty useless if only the basic system itself was implemented efficiently.
;-
;- Yet, the compiler generates and the library implements fairly efficient and
;- fastly executing programs, shown by some simple benchmarks: lib4th already was
;- considerably faster than, e.g., "gforth" (l4-0.1.03 vs gforth 0.4.9) which its
;- documents quite verbosely explain as extensively "optimized" (whatever that
;- may be) and which was said to be the fastest fully featured 4th for linux.
;- While I won't over-emphasize on "benchmarks", those tests proved "f8" being
;- about double as "fast" as "gforth" was, while startup-time measurement figure
;- for the statically linked "4" with linux command
;-	time 4 < b
;- the input-file "b" supplying the {bye}, was just all zero, worst case 17ms.
;- Though the reliability of such tests is not very high, repetitive exactness 
;- deviates by up to 30% (w/ Linux "time..." command)!
;-
;- What for? - I'd just want to *see* whether the "optimizing" statements which 
;- were overly repeated in those discussion groups apply to real code - where 
;- I'd never see any measurements deviation or faults figures mentioned, thus 
;- rendering those statements being nothing more than almost meaningless words.
;-
;- Another example, an application to converting a 'screenfile' to sequential, 
;- orderd by 'lines', though being called within a bash script and compiling
;- the required words 'on the fly', took about 15% less execution time than a
;- readily compiled aequivalent program which was written in "C".
;-
;- Therefore, not much more to telling about L4 code 'optimization'.
;-
;-	
;- System Security
;-	(The author is not an expert wrt system or network security, thus any 
;-	(help, hint, correction, etc. would be highly appreciated.
;-
;- lib4th does not rely on extended access rights, application programs can thus 
;- be restricted to any appropriate extent. The {real-user} word is provided for
;- safe return to real user mode when in a setuid-program.
;- Standard installation will set the library files to non-writable for any user.
;-
;- 4th-words proctection achievable by "seal"ing selected memory area, re below.
;- The library does not rely or act on or, read/set any environmental variables,
;- by itself. Environmental variables related 4th-words refer to 1st occurrence.
;- It also does not rely on program execution names or any configuration file.
;-
;- Simplest attempt:
;- Provide a complete program which does not depend on the interpreter, numeric
;- input inclusive - which is just the "normal" case(?). Getting a bit further, 
;- it might be helpful to compile a fully static program which thus won't be a 
;- subject to unwanted changes wrt any libraries and wrt its own code will be safe
;- because it would entirely be run from non-alterable memory.
;-
;- And, consider the following:
;-
;- Traditional implementations seem to develop a security risc, as there is no
;- means to safely protecting the system from unwanted programs execution.
;- Reason is that threaded interpretive forth compilers generate data references
;- which the inner interpreter then would take for entry into already present
;- executeable code. Thus compiling a program and executing from within the same
;- program requires just the common linux sections setup, .text for r/x, .data
;- and/or .bss section for r/w, i.e. no r/w/x memory.
;- No means exists to knowing in advance whether an address points to executable
;- or just to some in-active and safe data. Thus reliable safety precautions
;- would be very difficult to maintain and always be highly vulnerable.
;-
;- A native code compiler and interpreter might first appear even more a security
;- risk. But, the system integrity in Linux can be cared for by normal access
;- rights settings, which usually prevent any other than a program run by root or
;- an equally privileged user/group or, set suid, to install the required r/w/x
;- permissions for runtime generated code execution. Thus, by purposely executing
;- in a way the risc of which would be commonly known and easily be avoidable the
;- apparently unsafe r/w/x access mode of an executeable code Forth compiler works
;- out to (almost?) the single sufficiently safe choice. -?-
;-
;- Theory, so far, and not that easy. Thus, until everything will be verified for
;- certain, this system won't be loading any pre-compiled code modules but, only
;- compile on the fly from ascii text sources, to any programs remaining fully
;- controllable.
;-
;- Current implementation won't enable non-compiling execution of any program
;- which uses the interpreter. A safe program thus should provide every means
;- necessary, e.g., to evaluate a number, or text, without using the immediately
;- executing mode of the compiler which is standard lib4th "interactively
;- interpreting" mode - re {number}, {find}, {call}, {execute}, etc.
;-
;-
;- Write protection example:
;-
;- A compiled program can safely be protected, irreversibly, while leaving the
;- compiler enabled for new words, for instance with:
;-
;-   also linux also hidden	      ( system spec. words   )
;-   (uot) 4th>abs palign-            ( prepare base address )
;-   (lkindex) @ 4* palign            ( and memory range     )
;-   dup 4/ 1+ (lkindex) !            ( next writable index  )
;-   ['] mprotect dup idx>xec 4th>abs ( executeable address  )
;-   ['] 2drop idx>xec 4th>abs        ( xec of {2drop}       )
;-   rot idx>uot !                    ( patch uot            )
;-   prot-x prot-r or                 ( enable r/x only      )
;-   swap execute                     ( w-protect uot space  )
;-   previous previous		      ( rst search order     )
;-
;- whereafter the until then used uot space can't be changed - {mprotect} as well
;- as any other library words. Since the generic {syscall} excludes mprotect, this
;- is a safe means to protecting present pointers against unwanted modification. A
;- similar procedure could be applied to codespace, which doesn't bear modifiable
;- data, and thus may reliably be sealed further.
;- Though even this one would not be of ultimate safety, simply because directly
;- executeable code could by compiled, byte by byte, and then executed by anyone
;- who has access to the compiler.
;- To further get safe, re-define the lib4th interpreter to direct execution of 
;- any permittable words, and disable the standard interpretive compiling mode!
;- This would disable direct execution of any structures, in interpretive mode,
;- which anyway would rather be a development tool and not required by a program.
;-
;-	
;- Documentation
;-
;- certainly is another considerable means of program security as well as 
;- reliability. Though I won't write just another book on Forth, L4/F8 is thus
;- documented to every reasonable extent. lib4th is not intended to containing
;- any hidden details. Users who find anything left to guessing, pse, mailme
;-		<mailto:phpr@snafu.de>
;-
;- Those descriptions are distributed over the different source texts, which after
;- <make>ing can be found bundled together in files <glossary>, <glossary.idx> in
;- the <doc> directory.
;- Further, <make html topx xref> compiles a fairly comprehensive set of browsable
;- html reference texts and a cross reference list of asm labels. Descriptions
;- to internal support routines won't appear in the glossaries because they aren't
;- useable for hi-level programming: To changeing the sources consult the sources...
;-
;- But, "lib4th" programming requires basic knowledge of Forth, which can be
;- achieved by standard literature, e.g. the ANS-Forth standard document.
;-
;- Further information:
;-	http://www.forth.com
;-	http://www.taygeta.com
;- Tutorials on Forth:
;-	http://www.forth.org/fig.html
;-	http://www.forth.org/compilers.html
;- Forth Pointers:
;-	http://www.memnonio.com/forth.html
;-	
;-
;- -------------------------------------------------------------------------------
;-	
;-	
;-
;- Relative Addressing
;-
;- Usual access method in Forth is by named pointers, "variable"s or "constant"s,
;- which are executeables, just as any other Forth "word", which return either
;- the constant by numeric value or the pointer to the requested data space as
;- the displacement to the Forth system's base address. Standard implemented
;- Forth words do not refer to absolute addresses, wrt neither physical memory 
;- nor ELF system address space of any job in the tree.
;-
;- "lib4th" being a dynamically loadable library requires relative addressing to
;- go even further because prior to linking to a program it's position cannot be
;- determined and thus any items should be referrable independently of its
;- respective position - which is accomplished by PC-relative and displacement
;- addressing wrt the respective link, for any wordheader reference (as well as
;- other linked lists in the kernel system). Usually not much of concern this is
;- important, though, when referring to certain L4 system entities:
;-	prevlink = link - disp.to.prevlink
;-	disp     = @link
;- and
;-	newlink  = link + disp.to.newlink
;-	@newlink = disp.to.newlink
;-
;- Linked lists are chained by displacements, displacement being the signed count
;- of bytes between the link and its destination, counting +ve toward lower
;- addresses. Members of a linked chain can be found by repetetive application of
;- { ptr dup @ - }. Thus, for instance, the commonly known sequence 
;-		{ context @ @ @ ... @ } 
;- which links through the wordlist of a vocabulary should be substituted
;-		{ context dup @ - dup @ - dup @ - ... dup @ - }.
;- Pointers, e.g. to execution addresses, are relative to their own position.
;- Other reference points are beginning of dataspace at the initial {here}={d0 @}
;- and, at beginning of codespace, wrt initial {c-here} = { c0 @ }.
;- Adresses in uot which substitutes the g.o.t (global offset table) of linux/ELF
;- libraries, for executional speed are the only true address references, set up
;- at startup within the lib4th initiating procedures.
;-
;- Physical dataspace is not typed, neither is memory in Forth. Though by
;- comparing the execution pointers it will be possible to deriving some typing
;- in a non-standard(!) way - which by any means of orderly Forth programming
;- would just be a mere nuisance and useless as well as needless: Programs
;- determine data usage. Certainly, any sort of datatypes defining entities
;- could be set up and then be used in a Forth program, with {CREATE} etc...
;-
;- What is referred to as the single one datatype in dpans document, the 'CELL',
;- in fact is not a type but a measure, the unit of which is a system defined
;- entity of at least 16 consecutive bits, i.e. two 8bit-bytes, and which for
;- lib4th is defined as a contiguos four bytes (IA32 'dword') item in virtual
;- address space, where-/whatver.
;-
;- Thus:
;-
;- Address space is task specific, though commonly accessible,
;- all references relative wrt the kernel code reference pointer.
;-
;- Resource of addresses space is indeterminate, may be physical RAM, ROM, any
;- hardware, any peripheral or file. Neither of these implement address related
;- data typing. lib4th/F8 always reads/writes any data with no loss of information,
;- whether w/ files or memory, regardless of obscure files "typing" (e.g. 'bin').
;- Port and absolute memory addressing can be enabled with the usual Linux access
;- methods and, by specific 4th words.
;-
;- The per task address space is split into several sections:
;-
;-	datastack can be compiled as a 64K section, the	bounds 
;-		of which thus need no control because possibly 
;-		wrapping around at 64K would overwrite very 
;-		old data of - presumably - no importance.
;-		Due to higher executional speed the library by
;-		default does not use that feature, but fully
;-		sized register reference - by <edi>, instead.
;-	dictionary bounds will be controlled when compiling, 
;-		where executional speed is not most important. 
;-	error checking internally will catch most operational 
;-		faults, as much as possible, regarding safety 
;-		and fault tolerance more than runtime speed.
;-		segfaults, arithmetic faults and window resizeing
;-		watched by signals w. no runtime penalty, at all.
;-	returnstack memory and variable data area is a separate 
;-		section in .ss and may be watched similarly.
;-
;- Forth compiles fairly compact code, a single word reference wrt memory space
;- is 6 bytes for the executeable code compiler vs the minimum of 4 bytes plus
;- nesting/un-nesting code per word of traditional execution token interpreters.
;- To effectively extend code-/data-space any number of tasks could be assigned
;- to the currently running job. Dataspace is no limit, either, as besides the
;- space in the .ss segment already reserved (128K), any more could be taken with
;- the sys_brk system call to extending the .bss section which supplies the L4 
;- 'data space', and by initiation with <push/pop> in .ss without specific limits.
;- {call-by-disp} mode compiles non-relocatible code w. 5 bytes per standard word
;- and is somewhat faster executing (acording to tests w. v 0.0.56 by about 30%
;- wrt gforth 0.4.9). uot-referencing mode can be restored w. {call-by-uot}, both
;- in {compiler} wordlist.
;-
;- Memory defaults are configurable by "lib4th" source compilation.
;- lib4th currently implements no specific memory management.
;-
;- Because runtime compiled words can't rely on the ELF style GOT it introduces
;- an own, similar list, the "User Offset Table", uot which lists any currently
;- available 4th words, transparently to the programmer, used within the {find}
;- procedures and, immediately after loading pre-compiled code, i.e. "modules".
;- Base address of this table can be found with { 0 idx>uot }, 1st free entry is
;- at { (lkindex) @ idx>uot ).
;-
;-
;- Stacks
;-	actual memory assignment noted in -re- "constants.inc".
;-
;- "top" of any stack is 1st accessible item, regardless of the
;- 	 particular stack's direction of growth.
;- "bottom" of a stack is address of empty stack.
;- "above"  refers to next item, regardless of growth direction.
;-	Thus with lib4th a cell "above tos" is at lower address
;-	while a cell "above tor" resides at higher address!
;-	Which isn't much of concern since hi-level access is
;-	independent of actual addresses, and macroes readily
;-	provided for lo-level access ("lib4th.mac", etc).
;-
;- Returnstack Pointer
;-	in ESP register, push is pre-decrement and store.
;-	Returnstack overflow, after excessive recursions, etc, might
;-	run into data-stack, the two of which share a 128K area.
;-	Latest jobs returnstack would underflow into non-allocated
;-	memory, thus give a segfault, other jobs might overwrite
;-	preceding jobs bottom of uot(!).
;-
;- Datastack Pointer
;-	in ESI register for 2nd and further items, top of stack
;-	cell is held in EAX. Push is store and post-increment.
;-	Initial datastack bottom would underflow into r/x .text 
;-	section, other jobs underflow into older job's data-space.
;-	Datastack top would overflow into code-space (128K by dft).
;-
;- Float stack
;-	does not exist, i.e. no cpu/fpu-related FLOATING words implemented.
;- Compilestack
;-	is datastack.
;- Characters stack
;-	console & task specific. (planned, n.i.)
;-
;- Dataspace
;-
;- User-Task Area (4th "user area")
;-	in EBP register, pointing to 40-th item in user area, 
;-	which is expanding to descending addresses.
;- Local data pointer
;-	in EDI register, temporarily
;- Kernel Reference Pointer
;-	in EBX register points to <Y>, 1st address of library.
;- mmx-related Data
;-	will be processed in mmx registers and stored to datastack,
;- Text Stacks (n.i.)
;-	text processing can be substituted with local memory.
;- Screen (n.i.)
;-	blocks of task specific console windows description data,
;-	independent of eachother, w. own char i/o stack (or pipe). -?-
;-
;-
;- Tasks -?- (n.i.)
;-
;- Basic "lib4th" tasks are standard linux threads, from <clone>, with own stack
;- and memory areae as well as an own dictionary, initiated with the "parent"s
;- environment and later on operate with resources specific to that task. On a
;- smaller scale Forth words can be run as independent jobs within a particular
;- "lib4th" clone, with just separate stacks and a sub-set of the user variables,
;- not enabled to compiling new code, if designed to self-contained operating. 
;-
;-================================================================================;
;-

;-
;- Vocabulary Stack
;-
;- Implemented as two interleaved stacks, 1st of which carries two items which
;- are pushed one posn up when a vocabulary is called, 2nd item pushed off memory
;- unless {also} executed prior to vocabulary name. 2nd stack is maintained by
;- {also}, {previous}, {only}, and its size defaults to 16 items of double cells,
;- top vocabulary pushed off memory if in excess of {#vocs} items:
;-	1st cell is the respective wid, the vocabulary's voc-link position.
;-	2nd cell, towards lower(!) address, used for flags during find procedures
;- and supposed to carry further flags specific to the particular voc and its posn
;- in the search order - currently only a marker for multiply present wid-s
;- implemented, to avoiding multiply searching the same vocabuary (v0.0.50+).
;-
;- 'push', by {also}, is towards lower addresses, {also} and {previous} both,
;- include the top two items stack - as {get-/{set-order} do, also. Because 
;- ANS restricts wordlist identifiers to cell size those words cannot re-/store
;- the flag items. Additional {get-vocs} and {set-vocs} of root wordlist do.
;-
;- voc-stack(s):
;-	top[context][ocontext][ #vocs more wordlists ... ]bot, low address
;-	   [-> {also}			    {previous} <-]
;-	   [	    {rvoc} <-]
;-	   [-> -vocname-     ]
;-

;-
;- Words Structures
;-
;- Words linkage is quite straight-forwardly implemented in a traditional and
;- standard way, no "hash"ing nor other sophisticated trickery, which might
;- sometimes be speeding up the process of compilation in a less efficiently
;- designed environment, at the penalty of loss of those probably more valuable
;- features which otherwise would be inherent to a standard Forth system. Thus
;- instead, lib4th will be utilizing the features of (sub)vocabularies and a
;- vocabulary stack, with several wordlists dedicated to certain usage groups,
;- which effectively equals "hash"ed compiling speedup when carefully used and,
;- leaves the system in an easily maintainable and always predictable state.
;-
;- "root"
;- is initial kernel/root vocabulary in ROM area (.text section), always present.
;- It is bottom of linked vocabulary list and of all words, and can't be excluded
;- from lib4th pre-defined names searching procedures. If not explicitely in the
;- vocabularies stack {root} will implicitely be searched last.
;- "only" is an ordinary 4th word which clears the search order to just {root}.
;-
;- "local"
;- usually an empty vocabulary, used while compiling for locals names, will
;- always be searched and, prior to any other vocabulary, implicitely.
;-

;-	

;-
;- Word Header - preliminary!
;-
;- => re "l4struc.inc", lib4th <struc> definitions		<=
;- => re "lib4words.inc" and "lib4th.mac", macro <create>,	<=
;-
;- any items end 4 bytes aligned
;-
;- variables
;-	Due to the ROM simulating nature of F8 vari are referred by
;-	index pointers in the same way as the commonly known user vari.
;-	Word structure is extended by
;-		the displacement within variables area.
;-		an initial value (if "constant", &c)
;-
;- variables word header extension
;-	dw index	; secondary link index
;-	dw 0		; dummy compileflags
;-	...		; other data, re "ifa2lfa" for actual disp
;- varilink:
;-	dd $-varilink	; disp to previous vari storage linkfield
;-	dd toplink	; disp to last vari storage lf
;-	db 1," ",0,0	; varinfa (same as vocnfa), dummy name
;-	dummy name in 2nd header unused, can store additional data.
;-
;- constants, literals
;-	will be stored to dictionary, alterable by the compiling
;-	program, only, which after a call to save-system will be 
;-	inserted into non-alterable (ROM or .text) area of the new 
;-	executable. Thus {CONSTANT}s are NOT generally alterable!
;-
;- <varf> words		(v0.3.02: 1st cell transfer, only)
;-	kernel words w. varf header-flag set may supply up to <xwfl>-1 
;-	additional data cells, as determinable with 
;-		{ ' name idx>lfa lfa>ffa @ xwfl and 1- }
;-	which will be copied to RAM data-space. >BODY applied to those 
;-	words returns ptr to displacement wrt @d0 to 1st relocated cell.
;-
;- <pfax> words
;-	execute from pfa in header and receive ptr to body by Forth-VM 
;-	W-registe, i.e. <ecx>.
;-	
;-
;- related pointers:
;-	uv.lkindex	running index to execution address table
;-	uv.mbot		base address of execution address table
;-	uv.voclink	ptr to end of vocabularies linkage
;-		latest	returns last lfa in {current} vocabulary
;-	uv.last		ptr to globally last defined words lfa
;-
;- "src/l4words.inc" glossary describes how to adding kernel words. 
;-
;-
;- The above may be subject to change according f6 model:
;- standard word header:
;-    [ 1 p s ccccc ][ name ][ link ][ doword ][ parameter ][ wa ] ...
;- vocabulary header:
;-    [name][lfa][dodoes][dovoc][vocnfa][voctop][voclink][search][ff]
;-
;-	

;-
;-
;-================================================================================;
;-
;- Assembler:
;-
;- Assembly of "lib4th" relies on extended de-bugged "nasm" and orderly working
;- %assign, %define and, the additional %xdefine without which it most certainly
;- won't be possible to compiling anything useable, at all. 
;- Thus nasm-0.98e or 0.98-3e (re below) indispensably required! Programming with
;- nasm is a nightmare. But, because once the desicion had to be done there simply
;- was no other such tool I got to rely on that one and try to make the best of it...
;-
;- For instance, for the word headers lib4th assembly depends on constructs like:
;-
;-	push esi,edi,ebx
;- %define aregl regl       ;segfaults: nasm won't save a string!
;-
;- %xdefine aregl regl	    ;this works, supplied with nasm-98e.
;-	..do-something..
;-	push ebx
;-	..do-something..
;-	pop ebx
;-	..do-something..
;-	pop aregl
;- While this case can easily be substituted there are others which can not - re
;- lib4th.asm and lib4th.mac, constants.inc
;-
;- Another, undocumented but required feature of "nasm" macroes:
;-	In a macro is %00 the label at actual macro invocation.
;-
;- The de-bugged version, nasm-0.98e, puts many of those things right and,
;- wouldn't do without its extended %xdefine keyword. I'd further patch nasm to
;- listing the binary output even if "non-fatal" errors occured - which is the
;- situation where it would be really helpful.
;-
;- nasm-0.98e is available from
;- 	ftp://ftp.linuxgames.com/crystal/nasm/
;- patches (based on debian/0.98-3, 0.98e version inclusive)
;-	http://www.snafu.de/~phpr/nasm-0.98-to-3e.diff.tar.bz2
;-	(without which assembly of "lib4th" might fail...!)
;- "debian"ized extended binary package
;-	http://www.snafu.de/~phpr/nasm_0.98-3.1_i386.deb
;- modified sources
;-	http://www.snafu.de/~phpr/nasm-0.98-3e.tar.bz2
;-
;- Initial assemblies were tested with asmutils' elf-macros and "nasm" in -fbin
;- mode and, with nasm mode -felf and ld. Both, the two variants required no
;- linking or relocation nor libraries. Initial "F8" is now "lib4th" dynamically 
;- linked shared library which, also requires no other libraries - libc.a should 
;- be accessible during the linking process, for "ld".
;-
;-

;-	

;-
;-================================================================================;
;- Kernel
;-

;-
;- Stacks, Dataspace
;-
;- Preliminary structure, just to having something which works!
;- ------------------------------------------------------------
;- I'm considering
;-	an internal job scheduler by a single free running job,
;-	user jobs set up & maintained internally.
;-	r/w(/x) memory manged by another free running job which
;-	maintains de-/allocation after user job's request.
;-	several internal system calls for i/o actions, resource
;-	management and resource de-/alloation, in the library.
;-
;- And, rt-linux approach, as soon as accessibility explored...
;-
;- The system provides independent data- and return-stacks and
;- areae of contiguous memory, per task:
;-
;- memory map
;-
;- memory map (preliminary, v0.1.02)
;- %define-d ptrs to corresponding user vari
;-= .ss ==========================================================
; RAM, task specific returnstack(s) & variables space, 128K+ ea,
;-	per task extends down to lower address space:
;- .ss	----		initial stack, env vari and args
;-	----		@r0	kernel return-stack bot, page-aligned
;-	 ..	RS	 64K, top down
;-	 ..	
;-	 ..	PS	 64K, bottom up
;-	----		@s0	bot. of data-stack
;- 	----		@utop	top of user variables,
;-	 ..			64K reserved user-vari area, top down
;-	 ..			beginning with task register storage,
;-	 ..	UP	uv.link	next 64 user-vari are byte-addressble
;-	 ..		ref into user-vari area by [ebp-uv.link+disp]
;-	----		bottom of user vari area
;-	[  ]			terminal input buffer, <ntib> bytes (4K)
;-	----		@utib
;-	 ..
;-	----		ultab	user exec address table base, bot. up
;-				bottom of 64K fixed size user area
;-	---------------------------------------------------------
;-	 ..next task..		blockwise growing top down
;-	 ..
;-= .bss =========================================================
;- RAM, multiple independent groups may exist, 196K ea,
;-	per task, data-space extends up to higher address,
;-	top task can extend (up) own memory area:
;-	 ..
;-	 ..next task..		blockwise growing bottom up
;- .bss	---- 		@mtop	top of actually allocated .bss section
;-				extendable by {allocate},
;-				extended by {allot}, on demand.
;- datatop		@dtop	kref-d @mtop
;-	 ..
;- dataptr		@dp	64K, extending into .bss, bottom up
;-	 ..
;-	bbuf			on demand allocated/removed blockfile buffers
;-	 ..
;- databot		@d0	dataspace
;- codetop		@ctop	end of code-space
;-	 ..
;- codeptr		@cp	bottom up, 64K
;-	 ..
;- codebot		@c0	dictionary
;-	 ..
;-	 ..	edi		datastack running ptr
;-	----		@uv.s0	datastack, bottom up, 64K
;----------------------------------------------------------------
;-= .text ========================================================
;- ROM/library, kernel code in non-alterable memory:
;- .text ---
;-	 ..
;-	 ..		ref into kernel via ebx-Y+disp = @uv.kref
;-	 ..		for kernel words, constants, wordheaders.
;-	----	<Y>	kref, beginning of library code
;-================================================================
;-

;-	
;-	

;-
;-================================================================================;
;- System
;-

;-
;- "lib4th" is re-entrant, interruptible and position independent.
;- Thus it is expected (not -yet- tested) to be "thread safe" and ROMable.
;-
;- i.e. it does not store to non-reserved memory, it doesn't refer to any data
;- outside the respective bounds and, not "below" stack ptr-s; no essential global
;- variables exist and, references are all relative wrt "KRref".
;-
;-
;- Compiling/Interpreting
;-
;- "lib4th" doesn't implement the traditional distinction between interpreting
;- and compiling state. It always compiles something executeable, terminated by an
;- <rts> code and then branches either to immediately executing this piece of code
;- and removing it from compilespace, which is "interpreting", or leaving it in
;- place until the surrounding structure(s) fully resolved, which is "compiling"
;- (there are exceptions, though..)..
;- The latter state applies to any structured code, i.e. DO..LOOP, IF..ENDIF, as
;- well as ":" and ";", etc. A hi-level 4th word being just one species of those
;- structures, execution of which is "delayed" until invoked explicitely and,
;- which can be repeated because it has a name header - (re "h4").
;-
;- "structure"
;-	is any sequence of source code which requires more than a single 
;-	executeable to be compiled before it can safely be executed.
;- "intermediate compiling"
;-	is delaying execution of compiled code until whatever structures 
;-	nesting levels fully resolved.
;- "compiling"
;-	is leaving compiled code in place, to be multiply executed by other 
;-	words or directly, by name or uot index.
;- "interpreting"
;-	is compiling a piece of code, i.e. a processor operation, and a 
;-	trailing <rts> which doesn't count to used codespace, which then will 
;-	immediately be executed and removed from codespace, afterwards. This 
;-	also applies to any compiled structure which was not assigned to 
;-	remain in codespace, i.e. after CREATE or : (colon).
;- "intermediate interpreting"
;-	is after {[} when in compiling state, until {]}.
;-	this state can be used for intermediate calculations.
;-
;-	
;- Forth Words
;-
;- ANS-standard was very helpful because it provides some certain guideline.
;- It (purposely) doesn't note many brilliant features but, somehow degrades
;- several known ones. I tried to unite whatever I'd find valuable, since the 
;- early descriptions of the pre-79-"standard" f.i.g. Forth model, to enabling
;- traditional Forth programming as well as (preferrably) ANS-4th compliant.
;-
;- One noticeable, new feature is the {EVALUATE} group of words which enable
;- interpretation from any given address, another being the -not implemented-
;- {CATCH} and {THROW} errors handling facility.
;-
;- But, before the ANS standard emerged Forth formed a well defined modular and
;- structured programming language, which was broken by a few 'inventions' of 
;- that standard:
;-
;-	unloop		immediately discard top loop parameters, which will run 
;-			havoc if not followed by {exit} and _all_ current loops 
;-			{unloop}ed or, by other, even worse compiler trickery!
;-
;-	leave		to immediately leaveing a loop structure, which is of no
;-			advantage but unnecessarily complicating the compiler.
;-
;-	exit		immediately terminating execution of a word.
;-
;-	then		substituting {endif}, i.e. nothing useful.
;-
;- {unloop} and {exit} might be useful to speeding up a well tested program, but
;- should probably not be *required* kernel words - ;S was different, being the 
;- runtime of {;} and, required to terminating compilation from screenfiles.
;- 
;- {leave} would always have to be surrounded by an {if} structure, thus ANS-mode
;- is of no advantage at all, but needlessly complicating the compiler. therefore
;- lib4th implements the old style:
;-	if .. leave .. else .. endif loop
;- ANS-mode supplied as a set of hi-level words, w. file "4th/leav.f8".
;-
;- {then} is a well established word in other, even human, languages where it is
;- used in an entirely different context then that meant with the Forth word.
;- Thus provided for ANS compliance, only, as a synonym to {endif} which much
;- better fits to the situation.
;-
;-	
;- Line Editting
;-
;- {accept} and {query} enable some limited editting functionality:
;-	<bel>	^G
;-		keybord signal (sound by PC speaker).
;-	<bs>	^H
;-		move cursor one char back, non-overwriting back-space.
;-	<esc>[D	cur.left
;-		ditto (vt102 type terminal).
;-	<tab>	^I
;-		non-overwriting space until eol, moves cursor right;
;-		1st keystroke initiates "last line recall" by cursor down.
;-	<esc>[C	cur.right
;-		non-overwriting space, moves cursor right - as <tab>.
;-	<esc>[A	cur.up, <pos1>
;-		cursor back to line beginning.
;-	<esc>[B	cur.dn, <end>
;-		after 1st <tab> expands till previous end of line.
;-	<ff>	^L
;-		clear console display.
;-	<del>	ascii 127, "<=" key
;-		backup and delete char under cursor; delete-left.
;-		non-functional in "rxvt".
;-	<nl>	ascii 10, <enter> key, ^J
;-		line terminator is <lf>.
;-	<cr>	^M
;-		carriage return, sends <cr/lf>.
;-	<lf>	^J
;-		line feed, exec <cr/lf>
;-
;-	<csi>	aequivalent to sequence of <esc>"["
;-
;-	
;-
;- Signals (system faults & exceptions)
;-
;- segfault:
;- lib4th recovers from single segfaults (addressing errors). After return to
;- the input prompt an <enter> before next probably faulting action is required
;- to fully recovering or, return to {quit}.
;-
;- arithmetic  fault:
;- Arithmetic faults recover from div0 returning the respective overflow value,
;- +ve or -ve maximum or, 1 in the case of 0/0, and, the correct remainder with
;- the quotient set to l.s. cell of dividend after division overflow.
;-
;- window resized:
;- When windows resizeing, e.g. in an "rxvt", 'sigwinch' will be triggerd and
;- it's handler store the new character-sized sizes to a system variable where
;- the related words - {max-xy}, etc. - read their data from.
;-
;- SIGCHLD:
;- Silent, to enabling other job's execution, for instance -re- {sh} kernel word.
;-
;- Other signals display a message and return or, terminate - re "constants.inc".
;-
;-	CTR/C	terminating the entire jobs tree, executing {bye} w/o error.
;-	CTR/Z	putting the job into background execution can result to 
;-		repetitive signal -15 messages (SIGTTIN) due to attempts 
;-		to read the keyboard, if not in a scripting job.
;-		further, console settings might get lost when re-entering
;-		with the <fg> command or, by SIGCONT.
;-

;-	

;-
;---------------------------------------------------------------------------------;
;- Assembly, lo.level words, system setup
;-
;-
;- forth registers
;-	eax	@tos, 1st cell in parameterstack
;-	ebx	KR : kernel ("lib4th") reference, <kref>
;-	ecx	   : aux. and, W-register of fig-4th v.m.
;-	edx	   : auxilary useage
;-	ebp	UP : reference into user vari
;-	edi	PS : datastack ptr, cell @tos kept in eax
;-	esi	LP : temporary locals ptr
;-	esp	RS : returnstack/instruction ptr
;-
;- non-restorable base register
;-	ebp	reference into user vari - cannot be restored!
;-		though might be tracked down from .ss section
;-		scanning for current p.i.d. which is stored at
;-		user vari (pid) and thus might lead to a valid
;-		reference.
;-
;- user routines shall preserve
;-	eax	@tos
;-		if top data-stack item would be to preserve.
;-	ebx	re kernel code <kref>
;-		can be restored from user vari or by <getref>.
;-	ebp	re user vari
;-		usually can NOT be restored!
;-	edi	datastack ptr
;-		empty stack can be restored from user vari,
;-	esi	locals ptr
;-		empty locals area if esi:=@s0-@(locb), @(locn):=0
;-	esp	returnstack ptr
;-		empty stack can be restored from user vari
;-
;- user code can communicate
;-	mm4..7	via mmx registers not used by kernel words, i.e.
;-		any other registers may be changed by or required
;-		pre-set specific to kernel.
;-		mmx regs are safe wrt fp since no f.p. op's used.
;-
;- mmx op-s in lib4th:
;-	movd, movq, por, psllq, psrlq, punpckhdq, punpckldq, pxor
;-
;- mmx usage can be disabled w. compileflag __MMX, in Makefile. All resp. words
;- are provided in non-mmx variants which belong to {non-mmx} vocabulary, where
;- applicable, and will then substitute the mmx version. -re- "Nomina", above.
;-

;-	

;-
;- uot
;-		is an analogon to ELF-s global offset table set up in user space 
;-		of each task, specifically. Though not that precise: "user offset 
;-		table" carries no offsets but, for speed, true execution addr's.
;-	<find>	refers to word headers where the reference to executeable code is 
;-		by the corresponding uot entry wrt. user vari base pointer of the
;-		running task. index to uot points to execution address. uot is 
;-		linked down to parent's table which ends in the kernel task's own 
;-		uot. uot entries are linked at startup time and carry the absolute
;-		addresses of any user-accessible executeables.
;-	<pfa>	words which require execution from a common ptr are not referred
;-		via uot, which in that case is zero, but, by ptr in <pfa> of the 
;-		name header fields which is one cell before "body" and receive
;-		ptr to their "body" in ecx register.
;-

;-
;---------------------------------------------------------------------------------;
;- Adding a hi-level accessible word to "lib4th"
;-	re "src/l4words.inc" for latest defn.
;-
;- 1) Write an assembly subroutine, using
;-	eax	TOS	top item on parameter stack, m.s.cell of double
;-	edi	PS	parameter stack, using:
;-			spush		push tos to nos, towards higher addr.
;-					eax & eflags remain un-changed
;-			spop		pop nos to tos
;-					eflags remain un-changed
;-			dword TOS(0)	saved tos, i.e. dword[PS]
;-			dword TOS(1)	nos
;-			dword TOS(2)	2nd cell on stack, etc...
;-	esp	RS	returnstack
;-	ebp	UR	[uref disp]	uservari reference
;-			uservari are many, re "constants.inc" & source
;-	ebx	KR	[kref disp]	kernel code addressing mode
;-
;- 2a) have it properly described, with stack balance(s) and action.
;- 2b) have it properly described, with stack balance(s) and action!
;-
;- 3) add label and macro GA at the new entrypoint
;-	label:GA
;-
;- 4) add a header line to "lib4words.inc" with crea macro:
;-		crea compileflags,'4th-name',entrypoint,wordlist
;-	compileflags	:= imed
;-		defines the word as a compiler word, i.e. immediately executing 
;-		instead of being compiled, and not compiling itself to execute.
;-			:= nopt
;-		words which depend on returnstack.
;-	compileflags can be accumulated by <or> operation "|";
;-	other flags re "constants.inc".
;-
;- 5) re-compile lib4th and glossary.
;-
;- 6) pse, mailme your diff's :)
;-
;-	

;-	

;-
;-================================================================================;
;- Startup sequence for application programs, Assembly level
;-

;-
;- Program Setup
;-
;-
;- External Reference into "lib4th"
;-
;- is possible from any other programming environment but, should restore and
;- preserve eax, ebx, ebp, edi, esi and esp processor registers, re "Assembly",
;- above, as well as the specific memory areae. And, watch mmx usage -if enabled-
;- and preserve mm0..mm3, if used outside "lib4th", across such calls.
;-
;-
;- Library reference
;-
;- referring to external labels can be done differently, more or less extensively
;- simplified, less or more space consuming in the binary:
;-
;- For minimal space requirements, 
;-
;- At least once ea. use macroes <callx> or <jmpx> when referring to library,
;- which insert the required 'extern'al reference. <callx>/<jmpx> may multiply
;- be used with the same references. Further insert any non-4th or inaccessible
;- lo-level lib4th entries, explicitely. for instance:
;-
;-	global _start
;-	extern allock,keycall,newline
;-	extern consn,er,edots,f8ht,ht,ht.e,ht.v,isegf,nl,npref,nsleep
;-	extern puvari,rsigt,sigt,tbye,tbye.e,tijobn,tok,tregs,ttyn
;-
;- With this method, example "f8" program to enter the Forth system is less than
;- 3K, the even further minimzed, stripped "calc4th" has a size of just 628 bytes.
;- A fully self-contained static Forth system is about 130K of size and may be more
;- efficient in a heavily loaded system.
;-
;-
;- Basic 4th job
;-
;- START4TH and END4TH macroes provided for easily setting up a standard lib4th
;- program, re (somewhere down in) glossary, "lib4th.mac" description.
;-
;- Lo-Level programming
;-
;- Executeables - remember that everything at hi-/lo-level Forth is accessed via
;- executeable code - referred by subroutine calls, or jump, with <callx> or
;- <jmpx> macroes at 1st useage, consecutive references may use <call> or <jmp>.
;- Non-Forth data referred via g.o.t., with macro <GETGOT reg1> and
;-	mov reg2,[reg1+datareference wrt ..got]
;-
;-
;- Clones Setup - not much tested, yet!
;- NOTE:
;-	Tests with early versions were sucessful, while in later development I 
;-	didn't take threading/multi-tasking into account in so far, as that 
;-	capability wasn't tested, though provisions taken to keep it enabled.
;-
;- Once ready, besides managing independent cloned jobs, it should enable single,
;- self contained Forth words' free-running multi-tasking execution as well as
;- independent cloned jobs within an applications memory, scheduled on a "real
;- time" basis and/or dependent on system load and job's requirements.
;- 
;- Re "lib4th.mac" for detailed macro descriptions.
;- Start with macro CREA4TH.
;- Insert code to modify stack setup to suit additional requirements.
;- Activate that job with macro ACTV4TH.
;- Start clone with macro CLON4TH and continue hi-/lo-level Forth.
;- When execution ends terminate clone with {bye} or, sys_exit.
;-
;-
;- External references
;- can be included en bloc, which is simpler but much more space consuming:
;-	%include "lib4words.inc"
;- including "lib4words.inc" w. "lib4th" is what "..h" headerfiles inclusion is
;- to "C"-ish source programming. It should be included prior to any code or
;- data written in an application program, and prior to .text section. globally
;- including all 4th names extends the binary by about 130K, thus explicit def's
;- should be considered for not really huge programs.
;-
;- Another, medium sized alternative:
;-
;- binary size can greatly be reduced by defining just what really is required,
;- for instance with above file's inclusion to 8K with the following:
;-
;- 'global's don't add to binary
;-	global _start
;-
;- an 'extern' item occupies 54 bytes in stripped binary
;-	extern consn,er,edots,f8ht,ht,ht.e,ht.v,isegf,nl,npref,nsleep
;-	extern puvari,rsigt,sigt,tbye,tbye.e,tijobn,tok,tregs,ttyn,lit
;-
;- fully enabled item occupies 120 bytes in stripped binary,
;- XN 15,.., defines 4 labels, ea.
;-	XN 1,accept,allocini,allock,argcopy,bindot,blk,byer,byes,count
;-	XN 1,cr,decdot,definitions,dminus,dots,doucons,drop,dzero
;-	XN 1,emit,fetch,help
;-	XN 1,idsvs,iiocons,ilink,intro,ivecw,irp,iuser
;-	XN 1,keycall,lit,litb,litw,ltsharp,mby,mcount,mrot,mmul,newline
;-	XN 1,palignp,peight,pone,ppid,quit,qcan,rfrom
;-	XN 1,sdrop,setty,sharps,sharpgt,sigmsg,sleepm,sleeps,source
;-	XN 1,span,spanf,terror,tib,torr,twodrop,twodup,twofetch,type
;-	XN 1,uddot,udmmul,usercopy,zbra,zcount,zero,zless
;-
;- a 2nd label adds 52 bytes, ea
;-	XN 9,root
;-
;-


;-	
;-
;-================================================================================;
;- Porting
;-	

;-
;- lib4th/F8 is not considered "portable" to different processor types but, the 
;- modifications required for other OS's w. i586+ processors should be reasonably
;- few and easy. it was coded and tested in a K6-2 pc-linux environment.
;- Since ELF library's "got" is not used in lib4th, even porting to completely
;- different environments should be fairly easy, only the linux specific system
;- calls requiring proper substition. The library code might even be ROMable,
;- since it requires no external relocation/linking and contains no position
;- dependent code, with the optional exception of a single reference which is 
;- supplied for convenience, only, and usually not required:
;-	_GLOBAL_OFFSET_TABLE_
;- in {getgot} - currently suppressend and left to a "Makefile" compile-switch.
;-
;- Processor dependent coding restricted to 486 op's plus, cpuid, xadd and mmx 
;- registers 0..3 w. the most simple mmx specific opr's, as of movq, movd,
;- shift, add, sub and logic - re "(x)" mark in words' glossary. mmx usage can
;- be disabled w. compileflag __MMX, in Makefile. All resp. words provided in a
;- non-mmx variant, which belong to {non-mmx} vocabulary, where applicable, and
;- substitute the mmx version if mmx register usage was disabled by compileflag.
;- Some such words do not co-exist in their mmx and non-mmx variants but, will 
;- be compiled according to the __MMX switch - re above, "Nomina" (which is not 
;- regulary tested during lib4th development!).
;-
;- OS dependent coding wrapped within respective macroes from the "asmutils"
;- which were made to produce portable code for Linux and BSD family (FreeBSD, 
;- NetBSD, OpenBSD, BeOS, AtheOS and probably others, dependent on asmutils' 
;- version). Thus only those fairly few bits might have to be adapted:
;-
;- host system-calls, re "doc/syscalls-in-f8" (after "make docs"):
;-
;-	sys_access	file access status
;-	sys_alarm	alarm signal
;-	sys_brk		alterable memory allocation.
;-			by intermediately compiling and with execve
;-			it should also be possible to executing a
;-			newly compiled program within a system which
;-			doesn't permit r/w/x memory sections.
;-	sys_clone	threads generation and scheduling
;-	sys_close	close file/device channel
;-	sys_exit	exit system, in {bye}
;-	sys_fcntl	files access permissions in <setty>,<otty>.
;-	sys_fstat	files status data
;-	sys_fsync	flush cached data
;-	sys_ftruncate	file truncation/expansion
;-	sys_generic	entry into syscall, for user supplied opr's
;-	sys_getpid	find identity of a thread
;-	sys_gettimeofday
;-			date & time	
;-	sys_ioctl	for different purposes:
;-			vt mode in <setty>,<otty> and <rstty>
;-			for single characters non waiting input,
;-			data re-used with {close} and {bye}.
;-			simple sound generation in {beep}, {bell}.
;-	sys_kill	sending signals
;-	sys_llseek	file pointer positioning
;-	sys_mprotect	used to set r/w/x memory permissions or, if
;-			it fails, for r/w and inhibited immediately
;-			executing complied code facility
;-	sys_nanosleep	wait until a timer expired
;-	sys_open	open a device/file
;-	sys_read	read from file descriptor
;-			used with single chars input, only
;-	sys_rename	re-naming files/links
;-	sys_rt_sigaction
;-			user specified realtime signal hnd's
;-	sys_sendfile	file to file copy
;-	sys_select	for job suspension if & until console input received
;-	sys_sigaction	signals re-definition (segf, arithm, winch, generic)
;-	sys_stat	file status
;-	sys_time	date & time
;-	sys_unlink	delete files
;-	sys_write	write to file descriptor,
;-			basic operation by strings, as in {type}
;-	sys_generic	added to asmutils files, supporting {scall}.
;-
;- Subroutine <intro> is somewhat non-standardly using a sys_ioctl to determine
;- whether initial STDIN is connected to a console. Though probably not the
;- proper way, it apparently works, but I'd like to change it if I only knew
;- how - efficiently. Any help would be very welcome...
;-
;- implementation, re "lib4th.mac" and "constants.inc":
;-
;- .text section:
;-	codespace	bottom of task's memory, after application's .text, 
;-			fixed size, by default set to 128K.
;-	variables	dataspace towards higher addr, growing up and
;-			extendable w. <sys_brk> and concerned 4th words.
;- .ss section:
;-	returnstack	grows down, no explicit cell order. rsp. 4th words
;-			preserve little endian mode. dft 128K w/ data-stack.
;-	datastack	below return-stack, grows to ascending(!) addr.
;-			cell order with m.s. cell on tos thus remains little
;-			endian. push is <stosd>, pop by <lea> and <mov>.
;-	user variables	assigned top down, below return-stack, uot follows.
;-	t.i.b.		4K allocated below PAGE_SIZE(4K) bound below user vari.
;-	uot		follows; fixed size of uvari+tib+uot is 64K.
;-
;- define-s for memory access
;-
;-	kref disp	wrt bottom of kernel memory (ROM, lib4th.so)
;-		KR		respective reference register (ebx)
;-	uref disp	wrt 32th cell in user vari
;-		UR		respective reference register (ebp)
;-	lref disp	wrt bottom of local dataspace
;-		LR		respective reference register (esi)
;-
;- macros and define-s for data transfer
;-
;-	PS		edi is datastack
;-			cell [PS] used for temporary storage
;-	eax		1st cell on datastack is register eax
;-	TOS(1)		2nd cell on datastack, at [PS-4]
;-	TOS(2)		3rd cell on datastack, at [PS-8]
;-	TOSPULL(x)	drop stackptr by x cells, no data transfer
;-	TOSPUSH(x)	advance stackptr by x cells, no data transfer
;-	spop		pop cell nos to tos, w/ optional no. of items
;-	spush		push eax contents to cell nos
;-	RS		returnstack is esp
;-
;- runtime configurable, re "constants.inc"
;- Several task specific entities which any time may be re-configured are shortly
;- described and defined in (re) "constants.inc", such as compile and i/o state,
;- vocabulary structure, linkage and stack, etc. as "user variables" - which in
;- L4 are no different access type but, are located in a different memory area wrt
;- the globally accessible task specific variables. There is no common area, by
;- default, though data access is globally enabled, at least for reading.
;-
;-

;-	
;-
;-================================================================================;
;- "lib4th" compiling
;-	

;-
;- Compiling the library requires no special access rights, thus would most safely
;- be done from a very low privileged users login. Re <MConfig> for used external
;- programs, which that user should have executing access to, and <INSTALL> in the
;- "doc" directory - some less common utilities can be found in the <util> directory.
;-
;- 	<make all>
;- generates the dynamically linkable shared library and reference programs,
;- <calc4th> and <f8>
;-	<make test>
;- can be used to verifying whether the result was ok.
;-	<make 4>
;- for the static library and the fully static reference program "4" (a Forth").
;-
;- Further tests, from main lib4th directory:
;-	<f8 include 4th/4/tt.f8 tt>
;- which is a little game on the console.
;-	<f8 include 4th/4/core.f8>
;- for a check whether the core words are (almost) ANS-standard.
;- NOTE: the test itself bears considerable inconsistencies (e.g., mixing bit oriented 
;- w/ arithmetic op's) and is not fully standard compliant, originally - thus modified.
;-	<f8 include 4th/4/bench.f8 include 4th/4/bm.f8>
;- some simple benchmarks.
;-

;-	
;-================================================================================;
;-

;-	

;-
;- Tests and deverlopment were carried out with (re "linux/scripts/ver_linux"):
;- ---------------------------------------------------------------
;- -- Versions installed: (if some fields are empty or looks
;- -- unusual then possibly you have very old versions)
;- Linux - 2.2.14-rtl2.0 #1 Sat May 20 21:56:04 GMT 2000 i586 unknown
;- Kernel modules         2.3.16
;- Gnu C                  2.95.2
;- Binutils               2.10.91, 2.11.90
;- Linux C Library        2.1.3
;- Dynamic linker         ldd: version 1.9.11
;- Procps                 1.2.9
;- Mount                  2.10d
;- Net-tools              2.01
;- Kbd                    0.96
;- Sh-utils               1.16
;- Modules Loaded       rtl8139 ppp_deflate bsd_comp x25 v_midi softdog sb 
;-			uart401 opl3 isdn_bsdcomp ipx hisax isdn awe_wave 
;-			sound soundlow soundcore sysv nls_iso8859-5 nls_iso8859-4 
;-			nls_iso8859-2 nls_iso8859-15 nls_iso8859-1 nls_cp866 
;-			nls_cp855 nls_cp852 nls_cp437 nfs lockd sunrpc 
;-			binfmt_java binfmt_aout nbd
;- ---------------------------------------------------------------
;- Short tests ok w. 2.2.5 and 2.4.0 kernels, wo. rt-linux extension
;- and w/ plain 2.2.19 kernel.
;- 

;-
;-	
;-================================================================================;
;-
;-
;- Legal
;-
;-	"lib4th" - Copyright (C) 2002 Berlin, H.-Peter Recktenwald (hp),
;-	Patent-, Marken- u. Urheberrechtliche Verwertung vorbehalten.
;-		Tel: ++49 30 85967858, mailto:phpr@snafu.de
;-
;-	=> Die "lib4th"-Sammlung befindet sich in experimentellem Zustand und 
;-	   unterliegt keinerlei Gewaehrleistung.
;-	   Urheberrechts-Hinweise weiter unten und Files LEGAL, "QT-lizenz.txt".
;-
;-	=> "lib4th" IS EXPERIMENTAL SOFTWARE WITHOUT WARRANTY which may be used
;-	   at users peril, only. Copyright (C) 2002 Berlin, H-Peter Recktenwald.
;-	   Re below and file QT-license.txt for further copyright information.
;-
;- --
;-
;-	"lib4th" and associated stuff is of experimental nature where no promise
;-	is given nor any warranty applies, which at users' peril may be used 
;-	according to the
;-		"THE Q PUBLIC LICENSE version 1.0"
;-	Permission is not given to any governmental, political or criminal 
;-	organization or any person at work for or related to such an institution.
;-
;-	=> No person in any way obliged to a certain software emanating vermin, 
;-	   commonly known by the name of "Microsoft", may use any part of the 
;-	   "lib4th" package, due to restrictions made in an "eula" of that 
;-	   organaization, as long as those restrictions which apparently are an 
;-	   attempt to taking advantage from existing but, sabotageing any other 
;-	   Open (safe!) and/or Free Software appear in any of it's documents...
;-
;-	The GNU license applies to most 3rd party software and texts:
;-	   "This is free software; you can non-commercially redistribute 
;-	   it and/or modify it according to the terms of the GNU General 
;-	   Public License as published by the Free Software Foundation; 
;-	   version 2. See the GNU General Public License for additional 
;-	   details, re file ./doc/GPL in "lib4th" distribution. If not 
;-	   supplied, write to
;-		Free Software Foundation, Inc., 59 Temple Place -
;-		Suite 330, Boston, MA 02111-1307, USA.
;-
;-	Anything else w/o a rsp notice is under full protection of the rsp law, 
;-	supplied for convenience, only, which should be regarded non-licensed, 
;-	to any aspect.
;-
;-	Only the german text versions are valid for reference wrt legal issues!
;-
;-	IF IN DOUBT OR NOT FULLY COMPLYING TO THOSE TERMS, ALL RIGHTS REMAIN WITH 
;-	THE AUTHOR AND NO LICENSE AT ALL IS GIVEN! - These restrictions made for 
;-	certainty wrt obscure laws and lawyers and, for the authors' (hp) personal
;-	safety. Thus, take it easy but take it and, please, mail me if in doubt: 
;-
;-		hp: h-peter recktenwald		mailto:phpr@snafu.de
;-	- Plain text! no attachements, HTML, Java(script) & other garbage.
;-	- for <big5>, <gb3212> etc, pse,	mailto:lxhp@china.com
;-
;- NOTE:
;-	Any user who is willing to simply respect the basic rights of authorship
;-	as he would expect others to behave wrt his own needs not much to care but, 
;-	after having read many related texts I'm simply uncertain about the legal 
;-	situation. Otherwise I would have just stated lib4th as "free software", 
;-	which seems not the right thing to do, thus those (silly?) restrictions.
;-
;-	For instance, when trying to understand the meaning of the GNU license, 
;-	I've become quite uncertain about what (u.s.-ish) understanding of legal 
;-	rights might be and whether that exists at all. Thus the "lib4th" stuff 
;-	is not expilicitely *licensed* but, it may be *used* as if it were, 
;-	according to the respective license documents, until I find something 
;-	which I can understand and wich I safely can rely upon...
;-	
;- --
;-	DEUTSCH:
;-
;-	Eine weitgehend allgemein gehaltene, deutschsprachige Einfhrung in den 
;-	Umgang mit Forth ist unter
;-		http://home.snafu.de/phpr/lhpf8td.html
;-	im Internet abrufbar.
;-
;-	Ich verdanke meinen ganzen Spa an der Computerei den vielen Entwicklern 
;-	im Linux, die ihre Programme offen und frei verfgbar machen - und(!) sie 
;-	hinreichend dokumentieren. Insbsondere aber der Forth-"Szene", der von 
;-	Anfang an kleinliche Eiferschtelei um Programmquellen vllig fremd war, 
;-	ganz ohne Klamauk um "Offene Software", lizensierte Steppenrinder und dem 
;-	weiteren Stallmann'schen Schwachsinn. L4 geht darum NICHT unter GPL!
;-	Die Form der lib4th-Lizenz soll dies meinerseits ein wenig kompensieren. 
;-	D.h. wer immer damit in gleicher Weise zu arbeiten beabsichtigt, mag die
;-	"lib4th"-Sammlung dazu frei verwenden - nicht aber frei verwerten!
;-
;-	Fuer meine (hp) hier vorgelegten Texte und Software gilt Nutzungserlaubnis 
;-	gemaesz beigefuegter Uebersetzung der "Q PUBLIC LICENSE version 1.0" als  
;-	"QT-Lizenz.txt" rsp. "QT-lizenz.html". Behrdliche, staatliche, politische 
;-	und kriminelle Organisationen haben sich jeglicher Verwendung zu enthalten,
;-	jenen ist die Verwendung beliebiger Art von Erzeugnissen, die unter meiner 
;-	Urheberschaft gehen, ausnahmslos nur nach besonderer Vereinbarung erlaubt.
;-
;-	AUSSCHLUSZVERMERK:
;-	Ein unter dem Namen "Microsoft" Weichware absondernder Schadfaktor versucht 
;-	seit geraumer Zeit, vermittels einer "eula" die Idee der Freien (sicheren!) 
;-	und Offenen Software zu sabotieren, aus welchem Grunde allen, die genannter 
;-	Organisation in welcher Weise auch immer verpflichtet sind, jede Verwendung 
;-	irgendwelcher Unterlagen aus der "lib4th"-Sammlung oder anderer Erzeugnisse 
;-	desselben Autors strikt untersagt ist. Diese Einschrnkung erlischt, sobald 
;-	die verblasene Form der Lizensierung bei "Microsoft" geeignet revidiert ist
;-	und der Autor (hp) nach entsprechender Mitteilung dem zugestimmt hat.
;-	
;-	Fremde Texte & Software sind z.Teil GNU-Lizensiert, s.dort; anderes ohne 
;-	entsprechenden Hinweis steht vollstndig unter dem betr. Urheberrecht.
;-
;-	IM ZWEIFELSFALLE IST die NUTZUNGSERLAUBNIS als NICHT GEGEBEN anzusehen!
;-	Rechtlich bindend sind vorrangig die betr. deutschsprachigen Textversionen, 
;-	es gilt deutsches Recht und soweit bergeordnet, das Recht der Europischen
;-	Gemeinschaft (EU, EC).
;-
;-	Nach den evidenten Eiertnzen realittsfremder Richter u. selbstherrlicher
;-	oder gar korrupter Rechts- und Regierunginstitutionen, Patentmter, u.dgl. 
;-	bleibt ohnehin groe Unsicherheit. Allein darum (und um gewisse Parasiten
;-	abzuwehren) die genannten Einschrnkungen.
;-	Sie sollen weder Anwendern noch den Entwicklern freier Software die Arbeit
;-	erschweren; ebensowenig ist beabsichtigt, dem, was gemein "lernen" heien 
;-	mag, irgendein Hindernis in den Weg zu legen. Betreffs der Verwendung in 
;-	kommerziellem Rahmen oder wenn Zweifel auftreten, bitte ich um Nachricht:
;-
;-		hp, h-peter recktenwald		mailto:phpr@snafu.de
;-	- Einfacher Text! - HTML u.. Zumutungen werden automatisch verworfen.
;-	- fr <big5>, <gb3212>, etc:		mailto:lxhp@china.com
;-	

;-
;-
;-================================================================================;
;- a-4th-design.inc <eof>
