; [hp, 3.3.00, v01, opcode test]

%include "system.inc"

CODESEG

%define __DBG
%include "dbg.inc"

;%define ms 1000000	; clocks per micro second
%define ms    1000   	; clocks per ms
;%define ms       0   	; clocks per s
;%define e2sec    3	; timing interval
%define e2sec    6	; timing interval (3:4 min)
%define e2sec    10	; timing interval
%define e2sec    08	; timing interval
%define clint
%define stint
%define level 3		;
%undef  __ni
%ifdef __NI
%define __ni		; un-comment only if test runs perfectly well!
%endif

%define mref byte ebp-rbuf+
%define TOS(x) [mref rbuf+4*(x)]

%macro xec 1-*.nolist
; code to test. eax,edx may be used
; ----------------------;
;t0 0000000005FFFFFA 100663
%00:
    mov eax,edx
%if %1=0
    nop
%elif %1=1
;t1 000000001EFFFFE3 318767
    pushfd
    sub eax,go-probe2
    popfd
;t1 --------------------;
%elif %1=2
;t2 000000000EFFFFF1 50331
    not eax
    lea eax,[eax+go-probe2]
    not eax
;t2 --------------------;
%elif %1=3
;t3 000000001CFFFFE3 285212
    nop
;t3 --------------------;
%endif
%endm

probe1:
    db 'DASZNEPROBE!'

    align 32
prep:
%ifdef __ni
%define clint	cli
%define stint	sti
	pushad
	sys_iopl level
	popad
%endif
	pop eax
	xor ebx,ebx
	mov edx,ebx
	emms
	pxor mm0,mm0
	pxor mm1,mm1
	lea ecx,[ebx-1]
	movd mm0,ecx
	shr ecx,e2sec
	push ecx
	mov ecx,ebx
	jmp eax

    align 32
dotestc:		; caliber
	lea esp,[esp-28]
	rdtsc		; start timer
	sub ebx,eax
	sbb ecx,edx
;;;;;;;;;;;;;;;;;;;;;;;;;
;t0 00000000C21AC42F 3256534
t0:	xec 0
;t0 00000000B24DB618 2991437
;t0 00000000B259A0E7 2992218
;;;;;;;;;;;;;;;;;;;;;;;;;
	rdtsc
	add ebx,eax	; count
	adc ecx,edx
	lea esp,[esp+28]
	jmp go.r

    align 32
dotest1:
	lea esp,[esp-28]
	rdtsc		; start timer
	sub ebx,eax
	sbb ecx,edx
;;;;;;;;;;;;;;;;;;;;;;;;;
t1:	xec 1
;;;;;;;;;;;;;;;;;;;;;;;;;
	rdtsc
	add ebx,eax	; count
	adc ecx,edx
	lea esp,[esp+28]
	jmp go.r1

    align 32
dotest2:
	lea esp,[esp-28]
	rdtsc		; start timer
	sub ebx,eax
	sbb ecx,edx
;;;;;;;;;;;;;;;;;;;;;;;;;
t2:	xec 2
;;;;;;;;;;;;;;;;;;;;;;;;;
	rdtsc
	add ebx,eax	; count
	adc ecx,edx
	lea esp,[esp+28]
	jmp go.r2

    align 32
dotest3:
	lea esp,[esp-28]
	rdtsc		; start timer
	sub ebx,eax
	sbb ecx,edx
;;;;;;;;;;;;;;;;;;;;;;;;;
t3:	xec 3
;;;;;;;;;;;;;;;;;;;;;;;;;
	rdtsc
	add ebx,eax	; count
	adc ecx,edx
	lea esp,[esp+28]
	jmp go.r3

probe2:
    db 'DASZNEPROBE!'

; --------------------- ;
    align 32
START:
	mov ebp,rbuf
	call prep
	pop eax
	    PRSTG't0 '	; empty loop (caliber)
go:
	sub esp,200
	mov [esp],esp
	add esp,200
	xor eax,eax
	mov [mref rbuf],eax
	mov [mref sg],eax
	call prep
.i:
	clint
	jmp dotestc

    align 32
.r:
	dec dword[esp]
	jnz go.i
	stint
	_add esp,4
	test dword[mref rem],-1
	mov [mref rem+4],ecx
	mov [mref rem],ebx
	jz go
	sar ecx,1
	rcr ebx,1
	call preg
	call p_num.p
;
	    PRSTG't1 '
	call prep
.i1:
	clint
	jmp dotest1
    align 32
.r1:
	dec dword[esp]
	jnz go.i1
	stint
	_add esp,4
	call p_num
;
	call prep
	    PRSTG't2 '
.i2:
	clint
	jmp dotest2

    align 32
.r2:
	dec dword[esp]
	jnz go.i2
	stint
	_add esp,4
	call p_num
;
	    PRSTG't3 '
	call prep
.i3:
	clint
	jmp dotest3
    align 32
.r3:
	dec dword[esp]
	jnz go.i3
	stint
	_add esp,4
        call p_num

.exit:
	xor ebx,ebx
	sys_exit 0

; --

    align 32
preg:
	PRNUM ecx
	PRTXT BSPC
	PRNUM ebx
	ret

    align 32
p_num:
        call preg
	sub ebx,[rem]
	sbb ecx,[rem+4]
	setl [sg]
	jge .p
	neg ebx
	sbb ecx,0
	neg ecx
.p:
        mov eax,ebx
	mov edx,ecx
%ifdef ms
%if ms > 0
    push eax
    mov eax,edx
    _mov ebx,ms		; scale to factor {ms}
    xor edx,edx
    div ebx
    mov edx,eax
    pop eax
    div ebx
;shr edx,((1+2*(ln(ms)/ln(2)))/2) ;sowas wr schn...
%endif
%endif
; print decimal number {eax} to stdout
; all regs preserved
; <p_b> l.s.byte
; <p_num> dword
;p_num:
.n:
    pushad
    lea ecx,[rbuf.e-2]
    mov word[ecx],10
    push byte 1		; length counter
    _mov ebx,10		; radix
.l:
    dec ecx		; numbuf-
    inc dword[esp]
    xor edx,edx		; hi dword for div
    div ebx
    or dl,'0'
    mov [ecx],dl
    test eax,eax
    jnz .l
    test byte[sg],-1
    jz .w
    dec ecx
    mov byte[ecx],'-'
    inc dword[esp]
.w:
    pop edx		; count
syswrite:
    push byte STDOUT
    pop ebx
    sys_write
    popad
    ret

    UDATASEG

    alignb 32
rbuf:
    resd 4		; 12 digits
.e:
rem:
    resd 2
sg:
    resd 2
    
    END
%macro nix 0.nolist
;;;
; checked:
%if 0
    orps xmm0,xmm0
    cli	;->segfault
    sti	
    mov esp,[esp]	;11;-14'
    add esp,byte 12	;12;-13'
    add esp,12	;00;-25'
;;;
    mov eax,[esp]
    dec ax
    add ax,1
    sbb ax,ax
    jz .n
    PRNUM[esp+4]
.n:
;;;
%if %1=1
;t1 - 27 -       -;
    dec eax
    add eax,1
    sbb eax,eax
;t1 --------------------;
%elif %1=2
;t2 - 40 -;
    neg eax
    sbb eax,eax
    not eax
;t2 --------------------;
%elif %1=3
;t3 - 13 -;
    test eax,eax	;;;
    mov eax,0
    jnz .r
    dec eax
.r:	
;t3 00000000C2503050 267816
%endif
%if %1=1
;t1 - 25 -       -;
    cmp eax,0x80000000
    mov eax,0
    jnc .r
    jnz .r
    sub eax,1
.r:
;t1 --------------------;
%elif %1=2
;t3 - 22 -;
    cmp eax,0x80000000
    mov eax,0
    jnc .r
    jnz .r
    dec eax
.r:
;t2 --------------------;
%elif %1=3
;t3 - 10 -;
    shl eax,1	;dec eax
    jnc .r	;mov eax,0
    jnz .r	;seto al
    sbb eax,eax	;neg eax
.r:
;t3 00000000C2503050 267816
%endif
;;;
%if %1=1
;t1 - 115 -       -;
    shl eax,1
    jnc .r
    jnz .r
    rcr eax,1
    shr eax,30
.r:
;t1 --------------------;
%elif %1=2
;t2 - 87 -;
    shl eax,1
    jnc .r
    jnz .r
    mov eax,-1
.r:
;t2 --------------------;
%elif %1=3
;t3 - 97 -;
    shl eax,1	;dec eax
    jnc .r	;mov eax,0
    jnz .r	;seto al
    sbb eax,eax	;neg eax
.r:
;t3 00000000C2503050 267816
%endif
;;;
; un-determinable timing, because different P-count values:
%if %1=1
;t1 - 115 -       -;
    shl eax,1
    jnc .r
    jnz .r
    rcr eax,1
    shr eax,30
.r:
;t1 --------------------;
%elif %1=2
;t2 - 87 -;
    shl eax,1
    jnc .r
    jnz .r
    mov eax,-1
.r:
;t2 --------------------;
%elif %1=3
;t3 - 97 -;
    shl eax,1
    jnc .r
    jnz .r
    sbb eax,eax
.r:
;t3 00000000C2503050 267816
%endif
;;;
    shl eax,30
%if %1=1
;t1 - 26 -       -;
    shl eax,1
    jnc .r
    jnz .r
    rcr eax,1
    shr eax,30
.r:
;t1 --------------------;
%elif %1=2
;t2 - 15 -;
    shl eax,1
    jnc .r
    jnz .r
    mov eax,-1
.r:
;t2 --------------------;
%elif %1=3
;t3 - 6 -;
    shl eax,1
    jnc .r
    jnz .r
    sbb eax,eax
.r:
;t3 00000000C2503050 267816
%endif
;;;
    shl eax,30
%if %1=1
;t1 - 201 -       -;
    shl eax,1
    adc eax,11
;t1 --------------------;
%elif %1=2
;t2 - 201 -;
    shl eax,1
    adc eax,byte 11
;t2 --------------------;
%elif %1=3
;t3 - 268 -;
    shl eax,1
    neg eax
    sbb eax,eax	;134
;t3 00000000C2503050 267816
%endif
;;;
; ----------------------;
%00:
;    shl eax,32	;;1)
    shl eax,1	;;1)	2)
%if %1=1
;t1 - 201 -	-;268	268
    neg eax
    sbb eax,eax
    not eax
;t1 --------------------;
%elif %1=2
;t2 - 201 -	-;134	134
    test eax,eax
    jz .r
    mov eax,-1
.r:
;t2 --------------------;
%elif %1=3
;t3 - 268 -;
;t3 00000000C2503050 267816
%endif
;;;
%if %1=1
;t1 - 201 -	-;21
    cmp al,10
    jc .n
    add al,7
.n:
    or al,'0'
.r:
;t1 --------------------;
%elif %1=2
;t2 - 201 -	-;46
    add al,0x90
    daa
    adc al,0x40
    daa
;t2 --------------------;
%elif %1=3
;t3 - 268 -	-;33
    add al,40h
    movzx ax,al
    and ah,09h
    add al,ah
    and al,0Fh
;t3 00000000C2503050 267816
%endif
%if %1=1
;t1 - 201 -	-;40
    add al,40h
    sbb ah,ah
    and ah,09h
    add al,ah
    and al,0Fh
;t1 --------------------;
%elif %1=2
;t2 - 201 -	-;40
    add al,40h
    movsx eax,al
    and ah,09h
    add al,ah
    and al,0Fh
;t2 --------------------;
%elif %1=3
;t3 - 268 -	-;33
    add al,40h
    movsx ax,al
    and ah,09h
    add al,ah
    and al,0Fh
;t3 00000000C2503050 267816
%endif
%if %1=1
;alle drei identisch:1140850
;t1
    xchg eax,[esp]
    xchg eax,[esp]
;t1 --------------------;
%elif %1=2
;t2
    xchg [esp],eax
    xchg [esp],eax
;t2 --------------------;
%elif %1=3
;t3
    xchg eax,[esp+4]
    xchg eax,[esp+4]
;t3
%endif
%if %1=1
;   t0 000000002BFFFFF5 738197
;t1;t1 000000003FFFFFF0 335544
    push eax
    push edx
    mov eax,[esp]
    mov edx,[esp+4]
    pop edx
    pop eax
;t1 --------------------;
%elif %1=2
;t2;t2 000000004400037D 402654
    push eax
    push edx
    movq mm1,[esp]
    pop edx
    pop eax
;t2 --------------------;
%elif %1=3
;t3;t3 000000002BFFFFF5 0
;t3
%endif
%if %1=1
;t1;t1 0000000012000013 100663
    mov edx,TOS(1)
    push dword TOS(2)
    push dword TOS(3)
    mov TOS(2),eax
    mov TOS(3),edx
    pop dword TOS(1)
    pop dword TOS(0)
;t1 --------------------;
%elif %1=2
;t2;t2 000000001700036C 184550
    mov TOS(0),eax
    movq mm1,TOS(0)
    movq mm2,TOS(2)
    movq TOS(2),mm1
    movq TOS(0),mm2
    mov eax,TOS(0)
;t2 --------------------;
%elif %1=3
;t3;t3 000000008EFFFF93 2197815
    xchg eax,TOS(2)
    mov edx,TOS(3)
    xchg edx,TOS(1)
    mov TOS(3),edx
;t3 --------------------;
%endif
%if %1=1
;t1;t1 000000001C24189D 65518
    mov TOS(1),eax
    sub TOS(1),ebp
;t1 --------------------;
%elif %1=2
;t2;t2 000000001A2B1704 32422
    sub eax,ebp
    mov TOS(1),eax
;t2 --------------------;
%elif %1=3
;t3;
;t3 --------------------;
%endif
%if %1=1
;t1;t1 000000001A000018 33554
    sub eax,TOS(1)
;t1 --------------------;
%elif %1=2
;t2;t2 000000001A00004D 33554
    mov edx,TOS(2)
    sub eax,edx
;t2 --------------------;
%elif %1=3
;t3;
;t3 --------------------;
%endif
%if %1=0
;  ;t0 000000000CFFFFF4 218103
    pop eax
    mov edx,eax
    push eax
    jmp .n
.n:
%elif %1=1
;t1;t1 0000000042FFFFC1 905969
    mov edx,eax
    pop eax
    push edx
    jmp .n
.n:
    xchg eax,[esp]
;t1 --------------------;
%elif %1=2
;t2;t2 000000000EFFFFF3 33554
    mov edx,eax
    pop eax
    push edx
    jmp .n
.n:
    mov edx,eax
    pop eax
    push edx
;t2 --------------------;
%elif %1=3
;t3;t3 000000000EFFFFF4 33554
    mov edx,eax
    pop eax
    push edx
    jmp .n
.n:
    mov edx,[esp]
    mov [esp],eax
    mov eax,edx
;t3 --------------------;
%endif
%if %1=0
;t0 000000005C49F8B2 1548351
    mov edx,eax
%elif %1=1
;t1 000000006A4D1D82 235087
    movd mm0,eax
;t1 --------------------;
%elif %1=2
;t2 00000000622C2942 98709
    psllq mm0,32
;t2 --------------------;
%elif %1=3
;t3 0000000061F0F087 94828
    movd mm0,eax
;t3 --------------------;
%endif
%if %1=0
    mov edx,eax
%elif %1=1
    nop
;;    pmovmskb eax,mm0; not w. k6-2 cpu
;;    pminsw mm0,mm1; not w. k6-2 cpu
;t1 --------------------;
%elif %1=2
    nop
;;    pmaxub mm0,mm1; not w. k6-2 cpu
;;    psllq mm0,32;:ok:
;;    pavgw mm0,mm1; not w. k6-2 cpu
;t2 --------------------;
%elif %1=3
    nop
;;    pmaxsw mm0,mm1; not w. k6-2 cpu
;;    pextrw eax,mm0,2; not w. k6-2 cpu
;t3 --------------------;
%endif
%00:
    mov eax,edx
%if %1=0
;t0 0000000017FFFFFA 402653
    xor eax,eax
%elif %1=1
;t1 000000002FFFFFF4 0
    mov eax,0
;t1 --------------------;
%elif %1=2
;t2 000000002FFFFFF4 0
    xor eax,eax
;t2 --------------------;
%elif %1=3
;t3 000000002FFFFFF4 0
    xor edx,edx
;t3 --------------------;
%endif
;# no-int
;t0 00000000 32C406AB 851707
;t1 00000000 77790561 301004
;t2 00000000 82D826D1 491788
;t3 00000000 73E9AAE8 241278
;# locked
;t0 00000000 17FFFFFA 402653
;t1 00000000 37FFFFF2 134217
;t2 00000000 3BFFFFF1 201326
;t3 00000000 37FFFFF2 134217
;# locked, last: bswap w.o. shr...
;t0 00000000 17FFFFFA 402653
;t1 00000000 37FFFFF2 134217
;t2 00000000 3BFFFFF1 201326
;t3 00000000 33FFFFF3 67108
; ----------------------;
%00:
    mov eax,edx
%if %1=0
    nop
%elif %1=1
    rol ax,8
;t1 --------------------;
%elif %1=2
    xchg al,ah
;t2 --------------------;
%elif %1=3
    bswap eax
;;    shr eax,16
;t3 --------------------;
%endif
;t0 00000000017FFFFA 25165
%00:
    mov eax,edx
%if %1=0
    nop
%elif %1=1
;t1 0000000003FFFFF0 16777
    not eax
    lea eax,[edx+eax]
    not eax
    lea eax,[eax-0x200]
;t1 --------------------;
%elif %1=2
;t2 00000000037FFFF5 8388
    push eax	; <= 8388, edx, eax, egal
    sub eax,edx
    lea eax,[eax-0x200]
    mov edx,eax	; <= 12582
    pop eax
;t2 --------------------;
%elif %1=3
;t3 00000000087FFFDE 92274
    pushfd
    popfd
;;    shr eax,16
;t3 --------------------;
%endif
%elif %1=1
;t1 000000001EFFFFE3 318767
    pushad
    nop
    popad
;t1 --------------------;
%elif %1=2
;t2 000000000EFFFFF1 50331
    push eax
    push ebx
    nop
    pop ebx
    pop eax
;t2 --------------------;
%elif %1=3
;t3 000000001CFFFFE3 285212
    push eax
    push ebx
    push ecx
    push edx
    push esi
    push edi
    push esp
    push ebp
    nop
    pop ebp
    pop esp
    pop edi
    pop esi
    pop edx
    pop ecx
    pop ebx
    pop eax
;t3 --------------------;
%endif
;;;
%endm
