;-================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file	: asm+resource.h.inc
;-  switch	: _I386_RESOURCE_H
;-  created	: 15-mai-2000
;-  modified	: 17-mai-2000
;-  version	: 0.02
;-  assembler	: nasm 0.98-3e
;-  description	: resource limits
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	: also in -re- file <resource.h.inc>
;-  source	: linux/include/asm-386/resource.h
;-  requires	: types.inc from "asmutils" by K.Boldyshev,
;-			http://lightning.voshod.com:/asm
;-================================================================;
;-
;-
%ifndef _I386_RESOURCE_H
%define _I386_RESOURCE_H

;- Resource limits

%define RLIMIT_CPU	0		; CPU time in ms
%define RLIMIT_FSIZE	1		; Maximum filesize
%define RLIMIT_DATA	2		; max data size
%define RLIMIT_STACK	3		; max stack size
%define RLIMIT_CORE	4		; max core file size
%define RLIMIT_RSS	5		; max resident set size
%define RLIMIT_NPROC	6		; max number of processes
%define RLIMIT_NOFILE	7		; max number of open files
%define RLIMIT_MEMLOCK	8		; max locked-in-memory address space
%define RLIMIT_AS	9		; address space limit
%define RLIMIT_LOCKS	10		; maximum file locks held

%define RLIM_NLIMITS	11

%define RLIM_INFINITY	(~0)

;%ifdef __KERNEL__
%define INIT_RLIMITS {{RLIM_INFINITY,RLIM_INFINITY},{RLIM_INFINITY,RLIM_INFINITY},{RLIM_INFINITY,RLIM_INFINITY},{_STK_LIM,RLIM_INFINITY},{0,RLIM_INFINITY},{RLIM_INFINITY,RLIM_INFINITY},{0,0},{INR_OPEN,INR_OPEN},{RLIM_INFINITY,RLIM_INFINITY},{RLIM_INFINITY,RLIM_INFINITY},{RLIM_INFINITY,RLIM_INFINITY},}
;%endif ; __KERNEL__

%endif; _I386_RESOURCE_H
;-
;-================================================================;
;- asm+resource.h.inc <eof>
