; Copyright (C) 1999-2000 Konstantin Boldyshev <konst@linuxassembly.org>
; Copyright (C) 2000 h-peter recktenwald <phpr@snafu.de>
;
; file		: syscall.inc
; created	: 10-dec-2000
; modified	: system calls supplement to <au/syscalls.inc>.
; 		: 30-jun-2000'hp, macroes set to 'nolist' mode
;		: 	additional 'generic' syscall for "lib4th"
; version	: 0.09
; assembler	: nasm 0.98
; description	: system call macros
; author	: h-peter recktenwald <phpr@snafu.de>
; comment	: included internally from system.inc
;		: including asmutils' file from <au> subdir.
;-

%ifndef	__SYSTEM_INC
%error "this file must be included internally from system.inc !"
%endif

%ifndef __SYSCALL_INC

%ifndef __AU__
;- asmutils version, adjust to suit if __AU__ undef'd!
%assign __AU__ 015
%endif

%include "au/syscall.inc"
%define syscallinc

;-
;- internal system call macros
;-

;- system call definition
;-
;- NEVER USE THIS MACRO DIRECTLY!
;-
;- %1	syscall name
;- %2	number of syscall parameters
;- %3	number of registers to prepare
;- %4..	parameters (eax,ebx,ecx,edx,esi,edi[,ebp])
;-
;- 'generic' mode for "lib4th" tested with Linux, only.
;-


;--------------------------------------------------------------------------
;-				System Calls
;--------------------------------------------------------------------------

%ifndef SYS_eax
%define SYS_eax eax
;- syscall entry, expecting all registers pre-set [hp/2000]
%macro sys_generic 0-6_nolist
	__syscall eax, 6, %0, %1, %2, %3, %4, %5, %6
%endmacro
%endif
;-
;- sys_uselib *path_to_library
%macro sys_uselib 0-1_nolist
	__syscall uselib, 1, %0, %1
%endmacro

;--------------------------------------------------------------------------
;arch/i386/
;--------------------------------------------------------------------------

;
;arch/i386/kernel/signal.c
;

;- sys_rt_sigaction 0-4
;-	int sig, const struct sigaction *act, struct sigaction *oact, size_t sigsetsize
%macro sys_rt_sigaction 0-4_nolist
	__syscall rt_sigaction, 4, %0, %1, %2, %3, %4
%endmacro

;- sys_rt_sigqueueinfo 0-3
;-	int pid, int sig, siginfo_t *uinfo
%macro sys_rt_sigqueueinfo 0-3_nolist
	__syscall rt_sigqueueinfo, 3, %0, %1, %2, %3
%endmacro

;--------------------------------------------------------------------------
;mm/
;--------------------------------------------------------------------------

;
;mm/filemap.c
;

;- sys_msync 0-3
;-	ulong start, size_t len, int flags
%macro sys_msync 0-3_nolist
	__syscall msync, 3, %0, %1, %2, %3
%endmacro

;--------------------------------------------------------------------------
;fs/
;--------------------------------------------------------------------------

;
;fs/read_write.c
;

%if __AU__ < 014
;- sys_llseek 0-5
;-	uint fd, ulong hi, ulong lo, loff_t * res, uint wh)
%macro sys_llseek 0-5_nolist
	__syscall _llseek, 5, %0, %1, %2, %3, %4, %5
%endmacro
%endif
;
;fs/open.c
;

;- sys_fchdir 0-1
;-	int fd
%macro sys_fchdir 0-1_nolist
	__syscall fchdir, 1, %0, %1
%endmacro

;-  sys_truncate 0-2
;-	char* path, off_t length
%macro sys_truncate 0-2_nolist
	__syscall truncate, 2, %0, %1, %2
%endmacro

;
;fs/buffer.c
;

;[hp'8/2000]
%macro sys_fsync 0-1_nolist; int fd
	__syscall fsync, 1, %0, %1
%endmacro
;[hp'11/2000]
%macro sys_fdatasync 0-1_nolist; int fd
	__syscall fdatasync, 1, %0, %1
%endmacro

;--------------------------------------------------------------------------
;kernel/
;--------------------------------------------------------------------------

;
;kernel/sched.c
;

%if __AU__<016
%macro sys_getpid 0_nolist
	__syscall getpid, 0
%endmacro
%endif
;[hp] 24.10.2001
%macro sys_waitpid 0-3_nolist
	__syscall waitpid, 3,%0,%1,%2,%3
%endmacro

%if __AU__<013
%macro sys_setuid 0-1_nolist
	__syscall setuid, 1, %0, %1
%endmacro
%endif
%macro sys_setgid 0-1_nolist
	__syscall setgid, 1, %0, %1
%endmacro


;
;kernel/sys.c
;
;[hp] 11/2000
%if __AU__<015

%macro sys_umask 0-1_nolist; mode_t mask
	__syscall umask, 1, %0, %1
%endmacro
%endif

%ifndef __LINUX__	; linux has its own implementation in os_linux.inc

;--------------------------------------------------------------------------
;network syscalls
;--------------------------------------------------------------------------

%endif	;__LINUX__

;--------------------------------------------------------------------------

%endif
