; Copyright (C) 1999-2000 Konstantin Boldyshev <konst@linuxassembly.org>
; Copyright (C) 2001 h-peter recktenwald <phpr@snafu.de>
;
; $Id: system.inc,v 1.9 2002/02/05 00:35:31 hp Exp $
;
; file		: system.inc
; created	: 18-Dec-2000
; modified	: 05-Jan-2001
; version	: lib4th 0.0.60+ for asmutils 0.11+
; assembler	: nasm 0.98-3e
; description	: generic (not OS specific) macros, sections, headers, etc.
; author	: hp for lib4th. extends asmutils 0.11+
;		: Konstantin Boldyshev <konst@linuxassembly.org>
; comment	: you must include this file to do anything else

%ifndef __SYSTEM_INC
%ifndef systeminc
;--------------------------------------------------------------------------
; default configuration parameters (used if not specified at compile time)
;--------------------------------------------------------------------------

%ifndef _nolist
%define _nolist
%endif

%ifdef __L4
%ifndef secset
%define secset
;mglicherweise gibt es ja vollidioten, die selbst diese nasm-"entwickler" noch bertreffen...
;    section .text align=4096
;triggers dozens of stupid such "warnings":
;    system.inc:46: warning: section attributes ignored on redeclaration of section `.text'
;    au/includes.inc:329: warning: section attributes ignored on redeclaration of section `.text'
;and what is that lines 46, 329? an <endstruc> statement! - how?
%endif
%endif
; versuch fr <ld -nobuiltin>
; ---------------------------
; geht nicht:    [section .text align=4096]
; spielt - und wieder nicht ...:
;    [section {.text align=4096}]
; noch schlimmer:
; (spielt, wenn das blde "warning..." in <nasm/outelf.c> auskommentiert ist,
; (ist dann aber immernoch zu nichts ntze, i.e. <ld -nobuiltin> versagt vllig!
;    section .text align=4096
; hilftnix:    %define __SECT__

%include "au/system.inc"
%define systeminc

; <cdq> doesn't pair, executes ca. 3 times slower than substitute
%macro _cdq 0_nolist ;[hp'3/2001]
%if __OPTIMIZE__=__O_SIZE__
    cdq
%else
    mov edx,eax
    sar edx,31
%endif
%endm

; nutzlos:
;	%undef _xchg;%ifidn __AU__,__AU_0.11__
%if __AU__<014
%macro _xchg 2-3_nolist
%if __OPTIMIZE__=__O_SIZE__
%assign ea 4
%else
%assign ea 0
    %if %{0}=3
	%ifid %{3}
%assign ea ea|8
	%endif
    %endif
    %ifid %{2}
%assign ea ea|2
    %endif
    %ifid %{1}
%assign ea ea|1
    %endif
    %ifdef __MMX
	%ifnid %{1}
	    %ifnid %{2}
%assign ea ea|16
	    %endif
	%endif
    %endif
%endif
; reg/mem,reg reg,reg/mem 5 clocks
%if ea=2
    add %{1},%{2}
    sub %{2},%{1}
    add %{1},%{2}
    neg %{2}
%elif ea=1
    add %{2},%{1}
    sub %{1},%{2}
    add %{2},%{1}
    neg %{1}
%elif ea=3;[hp'020204]
    lea %{1},%{2}
    sub %{2},%{1}
    lea %{1},%{2}
    neg %{2}
%elif ea>8		;[hp'010325]
; rm,r r,rm temp register
    %if ea>16
    movd mm0,%{1}
    movd mm1,%{2}
    movd %{2},mm0
    movd %{1},mm1
    %else
    mov %{3},%{1}
    mov %{1},%{2}
    mov %{2},%{3}
    %endif
%else
;  2 clocks w. reg,reg
; 33 clocks w. reg,mem or mem,reg - either case
    xchg %{1},%{2}	; [bugfix hp'010325]
%endif
%endmacro
%endif

%ifndef %$origin	; ELF programs' org
%push elf
%define	%$origin 0x08048000
%endif

%endif
%endif	;__SYSTEM_INC
