;-================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read LICENSE file for full copyright information (GNU GPL)
;-
;-  file  	: console_h.inc
;-  switch	: _LINUX_CONSOLE_H
;-  created	: 25-sep-2001
;-  modified	: 
;-  version	: 0.01
;-  assembler	: nasm 0.98
;-  description	: 
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	:
;-  source	: console.h, linux 2.2.14rtl2.0
;-  requires	: "asmutils" by K.Boldyshev, http://linuxasm.org
;-================================================================;
;-
;-

;  linux/include/linux/console.h
;  Copyright (C) 1993        Hamish Macdonald
; This file is subject to the terms and conditions of the GNU General Public
; License.  See the file COPYING in the main directory of this archive for more details.
; Changed:
; 10-Mar-94: Arno Griffioen: Conversion for vt100 emulator port from PC LINUX

%ifndef _LINUX_CONSOLE_H_
%define _LINUX_CONSOLE_H_ 1

%include "console_struct_h.inc"

;struct vc_data;
;struct console_font_op;

; this is what the terminal answers to a ESC-Z or csi0c query.
%define VT100ID "\033[?1;2c"
%define VT102ID "\033[?6c"

	struc consw
.con_startup:		resd 1	;const char *(*con_startup)(void);
.con_init:		resd 1	;void	(*con_init)(struct vc_data *, int);
.con_deinit:		resd 1	;void	(*con_deinit)(struct vc_data *);
.con_clear:		resd 1	;void	(*con_clear)(struct vc_data *, int, int, int, int);
.con_putc:		resd 1	;void	(*con_putc)(struct vc_data *, int, int, int);
.con_putcs:		resd 1	;void	(*con_putcs)(struct vc_data *, const unsigned short *, int, int, int);
.con_cursor:		resd 1	;void	(*con_cursor)(struct vc_data *, int);
.con_scroll:		resd 1	;int	(*con_scroll)(struct vc_data *, int, int, int, int);
.con_bmove:		resd 1	;void	(*con_bmove)(struct vc_data *, int, int, int, int, int, int);
.con_switch:		resd 1	;int	(*con_switch)(struct vc_data *);
.con_blank:		resd 1	;int	(*con_blank)(struct vc_data *, int);
.con_font_op:		resd 1	;int	(*con_font_op)(struct vc_data *, struct console_font_op *);
.con_set_palette:	resd 1	;int	(*con_set_palette)(struct vc_data *, unsigned char *);
.con_scrolldelta:	resd 1	;int	(*con_scrolldelta)(struct vc_data *, int);
.con_set_origin:	resd 1	;int	(*con_set_origin)(struct vc_data *);
.con_save_screen:	resd 1	;void	(*con_save_screen)(struct vc_data *);
.con_build_attr:	resd 1	;u8	(*con_build_attr)(struct vc_data *, u8, u8, u8, u8, u8);
.con_invert_region:	resd 1	;void	(*con_invert_region)(struct vc_data *, u16 *, int);
.con_screen_pos:	resd 1	;u16    *(*con_screen_pos)(struct vc_data *, int);
.con_getxy:		resd 1	;unsigned long (*con_getxy)(struct vc_data *, unsigned long, int *, int *);
	endstruc

;extern struct consw *conswitchp;
;extern struct consw dummy_con;	;dummy console buffer */
;extern struct consw fb_con;	;frame buffer based console */
;extern struct consw vga_con;	;VGA text console */
;extern struct consw newport_con;	;SGI Newport console  */
;extern struct consw prom_con;	;SPARC PROM console */

;void take_over_console(struct consw *sw, int first, int last, int deflt);
;void give_up_console(struct consw *sw);

;scroll */
%define SM_UP       (1)
%define SM_DOWN     (2)

;cursor */
%define CM_DRAW     (1)
%define CM_ERASE    (2)
%define CM_MOVE     (3)

; Array of consoles built from command line options (console=)
	struc console_cmdline
.name:	resb 8	;char	name[8];			;Name of the driver	    */
.index:	resd 1	;int	index;				;Minor dev. to use	    */
.options:resd 1	;char	*options;			;Options for the driver   */
	endstruc
%define MAX_CMDLINECONSOLES 8
;extern struct console_cmdline console_list[MAX_CMDLINECONSOLES];

; The interface for a console, or any other device that
; wants to capture console messages (printer driver?)

%define CON_PRINTBUFFER	(1)
%define CON_CONSDEV	(2) ;Last on the command line */
%define CON_ENABLED	(4)

; from linux/kdev_t.h
	struc kdev_t	; { unsigned short major, minor; } kdev_t;
.major:	resw 1
.minor:	resw 1
	endstruc

	struc console
.name:	resb 8	;char	name[8];
.write:	resd 1	;void	(*write)(struct console *, const char *, unsigned);
.read:	resd 1	;int	(*read)(struct console *, const char *, unsigned);
.device:resb ((kdev_t_size+4)&-4);kdev_t	(*device)(struct console *);
.wait_key:resd 1;int	(*wait_key)(struct console *);
.unblank:resd 1	;void	(*unblank)(void);
.setup:	resd 1	;int	(*setup)(struct console *, char *);
.flags:	resw 1	;short	flags;
.index:	resw 1	;short	index;
.cflag:	resd 1	;int	cflag;
.next:	resd 1	;struct	 console *next;
	endstruc

;extern void register_console(struct console *);
;extern int unregister_console(struct console *);
;extern struct console *console_drivers;

; VESA Blanking Levels
%define VESA_NO_BLANKING        0
%define VESA_VSYNC_SUSPEND      1
%define VESA_HSYNC_SUSPEND      2
%define VESA_POWERDOWN          3

%endif ;_LINUX_CONSOLE_H */
;-================================================================;
;- console_h.inc <eof>
