;-================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read LICENSE file for full copyright information (GNU GPL)
;-
;-  file  	: console_struct_h.inc
;-  switch	: _CONSOLE_STRUCT_H
;-  created	: 25-sep-2001
;-  modified	: 
;-  version	: 0.01
;-  assembler	: nasm 0.98
;-  description	: 
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	:
;-  source	: console_struct.h, vt_kern.h, linux 2.2.14rtl2.0
;-  requires	: "asmutils" by K.Boldyshev, http://linuxasm.org
;-================================================================;
;-
;-

%ifndef _CONSOLE_STRUCT_H
%define _CONSOLE_STRUCT_H

; from vt_kern.h
; this really is an extension of the vc_cons structure in console.c, but
; with information needed by the vt package
;#include <linux/config.h>
;#include <linux/vt.h>

; Presently, a lot of graphics programs do not restore the contents of
; the higher font pages.  Defining this flag will avoid use of them, but
; will lose support for PIO_FONTRESET.  Note that many font operations are
; not likely to work with these programs anyway; they need to be
; fixed.  The linux/Documentation directory includes a code snippet
; to save and restore the text font.

;#ifdef CONFIG_VGA_CONSOLE
;#define BROKEN_GRAPHICS_PROGRAMS 1
;#endif

	struc vt_struct
; :NOTE: padding to multiples of four might be false -??-
.vt_num:	resd 1		;int vc_num;			/* The console number */
.vc_mode:	resd 1		;unsigned char	vc_mode;	/* KD_TEXT, ... */
.vt_mode:	resb ((vt_mode_size+3)&-4);struct vt_mode vt_mode;
.vt_pid:	resd 1		;int		vt_pid;
.vt_newvt:	resd 1		;int		vt_newvt;
.paste_wait:	resd 1		;struct wait_queue *paste_wait;
	endstruc
;} *vt_cons[MAX_NR_CONSOLES];

; console_struct.h
; Data structure describing single virtual console except for data used by vt.c.
; Fields marked with [%] must be set by the low-level driver.
; Fields marked with [!] can be changed by the low-level driver
; to achieve effects such as fast scrolling by changing the origin.

%assign NPAR 16
%assign palette_size 3*16
 
	struc vc_data
; :NOTE: padding to multiples of four might be false -??-
.vc_num:	resd 1	;	unsigned short	vc_num;			;Console number */
.vc_cols:	resd 1	;	unsigned int	vc_cols;		;[%] Console size */
.vc_rows:	resd 1	;	unsigned int	vc_rows;
.vc_size_row:	resd 1	;	unsigned int	vc_size_row;		;Bytes per row */
.vc_sw:		resd 1	;	struct consw	*vc_sw;
.vc_screenbuf:	resd 1	;	unsigned short	*vc_screenbuf;		;In-memory character/attribute buffer */
.vc_screenbuf_size:resd 1;	unsigned int	vc_screenbuf_size;
.vc_attr:	resb 1	;	unsigned char	vc_attr;		;Current attributes */
.vc_def_color:	resb 1	;	unsigned char	vc_def_color;		;Default colors */
.vc_color:	resb 1	;	unsigned char	vc_color;		;Foreground & background */
.vc_s_color:	resb 1	;	unsigned char	vc_s_color;		;Saved foreground & background */
.vc_ulcolor:	resb 1	;	unsigned char	vc_ulcolor;		;Color for underline mode */
.vc_halfcolor:	resd 1	;	unsigned char	vc_halfcolor;		;Color for half intensity mode */
.vc_complement_mask:resw 1	;unsigned short	vc_complement_mask;	;[%] Xor mask for mouse pointer */
.vc_hi_font_mask:resw 1	;	unsigned short	vc_hi_font_mask;	;[%] Attribute set for upper 256 chars of font or 0 if not supported */
.vc_video_erase_char:resw 1	;unsigned short	vc_video_erase_char;	;Background erase character */
.vc_s_complement_mask:resw 1	;unsigned short	vc_s_complement_mask;	;Saved mouse pointer mask */
.vc_x:		resd 1	;
.vc_y:		resd 1	;	unsigned int	vc_x, vc_y;		;Cursor position */
.vc_top:	resd 1	;
.vc_bottom:	resd 1	;	unsigned int	vc_top, vc_bottom;	;Scrolling region */
.vc_state:	resd 1	;	unsigned int	vc_state;		;Escape sequence parser state */
.vc_npar:	resd 1	;
.vc_par:	resd NPAR;	unsigned int	vc_npar,vc_par[NPAR];	;Parameters of current escape sequence */
.vc_origin:	resd 1	;	unsigned long	vc_origin;		;[!] Start of real screen */
.vc_scr_end:	resd 1	;	unsigned long	vc_scr_end;		;[!] End of real screen */
.vc_visible_origin:resd 1;	unsigned long	vc_visible_origin;	;[!] Top of visible window */
.vc_pos:	resd 1	;	unsigned long	vc_pos;			;Cursor address */
.vc_saved_x:	resd 1	;      	unsigned int	vc_saved_x;
.vc_saved_y:	resd 1	;      	unsigned int	vc_saved_y;
;mode flags */
.vc_charset:	resd 1	;: 1;	unsigned int	vc_charset	: 1;	;Character set G0 / G1 */
.vc_s_charset:	resd 1	;: 1;	unsigned int	vc_s_charset	: 1;	;Saved character set */
.vc_disp_ctrl:	resd 1	;: 1;	unsigned int	vc_disp_ctrl	: 1;	;Display chars < 32? */
.vc_toggle_meta:resd 1	;: 1;	unsigned int	vc_toggle_meta	: 1;	;Toggle high bit? */
.vc_decscnm:	resd 1	;: 1;	unsigned int	vc_decscnm	: 1;	;Screen Mode */
.vc_decom:	resd 1	;: 1;	unsigned int	vc_decom	: 1;	;Origin Mode */
.vc_decawm:	resd 1	;: 1;	unsigned int	vc_decawm	: 1;	;Autowrap Mode */
.vc_deccm:	resd 1	;: 1;	unsigned int	vc_deccm	: 1;	;Cursor Visible */
.vc_decim:	resd 1	;: 1;	unsigned int	vc_decim	: 1;	;Insert Mode */
.vc_deccolm:	resd 1	;: 1;	unsigned int	vc_deccolm	: 1;	;80/132 Column Mode */
;attribute flags */
.vc_intensity:	resd 1	;: 2;	unsigned int	vc_intensity	: 2;	;0=half-bright, 1=normal, 2=bold */
.vc_underline:	resd 1	;: 1;	unsigned int	vc_underline	: 1;
.vc_blink:	resd 1	;: 1;	unsigned int	vc_blink	: 1;
.vc_reverse:	resd 1	;: 1;	unsigned int	vc_reverse	: 1;
.vc_s_intensity:resd 1	;: 2;	unsigned int	vc_s_intensity	: 2;	;saved rendition */
.vc_s_underline:resd 1	;: 1;	unsigned int	vc_s_underline	: 1;
.vc_s_blink:	resd 1	;: 1;	unsigned int	vc_s_blink	: 1;
.vc_s_reverse:	resd 1	;: 1;	unsigned int	vc_s_reverse	: 1;
;misc */
.vc_ques:	resd 1	;: 1;	unsigned int	vc_ques		: 1;
.vc_need_wrap:	resd 1	;: 1;	unsigned int	vc_need_wrap	: 1;
.vc_can_do_color:resd 1	;: 1;	unsigned int	vc_can_do_color	: 1;
.vc_report_mouse:resd 1	;: 2;	unsigned int	vc_report_mouse : 2;
.vc_kmalloced:	resd 1	;: 1;	unsigned int	vc_kmalloced	: 1;
.vc_utf:	resb 1	;: 1;	unsigned char	vc_utf		: 1;	;Unicode UTF-8 encoding */
.vc_utf_count:	resb 1	;    	unsigned char	vc_utf_count;
		resw 1	; padding to dword bounds -??-
.vc_utf_char:	resd 1	;	int	vc_utf_char;
.vc_tab_stop:	resd 5	;	unsigned int	vc_tab_stop[5];		;Tab stops. 160 columns. */
.vc_palette:	resb palette_size;unsigned char vc_palette[16*3];       ;Colour palette for VGA+ */
.vc_translate:	resd 1	;   	unsigned short * vc_translate;
.vc_G0_charset:	resb 1	;      	unsigned char 	vc_G0_charset;
.vc_G1_charset:	resb 1	;      	unsigned char 	vc_G1_charset;
.vc_saved_G0:	resb 1	;     	unsigned char 	vc_saved_G0;
.vc_saved_G1:	resb 1	;	unsigned char 	vc_saved_G1;
.vc_bell_pitch:	resd 1	;	unsigned int	vc_bell_pitch;		;Console bell pitch */
.vc_bell_duration:resd 1;	unsigned int	vc_bell_duration;	;Console bell duration */
.vc_cursor_type:resd 1	;	unsigned int	vc_cursor_type;
.vc_display_fg:	resd 1	;	struct vc_data **vc_display_fg;		;[!] Ptr to var holding fg console for this display */
.vc_uni_pagedir:resd 1	;     	unsigned long	vc_uni_pagedir;
.vc_uni_pagedir_loc:resd 1;	unsigned long	*vc_uni_pagedir_loc;  ;[!] Location of uni_pagedir variable for this console */
;additional information is in vt_kern.h */
	endstruc

;struct vc {
;	struct vc_data *d;
;	;might add  scrmem, vt_struct, kbd  at some time, to have everything in one place
;	; - the disadvantage would be that vc_cons etc can no longer be static
;};

;extern struct vc vc_cons [MAX_NR_CONSOLES];

%assign CUR_DEF		0
%assign CUR_NONE	1
%assign CUR_UNDERLINE	2
%assign CUR_LOWER_THIRD	3
%assign CUR_LOWER_HALF	4
%assign CUR_TWO_THIRDS	5
%assign CUR_BLOCK	6
%assign CUR_HWMASK	0x0f
%assign CUR_SWMASK	0xfff0

%assign CUR_DEFAULT CUR_UNDERLINE

;%define CON_IS_VISIBLE(conp) (*conp->vc_display_fg == conp)

%endif; _CONSOLE_STRUCT_H
;-================================================================;
;- console_struct_h.inc <eof>
