;[nolist]
;-================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file  	: constants.inc
;-  switch	: __CONSTANTS_INC
;-  created	: 23-apr-00
;-  modified	: 29-mai-00
;-  version	; 0.18
;-  assembler	: nasm 0.98-3e
;-  description	: constant values defn's for "calc"/"f8" assembly
;-		: assembly control, uservari disp's, signals
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	: 
;-  source	: (several)
;-  requires	: signal_h.inc, ascictrl.inc, kd.h.inc
;-================================================================;
;-
;-
%ifndef __CONSTANTS_INC
%define __CONSTANTS_INC
%define constantsinc

%if 0
%ifdef __LIB4TH
	extern _start
%else
	global _start:function
%endif
%endif
%ifndef _nolist
%define _nolist
%endif

%define aligndft 16
;
; NOTE: Due to nasm specific issues (deficiencies) DO NOT CHANGE
; the general structures SETUP AND LOCATIONS! Current arrangement
; was found feasible after many (weeks of) trials and errors and
; apparently is on a very narrow path of possible solutions!

;-
;- "sysdep.inc"
;-	includes system dependent constants which cannot be
;-	derived at runtime, neither from the proc fs nor, by trial. 
%ifndef sysdepinc
%include "sysdep.inc" 
%define sysdepinc
%endif
%ifndef ascictrlinc
%include "ascictrl.inc" 
%define ascictrlinc
%endif
;-
;-  conditional assembly
;-
;-
;-  __lockthread, dft: NOT defined
;-	if def'd block move operations executed w. interrupts disabled
;-	NOTE: <setuid> programs only!
%define __lockthread
%undef __lockthread	;
;-

;-	
;-
;-
;-================================================================;
;-  signals -re- man 7 
;-

;-
;-  default setup
;-
;-  nsi(signum)
;-	signal mask for messages handler
;-  sgm(signum)
;-	signal mask for program exit handler
;-	re include/asm/signal.h
;-  srt(signum)
;-	signal mask for retry mode (re asm, segfault recovery)
;-  nms(signum)
;-	quiet, neither one of nsi, sgm
%undef sgarg
%macro sgm 1_nolist
%ifdef sgarg
%xdefine sgarg sgarg,%{1}
%assign  sgmask ((sgmask)|(1<<%{1}))
%else
%xdefine sgarg %{1}
%assign  sgmask (1<<%{1})
%endif
%endm
%undef mgarg
%macro nsi 1_nolist
%ifdef mgarg
%xdefine mgarg mgarg,%{1}
%assign  mgmask ((mgmask)|(1<<%{1}))
%else
%xdefine mgarg %{1}
%assign  mgmask (1<<%{1})
%endif
%endm
%undef rtarg
%macro rtm 1_nolist
%ifdef rtarg
%xdefine rtarg rtarg,%{1}
%assign  rtmask ((sgmask)|(1<<%{1}))
%else
%xdefine rtarg %{1}
%assign  rtmask (1<<%{1})
%endif
%endm
%xdefine nms(x)
;   xit msg none		;signo.	; ASCI,CTRL..	;    text
	    nms(SIGHUP)		; 1	;		; " Hangup"	----- not for sigaction
	    nms(SIGINT)		; 2	; 03,"C"	; " Terminal Interrupt"
;;	    nms(SIGQUIT)	; 3	; 28,"\"	; " Quit"
	nsi(SIGQUIT)		; 3	; 28,"\"	; " Quit"
;;    sgm(SIGQUIT)		; 3	; 28,"\"	; " Quit"	-> <can> (silly abort signal: badly placed on keyboard!)
    sgm(SIGILL)			; 4	;		; " Illegal instruction"	:srt:
	    nms(SIGTRAP)	; 5	;		; " Trace/breakpoint trap"
    sgm(SIGABRT)		; 6	;		; " Aborted"
;;    	    nms(SIGIOT)		; 6	;		; " Terminal Interrupt" -???- SIGINT
    sgm(SIGBUS)			; 7	;		; " Bus error"			:srt:
;;	nsi(SIGFPE)		; 8	;		; " Floating point exception"/"Arithmetic Fault":srt:
    sgm(SIGFPE)			; 8	;		; " Floating point exception"/"Arithmetic Fault":srt:
    sgm(SIGKILL)		; 9	;		; " Killed"	----- not for sigaction
        nsi(SIGUSR1)		;10 0A	;		; " User defined signal 1"
    sgm(SIGSEGV)		;11	;		; " Segmentation fault"		:srt:!
;;	nsi(SIGSEGV)		;11	;		; " Segmentation fault"		:srt:!
	nsi(SIGUSR2)		;12 0C	;		; " User defined signal 2"
        nsi(SIGPIPE)		;13	;		; " Broken pipe"
	nsi(SIGALRM)		;14	;		; " Alarm clock"
    sgm(SIGTERM)		;15	;		; " Terminated"
    sgm(SIGSTKFLT)		;16 10	;		; " Stack fault"		:srt:
	    nms(SIGCHLD)	;17	;		; " Child exited"
        nsi(SIGCONT)		;18	;		; " Continued"
	nsi(SIGSTOP)		;19	; 		; " Stopped (signal)"
        nsi(SIGTSTP)		;20 14	; 26,"Z"	; " Stopped"
	nsi(SIGTTIN)		;21	;		; " Stopped (tty input)"
        nsi(SIGTTOU)		;22	;		; " Stopped (tty output)"	-:1:-
	nsi(SIGURG)		;23	;		; " Urgent I/O condition"
    sgm(SIGXCPU)		;24 18	;		; " CPU time limit exceeded"	:srt:
        nsi(SIGXFSZ)		;25	;		; " File size limit exceeded"	:srt:
	nsi(SIGVTALRM)		;26	;		; " Virtual timer expired"
        nsi(SIGPROF)		;27	;		; " Profiling timer expired"
	    nms(SIGWINCH)	;28 1C	;		; " Window changed" : ok if xterm re-zized, console-chg doesn't trigger
        nsi(SIGIO)		;29	;		; " I/O possible", SIGPOLL
;;        nsi(SIGLOST)		;29	;		; " Resource lost"
    sgm(SIGPWR)			;30 1E	;		; " Power failure"
	nsi(SIGUNUSED)		;31
;:1: lx, tty_io.c, tty_check_change:
;	If we try to write to, or set the state of, a terminal and we're
;	not in the foreground, send a SIGTTOU. If the signal is blocked or
;	ignored, go ahead and perform the operation.  (POSIX 7.2)
;%xdefine sgarg sgarg,0,0
; Set up the stack frame (signal.c):
; if (ka->sa.sa_flags & SA_SIGINFO) setup_rt_frame(sig, ka, info, oldset, regs);

;errors occurred due to false siginfo structure:(*sa_sigaction)... is libc specific!
;    sgm(SIGINT) 	; 2	; " Interrupt"	<- strace getting stuck if enabled ::
;    sgm(SIGQUIT)	; 3	; " Quit"	<- strace getting stuck if enabled ::


;-
;-================================================================;
;-  ctrl-s
;-

;-
;-  ctrl actions, signals and/or linux console, re struct "termios"
;-	3	C		SIGINT
;-	4	D	EOF	logout(!)
;-	7	G		<bel>
;-	8	H		<bs><bl><bs>
;-	9	I		<tab>
;-	19	S		lock screen ("roll" off)
;-	26	Z	SUSP	SIGTSTP	-> job to bg
;-	28	\		SIGQUIT
;-	127			<del>
;QUIT		;0x1C	c"\"
;START		;0x11	Q
;STOP		;0x13	S
;REPRINT	;0x12	R
;DISCARD	;0x0F	O
;WERASE		;0x17	W
;LNEXT		;0x16	V	<can>
;-	

;-
;-  AC_NUL,...
;-	ascii contol-character constants by AC_(ascii name)
; asci:   0   1   2   3   4   5   6   7  8  9  0  1  2  3  4  5   6   7   8   9   0   1   2   3   4  5   6   7  8  9  0  1
;;  mdef NUL,SOH,STX,ETX,EOT,ENQ,ACK,BEL,BS,HT,LF,VT,FF,CR,SO,SI,DLE,DC1,DC2,DC3,DC4,NAK,SYN,ETB,CAN,EM,SUB,ESC,FS,GS,RS,US;

; ctrl:^@  ^A, ^B  ^C  ^D  ^E  ^F  ^G ^H ^I ^J ^K ^L ^M ^N ^O  ^P  ^Q  ^R  ^S  ^T  ^U  ^V  ^W  ^X ^Y  ^Z esc ^\ ^] ^^ ^_
%define LF	AC_LF
%define AC_NL	AC_LF	; linux specific
%define TAB	AC_TAB
%define BSP	AC_BS
%define BEL	AC_BEL
%assign BL	32
%assign ESC	AC_ESC
%assign FS	AC_FS
%define EOF	CC_VEOF
;-	AC_DEL
;-		<del>ete at cursor posn, code 127
%assign AC_DEL	127
;-	AC_NBSP
;-		"non breaking space", code 160 in iso????-1 ("latin")
%assign AC_NBSP	160
;-	AC_VT102, reg_vt102
;-		dft terminal query response string "vt102"
%define	AC_VT102 '[?6c'
%define reg_vt102 'c6?['	; register value in {?vt}
;-	AC_VT100x, reg_vt100x
;-		terminal query response ("enhanced", whatever...) "vt100" of xterm
%define	AC_VT100x '[?1;2c'
%define reg_vt100x ';1?['	; register value in {?vt}
;-

;-
;-================================================================;
;-  forth system constants:
;-

;-
;-	
;-	b_b		bits per byte (8)
%assign b_b	8
;-	b_c		bytes per character (1), may be set to max. 4
%assign b_c	1
;-	b_cell		bytes per cell (4), may *not* be changed!
%assign b_cell	4
;-
;-	galign		subroutines entry alignment (4)
%define gos
%define jos short
%if __OPTIMIZE__=__O_SPEED__
%assign galign	1
%assign galign	4
;%assign galign	8
;%assign galign	16	; -> is slow!
%else
%assign galign	1
%define gos near	; asmutils compiles longer code on SIZE opt!
%define jos
%endif
;- alignment figures > 4 seem useless: no timing difference... (or even worse)
;	j.. jmp, g.. jcc
%define g32
%define g16
%define g08
%define g04
%define g01
%define j32 short
%define j16 short
%define j08 short
%define j04 short
%define j01 short
%if galign>1
%define g01 near
%define j01
%if galign>4
%define g04 near
%define j04
%if galign>8
%define g08 near
%define j08
%if galign>15
%define g16 near
%define j16
%if galign>31
%define j32
%define g32 near
%endif
%endif
%endif
%endif
%endif
;-

;-
;-  vm registers
;-

;-
;-  KR	ebx		kernel ref reg, base of lib4th .text section
%define KR ebx
;-  PS	edi		parameterstack, datastack (push bottom up!)
;-			memory ref for <scas>,source for <movs>
%define PS edi
;-  SP	edi		data-stack, synonym
%define SP PS
;-  LP	esi		locals base-ptr
; -	base address (bottom up) of dataspace in .ss = kref<@{d0}>
; -	NOTE: esi also used as ptr to lib4th initializing data structure
%define LP esi
;-  lref	LP + (disp)	ref to local value/ptr
%define lref LP+
;-  RS	esp		return-stack
%define RS esp
;-  UR	ebp		user vari reference base register (uref...)
%define UR ebp
;-  W	ecx		4th-vm W register (word address, wa, pfa)
%define W ecx
;-  T	edx		4th-vm T register (temporary storage)
%define T edx
;-  uref	uvari		ref into user-vari via [UR-uv.link+disp]
%define uref UR-(uv.link)+
;-  vref	vari		ref into data memory [vref ptr] = [VR+disp]
%define vref VR+
;-  kref	address-$$	ref into kernel by [kref address-Y] = [KR+disp]
;-			for kernel words & constant data (r/x memory)
%define kref KR+
;-
;-  datatop		@dtop	kref-d @mtop
%define datatop [uref uv.dtop]
;top of dataspace
;-	 ..
;-  dataptr		@dp	64K+, extendable into .bss, bottom up
%define dataptr [byte uref uv.dp]
;-	 ..
;-  databot		@d0	dataspace
%define databot [byte uref uv.d0]
;-  codetop		@ctop	end of code-space
%define codetop [byte uref uv.ctop]
;-	 ..
;-  codeptr		@cp	bottom up, 64K
%define codeptr [byte uref uv.cp]
;-	 ..
;-  codebot		@c0	dictionary
%define codebot [byte uref uv.c0]
;-  loclptr		@lp	@s0 bottom up
%define loclptr [byte uref uv.lp]


;-	
;-
;-================================================================;
;-  user vari defaults:
;-
;-
;-	d_base	number conversion radix, dft decimal.
%assign d_base  10
;- 	d_ccr	max 4 bytes newline ctrl code, dft (msb..<lf>lsb) sequence.
%assign d_ccr   AC_LF
;-	d_bl	blank space, any code below equally valid for <bl> parsing, ascii 32.
%assign d_bl	BL
;-	d_can	keyboard input char code for program termination, dft AC_EM, ^Y.
%assign d_can	AC_EM
;- 	d_cmul	no. of consecutive chars to recognize <d_del>, default is 4
%assign d_cmul	4
;- 	d_del	"delete", up to 4 chars used to deleting char under cursor, dft AC_DEL
%assign d_del   AC_DEL
;- 	d_bs	"backspace", up to 4 chars to retracting cursor by one posn, dft AC_BS
%assign d_bs	AC_BS
;-	d_substc
;-		text substitution delimiters, dft ascii 96 = "'", start in l.s.w, end in m.s.w
%assign d_substc ("'"<<16)|"'"
;-	d_tab	tabulator spacing, dft 8
%assign d_tab	8
;-	d_nvocs	max no. of stacked vocs., dft 16
%assign d_nvocs 16
;-	d_pchr	(lsb[32,126],[160,255]msb) ranges of printing chars
%assign d_pchr  0xffa07e20
;-	d_escc	"\" {etype} escape char
%assign d_escc	"\"
; -	d_prp	up to 4 chars for (r), used for formatted text output, dft 4 chars of AC_NBSP
;%define d_prp	(((AC_NBSP<<8)|AC_NBSP<<8)|AC_NBSP<<8)|AC_NBSP
;-	d_prp	up to 4 chars for (r), used for formatted text output, dft 4 chars of AC_BS
%define d_prp	(((BL<<8)|BL<<8)|BL<<8)|BL
;-	d_frac	max 4 +ve chars to mark input numeric fractions (dec. comma, etc; dft ",."
%define d_frac	',.'
;-	d_hdp	stg output char to mark output numeric fractions, dft ","
%define d_hdp	','
;-	d_nfm	max 4 +ve chars to mark bignum fractions (dec. comma, etc; dft ",."
%xdefine d_nfm ',.'
;-	d_width	max leading part of a name copied to wordheader, dft 254 (system dep'd max)
%assign	d_width	254
;-		provisional (tested -> useless -> in-active):
;-	d_pydel pty output delay count, hard dft 10200, actual appropriate value will be
;-		determined at startup if stdin is pty; may be saved for later use instead 
;-		of dft. (pty-delay) set to dft by {out-pty?} query, if pty and vari unset.
%assign	d_pydel	10200
;-	d_pydiv	timing divisor for automatic pty-delay detection, dft 34000
%assign	d_pydiv	34000
;-

;- 

;- 
;-  blockfile constants
;-		note: implied size of a char is a(n 8-bit-)byte.
;-	b_buf		bytes per screenfile buffer (cons 1024, as of ANS-4th)
%assign b_buf	1024
;-	b_scr		block per screen (1)
%assign b_scr	1
;-	c_l		c/l characters per line (64)
%assign c_l	64
;-	bbuffers	no. of initial blockfile buffers (1 buf w/ 4 blocks)
;-			for bbufmem := (b_buf*bbuffers+PAGE_SIZE-1)&PAGE_MASK
%assign bbuffers 1

;-
;-  bupdt, mupdt 31		screenfile blocks' update flag, in <bufhead.u>
%assign bupdt 31
%assign mupdt 1<<bupdt
;-  bfile, mfile 30		(un-used: 4th input from file, in {sourcre-id})
%assign bfile 30
%assign mfile 1<<bfile
;-
%if bupdt != 31
%die "update flag <mupdt> expected at bit#31"
%endif

;-
;-  user variables flag(bit)s
;-
;-  flag	vari	posn	if flag set:
;-
;- 	uv.aux	byte#
;-  skey	l.s.b.	0	single keystroke console mode
%assign skey 0
;-  klok	m.s.b.	3	kernel to input-job lock
%assign klok 3
;-
;-	uv.bits	bit-value, bit#
;-  caps, mcaps	16
;-			case dependent word search
%assign caps 15
%assign mcaps 1<<caps
;-  bbign,mbign
;-		16	next numeric input is bignum (counted integer)
%assign bbign 16
%assign mbign 1<<bbign
;-  branu,mranu
;-		17	next numeric input is 'ranum'
;-			(ordered cells pair, 'real', rational, reelle zahl...)
%assign branu 17
%assign mranu 1<<branu
;-  bqranu,mqranu
;-		18	next numeric input is quad 'ranum'
;-			(ordered quad cells pair)
%assign bqranu 18
%assign mqranu 1<<bqranu
;-  bfloat,mfloat, mfloatm
;-		19	set persistent numeric input mode to 'double ranum'
;-			'mfloatm' defines the set of bit-values (mfloat|mranu|mquad)
%assign bfloat 19
%assign mfloat 1<<bfloat
;-  bquadm,mquad 20
;-			next numeric input is quad
%assign bquad 20
%assign mquad 1<<bquad
;-  bcall,mcall	21
;-			cpl direct calls by disp to words, instead of uot-indirect;
;-			controlled {call-by-disp}, {call-by-uot} of {compiler}-voc.
%assign bcall 21
%assign mcall 1<<bcall
;-  bfmac,mfmac	22
;-			set if <bcmac> set and a macro compiling word was found
%assign bfmac 22
%assign mfmac 1<<bfmac
;-  bcmac,mcmac	23
;-			compile words as inlined code - where possible
%assign bcmac 23
%assign mcmac 1<<bcmac
;-  bedpl 24(l.s.b.), medpl 24..31(bits), edpl 3(byte)
;-			auxilary dpl for -ve exponent w/ rational numbers input
%assign edpl 3
%assign bedpl 24
%assign medpl 0xff<<bedpl
;-
;- quad ranum if mfloat,mranu,mquad all set and, medpl mask = $080
%assign mdfloat mqranu|mranu|mquad	; single quad ranum
%assign mfloatm mfloat|mranu|mquad	; persistent, double ranum mode
;-

;-	

;-
;-  i/o channels & flags
;-
;-  cdt_num
;-	no. of channel definition tables, dft 32 (any power of 2)
%assign cdt_bnum 6;
%assign cdt_num	1<<cdt_bnum
; - cdt_bsize
; -	binary exponent of cdt_size, dft 3 (cdt_size :=8 cells)
; -	def'd in "lib4th.mac"
;-
;-  cdt_bsize
;-	binary exponent of cdt_size in :cells:, dft 4 (cdt_size:=16 cells)
%assign cdt_bsize 4 ; 2^cdt_bsize cells
;-

;-
;-  cdt.chid
;-  +ve file descriptor, dword at <cdt.chid>, 4th per {ch-id}.
;-
;-  chinval
;-	cons (-1) pseudo file descriptor at invalid channel id
%assign chinval -1
;-  stdin, stdout, stderr, work, prt, scr1, scr2, kbd
;-	pre-defined channel numbers
%assign stdin	STDIN
%assign stdout	STDOUT
%assign stderr	STDERR
%assign workch	3
%assign prtch	4
%assign scr1ch	cdt_num-2
%assign scr2ch	cdt_num-1
%assign kbdch	cdt_num
;-
;-  O_ANYF	pseudo open-flag for {create-file} wrt serial devices.
%assign O_ANYF	0x80000000
;-	
;-  cdt.iofl
;-  file descriptor flag bits, dword at <cdt.iofl>, 4th per {ch-flags}.
;-
;-  binval, minval 31, sign-bit of flags dword
;-	not normally used but, if set denoting that associated
;-	channel id does not correspond to a valid file descriptor
%assign binval 31
%assign minval 1<<binval
;-  bcons,mcons	30
;-	set if fd is echoing console
%assign bcons 30
%assign mcons 1<<bcons
;-  bicon,micon	29
;-	set if 2ndary console opened
%assign bicon 29
%assign micon 1<<bicon
;-  bcflg,mcflg	28
;-	character received flag, set if any char present (buffered)
%assign bcflg 28
%assign mcflg 1<<bcflg
;-  bcrgt,mcrgt	27
;-	charcter reget flag, set if non-ascii char received (buffered)
%assign bcrgt 27
%assign mcrgt 1<<bcrgt
;-  bedif,medif	26
;-	edit mode, 1st cursor backup done
%assign bedif 26
%assign medif 1<<bedif
;-  bptyf,mptyf	25
;-	set if channel is a pty device
%assign bptyf 25
%assign mptyf 1<<bptyf
;-  bqryf,mqryf	24
;-	{query}-compliant {accept} mode, terminating if buffer full
%assign bqryf 24
%assign mqryf 1<<bqryf
;-  bchrf,mchrf	23
;-	nonblocking i/o if flag set, else "ndelay"
%assign bchrf 23
%assign mchrf 1<<bchrf
;-  biowf,miowf	22
;-	inserting editting mode, overwriting if bit unset
%assign biowf 22
%assign miowf 1<<biowf
;-
;-  cdt.perm
;-  file descriptor flag bits, dword at <cdt.perm>.
;-
;-  d_fperm
;-	new files' permissions, dft 600. on file open taken from user vari (fperm),
;-	required because ANS <fam> defined to the unsufficient size of a single cell.
%assign d_fperm 600q
;-
;-	

;-
;-  termios ioctl values
;-
;-  qtermtimo 1
;-	VTIME timeout value, dft 1, should always be >0 (re below)
%assign qtermtimo 2	; different =/= 0 values w. no effect
;-  qtermnum 1
;-	VMIN min. no. of chars to returning error free (if VTIME > 0),
;-	dft 1, after timeout read returns zero if VTIME := 0!
%assign qtermnum  1
;-
;-	VTIME	VMIN	(glibc 2.1.3 description)
;-	>0	>0	wait until VMIN char or timeout VTIM wrt each char
;-	 0	 0	ret immediately, 0 if no char available
;-	>0	 0	ret after timeout, 0 if no char available
;-	 0	>0	wait until at least VMIN chars received
;-
;- sys_select
;-
;- d_ustimo 0x7fffffff
;-	{wait4in} timeout default, used on entry to {accept}
%assign d_ustimo 0x7fffffff
; - d_itry  110000
; -	{accept} attempts to {key?} until intermediate call to {wait4in} 
;%assign d_itry 11000	; ca. 1/2s, max is 32767
; -
; - vt100, etc
; -
; -	wesc_attempts
; -		attempts to receiving <esc> response to vt.. queries, dft 6
;%assign wesc_attempts 6
; -
;-	

;-
;-================================================================;
;-  compiler, interpreter
;-

;-	

;-
;- assembler cons, for {see} etc. eax is @tos
;-	call/jmp 4th-word, fetch/sto kref'd/user mem, dup, drop, nop, ret
;-
;- x_dcall  b	<call PC+4+disp>, call a word by disp
%assign x_dcall	0xe8
;- x_ucall  w	<call [UR+disp]>, call a word by uot index
%assign x_ucall 0x95ff
;- x_djmp   b	<jmp PC+4+disp>, jump into a word by disp
%assign x_djmp	0xe9
;- x_ujmp   w	<jmp [UR+disp]>, jump into a word by uot index
%assign x_ujmp	0xa5ff
;-
;- x_nop    b	<nop>, alignment
%assign x_nop 0x90
;- x_ret    b	<ret>, unnest, {;S}
%assign x_ret 0xc3
;- x_spush  b	<stosd>, op-code for push @tos to nos, {DUP}
%assign x_spush	0xab
;- x_push  b	op-code for push reg
%assign x_push	0x50
;- x_pop   b	op-code for pop reg
%assign x_pop	0x58
;-
;- x_ipush  w	<stosd\;mov eax,imed>, push imed, i.e. {LIT}eral or cons, vari, etc.
%assign x_ipush 0xb8ab	;
;-
;- x_drmov  w	<mov eax,[dword kref+disp]> fetch from dataspace - {integer}, {VALUE}
%assign x_drmov	0x838b
;- x_ubread w	<mov eax,[byte UR+disp]>, fetch uvari at byte-sized disp
%assign x_ubread 0x458b
;- x_udread w	<mov eax,[UR+disp]>, fetch uvari at dword-sized disp
%assign x_udread 0x858b
;-
;- x_drmov  w	<mov [dword kref+disp],eax> sto to dataspace - {TO}
%assign x_drmov	0x8389
;- x_ummov  w	<mov [byte UR+disp],eax>, store uvari at byte-sized disp
%assign x_ummov	0x4589
;- x_ummov  w	<mov [UR+disp],eax>, store uvari at dword-sized disp
%assign x_ummov	0x8589
;-
;- x_rread 3b	<mov eax,[kref eax]>, fetch from kref'd memory - for {@}
%assign x_rread	0x03048b
;- x_dread 3b	<mov eax,[kref eax+disp]>, fetch from kref'd memory w. dword disp
%assign x_aread	0x03448b; 44:eax, 24:esp
;- x_dread 3b	<mov eax,[kref eax+disp]>, fetch from kref'd memory w. dword disp
%assign x_dread	0x03848b
;- x_dalea w	<lea eax,[kref disp]>
%assign x_dalea 0x838d
;-
; local mem:
;- x_lread w	<mov eax,[lref disp]>, fetch from local memory
%assign x_lread	0x868b
;- x_lstor w	<mov eax,[lref disp]>, store to local memory w. dword disp
%assign x_lstor	0x8e89
;- x_lpsto w	<add eax,[lref disp]>, add to local memory w. dword disp
%assign x_lpsto	0x8e01
;- ptr to local
;-
;- x_eaxc w	<mov eax,ecx>, prior to <spush> in {to}, {+to}
%assign x_eaxc	0xc889
;- x_lptr1 w	<mov eax,LP>
%assign x_lptr1	0xf089
;- x_lptr2 3b	<sub eax,KR; sub eax,disp>, disp follows
%assign x_lptr2	0x2dd829
;-

;-
;- "lib4th" doesn't implement traditional distinction between interpreting
;- and compiling state. It always compiles something executeable, terminated
;- by an <rts> code and then decides whether to immediately executing this
;- piece of code and removing it from compilespace, which is "interpreting",
;- or leave it in place until the surrounding structure(s) fully resolved,
;- which is "compiling". the latter state applies to any structured code, i.e.
;- "IF" .. "ENDIF" as well as ":" .. ";" sequences, equally.
;- A "structure" to this respect is any source sequence which requires more
;- than a single executeable to be compiled before it can safely be executed.
;- "compiling" simply is delaying execution of compiled code until structures
;- nesting levels fully resolved.
;- A hi-level 4th word being just one of those structures, execution of which
;- is "delayed" until invoked explicitely and which can be repeated.
;-
;- variable {state} used for two different purposes:
;-	l.s. half cell is structures nesting levels counter.
;-	m.s. half cell carries several special states flags.
;-

;-
;- {state} bit-flags and masks:
;-
;- bimed, mimed #31, 80000000
;-		immediate words not executing while in a structure
;-		set by {[COMPILE]} and, {POSTPONE} or equivalent {[_]}.
%assign bimed 31
%assign mimed 1<<bimed
;- bbrac, mbrac #30, 40000000
;-		temporarily interpreting, after {[} within a structure;
;-		interpreting, emergency only, after errors, etc.
%assign bbrac 30
%assign mbrac 1<<bbrac
; - bcomp, mcomp   #29, 20000000
; -		compile next word to be compiled at runtime
; %assign bcomp 29
; %assign mcomp 1<<bcomp
;- basciz, masciz #28, 10000000
;-		currently compiling literal string is asciz, for (z"), etc.
;-		flag instantly reset, may be set but not read by a program.
%assign basciz 28
%assign masciz 1<<basciz
;- bword,mword  #27, 08000000
;-		persistent code after wordheader compilation
%assign bword 27
%assign mword 1<<bword
;- bnnam,mnnam  #26, 04000000
;-		headerless word compilation
%assign bnnam 26
%assign mnnam 1<<bnnam
;- blocl,mlocl  #25, 02000000
;-		word has local memory def'd
%assign blocl 25
%assign mlocl 1<<blocl
;- blocr,mlocr  #24, 01000000
;-		word refers to previously initiated locals
%assign blocr 24
%assign mlocr 1<<blocr
;-

;-
;- search order storage bit-flags and masks
;-	flags stored in cell at lower address near the rsp. wid in vocabulary stack.
;-
;- bsvoc,msvoc	#31
;-	'vocabulary searched' flag, to avoiding multiply searching of wordlists.
%assign bsvoc 31	; 80000000
%assign msvoc 1<<bsvoc
;- bfpcpl,mfpcpl #30
;-	floating point numbers ('ranum') compiling/reading vocabulary (n.i.)
%assign bfpcpl 30	; 40000000
%assign mfpcpl 1<<bfpcpl
;-

;-	

;- 
;- whead.f
;- <ffa> word-sized header-field of bit-flags
;-
;-	bit#	mask	useage
;-	0	noxf	inhibit execution flag if no other bits set or, 
;-	0..3	xwfl	parameter-fields count mask (0..15)
;-	 4	vocf	word is a vocabulary, fieldcount=no. of wordheaders -?-
;-	 5	smud	word name finding disabled - re {smudge}, {unsmudge}
;-	 6	pfax	xec from pfa, pass ptr to body to ecx = W of 4th vm.
;-	 7	imed	immediately executing word - re {immediate}
;-	 8	wcas	find always letter-case dependently - re <ncas>, {lc-depend}
;-	 9	locf	double purpose: 1) local value; used while compiling, only
;-					2) 'normal' word w/ compiled in {forget:} action
;-	10	ixec	immediately execute when not in compiling state, e.g. {bye}
;-	11	inif	initalization from header-fields, @pfa is kref'd ptr to xec
;-	12	varf	type {variable} word, 2nd-ary pfa is disp to vari-space
;-	13	ncas	find always letter-case independently - re <wcas>, {lc-ignore}
;-	14	nopt	suppress backward code optimizing
;-	15	cmac	word can be compiled as inline code ("macro")
;-
;- noxf		0
;-	bit#0 set if find and execution disabled, for {novoc} words.
%assign	noxf	0x0001
;- xwfl		0..3
;-	additional parameter-fields count mask (0..15),
;-	no. of dwords (cells) after concerning word header's pfa.
;-	this field is valid only if at least one other flag set, otherwise 
;-	a word w. bits 0..3 set will be seen as "smudged", i.e. not found.
%assign	xwfl	0x000f
;- vocf		4
;-	word is vocabulary, fieldcount is no. of wordheaders
%assign	vocf	0x0010
;- smud		5
;-	word finding disabled, un-set by {unsmudge}, toggled by {smudge}
%assign	bsmud	5
%assign	smud	1<<bsmud
;- pfax		6
;-	execute from pfa in header, pass ptr to body in ecx
%assign pfax	0x0040
;- imed		7
;-	immediately executing, set by {immediate}
%assign imed	0x0080
;- wcas		8
;-	word will always be found letter-case dependently
%assign wcas	0x0100
;- locf		9
;-	word is local value
%assign locf	0x0200
;- ixec		10
;-	do not compiled execute when in interpreting state;
;-	provision for the emergency case - e.g. {bye}, {cold}.
%assign ixec	0x0400
;- inif		11
;-	word which requires initialization from header data
;-	@pfa is ptr to init. code wrt beginning of module
%assign inif	0x0800
;- varf		12
;-	2nd-ary pfa holds disp to beginning of variables dataspace
%assign varf	0x1000
;- ncas		13
;-	word will always be found letter-case independently
%assign ncas	0x2000
;- nopt		14
;-	suppress backward code optimizing
%assign nopt	0x4000
;- cmac		15
;-	compile-macro, bitmask to compiling inline code
%assign	cmac	0x8000
;-
;-	
;- accumulated:
;-	combined flags, internally used.
;-
;- ihead	= imed|nopt
%assign ihed	imed|nopt
;- locvf	= nopt|locf|pfax|imed|varf|2
;-	local value combined header-flags
%assign locvf	nopt|locf|pfax|imed|varf|2
;- kvalf	= pfax|varf|2
;-	kernel value header-flags - (notwendige, nicht hinreichende bed.)
%assign kvalf	pfax|varf|2
;-

;-	

;- 
;- 4th words, initial pointers & defns
;-	to setting up linkable dynamically loadable wordlists.
;-
;- vocnfa, rgvnfa	cons: (1,blank space,0,0)
;-	unique(!), dummy vocabulary name, data/register values
%define vocnfa 1,' ',0,0
%define rgvnfa 0x02001
;- vocrfa, rgvrfa	cons: (2,0,0,0)
;-	dummy vocabulary RAM linkage name, data/register values
%define vocrfa 2,0,0,0
%define rgvrfa 2
;- modnfa, rgmnfa	cons: (0,0,0,0)
;-	module base header dummy name
%define modnfa 0,0,0,0
%define rgmnfa 0
;-
;- v0.0.50: lastroot, prevlink, lkindex def'd in "lib4words.inc"
;-
;- lastroot
;-	required initial link, base ref of voc-link
;-	running asm-vari re previous linkaddress
;- prevlink, re <uv.voclink>
;-	initial vocabulary link <Vz> in library .text segment,
;-	running asm-vari re previous linkaddress.
;- lkindex, re <uv.lindex>
;-	per word 16bit unsigned index into user offset table
;- ixalias
;-	synonymous words count, initial value := 0
%assign ixalias 0
;- variptr
;-	index into vari space (alterable memory), dft = 0.
;-	final value at <tophead> for initial @dp.
%assign variptr	0	; fehler: mu in <lib4words.inc> erneut initiiert werden -!-
%assign minptr 0x7fffffff


;-	
;-
;-================================================================;
;-  Forth system memory
;-

;-
;-  :preliminary: per task memory
;-  ranges adjusted to page-size!
;-
;-  adr: [ hi ...                                          ... lo address range ]
;-  .ss  [ r0 ret-stack 64K <-|-> data-stack 64K s0 ][ tib 4K ][ uvari 64K+ ... ]
;-       [-  -                     -  (libraries) -                        -   -]
;-       [-    system heap - extends .bss by sy_brk, managed by lib4th code    -]
;-  .bss [- ...  64k+ data-space  ... d0 -] [- ...  64(128?)K codespace ... c0 -]
;-  .text[- calling application programm -]
;-
;-
;-  workspace
;-	d_npad			4-aligned(!) disp from {here} to {pad}, 4K, min. 256 bytes
%assign d_npad PAGE_SIZE
;-	d_mintib		min. local t.i.b. for nested {included}s, 256 bytes
%assign d_mintib 256
;-	pthfsize		{place}, {+place}, {path+file} string storage limit
;-				dft %xdefine-d to max(PATH_MAX,PAGE_SIZE)
pthfsize: max PATH_MAX,PAGE_SIZE
;-
;-  allocation blocks
;-  cdtmem
;-	cdt_num*cdt_size + cdt_size(for kbd channel), extends data-space
;%assign cdtmem cdt_num*cdt_size+cdt_size
%assign cdtmem (cdt_num+1)*(4<<cdt_bsize)
;-  bbufmem
;-	memory space for blockfile buffers (b_bufbuffers), extends dat-space
%assign bbufmem (b_buf*bbuffers+PAGE_SIZE-1)&PAGE_MASK
;-	d_dictionary		128K compilespace, w. {pad},{hld},{here}
;%assign d_dictionary pg(64)
%assign d_dictionary pg(128);;(16);;pg(128)
;-	d_dcmin			max(1K,PAGE_SIZE) compilespace minimum
%assign d_dcmin pg(1)
;-	d_dstack, dsmin		64K data stack, min 64K
%assign d_dstack pg(128);:bh:
%assign d_dsmin	pg(64)
;-	d_rstack,d_rsmin	64K returnstack & locals, min max(4K,PAGE_SIZE)
%assign d_rstack pg(128);:bh:
%assign d_rsmin	pg(1)
;-	d_uarea,d_uamin		64K user variables/data, min max(4K,PAGE_SIZE)
%assign d_uarea	pg(64)
%assign d_uamin	pg(1)
;-	d_varispace,d_vsmin	64K per task dataspace, min max(4K,PAGE_SIZE)
%assign d_varispace pg(128);:bh:
%assign d_vsmin pg(1)
;-	d_ntib			max(4K,PAGE_SIZE) terminal input buffer
%assign d_ntib pg(PAGE_SIZE/1024)
;-	d_safecode		safety margin towards top of code-space max(1K,PAGE_SIZE)
%assign d_safecode pg(1)
;-
;-  .bss section:
; -	d_taskmem	    	std. per task .bss memory size
; -				dictionary+dstack+uarea+ntib = 196K
;%assign d_taskmem (d_dictionary+d_dstack+d_uarea+d_ntib)
;-	d_bssmem		std. per task .bss memory size
;-				dataspace(64)+codespace(128) = 192K
;%assign d_taskmem (d_varispace+d_dictionary)
%assign d_bssmem (d_varispace+d_dictionary+cdtmem+bbufmem); <allocjob>
;-
;- .ss section:
;-	d_ssmem			std. per task .ss memory size
;-				rstack(64)+dstack(64)+ntib(4)+uarea(64) = 196K
%assign d_ssmem (d_rstack+d_dstack+d_ntib+d_uarea)
;-
;- sigle words executing job
;-	d_jobstk		minimal single words executing .ss setup, just stacks = 2K
;-				plus <d_jobbss> for number conversion, etc = 2K, sa. 4K
;-	d_jobss, d_jobbss	minimal compiling jobs memory setup
;-				dcmin(1)+dsmin(64)+uamin(1)+ntib(4)+vsmin(1)+rsmin(1) = 68K
%assign d_jobstk (d_rsmin+d_dsmin)
%assign d_jobss	 (d_jobstk+d_uamin+d_ntib)
%assign d_jobbss (d_dcmin+d_vsmin)
;-

;-	

;-	
;-================================================================;
;- asm cons:
;-

;-

;-
;- s_sqr2n2, s_sqr2n3, s_sqr2n10, s_sqr12n2, s_pi, s_e, s_e3by16k, s_c      
;- scaling constants (val := arg * 1st_cons / 2nd_cons)
;- (re r.zech, forth 83, pg 43)
;		approximation 	;value		error	constant
%define s_sqr2n2  dd 19601,13860;1.414...	1,5e-9	2^(1/2)
%define s_sqr2n3  dd 18817,10864;1,732...	1,1e-9	3^(1/2)
%define s_sqr2n10 dd 22936,7253	;3,162...	5,7e-9	10^(1/2)
%define s_sqr12n2 dd 26797,25293;1,059...	1,0e-9	2^(1/12)
%define s_pi	  dd 355,113	;3,141...	8,5e-8	pi
%define s_e       dd 28667,10546;2,718...	5,5e-9	e
%define s_e3by16k dd 846,19997	;0,042...	1,2e-8	1000/16384*ln(2)
%define s_c       dd 24559,8192	;2,997...	1,6e-9	c

;-
;- preset <uvp>:=0,<uvi>:=-4,<uvs>:=-1 for macro <uv>
%assign uvp 0;null
%assign uvi (-4)	; -ve bytes per item
%assign uvs (-1)	; -ve cells per item
%assign uvutop 0	; for byte addressable item
;-
;- uv, macro 1
;-	setting up the user vari names and cell size disp's
;-	%define uv_%{1} as shortest [<ea>] ptr
%macro uv 1;.nolist
uv.%{1} equ uvp
%assign uvp uvp+uvi
%endmacro
;-
;- :preliminary: user vari setup
;-
;- uv.utop
;-	beginning of pre-defined user area = top of user task memory, growing down
;- names the 2nd part of which does NOT begin wit "u" are byte addressable, i.e.
;-	those of pattern {uv.u...} are not byte addressable (single exception: uv.u0)!
;-	stored memory references are all relative to kernel ref reg <kref> with a few
;-	exceptions w. pointers which are used internally, only.
;-	the "uot" stores true ptrs to the rsp. words' execution entry.
;-	re "lib4th.asm" and "constants.inc" about usage and default settings.
;-
; pushad -> tos{di si bp sp bx dx cx ax} - popa(d) ignores (e)sp
; (top) --------------- ; --- 		task register storage 		    --- ; (-himem-)
;- do not use utop...uedi for an application! reserved for inner task scheduler ;
%assign uvp uvp+(uvi)
uv utop:	; -/-
uv ueax:	;(eax)
uv uecx:	;(ecx)
uv uedx:	;(edx)
uv uebx:	;(ebx)	.kref	ref into kernel memory (ROM)
uv uesp:	;(esp)	.rp	returnstack ptr
uv uebp:	;(ebp)	.uref	old ref into user vari
uv uesi:	;(esi)	.ip	instruction ptr
uv uedi:	;(edi)	.sp	datastack ptr
; --------------------- + ----------------------------------------------------- ; (^- + -^)
; variname	size	; default		use				;
;00; -- #31 uv.aux first byte-addressable user vari, at +ve disp to uv.link --- ;
uv aux:		; input flags:
%assign uvutop uv.aux; 1st byte addressable item for <uvuv>
;			;skey:	l.s.b	-1:single keystroke console mode, 1:file
;			;cflg:		character received flag
;			;crgt:		charcter reget flag
;			;klok:	m.s.b.	kernel to input-job lock
; ---------------------	+ -- standard address in user-vari area is rel(kref) -- ;
;		;X; uvari not required for free running words (jobs/clones)
uv s0:		;s0		datastack, bottom up
uv lp:		;lp		local space running ptr
uv r0:		;r0		initial returnstackptr
uv up:		;up		uservari ptr, -ve top down, after last used item
; - compiler/interpreter
uv d0:		;d0		vari data-space, .ss bottom
uv dp:		;dp		vari data-space, running ptr to {here}
uv c0:		;c0		base address of user's codespace
uv cp:		;cp	   <hpts> running ptr into codespace
uv bcp:		;	X; <hpts> backup while cinterpreting
uv head:	;(head)	X; <hpts>
uv tail:	;(tail)	X; <hpts>
uv btail:	;	X; <hpts>
uv state:	;state		compile/interpret state levels count & flags
; -
uv tib:		;(tib)		terminal input buffer (t.i.b.)
uv span:	;span		len of latest parsed word
uv blk:		;blk
uv in:		;in, >in	running ptr into current parse buffer
uv in0:		;-/-		received string len in/of current parse buffer
uv bits:	;(bits)	;auxilary flagbits:
;			;caps:	   0	case dependent name search
;			;cons:	   1	input is console
;			;	...
;			; m.s.bit 31
; memory management, 4th
uv fence:	;fence		ptr to top of non-alterable words data-space
uv cfence:	;c-fence	ptr to top of non-alterable words code-space
uv ifence:	;i-fence	top index to 1st after write protected words
; memory management, common heap
uv sstop:	;(sstop)	true top (lowest addr) of .ss section
uv mbot:	;(bot)		base job:  true address of bottom of user task memory
;		;		task/clone:top of local memory.
uv mtop:	;(top)		base job:  true address of global RAM/.bss top
;		;		task/clone:top of local memory.
uv fheap:	; f-heap	free heap linklist, ends at 1st free address in .bss
uv aheap:	; a-heap	heap memory linked list base-ptr
uv dtop:	; d-top		top of dataspace
uv ntop:	; n-top		counted int to stg conversion memtop, base of block-buffers
%assign b uvp
uv ctop:	;c-top		compile-top in .bss, or zero
%assign k uvp
%assign h uvp
%assign uvp uvp+(31*uvi-(b-uvutop)-uvi)
%assign k k-(uvp)
%if k<>0
%if (k/4)>0
%assign k k/4
%error ":0: uvp<-diff->k : #k items free before uv.link"
%else
%error ">0< uvp<-diff->k : bytes index overflow at uv.link"
;constants.inc:934: warning: by user: >0< -164<-diff->-4 : bytes index overflow at uv.link
%endif
%endif
;  (+)`--<-- #00 uv.link user vari reference -->--.(-)
uv link:	;(ulink);ebp	32<==	user vari & task reference, circular linklist to next uarea/.ss ref
;  (+)`--<-- #00 uv.link user vari reference -->--.(-)
uv lkindex:	;(lkindex)	running ptr to word execution address indices (preserved in tasks!)
uv sigh:	;(sigh)		base of signal handler defn blocks - ref'd to by {max-xy}, etc.
uv nout:	;out		count of output chars (per line)
uv rows:	;rows		count of output lines
uv base:	;base		radix for number conversion
uv fld:		;fld		general purpose when executing compiled words, also used by {see}, {#see}
uv dpl:		;dpl		decimal 'point' location (;-?
uv hld:		;hld		ptr to current posn in number to string conversion buffer
uv hld0:	;hld0		saved base (top) address of number conversion buf
; local data-space (re below, "ulocn")
uv locb:	;(locb)		globally reserved space bytes count
uv locn:	;(locn)		cpl: no. of local bytes in current defn
; i/o
uv padsz:	;(padsz)	pad & pad2 size, default <d_npad>, PAGE_SIZE (4K) bytes
uv ierr:	;(ierr)		latest input ernum
uv sourceid:	;(source-id)	coded input source: 0:terminal -1:evaluate else:file, val=ptr to input chp
uv iolink:	;(iolink)	ptr to latest stack frame for stdin redirection
uv chans:	;(chans)	ptr to i/o redirection table datafield
uv inchp:	;(inchp)	latest used input-channel's chp ptr, set by {?terminal}, {iomode}
uv outchp:	;(outchp)	latest used output-channel's chp ptr, set by {type}, {emit}, {iomode}
; cc4th
uv icc4th:	;ICC4TH		kref(ptr) to jumptable of input ctrl actions, else zero
uv occ4th:	;OCC4TH		kref(ptr) to jumptable of output ctrl actions, else zero
; vocabularies
uv voclink:	;VOC-LINK	vocabulary link pointer
uv last:	;LAST		last defined word in system
;;; -- in {current} wird :definiert: -- ;;;
uv current:	;CURRENT	pointer, DEFINITIONS move to OCURRENT
%assign uvp uvp+(uvi)
uv ocurrent:	;OCURRENT	previous current, PREVDEF restores last CURRENT
%assign uvp uvp+(uvi)
;- vocabulary stack builds top down: ------------------------------------------ ; (v- - -v)
uv context:	;CONTEXT	pointer, ALSO & ":" move to OCONTEXT
%assign uvp uvp+(uvi)
uv ocontext:	;OCONTEXT	previous context, ALSO moves into V-stack
%assign uvp uvp+(uvi)
;    -- #-32 is last byte-addressable user vari (with nvocs = 16) --
uv vocs:	;		top of voc-stack, PULLed/PUSHed by PREVIOUS/ALSO (:platzhalter:!)
%assign uvubot uvp; last byte addressable item
%assign uvbot uvp
; --------------------- + ----------------------------------------------------- ; (^- + -^)
%assign uvp uvp+(d_nvocs*2*uvi);	vocstack, pushed by {also} to lower addresses,
;- vocabulary stack growing 'down', extending into non-byte-addressable space
;- each item is double cell, voc-link ptr and searchflags cell, used in {find}
; --------------------- ; ----------------------------------------------------- ; (^- + -^)
uv utattr:		;	ptr to program's terminal settings
uv ustattr:		;	ptr to initial terminal settings
;vmode yet un-used
uv uvpalette:		; (vpal) initial console palette
; - alterable cons.    -+ ----------------------------------------------------- ; (^- + -^)
;		;X; uvari required for free running words (jobs/clones)
uv ucan:	;(can)	X;	lo-w:d_can exit code, hi-w:no. of sequential chars=d_can
uv udplm:	;(dpl)	X;	up to 4 numeric fraction marker chars
uv ueof:	;(eof)	X;	console eof character, for <setty>
uv ueol:	;(eol)	X; CR	<nl> char(s), the <eol> code
uv untab:	;(#tab)	X;	<tab> spacing
uv utibmax:	;(tib-max) X;   size of t.i.b
uv upchr:	;(pchr)	X;[32,126] & [128,255] ranges of printing chars
uv uescc:	;(escc) X;	escape symbol (char) for {etype}
uv uprp:	;(r)	X;	fill character for u.r etc.
; -  system variables  -+- non-standard vector table - all true addresses
uv uargn:	;(argn)	X;\	arguments counter
uv uargc:	;(argc)	X; )argc program arguments count
uv uargp:	;(argp)	X;/	ptr to current argument
uv ubootp:	;(bootp) X;	boot data ptr, passed from calling executeable, for supplied prg/data
uv upath:	;(path)	;	ptr to {path} string
uv ucmc:	;(cmc)		compiled words count
uv ucsp:	;csp		current stack ptr while compiling
uv ufsp:	;(fsp)		floating pt co-proc stack-ptr, provisional, L4 doesn't implent fp-ops
uv uhi2lo:	;(hi>lo)	i/o chars, bytewise, hi mapped into lo, 0:no translation
uv uioacc:	;(ioacc)	up to 4 accumulated input chars (for vt emu)
uv uiovtim:	;(vtim)	lo.b:	VTIME	byte values for stdin ioctl
;			;	VMAX
;			;	n.i
;			;hi.b	n.i.
uv uprevix:	;		<cplxit>,<recurse>, ix of previously compiled word
uv uprevcp:	;		<recurse>, c-here before previously compiled word
uv ulo2hi:	;(lo>hi)	i/o chars, bytewise, lo mapped into hi, 0:no translation
uv ulocvb:	;		local local values bytes counter, while compiling
uv ulocvc:	;		local local values counter, while compiling
uv ulocptr:	;		local local values count, init. runtime code
uv ufperm:	;(fperm)	new files' permissions mask
uv unr:		;#r		editor cursor posn
uv uoerr:	;(oerr)	X;	output error on write
uv upid:	;	X;	task's process id
uv urdumpm:	;	\	for {dump}/{rdump}
uv urdumpc:	;	/
uv uscr:	;scr	X;	screen no. in screefile
uv ustimo:	;(timo)		timeout for <sys_select>, {wait4..} words
uv ustimm:	;		<timo> microseconds 
uv utick:	;(tick)	X;	1s measured cpu timing
uv uwidth:	;width		max. length of a 4th name moved into header data
; - execution vectors  -+- non-standard vector table - all true addresses
;		;X all required for free running words (jobs/clones)
uv uabort:	;(abort)	:::::: 
uv uaccept:	;(accept)	:::::: executes EXPECT + count
uv ubinterpret:	;(]interpret)	:::::: error exit vector after interpreter/compiler
uv uinterpretb:	;(interpret[)	:::::: user vector after find, before any other action, in interpreter/compiler
uv ublock:	;(block)	:::::: 
uv ubuffer:	;(buffer)	:::::: 
uv ucompile:	;(compile)	:::::: redirectable interpreter/compiler, final routine
uv uecho:	;(echo)		:::::: single chars output to stderr
uv uekeyq:	;(ekey?)	:::::: basic character input, dft ?terminal via uqterminal
uv uemit:	;(emit)		:::::: (buffer required, anyway, thus implemented as: tmp c! tmp 1 type)
uv uerror:	;(error)	:::::: error handling execution
uv ueval:	;(eval)		:::::: redirectably evaluate command input
uv uinterpret:	;(interpret)	:::::: redirectable interpreter/compiler, data acquisition
uv upmbymp:	;(m/mod)	::::::
uv unumber:	;(number)	:::::: ans/fig style number conversion word, dft as set in Makefile, fig or ans
uv updebugp:	;(debug)	:::::: vector to execute before actual code compiler entry
uv upokp:	;(ok)		:::::: ptr to keyboard input prompt routine
uv uqerror:	;(?error)	:::::: conditional error handling
uv uqterminal:	;(?terminal)	:::::: vectored default for vectored {ekey?}
uv upause:	;(pause)	:::::: job switching, after select in wait4.. words
uv uquit:	;(quit)		:::::: initial execution entry, rel <kref>
uv uscanwl:	;(scanwl)	:::::: wordlists scanning 2ndary error handler
uv usmbym:	;(um/mod)	:::::: default SM/MOD variant (floored/near zero), init {sm/rem}
uv usource:	;(source)	:::::: xec vec
uv ustosp:	;(sp!)		:::::: xec vec
uv utonum:	;(>number)	:::::: convert
uv utype:	;(type)		:::::: [this is the basic operation for text output to stdout]
uv ufini:	;(fini)		final xec, before un-loading L4
uv vbot:	;end of pre-defined user area, up := disp to uv.link in uv.up
; ----------------------+ terminal input buffer --------------------------------; (^- + -^)
;			; 4K below uv.vbot				<-- ???
; --------------------- + ----------------------------------------------------- ; (^- + -^)
%assign uvp uvp+(d_ntib*uvs)
;%error "u:uvp"; -4860
%assign uvp -uvp	;(required due to broken arithmetics in nasm)
%assign uvp (uvp+PAGE_SIZE-1)&PAGE_MASK
%assign uvp -uvp
;%error "u-tibot:uvp"; -8192
uv utibot:		; bottom of t.i.b.		<-- ???
uv uintib:		; count of received chars in tib = span
; - user offset table -	+ ----  referring to true execution address entries --- ;
;			;  @uv.lkindex points to latest word ptr
%assign uvp uvs*(d_uarea-8)
uv ultab:		; (uot)		bottom of executeables pointers, all true addresses
uv.ubot:	equ uvp	; end of 64K user area		<-- ???
%assign uvp uvp+uvi
;%error "u-ubot:uvp"; -65536
; --------------------- + ----------------------------------------------------- ;(^- + -^)(lo address)

; assembly time range control
%assign uvbot -(uv.vocs-uv.link)/4		; -ve no. items after link
%if uvbot != 31					; range of byte-addressable uvari
%error ":1: uvbot : vocs-link index"
;constants.inc:1080: warning: by user: :1: 30 : vocs-link index
%endif
%assign uvvbot	(uvp-(uv.link))
%assign uvvend	(uvp-(uv.utop))			; control value =!= uarea top
%assign uvvtop	((uv.utop)-(uv.link))		; +ve byte addressable
%assign uvbot	(uvbot-(uvi)-(uv.link))		; := (uv.vocs+4-(uv.link))
%assign uvtop	(uv.aux-(uv.link))		;

%if (uv.vocs+0x80 < uv.link)			;|1 ; <= uncomment to forcing messages
;:ok:
;constants.inc:460: warning: uv.vocs not in reserved space: |uv.vocs-uv.link| = 32
;constants.inc:461: warning: user area 65536:-65536, bot:-65376, top:160, byte addressable ubot:-128, utop:124
;constants.inc:463: warning: d(link-vram):-4
    %assign uvp -(uv.vocs-uv.link)/4		; -ve no. items after link
    %error ":2: uv.vocs not in reserved space: |uv.vocs-uv.link| = uvp"
    %error ":3: 64K uarea:uvvend, bot:uvvbot, top:uvvtop, byte addressable ubot:uvbot, utop:uvtop"
    %assign uvp (uv.link-(h))
    %error ":4: d(link-vram):uvp"
%endif
%if (uv.chans >= uv.link)|(uv.link >= uv.fheap)	;|1 ; <= uncomment to forcing messages
;:ok:
;constants.inc:474: warning: uv.link in reserved space: (uv.chans[-56>-40>-39]uv.heaplk)
;constants.inc:475: warning: user area bot:-65376, top:160, byte addressable ubot:-128 , utop:124
    %assign uvp uv.chans/4
    %assign uvi h/4
    %assign uvl uv.link/4
    %error ":5: uv.link in reserved space: (uv.chans[uvp>uvl>uvi]h)"
    %error ":6: user area bot:uvvbot, top:uvvtop, byte addressable ubot:uvbot , utop:uvtop"
%endif
;-	

; memory map (preliminary, re glossary for actual mapping)
; %define-d ptrs to corresponding user vari re "lib4th.mac"

;:: :aendern: -?-
;:: dynamic exdendability of code, data areae, stacks, probably even uot and tib:
; => [ .txt ][ code ][ data ][ dstack |=> ... <=| rstack ][ tib ][ uot ]
; ++                ][ data ][ data+ ][ dstack... (by >loc and s0 := lp)
; ++        ][ code ][ data ][ code+ ][ dstack... (by >loc and cp := lp, lp := s0 )
; => requred mod would be dstack, from .ss to .bss, and allocate/free/resize
; actual set-up such, that 
;	data-memory can extend upon demand, into .bss, implicitely done in {allot}.
;	code-memory extendable after data-space relocation (may be a future project?)
;	data- and return-stacks extendable after relocation of UP and @s0.

;= .ss ==========================================================
; RAM, task specific returnstack(s) & variables space, 128K+ ea,
;	per task extends down to lower address space:
; .ss	----		initial stack, env vari and args
;	----		@r0	kernel return-stack bot, page-aligned
;	 ..	RS		 64K+, top down
;	 ..	
;	 ..	PS	sp@	 64K+, bottom up
;	(..)		@s0	bot. of data-stack
;	----	LS	..	locals 'below' data-stack, bottom up;
;			(@s0)	data-stack relocated w/ locals allocation.
; 	====	<top>	=utop	top of user variables,
;	 ..			64K reserved user-vari area, top down
;	 ..			beginning with task register storage,
;	 ..	UP		uv.link	next 64 user-vari are byte-addressble
;	 ..			ref into user-vari area by [ebp-uv.link+disp]
;	 ..			uvari extend towards lower addr.
;	----		bottom of user vari area
;	[  ]			terminal input buffer, <ntib> bytes (4K)
;	----	tib	@utib
;	 ..
;	----	0 up+	=ultab	user exec address table base, bot. up
;				max. available indices: { tib 4+ 0 idx>uot - }
;				bottom of 64K fixed size user area.
;	---------------------------------------------------------
;	 ..next task..		blockwise growing top down
;	 ..
;= .bss =========================================================
; RAM, multiple independent groups may exist, 196K ea,
;	per task extends up to higher address space,
;	top task can extend (up) own memory area:
;	 ..
;	 ..next task..		blockwise growing bottom up
;
; .bss	----	uv.utop	top of task memory
; 			@mtop	top of actually allocated .bss section
; datatop		@dtop	kref-d @mtop
;top of dataspace
;	 ..
; dataptr		@dp	64K, extendable into .bss, bottom up
;	 ..
;	bbuf			block buffers (allocated on demand)
;	 ..
; databot		@d0	dataspace
; codetop		@ctop	end of code-space
;	 ..
; codeptr		@cp	bottom up, 64K
;	 ..
; codebot		@c0	dictionary
;	 ..
;	 ..	edi		datastack running ptr
;	----		@uv.s0	datastack, bottom up, 64K
;----------------------------------------------------------------
;= .text ========================================================
; ROM/library, kernel code in non-alterable memory:
; .text ---
;	 ..
;	 ..		ref into kernel via ebx-Y+disp = @uv.kref
;	 ..		for kernel words, constants, wordheaders.
;	----	<Y>	kref, beginning of library code
;================================================================
;
%endif;__CONSTANTS_INC
;-
;- (*) mode-7: 'safety fast'
;-================================================================
;- constants.inc <eof>
