;-================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-
;-  file  	: l4-debug.inc
;-  switch	: __L4DEBUG_INC
;-  created	: 15-jan-00
;-  modified	: 20-jan-01
;-  version	; 0.18
;-  assembler	: nasm 0.98-3e
;-  description	: lib4th specific debugging macros
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  requires	: lib4th package
;-================================================================;
;-
;-

%ifndef __L4DEBUG_INC
%define __L4DEBUG_INC
%define l4debuginc

%ifndef debuginc
%include "debug.inc"
%define debuginc
%endif

;-
;- [label]:L4PN 3
;-	substitutes PRNUM w. all unitiated lib4th routines, to STDERR
;-	%1: 32bit-reg by name, or "eflags"
;-	%2: display unsigned 32-bit-value if not one of:
;-	    's'igned, 'm'inus/'p'lus kref, l.s. 'w' 16bit-, 'b'8bit
;-	%3: max 4 chars text
%macro L4PN 3_nolist;[list]
%ifid %00
%00:
%endif
    pushfd
    pushad
    call getrefb
%ifnidni %{1},eax
 %ifidni %{1},eflags
     readad eax,tos
 %else
    mov eax,%{1}
 %endif
%endif
%ifnidni %{3},ecx
    mov ecx,%{3}
%endif
%ifidni %{2},m
    sub eax,KR
%elifidni %{2},p
    lea eax,[kref eax]
%endif
%ifidni %{2},s
    call ersmsg
%elifidni %{2},w
    movzx eax,ax
    call ersmsg
%elifidni %{2},b
    movzx eax,al
    call ersmsg
%else
    call erumsg
%endif
    popad
    popfd
%endm;[nolist]
;-
;- [label]:L4PS 0-1
;-	substitutes PRSTG w. all unitiated lib4th routines, to STDERR
;-	%1: max 4 chars text, default <nl>
%macro L4PS 0-1_nolist AC_NL
%ifid %00
%00:
%endif
    pushfd
    pushad
%ifstr %{1}
    mov ecx,%{1}
%elifidn %{1},ecx
    lea ecx,[%{1}]
%endif
    call erustg
    popad
    popfd
%endm
;-
;- [label:]L4DP 1-3
;-	dump 12 cells at <ea> %1(edx),
;-	w. optional count %2(dft=16), %3:(a)bs/(r)el, dft=a
;-	regs & flags preserved
%macro L4DP 0-4_nolist AC_NL,16,a
%ifid %00
%00:
%endif
    pushfd
    pushad
    mov ecx,AC_NL
    call erustg
%ifidni %{1},esp
    lea esi,[byte esp s_tor+4]
%else
    AMODE %{1}
    %if REG=1
    mov esi,[byte esp s_%{1}]
    %else
    lea esi,%{1}; mem
    %endif
%endif
    mov eax,esi
    call erudot
    readad ecx,ecx
    readad eax,eax
    AMODE %{2}
%if REG=1
    mov ecx,[byte esp s_%{2}]
%else
    mov ecx,%{2}
%endif
    push ecx	; count
%%l:
    test byte[esp],7
    jnz %%n
    mov ecx,AC_NL
    call erustg
%%n:
    lodsd
%ifidni %{3},r
    sub eax,KR
%endif
    mov ecx,' '
    call erumsg
    dec dword[esp]
    jg %%l
    lea esp,[esp+4]
    mov ecx,AC_NL
    call erustg
    popad
    popfd
%endm
;[nolist]
;-
;- mdumptail on/off, macro for "lib4th":
;-
;- <dumptail>	( -- )				(4)		'dumptail'
;-	debugging utility, assembly level only.
;-	dump code ptrs, data-stack and used area @{c0} till {c-here}.
;-	all regs and eflags preserved.
;-	in-active if switch <__tosi> not %define-d.
%macro mdumptail 0-1,on
dumptail:A;:test:
%ifidni %{1},on
    pushfd
    pushad
    call pdotqtep
    db 0,10,'caller',0
    spush
    mov eax,[esp tos+4]
    sub eax,KR
    call hexdot
    call pdotqtep
    db 0,10,'c0:',0
    call c0
    mov eax,[kref eax]
    call torr
    call hexdot
    call pdotqtep
    db 0,' tail:',0
    spush
    mov eax,[byte uref uv.tail]
    call hexdot
    call pdotqtep
    db 0,' head:',0
    spush
    mov eax,[byte uref uv.head]
    call hexdot
    call pdotqtep
    db 0,' state:',0
    call statef
    call hexdot
    call pdotqtep
    db 0,' eflags:',0
    spush
    readad eax,tos
    movzx eax,ax
    call bindot
    call pdotqtep
    db 0,10,'cp:',0
    call chere
    call torr
    call hexdot
    call pdotqtep
    db 0,'btail:',0
    spush
    mov eax,[byte uref uv.btail]
    call hexdot
    call pdotqtep
    db 0,'bcp:',0
    spush
    mov eax,[byte uref uv.bcp]
    call hexdot
    call dots	; .s
    call tworfrom; 2r>
    call swap
    movzx eax,ax
    sub ax,[byte uref uv.c0]
    add ax,byte 9
    or al,9
    call dump	; (tail) @ 8 dump
    popad
    popfd
%endif
    ret
%endm
;
%endif	;__DEBUG_INC
;-
;-
;-================================================================
;- l4-debug.inc <eof>
