;-================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file	: fcntl.inc
;-  switch	: _I386_FCNTL_H
;-  created	: 17-jan-2000
;-  modified	: 17-jan-2000
;-  version	: 0.01
;-  assembler	: nasm 0.98
;-  description	: fcntl op's
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	:
;-  source	: linux 2.2.14, include/asm-i386/fcntl.h
;-  requires	: types.inc from "asmutils" by K.Boldyshev,
;-			http://lightning.voshod.com:/asm
;-================================================================;
;-


%ifndef _I386_FCNTL_H
%define _I386_FCNTL_H
%define fcntlinc

;%include "types.inc"

;-
;- O_...
;- 	open/fcntl
%define O_ACCMODE	   0003q
%define O_RDONLY	     00q
%define O_WRONLY	     01q
%define O_RDWR		     02q
%define O_CREAT		   0100q	; not fcntl
%define O_EXCL		   0200q	; not fcntl
%define O_NOCTTY	   0400q	; not fcntl
%define O_TRUNC		  01000q	; not fcntl
%define O_APPEND	  02000q
%define O_NONBLOCK	  04000q
%define O_NDELAY	O_NONBLOCK
%define O_SYNC		 010000q	; only on block devs & files on ext2 fs
%define FASYNC		 020000q	; fcntl, for BSD compatibility
%define O_DIRECT	 040000q	; direct disk access hint - currently ignored
%define O_LARGEFILE	0100000q
%define O_DIRECTORY	0200000q	; must be a directory
%define O_NOFOLLOW	0400000q	; don't follow links
;-
;- F_...
;-	(f_)flags, fcntl cmd
%define F_DUPFD		0		; dup
%define F_GETFD		1		; get f_flags
%define F_SETFD		2		; set f_flags
%define F_GETFL		3		; more flags (cloexec)
%define F_SETFL		4		;
%define F_GETLK		5		;
%define F_SETLK		6		;
%define F_SETLKW	7		;
;-
;- F_...
;-	sockets
%define F_SETOWN	8
%define F_GETOWN	9
%define F_SETSIG	10
%define F_GETSIG	11
;-
;- FD_CLOEXEC
;- 	F_[GET|SET]FL
%define FD_CLOEXEC	1		; actually anything with low bit set goes
;-
;- F_..LCK - at <flock.l_type>
;-	posix fcntl() and lockf()
%define F_RDLCK		0
%define F_WRLCK		1
%define F_UNLCK		2

;-	old bsd flock ()
%define F_EXLCK		4		; or 3
%define F_SHLCK		8		; or 4

;-	ops for bsd flock(), also kernel - at <flock.l_whence>
%define LOCK_SH		1		; shared lock
%define LOCK_EX		2		; exclusive lock
%define LOCK_NB		4		; or'd with one of the above to prevent blocking
%define LOCK_UN		8		; remove lock

;-
;- flock
;-	structure for bsd flock()
    struc flock
.l_type		SHORT	1
.l_whence	SHORT	1
.l_start 	LONG	1	; off_t
.l_len		LONG	1	; off_t
.l_pid		SHORT	1	; pid_t
    endstruc

%endif ;_I386_FCNTL_H
;-
;-================================================================;
;- fcntl.inc <eof>
