;-================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read LICENSE file for full copyright information (GNU GPL)
;-
;-  file	: ioctls.inc
;-  switch	: __ARCH_I386_IOCTLS_H__
;-  created	: 17-jan-2000
;-  modified	: 25-feb-2000
;-  version	: 0.01
;-  assembler	: nasm 0.98
;-  description	: tty ioctl-s magic numbers - not reliable!
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	: i386 related data are barely documented,
;-  source	: linux 2.2.14, include/asm-i386/ioctls.h, 
;-		: 	2.2.19,	drivers/block/tty_io.c
;-  requires	: -/-
;-================================================================;
;-

%ifndef __ARCH_I386_IOCTLS_H__
%define __ARCH_I386_IOCTLS_H__
%define ioctlshinc
%include "ioctl_h.inc"

; (m) comments from asm/mips
; 0x54 is ascii 'T'
%define TCGETS		0x5401	; get tty data into <termios> structure
%define TCSETS		0x5402	; set tyy from <termios> struc. == SNDCTRL_xx !
%define TCSETSW		0x5403	; change when pending output is written (m)
%define TCSETSF		0x5404	; flush pending input before changing (m)
%define TCGETA		0x5405	; set selection, lookup table (man 4 console_ioctls, wirres zeug...)
%define TCSETA		0x5406	; set a char to value of kvari 'shift state'
%define TCSETAW		0x5407	; set a char to value of kvari 'report mouse'
%define TCSETAF		0x5408	; dump full screen, w/ attrib
%define TCSBRK		0x5409	; rst screen & attr
%define TCXONC		0x540A	; monitor powersaving
%define TCFLSH		0x540B	; 
%define TIOCEXCL	0x540C	; set exclusive use of tty
%define TIOCNXCL	0x540D	; reset exclusive use of tty
%define TIOCSCTTY	0x540E	; become controlling tty
%define TIOCGPGRP	0x540F	; get pgrp of tty
%define TIOCSPGRP	0x5410	; set pgrp of tty
%define TIOCOUTQ	0x5411	; output queue size       - lx 2.4.16: set kmsg redirect -?-
%define TIOCSTI		0x5412	; simulate terminal input - lx 2.4.16: set new & get old fg console
%define TIOCGWINSZ	0x5413	; get window size (tty_io.c)
%define TIOCSWINSZ	0x5414	; set window size (tty_io.c)
%define TIOCMGET	0x5415	; get all modem bits
%define TIOCMBIS	0x5416	; bis modem bits
%define TIOCMBIC	0x5417	; bic modem bits
%define TIOCMSET	0x5418	; set all modem bits
%define TIOCGSOFTCAR	0x5419
%define TIOCSSOFTCAR	0x541A
%define FIONREAD	0x541B
%define TIOCINQ		FIONREAD; 541b
%define TIOCLINUX	0x541C
%define TIOCCONS	0x541D	; become virtual console
%define TIOCGSERIAL	0x541E
%define TIOCSSERIAL	0x541F
%define TIOCPKT		0x5420	; pty: set/clear packet mode
%define FIONBIO		0x5421
%define TIOCNOTTY	0x5422	; void tty association
%define TIOCSETD	0x5423	; set line discipline
%define TIOCGETD	0x5424	; get line discipline
%define TCSBRKP		0x5425	; Needed for POSIX tcsendbreak()
%define TIOCTTYGSTRUCT	0x5426  ; For debugging only
%define TIOCSBRK	0x5427  ; BSD compatibility
%define TIOCCBRK	0x5428  ; BSD compatibility
%define TIOCGSID	0x5429  ; Return the session ID of FD (also for pty devices)

; %define TIOSWINSZ	.(m).	; set window size	(m)
; %define TIOGWINSZ	.(m).	; get window size	(m)

%define TIOCGPTN	_IOR('T',0x30,4)	; Get Pty Number (of pty-mux device)
%define TIOCSPTLCK	_IOW('T',0x31,4)	; Lock/unlock Pty

%define FIONCLEX	0x5450  ; these numbers need to be adjusted.
%define FIOCLEX		0x5451
%define FIOASYNC	0x5452
%define TIOCSERCONFIG	0x5453
%define TIOCSERGWILD	0x5454
%define TIOCSERSWILD	0x5455
%define TIOCGLCKTRMIOS	0x5456
%define TIOCSLCKTRMIOS	0x5457
%define TIOCSERGSTRUCT	0x5458	; For debugging only
%define TIOCSERGETLSR   0x5459	; Get line status register
%define TIOCSERGETMULTI 0x545A	; Get multiport config
%define TIOCSERSETMULTI 0x545B	; Set multiport config

%define TIOCMIWAIT	0x545C	; wait for a change on serial input line(s)
%define TIOCGICOUNT	0x545D	; read serial port inline interrupt counts
%define TIOCGHAYESESP   0x545E  ; Get Hayes ESP configuration
%define TIOCSHAYESESP   0x545F  ; Set Hayes ESP configuration

; Used for packet mode
%define TIOCPKT_DATA		 0	; data packet
%define TIOCPKT_FLUSHREAD	 1	; flush packet
%define TIOCPKT_FLUSHWRITE	 2	; flush packet
%define TIOCPKT_STOP		 4	; stop output
%define TIOCPKT_START		 8	; start output
%define TIOCPKT_NOSTOP		16	; no more ^S, ^Q
%define TIOCPKT_DOSTOP		32	; now do ^S ^Q
; %define	TIOCPKT_IOCTL	0x40	; state change of pty driver

%define TIOCSER_TEMT    0x01	; Transmitter physically empty

%endif ;__ARCH_I386_IOCTLS_H__
;-
;-================================================================;
;- ioctls.inc <eof>
