;-=========================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file  	: kd_h.inc
;-  switch	: _LINUX_KD_H
;-  created	: 25-feb-2002
;-  version	: 0.01
;-  assembler	: nasm 0.98-3e
;-  description	: 
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	:
;-  source	: linux/include/linux/kd.h
;-  requires	: "asmutils" by K.Boldyshev, http://linuxassembly.org
;-=========================================================================;
;-
;-

%ifndef _LINUX_KD_H
%define _LINUX_KD_H
%define kdhinc
%ifndef systeminc
%define systeminc
%include "system.inc"
%endif

; 0x4B is 'K', to avoid collision with termios and vt
; sys_ioctl fd, request,

%define GIO_FONT	0x4B60		; gets font in expanded form
%define PIO_FONT	0x4B61		; use font in expanded form

%define GIO_FONTX	0x4B6B		; get font using struct consolefontdesc
%define PIO_FONTX	0x4B6C		; set font using struct consolefontdesc


%define PIO_FONTRESET   0x4B6D		; reset to default font

%define GIO_CMAP	0x4B70		; gets colour palette on VGA+
%define PIO_CMAP	0x4B71		; sets colour palette on VGA+

%define KIOCSOUND	0x4B2F		; start sound generation (0 for off)
%define KDMKTONE	0x4B30		; generate tone

%define KDGETLED	0x4B31		; return current led state
%define KDSETLED	0x4B32		; set led state [lights, not flags]
%define 	LED_SCR		0x01	; scroll lock led
%define 	LED_CAP		0x04	; caps lock led
%define 	LED_NUM		0x02	; num lock led

%define KDGKBTYPE	0x4B33		; get keyboard type
%define 	KB_84		0x01
%define 	KB_101		0x02 	; this is what we always answer
%define 	KB_OTHER	0x03

%define KDADDIO		0x4B34		; add i/o port as valid
%define KDDELIO		0x4B35		; del i/o port as valid
%define KDENABIO	0x4B36		; enable i/o to video board
%define KDDISABIO	0x4B37		; disable i/o to video board

%define KDSETMODE	0x4B3A		; set text/graphics mode
%define		KD_TEXT		0x00
%define		KD_GRAPHICS	0x01
%define		KD_TEXT0	0x02	; obsolete
%define		KD_TEXT1	0x03	; obsolete
%define KDGETMODE	0x4B3B		; get current mode

%define KDMAPDISP	0x4B3C		; map display into address space
%define KDUNMAPDISP	0x4B3D		; unmap display from address space

%define scrnmap_t char
%define		E_TABSZ		256
%define GIO_SCRNMAP	0x4B40		; get screen mapping from kernel
%define PIO_SCRNMAP	0x4B41		; put screen mapping table in kernel
%define GIO_UNISCRNMAP  0x4B69		; get full Unicode screen mapping
%define PIO_UNISCRNMAP  0x4B6A		; set full Unicode screen mapping

%define GIO_UNIMAP	0x4B66		; get unicode-to-font mapping from kernel
%define PIO_UNIMAP	0x4B67		; put unicode-to-font mapping in kernel
%define PIO_UNIMAPCLR	0x4B68		; clear table, possibly advise hash algorithm

%define UNI_DIRECT_BASE 0xF000		; start of Direct Font Region
%define UNI_DIRECT_MASK 0x01FF		; Direct Font Region bitmask

%define		K_RAW		0x00
%define		K_XLATE		0x01
%define		K_MEDIUMRAW	0x02
%define		K_UNICODE	0x03
%define KDGKBMODE	0x4B44		; gets current keyboard mode
%define KDSKBMODE	0x4B45		; sets current keyboard mode

%define		K_METABIT	0x03
%define		K_ESCPREFIX	0x04
%define KDGKBMETA	0x4B62		; gets meta key handling mode
%define KDSKBMETA	0x4B63		; sets meta key handling mode

%define		K_SCROLLLOCK	0x01
%define		K_CAPSLOCK	0x02
%define		K_NUMLOCK	0x04
%define	KDGKBLED	0x4B64		; get led flags (not lights)
%define KDSKBLED	0x4B65		; set led flags (not lights)

%define		K_NORMTAB	0x00
%define		K_SHIFTTAB	0x01
%define		K_ALTTAB	0x02
%define		K_ALTSHIFTTAB	0x03

%define KDGKBENT	0x4B46		; gets one entry in translation table
%define KDSKBENT	0x4B47		; sets one entry in translation table

%define KDGKBSENT	0x4B48		; gets one function key string entry
%define KDSKBSENT	0x4B49		; sets one function key string entry

    
%define KDGKBDIACR      0x4B4A		; read kernel accent table
%define KDSKBDIACR      0x4B4B		; write kernel accent table


%define KDGETKEYCODE	0x4B4C		; read kernel keycode table entry
%define KDSETKEYCODE	0x4B4D		; write kernel keycode table entry

%define KDSIGACCEPT	0x4B4E		; accept kbd generated signals

%define KDGHWCLK        0x4B50		; get hardware clock
%define KDSHWCLK        0x4B51  	; set hardware clock

%define KDKBDREP        0x4B52  	; set keyboard delay/repeat rate;
				        ; actually used values are returned

%define KDFONTOP	0x4B72		; font operations


%define KD_FONT_OP_SET		0	; Set font
%define KD_FONT_OP_GET		1	; Get font
%define KD_FONT_OP_SET_DEFAULT	2	; Set font to default, data points to name / NULL
%define KD_FONT_OP_COPY		3	; Copy from another console

%define KD_FONT_FLAG_DONT_RECALC 	1	; Don't recalculate hw charcell size [compat]
;%ifdef __KERNEL__
%define KD_FONT_FLAG_OLD	0x80000000	; Invoked via old interface [compat]
;%endif

; note: 0x4B00-0x4B4E all have had a value at some time;
;   don't reuse for the time being
; note: 0x4B60-0x4B6D, 0x4B70-0x4B72 used above

; structs:
%ifnid consolefontdesc
    struc consolefontdesc
.charcount:	USHORT 1	;	; characters in font (256 or 512)
.charheight:	USHORT 1	;	; scan lines per character (1-32)
.chardata:	ULONG 1	;512	;char *chardata; font data in expanded form
    endstruc
%endif

%ifnid unipair
    struc unipair
.unicode:	USHORT 1
.fontpos:	USHORT 1
    endstruc
%endif

%ifnid unimapdesc
    struc unimapdesc
.entry_ct:	USHORT 1
.entries:	ULONG 1	;;;	;; struc unipair *entries;
;;;;.entries.unicode:	USHORT 
;;;;.entries.fontpos:	USHORT 
    endstruc
%endif

%ifnid unimapinit
    struc unimapinit
.advised_hashsize:	USHORT 1	; 0 if no opinion
.advised_hashstep:	USHORT 1	; 0 if no opinion
.advised_hashlevel:	USHORT 1	; 0 if no opinion
    endstruc
%endif

%ifnid kbentry
    struc kbentry
.kb_table:	UCHAR 1
.kb_index:	UCHAR 1
.kb_value:	USHORT 1
    endstruc
%endif

%ifnid kbsentry
    struc kbsentry
.kb_func:	UCHAR 1
.kb_string:	UCHAR 512
    endstruc
%endif

%ifnid kbdiacr
    struc kbdiacr
.diacr:		UCHAR 1
.base:		UCHAR 1
.result:	UCHAR 1
    endstruc
%endif

%ifnid kbdiacrs
    struc kbdiacrs
.kb_cnt:        UINT 1  	; number of entries in following array
.kbdiacr:times 256 resb kbdiacr_size; MAX_DIACR from keyboard.h
    endstruc
%endif

%ifnid kbkeycode
    struc kbkeycode
.scancode:	UINT 1
.keycode:	UINT 1
    endstruc
%endif

%ifnid kbdrepeat
    struc kbd_repeat
.delay:	INT 1			; in msec; <= 0: don't change
.rate:	INT 1			; in msec; <= 0: don't change
    endstruc
%endif

%ifnid console_font_op
    struc console_font_op
.op:	UINT 1			; operation code KD_FONT_OP_*
.flags:	UINT 1			; KD_FONT_FLAG_*
.width:	UINT 1			; font size
.height:UINT 1
.charcount:UINT 1
.cdata:	ULONG 1	;.data UCHAR *data;	; font data with height fixed to 32
    endstruc
%endif

; neither typed nor used (by name, in kernel 2.2.14):
%ifnid hwclk_time
    struc hwclk_time
.sec:	INT 1 ;unsigned		; 0..59
.min:	INT 1 ;unsigned		; 0..59
.hour:	INT 1 ;unsigned		; 0..23
.day:	INT 1 ;unsigned		; 1..31
.mon:	INT 1 ;unsigned		; 0..11
.year:	INT 1 ;unsigned		; 70...
.wday:	INT 1 ;			; 0..6, 0 is Sunday, -1 means unknown/don't set
    endstruc
%endif

%endif ;_LINUX_KD_H
;-
;-=========================================================================;
;- kd_h.inc <eof>
