;; linux kernel structure defn's

;   exception_table_entry include/linux/module.h:
	struc exception_table_entry
.insn:	LONG 1
.fixup:	LONG 1	;unsigned long insn, fixup;
	endstruc
;
;   iovec include/linux/uio.h:
	struc iovec
.iov_base:LONG 1	;void *iov_base;
.iov_len:LONG 1	;::-?-::;__kernel_size_t iov_len; };
	endstruc

;   itimerval include/linux/time.h:
	struct itimerval {
        struct timeval it_interval; /* timer interval */
        struct timeval it_value; /* current value */
   };
;   kernel_sym include/linux/module.h:
	struc kernel_sym
.value:	LONG 1		;unsigned long value;
.name:	CHAR 60		;char name[60];
	endstruc

;   mmap_arg_struct arch/i386/kernel/sys_i386.c:
	struc mmap_arg_struct
.addr:	LONG 1		;unsigned long addr;
.len:	LONG 1		;unsigned long len;
.prot:	LONG 1		;unsigned long prot;
.flags:	LONG 1		;unsigned long flags;
.fd:	LONG 1		;unsigned long fd;
.offset:LONG 1		;unsigned long offset;
	endstruc

;   module include/linux/module.h:
	struc module
.size_of_struct:LONG 1	;unsigned long size_of_struct; /* sizeof(module) */
.next:	LONG 1		;struct module *next;
.name:	LONG 1		;const char *name;
.size:	LONG 1		;unsigned long size;
.uc:	LONG 1		;union {
			; atomic_t usecount;
			; long pad;
			;} uc;
.flags:	LONG 1		;unsigned long flags; /* AUTOCLEAN et al */
.nsyms:	LONG 1		;unsigned nsyms;
.ndeps:	LONG 1		;unsigned ndeps;
.syms:	LONG 1		;struct module_symbol *syms;
.deps:	LONG 1		;struct module_ref *deps;
.refs:	LONG 1		;struct module_ref *refs;
.init:	LONG 1		;int (*init)(void);
.cleanup:LONG 1		;void (*cleanup)(void);
.ex_table_start:LONG 1	;const struct exception_table_entry *ex_table_start;
.ex_table_end:LONG 1	;const struct exception_table_entry *ex_table_end; 
;Members past this point are extensions to the basic module 
;support and are optional. Use mod_opt_member() to examine them. */
.persist_start:		;const struct module_persist *persist_start;
.persist_end:		;const struct module_persist *persist_end; 
.can_unload:LONG 1	;int (*can_unload)(void);
	endstruc	;};

;   module_persist include/linux/module.h:
	struc module_persist; /* yes, it's empty */
	endstruc

;   module_ref include/linux/module.h:
	struc module_ref
.dep:	resd 1		;struct module *dep; /* "parent" pointer */
.ref:	resd 1		;struct module *ref; /* "child" pointer */
.next_ref:resd 1	;struct module_ref *next_ref;
	endstruc

;   module_symbol include/linux/module.h:
	struc module_symbol
.value:	LONG 1		;unsigned long value;
.name:	resd 1		;const char *name;
	endstruc

;   new_utsname include/linux/utsname.h:
	struc new_utsname
.sysname:	CHAR 65	;char sysname[65];
.nodename:	CHAR 65	;char nodename[65];
.release:	CHAR 65	;char release[65];
.version:	CHAR 65	;char version[65];
.machine:	CHAR 65	;char machine[65];
.domainname:	CHAR 65	;char domainname[65];
	endstruc

;   __old_kernel_stat include/asm/stat.h:
	struc __old_kernel_stat
.st_dev:	USHORT 1;unsigned short st_dev;
.st_ino:	USHORT 1;unsigned short st_ino;
.st_mode:	USHORT 1;unsigned short st_mode;
.st_nlink:	USHORT 1;unsigned short st_nlink;
.st_uid:	USHORT 1;unsigned short st_uid;
.st_gid:	USHORT 1;unsigned short st_gid;
.st_rdev:	USHORT 1;unsigned short st_rdev;
.st_size:	ULONG  1;unsigned long  st_size;
.st_atime:	ULONG  1;unsigned long  st_atime;
.st_mtime:	ULONG  1;unsigned long  st_mtime;
.st_ctime:	ULONG  1;unsigned long  st_ctime;
	endstruc

;   oldold_utsname include/linux/utsname.h:
   struct oldold_utsname {
        char sysname[9];
        char nodename[9];
        char release[9];
        char version[9];
        char machine[9];
   };
;   old_sigaction include/asm/signal.h:
       struc old_sigaction
.sa_handler:	resd 1	;__sighandler_t sa_handler;
.sa_mask:	resd 1	;old_sigset_t sa_mask;
.sa_flags:	LONG 1	;unsigned long sa_flags;
.sa_restorer:	resd 1	;void (*sa_restorer)(void);
	endstruc

;   old_utsname include/linux/utsname.h:
   struct old_utsname {
        char sysname[65];
        char nodename[65];
        char release[65];
        char version[65];
        char machine[65];
   };
;   pollfd include/asm/poll.h:
   struct pollfd {
        int fd;
        short events;
        short revents;
   };
;   pt_regs include/asm/ptrace.h:
%ifndef pt_regs_size
%ifndef pt_regs
%ifndef __AU__
%ifndef _pt_regs_
%define _pt_regs_
	struc pt_regs
.ebx:	LONG 1	;long ebx;
.ecx:	LONG 1	;long ecx;
.edx:	LONG 1	;long edx;
.esi:	LONG 1	;long esi;
.edi:	LONG 1	;long edi;
.ebp:	LONG 1	;long ebp;
.eax:	LONG 1	;long eax;
.xds:	resd 1	;int  xds;
.xes:	resd 1	;int  xes;
.orig_eax:LONG 1;long orig_eax;
.eip:	LONG 1	;long eip;
.xcs:	resd 1	;int  xcs;
.eflags:LONG 1	;long eflags;
.esp:	LONG 1	;long esp;
.xss:	resd 1	;int  xss;
	endstruc
%endif
%endif
%endif
%endif
;   revectored_struct include/asm/vm86.h:
   struct revectored_struct {
        unsigned long __map[8];
   };
;   rlimit include/linux/resource.h:
   struct rlimit {
        long rlim_cur;
        long rlim_max;
   };
;   rusage include/linux/resource.h:
   struct rusage {
        struct timeval ru_utime; /* user time used */
        struct timeval ru_stime; /* system time used */
        long ru_maxrss; /* maximum resident set size */
        long ru_ixrss; /* integral shared memory size */
        long ru_idrss; /* integral unshared data size */
        long ru_isrss; /* integral unshared stack size */
        long ru_minflt; /* page reclaims */
        long ru_majflt; /* page faults */
        long ru_nswap; /* swaps */
        long ru_inblock; /* block input operations */
        long ru_oublock; /* block output operations */
        long ru_msgsnd; /* messages sent */
        long ru_msgrcv; /* messages received */
        long ru_nsignals; /* signals received */
        long ru_nvcsw; /* voluntary context switches */
        long ru_nivcsw; /* involuntary '' */
   };
;   sched_param include/linux/sched.h:
   struct sched_param {
        int sched_priority;
   };
;   sel_arg_struct arch/i386/kernel/sys_i386.c:
   struct sel_arg_struct {
        unsigned long n;
        fd_set *inp, *outp, *exp;
        struct timeval *tvp;
   };
;   sigaction include/asm/signal.h:
	struc sigaction
.sa_handler:	resd 1	;__sighandler_t sa_handler;
.sa_flags:	resd 1	;unsigned long sa_flags;
.sa_restorer:	resd 1	;void (*sa_restorer)(void);
.sa_mask:	resd 1	;sigset_t sa_mask; /* mask last for extensibility */
	endstruc

;   stat include/asm/stat.h:
	struc stat
.st_dev:	SHORT 1;unsigned short st_dev;
.__pad1:	SHORT 1;unsigned short __pad1;
.st_ino:	LONG 1;unsigned long  st_ino;
.st_mode:	SHORT 1;unsigned short st_mode;
.st_nlink:	SHORT 1;unsigned short st_nlink;
.st_uid:	SHORT 1;unsigned short st_uid;
.st_gid:	SHORT 1;unsigned short st_gid;
.st_rdev:	SHORT 1;unsigned short st_rdev;
.__pad2:	SHORT 1;unsigned short __pad2;
.st_size:	LONG 1;unsigned long  st_size;
.st_blksize:	LONG 1;unsigned long  st_blksize;
.st_blocks:	LONG 1;unsigned long  st_blocks;
.st_atime:	LONG 1;unsigned long  st_atime;
.__unused1:	LONG 1;unsigned long  __unused1;
.st_mtime:	LONG 1;unsigned long  st_mtime;
.__unused2:	LONG 1;unsigned long  __unused2;
.st_ctime:	LONG 1;unsigned long  st_ctime;
.__unused3:	LONG 1;unsigned long  __unused3;
.__unused4:	LONG 1;unsigned long  __unused4;
.__unused5:	LONG 1;unsigned long  __unused5;
	endstruc
	
;   statfs include/asm/statfs.h:
   struct statfs {
        long f_type;
        long f_bsize;
        long f_blocks;
        long f_bfree;
        long f_bavail;
        long f_files;
        long f_ffree;
        __kernel_fsid_t f_fsid;
        long f_namelen;
        long f_spare[6];
   };
;   __sysctl_args include/linux/sysctl.h
   struct __sysctl_args {
        int *name;
        int nlen;
        void *oldval;
        size_t *oldlenp;
        void *newval;
        size_t newlen;
        unsigned long __unused[4];
   };
;   sysinfo include/linux/kernel.h:
   struct sysinfo {
        long uptime; /* Seconds since boot */
        unsigned long loads[3]; /* 1, 5, and 15 minute load averages */
        unsigned long totalram; /* Total usable main memory size */
        unsigned long freeram; /* Available memory size */
        unsigned long sharedram; /* Amount of shared memory */
        unsigned long bufferram; /* Memory used by buffers */
        unsigned long totalswap; /* Total swap space size */
        unsigned long freeswap; /* swap space still available */
        unsigned short procs; /* Number of current processes */
        char _f[22]; /* Pads structure to 64 bytes */
   };
;   timex include/linux/timex.h:
   struct timex {
        unsigned int modes; /* mode selector */
        long offset; /* time offset (usec) */
        long freq; /* frequency offset (scaled ppm) */
        long maxerror; /* maximum error (usec) */
        long esterror; /* estimated error (usec) */
        int status; /* clock command/status */
        long constant; /* pll time constant */
        long precision; /* clock precision (usec) (read only) */
        long tolerance; /* clock frequency tolerance (ppm) (read only) */
        struct timeval time; /* (read only) */
        long tick; /* (modified) usecs between clock ticks */
        long ppsfreq; /* pps frequency (scaled ppm) (ro) */
        long jitter; /* pps jitter (us) (ro) */
        int shift; /* interval duration (s) (shift) (ro) */
        long stabil; /* pps stability (scaled ppm) (ro) */
        long jitcnt; /* jitter limit exceeded (ro) */
        long calcnt; /* calibration intervals (ro) */
        long errcnt; /* calibration errors (ro) */
        long stbcnt; /* stability limit exceeded (ro) */
        int :32; int :32; int :32; int :32;
        int :32; int :32; int :32; int :32;
        int :32; int :32; int :32; int :32;
   };
;   timespec include/linux/time.h:
   struct timespec {
        time_t tv_sec; /* seconds */
        long tv_nsec; /* nanoseconds */
   };
;   timeval include/linux/time.h:
   struct timeval {
        time_t tv_sec; /* seconds */
        suseconds_t tv_usec; /* microseconds */
   };
;   timezone include/linux/time.h:
   struct timezone {
        int tz_minuteswest; /* minutes west of Greenwich */
        int tz_dsttime; /* type of dst correction */
   };
;   tms include/linux/times.h
   struct tms {
        clock_t tms_utime;
        clock_t tms_stime;
        clock_t tms_cutime;
        clock_t tms_cstime;
   };
;   ustat include/linux/types.h:
   struct ustat {
        __kernel_daddr_t f_tfree;
        __kernel_ino_t f_tinode;
        char f_fname[6];
        char f_fpack[6];
   };
;   utimbuf include/linux/utime.h:
   struct utimbuf {
        time_t actime;
        time_t modtime;
   };
;   vm86plus_info_struct include/asm/vm86.h:
   struct vm86plus_info_struct {
        unsigned long force_return_for_pic:1;
        unsigned long vm86dbg_active:1;
        unsigned long vm86dbg_TFpendig:1;
        unsigned long unused:28;
        unsigned long is_vm86pus:1;
        unsigned char vm86dbg_intxxtab[32];
   };
;   vm86plus_struct include/asm/vm86.h:
   struct vm86plus_struct {
        struct vm86_regs regs;
        unsigned long flags;
        unsigned long screen_bitmap;
        unsigned long cpu_type;
        struct revectored_struct int_revectored;
        struct revectored_struct int21_revectored;
        struct vm86plus_info_struct vm86plus;
   };
;   vm86_regs include/asm/vm86.h:
   struct vm86_regs {
;   /* normal regs, with special meaning for the segment descriptors.. */
        long ebx;
        long ecx;
        long edx;
        long esi;
        long edi;
        long ebp;
        long eax;
        long __null_ds;
        long __null_es;
        long __null_fs;
        long __null_gs;
        long orig_eax;
        long eip;
        unsigned short cs, __csh;
        long eflags;
        long esp;
        unsigned short ss, __ssh;
;   /* these are specific to v86 mode: */
        unsigned short es, __esh;
        unsigned short ds, __dsh;
        unsigned short fs, __fsh;
        unsigned short gs, __gsh;
   };
;   vm86_struct include/asm/vm86.h:
   struct vm86_struct {
        struct vm86_regs regs;
        unsigned long flags;
        unsigned long screen_bitmap;
        unsigned long cpu_type;
        struct revectored_struct int_revectored;
        struct revectored_struct int21_revectored;
   };
;;;;;;