;[nolist]
;-================================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file  	: l4struc.inc
;-  switch	: __LIB4TH_S
;-  created	: 12-dec-2000
;-  modified	:
;-  version	: 0.61
;-  assembler	: nasm 0.98-3e (re below)
;-  description	: structure defn's for "lib4th" and related programs
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	: ..."nasm" is a pain!
;-  source	: -/-
;-  requires	: lib4th sources package
;-		:	http://home.snafu.de/phpr/lib4th.tar.bz2
;-		: "asmutils" 0.11+
;-		:	http://linuxassembly.org/asmutils.html
;-		: nasm-0.98-3e, without the patches of which the
;-		: <create> macro won't compile! found no feasible
;-		: alternatives with plain "nasm" program, thus:
;-		:	http://home.snafu.de/phpr/e-lhputils.html#nasm	(en)
;-		:	http://home.snafu.de/phpr/lhputils.html#nasm	(de)
;-		: or
;-		:	ftp://ftp.linuxgames.com/crystal/nasm/
;-================================================================================;
;-

%ifndef __LIB4TH_S
%define __LIB4TH_S
%define l4strucinc
;
; NOTE:
; Due to nasm specific issues (deficiencies) DO NOT CHANGE the general structures
; SETUP AND LOCATIONS! Current arrangement found feasible after many (weeks of)
; trials and errors and apparently is on a very narrow path of possible solutions!

;- %include "constants.inc"	assembly & system constants, for <cdt_bsize>
%ifndef constantsinc
%include "constants.inc"
%define constantsinc
%endif
;-

;-
;-================================================================================;
;- multi-tasking
;-

;-	

;-
;- struc jargs
;-	initial data on stack for sys_clone call
    struc jargs		;:jargs:;
;- 	.ur:uref	; 1st 3 items popped after syscall
.ur	resd 1
;- 	.kr:kref
.kr	resd 1
;- 	.nt:entry
.nt	resd 1
;- 	.ac:argc	; count begins here
.ac	resd 1
;- 	.np:nameptr
.np	resd 1
;-	next two dwords should be zeroed or, stack set up to additional 
;-	args requirements - <jargs_size> is minimum!
	resd 2
    endstruc
;-
;-
;- Wordheaders structures (as of lib4th 0.0.47)
;-
;- names headers & linkage, pointers at dword aligned address,
;- entries signed 32bit dword items, unless stated,
;- basic structure as set up with <struc whead>, below.
;-
;- linkage by +ve displacements such that
;-		linkfield dup @ -
;- points to preceding lfa.
;-
;- standard 4th word:
;-
;- ifa,	index field, 16bit word
;-		index	unsigned 16bit index into u.o.t.
;- ffa, flags field, 16bit word
;-		flags	4th compileflags, re <constants.inc>
;- mfa,	macro field
;-		ms. word
;-		cmac	top bit set: word can compile inline code (macro)
;-			bits 14..0	disp of label to macro code
;-		ls.word 		count of code length
;- lfa,	linkfield
;-		link	+ve displacement to preceding words link pointer posn
;- nfa,	name field
;-		name	byte counted asciz string,
;-			with <nul> bytes filled up to before dword aligned posn
;- pfa,	parameter field
;-		doword	code entry in execution segment wrt. <wordbot> reference,
;-			pre-compiled modules can thus be loaded anywhere and linked 
;-			by adjusting the pointers with a constant disp supplied 
;-			by nature of extension, at no cost of additional data.
;-			code relocation is done by means of inserting relocated
;-			execution addresses to uot and further adjustment to
;-			where uot access occurs in the module.
;- extendability/compiler not implemented in this version,
;- relocation info might follow, with another F8 version...
;-
;- vocabulary:
;-
;- defined by two consecutive standard forth words:
;- 	1st the vocabulary word as the above pattern, w. vocf set.
;-	2nd extension word
;-		where the execution pointer is replaced by the
;-		lfa-s displacement value to currently latest word
;-		in vocabulary to vocabulary's own, 1st word header.
;-	vifa, index field
;-		dword +ve disp to primary header's lfa
;-	vmfa, macro field
;-		dword vocabulary linkage, +ve disp to previous vmfa,
;-		last lfa goes to {voc-link}
;-	vlfa, link field
;-		zero, base lfa of this voc's wordlist
;-	vnfa, name field
;-		unique, dummy name {1,' ',0,0}
;-	vpfa, parameter field
;-		toplink, +ve disp to vlfa of top lfa in voc
;-
;- voc-link:
;-	voc-link disp points to latest 2nd-ary voc-lfa
;-	which is linked to preceding voc, until disp=0.
;-
;- kernel-vocs:
;-	root and forth pre-defined, voc-link points to auxilary link
;-	at dataspace beginning, re below, "RAM linkage".
;-	@c0	.-- dataspace --.	initial {here}
;-		    1st vhead (root)	copy of 2nd-ary wordheader
;-		    2nd vhead (forth)	..
;-			other data	\ following voc. linkheaders
;-		    3rd vhead		/ may be mixed with other data
;- module:
;-	kernel wordlist may serve as an example, re "lib4words.inc".
;-
;- 	1st standard wordheader as above pattern
;-		lfa is respective <wordbot> to which all execution 
;-		pointers supplied with this modules wordlists refer.
;-	2ndary, vocabulary type extension header w. additional description
;-	mlst, dword
;-		+ve disp wrt 1st to last lfa in module, for {last}
;-	mtop, dword
;-		+ve disp wrt 1st to last vlfa in module, for {voc-link}
;-	any number of any type wordheaders may follow.
;-
;-	words initially linked to {current},
;-	modules may define sub-vocabularies and wordlists.
;-	2nd-ary of 1st header may be a dummy, after non-vocabulary word, 
;-		providing disp to last wrt 1st lfa within module.
;-	xec-ptrs within module refer to 1st lfa,
;-	data-ptrs of 2ndary pfa refer to beginning of data memory, @d0.
;-	nasm deficiencies require modules descriptions positioned last in 
;-	a module, after the actual code. this is not a lib4th requirement.
;-
;- RAM linkage
;-	Wordlists when extending into alterable data memory will be linked 
;-	via an intermediate dummy header of 2nd-ary vocabulary headers type,
;-	vifa
;-		+ve disp pointing to the primary vocabulary header
;-	vlfa
;-		+ve disp to this wordlists previous toplink
;-	vpfa
;-		new toplink, updated by new words definitions.
;-
;-	
;-
;- struc whead
;-	primary word header. (w) is 16bit item.
;-	when referring to this struct take variable names length into account!
    struc whead		;:whead:;
;- .i:	C{name}:	ifa (w)	uot index
.i:	resw 1
;- .f:			ffa (w)	compileflags, l.s.nibble xtn fields count
.f:	resw 1
;- .m:			mfa	macro flags&count
.m:	resd 1
;- .l:	L{name}:	lfa	linkfield, wordlink
.l:	resd 1
;- .n:			nfa	countbyte, min. length
;-			3 < namelength < 256, <nul> padded to dwords bounds.
;-	variable ptr-s follow, dependent on name length:
.n:	resb 4
;- .x:			pfa	one cell after nfa is min. posn of execution ptr
;-			{>body} returns ptr to data-space, past <pfa> - re below.
.x:	resb 256-4
;- .p:			body	.n+aligned(min(max(8,namelength+5),260))
;-			at 4-aligned 4+(3 < disp = namelength+1 < 257) from nfa.
;-			contains xec-ptr wrt this address, <zero> in uot for <pfax> words.
.p:	resd 1
;- .e			- end of this <struc> -
;-			additional fields the no. of which is ((@ffa&&xwfl)-1) may follow.
.b:; (no pre-assigned data!)
;- .b			<pfax>-words disp to vari space
;-	+4		<inf> init entry
;-	+8		other data, e.g. {defer}-actions, etc.
    endstruc
;-
;- struc vhead
;-	vocabulary 2ndary header, {wordlist} basic structure.
    struc vhead		;:vhead:;
;- .i:			vifa	disp vlfa to word header lfa of vocabulary
.i:	resd 1
;- .m:	V{name}:	vmfa	<wid>, voclink
.m:	resd 1
;- .l:	B{name}:	vlfa	base lfa of wordlist linkage (0)
.l:	resd 1
;- .n:	{name}vnfa:	vnfa	4 bytes dummy name, vocnfa: 1,<bl><nul><nul>
.n:	resd 1
;- .p:	{name}top:	vpfa	disp to top lfa of this voc's wordlist
.p:	resd 1
    endstruc
;-
;- struc mhead
;-	module 2ndary header (by 2 dwords extended 2ndary vocabulary header)
    struc mhead		;:mhead:;
;- .i:			vifa	disp to word header lfa
.i:	resd 1
;- .m:			vmfa	voclink, disp to previous voc-link, init. 0
.m:	resd 1
;- .l:			vlfa	initial link (0), modules base ref of execution ptrs
.l:	resd 1
;- .n:			vnfa	4 bytes dummy name, vocnfa: 1,<bl><nul><nul>
.n:	resd 1
;- .p:			vpfa	disp to top lfa
.p:	resd 1
;- .s:			mlst	disp to last lfa in module
.s:	resd 1
;- .t:			mtop	disp to last voc-link in module
.t:	resd 1
    endstruc
;-
;- struc fgtlink
;-	forget handler linkage field
    struc fgtlink	;:fgtlink:
;- .lfa:  		flfa	link address
.lfa:	resd 1
;- .ixw:  		fwrd	word by ix, which the datafiled is assigned to
.ixw:	resd 1
;- .ixh:  		fhnd	word by ix, which will be executed immediately 
;-				before <fwrd> being removed by {forget}.
;-				<fhnd> receives ix of fwrd on @tos, which item 
;-				may be changed but must remain on stack.
.ixh:	resd 1
    endstruc
;-	
;- struc casec
;-	'cnum' list header, for {associative}, {case:}, {range:}
    struc casec		;:casec:
.flag:	resd 1
.size:	resd 1
    endstruc
;-

;-	

;-
;-================================================================================;
;- application data, program setup
;-
;-	

;-
;- struc i4th	re macro i4th_ntry in <lib4th.mac>	-not used-
;-	lib4th setup, initial data passing structure, from L4 app. by EDI reg.
;-	defaults used for <zero> items				(dft.)
    struc i4th		;:i4th:;
;-	.ntry		inital execution entry true address	(quit)
.ntry:	resd 1
;-	.bootp		ptr to supplied boot parameters, loadfile/data
.bootp:	resd 1
;-	.dstack		size of datastack			( 64K)
.dstack:resd 1
;-	.rstack		size of returnstack			( 64K)
.rstack:resd 1
;-	.tibmem		size of t.i.b.				(  4K)
.tibmem:resd 1
;-	.uarea		size of user-vari and uot area, min 64K	( 64K)
.uarea:	resd 1
;-	.cplmem		size of compilespace			(128K)
.cplmem:resd 1
;-	.datamem	size of dataspace (and word-headers)	(  64K, extendable)
.datamem:resd 1	
;;-	.jobstk		minimal word executing jobs' stacks	(   2K)
;.jobstk:resd 2
;;-	.jobss		minimal i/o & compiling jobs .ss, plus jobstk
;.jobss:	resd 2
;;-	.jobbss		minimal i/o & compiling jobs .bss section
;.jobbss:resd 2
;-	.e		-1 marker value for end of structure
.e:	resd 1
	endstruc
;-

;-
;-================================================================================;
;- resources management
;-
;-	

;-
;- -- file access
;-

;-
;- struc cdt
;-	channel definition table
	struc cdt		;:cdt:;
;- .chid  0  	file descriptor
.chid:	resd 1
;- .chpt  4	ptr to extension field (yet empty)
.chpt:	resd 1
;- .iofl  8	io flags
.iofl:	resd 1
;- .acfl 0c 	access flags from open
.acfl:	resd 1
;- .perm 10 	file permissions
.perm:	resd 1
;- .rnum 14 	latest op error code
.rnum:	resd 1
;- .fpos 18 	current file pointer, 64bit (2.4 kernel)
.fpos:	resd 2
;- .ibuf 1c	single char input buffer
.ibuf:	resd 1
;- .bbuf 20	ptr to blockfiles buffer (n.i., requires memory management)
.bbuf:	resd 1
.x:	resd (1<<cdt_bsize)-((.x-.chid)/4)
	endstruc
%if cdt_size != 4<<cdt_bsize
%error "cdt_size != 4<<cdt_bsize"
%endif
;-

;-
;- struc buffers - n.i.
;-	pointers, flags, linkage for blockfile buffers, per file linkage base
	struc buffers
;- .l		circular link, to next buffer or self if single buf
.l:	resd 1
;- .u		(ptr to buffer space -?-)
.u:	resd 1
;- .n		latest used buffer
.n:	resd 1
;- .c		file channel the rsp buffer chain is assigned to
.c:	resd 1
	endstruc
;-
;- struc blkbuf
;-	screenfile block buffer ptrs
;-	[ link ][ (reserve) ][ owner-file fd ][ no. of blocks ] [[ updt|blk# ][ disp to blk ] ... ]
	struc blkbuf	;:blkbuf:
;- .l		circular link, disp to next blockptr, -re- {block-lk}
.l:	resd 1
;- .u		- (yet unused) -
.u:	resd 1
;- .c		file channel this buffer is assigned to
.c:	resd 1
;- .b		no. of blocks in this buffer (4)
.b:	resd 1
;- .f		2 cells per block: block number & update flag, disp to rsp. block (8)
.f:	resd 4*2
	endstruc
;-
;- struc blkhead
;-	block header per buffer in block of screenfile buffers
	struc blkhead	;:blkhed:
;- .u		file-block number, bit#31:update-flag, bit#30(n.i.):interpreter input
.u:	resd 1
;- .d		pc-rel disp to buffer
.d:	resd 1
	endstruc
;-


;-
;- -- memory
;-

;-
;- struc hphead		( => 'under construction...')
;-	heap memory allocation block header
;-	[ len ][ drivr ][ owner ][ rflag ]
;-	<zero> entries indicate a noop, struc. may be extended by other handlers
;- useage for
;-	reserved system heap:
;-	.len		size, header inclusive
;-	.drivr  	used heap blocks chain: ptr to handler link address
;-	.owner  	pid of allocating job, 0 if block unused
;-	.rflag  	ptr to follow-up block wrt .rflag address, 0 at end of chain
;-	available system blocks:
;-	.len		size, header inclusive
;-	.next		ptr to next free heap address, 0 at end of chain
;-	.owner  	0
;-	.rflag  	0
;-	user heap:
;-	.len		size, header inclusive
;-	.drivr  	ptr to handler link address
;-	.owner  	pid of owner job
;-	.rflag  	ptr to flagbit to set when block removed, or 0
;-	available user heap:
;-	.len		size, header inclusive
;-	.next		ptr to next free heap address, 0 at end of chain
;-	.owner  	0
;-	.rflag  	0
    struc hphead	;:hphead:;
.len:	resd 1
.drivr:	resd 1
.owner:	resd 1
.rflag:	resd 1
;-
    endstruc
;-
;-
;- struc handler
;-	full size handler defn. block
;-	link and ptr-s to resources management routines and simple devices
    struc handler	;:handler:;
.lxint:	resd 1
.axint:	resd 1
.lpoll:	resd 1
.apoll:	resd 1
.lschd:	resd 1
.aschd:	resd 1
;- .lio		linkage
.next:
.lio:	resd 1
;- .aio		address of i/o routine
.inout:
.aio:	resd 1
;- .aopen  	address of allocation routine
.opem:
.aopen:	resd 1
;- .aclos  	address of cancelling routine
.close:
.aclos:	resd 1
.slave:	resd 1
.renam:	resd 1
	resd 1
.formt:	resd 1
.dflen:	resd 1
.drnam:	resb 36
    endstruc
;-

;-
;---------------------------------------------------------------------------------;
;- heap header extensions
;-

;-	

;-
;- struc console4	(n.i.)
;-	i/o window definition block
;- struc screen4 = console w/o <console.queue> item
;-	non-input window definition block
    struc console4	;console;screen;
.prwlb:	resd 1	; primary link list, bottom up; ptr to prim if secondary
.prwlt:	resd 1	; primary, top down
.sewll:	resd 1	; base ref.
.wsave:	resd 1	; window data save buffer
.wssiz:	resd 1	; size of saved area
.wwdef:	resd 1	; 
.wlstt:	resb 1	; window locked flg
.prwin:	resb 1	; primary w. flag
.wmode:	resb 1	; display mode
.mysav:	resb 1	; window data saved flag
.wmove:	resb 1
.pick:	resb 1
	resb 1
	resb 1
.min:
.xmin:	resw 1	; left origin
.ymin:	resw 1	; top origin
.size:		; 
.xsiz:	resw 1	; width
.ysiz:	resw 1	; height
.borwd:	resw 1	; border width
.pos:		; 
.xpos:	resw 1	; cursor column
.ypos:	resw 1	; cursor row
.inc:		; cursor increment (size)
.xinc:	resw 1
.yinc:	resw 1
.font:	resd 2	; character founts
.scrb:	resd 1	; video memory base address
.pmask:	resd 1	; 'paper' colour mask
.smask:	resd 1	; 'strip'
.imask:	resd 1	; 'ink'
.cattr:	resb 1	; cursor attributes, chars display mode
.curf:	resb 1	; new-line status
.pcolr:	resb 1	; 'paper' colour
.scolr:	resb 1	; 'strip'
.icolr:	resb 1	; 'ink'
.bcolr:	resb 1	; 'border'
.nlsta:	resb 1	; 
.fmod:	resb 1	; 
.org:		; graphic co-ordinates origin, double prec.
.yorg:	resd 2	; 
.xorg:	resd 2	; 
.scal:	resd 2	; drawing scale
.fbuf:	resd 1	; areae filling buffer
.fuse:	resd 1	; ptr to working routine for fill
.linel:	resw 1	; line increment by bytes of video memory
.queue:	resd 1	; 0 if no input capability, else i/o queue
    endstruc
;-	
;-

;-
%endif ;__LIB4TH_S
;-
;-================================================================;
;- l4struc.inc <eof>
