;-================================================================;
;- Copyright (C) 2001 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for copyright information (GNU GPL)
;-
;-  file	: nasmmac.inc
;-  switch	: __NASMMAC_I
;-  created	: 08-apr-2001
;-  modified	:
;-  version	: 0.01
;-  assembler	: nasm 0.98e(!)
;-  description	: supplementary macroes
;-		:	which belong to the assembler:
;-		: _nolist, _listing_, list, jr, {A,T}MODE
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  source	: -/-
;-  requires	: nasm 0.98e or later, patched vers. w/ "%xdefine"
;-================================================================;
;-

%ifndef __NASMMAC_I
%define __NASMMAC_I
%define nasmmacinc

;-
;- %define _nolist
;-	pre-definable macroes global listing on/off via asm-vari
;das, o staunen, spielt...
%ifndef _nolist
%define _nolist
%endif

;-
;- import 1-2 name
;-	%include %1 if not already done; binary mode if %2=bin
%imacro import 1-2 name_nolist
%ifndef _%{1}_imp_
%ifidni %{2},bin
%error "no such instruction: %incbin (%{1})"
%else
%include %{1}
%endif
%define _%{1}_imp_
%endif
%endm

;-
;- %macro num_stg 1 .nolist
;-	db secimal 8 digits number to 8 bytes text stg
;-	nasm: w/ %assign no (not even relative disp's) forward refs useable!
;-	      <db..> would do, but cannot add for ascii/hex...
%macro c_a 1.nolist
%assign %00 (${1})&15
%if (%00) > 9
%assign %00 (%00)+7
%endif
%endm
;
%macro num_stg 1;.nolist
%ifid %00
%00:
%endif
%define %%k (((%{1})&15)|'0')
%define %%n ((%{1})>>4)
%if %%k>(9+'0')
%define %%k ((%%k)+7)
%endif
%xdefine d	%%k
%assign %%l 7
%rep
    %define %%k ((%%n&15)|'0')
    %define %%n ((%%n)>>4)
    %if %%n>(9+'0')
	%define %%n ((%%n)+7)
    %endif
    %xdefine d %%n,d
    %assign l l-1
    %if %%l<1
	%exitrep
    %endif
%endrep
    db d
%endm
;
;-
;- %macro list 0-*.nolist on;[nolist]
;-	useless substitute to upgraded nasm, just to preventing "errors"
%ifndef _listing_
%macro list 0-*.nolist on;[nolist]
%define _listing_ %{1}
%endm
%ifidn _nolist,.nolist
%define _listing_ on
%else
%define _listing_ off
%endif
%endif
;-
;- %imacro _message 0-*.nolist
;-	silly 'helper' to list macroes arguments by _content_
%if __NASM=9821
%define _message_
%elif __NASM=9818
%define _message_
%elif __NASM=9809
%define _message
%endif
;
%ifndef _message
    %ifdef _message_;_m_
%xdefine _message
%define _message
%imacro _message 0-*.nolist
%if %0>0
 %xdefine _msg_
 %rep %0
  %xdefine _msg_ _msg_ %{1}
  %rotate 1
 %endrep
 %error "_msg_"
%endif
%endm
    %else;_m_
%imacro _message 0-*.nolist
%if %0>0
 %xdefine _msg_
 %rep %0
  %xdefine _msg_ _msg_ %{1}
  %rotate 1
 %endrep
 %message "_msg_"
%endif
%endm
    %endif;_m_
%endif;_m
; another such thing:
%ifndef _message
%macro MD 0-2.nolist ; debug a nasm macro.. (not w/ 'official' nasm)
%if %{0} = 0
%message " "
%else
%assign x %{1}
%xdefine x x
%xdefine y %{2}
%message "y => x"
%endif
%endm
%endif
;-
;- jr
;-	<jmp short>
%ifndef jr
%define jr jmp short
%endif
;-
;- disp
;-	<jcc/jmp disp [label|abs.expr]>
;-	cpl shortest branch code, backwards only.
%macro disp 1_nolist
%%d: equ $+4-(%{1})
%assign %%x %%d
%if (%%x<=0)&&(%%x>=0xFFFFFF80)
	%{00}	short %{1}
%elif (%%x>0)&&(%%x<0x80)
	%{00} short %{1}
%else
	%{00} near %{1}
%endif
%endm
;-
;- a32
;-	noop if __OPTIMIZE__ =/= __O_SPEED__, else
;-	align 32 if 8 bytes or less below a 32-byte bound, else align 4
%macro a32 0_nolist
%if __OPTIMIZE__=__O_SPEED__
%%x: equ ($$-$)&31
%if (%%x<9)&&(%%x>0)
    align 32
%else
    align 4
%endif
%endif
%endm
;
;-	_ascall_	;seg-prefixed call, disp 4-aligned (eForth, muell!)
%define _ascall_ dd 0xE82e2e2e
; a more efficient "align" macro for nasm 098e(+) or devel 0.98-08-09(+)
%define _align0
; from AMD-64 binutils 2.11.90: "Various efficient no-op patterns for aligning code labels..." (comment in att-syntax!)
%define _align1  db 0x90							; nop
%define _align2  db 0x89,0xf6							; mov esi,esi
%define _align3  db 0x8d,0x76,0x00						; lea 0(esi),esi
%define _align4  db 0x8d,0x74,0x26,0x00						; lea 0(esi,1),esi
%define _align5  db 0x90,0x8d,0x74,0x26,0x00					; nop / lea 0(esi,1),esi
%define _align6  db 0x8d,0xb6,0x00,0x00,0x00,0x00				; lea 0L(esi),esi
%define _align7  db 0x8d,0xb4,0x26,0x00,0x00,0x00,0x00				; lea 0L(esi,1),esi
%define _align8  db 0x90,0x8d,0xb4,0x26,0x00,0x00,0x00,0x00			; nop / lea 0L(esi,1),esi
%define _align9  db 0x89,0xf6,0x8d,0xbc,0x27,0x00,0x00,0x00,0x00		; mov esi,esi / lea 0L(edi,1),edi
%define _align10 db 0x8d,0x76,0x00,0x8d,0xbc,0x27,0x00,0x00,0x00,0x00		; lea 0(esi),esi / lea 0L(edi,1),edi
%define _align11 db 0x8d,0x74,0x26,0x00,0x8d,0xbc,0x27,0x00,0x00,0x00,0x00	; lea 0(esi,1),esi / lea 0L(edi,1),edi
%define _align12 db 0x8d,0xb6,0x00,0x00,0x00,0x00,0x8d,0xbf,0x00,0x00,0x00,0x00	; lea 0L(esi),esi / lea 0L(edi),edi
%define _align13 db 0x8d,0xb6,0x00,0x00,0x00,0x00,0x8d,0xbc,0x27,0x00,0x00,0x00,0x00	; lea 0L(esi),esi / lea 0L(edi,1),edi
%define _align14 db 0x8d,0xb4,0x26,0x00,0x00,0x00,0x00,0x8d,0xbc,0x27,0x00,0x00,0x00,0x00;lea 0L(esi,1),esi / lea 0L(edi,1),edi
%define _align15 db 0xeb,0x0d,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90; jmp .+15; lotsa nops
;-
;- label: aligned 2
;-	assign by %{2} (dft=4) aligned number %{1} to <label>
%macro aligned 2.nolist 4
%assign %00 (%{1}%%%{2})
%if %00 > 0
%assign %00 %{1}+%{2}-%00
%else
%assign %00 %{1}
%endif
%endm
;-
;- oalign 0-3+
;-	alignment of 2^(%{1}), optionally displaced by %{2} bytes
;-	%3 unset (or non-numeric):
;-	align by neutral opcode insertion or, <jmp short (disp-2)> if disp > 15
;-	%3 numeric:
;-	align by insertion of the required no. of {db %3}.
%macro oalign 0-3+_nolist 2,0,nop; leading macro defaults don't work!
%assign %%a (1<<(%{1}))	; alignment
%%o: equ ($-$$)		; current offset in section
%assign %%m %%o %% (%%a); aligned address
%if %%m>0
%assign %%m %%o+%%a-%%m
%else
%assign %%m %%o
%endif
%assign %%s ((%%m)-(%%o)+(%{2}))
%if %%s < 0
%assign %%s (%%s+%%a)
%endif
%assign %%s ((%%s)&(~(%%a)))
%ifnum %{3}
	times %%s %{3}
%else
	_align %+ %%s
%endif
%ifid %{00}
%{00}:
%endif
%endm
;-
;- AMODE 0-1
;-	<%assign (var) 0/1> to addressing mode of operand %1
;-	var = one of AER(unknown), REG, TXT(string), EA(other)
%macro TMODE 1.nolist
%assign TXT 0
%assign NUM 0
%assign REG 0
%assign EA  0
%assign AER 1
%ifnum %{1}
%assign NUM 1
%elifstr %{1}
%assign TXT 1
%else
%assign REG 1
    %ifidni %{1},eax
    %elifidni %{1},ebx
    %elifidni %{1},ecx
    %elifidni %{1},edx
    %elifidni %{1},ebp
    %elifidni %{1},esi
    %elifidni %{1},edi
    %elifidni %{1},esp
%ifndef __LIB4TH
%elifndef __E4TH
%else
    %elifidni %{1},PS
    %elifidni %{1},RS
    %elifidni %{1},BP
    %elifidni %{1},IP
    %elifidni %{1},UP
%endif
    %else
%assign REG 0
%assign EA  1
    %endif
%endif
%endm
;
%macro AMODE 0-*_nolist
%if %0>0
    TMODE {%{1}}
%else
    TMODE {%{00}}
%endif
%endm
;-
;- label: min 2, %macro - but, "nasm": neither variant works!
;-	%xdefine %00 to the lesser of two args
	%if 0
%macro min 2.nolist
%xdefine %00 %{1}
%if %{1} > %{2}
%xdefine %00 %{2}
%endif
%endm
	%else
%macro min 2.nolist
%assign %%m %{1}-%{2}
%xdefine %00 %{1}
%if %%m>0
%xdefine %00 %{2}
%endif
%endm
	%endif
;- label: max 2, %macro
;-	%xdefine %00 to the greater of two args
%macro max 2.nolist
%assign %%m1 %{1}
%assign %%m2 %{2}
%xdefine %00 %%m1
%if %%m1 < %%m2
%xdefine %00 %%m2
%endif
%endm
;-
%endif ;__NASMMAC_I
;-
;-================================================================;
;- nasmmac.inc <eof>
