;-================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file	: posix_types.h.inc
;-  switch	: __RELOC_I
;-  created	: 18-jan-2000
;-  modified	: 30-aug-2000
;-  version	: 0.03
;-  assembler	: nasm 0.98
;-  description	: macros for relocatible & reentrant code
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	: unless stated all macroes case-sensitive
;-  source1	: include/linux/posix_types.h
;-  source2	: include/asm/posix_types.h
;-  requires	: scilab's patched nasm 0.98e
;-		:	ftp://ftp.linuxgames.com/crystal/nasm/
;-================================================================;
;-
%error "posix_types.h.inc not converted"

; from source1
%ifndef _LINUX_POSIX_TYPES_H
%define _LINUX_POSIX_TYPES_H

;%include <linux/stddef.h>

; This allows for 1024 file descriptors: if NR_OPEN is ever grown
; beyond that you'll have to change this too. But 1024 fd's seem to be
; enough even for such "real" unices like OSF/1, so hopefully this is
; one limit that doesn't have to be changed [again].
; Note that POSIX wants the FD_CLEAR(fd,fdsetp) defines to be in
; <sys/time.h> (and thus <linux/time.h>) - but this is a more logical
; place for them. Solved by having dummy defines in <sys/time.h>.
; Those macros may have been defined in <gnu/types.h>. But we always
; use the ones here. 

%define sizeof(unsigned_long) 4

%undef __NFDBITS
%define __NFDBITS	(8 * sizeof(unsigned_long))

%undef __FD_SETSIZE
%define __FD_SETSIZE	1024

%undef __FDSET_LONGS
%define __FDSET_LONGS	(__FD_SETSIZE/__NFDBITS)

%undef __FDELT
%define	__FDELT(d)	((d) / __NFDBITS)

%undef __FDMASK
%define	__FDMASK(d)	(1 << ((d) % __NFDBITS))

;typedef struct {
;	unsigned long fds_bits [__FDSET_LONGS];
;} __kernel_fd_set;
%define __kernel_fd_set	resd __FDSET_LONGS

; Type of a signal handler.
;typedef void (*__kernel_sighandler_t)(int);
%define __kernel_sighandler_t	resd 1

; Type of a SYSV IPC key.
;typedef int __kernel_key_t;
%define __kernel_key_t resd 1

;%include <asm/posix_types.h>

%endif /* _LINUX_POSIX_TYPES_H */

; from source2
%ifndef __ARCH_I386_POSIX_TYPES_H
%define __ARCH_I386_POSIX_TYPES_H

; This file is generally used by user-level software, so you need to
; be a little careful about namespace pollution etc. Also, we cannot
; assume GCC is being used.

__kernel_dev_t:		resw 1	;short
__kernel_ino_t:		resd 1	;long	
__kernel_mode_t:	resw 1	;unsigned short	
__kernel_nlink_t:	resw 1	;unsigned short	
__kernel_off_t:		resd 1	;long		
__kernel_pid_t:		resd 1	;int		
__kernel_ipc_pid_t:	resw 1	;unsigned short	
__kernel_uid_t:		resw 1	;unsigned short	
__kernel_gid_t:		resw 1	;unsigned short	
__kernel_size_t:	resd 1	;unsigned int	
__kernel_ssize_t:	resd 1	;int		
__kernel_ptrdiff_t:	resd 1	;int		
__kernel_time_t:	resd 1	;long		
__kernel_suseconds_t:	resd 1	;long		
__kernel_clock_t:	resd 1	;long		
__kernel_daddr_t:	resd 1	;int		
__kernel_caddr_t:	resd 1	;char *		
                        
__kernel_loff_t:	resd 2

;typedef struct {
;%if defined(__KERNEL__) || defined(__USE_ALL)
;	int	val[2];
;%else /* !defined(__KERNEL__) && !defined(__USE_ALL) */
;	int	__val[2];
;%endif /* !defined(__KERNEL__) && !defined(__USE_ALL) */
;} 
%define __kernel_fsid_t(x) resd 2*(x)

%define k=0
%ifdef __KERNEL__
%define k=1
%endif
%ifdef __GLIBC__
%if __GLIBC_<2
%define k=1
%endif
%else
%define k=1
%endif

%if k>0;defined(__KERNEL__)|| !defined(__GLIBC__) || (__GLIBC__ < 2)

%undef	__FD_SET
;%define __FD_SET(fd,fdsetp) \
;		__asm__ __volatile__("btsl %1,%0": \
;			"=m" (*(__kernel_fd_set *) (fdsetp)):"r" ((int) (fd)))
%macro __FD_SET 2-3_nolist edx
%define %%r %{3}
    lea %%r,[%{2}+((%{1}/32)*8)]
    bts byte[%%r],%{1}
%endm

%undef	__FD_CLR
;%define __FD_CLR(fd,fdsetp) \
;		__asm__ __volatile__("btrl %1,%0": \
;			"=m" (*(__kernel_fd_set *) (fdsetp)):"r" ((int) (fd)))

%undef	__FD_ISSET
;%define __FD_ISSET(fd,fdsetp) (__extension__ ({ \
;		unsigned char __result; \
;		__asm__ __volatile__("btl %1,%2 ; setb %0" \
;			:"=q" (__result) :"r" ((int) (fd)), \
;			"m" (*(__kernel_fd_set *) (fdsetp))); \
;		__result; }))

%undef	__FD_ZERO
;%define __FD_ZERO(fdsetp) \
;do { \
;	int __d0, __d1; \
;	__asm__ __volatile__("cld ; rep ; stosl" \
;			:"=m" (*(__kernel_fd_set *) (fdsetp)), \
;			  "=&c" (__d0), "=&D" (__d1) \
;			:"a" (0), "1" (__FDSET_LONGS), \
;			"2" ((__kernel_fd_set *) (fdsetp)) : "memory"); \
;} while (0)

%endif /* defined(__KERNEL__) || !defined(__GLIBC__) || (__GLIBC__ < 2) */

%endif;__ARCH_I386_POSIX_TYPES_H
;-
;-
;-================================================================;
;- posix_types.h.inc <eof>
