;-================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file	: ptrace.h.inc
;-  switch	: __PTRACE_H
;-  created	: 17-jan-2001
;-  modified	:
;-  version	: 0.01
;-  assembler	: nasm 0.98-3e
;-  description	:
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	: unless stated all macroes case-sensitive
;-  source	: include/asm/ptrace.h, include/ptrace.h
;-  requires	: scilab's patched nasm 0.98e
;-		:	ftp://ftp.linuxgames.com/crystal/nasm/
;-================================================================;
;-

%ifndef _PTRACE_H
%define ptracehinc
%define _PTRACE_H

; include/ptrace.h
; ----------------

%define PTRACE_TRACEME		 0
%define PTRACE_PEEKTEXT		 1
%define PTRACE_PEEKDATA		 2
%define PTRACE_PEEKUSR		 3
%define PTRACE_POKETEXT		 4
%define PTRACE_POKEDATA		 5
%define PTRACE_POKEUSR		 6
%define PTRACE_CONT		 7
%define PTRACE_KILL		 8
%define PTRACE_SINGLESTEP	 9
; asm/ptrace.h
%assign PTRACE_GETREGS		12
%assign PTRACE_SETREGS		13
%assign PTRACE_GETFPREGS	14
%assign PTRACE_SETFPREGS	15
; include/ptrace.h
%define PTRACE_ATTACH		16
%define PTRACE_DETACH		17
%define PTRACE_SYSCALL		24

; asm/ptrace.h
; ------------

; added prefix PT_ for the assmbler [hp'01]
%assign PT_EBX	 0
%assign PT_ECX	 1
%assign PT_EDX	 2
%assign PT_ESI	 3
%assign PT_EDI	 4
%assign PT_EBP	 5
%assign PT_EAX	 6
%assign PT_DS	 7
%assign PT_ES	 8
%assign PT_FS	 9
%assign PT_GS	10
%assign PT_ORIG_EAX 11
%assign PT_EIP	12
%assign PT_CS	13
%assign PT_EFL	14
%assign PT_UESP	15
%assign PT_SS	16

; neither one recognized, by that "nasm" thing...
%ifndef pt_regs_size
%ifndef pt_regs
%ifndef __AU__
%ifndef _pt_regs_
%define _pt_regs_
; this struct defines the way the registers are stored on the stack during a system call.
    struc pt_regs
.ebx:		LONG
.ecx:		LONG
.edx:		LONG
.esi:		LONG
.edi:		LONG
.ebp:		LONG
.eax:		LONG
.xds:		INT
.xes:		INT
.orig_eax:
.eip:		LONG
.xcs:		INT
.eflags:	LONG
.esp:		LONG
.xss:		INT
    endstruc
%endif
%endif
%endif
%endif

;;%ifdef __KERNEL__
;; user_mode(regs) ((VM_MASK & (regs)->eflags) || (3 & (regs)->xcs))
;%define user_mode(regs) ((VM_MASK&(regs+pt_regs.eflags)|(3&(regs+pt_regs.xcs))
;; instruction_pointer(regs) ((regs)->eip)
;%define instruction_pointer(regs) (regs+pt_regs.eip)
;;extern void show_regs(struct pt_regs *)
;%endif;__KERNEL__

%endif;_PTRACE_H
;-
;-
;-================================================================;
;- ptrace.h.inc <eof>
