;-================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file	: reloc.inc
;-  switch	: __RELOC_I
;-  created	: 18-jan-2000
;-  modified	: 30-aug-2000
;-  version	: 0.03
;-  assembler	: nasm 0.98
;-  description	: macros for relocatable & reentrant code
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	: unless stated all macroes case-sensitive
;-  source	: -/-
;-  requires	: scilab's patched nasm 0.98e
;-		:	ftp://ftp.linuxgames.com/crystal/nasm/
;-================================================================;
;-

;-
%ifndef __RELOC_I
%define __RELOC_I
%define relocinc
%ifndef _nolist
%define _nolist
%endif

;-

;-
;-	inl		compiles inline code
;-	sub		compiles a subroutine, takes a label
;-	imac		macro name case in-sensitve
;-	0-*	etc.,	macro w. arguments specification
;-
;-================================================================;
;-
;-

;-
;- GETGOT 0-1	%1=<reg> or ebx
;-	fetch relocatible elf code vari ref, by
;-	<ea wgot> independent of g.o.t got or not
;-	macro in-active and <wgot> empty if __NO_PIC defined.
;- =>	UN-SAFE - VERIFY!	<=
;- i:	%1 reg	dft <ebx>
;- o:	%1	ref addr
;- c:	%1
%macro GETGOT 0-1_nolist ebx
; -	- ;
%ifndef __NO_PIC__
    %ifdef __LINUX__
	extern _GLOBAL_OFFSET_TABLE_	; lx/11
    %elifdef __BSD__
	extern __GLOBAL_OFFSET_TABLE_	; bsd (?)
    %endif
    %ifid %00
%00:
    %endif
	call %%c
%%g:
	nop
%%c:
	pop %{1}
	add %{1},_GLOBAL_OFFSET_TABLE_+$$-%%g wrt ..gotpc
%endif;__PIC__
%endm
;-
;-;------------- das spielt ------------- ;
;-   mov dword [tbuf+80],VER<<16|EXT
;-;------------- das spielt ------------- ;
;-   get_GOT
;-   PRNUM ebp
;-; auf tbuf nur _ein_ d-posten angegeben
;-   PRNUM [ebp+tbuf wrt ..gotoff]
;-   mov dword [ebx+tbuf+24 wrt ..gotoff],0x99|EXT<<16
;-   PRNUM [ebp+tbuf+24 wrt ..gotoff]
;-;------------- reloc.inc -------------- ;
;-

;-
;- "lib4th" support
;-

;-
;- kernref 0-1	%1 := reg, inl
;-	dft ebx or, %1-reg to segment base reference <$$>. - (slow!)
%macro kernref 0-1_nolist ebx
; -	- ;
	call %%k
%%n:
	nop
%%k:
	pop %{1}
	lea %{1},[%{1}-%%n+$$]
%endm
;-
;- XN 2-*
;-	define (a list of) "extern"al labels, %1 determines which ones,
;-	or-ed together to accumulate for several labels types:
;-	%1 = 1	 %{2}:function    code entry
;-	   = 2  C%{2}:data	\ lib4th
;-	   = 4  I%{2}		 )wordheader
;-	   = 8  L%{2}:data	/ references
;-	   =16	define 'global', instead of 'extern'
;-	%undef __LIB4TH and %include "lib4words.inc" for all "lib4th" hi-level words
%macro XN 2-*_nolist
; -	- ;
%assign %%p (%1&1)
%assign %%c (%1&2)
%assign %%i (%1&4)
%assign %%l (%1&8)
%rotate 1
%if %{1}<16
%rep %{0}-1
%if %%p>0
	extern %{1}:function
%endif
%if %%c>0
	extern C%{1}:data
%endif
%if %%i>0
	extern I%{1}
%endif
%if %%l>0
	extern L%{1}:data
%endif
    %rotate 1
%endrep
%else
%rep %{0}-1
%if %%p>0
	global %{1}:function
%endif
%if %%c>0
	global C%{1}:data
%endif
%if %%i>0
	global I%{1}
%endif
%if %%l>0
	global L%{1}:data
%endif
    %rotate 1
%endrep
%endif
%endm
;-
;- label:GL
;-	define global label:function
%macro GL 0-*_nolist
	global %00:function
%00:
%endm
;-
;- label:A	0-*
;-	label:A
;-	initiate 4-aligned local to source .text <label>
;-	%1 may be another macro, for instance
;-		label:A M	(f8 macro and label)
;-		label:A N	(un-typed label)
;-		label:A <num>	4-aligned + <num> nops before <label:>
%macro A 0-*_nolist
; -	- ;
	align 4
%ifnum %{1}
	times %{1} nop
%00:
%else
    %if %0=1
    %00:%{1}
    %else
    %00:
    %endif
%endif
%endm
;-
;- label:GA	0-*
;-	label:GA		(label re global function)
;-	initiate 16-aligned globally accessible .text <label>
;-	%1 may be another macro, for instance:
;-		label:GA M	(f8 macro and label re global function)
;-		label:GA N	(un-typed global label)
%macro GA 0-*_nolist
; -	- ;
%ifdef galign
	align galign
%else
	align 16
%endif
%if %0>0
%00:%{1}
%else
	global %00:function
%00:
%endif
%xdefine f_%00 $-Y
%endm
;-
;- <label>:N 0-3, global label
;-	label:N
;-		generates	global {label}:data,N{label}:data
;-	label:N,length
;-		un-aligned	global N{label}:data
;-		4-aligned	global {label}:data
;-	label:N,length,<data>
;-		un-aligned	global N{label}:data
;-		4-aligned	global {label}:data (%2)
;-		%xdefine-s	_N_{label}
%macro N 0-3_nolist nodata
; -	- ;
	global N%00:data
N%00:
%if %{0}>1
	align 4
    %ifidn %{3},data
	global %00:data %{2}
%xdefine _N_%00
    %else
	global %00:data
    %endif
%else
	global %00:data
%endif
%00:
%endm
;-
;- label KV 0-*
;-	name of a kernel defined "value", noop macro for the docs
%macro KV 0-*.nolist
%endm
;-
;- callx symbol		macro 1
;-	call external subroutine
;-	declare external symbol, if not already done and __LIB4TH undefined(!)
;-	%xdefine-s a testable (nasm!) name "_X_%{1}"
%macro callx 1_nolist
; -	- ;
%ifndef __LIB4TH
%ifndef _X_%{1}
%xdefine _X_%{1}
	extern %{1}
%endif
%endif
	call %{1}
%endm
;-
;- jmpx symbol		macro 1
;-	jump into external subroutine
;-	declare external symbol, if not already done and __LIB4TH undefined(!)
;-	%xdefine-s a testable (nasm!) name "_X_%{1}"
%macro jmpx 1_nolist
; -	- ;
%ifndef __LIB4TH
%ifndef _X_%{1}
%xdefine _X_%{1}
	extern %{1}
%endif
%endif
	jmp %{1}
%endm

%endif ;__RELOC_I
;-
;-================================================================;
;- reloc.inc <eof>
