;-=========================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file  	: signal_h.inc
;-  switch	: _ASMi386_SIGNAL_H
;-  created	: 21-mar-2000
;-  modified	: 27-mai-2001
;-  version	: 0.03
;-  assembler	: nasm 0.98-3e
;-  description	: 
;-  author	: H-Peter Recktenwald, Berlin <lux@snafu.de>
;-  comment	: doc's are inconsistent, as well as sources! verify!
;-		: would be much easier if those GNU-ish "programmers"
;-		: could make their mind up and, synchronize w/ reality...
;-  source	: linux/include/asm/signal.h, linux/include/signal.c
;-  requires	: "asmutils" by K.Boldyshev, http://linuxassembly.org
;-=========================================================================;
;-
;-

%ifndef _ASMi386_SIGNAL_H
%define _ASMi386_SIGNAL_H
%define signalhinc
%define signal_hinc

;-
; Avoid too many header ordering problems.
;- syscalls acces is kernel mode
%ifndef __KERNEL__
%define __KERNEL__
%endif
%ifdef __KERNEL__
;-
;- Most things should be clean enough to redefine this at will, 
;- if care is taken to make libc match.
;-	_NSIG	_NSIG_BPW	_NSIG_WORDS
%define _NSIG		64
%define _NSIG_BPW	32
%define _NSIG_WORDS	(_NSIG/_NSIG_BPW)
;- These should not be considered constants from userland:
;-	SIGRTMIN	SIGRTMAX
%define SIGRTMIN	32
%define SIGRTMAX	(_NSIG-1)
;typedef unsigned long old_sigset_t;		; at least 32 bits ;
;typedef struct {
;	unsigned long sig[_NSIG_WORDS];
;} sigset_t;
%define old_sigeset_t	resd 1
%define sigset_t	resd _NSIG_WORDS
%else
; Here we must cater to libcs that poke about in kernel headers.  ;
;typedef unsigned long sigset_t;
%define NSIG		32
%define sigeset_t	resd 1
%endif ; __KERNEL__ ;
;-
;- linux signal number defn's
%define SIGHUP		 1	; " Hangup"
%define SIGINT		 2	; " Interrupt"
%define SIGQUIT		 3	; " Quit"
%define SIGILL		 4	; " Illegal instruction"
%define SIGTRAP		 5	; " Trace/breakpoint trap"
%define SIGABRT		 6	; " Aborted"		- program termination if signal hnd returns
%define SIGIOT		 6	; " Terminal Interrupt" -???- SIGINT
%define SIGBUS		 7	; " Bus error"
%define SIGFPE		 8	; " Floating point exception" -> 'arithmetic fault' meets the condition, better
%define SIGKILL		 9	; " Killed"
%define SIGUSR1		10	; " User defined signal 1"
%define SIGSEGV		11	; " Segmentation fault"
%define SIGUSR2		12	; " User defined signal 2"
%define SIGPIPE		13	; " Broken pipe"
%define SIGALRM		14	; " Alarm clock"
%define SIGTERM		15	; " Terminated"
%define SIGSTKFLT	16	; " Stack fault"
%define SIGCHLD		17	; " Child exited"
%define SIGCONT		18	; " Continued"			; re-start
%define SIGSTOP		19	; " Stopped (signal)"
%define SIGTSTP		20	; " Stopped"			; halt scheduling
%define SIGTTIN		21	; " Stopped (tty input)"
%define SIGTTOU		22	; " Stopped (tty output)"
%define SIGURG		23	; " Urgent I/O condition"
%define SIGXCPU		24	; " CPU time limit exceeded"
%define SIGXFSZ		25	; " File size limit exceeded"
%define SIGVTALRM	26	; " Virtual timer expired"
%define SIGPROF		27	; " Profiling timer expired"
%define SIGWINCH	28	; " Window changed"
%define SIGIO		29	; " I/O possible"
%define SIGPOLL		SIGIO
%define SIGLOST		29	; " Resource lost"
%define SIGPWR		30	; " Power failure"
%define	SIGUNUSED	31						

%if 0	; only in glibc6
%define	SIGEMT		29	; " EMT trap"
%define	SIGSYS		30	; " Bad system call"
%define	SIGINFO		32	; " Information request"
%endif
%if 0	; glibc6 signals, (mostly) same but, different numbers
%define	SIGHUP		1	;"HUP",  	N_("Hangup"))
%define	SIGINT		2	;"INT",  	N_("Interrupt"))
%define	SIGQUIT		3	;"QUIT", 	N_("Quit"))
%define	SIGILL		4	;"ILL",  	N_("Illegal instruction"))
%define	SIGTRAP		5	;"TRAP", 	N_("Trace/breakpoint trap"))
%define	SIGABRT		6	;"ABRT", 	N_("Aborted"))
%define	SIGFPE		7	;"FPE",  	N_("Floating point exception"))
%define	SIGKILL		8	;"KILL", 	N_("Killed"))
%define	SIGBUS		9	;"BUS",  	N_("Bus error"))
%define	SIGSEGV		10	;"SEGV", 	N_("Segmentation fault"))
%define	SIGPIPE		11	;"PIPE", 	N_("Broken pipe"))
%define	SIGALRM		12	;"ALRM", 	N_("Alarm clock"))
%define	SIGTERM		13	;"TERM", 	N_("Terminated"))
%define	SIGURG		14	;"URG",  	N_("Urgent I/O condition"))
%define	SIGSTOP		15	;"STOP", 	N_("Stopped (signal)"))
%define	SIGTSTP		16	;"TSTP", 	N_("Stopped"))
%define	SIGCONT		17	;"CONT", 	N_("Continued"))
%define	SIGCHLD		18	;"CHLD", 	N_("Child exited"))
%define	SIGTTIN		19	;"TTIN", 	N_("Stopped (tty input)"))
%define	SIGTTOU		20	;"TTOU", 	N_("Stopped (tty output)"))
%define	SIGIO		21	;"IO",   	N_("I/O possible"))
%define	SIGXCPU		22	;"XCPU", 	N_("CPU time limit exceeded"))
%define	SIGXFSZ		23	;"XFSZ", 	N_("File size limit exceeded"))
%define	SIGVTALRM	24	;"VTALRM",	N_("Virtual timer expired"))
%define	SIGPROF		25	;"PROF", 	N_("Profiling timer expired"))
%define	SIGWINCH	26	;"WINCH",	N_("Window changed"))
%define	SIGUSR1		27	;"USR1", 	N_("User defined signal 1"))
%define	SIGUSR2		28	;"USR2", 	N_("User defined signal 2"))
%define	SIGEMT		29	;"EMT",  	N_("EMT trap"))
%define	SIGSYS		30	;"SYS",  	N_("Bad system call"))
%define	SIGSTKFLT	31	;"STKFLT",	N_("Stack fault"))
%define	SIGINFO		32	;"INFO", 	N_("Information request"))
%define	SIGPWR		33	;"PWR",  	N_("Power failure"))
%define	SIGLOST		34	;"LOST",  	N_("Resource lost"))           
%endif

;-
;- SA_FLAGS values (re "Single Unix" doc's by Open Group; man 2, "sigaction"):
;-	SA_ONSTACK
;-		indicates that a registered stack_t will be used.
;-	SA_INTERRUPT
;-		is a no-op, but left due to historical reasons. Use the
;-	SA_RESTART
;-		flag to get restarting signals (which were the default long ago)
;-	SA_NOCLDSTOP
;-		flag to turn off SIGCHLD when children stop.
;-	SA_RESETHAND
;-		clears the handler when the signal is delivered.
;-	SA_NOCLDWAIT
;-		flag on SIGCHLD to inhibit zombies.
;-	SA_NODEFER
;-		prevents the current signal from being masked in the handler.
;-
;- SA_ONESHOT and SA_NOMASK are the historical Linux names for
;- the Single Unix names RESETHAND and NODEFER respectively.
;- 	In contrary to man 2 page documentation, the sys_sigaction call does 
;- 	NOT default to ANY setting, i.e. SA_ONESHOT isn't "default behaviour", 
;-	i.e. SA_FLAGS bits is under full control of the programmer!
%define SA_NOCLDSTOP	0x00000001
%define SA_NOCLDWAIT	0x00000002 ; not supported yet ;
%define SA_SIGINFO	0x00000004
%define SA_ONSTACK	0x08000000
%define SA_RESTART	0x10000000
%define SA_NODEFER	0x40000000
%define SA_RESETHAND	0x80000000

%define SA_NOMASK	SA_NODEFER
%define SA_ONESHOT	SA_RESETHAND
%define SA_INTERRUPT	0x20000000 ; dummy -- ignored ;

%define SA_RESTORER	0x04000000

; sigaltstack controls
%define SS_ONSTACK	1
%define SS_DISABLE	2

%define MINSIGSTKSZ	2048
%define SIGSTKSZ	8192

;-
;- These values of sa_flags are used only by the kernel as part of the
;- irq handling routines.
;-
;- SA_INTERRUPT is also used by the irq handling routines.
;- SA_SHIRQ is for shared interrupt support on PCI and EISA.
%define SA_PROBE		SA_ONESHOT
%define SA_SAMPLE_RANDOM	SA_RESTART
%define SA_SHIRQ		0x04000000

%define SIG_BLOCK          0	; for blocking signals ;
%define SIG_UNBLOCK        1	; for unblocking signals ;
%define SIG_SETMASK        2	; for setting the signal mask ;

%endif ; _ASMi386_SIGNAL_H
;-
;-=========================================================================;
;- signal_h.inc <eof>
