;-=========================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file  	: stat.h.inc
;-  switch	: _I386_STAT_H, stathinc, _LINUX_STAT_H, linuxstathinc
;-  created	: 25-Aug-2000
;-  modified	: 06-Mai-2001
;-  version	: 0.02
;-  assembler	: nasm 0.98-3e+
;-  description	: file/device status, mknod, i_mode data & struc.
;-  author	: H-Peter Recktenwald, Berlin <lux@snafu.de>
;-  comment	: 
;-  source	: include/asm/stat.h; include/linux/stat.h, sysv_fs.h
;-  requires	: "asmutils" by K.Boldyshev, http://linuxassembly.org
;-=========================================================================;
;-
;-
%ifndef _I386_STAT_H
%define _I386_STAT_H
%define stathinc

%ifnid __old_kernel_stat
 struc __old_kernel_stat
.st_dev:	SHORT 1 
.st_ino:	SHORT 1 
.st_mode:	SHORT 1 
.st_nlink:	SHORT 1 
.st_uid:	SHORT 1 
.st_gid:	SHORT 1 
.st_rdev:	SHORT 1 
.st_size:	LONG  1 
.st_atime:	LONG  1 
.st_mtime:	LONG  1 
.st_ctime:	LONG  1 
 endstruc
%endif

;;%if __AU__<16
;;%ifnid stat
 struc stat
.st_dev:	SHORT 1
.__pad1:	SHORT 1
.st_ino:	LONG  1
.st_mode:	SHORT 1
.st_nlink:	SHORT 1
.st_uid:	SHORT 1
.st_gid:	SHORT 1
.st_rdev:	SHORT 1
.__pad2:	SHORT 1
.st_size:	LONG  1
.st_blksize:	LONG  1
.st_blocks:	LONG  1
.st_atime:	LONG  1
.__unused1:	LONG  1
.st_mtime:	LONG  1
.__unused2:	LONG  1
.st_ctime:	LONG  1
.__unused3:	LONG  1
.__unused4:	LONG  1
.__unused5:	LONG  1
 endstruc
;;%endif
;;%else
;;%define stat Stat
;;%endif
%ifndef _LINUX_STAT_H
%define _LINUX_STAT_H
%define linuxstathinc

; mknod mode_t flags, linux/stat.h, 
%define S_IFMT		0170000q	; mask for type
%define S_IFSOCK	0140000q	;
%define S_IFLNK		0120000q	; symbolic link (SysV)
;
%define S_IFREG		0100000q	; regular file
%define S_IFBLK		0060000q	; block device
%define S_IFDIR		0040000q	; directory
%define S_IFCHR		0020000q	; character device
%define S_IFIFO		0010000q	; named pipe
%define S_ISUID		0004000q	; set user id
%define S_ISGID		0002000q	; set group id
%define S_ISVTX		0001000q	; save swapped text even after use
;	'user' permisssion bits
%define S_IRWXU		0000700q
%define S_IRUSR		0000400q
%define S_IWUSR		0000200q
%define S_IXUSR		0000100q
;	'group' permisssion bits
%define S_IRWXG		0000070q
%define S_IRGRP		0000040q
%define S_IWGRP		0000020q
%define S_IXGRP		0000010q
;	'other' permisssion bits
%define S_IRWXO		0000007q
%define S_IROTH		0000004q
%define S_IWOTH		0000002q
%define S_IXOTH		0000001q
;
%define S_IFMPB		0070000q	; ?? multiplexed block device (Coherent)
%define S_IFNAM		0050000q	; ?? XENIX special named file (SysV)
%define S_IFMPC		0030000q	; ?? multiplexed character device (Coherent)
; -- ;
%define S_ISLNK(m)	(((m) & S_IFMT) == S_IFLNK)
%define S_ISREG(m)	(((m) & S_IFMT) == S_IFREG)
%define S_ISDIR(m)	(((m) & S_IFMT) == S_IFDIR)
%define S_ISCHR(m)	(((m) & S_IFMT) == S_IFCHR)
%define S_ISBLK(m)	(((m) & S_IFMT) == S_IFBLK)
%define S_ISFIFO(m)	(((m) & S_IFMT) == S_IFIFO)
%define S_ISSOCK(m)	(((m) & S_IFMT) == S_IFSOCK)

%define S_IRWXUGO	(S_IRWXU|S_IRWXG|S_IRWXO)
%define S_IALLUGO	(S_ISUID|S_ISGID|S_ISVTX|S_IRWXUGO)
%define S_IRUGO		(S_IRUSR|S_IRGRP|S_IROTH)
%define S_IWUGO		(S_IWUSR|S_IWGRP|S_IWOTH)
%define S_IXUGO		(S_IXUSR|S_IXGRP|S_IXOTH)

; linux/sysv_fs.h:
;"The admissible values for i_mode are listed in <linux/stat.h>
; Since Coherent doesn't know about symbolic links, we use a kludgey
; implementation of symbolic links: i_mode = COH_KLUDGE_SYMLINK_MODE
; denotes a symbolic link. When a regular file should get this mode by
; accident, it is automatically converted to COH_KLUDGE_NOT_SYMLINK.
; We use S_IFREG because only regular files (and Coherent pipes...) can have
; data blocks with arbitrary contents associated with them, and S_ISVTX
; ("save swapped text after use") because it is unused on both Linux and
; Coherent: Linux does much more intelligent paging, and Coherent hasn't
; virtual memory at all. Same trick for Xenix.
%define COH_KLUDGE_SYMLINK_MODE	(S_IFREG|S_ISVTX)
%define COH_KLUDGE_NOT_SYMLINK	(S_IFREG|S_ISVTX|S_IRUSR)

%endif
%endif
;-
;-=========================================================================;
;- stat.h.inc <eof>
