;[nolist]
;-=================================================j===============;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file  	: sysdep.inc
;-  switch	: __SYSDEP_INC
;-  created	: 07-apr-01
;-  modified	:
;-  version	; 0.5.02+6
;-  assembler	: nasm 0.98-3e-20
;-  description	: host specific system constants
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	: PAGE_SIZE, CLONE-flags
;-  source	: Linux kernel (2.2.14, 2.4.2)
;-================================================================;
;-
;-
%ifndef __SYSDEP_INC
%define __SYSDEP_INC
%define sysdepinc

%ifndef _nolist
%define _nolist
%endif

;-
;-================================================================;
;- kernel
;-

;-
;- PAGE_SHIFT, PAGE_SIZE, PAGE_MASK
;-	check for currently valid data: /usr/include/asm/page.h
%assign PAGE_SHIFT 12
%assign PAGE_SIZE (1<<PAGE_SHIFT)
%assign PAGE_MASK (-PAGE_SIZE)
;- pg(x)	for page size adjustment, takes (x)K bytes
%define pg(x) (((x)*1024+PAGE_SIZE-1)&PAGE_MASK)
;-


;-
;-================================================================;
;- jobs
;-

;-
;- flags to sys_clone, re linux/inlude/linux/sched.h
;-	CSIGNAL		signal mask to be sent at exit
%define CSIGNAL		0x000000ff
;-	CLONE_VM	set if VM shared between processes
%define CLONE_VM	0x00000100
;-	CLONE_FS	set if fs info shared between processes
%define CLONE_FS	0x00000200
;-	CLONE_FILES	set if open files shared between processes
%define CLONE_FILES	0x00000400
;-	CLONE_SIGHAND	set if signal handlers shared
%define CLONE_SIGHAND	0x00000800
;-	CLONE_PID	set if pid shared, - CLONE_PID not permitted for root (and others?)
%define CLONE_PID	0x00001000
;-	CLONE_PTRACE	set if we want to let tracing continue on the child, too
%define CLONE_PTRACE	0x00002000
;-	CLONE_VFORK	set if the parent wants the child to wake it up on mm_release
%define CLONE_VFORK	0x00004000
;%define HZ		100		; linux/asm/param.h
;-

;-
;- clonflags
;-	flags to macro CLON4TH: CLONE_VM|CLONE_FS|CLONE_FILES|CLONE_PTRACE
%assign clonflags CLONE_VM|CLONE_FS|CLONE_FILES|CLONE_PTRACE
;-	other possible flags re above, flags to sys_clone..
;-
;-

;-
;-
;================================================================
;
%endif;__SYSDEP_INC
;-
;- (*) mode-7: 'safety fast'
;-================================================================
;- sysdep.inc <eof>
