;-=========================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file  	: sysexits.h.inc
;-  switch	: _SYSEXITS_H
;-  created	: 25-aug-2000
;-  modified	: 
;-  version	: 0.01
;-  assembler	: nasm 0.98-3e
;-  description	: system programs' exit codes
;-  author	: H-Peter Recktenwald, Berlin <lux@snafu.de>
;-  comment	: 
;-  source	: /usr/local/include/sysexits.h
;-  requires	: "asmutils" by K.Boldyshev, http://linuxassembly.org
;-=========================================================================;
;-
;-

%ifndef	_SYSEXITS_H
%define	_SYSEXITS_H

%define EX_OK		0	; successful termination */

%define EX__BASE	64	; base value for error messages */

%define EX_USAGE	64	; command line usage error */
%define EX_DATAERR	65	; data format error */
%define EX_NOINPUT	66	; cannot open input */
%define EX_NOUSER	67	; addressee unknown */
%define EX_NOHOST	68	; host name unknown */
%define EX_UNAVAILABLE	69	; service unavailable */
%define EX_SOFTWARE	70	; internal software error */
%define EX_OSERR	71	; system error (e.g., can't fork) */
%define EX_OSFILE	72	; critical OS file missing */
%define EX_CANTCREAT	73	; can't create (user) output file */
%define EX_IOERR	74	; input/output error */
%define EX_TEMPFAIL	75	; temp failure; user is invited to retry */
%define EX_PROTOCOL	76	; remote error in protocol */
%define EX_NOPERM	77	; permission denied */
%define EX_CONFIG	78	; configuration error */

%define EX__MAX	78		; maximum listed value */

%endif ; sysexits.h
;-
;-=========================================================================;
;- sysexits.h.inc <eof>
