;-================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file  	: termbits.inc
;-  switch	: __ARCH_I386_TERMBITS_H__
;-  created	: 15-jan-2000
;-  modified	: 27-mai-2000
;-  version	: 0.03
;-  assembler	: nasm 0.98-3e
;-  description	: definitions for linux console/terminal control
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	: -/-
;-  source	: linux 2.2.14, arch/i386/term{io,bit}s.h
;-  requires	: -/-
;-================================================================;
;-

%ifndef __ARCH_I386_TERMBITS_H__
%define __ARCH_I386_TERMBITS_H__
%define termbitsinc

;-
;- TCSETS, TCGETS
;-	tty related ioctl descriptors
%define TCGETS		0x5401 ; tty-"magic"
%define TCSETS		0x5402
; %define TCSANOW		0x5400 ; oder nur 0 oder hier nicht mglich?
; %define TCSANOW		000 ; oder nur 0 oder hier nicht mglich?

%define	cc_t		resb 	; unsigned char CHAR
%define	speed_t		resd 1	; unsigned long INT
%define	tcflag_t	resd 1	; unsigned long INT

;-
;- NCCS
;-	no. of ctrl-s in termios, kernel 2.2.14
;-	re kernel source for version dep'd value!
%define NCCS 19

;-
;- struc termios, termio
;-	terminal control structures
;-	from linux/include/asm/termbits.h:
%ifnid termios
    struc termios
	alignb 4
.c_iflag:	tcflag_t	; input mode flags
.c_oflag:	tcflag_t	; output mode flags
.c_cflag:	tcflag_t	; control mode flags
.c_lflag:	tcflag_t	; local mode flags
.c_line:	cc_t 1		; line discipline
.c_cc:		cc_t NCCS	; control characters
    endstruc
%endif
;- 	from linux/include/asm/termios.h:
%ifnid termio
    struc termio
	alignb 4
.c_iflag:	tcflag_t	; input mode flags
.c_oflag:	tcflag_t	; output mode flags
.c_cflag:	tcflag_t	; control mode flags
.c_lflag:	tcflag_t	; local mode flags
.c_line:	cc_t 1		; line discipline
.c_cc:		cc_t NCCS	; control characters
    endstruc
%endif
;-
;- c_cc character posn's - commments from the mips defn
;-	VINTR	VQUIT	VERASE	VKILL	VEOF	VTIME	VMIN	VSWTC	VSTART	
;-	VSTOP	VSUSP	VEOL	VREPRINT VDISCARD VWERASE	VLNEXT	VEOL2	
%define VINTR	0		; Interrupt character [ISIG].
%define VQUIT	1		; Quit character [ISIG].
%define VERASE	2		; Erase character [ICANON].
%define VKILL	3		; Kill-line character [ICANON].
%define VEOF	4		; End-of-file character [ICANON]. (m:16)
%define VTIME	5		;.Time-out value (tenths of a second) [!ICANON].
%define VMIN	6		;.Minimum number of bytes read at once [!ICANON]. (m:4)
%define VSWTC	7		; ???(console switch)???
%define VSTART	8		; Start (X-ON) character [IXON, IXOFF].
%define VSTOP	9		; Stop (X-OFF) character [IXON, IXOFF].
%define VSUSP	10		; Suspend character [ISIG]
%define VEOL	11		; End-of-line character [ICANON]. (m:17)
%define VREPRINT 12		; Reprint-line character [ICANON].
%define VDISCARD 13		; Discard character [IEXTEN].
%define VWERASE	14		; Word-erase character [ICANON].
%define VLNEXT	15		; Literal-next character [IEXTEN].
%define VEOL2	16		; Second EOL character [ICANON]. (m:6)
;- defaults, from linux/include/asm-i386/termios.h:
;-	intr=^C		quit=^\		erase=del	kill=^U
;-	eof=^D		vtime=\0	vmin=\1		sxtc=\0
;-	start=^Q	stop=^S		susp=^Z		eol=\0
;-	reprint=^R	discard=^U	werase=^W	lnext=^V
;-	eol2=\0
%define CC_VINTR	3
%define CC_VQUIT	034q
%define CC_VERASE	177q
%define CC_VKILL	025q
%define CC_VEOF		4
%define CC_VTIME	0
%define CC_VMIN		1
%define CC_VSWTC	0
%define CC_VSTART	021q
%define CC_VSTOP	023q
%define CC_VSUSP	032q
%define CC_VEOL		0
%define CC_VREPRINT	022q
%define CC_VDISCARD	017q
%define CC_VWERASE	027q
%define CC_VLNEXT	026q
%define CC_VEOL2	0

%define INIT_C_CC 3,034q,177q,025q,4,0,1,0,021q,023q,032q,0,022q,017q,027q,026q,0

%ifnid cc_termio
    struc cc_termio
.VINTR:		resb 1
.VQUIT:		resb 1
.VERASE:	resb 1	
.VKILL:		resb 1
.VEOF:		resb 1
.VTIME:		resb 1
.VMIN:		resb 1
.VSWTC:		resb 1
.VSTART:	resb 1	
.VSTOP:		resb 1
.VSUSP:		resb 1
.VEOL:		resb 1
.VREPRINT:	resb 1
.VDISCARD:	resb 1
.VWERASE:	resb 1	
.VLNEXT:	resb 1
.VEOL2:		resb 1
		resb NCCS-($-.VINTR)
    endstruc
%endif
;- c_iflag bits
;-	IGNBRK	BRKINT	IGNPAR	PARMRK	INPCK	ISTRIP	
;-	INLCR	IGNCR	ICRNL	IUCLC	IXON	IXANY	IXOFF	IMAXBEL	
%define IGNBRK	0000001q	; Ignore break condition.
%define BRKINT	0000002q	; Signal interrupt on break.
%define IGNPAR	0000004q	; Ignore characters with parity errors.
%define PARMRK	0000010q	; Mark parity and framing errors.
%define INPCK	0000020q	;.Enable input parity check.
%define ISTRIP	0000040q	;.Strip 8th bit off characters.
%define INLCR	0000100q	; Map NL to CR on input.
%define IGNCR	0000200q	; Ignore CR.
%define ICRNL	0000400q	; Map CR to NL on input.
%define IUCLC	0001000q	; Map upper case to lower case on input. (bsd|kernel)
%define IXON	0002000q	;.Enable start/stop output control.
%define IXANY	0004000q	; Any character will restart after stop. (bsd|kernel)
%define IXOFF	0010000q	; Enable start/stop input control.
%define IMAXBEL	0020000q	; Ring bell when input queue is full. (bsd|kernel)

;- c_oflag bits, and attributes
;-	OPOST	OLCUC	ONLCR	OCRNL	ONOCR	ONLRET	
;-	OFILL	OFDEL	NLDLY	CRDLY	TABDLY	BSDLY	VTDLY	FFDLY	
%define OPOST	0000001q	;.Perform output processing.
%define OLCUC	0000002q	; Map lower case to upper case on output.
%define ONLCR	0000004q	;.Map NL to CR-NL on output.
%define OCRNL	0000010q
%define ONOCR	0000020q
%define ONLRET	0000040q
%define OFILL	0000100q
%define OFDEL	0000200q
%define NLDLY	0000400q
%define   NL0	0000000q
%define   NL1	0000400q
%define CRDLY	0003000q
%define   CR0	0000000q
%define   CR1	0001000q
%define   CR2	0002000q
%define   CR3	0003000q
%define TABDLY	0014000q
%define   TAB0	0000000q
%define   TAB1	0004000q
%define   TAB2	0010000q
%define   TAB3	0014000q
%define   XTABS	0014000q
%define BSDLY	0020000q
%define   BS0	0000000q
%define   BS1	0020000q
%define VTDLY	0040000q
%define   VT0	0000000q
%define   VT1	0040000q
%define FFDLY	0100000q
%define   FF0	0000000q
%define   FF1	0100000q

;- c_cflag bit meaning, and attributes
;-	CBAUD	EXTA	EXTB	CSIZE	CSTOPB	CREAD	PARENB
;-	PARODD	HUPCL	CLOCAL	CBAUDEX	CIBAUD	CRTSCTS	CMSPAR
%define CBAUD	0010017q
%define  B0	0000000q	; hang up
%define  B50	0000001q
%define  B75	0000002q
%define  B110	0000003q
%define  B134	0000004q
%define  B150	0000005q
%define  B200	0000006q
%define  B300	0000007q
%define  B600	0000010q
%define  B1200	0000011q
%define  B1800	0000012q
%define  B2400	0000013q
%define  B4800	0000014q
%define  B9600	0000015q
%define  B19200	0000016q
%define  B38400	0000017q
%define EXTA	B19200q
%define EXTB	B38400q
%define CSIZE	0000060q	; Number of bits per byte (mask).
%define   CS5	0000000q	; 5 bits per byte. .. etc
%define   CS6	0000020q
%define   CS7	0000040q
%define   CS8	0000060q
%define CSTOPB	0000100q	; Two stop bits instead of one.
%define CREAD	0000200q	; Enable receiver.
%define PARENB	0000400q	; Parity enable.
%define PARODD	0001000q	; Odd parity instead of even.
%define HUPCL	0002000q	; Hang up on last close.
%define CLOCAL	0004000q	; Ignore modem status lines.
%define CBAUDEX 0010000q
%define  B57600  0010001q
%define  B115200 0010002q
%define  B230400 0010003q
%define  B460800 0010004q
%define CIBAUD	002003600000q	; input baud rate (not used)
%define CRTSCTS	020000000000q	; flow control
%define CMSPAR  010000000000q	; mark or space (stick) parity ! MIPS only (?) !

;- c_lflag bits
;-	ISIG	ICANON	XCASE	ECHO	ECHOE	ECHOK	ECHONL	NOFLSH	
;-	TOSTOP	ECHOCTL	ECHOPRT	ECHOKE	FLUSHO	PENDIN	IEXTEN	
%define ISIG	0000001q	;.Enable signals.
%define ICANON	0000002q	;.Do erase and kill processing.
%define XCASE	0000004q
%define ECHO	0000010q	;.Enable echo.
%define ECHOE	0000020q	; Visual erase for ERASE.
%define ECHOK	0000040q	; Echo NL after KILL.
%define ECHONL	0000100q	; Echo NL even if ECHO is off.
%define NOFLSH	0000200q	; Disable flush after interrupt.
%define TOSTOP	0000400q	; Send SIGTTOU for background output.
%define ECHOCTL	0001000q	; Echo control characters as ^X.
%define ECHOPRT	0002000q	; Hardcopy visual erase.
%define ECHOKE	0004000q	; Visual erase for KILL.
%define FLUSHO	0010000q	;
%define PENDIN	0040000q	; Retype pending input (state).
%define IEXTEN	0100000q	; Enable DISCARD and LNEXT.

;-
;- tcflow() and TCXONC modes
;-	TCOOFF	TCOON	TCIOFF	TCION	
%define	TCOOFF		0	; Suspend output.
%define	TCOON		1	; Restart suspended output.
%define	TCIOFF		2	; Send a STOP character.
%define	TCION		3	; Send a START character.
;- tcflush() and TCFLSH modes
;-	TCIFLUSH	TCOFLUSH	TCIOFLUSH	
%define	TCIFLUSH	0	; Discard data received but not yet read.
%define	TCOFLUSH	1	; Discard data written but not yet sent.
%define	TCIOFLUSH	2	; Discard all pending data.
;- tcsetattr modes
;-	TCSANOW		TCSADRAIN	TCSAFLUSH	
%define	TCSANOW		0	;.Change immediately.
%define	TCSADRAIN	1	; Change when pending output is written.
%define	TCSAFLUSH	2	; Flush pending input before changing.
; ioctl equivalents from mips/termbits.h
%define	mTCSANOW	TCSETS
%define	mTCSADRAIN	TCSETSW
%define	mTCSAFLUSH	TCSETSF

; ioctl (fd, TIOCSERGETLSR, &result)
; %define mTIOCSER_TEMT    0x01	; Transmitter physically empty

%endif ;__ARCH_I386_TERMBITS_H__
;-
;- termbits.inc <eof>
