;-================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read LICENSE file for full copyright information (GNU GPL)
;-
;-  file  	: f8.asm
;-  created	: 18-jul-00
;-  modified	:
;-  version	; 0.01, "lib4th" 0.0.34+ (re "version.inc")
%include "version.inc"
;-  assembler	: nasm 0.98-3e (patched & bugs fixed 0.98)
;-  description	: stand-alone commandline upn calculator,
;-		: i/o by stdin,stdout,stderr; no libraries
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	: "f8", in fact is a minimal forth system
;-		: - and one more preliminary study for F8/QOX.
;-  source	: (me, and ansi)
;-  requires	: running:
;-		:	no prerequisites other than those
;-		:	implied by the program concerned
;-		: programming:
;-		:	knowledge of "lib4th" glossary, and 4th!
;-		: kernel programming:
;-		: 	thorough knowledge of assembly & forth,
;-		:	currently programming with "lib4th" is
;-		:	greatly simplified assembly programming
;-		:	mainly by Forth based subroutines, re
;-		:	<typetest> example, below, others in lib.
;-		: compiling prerequisites:
;-		:	asmutils 0.11+, nasm-0.98-3e (0.98e)
;-  switches	:
;-		: for proper section alignment assemble only with
;-		: 	-D__OPTIMIZE__=__O_SPEED__
;-		: for conditional assembly (yet unused) define:
;- 		: 	-D__F8
;-		: those switches cannot be effectively %define-d
;-		: in assembly source but should be set in Makefile
;-================================================================;
;-

%define __DBG	; enable debugging macroes & subroutines, further, 
;		; __MK_DBG required set for those being activated
%define __MK_DBG; which adds about 1,3K to the binary
%undef __DBG
%undef __MK_DBG
%undef __LIB4TH; this mustn't be defined unless in library source!
;%define __startgot_omit
;-
;-
; ------------- ;
%ifndef l4l4inc
%define l4l4inc
%include "l4-lib4th.inc"
%endif

%ifndef __MK_DBG
%undef __DBG
%endif
;

;[list]
;-================================================================
;-
	section .text
;- section .text	; kernel code & constant data
;-
;[nolist]		; extends the binary by about 130K!
X:
;
;-================================================================
;- debugging
;-

%ifdef __DBG
;- dbg		beginning of debugging routines
dbg:
;[list -];[ nolist]
	mdump
	perrm
	perrs
	perrn
	dbmrg
%define __DBCONS
	dbcons
	pbits	; flagbits/binary
	psbits	; eflags symbols
%else
%macro DUMP 0-*.nolist
%endm
%macro PFSYM 0-*.nolist
%endm
%macro PRNUM 0-*.nolist
%endm
%macro PRSTG 0-*.nolist
%endm
%macro PRTXT 0-*.nolist
%endm
%macro L4PN 0-*.nolist
%endm
%endif;__DBG

; ================================================================

;not required (300 bytes):
;    extern Vroot,Croot,Lroot,roottop,toplink,topref,vocref
;    extern Vforth,Cforth,Lforth

;-
;- debugging routines end
;-================================================================
;-

;-
; text constants
;-
;-================================================================
;- (ref's to) signals constants and error messages, jumptables
;- by macros <ertstg>, <ertdsp>, <sigstg>, <sigdsp>
;-
	a
;[list -];[ nolist]
	ertstg 1	; compiles just the 'extern' refs, valid also for <ertdsp>
	a
;[list -];[ nolist]
	ertdsp
	a
;[list -];[ nolist]
	sigstg 1	; compiles just the 'extern' refs, valid also for <sigdsp>
	a
;[list -];[ nolist]
	sigdsp
[list]
;-
;-================================================================
;- execution entry
;-
START4TH 0,0,f8i4th,{10,"'lib4th-",.vers,"' Test Program #2.2"}
iniquit:A
	jmpx quit
	global main
main:equ _start
;-
;- zero in <START4TH> or, optional structure w. initial memory setup and entry:
f8i4th:	i4th_ntry 0,Z

	a
	dd E-Z,Z-X,E-X	; text till end, prog till end, till text beginning
Z:
	db '." f8.asm - end of code after end of this text" cr'
	db ' (bootp) @ abs>4th 4+ @ dup u. abs>4th dup u. cr',0
E:
;-
;-================================================================
;- end of program area
;-	initated data and (local) .bss may follow
;-
;-================================================================
;- f8.asm <eof>
