;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-=====================================================================;
;-  file  	: l4constants.inc
;-  created	: 12-sep-01
;-  modified	: -> re "version.inc"
;-  version	: 0.01(+)
;-  switches	: __CONSTANTS_I
;-  assembler	: nasm 0.98-3e (patched & bugs fixed 0.98)
;-  description	: 4th kernel constants
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  source	: (me, hp)
;-  requires	: the "lib4th" package
;-=====================================================================;
;-
;-	
%ifndef __CONSTANTS_I
%define __CONSTANTS_I
%define constantsinc
;-
;-================================================================
;- -- constants
;-

;-
;- -1.		( -- dn )					'dmone'		forth
;-	double cons -1
dmone:GA;:ok:
	spush
	mov eax,-1
;-
;- true		( -- tf )			(e)(m,6)			forth
;-	leave cell value with all bits set (-1)
true:GA M;:ok:
	spush
	mov eax,-1
M true
	ret
	global mone:function
mone:equ true
;-
;- 0.		( -- dn )			(m,4)		'dzero'		forth
;-	double cons 0
dzero:GA M;:ok:
	spush
	xor eax,eax
	spush
M dzero
	ret
;-
;- mem		( -- n )			(m,3)		'zero'		forth
;-	flag for bit opr's, test cell in memory (single cons 0)
zero:GA M;:ok:
	spush
	xor eax,eax
M zero
	ret
;- false   	( -- ff )			(e)(m,3)	'zero'		forth
;-	cell value with all bits un-set (0)
	global false:function
false:equ zero
;-
;- true		( -- tf )			(m,6)		'pone'		fig
;-	f.i.g. true flag = 1 (+ve!)
pone:GA M;:ok:
	spush
	mov eax,1
M pone
	ret
;-
;- cell   	( -- n1 )			(a:c)		'pfour'		forth
;-	no. of bytes per cell (4)
pfour:GA M;:ok:
	spush
	mov eax,4
M pfour
	ret
;-
;- -0.		( -- dn )			(f6)		'dmzero'	forth
;-	double cons -0 (zero with sign bit set)
dmzero:GA;:ok:
	spush
	xor eax,eax
;-
;- -0		( -- n1 )			(f6)(m,6)	'mzero'		forth
;-	single cons -0 (zero with sign bit set)
mzero:GA M;:ok:
	spush
	mov eax,0x80000000
M mzero
	ret
;-
;- #vocs  	( -- n )			(f6)		'nvocs'		forth
;-	cons, number of vocabulary ptrs in voc-stack, 
;-	on top of two items volatile stack of context, ocontext.
;-	push by {also} is to lower addresses, two cells each.
nvocs:GA;:ok:
	spush
	mov eax,d_nvocs
	cnvocs:equ $-4
	ret
;-
;- (hichar)	( -- p )					'phicharp'	hidden
;-	dft lower to upper case mapping character table
phicharp:GA;:ok:
	spush
	mov eax,thichar-Y
	ret
;-
;- (lochar)	( -- p )					'plocharp'	hidden
;-	dft upper to lower case mapping character table
plocharp:GA;:ok:
	spush
	mov eax,tlochar-Y
	ret
;-
;- 4th>abs	( p -- address )		(m)		'fth2abs'	forth
;-	convert forth ptr to true (virtual) address
fth2abs:GA M;:ok:
	lea eax,[kref eax];(for alignment, until {getenv} inclusive)
M fth2abs
	ret
;-
;- abs>4th	( address -- a )		(m)		'abs2fth'	forth
;-	convert true (virtual) address to forth ptr
abs2fth:GA M;:ok:
	sub eax,KR
M abs2fth
	ret
%endif;__CONSTANTS_I
;-
;-=====================================================================;
;- l4constants.inc <eof>
