;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-=====================================================================;
;-  file  	: l4debug.inc
;-  created	: 04-aug-01
;-  modified	: -> re "version.inc"
;-  version	: 0.01(+)
;-  switches	: __DEBUG_I
;-  assembler	: nasm 0.98-3e (patched & bugs fixed 0.98)
;-  description	: "lib4th" shared library Forth kernel
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  source	: (me, hp)
;-  requires	: the "lib4th" package
;-=====================================================================;
;-
;-	
;-	

%ifndef __DEBUG_I
%define __DEBUG_I
%define debugi

l off;[list off]
;%undef __DBG	; debugging in-active, assemble empty routines
%ifdef __DBG
;-
;- dbg		beginning of debugging routines
dbg:GA
;[nolist]
	mdump
	perrm
	perrs
	perrn
	dbmrg
	dbcons
	pbits	; flagbits/binary
	psbits	; eflags symbols
%else; dummy macroes
%ifndef __DEBUG_INC
%macro DUMP 0-*.nolist
%endm
%macro PFSYM 0-*.nolist
%endm
%macro PRNUM 0-*.nolist
%endm
%macro PRSTG 0-*.nolist
%endm
%macro PRTXT 0-*.nolist
%endm
%macro L4PN 0-*.nolist
%endm
%endif
%endif; __DBG
l on;[list]
;-
;- puvari					(k)(u)
;-	debugging utility, display main user vari
puvari:GA;:ok:<non-redirected signals)
	pushad
	call getrefb		;>:KREF:
	mov ecx,'KR>'<<8|AC_NL
	mov eax,ebx
	call erumsg
	mov ecx,'top>'
	lea eax,[uref uv.utop]
	call erumsg
	mov ecx,'UR>'
	mov eax,UR
	call erumsg
	mov ecx,'PS>'
	mov eax,PS
	call erumsg
	mov ecx,'RS>'
	mov eax,RS
	call erumsg
; uvari
	mov ecx,'UV:'<<8|AC_NL
	call erustg
	lea eax,[byte uref uv.mtop]
	mov ecx,'top:'
	call erumsg
	lea eax,[byte uref uv.mbot]
	mov ecx,'bot:'
	call erumsg
	lea eax,[byte uref uv.tib]
	mov ecx,'tib:'
	call erumsg
	lea eax,[byte uref uv.c0]
	mov ecx,'c0:'
	call erumsg
	lea eax,[byte uref uv.cp]
	mov ecx,'cp:'
	call erumsg
	lea eax,[byte uref uv.s0]
	mov ecx,'s0:'
	call erumsg
	lea eax,[byte uref uv.r0]
	mov ecx,'r0:'
	call erumsg
	lea eax,[byte uref uv.d0]
	mov ecx,'d0:'
	call erumsg
	lea eax,[byte uref uv.dp]
	mov ecx,'dp:'
	call erumsg
; value
	mov ecx,'U@:'<<8|AC_NL
	call erustg
	mov ecx,'top:'
	mov eax,[byte uref uv.mtop]
	call erumsg
	mov ecx,'bot:'
	mov eax,[byte uref uv.mbot]
	call erumsg
	mov ecx,'tib:'
	mov eax,[byte uref uv.tib]
	call erumsg
	mov ecx,'c0:'
	mov eax,[byte uref uv.c0]
	call erumsg
	mov ecx,'cp:'
	mov eax,[byte uref uv.cp]
	call erumsg
	mov ecx,'s0:'
	mov eax,[byte uref uv.s0]
	call erumsg
	mov ecx,'r0:'
	mov eax,[byte uref uv.r0]
	call erumsg
	mov ecx,'d0:'
	mov eax,[byte uref uv.d0]
	call erumsg
	mov ecx,'dp:'
	mov eax,[byte uref uv.dp]
	call erumsg
; kref'd
	mov ecx,'+K:'<<8|AC_NL
	call erustg
	mov ecx,'top:'
	mov eax,[byte uref uv.mtop]
	call erkmsg
	mov ecx,'bot:'
	mov eax,[byte uref uv.mbot]
	call erkmsg
	mov ecx,'tib:'
	mov eax,[byte uref uv.tib]
	call erkmsg
	mov ecx,'c0:'
	mov eax,[byte uref uv.c0]
	call erkmsg
	mov ecx,'cp:'
	mov eax,[byte uref uv.cp]
	call erkmsg
	mov ecx,'s0:'
	mov eax,[byte uref uv.s0]
	call erkmsg
	mov ecx,'r0:'
	mov eax,[byte uref uv.r0]
	call erkmsg
	mov ecx,'d0:'
	mov eax,[byte uref uv.d0]
	call erkmsg
	mov ecx,'dp:'
	mov eax,[byte uref uv.dp]
	call erkmsg
;
	mov ecx,AC_NL
	call erustg
	popad
	ret
; --
; headerflags of latest word
ltflags:A
	call latestf
	movzx ecx,word[ecx]
	L4PN ecx,l,'vf:'
	ret
; access w/ macro <ts 1-2>, re 'lib4th.mac'
; -- debugging, quad/double ranum test, display top 3 items and stckdump
; -- .xf: print l.s.w edx, text ecx, data
; -- .xx: print " :L:", data; exit into <quit> if key = <esc>
; -- .xm: print text ecx, data; exit into <quit> if key = <esc>
; -- .xs: print text ecx, data
stestq:A;quad
.xf:
    spush
    push ecx
    mov eax,edx
    shl eax,4
    shr al,4
    or eax,AC_NL<<16|'00'
    add al,0x90	; re asmutils, 'libc.asm'
    daa
    adc al,0x40
    daa
    xchg al,ah
    add al,0x90
    daa
    adc al,0x40
    daa
    call emit
    pop ecx
    jr .xs
.xx:
    mov ecx,AC_NL<<24|':L:'
.xm:
    lea edx,[kref .xk-Y]
    push edx
.xs:
    spush 2
    mov eax,ecx
    call emit
    mov eax,':1:'
    call emit
    call .xd
    spush
    mov eax,':2:'
    call emit
    call qvover
    call .xd
    spop 6
    mov eax,':3:'
    call emit
    mov eax,2
    call pick8
    call .xd
    spop 6
    mov eax,':4:'
    call emit
    mov eax,3
    call pick8
    call .xd
    spop 8
    call cr
    call dots
    jmp cr
.xk:
    call key
    cmp eax,byte 27
    spop
    jz near quit
    jmp cr
.xd:
    call qvdup
    call qv2dv
    jmp dvdotf
stestd:A;double
.xx:
    mov ecx,AC_NL<<24|':L:'
.xm:
    lea edx,[kref .xk-Y]
    push edx
.xs:
    spush 2
    mov eax,ecx
    call emit
    mov eax,':1:'
    call emit
    call dvdup
    call dvdotf
    spush
    mov eax,':2:'
    call emit
    call dvover
    call dvdotf
    spush
    mov eax,':3:'
    call emit
    call dvrot
    call dvdup
    call dvdotf
    call dvmrot
    call cr
    call dots
    jmp cr
.xk:
    call key
    cmp eax,byte 27
    spop
    jz near quit
    jmp cr
%endif;__DEBUG_I
;-
;-=====================================================================;
;- l4debug.inc <eof>
