;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-=====================================================================;
;-  file  	: l4errhnd.inc
;-  created	: 27-jun-01
;-  modified	: -> re "version.inc"
;-  version	: 0.01(+)
;-  switches	:
;-  assembler	: nasm 0.98-3e (patched & bugs fixed 0.98)
;-  description	: signal & erorr handling words
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	:
;-  source	: linux
;-  requires	: the "lib4th" package
;-=====================================================================;
;-
	
;-
;-================================================================
;-
;- -- error handling, messages.
;-

;-
;- ?error  	( flg n2 -- | in blk ,quit )	(v)		'qerror'	forth
;-	if nonzero flg display error message no. n2 and {quit}
qerror:GA;:ok:
; c: -/- if no error, else ecx,edx
	spush
	mov eax,[uref uv.uqerror]
	jmp execute.c
;-
;- [CATCH]  	( flg n2 -- 0 | n2 )		(a:ex)?		'bcatchb'	ans
;-	if nonzero flg leave n2. else false
bcatchb:GA
	cmp dword TOS(1),byte 0
	jz bqerrb.r
	TOSPULL(1)
	ret
;-
;- [THROW]	( er -- | abort-er )		(a:ex)?		'bthrowb'	ans
bthrowb:GA
;throw substituted w. { dup [?error] }
	spush	;:continues: in <bqerrb>
;-
;- [?error]  	( flg n2 -- | in blk ,quit )			'bqerrb'	hidden
;-	if nonzero flg display error message no. n2 and {quit}
bqerrb:GA;:ok:
; c: -/- if no error, else ecx,edx
	cmp dword TOS(1),byte 0
	TOSPULL(1)
	jnz errorf
.r:
	spop
	ret
;-
;- error  	( n --> quit )					'errorf'	root
;-	display error (+n) or system (-n) message and {quit}.
errorf:GA;:ok:
; c: -/- if no error, else ecx,edx
	spush
	mov eax,[uref uv.uerror]
	jmp execute.c
;-
;- [error]	( n --> quit )					'berrb'		hidden
;-      {error} vector default:
;-      display error (+n) or system (-n) message, rst RP & tib, {quit}.
berrb:GA;:ok:
	call getrefb	;<:KREF:
	cmp ecx,'nnam'
	jnz .t
	dec dword[byte uref uv.lkindex]
.t:
	call hptr	; interpreting state
	call rpstore
;;	call lcignore	;
;;	call uclu	; uc-unmap
	push eax
	mov eax,[byte uref uv.in]
	add eax,[byte uref uv.tib]
	spush
	mov eax,[byte uref uv.blk]
	spush
	call tib0	;;;
	pop eax
	lea ecx,[kref quit.s-Y]
	push ecx
	lea ecx,[kref cr-Y]
	push ecx
;-
;- message	( n -- )							forth
;-	display system message, lib4th defined w/ +n, Linux kernel w/ -n
;-	overflow: 'msg #' n
;-	display startup text if n = 0x80000000
message:GA;:ok:
; c: ecx,edx
	call msgstg
	test eax,eax
	jz .d
	jmp type
.d:
	spop
	mov eax,ecx
	call pdotqtep
	db 0,10,"msg #",0
	jmp decdot
;-
;- msgstg  	( n -- p u )							forth
;-	return ptr p and length u of message stg corresponding to signed no. n
msgstg:GA;:ok:
	neg eax
	jo .i		;?; "-0"
	jg .s
	neg eax
	cmp eax,[kref msgt.m-Y]
	ja .z
.m:
	movsx eax,word[kref eax*2+msgt-Y]
	test eax,eax
	js msgstg
	jz .z
	lea eax,[eax+msgt-Y+2]
	spush
	movzx eax,word[kref eax-2]
	ret
.s:A
	mov ecx,dword[kref rm-Y]
	cmp eax,ecx	; upper bound of errno-s
	ja .z 		; out of range
.i:
	lea ecx,[rn-Y]	; sysmsg, disp to base of disp table
	lea eax,[eax*2+ecx-2]
	movsx eax,word[kref eax]
	lea eax,[eax+ecx+2]
	spush
	movzx eax,word[kref eax-2]
	ret
.z:A
	mov ecx,eax	; save for "msg#"
	mov eax,KR
	spush
	xor eax,eax
	ret
;-	
; list of error names, prepended "E" implied!
ernos:A
	spush
	mov eax,ernot-Y
	ret
; list of signal names
signos:A
	spush
	mov eax,signot-Y
	ret
daynos:A
	cmp eax,0+'de'
	mov ecx,dayt.d-Y
	jz .r
	cmp eax,0+'en'
	mov ecx,dayt.e-Y
	jz .r
	spush
	mov ecx,dayt-Y
.r:
	mov eax,ecx
	ret
;-
;-================================================================
;--- errors
;-
;-	

;-
;- null?	( p -- f )					'nullq'		forth
;-	tf if p = 0 or ref to zero 4th address
nullq:GA
	test eax,eax
	jz .r
	add eax,KR
	jz .r
	mov eax,1
.r:
	dec eax
	ret
;-
;- ?null  	( p -- abort-14 )				'qnull'		forth
;-	abort w/ "Bad address" if p is zero or zero 4th address
qnull:GA
	call nullq
	mov eax,-14
	jnz qcomp.e
	spop
	ret
;-
;- ?comp  	( -- | abort-17 )				'qcomp'		forth
;-	abort if not in compiling state
qcomp:GA;:ok:
	cmp word[byte uref uv.state],0
	jg g32 qpairs.r
.n:
	mov eax,17	; "cpl only"
.e:
	jmp errorf
rco:equ qcomp.n
;-
;- ?exec  	( -- | abort-18 )				'qexec'		forth
;-	abort if not in true (vs. imtermediatly) executing state
qexec:GA;:ok:
	cmp word[byte uref uv.state],0
	jz qpairs.r
rxo:	; "xec only"
	mov eax,18
	jr qcomp.e
;-
;- ?csp		( -- | abort )					'qcsp'		forth
;-	abort if stack is out of balance w. stored value from {csp}.
qcsp:GA;:ok:
	mov ecx,KR
	add ecx,[uref uv.ucsp]
	sub ecx,PS
	spush
	mov eax,ecx
rdn:	; "definition not finished"
	spush
.n:
	mov eax,20
	jmp qerror
;-
;- ?pairs2	( f1 f2 f3 -- | abort )		(k)		'qpairs2'
;-	abort if neither f2 = f1 nor f3 = f1
qpairs2:A;:ok:
	cmp eax,TOS(2)
	spop
	jz qpairs.p
;-
;- ?pairs  	( f1 f2 -- | abort )		(fg)		'qpairs'	forth
;-	abort if f1 =/= f2
qpairs:GA;:ok:
	cmp eax,TOS(1)
.p:
	mov eax,28
	TOSPULL(1)
	jnz qcomp.e
	spop
.r:
	ret
;-
;- ?stack  	( --  abort )			(fg)		'qstack'	forth
;-	abort w. message "empty stack" if unsufficient space
;-	abort w. message "stack overflow" if upper bound overflow
;-	else continue silently
qstack:GA
; c: ecx
	mov ecx,PS
.n:
	sub ecx,KR
	sub ecx,[byte uref uv.s0]
	jc .x	;?; stack empty
	lea ecx,[ecx+8]
	shr ecx,16
	jnz .x
	ret
.u:
	neg ecx	; mark for 'stack empty'
.x:
	lea ecx,[kref quit.s-Y]
	push ecx
qdepth.m:	; stack empty/not sufficient
	mov PS,[uref uv.s0]
	lea PS,[kref PS]
	jr qdepth.n;;m;
; <qdepthb>
; i: ecx  = requested data-stack depth in bytes
; o: ecx := actual stack depth
qdepthb:GA;<mmap,msync,munmap,qvround,svocflags)
	add ecx,[byte uref uv.s0]
	add ecx,KR	; min tos ptr
	sub ecx,PS
	ja qstack.u	;?; requested tos u> actual tos
	ret
;-
;- ?depth  	( n -- | abort )		(f6)		'qdepth'	forth
;-	check whether sufficient data cells on datastack, else
;-	rst datatstack and send message "off working area" to stderr
qdepth:GA;:ok:
; c: ecx
	call depthq		; Z & eax=-1
	spop
	jnz .r			;?; sufficient depth
	lea PS,[PS+ecx*4+4]	; adjust stack to requested depth
	cmp eax,eax		; -> Z
;;.m:	; stack empty/not sufficient
;;	mov PS,[uref uv.s0]
;;	lea PS,[kref PS]
.n:
	pushad
	pushfd
	spush
	mov eax,stderr
	call chid
	js .q
	popfd
	lea ecx,[kref mptyad-Y]	; "empty stack"
	jc .p
	lea ecx,[ecx+sovfad-mptyad]; "stack overflow"
	jnz .p
	lea ecx,[ecx+edisad-sovfad]; "off working area"
.p:
	movzx edx,word[ecx]
	mov ebx,eax
	lea ecx,[ecx+2]
	sys_write
.q:
	popad
.r:
	ret
killstack:A
	pushad
	sys_kill eax,SIGSTKFLT
	popad
	ret
;-
;- depth?  	( n -- flg )			(f6)		'depthq'	forth
;-	tf if at least n cells on stack.
depthq:GA;:ok:
; c: ecx
	call depth
%if 1
	mov ecx,TOS(1)
	TOSPULL(1)
	sub ecx,eax
	sbb eax,eax	; tf if n within depth
	ret
%elif 0
	mov ecx,eax
	spop
	sub eax,ecx	; +ve if n > actual depth
	sar eax,31
	ret
%else
	mov ecx,TOS(1);;;
	sub TOS(1),eax
	spop
	sar eax,31
	ret
%endif
;-
;- abort  					(d)		'cabort'	root
;-	restore stacks & kref, lc-unmap, uc-unmap, enter {quit} or,
;-	if @pid =/= actual job's pid terminate w. SIGSTKFLT 
cabort:GA
rabort:
	mov ecx,cabortv-Y
	jmp pdodefer
tib0:
	mov ecx,d_ntib-4
	mov dword[uref uv.utibmax],ecx
	mov dword[uref uv.in],ecx
	jmp tib2dft
;-
;- [abort]  							'babortb'	hidden
;-	deferred -re- {abort} default.
babortb:A
	call rpstore
;;cabort:GA;:ok:
	call getrefb	;>:KREF:
	call tib0
	call lcignore
	call uclu	; uc-unmap
	mov ecx,eax
	call fspstore
	mov eax,ecx
	call pidf
	cmp eax,[uref uv.upid]
	jnz g16 killstack
	spop
	jmp quit.s
;-
;- abort" 	ccc( f -- )			(i)(4)		'abtqte'	forth
;-	if f = 0 continue, else send <"> delimited message stg ccc and {abort}.
abtqte:GA;:ok:
	call if
	call dotquote
.n:
	TICK cabort;TICK pdodefercabort;(ok)
	call mcompilec
	jmp endif
;-
;- daystg  	( n [cc] -- p u )				'daystg'	forth
;-	return ptr to day name corresponding to no. n
;-	optional country code cc, one of <en>, <de> (l4_0.0.57).
daystg:GA;:ok:
	call daynos	; eax:=list
	jr enumf
;-
;- sigstg  	( n -- p u )					'sigs'		linux
;-	return ptr to signal name corresponding to no. n
;-	leading "SIG" implied.
sigs:GA;:ok:
	call signos	; eax:=list
	jr enumf
;-
;- errstg  	( n -- p u )					'errs'		forth
;-	return ptr to error name corresponding to no. n
;-	leading "E" implied.
errs:GA;:ok:
	call ernos	; eax:=list
;-
;- enum@  	( n p1 -- p2 u )				'enumf'		forth
;-	find string(p2,u) by number n in list of <nul>-terminated stg-s at p1.
;-	<nul> <nul> is list terminator. enum list constructor -re- {:slist} etc.
enumf:GA;:ok:
	mov ecx,TOS(1)
	inc ecx		; n+1 counter
	push edi
	lea edi,[kref eax]; list
	xor eax,eax
.l:
	mov edx,edi
.s:
	scasb
	jnz .s		;?; no terminating <nul> found
	cmp [edi+1],ax
	loopnz .l	;?; next stg until end of count
	mov ecx,edi
	pop edi
	jz .r		;?; end of list
	not edx
	lea eax,[ecx+edx]; count u
	add edx,KR
	not edx		; p2
	mov TOS(1),edx
.r:
	ret
;-
;-  {errno} and {signo}
;-	respond to upper case strings, unless {lc-ignore} mode set.
;-

;-
;- errno  	( p u -- n )					'erno'		forth
;-	find error number +n corresponding to given name p,u.
;-	leading "E" may be omitted.
erno:GA;:ok:
	test eax,eax
	jle .q		;?; empty stg or false u
	mov ecx,TOS(1)
	mov ecx,[kref ecx]
	cmp cl,'E'
	jnz .s		;?; significant part of stg
	cmp ch,'X'
	jz .s
	inc dword TOS(1)
	dec eax
.q:
	jle signo.q	; ret -ve flag
.s:
	call ernos
	jr enumn
;-
;- signo  	( p u -- n )							linux
;-	find signal number +n corresponding to given name p,u.
;-	leading "SIG" may be omitted.
signo:GA;:ok:
	test eax,eax
	jle .q		;?; empty stg or false u
	mov ecx,TOS(1)
	mov ecx,[kref ecx]
	shl ecx,8
	cmp ecx,'SIG'<<8
	jnz .s		;?; significant part of stg
	add dword TOS(1),byte 3
	sub eax,byte 3
.q:
	jle enumn.q	; ret -ve flag
.s:
	call signos
;-
;- enum#  	( p1 u p2 -- n )  		(4)		'enumn'		forth
;-	item number n of string p1,u1 in list of asciz strings at p2.
;-	ret n:= +ve item number, else n:=-1 if string not found.
;-	-re- {enum@} and, enum list constructor {:slist} etc.
enumn:GA;:ok:
; eax: ptr to text table, TOS(2)=p,TOS(1)=u string to find, bytes 0,0 is end of table
	spush	; -1 swap			; initial cnt
	mov dword TOS(1),-1;{ n tt u p
	call swap2	; 2swap
	call tor2	; 2>r	{ tt n		[ u p
.begin:
	inc dword TOS(1);  swap 1+ swap		; n:=n+1
	call zcount	;  zcount { tu tp n	[ u p
	test eax,eax	;  dup	{ tu tu tp n	[..
	jz .until	; while	/ tu tp n
	call dup2	;  2dup
	call plus	;  +
	inc eax		;  1+	{ t' tu tp n	[..
	call mrot	;  -rot	{ tu tp t' n
	call r2		;  2r	{ u p tu tp t' n[ u p
	call compare	;  compare { f t' n	[..
	call nzbra	;  0=	{ t' n
	dd .begin-$	; until(2)
	test eax,eax	;	{ n		; set NZ
	spush
.until:	
	lea esp,[esp+8]	;2rdrop		[-/-
	spop
.q:
	spop		; swap drop{ n
	jnz .r		;?; stg found
.f:
	xor eax,eax
	dec eax
.r:
	ret
rtrue:equ enumn.f
;-
;- errno?  	( -- )						'ernoq'		forth
;-	display error names in {errno} list.
ernoq:GA;:ok:
	call ernos
	jr enumq
;-
;- signo?  	( -- )						'signoq'	linux
;-	display signal names in {signo} list.
signoq:GA;:ok:
	call signos
;-
;- enum?  	( p -- )			(4)		'enumq'		forth
;-	display all asciz strings of list p, space delimited.
;-	-re- {enum#}, {enum@}, enum list constructor {:slist} etc.
enumq:GA;:ok:
	call zcount
	test eax,eax
	jnz .c
	spop 2
	ret
.c:
	call dup2
	call plus
	inc eax
	call mrot
	call type
	call space
	jr enumq
;-
;-=====================================================================;
;-  l4errhnd.inc <eof>
