;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-=====================================================================;
;-  file  	: l4file.inc
;-  created	: 14-jul-01
;-  modified	: -> re "version.inc"
;-  version	: 0.01(+)
;-  switches	: __FILE_I
;-  assembler	: nasm 0.98-3e (patched & bugs fixed 0.98)
;-  description	: file/devices i/o opr, channels redirection
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  requires	: the "lib4th" package
;-=====================================================================;
;-
%ifndef __FILE_I
%define __FILE_I
%define fileinc

%ifndef linuxstathinc
%include "stat.h.inc"
%endif
;-	
;-
;-================================================================
;- -- i/o
;-

;-	
;-
;- source  	( -- a +u )			(v)(83)				forth
;-	addr of current input buf. & maxcount of data
;-	execute true address uot vector (source), dft {[source]}.
source:GA
	spush
	mov eax,[uref uv.usource]
	jmp execute.c
;-
;- refill  	( -- flg )			(a:c)(e)			forth
;-	dependent on input mode, re {source-id}, fetch next group of input data 
;-	to current input buf. ret tf, else ret ff if no input available.
; 	(e:flags reflect flg result
refill:GA;:ok:
	call sourceid		; -1:evaluate 0:tib +ve:file (seq or blk)
	mov ecx,eax
	inc eax
	jz .r			;?; {evaluate}, ret Z
	dec ecx
	jns .b			;?; > 0 is file
.f:; <stdin is file
	spop			; 0 is stdin, whether file or keyboard
	call qterminal		; ( -- e1 )
	mov ecx,[byte uref uv.ierr]
	spop			; ( e1 -- )
	inc ecx
	jg .q			;?; char received
	cmp ecx,byte 1+EAGAIN
.e:
	jne near .s		;?; neither file nor console, ret Z
.q:
	call query		; ( -- )
	cmp dword[byte uref uv.span],0
	js .s			;?; eof, ret Z
	cmp dword[byte uref uv.blk],0
	spush
	jns .t			;?; console input, ret S*NZ
	movzx eax,byte[byte uref uv.sourceid]; source channel
	and al,cdt_num-1
	call fposf		; ( e1 ch -- e1 d.fp flg )
	mov ecx,eax
	test eax,eax
	spop 2			; ( .. -- e1 fp
	js .x			;?; file positioning error, ret Z
	not eax
	mov [byte uref uv.blk],eax
	sar eax,31		; ret tf, S*NZ
.r:; <input from evaluate
	ret
.b:A;<file
	cmp dword[byte uref uv.blk],0
	js .f			;?; file by stdin
	inc dword[byte uref uv.blk]; next block no.
	mov eax,[byte uref uv.blk]
	call block
	push eax
	call scrcc
	mov eax,ecx
	call chrnum
	mov ecx,eax		; received count
	pop edx			; block ptr
	test ecx,ecx
	jng .x			;?; ret error
	mov [byte uref uv.span],ecx
	mov dword[byte uref uv.in],0
	push edi,esi
	mov edi,[byte uref uv.tib]
	mov esi,edx
	shr ecx,2
	lea edi,[kref edi]
	lea esi,[kref esi]
	rep movsd
	pop edi,esi	
.t:;				; ret tf, S*NZ
	xor eax,eax
	dec eax
	ret
.x:; ;< file error
	mov [byte uref uv.ierr],ecx
	xor eax,eax		; ret ff, NS*Z
	ret
.s:; ;< no input, eof ( -- f )
	spush
	xor eax,eax		; push ff, NS*Z
	ret
;-
;- save-input	( -- xn..x1 n )			(a:cx)		'saveinput'	forth
;-	[n:(source-id), s0, blk, in, (tib), (tib-max), span, set-chan(stdin), (iolink):1]
;-	and cnt n stored to data-stack. an application may further store this
;-	block to memory and link to (iolink) and, assign local {tib}.
;-	local dataspace left over after entry would be resolved by next {restore-input}.
saveinput:GA;:ok:
	spush
	push PS
	mov eax,[byte uref uv.sourceid]
%define _piolc
%undef _piolc
%ifdef _pioloc
	spush				;;;for locals resolution
	mov eax,[byte uref uv.s0]	;;;
%endif
	spush
	mov eax,[byte uref uv.blk]
	spush
	mov eax,[byte uref uv.in]
	spush
	mov eax,[byte uref uv.tib]
	spush
	mov eax,[uref uv.utibmax]
	spush
	mov eax,[byte uref uv.span]
	call stdinc
	call getchan
	spush
	mov eax,[byte uref uv.iolink]
	spush
	mov eax,PS
	pop ecx		; PS on entry
	sub eax,ecx
	shr eax,2	; items count
	ret
;-
;- restore-input	( xn..x1 n -- flg )		(a:cx)(e)	'restoreinput'	forth
;-	restores data-stack top from (iolink), stores cnt n saved values back to
;-	[n:(source-id), s0, blk, in, (tib), (tib-max), span, set-chan(stdin), (iolink):1]
;-	and forcedly resolves after latest -re- {save-input} locally assigned memory.
;-	(eflags; Z if at top input level else NZ, S after early termination - re <popiosrc>)
restoreinput:GA;:ok:
; o: ecx	prev. @in
	mov edx,eax
	neg eax
	lea eax,[PS+eax*4]
	dec edx
	js near true
	push eax
	push dword[byte uref uv.in]	; save @in at entry
	spop
	mov dword[byte uref uv.iolink],eax
	dec edx
	js .s		;?; ready
	sub edx,byte (cdt_size-1)/4
	js near cabort	;?; insufficient data
	push edx
	spop
	call stdinc
	call setchan
	pop edx
	mov dword[byte uref uv.span],eax
	dec edx
	js .s
	mov ecx,TOS(1)
	mov dword[uref uv.utibmax],ecx
	dec edx
	js .s
	mov ecx,TOS(2)
	mov dword[byte uref uv.tib],ecx
	dec edx
	js .s
	mov ecx,TOS(3)
	mov dword[byte uref uv.in],ecx
	dec edx
	js .s
	mov ecx,TOS(4)
	mov dword[byte uref uv.blk],ecx
	dec edx
	js .s
	mov ecx,TOS(5)
%ifdef _pioloc
	push ecx			;;;for locals resolution and ds safety
	sub ecx,[byte uref uv.s0]	;;;
	jz .j				;;;
	mov eax,ecx			;;;
	shr eax,2			;;;
	push eax			;;;
	call toloc			;;;
.j:
	pop dword[byte uref uv.s0]	;;;
	dec edx				;;;
	js .s				;;;
	mov ecx,TOS(6)			;;;
%endif
	mov dword[byte uref uv.sourceid],ecx
	or edx,byte 1	; force NS*NZ
.s:
%if 0
;;	mov eax,[byte uref uv.iolink]
;;	shr eax,1	; NS ok, NZ if not at last level
	pop ecx		; previous @in
	pop PS
	mov eax,0
	ret
%else
	xor eax,eax
	pop ecx		; previous @in
	inc eax		; force NZ & NS (re quit/popiosrc)
.r:
	pop PS
	mov eax,0
	ret
%endif
;
ipushio:;:ok:<include-file)
	spush
	mov eax,d_mintib
;-
;- push-io	( n -- )(R: -- -tib- nn...nm nc )		'pushio'	forth
;-	allocate n bytes of local tib, >in := n, tib-max := n
;-	push i/o source data to tor, link into (iolink) chain
pushio:GA;:ok:
; no regs but, eflags preserved!
	pushfd		; save eflags
	spush
	pop dword TOS(1); @nos:=eflags	{ n f
	lea eax,[eax+7]	; safety margin
	call aligned
	spush		; dup	{ n n f
	pop dword TOS(1); ret	{ n r f
	mov ecx,eax	; n
	spush
	sub esp,eax	; dataspace
	add eax,esp	;	{ n+s n r f
	push eax	; empty r-stack			[ rs -tib-
	lea eax,[esp+8]
	sub eax,KR	; tib	{ t n r f
	call saveinput	;	{ c .x. t n r f
	spush		;	{ c c .x. t n r f
	spush		;	{ c c c .x. t n r f
	not eax		;	{ -(c+1) c c .x. t n r f
	call roll	;	{ c .x. c t n r f
	spush		;	{ c .x. c t n r	f	[ c rs -tib-
	lea eax,[eax+2]	;	{ c+2 c .. c t n r f	[ c rs -tib-
	call ntor	;	{ t n r	f		[ c .x. c rs -tib-
	mov ecx,TOS(1)	; n
	mov edx,TOS(2)	; r
	push dword TOS(3);eflags
	mov [byte uref uv.tib],eax	; local tib =
	mov [byte uref uv.in],ecx	; >in, force new input = n
	xor eax,eax
	popfd				; rst eflags
	mov [uref uv.utibmax],ecx	; tib-max = n
	mov [byte uref uv.iolink],esp	; tor
	mov dword[uref uv.uintib],eax	; #tib = 0
	mov dword[byte uref uv.span],eax; span = 0
	spop 4
	jmp edx
;-
;- pop-io 	( -- )(R: -tib- nn...nm nc -- )	(e)		'popio'		forth
;-	pop i/o source from tor, discard latest local tib, remove from (iolink) chain
;-	(eflags: NZ if, on entry, no more levels to resolve.
popio:GA;:ok:
	spush
	pop eax			; ret
	mov ecx,[byte uref uv.in]
	cmp dword[byte uref uv.iolink],byte 0
	jz .z			;?; no nested levels
	cmp [byte uref uv.iolink],KR
	jz .z
	mov esp,[byte uref uv.iolink];		[ c .x. c rs ...
	call rfrom		; c
	call nrfrom		; .x.
	call rfrom		; c .x.
	call restoreinput
	spop
	pop esp
	cmp [byte uref uv.blk],byte 0
	jg .z			;?; blockfile, to {interpret} not resetting RP
	cmp UR,KR		; force NZ
.z:
	mov edx,eax		; ret
	spop
	jmp edx
;-	
;- -- file
;-	

;-
;- path-max	( -- n )			(c)(m,6)	'pathmax'	linux
;-	max. length of a path-name (4K-1 w/ kernel 2.2.xx)
pathmax:GA;:ok:
	spush
	mov eax,PATH_MAX
	ret

; fetch filename from input stream ( n -- p u n )
ffname:A
	push eax
	spop
	call name
	spush
	pop eax
	ret
;
bfnameb.c:A
	TICK pfnamep
	jmp compilec
;-
;- f"		ccc ( -- p u )  		(i)(4)		'fqte'		forth
;-	{fname"} w/ {path-max} bytes buf. at {pad}. -re- {[fname]}.
fqte:GA;:OK: interpreting and [_] cpld, else -?-
	call pad
	call pathmax
	call dliteral
;-
;- fname" 	ccc( p1 u1 -- p2 u2 )		(i)(4)  	'fnmqte'	forth
;-	fetch <"> delimited file-name to buf(p1,u1), search {f8dir}, {path}, {lxpath}
;-	ret the fully qualified path+file name stg(p2,u2) to buf(p1,u1).
fnmqte:GA
	call sqte
;-
;- [fname]	( p1 u1 p2 u2 -- p3 u3 )	(i)(4)  	'bfnameb'	forth
;-	search in {f8dir}, {path} and {lxpath} for filename(p2,u2);
;-	ret fully qualified path+file name stg(p3,u3) to buf(p1,u1).
;-	else, if file not found ret empty stg(p3,u3) u3=0.
bfnameb:GA;:OK: interpreting, else -?-
	call ccplq
	jnz .c		;?; compiling (re above)
;-
;- [fn		( d.buf d.file -- np nu )	 (k)(r)		'pfnamep'	novoc
;-	runtime {[fname]}, 
;-	search cwd if not 'root', then {f8dir}, {path}, {lxpath} for filename(d.file). 
pfnamep:A;<bfnameb.c); -re- {path+file} in <src/l4string.inc>
	call f8dir	; path to l4 library files, as configured
	call .n
	jg .f
	spop 2		; 2drop - drop result
	call epath	; PATH env-vari
	call .n
	jg .f		;?; found
	spop 2
	call lxpath	; linux source files
	call .n
.f:
	call sdrop2
	jmp sdrop2	; leave result stg(np,nu)
.n:A; ( buf file path --
	call over2
	spush
	mov eax,3
	call pick2
	call pthfile	; path file buf -- p+f
	test eax,eax	; -- bp bu fp fu np nu
.r:
	ret
; ret Z if fd is duplicate, work < fd < max-chan
; i:	eax	fd
; o:	ecx	chnum	| -1
;	edx	chp	| 0
tstclos:A
	mov edx,[byte uref uv.chans]; chp base
	lea edx,[kref edx+((cdt_num-1)*cdt_size)+cdt.chid-cdt]; top chp, at disp to chan-id
	mov ecx,cdt_num-1; max-chan
.l:
	cmp ecx,workch
	jz .n
	cmp eax,[edx]
	jz .r		;?; duplicate channel
.n:
	dec ecx
	lea edx,[edx-cdt_size]
	jns .l		;?; more
	mov edx,ecx	; NZ and edx:=0 at end of list
.r:
	ret
;-
;- w-close	( -- er )			(s)		'wclose'	forth
;-	close {work}-channel - re {close-file}.
wclose:GA;:ok:
	spush
	mov eax,workch
;-
;- close-file	( c -- er )			(s)		'closef'	forth
;- close-dir	( c -- er )			(s)		'closef'	ans
;-	close channel no. c, ret er = 0 after success, else 
;-	error code er = +ve (fd, duplicate exists) or -ve (fss error).
;-	invalidate chp entry.
;-	don't actually close if duplicate channel other than {work} exists,
;-	if {work} is duplicate to channel c close work, also.
;-	channel protected if c = stdin and fd = host STDIN.
;-	syscall close -re- man 2 ...
closef:GA;:ok:
; o: edx = chp
	push eax
	call chid
	inc eax
	pop ecx
	jz .q		;?; not a channel, ret Z = ok
	dec eax
	pushad
	cmp eax,byte STDIN
	jnz .c		;?; not host stdin
	readad ecx,ecx	; channel no.
	test ecx,ecx
	jz .r		;?; host STDIN at channel no. 0
.c:
	xor ecx,ecx
	mov dword[kref edx+cdt.fpos],ecx
	mov dword[kref edx+cdt.fpos+4],ecx
	dec ecx
	mov dword[kref edx+cdt.iofl],ecx
	mov dword[kref edx+cdt.chid],ecx
	cmp eax,byte STDIN
	jz .r		;?; protect host stdin
	call tstclos	; check whether..
	jz .r		;?; ..duplicate channel
	sys_close eax
	readad ecx,eax
	cmp ecx,workch
	jz .r
	readad ebx,ebx	; rst kref
	push eax
	mov eax,workch
	call closef	; close duplicate work channel
	pop eax
	test eax,eax
.r:
	writead eax,eax
	popad
.q:
	ret
;-
;- a-close	( -- )						'aclose'	util
;-	close channels no. 5 .. { max-chan 1- }, and work-channel (3).
aclose:GA;:ok:
; max-chan 5 do i close-file drop loop 3 close-file drop ;
	call maxchan
	dec eax
	push eax
.l:
	dec dword[esp]
	call closef
	mov eax,[esp]
	cmp eax,byte 4
	jnz .l
	lea esp,[esp+4]	; drop counter
	dec eax
	call closef	; close work-channel
	spop
	ret
;-
;- delete-file	( p u -- er )			(s)(a:f)	'deletf'	forth
;-	ret 0 or, -ve er after failure.
;-	syscall unlink -re- man 2 ...
;-	! if data security is an issue, pse, note that there is no safe way to 
;-	! erasing any data from e.g., a hard disk, but physical destruction...
deletf:GA;:ok:
	call placeps	; tmp. store asciz name
	push eax,ebx	; save ptr to name & kernel-ref
	sys_unlink eax	; ptr to path
	pop ebx		; kernel-ref
	pop PS		; restore PS
	TOSPULL(1)	; swap drop
	ret
;-	
;-----------------------------------------------------------------
;- -- basic fd access mode flags (open)
;-	read, write
;-	
;-

;-
;- r/o		( -- n )			(a:f)(m,7)	'rbyof'		forth
;-	'read only' file open access mode
rbyof:GA M;:ok:
	spush
	mov eax,O_RDONLY
M rbyof
	ret
;-
;- r/w		( -- n )			(a:f)(m,7)	'rbywf'		forth
;-	'read and write' file open access mode
rbywf:GA M;:ok:
	spush
	mov eax,O_RDWR
M rbywf
	ret
;-
;- w/o		( -- n )			(a:f)(m,7)	'wbyof'		forth
;-	'write only' file open access mode
wbyof:GA M;:ok:
	spush
	mov eax,O_WRONLY
M wbyof
	ret
;-
;-
;-----------------------------------------------------------------
;- -- modifiers to 'read'/'write' fd access mode flags
;-	directory, append, nonblock, sync, nofollow, excl, creat
;-	

;-
;- app		( n1 -- n2 )			(m,6)		'appf'		linux
;-	modify acess flag to append mode
appf:GA M
	or eax,O_APPEND
M dirf
	ret
;-
;- bin		( n1 -- n2 )			(a:f)(m,0)	'binf'		forth
;-	modify access flag to binary (non text, <eol>, etc) mode.
;-	ANS required; "bin"ary is a *transfer* mode and not a files entity!
;-	too silly, specific to a certain 'OS' and just a {noop} in Linux.
binf:GA M
M binf
	ret
;-
;- cre		( n1 -- n2 )			(m,6)		'cref'		linux
;-	modify acess flag to truncate after open, i.e. open overwriting
cref:GA M;:ok:
	or eax,O_CREAT
M cref
	ret
;-
;- dir		( n1 -- n2 )			(m,6)		'dirf'		linux
;-	modify acess flag to open only if file is directory
dirf:GA M;:ok:
	or eax,O_DIRECTORY
M dirf
	ret
;-
;- nbl		( n1 -- n2 )			(m,6)		'nblf'		linux
;-	modify acess flag to non-blocking i/o,
;-	required for console single key input mode.
nblf:GA M
	or eax,O_NONBLOCK
M dirf
	ret
;-
;- nof		( n1 -- n2 )			(m,6)		'noff'		linux
;-	modify acess flag to not following links
noff:GA M
	or eax,O_NOFOLLOW
M dirf
	ret
;-
;- syn		( n1 -- n2 )			(m,6)		'synf'		linux
;-      modify acess flag to synchrounous mode, waiting until actual
;-	opr. finished - <enter> if console input. flushing output data.
synf:GA M
	or eax,O_SYNC
M synf
	ret
;-
;- trn		( n1 -- n2 )			(m,6)		'trnf'		linux
;-	modify acess flag to truncate after open, i.e. open overwriting
trnf:GA M;:ok:
	or eax,O_TRUNC
M dirf
	ret
;-
;- any		( n1 -- n2 )			(m,6)		'anyf'		forth
;-	modify access flag to 4th calling a modified {create-file} which
;-	also returns error-free if the file is an accessible serial channel.
anyf:GA M;:ok:
	or eax,O_ANYF
M dirf
	ret
;-	
;-
;-----------------------------------------------------------------
;- -- file access
;-

;-
;- -- directories
;-
;- f8doc  	( -- p u )			(kv)				util
;-	ret path to lib4th documentation files (dft compiled in by lib4th compilation).
f8doc:GA;:ok:
	mov ecx,pf8docpv-Y
	call pdoval
	jmp count
;-
;- f8glo  	( -- p u )			(kv)				util
;-	ret glossary filename stg(p,u)
f8glo:GA;:ok:
	mov ecx,pf8glspv-Y
	call pdoval
	jmp ccount
;-
;- f8gls  	( p1 u1 -- p2 u2 )		((kv))				util
;-	store path+file(p2,u2) of l4-glossary to buf(p1,u1)
;-	NOTE: string concatenation requires buf(p1,u1) as an argument!
f8gls:GA;:ok:
	call f8doc
	call f8glo
	call rot2
	jmp pthfile
;-
;- f8dir  	( -- p u )							forth
;-	path to lib4th supplemental files (fix, compiled in w/ __LIBF8D in Makefile):
;-	'__LIBF8D:__LIBF8D/app:~/.f8:~/f8:~/.f8/app:~/f8/app:$(__LIBDIR)'
f8dir:GA;:ok:
	mov ecx,pf8libpv-Y
	call pdoval
	jmp count
;-	
;- -- resources
;-

;
; <creanyf>
; open any file type, overwriting if possible
creanyf:A;<ret from creaf if O_ANYF was set)
	test eax,eax
	js .x
	spop
	and eax,~(O_CREAT)
	push eax
	and eax,~(O_TRUNC|O_CREAT|O_APPEND)
	call openf
	test eax,eax
	jz .r		;?; failure
	mov ecx,[esp]
	test ecx,O_APPEND
	jnz .r		;?; append is not truncating
	test ecx,O_TRUNC
	jz .r		;?; no truncate flag
	push eax,ebx
	xor ecx,ecx	; fptr
	mov ebx,[kref edx+cdt.chid]
	sys_ftruncate	; don't care for serial channels...
	pop eax,ebx	; rst ernum & KR
.r:
	add esp,byte 4
	ret
.x:A
	mov ecx,TOS(1)
	mov TOS(3),eax
	mov TOS(4),ecx
	TOSPULL(3)
	ret
;-
;- mfopen       ccc( n1 pf -- c flg )						linux
;-      open file ccc w/ flags n1 & pf, -re- {mopen-file}.
mfopen:GA
	call name
	call swap2
;-
;- mopen-file	( p u n1 pf -- fd flg )		(s)		'mopenf'	linux
;-	{open-file} w/ file permissions pf, using @{(fperm)} if not > 0.
mopenf:GA;:ok:
	mov edx,eax
	spop
	jmp j32 openf.m
;-
;- mcreate-file	( p u n1 pf -- n2 n3 )		(s)		'mcreaf'	linux
;-	{create-file} w/ file permissions pf, dft = 600 if pf not > 0.
;-	{mopen-file} w. TRUNC and CREAT flags or-ed to access code.
mcreaf:GA
	mov edx,eax
	spop
	jr creaf.m
;-
;- create-file	( p u n1 -- n2 n3 )		(s)(a:f)	'creaf'		forth
;-	open old and truncate or, create new file,
;-	{open-file} w. TRUNC, CREAT, NONBLOCK flags or-ed to access code.
creaf:GA;:ok:
	_or eax,O_NONBLOCK
	btr eax,31
	jnc .a
	lea ecx,[kref creanyf-Y]
	push ecx
	call dup3
.a:
	xor edx,edx
.m:;	;<mcreaf)
	or eax,O_TRUNC|O_CREAT;;|O_NONBLOCK;
	jr openf.m
;-
;- open-dir	( p u -- fd flg )				'opendirf'	linux
;-	r/o open directory path (p,u).
opendirf:GA;:ok:
	call rbyof
	call dirf
	jr openf
;-
;- mcreate-dir	( p u pf -- n2 n3 )		(s)(a:f)	'mcread'	linux
;-	create a directory w/ file access mask pf.
;-	-re- man 2 mkdir
mcread:GA
	mov edx,eax
	jr cread.m		;:continued: create-dir
;-
;- create-dir	( p u -- n2 n3 )		(s)(a:f)	'cread'		linux
;-	create a directory w/ file access mask &02700.
;-	-re- man 2 mkdir
cread:GA
	mov edx,02700q
	spush
.m:
	push_ibyte(__NR_mkdir)
	mov eax,edx
	jr openf.d
;-
;- fopen        ccc( n1 -- c flg )				'fopenf'	forth
;-      open file ccc, n1 & ret re {open-file}
fopenf:GA;:ok:
	call ffname
;-
;-----------------------------------------------------------------
;- -- fd open flags
;-
;- -- Linux 2.2.14 kernel open-flags:
;-	 O_ACCMODE	    3		mask
;-	 O_RDONLY	    0
;-	 O_WRONLY	    1
;-	 O_RDWR		    2
;----------------------- modifiers
;-	O_ANY		0x80000000	lib4th specific for {create-file}, any file-type
;-	 O_CREAT	  100q
;-	 O_EXCL		  200q
;-	 O_NOCTTY	  400q
;-	 O_TRUNC	  1000q
;-	 O_APPEND	  2000q
;-	 O_NONBLOCK	  4000q
;-	 O_NDELAY	O_NONBLOCK
;-	 O_SYNC		010000q		only on block devs & files on ext2 fs
;-	 O_DIRECT	040000q		direct disk access hint - currently ignored
;-	 O_LARGEFILE	100000q
;-	 O_DIRECTORY	200000q		must be a directory
;-	 O_NOFOLLOW	400000q		don't follow links
;-	 FASYNC		020000q		fcntl, for BSD compatibility
;----------------------- access mode, re <man 1,2 chmod>
;-		value	4 for	read access
;-			2	write
;-			1	execution
;-	or-ed together and coded in three octal digits where
;-			m.s. digit is for the file's owner (user)
;-			2nd			     group
;-			l.s.			     all other
;----------------------- fcntl fd,cmd[,arg|struc]
;-	 F_DUPFD	     0		dup
;-	 F_GETFD	     1		get f_flags
;-	 F_SETFD	     2		un-/set close-on-exec flag
;-	 FD_CLOEXEC	     1		f_setfd: actually anything with low bit set goes
;-	 F_GETFL	     3		get all flags of fd
;-	 F_SETFL	     4		set section of O_APPEND, O_NONBLOCK, O_ASYNC flags
;-	 F_GETLK	     5		\
;-	 F_SETLK	     6		 )get/set file locks
;-	 F_SETLKW	     7		/
;-	
;
;-
;- open-file	( p u n1 -- c flg )		(s)(a:f)	'openf'		forth
;-	open in mode n1 an existing file the name of which is string (p,u).
;-	n1 either one of {r/w}, {r/o} or {w/o}, which may be ORed by several
;-	modifiers, e.g. {app}, {cre}, {dir}, {nbl}, {nof}, {syn}, {trn}, {any}.
;-	file open words expect valid path to file -re- {path+file}, {f"}.
;-	permissions set to value from uvari {fperm}, dft 600o
;-	ret c := work-channel no. or error code, and flg := tf after success, or ff.
;-	actual fd stored to (work) and work-chp if open was successful.
;-	syscall open -re- man 2, and glossary "fd open flags".
openf:GA;:ok:
; c: ecx, edx(:=chp)
	xor edx,edx
.m:; ;<creaf, mopenf)
	push_ibyte(__NR_open)
.d:; ;<cread)
	mov ecx,eax		; access flags
	test edx,edx
	spop
	jg .p
	mov edx,[uref uv.ufperm]; permission bits
.p:
	push ecx,edx
	call ptystgq
	pop edx
	mov eax,[esp]
	mov [esp],ecx		; pty-flg (bit #25)
	mov ecx,eax
	spop			; drop n1
	call placeps		; eax: old PS = stg, @(eax-4) stg, PS := below local stg
	pushad
	call wclose
	readad ecx,ecx		; amode
	readad edx,edx		; perm
	readad ebx,eax		; string
	mov eax,[esp s_tor+4]	; syscall code
	sys_generic
	writead ecx,eax		; ernum or fd
	readad ebx,ebx
	push ecx		; access flags
	call getwork
	pop dword[kref ecx+cdt.acfl-cdt]; access flags
	mov [kref ecx+cdt.perm-cdt],edx	; permission bits
	mov [kref ecx+cdt.chid-cdt],eax	; channel id (linux fd)
	mov [kref ecx+cdt.chpt-cdt],dword 0; no extended channel descr
	readad edx,tor
	mov [kref ecx+cdt.iofl-cdt],edx	; sto pty-flg
	writead edx,ecx
	test eax,eax
	popad
	mov PS,eax
	lea esp,[esp+8]		; drop pty-flag
	mov eax,0
	jng .x
	mov ecx,workch
	dec eax
.x:
	mov TOS(1),ecx
	ret
;-
;- --		( -- )						'slsl'		root
;-	optional, active initial arguments terminator; a noop used for termination 
;-	by <argcopy> at program startup. - should be passed as a single argument!
slsl:GA;:ok:
	ret
;-
;- ss		( -- )						'ss4'		root
;-	required for shell script execution, after {#! /path/executeable}:
;-	copy stdin, stdout, stderr to {in-chan}, {out-chan}, {err-chan},
;-	fetch next space delimited argument/string and execute {included}.
;-	while executing the scriptfile itself is source to {stdin}, PIPEd
;-	or redirected i/o channels can then be referred w/ the copied id-s.
;-	use {include}, instead, to omitting the i/o channels setup.
;-	optional words may be inserted between path to lib4th executable 
;-	and {ss} - or {include} - being executed before script execution 
;-	starts. the entire line, after path to f8 but including the {ss} 
;-	word, becomes 1st argument passed to the application:
;-		#! /usr/local/bin/f8 { optional words } ss
;-		(text of 4th script follows)
ss4:GA;:ok:
	spush
	mov eax,[kref incnv-Y]
	call stdinc
	call sschan
	spush
	mov eax,[kref outcnv-Y]
	call stdoutc
	call sschan
	spush
	mov eax,[kref errcnv-Y]
	call stderrc
	call sschan
;-
;- include	ccc( -- )							forth
;-	open and include source text from file ccc, re {include-file}
;-	search {f8dir} and {path} if ccc is not a fully qualified file-name
include:GA;:ok:
	lea ecx,[kref name-Y]
	call .n
	jr included
.n:A
	call pad
	call pagesize
	call ecx
	jmp bfnameb
;-
;- include?	www ccc( -- )					'qincludeq'	forth
;-	a no-op if word www already accessible, else -re- {include} file ccc.
includeq:GA;:ok:
	call blwf
	spop 2
	jnz near blword
	jr include
;-
;- include"	ccc( -- )					'includeqte'	forth
;-	include source from filename <ccc>, delimited by a quote <">.
;-	search {f8dir} and {path} if ccc is not a fully qualified file-name
includeqte:GA;:ok:
	lea ecx,[kref sqte-Y]
	call include.n
;-
;- included	( .xx. p u -- .yy. | abort )	(a:f)		'included'	forth
;-	non-blocking open r/o file w. name+path p,u and {include-file}.
;-	abort w. error message on open error.
;-	an abort while compiling leaves all data on stack and returns the 
;-	rsp tib address and 1's-complement of the error line's <eol> position.
included:GA;:ok:
	call rbyof	; r/o
	or eax,O_NONBLOCK
	call openf	; open-file
	test eax,eax	; test error
	jns .e		;?; error
	not eax		;->
	mov TOS(1),eax	; 0
.e:
	mov eax,TOS(1)	; pass message code
	call qerror
	call newchan	; get top unused channel no.
	spush
	call ischan	; transfer work-data to new chp
;-
;- include-file	( .xx. c -- .yy. )		(a:f)		'ifile'		forth
;-	save current input source description, revert to -re- {int} mode,
;-	redirect file input by channel no. to stdin,
;-	un-nesting, early termination by return to {quit}.
ifile:GA;:ok:
	call ipushio	; store current i/o parameter, assign local {tib}
	call intf	;(prevent segfaults from false numeric conversion)
	mov ecx,eax
	or ecx,byte cdt_num
	mov [byte uref uv.sourceid],ecx	; c|cdt_num -> {source-id} > 0
;input channels redirection
	call stdinc	;
	call tochan	;
	mov dword[byte uref uv.blk],-1; initial file pointer
	mov dword[byte uref uv.span],0;force new input
	jmp bquitb.c	;>; inner interpreter
;-
;- file-size	( c -- un|er )			(s)(a:f)(e)	'fsizef'	forth
;-	32-bit file size un or error code, by channel no. c
;-	syscall fstat -re- man 2 ...
;-	(eflags reflect error code)
fsizef:GA;:ok:
	call chid
	js .r
.n:;	;<copyf)
	push eax	; fd
	push PS		; buf
	call statsize
	add PS,eax
	pop ecx		; mem
	mov eax,[esp]
	mov [esp],ebx
	mov ebx,eax
	sys_fstat
	pop ebx
	test eax,eax
	mov edx,[ecx+stat.st_size]
	mov PS,ecx
	js .r
	mov eax,edx
.r:
	ret
;-
;- stat-size	( -- +u )			(m)		'statsize'	forth
;-	required buf. size for {file-status} data structure.
statsize:GA M;:ok:
	spush
	mov eax,stat_size
M statsize
	ret
;-
;- file-status	( p1 +u p2 -- er|p2 )		(s)(a:fx)	'fstatf'	forth
;-	return error or ptr to description of file status, by path+name p1,u.
;-	required buf. size at p2 is linux kernel specific, re "asm/stat.h".
;-	NOTE: implementation conformant to DPANS 11.6.2.1524 is impossible!
;-	use -re- {fstat} to reading the file status by number of an open channel.
;-	syscall stat -re- man 2 ...
;-	lx kernel 2.2 stat structure ("SHORT" is 16-bit, half CELL):
;-		00 	SHORT st_dev	; device, zero for PIPE
;-			SHORT pad1
;-		04	CELL  st_ino	; inode
;-		08	SHORT st_mode	; protection
;-		0a	SHORT st_nlink	; number of hard links
;-		0c	SHORT st_uid	; user ID of owner
;-		0e	SHORT st_gid	; group ID of owner
;-		10	SHORT st_rdev	; device type (if inode device)
;-			SHORT pad2
;-		14	CELL  st_size	; total size, in bytes
;-		18	CELL  st_blksize; blocksize for filesystem I/O
;-		1c	CELL  st_blocks	; number of blocks allocated
;-		20	CELL  st_atime	; time of last access
;-		24	CELL  unused1
;-		28	CELL  st_mtime	; time of last modification
;-		2c	CELL  unused2
;-		30	CELL  st_ctime	; time of last change
;-		34	CELL  unused3
;-		38	CELL  unused4
;-		3c	CELL  unused5
fstatf:GA;:ok:
; c: ecx,edx
	mov ecx,eax	; destn ptr p2
	spop
	call placeps	; eax:=PS, PS:=PS+u
	pushad
	add ecx,KR
	mov ebx,eax
	sys_stat
	writead edx,eax
	popad
	mov PS,eax
	spop
	mov eax,ecx
	test edx,edx
	jns .r
	mov eax,edx
.r:
	ret
;-
;- flush-file	( c -- er )			(s)(a:fx)	'flushf'	forth
;-	assure all rsp. data cached by system flushed to fd, re man(2) fdatasync.
;-	syscall flush -re- man 2 ...
flushf:GA;:ok: i.e. w.o. error - actual data transfer not checked,
; final test left to emergency case, when linux irregularly aborted...
	call chid
	js .r
	push ebx
	sys_fdatasync eax
	pop ebx
.r:
	ret
readf.p:
	spop 3
;-
;- read-file	( p +u1 c -- u2 er )		(s)(a:f)	'readf'		forth
;-	read +u1 chars into buf. of size u1, or until <eof>.
;-	u2 is no of received bytes.
;-	er<0 is an error, regardless of u2; er=0 and +u2=0 is <eof>.
;-	syscall read -re- man 2 ...
readf:GA;:ok:;:HIER: what about non-/blocking mode?
; c: ecx
	call chid
	js near rotd
	push edx,ebx
	mov ecx,TOS(2)
	mov edx,TOS(1)		; size
	lea ecx,[kref ecx]	; buf
	mov ebx,eax		; fd
	sys_read
	pop edx,ebx
	test eax,eax
	TOSPULL(1)
	mov [kref edx+cdt.rnum],eax; := 0 at eof
	mov TOS(1),eax
	js .r
.f:
	xor eax,eax
.r:
	ret
rfalse:equ readf.f
; read-line		; ( p u ch --		[ ret p fd u
readp:A
	spush			; p u ch ch
	call fposf		; p u ch fp.fp er, edx:=chp
	cmp eax,ESPIPE
	jnz readf.p		;?; file
.n:
	spop 3			; drop fptr & rnum ( -- p u ch
	lea edx,[kref edx+cdt.fpos]; file-ptr 4th>abs
	mov eax,TOS(2)		; p
	push KR,dword[edx],edx,edi,dword TOS(1); [ u PS fpos @fpos KR
%xdefine fpt +8	; disp to adr of cdt.fpos @rs
	lea edi,[kref eax]	; buffer
	mov ebx,[edx-cdt.fpos+cdt.chid]	; fd
	lea ecx,[edx-cdt.fpos+cdt.ibuf]	; char-buf
	sub dword[edx],byte 1
	sbb dword[edx+4],byte 0
	mov edx,1
.l:
	mov eax,[esp fpt]	; cdt.fpos
	add dword[eax],byte 1	; advance by byte
	adc dword[eax+4],byte 0
	mov eax,EOVERFLOW
	dec dword[esp]
	js .x			;?; done, ret err.bo
	sys_read
	cmp eax,byte 1
	jnz .x			;?; eof or error
	mov al,[ecx]
	stosb
	cmp al,[uref uv.ueol]
	jnz .l
	mov eax,1
.x:
	pop KR,ecx,edx,edi,1	; drop count, ret old fptr, rst regs
	mov [edx-cdt.fpos+cdt.rnum],eax; pass error code: 1(input ok), 0(eof), -ve(error)
	mov eax,[edx]
	sub edx,KR
	sub eax,ecx
	mov TOS(2),eax		; ret bytecount
	mov eax,-1		; mark success
	TOSPULL(1)
	or ecx,byte -1		; S for immediate ret
	ret
;-
;- read-line	( p +u1 ch -- u2 flg er )	(a:f)		'readl'		forth
;-	read at most +u1 chars until <eol> into buf. of size u1.
;-	return error code er and no. of received chars u2 until <eol> or u1.
;-	false flg and er<0 is an error, regardless of u2
;-	false flg and er=0 and +u2=0 is <eof>.
;-	flg=0 and er=EOVERFLOW(-75) if input ok & buffer full, no <eol> received.
;-	reading by bytes if ch is a pipe, {ch-fpos} advanced by count of bytes read 
;-	and, {ch-rnum} returns: 1 if input ok, 0 at eof, -ve after an error.
;-	NOTE1: fills buf. w. {read-file}, then scans for <eol> and
;-	       adjusts file pointer accordingly.
readl:GA;:ok:
;reading by lines: (e.g: 3 ch ch-id sp@ sys fcntl $4000 not and &10000 or 4 ch ch-id sp@ sys fcntl)
;woould block at eof -?- => :TEST:
	push dword TOS(1)	;		[ u
	push eax		; 		[ fd u
	push dword TOS(2)	;		[ p fd u
	call readp		;edx:=chp, tos{ er u'
	js .r			;?; ret ff & file access error or ok from pipe
	spush
	mov eax,[esp]		; p	{ p er u'	[ p fd u
	spush
	mov eax,TOS(3)		;	{ n2 p e u'
	push edx		; save chp
	spush
	mov eax,[uref uv.ueol]	;	{ c n2 p e u'
	call scan		;	{ u" p2 e u'	[ chp p fd u
	jz .n			;?; no <eol> -?- ret err.bo -?-
	call bkeol		;	{ uu p3 e u'	[ chp p fd u
	sub TOS(3),eax
	dec eax			; exclude 1st <nl>-char
	neg eax
	spush
	sar eax,31		; signed double
	spush			; disp
	mov eax,[esp+8]		; fd	{ fd ddisp p3 e u'
	call fposre		; adjust fptr to beginning of next line
	spop 4			;	{ u2 p3 e u'	[ chp p fd u
.q:
	pop edx			; chp
.r:
	lea esp,[esp+12]	; drop p,fd,u		[-/-
	mov ecx,[kref edx+cdt.rnum]
	spush
	test ecx,ecx
	jns .e;;jz .x;
	mov eax,ecx		; put -ve er
.e:
	sar ecx,31
	not ecx			; ff for reading error or err.bo
.x:
	mov TOS(1),ecx		; flg
	ret
.n:; ;		[ chp p fd u
	mov eax,TOS(3)
	cmp eax,[esp+12]	; buffer size
	TOSPULL(2)		; drop fd, p
	jnz .q			;?; eof
	pop edx
	mov dword[kref edx+cdt.rnum],EOVERFLOW; 'value too large...' if no <lf> present and buffer full
	jr .r
; ( p n -- p' n' ) ; find 2nd+ <eol> chars
; p: posn of last char of <eol> sequence, n: length of string until p
; ret adjusted ptr & length of non-<eol> chars.
bkeol:A;:ok:
	mov edx,TOS(1)		; p2
	mov ecx,eax		; n3
	lea edx,[kref edx]
	mov eax,[uref uv.ueol]
.c:
	shr eax,8
	jnz .n
.r:
	mov TOS(1),edx
	mov eax,ecx
	ret
.n:A
	cmp [edx-1],al
	jnz .r
	dec edx
	dec ecx
	jnz .c
	jr .r
;-
;- read-char	( ch -- c flg )					'readchar'	forth
;-	input from supplied channel, otherwise identical -re- {?ekey}
;-	no time-out, execute { ch ch-eof } to find out whether a file is at it's end.
readchar:GA
	spush
	call qinput
	mov edx,[uref uv.inchp]
	and dword[kref edx+cdt.iofl],~(mcflg); clr char received flag
	mov ecx,[kref edx+cdt.ibuf]
	add dword[kref edx+cdt.fpos],byte 1
	adc dword[kref edx+cdt.fpos+4],byte 0
	mov TOS(1),ecx
	ret
;-
;- rename-file	( p1 u1 p2 u2 -- er )		(s)(a:fx)	'renamf'	forth
;-	rename file p1,u1 to name p2,u2.
;-	syscall rename -re- man 2 ...
renamf:GA;:ok:
	push eax	; u2 >r
	spop
	push eax	; p2 >r
	spop
	call placeps	; store source
	mov ecx,[esp+4]	; p2
	mov [esp+4],eax	; save initial PS = source ptr
	pop eax		; u2
	spush
	mov eax,ecx
	call placeps
	push ebx
	mov ecx,eax	;
	mov ebx,[esp+4]
	sys_rename	; b:p1 c:p2
	pop ebx
	pop PS		; sdrop
	TOSPULL(1)
	ret
;-
;- reposition-file	( ud c -- er )		(a:f)		'reposnf'	forth
;-	set file-ptr of channel no. c to position ud.
reposnf:GA;:ok:
	spush
	mov dword TOS(1),SEEK_SET; seek_set swap
	call llseekf
	TOSPULL(2)	; -rot 2drop
	ret
;-
;- resize-file	( ud c -- er | abort )		(s)(a:f)	'resizef'	forth
;-	truncate writable file or extend with <nul> bytes, re man(2) ftruncate.
;-	VERIFY: <nul>s extension might be linux kernel version dependent.
;-	NOTE: ANS-std double cell (64bit) file size available w. linux 2.4. kernel,
;-	      until then {resize-file} will abort on size overflow into m.s. cell.
;-	syscall ftruncate -re- man 2 ...
resizef:GA;:ok:
	call chid
	mov ecx,eax
	spop
	js near rtrue
	test eax,eax
	mov eax,EOVERFLOW
	jnz near errorf
	spop
	pushad
	mov ebx,ecx	; fd
	mov ecx,eax	; fptr
	sys_ftruncate	; extends file w. <nul>s if fptr beyond eof!
	writead eax,eax
	popad
	ret
;-
;- write-line	( p u1 fd -- er ) 		(a:f)		'writeline'	forth
;-	send string p,u to file fd, append <eol> code(s) as defined in (ccr).
writeline:GA;:ok:
	push eax
	call writefile
	js .r
.n:; <eol> from uvari
	mov TOS(1),eax	; ernum
	lea eax,[uref uv.ueol]
	sub eax,KR
	call zcount
	spush
	mov eax,[esp]	; fd
	call writefile
	TOSPULL(1)
.r:
	TOSPULL(1)
	lea esp,[esp+4]
	ret
;-
;- WRITE-FILE	( p u1 c -- er )		(s)(e)(a:f)	'awritefile'	ans
;-	write data from buf. p,u1 to file fd, er := 0 or error code. - ANS-mode 
;-	syscall write -re- man 2 ...
awritefile:GA;:ok:
	lea ecx,[kref drop-Y]
	push ecx
;-
;- write-file	( p u1 c -- u2 er )		(s)(e)(a:f)	'writefile'	forth
;-	write data from buf. p,u1 to file fd, ret u2 no. of data sent.
;-	syscall write -re- man 2 ...
writefile:GA;:ok:
; c: ret eflags
	call chid
	js near rotd
	mov [byte uref uv.outchp],edx	; chp in use
	mov ecx,eax
	lea edx,[kref edx]
	spop
	pushad
	add TOS(1),KR
	mov ebx,ecx
	mov ecx,TOS(1)
	mov edx,eax
	sys_write
	readad edx,edx
	mov [edx+cdt.rnum],eax
	mov TOS(1),eax
	popad
	mov eax,TOS(1)
	test eax,eax
	js .r
	xor eax,eax
.r:
	ret
;-
;- kbd-type	( p u -- )			(e)		'kbdtype'	forth
;-	send a string to the keyboard channel
;-	use { kbd ch-rnum } for error code.
kbdtype:GA
	call kbdc
	call writefile
	spop 2
	ret
;-
;- kbd-emit	( c -- )			(e)		'kbdemit'	forth
;-	{emit} to keyboard channel
;-	use { kbd ch-rnum } for error code.
kbdemit:GA
	call kbdc
;-
;- write-char	( c ch -- )			(s)		'writechar'	forth
;-	emit a single multi-byte (up to four) char to channel ch
;-	use { ch ch-rnum } for error code.
writechar:GA
	mov ecx,eax
	call getstdin.n
	push ebx,ecx	; save kref & cdt
	spop
	call cbytes	; edx := bytecount
	mov ebx,[kref ecx+cdt.chid-cdt]
	mov [PS],eax	; store char
	mov ecx,PS	; buf
	sys_write
	pop ebx
	add ebx,[esp]	; kref'd
	mov [ebx+cdt.rnum-cdt],eax; store ernum
	pop ebx
	spop
	ret
;-
;- file-position  	( c -- ud er )		(s)(a:f)	'fposf'		forth
;-	return file-ptr
fposf:GA;:ok:
	mov ecx,eax
	xor eax,eax	; disp
	spush 2		; dn
	mov eax,ecx	; fd	:continues: in <fposre>
;-	
;-
;--------------------------------------------
;- -- linux specific file opr's, not in ANS-std
;-	
;-
;args to syscalls: ebx,ecx,edx,esi,edi

;-
;- fposre 	( d1 c -- d2 er )		(s)(f6)				linux
;-	set file-ptr by displacement d1 to current posn,
;-	return current file-pointer value, {lseek} w. SEEK_CUR
fposre:GA;:ok:
	spush	; SEEK_CUR swap
	mov dword TOS(1),SEEK_CUR
;-
;- llseek  	( d1 n2 c -- ud2 er )		(s)		'llseekf'	linux
;-	syscall _llseek w. d1=signed offset, n2=relation, c=channel; -re- man 2 ...
;-	n2	offset set to
;-	 0 SEEK_SET	unsigned d1 bytes.
;-	 1 SEEK_CUR	it's current location plus signed d1 bytes.
;-	 2 SEEK_END	eof plus signed d1 bytes.
;-	ret ud2 := new file ptr, er := ernum.
;-	file offset may be set beyond the end of the existing end-of-file. If data 
;-	later written at this point, subsequent reads in the gap return <nul>-bytes.
llseekf:GA;:ok:
; o: edx = chp if successful
	call chid	; edx:=chp
	js near rotd
	push ebx,edx,esi,edi
; llseek does not store acessed chp!
	or dword[byte kref edx+cdt.fpos],byte -1
	or dword[byte kref edx+cdt.fpos+4],byte -1
	mov ebx,eax	;   fd
	lea esi,TOS(3);[edi-8]	;ptr to result, d1 overwriting
	mov edx,TOS(3)	; n1 disp.lo
	mov ecx,TOS(2)	; n1 disp.hi
	mov edi,TOS(1)	; n2 flags
	sys_llseek	; b:fd c:disp.hi d:disp.lo esi:res edi:whence
	pop ebx,edx,esi,edi
	mov ecx,TOS(3)	; fptr.lo
;;	mov [byte kref edx+cdt.rnum],ecx;;;
	mov [byte kref edx+cdt.fpos],ecx
    %if __KERNEL__ > 22
	mov ecx,TOS(2)	; fptr.hi
    %else
	sar ecx,31
	mov TOS(2),ecx
    %endif
	mov [byte kref edx+cdt.fpos+4],ecx
	TOSPULL(1)
	ret
;-
;- copy-file	( p1 u1 p2 u2 -- er )		(s)		'copyf'		forth
;-	fast, kernel-space only file transfer by file names;
;-	copy in-file(p1,u1) overwriting to out-file(p2,u2).
;-	ret er:=error code or er:=no. of bytes sent. no ernum in {work}-cdt.
;-	ret w/ out-file un-modified if in-file opening returns an error.
;-	copy by channel numbers -re- {file>file}.
;-	syscall sendfile -re- man(2) sendfile.
;-	NOTE:	source restricted to channels which support <mmap> 
;-		operations, destination may be a socket.
;-		for instance, cannot be used to reading /dev/vcs{,a}.
copyf:GA;:ok:
	pushad
	call swap2	; try in-file 1st (prevent truncating an existing dst if false src)
	call rbyof	; r/o
	call openf	; open-file
	test eax,eax
	mov eax,TOS(1)	; in-fd or..
	jz .r		;?; ..open error
	call newchan
	push eax	;				[ in-chan
	call ischan	; lock this channel number
	mov eax,[esp]
	call chid
	mov ecx,TOS(3)	; p2
	mov TOS(3),eax	; save in-fd
	mov eax,TOS(2)	; <-u2
	pop dword TOS(2); in-chan			[ -/-
	mov TOS(1),ecx	; <-p2
	call rbywf
	or eax,O_ANYF
	call creaf	; create-file (destn)
	test eax,eax
	mov edx,eax	; ernum for early exit
	mov eax,TOS(1)	; out-fd or ernum
	jz .i		;?; on error close in-file and exit
	call chid
	push eax	; save out-fd			[ out-fd
	mov eax,TOS(2)
	call fsizef.n
	mov esi,eax	; pass file size
	mov ecx,TOS(3)	; pass in-fd
	xor eax,eax
	lea edx,TOS(1)	; pass ptr to posn
	mov [PS],eax
	mov [edx],eax	; begin copying at posn 0
	pop ebx		; pass out-fd			[ -/-
	sys_sendfile	; to, from, p, num
	mov edx,eax	; save ernum
	sys_close	; close out-file
.i:
	mov eax,TOS(2)	; in-chan
	readad ebx,ebx	; rst KR
	push edx	; save ernum
	call closef	; close by channel no.
	pop eax		; rst ernum
.r:
	writead eax,eax	; pass ernum/count of copied bytes
	popad
	TOSPULL(3)
	ret	
;-
;- file>file	( c1 c2 ud1 u2 -- er )		(s)		'f2file'	forth
;-	fast, kernel-space only file transfer, 
;-	send u2 bytes from channel c1 to channel c2, beginning at file-ptr ud1.
;-	ret er = error code or er = no. of bytes sent; no channels being closed.
;-	copy by file names -re- {copy-file}.
;-	syscall sendfile -re- man(2) sendfile, man(2) mmap.
;-	NOTE:	source restricted to channels which support <mmap> operations,
;-		destination may be a socket but, not the source channel.
f2file:GA;:ok: -?-
	pushad
	mov eax,TOS(4)	; c1 in-channel
	call chid
	mov TOS(4),eax	; -> in-fd
	mov eax,TOS(3)	; c2 out-channel
	call chid	; eax:=out-fd
	or ecx,eax	; ernum?
	js .r
	mov ecx,TOS(4)	; in-fd
	lea edx,TOS(2)	; ptr to lo dword of fptr
	readad esi,eax	; len
	mov ebx,eax	; out-fd
	sys_sendfile	; to, from, p(fptr), num
	mov ecx,eax
.r:
	writead eax,ecx	;ernum
	popad
	TOSPULL(4)
	ret
;-
;- fstat  	( c p -- er|p )			(s)		'ffstatf'	linux
;-	fetch file channel c status data to buf. of size {stat-size} at p.
;-	use -re- {file-status} to reading the file status by file name.
;-	syscall fstat -re- man 2 ...
ffstatf:GA;:ok:
	lea ecx,[kref eax]
	push ebx,ecx
	spop
	call chid
	pop ecx		; buf.
	js .r
	mov ebx,eax	; fd
	sys_fstat
	pop ebx		; kref
	test eax,eax
	js .r
	mov eax,ecx
	sub eax,KR	; ptr to buf.
.r:
	ret
;-
;- cd	  	ccc( -- )			(4)(i)		'cdf'		root
;-	change working directory to {bl}-delimited path ccc.
;-	no error message, noop if path doesn't exist; $HOME if zero length text.
;-	use -re- {s"} or {string} and {chdir} for path names w/ blanks.
cdf:GA;:ok:
	call BLWORD
	call ccount
	call sliteral
	call ccplq
	jnz .c
;-
;- (cd		( p u -- )					'pcdp'		novoc
pcdp:
	test eax,eax
	jg .d		; path given
	spop 2
	call ehome	; default to home dir
.d:
	call chdirf
	spop
	ret
cdf.c:
	TICK pcdp
	jmp compilec
;-
;- chdir  	( p u -- 0 | er )		(s)		'chdirf'	linux
;-	change working directory to path (p,u)
;-	syscall chdir -re- man 2 ...
chdirf:GA;:ok:
	call placeps	; tmp. store asciz name
	push eax,ebx	; save ptr to name & kernel-ref
	sys_chdir eax	; ptr to path
	pop ebx		; kernel-ref
	pop PS		; restore PS
	TOSPULL(1)	; swap drop
	ret
;-
;- pwd		( -- )								linux
;-	print working directory (to stdout).
pwd:GA;:ok:
	spush
	mov eax,[byte uref uv.s0]
	call pathmax
	spush
	shr eax,2
	push eax
	call toloc
	call cwdf
	call type
	spush
	pop eax
	jmp toloc.d
;-
;- cwd@		( p1 u1 -- p1 u2 | er )		(s)		'cwdf'		linux
;-	fetch current working directory path to buf(p1,u1), 
;-	ret stg(p1,u2) or, p1 and -ve error code. 
;-	buffer limited to u bytes, by syscall, max up to { path-size 2+ }. 
;-	syscall getcwd -re- man 2 ... 
cwdf:GA;:ok:
	push ebx		; save kernel-ref
	add ebx,TOS(1)		; buf
	mov dword[ebx],0
	sys_getcwd EMPTY,eax	; buf.
	test eax,eax
	js .r
	mov eax,ebx
.l:
	cmp byte[ebx],1
	inc ebx
	jnc .l
	sub eax,ebx
	not eax
.r:
	pop ebx
	ret
;-
;- umask  	( n -- )			(s)		'umaskf'	linux
;-	set new files permissions creation mask
;-	syscall umask -re- man 2 ...
umaskf:GA;:ok:
	mov ecx,ebx
	mov ebx,eax
	sys_umask
	mov ebx,ecx
	ret
;-
;- file access query modifiers

;-
;- r-ok		( -- n )			(m.6)		'rok'		forth
;-	readable, file access query flag
rok:GA M;:ok:
	spush
	mov eax,R_OK
M rok
	ret
;-
;- w-ok		( -- n )			(m.6)		'wok'		forth
;-	writable, file access query flag
wok:GA M;:ok:
	spush
	mov eax,W_OK
M wok
	ret
;-
;- x-ok		( -- n )			(m.6)		'xok'		forth
;-	executable, file access query flag
xok:GA M;:ok:
	spush
	mov eax,X_OK
M xok
	ret
;-
;- f-ok		( -- n )			(m,6)		'fok'		forth
;-	file present, file access query flag
fok:GA M;:ok:
	spush
	mov eax,F_OK
M fok
	ret
;-
;- faccess	( n c -- er )			(s)		'faccessfd'	linux
;-	test file access perm by channel no. c w/ query mask n
;-	ret er = ff if accessible, else -ve. -re- {file-access}.
faccessfd:GA;:ok:
	call chid
	js faccessf.r
	push dword TOS(1)	; flgs
	mov ecx,dataptr
	mov edx,eax		; chan
	mov TOS(1),ecx		;	{ p
	mov eax,d_npad		;	{ u p
	spush
	mov eax,edx		;	{ c u p
	call chname
	spush
	pop eax			;	{ n u p
	jr faccessf
;
paccessf:A;<path+file)
	call dup2
	spush
	mov eax,F_OK
;-
;- file-access	( p u n1 -- 0 | er )		(s)(a:fx)	'faccessf'	forth
;-	n1 OR-able flags {r-ok}, {w-ok}, {x-ok}, {f-ok}.
;-	ret zero if caller has access according to flag n1 to file the 
;-	path+name of which is u chars at p, else ret -ve error code. 
;-	syscall access -re- man 2 .., linux/fs/open.c.
;-	security relevant applications should check _after_ open.
;-	NOTE: syscall by <root> returns root permissions, i.e. all enabled.
faccessf:GA;:ok:
	mov ecx,eax		; mode
	and eax,(-1<<F_OK)&(-1<<R_OK)&(-1<<X_OK)&(-1<<W_OK); -?-
	mov eax,EINVAL
	jnz near errorf 	;?; false flag value
	spop
	call placeps
.n:
	pushad
	mov ebx,eax		; path
	sys_access		; *path, mode
	writead ecx,eax
	popad
	mov PS,eax
	TOSPULL(1)
	mov eax,ecx
	test ecx,ecx
	jle .r			;?;
	mov eax,EINVAL
.r:
	ret
;-
;- unlock-file	( ch -- er )			(s)(e)		'unlockf'	linux
;-	clear lock on a file by channel ch, 
;-	syscall -re- man 2 fcntl
;-	(eflags reflect error code)
unlockf:GA
	push_ibyte(F_UNLCK)
	jr lockf.n
;-
;- lock-file	( ch -- er )			(s)(e)		'lockf'		linux
;-	set lock on a file by channel ch, 
;-	disabling write access by any other file descriptor.
;-	syscall -re- man 2 fcntl - returns error free but, no effect... <=
;-	(eflags reflect error code)
lockf:GA
	push_ibyte(F_RDLCK)
.n:
; :HIER: setgid and chmod g-x :HERE: - re linux/Documentation/mandatory.txt -?-
	push PS
	spush 4
	call fsizef
	js .r
	call swap
	call chid
	js .r
	call pidf
	mov edx,[esp]
	push ebx
	mov ecx,TOS(2)
	mov ebx,TOS(1)
;.l_type	SHORT	1 ;0(half cell)	; 0)F_RDLCK, 1)F_WRLCK, 2)F_UNLCK
;.l_whence	SHORT	1 :2		; 1)LOCK_SH|LOCK_NB, 2)LOCK_EX|LOCK_NB, 4)LOCK_NB, 8)LOCK_UN
;.l_start 	LONG	1 ;4 off_t	;
;.l_len		LONG	1 ;8 off_t	;
;.l_pid		SHORT	1 ;C pid_t	;
	mov [edx+flock.l_pid],eax
	mov [edx+flock.l_len],ecx
	mov ecx,[esp+8]
	mov dword[edx+flock.l_type],ecx	; un-/lock
	mov dword[edx+flock.l_whence],LOCK_EX;|LOCK_NB;LOCK_SH; => |LOCK_NB <= -22 'invalid arg..'
	mov dword[edx+flock.l_start],0
;cmd:	 F_SETLK, F_GETLK
;    DUMP edx,':F:',l
	mov ecx,F_SETLK
	sys_fcntl
	TOSPULL(1)
	pop ebx
.r:
	lea esp,[esp+8]
	TOSPULL(4)
	ret
;-
;- <decnum>					(k)
;-	asciz unsigned decimal number string, for {ch-name}
decnum:A
	spush
	xor eax,eax		; d.c u1 p1
;-
;- <decdnum>					(k)
;-	asciz unsigned decimal number string
decdnum:A
	push dword[byte uref uv.base]
	mov dword[byte uref uv.base],10; force decimal!
	call ltsharp
	spush
	xor eax,eax
	call hold		; <nul> terminator
.n:;	;<"date, "time)
	call sharps
	call sharpgt		; u# p# u1 p1
	pop dword[byte uref uv.base]
	ret
;-
;- ch-name	( p1 u1 c -- p1 u2 | p1 0 )	(s)		'chname'	forth
;-	find path and filename of channel c. - requires "proc" filesystem accessible.
;-	returns valid name w. +ve u2 or, on error u2:=0; does not store a count-byte.
;-	error code stored to uvari {(ierr)}, -1 if channel c was not open.
;-	uses {hld} area, below {pad2}, overwritten by words for numeric stg output.
;-	syscall readlink -re- man 2 ..
chname:GA;:ok:
	call chid		; edx is chp
	js .q			;?; channel unused
	push edx		;			[ chp
	call decnum
	mov ecx,stdoutpt.e-stdoutpt; us devname
	mov eax,TOS(1)	; p#	; p#
	sub eax,ecx	; pd	; pd
	push eax	;			[ pd
	mov eax,stdoutpt-Y; ps	; ps p# u1 p1
	spush
	mov eax,[esp]	; pd	; pd ps p# u1 p1
	spush
	mov eax,ecx	; ud	; ud pd ps p# u1 p1
	call xcmove		; prepend path to fd
	pop eax			; p2 u1 p1
	mov ecx,TOS(2)		; p1
	mov edx,TOS(1)
	push KR
	lea ecx,[kref ecx]	; p1->a1
	lea ebx,[kref eax]	; p2->a2
	sys_readlink ebx,ecx,edx
	test eax,eax
	pop KR
	pop edx
.q:
	mov [byte uref uv.ierr],eax
	jg .r
	xor eax,eax
.r:
	TOSPULL(1)
	ret
;-
;- readlink	( p1 p2 u2 -- p u )		(s)		'readlk'	linux
;-	resolve linkname per asciz-string at p1 to filename (p,u) in buf. (p2,u2)
;-	syscall readlink -re- man 2 ...
readlk:GA;:ok:
	mov ecx,TOS(1)		; p2 buf
	mov edx,eax		; u2 bufsiz
	lea ecx,[kref ecx]	; a1 buf
	push ebx
	mov eax,TOS(2)		; p1
	lea ebx,[kref eax]	; a1
	mov TOS(2),eax
	sys_readlink		;b:=name,c:=buf,d:=bufsize
	TOSPULL(1)
	pop ebx
	test eax,eax
	ret
;- 

;-
;- <placeps>	( p1 u1 -- a2 ..cc.. a3 )	(k)
;-	(supposedly) thread-safe temporary local string conversion & storage:
;-	temporarily store u1 chars of stg from p1 to asciz stg on tos,
;-	ret a2 ptr to strg { a2: a3 abs>4th cell- @ }, a3 initial PS, PS:=PS+u1
;-	NOTE:	for "lib4th" kernel, or within native code words, only!
;-		PS should be restored before any regular access to datastack.
placeps:A;:ok:
;	used in {file-access}, {file-status}, {open-file}, {create-file}, 
;		{rename-file}, {delete-file}, {search-wordlist}
; c: -/-
	pushad
	writead eax,edi	; save current PS to eax
	mov esi,TOS(1)	; name
	mov TOS(1),PS
	add esi,KR	; true src address
	mov ecx,eax	; c:length
	mov ebx,PS	; == edi
	rep movsb	; tmp. store filename to below tos
	mov dword[PS],0	; make it asciz
	lea PS,[PS+8]	;edi: min 3 spare zeroes
	and PS,byte -4	; 4-aligned
	writead edi,edi	; thread safe value
	popad
	ret
;
fsearch:GA
%if 1; use :mmap:
%endif
;
searchf.z:A
	mov ecx,23		; 'off working area'
searchf.r:
	mov eax,ecx		; ernum
searchf.x:
	TOSPULL(1)		; drop type-flag
	xor ecx,ecx
	mov TOS(1),ecx		; zero disp
	mov TOS(2),ecx
	ret
;-
;- search-file	( p1 u1 ch -- d2 0 | dx er )	(s)		'searchf'	forth
;-	search file by channel ch for stg(p1,u1) beginning at current file-ptr.
;-	terminates if stg found or at <eof>, <nul> and after <nl> if ch is a console.
;-	if stg found ret disp of file-ptr from entry to end of stg and er = 0
;-	if stg not found ret byte-count until eof and er = ENODATA (-61).
;-	stg(p1,u1) may be up to {path-max} bytes of length.
;-	reading by single bytes, thus slow but, suitable to any kind of input.
searchf:GA;:ok:
	push eax
	call consq
	and eax,AC_LF		; terminator if input is console
	spush
	pop eax
	call chid
	js .x			; no channel
	mov ecx,TOS(2)		; u1
	test ecx,ecx
	jng .r			;?; empty stg is always 'found', or error if -ve
	cmp ecx,pthfsize
	jnc .z
	spush
	mov eax,[byte uref uv.s0]; b1
	spush
	mov eax,pthfsize/4+1
	spush			; dup
	call toloc		; allocate
	spush
	mov eax,tcharchar-Y
	test dword[byte uref uv.bits],mcaps
	jz .v			;?; no char conversion
	mov ecx,[uref uv.uhi2lo]
	test ecx,ecx
	jz .v
	mov eax,ecx
.v:
	add eax,KR		; true addr of char conv table
	kloci 11		; p1 u1 fd buf1 buf2 #l cv n1 n2 n3 n4
.f1:	klocz			; fileptr, l.s. cell
.f2:	klocz			; fileptr, m.s. cell
.u1:	klocz			; count of converted search-stg
.p1:	klocz			; ptr to 1st char of converted search-stg
.cb:	klocz			; charbuf
.cc:	klocz			; tmp. char-count while comparing
.cv:	klocv			; character conversion table
.nl:	klocv			; locally alloc. cells count
.b1:	klocv			; 1st local buf
.fd:	klocv			; input fd
.te:	klocv			; terminator flag, AC_NL if console
	test dword[byte uref uv.bits],mcaps
	jz .p			;?; no char conversion
	lea ecx,[eax+1]
	spush
	mov eax,[lref .b1]
	spush
	mov eax,ecx
	call s2lower
.p:
	mov ecx,eax
	mov [lref .u1],eax	; count
	mov eax,[lref .b1]
	spush
	add eax,KR
	mov [lref .p1],eax	; true addr of 1st char
	mov eax,ecx
	call move		; search-stg at (p1,u1) in buf(b1)
	spush
	xor eax,eax		; clr result flag/workspace
	push edi,ebx
	mov edx,1		; fetch single char
	mov ebx,[lref .fd]	; fd
	lea ecx,[lref .cb]	; in-buf
.l:
	call .k
	jng .e			;?; error or eof
	movzx eax,byte[ecx]	; char from file
	cmp eax,[lref .te]
	jz .e			;?; <eol> by console
	add eax,[lref .cv]	; ptr into table
	mov al,byte[eax]	; translated char
.o:
	mov edi,[lref .p1]	; 1st char
	cmp al,[edi]
	jnz .l			;?; continue searching
	mov eax,[lref .u1]
	dec eax
	jz .e			;?; ready if len=1
	mov [lref .cc],eax
.i:
	inc edi
	call .k
	jng .e			;?; eof, or error
	movzx eax,byte[ecx]	; char from file
	cmp eax,[lref .te]
	jz .e			;?; <eol> by console
	add eax,[lref .cv]	; ptr into table
	mov al,byte[eax]	; translated char
	cmp al,[edi]
	jnz disp .o
	dec dword[lref .cc]
	jnz disp .i		;?; more
	xor eax,eax
.e:
	pop edi,ebx
	mov ecx,eax
	mov eax,[lref .f1]
	mov edx,[lref .f2]
	spush
	mov eax,edx
	spush
	mov eax,ecx
	spush
	mov eax,[lref .nl]
	neg eax
	call toloc
	ret
; in: eax xx, ebx fd, ecx buf, edx 1, edi stg, esi lref, TOS(1,2) fptr
;out: eax er,	-/-					 TOS(1/2) 1 m+!
.k:A
	sys_read
	cmp eax,EAGAIN
	jz .k			;?; retry
	test eax,eax
	js .n			;?; error
	mov eax,ENODATA
	jz .n			;?; <eof>
	add dword[lref .f1],edx	; d1+
	adc dword[lref .f2],byte 0; inc fileptr
	and eax,edx		; eax:=1
.n:
	ret
;-
;- -- files/devices locking (n.i.)
;-
;-	


;-
;- -- files/devices memory mapping
;-	{mmap} selects appropriate access method, returns base address or error;
;-	{msync} for syncronization of data w/ file; {munmap} reverts assignations.
;-	

;-
;- mmap		( p1 u1 m f fd o -- p2|er )	(s)				linux
;-	maps u1 bytes of file/device w/ file-descriptor fd, beginning at offset o
;-	bytes, to memory, preferrably at p1, the actual value of which is returned 
;-	by page-aligned ptr p2 or, an error code er if in range 0 < p < $ffff0000.
;-	args:
;-	p1	if zero the system call returns p2 chosen by host kernel, 
;-		if flag MAP_FIXED set, p2 will forcedly be set to p1, or failure, 
;-		any non-zero p1 will be page-aligned towards higher addresses.
;-	u1:	(partial) file size to map into memory
;-	m:	access mode -re- {prot-r}, {prot-w}, {prot-x} or, neither one.
;-	f:	flags (re sys/mman.h),
;-		either one of MAP_SHARED or MAP_PRIVATE required, others otional:
;-			MAP_SHARED      0x01    Share changes
;-			MAP_PRIVATE     0x02    Changes are private
;-			MAP_FIXED       0x10    Interpret addr exactly, fail otherwise
;-			MAP_ANONYMOUS   0x20    don't use a file
;-			MAP_GROWSDOWN   0x0100  stack-like segment
;-			MAP_DENYWRITE   0x0800  ETXTBSY
;-			MAP_EXECUTABLE  0x1000  mark it as an executable
;-			MAP_LOCKED      0x2000  pages are locked
;-			MAP_NORESERVE   0x4000  don't check for reservations
;-	fd:	file descriptor of file to map, -re- {ch-id}
;-	o:	file ptr to where to begin mapping.
;-	sys_mmap receives the data structure:
;-		00: 0 or preferred/forced address,
;-		04: length of file, may be partial length,
;-		08: mode
;-		0C: flags
;-		10: file descriptor,
;-		14: offset wrt file beginning, a multiple of -re- {page-size}.
;-	syscall re man (2) mmap
mmap:GA;:ok:
	spush
	mov ecx,6*4+4
	call qdepthb	; abort if less than 6 args
	lea ecx,TOS(6)
	mov edx,KR	; save ebx
	mov eax,[ecx]	; ( p1 u1 m f fd o p1
	test eax,eax
	jz .p		;?; null-ptr
	lea eax,[kref eax+PAGE_SIZE-1]
	and eax,PAGE_MASK; true, page-aligned address
	mov [ecx],eax
.p:
	sys_mmap ecx
	cmp eax,-4096
	mov KR,edx
	ja .r
	sub eax,KR
.r:
	TOSPULL(6)
	ret
;-
;- munmap 	( p u -- er )			(s)				linux
;-	un-map range u at ptr p, mapped file not guaranteed to be updated 
;-	accordingly unless prior execution of -re- {msync}.
;-	syscall re man (2) munmap
munmap:GA
	mov ecx,2*4
	call qdepthb	; abort if less than 2 args
	lea ecx,TOS(1)
	mov edx,KR
	add [ecx],KR
	sys_munmap ecx
	mov KR,edx
	TOSPULL(1)
	ret
;-
;- msync  	( p u n -- er )			(s)				linux
;-	synchronize rsp. file w/ mapped range u at ptr p, according to flags n:
;-		MS_ASYNC        1  sync memory asynchronously
;-		MS_INVALIDATE   2  invalidate the caches
;-		MS_SYNC         4  synchronous memory sync
;-	syscall re man (2) msync
msync:GA
	mov ecx,3*4
	call qdepthb	; abort if less than 3 args
	lea ecx,TOS(2)
	push KR
	add [ecx],KR
	sys_msync ecx
	pop KR
	TOSPULL(2)
	ret
;-
;-
;-----------------------------------------------------------------
;- -- i/o channels (double) redirection - re <struc cdtd> in "lib4th.mac".
;-
;-	ANS term "fileid" in FILE wordsets is lib4th "channel number", in the 
;-	range of [0,63] pointing as an index into a table of channel specific 
;-	data, i.e. the actual file descriptor, access permission and mode bits, 
;-	several other flags, each of which is extendable by a (yet unused) 
;-	per-channel link to further data.
;-	ch-id, "channel identifier", is the linux file descriptor of a "channel"
;-	which, when set to -1 signifies an unused channels table.
;-
;-	The pre-compiled number of available channels -re- {max-chan} can 
;-	be changed by re-definition of %assign-ed cdt_bnum (dft 6) in 
;-	"constants.inc", cdt tables re-sizeable with %assign-ed <cdt_bsize> 
;-	in "l4struc.inc".
;-

;-	

;-
;- stdin  	( -- c ) 			(m,5)		'stdinc'	forth
;-	actual standard input channel number
stdinc:GA M;:ok:
	spush
	mov eax,stdin
M stdinc
	ret
;-
;- stderr  	( -- c ) 			(m,5)		'stderrc'	forth
;-	actual standard error output channel number
stderrc:GA M;:ok:
	spush
	mov eax,stderr
M stderrc
	ret
;-
;- stdout  	( -- c ) 			(m,5)		'stdoutc'	forth
;-	actual standard output channel number
stdoutc:GA M;:ok:
	spush
	mov eax,stdout
M stdoutc
	ret
;-
;- work	  	( -- c ) 			(m,5)		'workc'		forth
;-	actual work-channel number
workc:GA M;:ok:
	spush
	mov eax,workch
M workc
	ret
;-
;- cdt-xptr	( -- n )			(c)(m,6)	'cdtxptr'	linux
;-	ret disp to xtension ptr in a channel's defn table
cdtxptr:GA M;:ok:
	spush
	mov eax,cdt.chpt-cdt
M cdtflags
	ret
;-
;- cdt-flags	( -- n )			(c)(m,6)	'cdtflags'	linux
;-	ret disp to flags in a channel's defn table
;-	-re- {channel}, {ch-rnum}, {ch-omode}, {ch-perm}, {ch-eof}.
cdtflags:GA M;:ok:
	spush
	mov eax,cdt.iofl-cdt
M cdtflags
	ret
;-
;- cdt-fptr	( -- n )			(c)(m,6)	'cdtfptr'	linux
;-	ret disp to double cell file ptr in a channel's defn table
;-	-re- {channel}, {ch-rnum}, {ch-omode}, {ch-perm}, {ch-eof}.
cdtfptr:GA M;:ok:
	spush
	mov eax,cdt.fpos-cdt
M cdtfptr
	ret
;-
;- cdt-size	( -- n )			(c)(m,6)	'cdtsize'	linux
;-	ret size in bytes of a single channel defn table.
cdtsize:GA M;:ok:
	spush
	mov eax,cdt_size
M cdtsize
	ret
;-
;- max-chan	( -- n )			(c)(m,6)	'maxchan'	linux
;-	ret max. number of available channel ptrs/numbers.
maxchan:GA M;:ok:
	spush
	mov eax,cdt_num
M maxchan
	ret
;-
;- kbd		( -- c )			(c)(m,5)	'kbdc'		forth
;-	initial keyboard channel, set from stdin
kbdc:GA	{equ maxchan}
;-
;- kbd-chan	( -- n )			(c)(m,6)	'kbdchan'	forth
;-	keyboard-channel number - system channel, not redirectable.
kbdchan:GA {equ maxchan}
;-
;- kbd-id  	( -- n )					'kbdid'		linux
;-	keyboard channel number
kbdid:GA;:ok:
; c: ecx := ch-flags
	spush
	mov eax,kbdch
	jr inid.n
;-
;- work-id	( -- n )					'workid'	linux
workid:GA;:ok:
; c: ecx := ch-flags
	spush
	mov eax,workch
	jr inid.n
;-
;- err-id 	( -- n )					'errid'		linux
errid:GA;:ok:
; c: ecx := ch-flags
	spush
	mov eax,stderr
	jr inid.n
;-
;- out-id 	( -- n )					'outid'		linux
outid:GA;:ok:
; c: ecx := ch-flags
	spush
	mov eax,stdout
	jr inid.n
;-
;- in-id  	( -- n )					'inid'		linux
inid:GA;:ok:
; c: ecx := ch-flags
	spush
	mov eax,stdin
.n:
;-
;- ch-id  	( c -- fd | abort-3 )				'chid'		linux
;-	file descriptor, n := -1 if fd not available.
;-	abort if c not in range [0,max-chan); dft -re- {max-chan} = 64 (L4 v10+).
;-	channel flags -re- {channel}, {ch-rnum}, {ch-omode}, {ch-perm}, {ch-eof}.
chid:GA;:ok:
; c:	ecx := ch-flags
;	edx := chp
;	eflags: NS if c is valid channel
	shl eax,cdt_bsize+2
.i:
	mov ecx,[byte uref uv.chans]	; chp
	lea edx,[eax+ecx]
	
	cmp eax,(cdt_num+1)*(1<<(cdt_bsize+2))
	mov eax,-1
	jnc .r
	mov eax,[kref edx+cdt.chid-cdt]	; fd
	mov ecx,[kref edx+cdt.iofl-cdt]	; flags
.r:
	test eax,eax			; S if not an active channel
	ret
;-
;- ch-omode	( c -- n )			(m,10)		'chomodef'	linux
;-	channel open mode. dft is un-set, n=0
chomodef:GA M;:ok:
	shl eax,cdt_bsize+2
	add eax,[byte uref uv.chans]
	mov eax,[kref eax+cdt.acfl-cdt]
M chomodef
	ret
;-
;- ch-perm	( c -- n )			(m,10)		'chpermf'	linux
;-	channel permission bits. dft is un-set, n=0
chpermf:GA M;:ok:
	shl eax,cdt_bsize+2
	add eax,[byte uref uv.chans]
	mov eax,[kref eax+cdt.perm-cdt]
M chpermf
	ret
;-
;- ch-flags	( c -- n )			(m,10)		'chflagsf'	linux
;-	channel flags. dft is un-set, n=0
chflagsf:GA M;:ok:
	shl eax,cdt_bsize+2
	add eax,[byte uref uv.chans]
	mov eax,[kref eax+cdt.iofl-cdt]	; flags
M chflagsf
	ret
;-
;- ch-cons?	( c -- flg )					'chconsq'	linux
;-	tf if c is in range of lib4th channels and a console channel -re- {max-chan}.
chconsq:GA
	mov cl,32-bcons
	jr chptyq.n
;-
;- ch-pty?	( c -- flg )					'chptyq'	linux
;-	tf if c is in range -re- {max-chan}, and connected to a pty device.
chptyq:GA;:ok:
	mov cl,32-bptyf
.n:
	call chflagsf
	test eax,eax
	js .r		;?; invalid
	shl eax,cl	; 32-bptyf
.r:
	sbb eax,eax
	ret
;-
;- ch-rnum	( c -- n )					'chrnum'	linux
;-	ret channel c specific latest error code.
chrnum:GA;:ok:
	call chid
	js cheof.r
	mov eax,dword[kref edx+cdt.rnum-cdt]
	ret
;-
;- ch-eof 	( c -- flg )					'cheof'		linux
;-	ret tf at file eof (if zero ernum in cdt) -re- {ch-rnum}
cheof:GA;:ok:
	call chrnum
.r:
	js near rfalse
	test eax,eax
	jz .q
	mov eax,1
.q:
	dec eax
	ret
;-
;- channel	( c -- n1 n2 )							forth
;-	channel i/o-flags n2 and id n1.
;-	n1 := -1 if fd not available, flags then in-valid.
;-	other flags -re- {ch-rnum}, {ch-omode}, {ch-perm}, {ch-eof}
channel:GA;:ok:
; c: ecx := ch-id
	call chid
	spush
	mov eax,ecx
	ret
;-
;- chp		( c -- p | abort-3 )						linux
;-	ptr p to description of channel c
chp:GA;:ok:
	cmp eax,cdt_num
	ja ram
	shl eax,cdt_bsize+2
	add eax,[byte uref uv.chans]
	ret
ram:
	spush 2
	call dot
r.am:
	mov eax,3
	jmp errorf
; c: ecx, ret eflags NZ if stdout console flag set
teststdout:A
	mov ecx,stdout
	jr teststdin.n
;
; c: ecx, ret eflags NZ if stdin console flag set
teststdin:A;:ok:
	mov ecx,stdin
.n:
	shl ecx,cdt_bsize+2
	add ecx,[byte uref uv.chans]
	test dword[kref ecx+cdt.iofl-cdt],mcons
	ret
; c:	ecx	outcons cdt
getwork:A;:ok:
	mov ecx,workch
	jr getstdin.n
; c:	ecx	outcons cdt
getstdout:A;:ok:
	mov ecx,stdout
	jr getstdin.n
; c:	ecx	incons cdt
getstdin:A;:ok:
	mov ecx,stdin
.n:
	shl ecx,cdt_bsize+2
	add ecx,[byte uref uv.chans]
	ret
;-
;- new-chan	( -- c | -1 )					'newchan'	forth
;-	get lowest free channel number, c in range (prt-chan,scr1-chan).
newchan:GA;:ok:
	spush
	mov ecx,scr1ch-prtch-1; protect 0..4
	mov eax,scr1ch
	mov edx,[byte uref uv.chans]
	lea edx,[kref edx+(scr1ch*cdt_size)]
.l:
	dec eax
	lea edx,[edx-cdt_size]
	cmp dword[edx+cdt.chid-cdt],-1
	jz .r
	dec ecx
	jns .l
	mov eax,ecx
.r:
	ret
;
;- <svcons>	( -- )				(k)
;-	store stdin to kbd, if console channel
svcons:A
;re above, <setkbd>
	call kbdc	; kbd
	call consq	; cons?
	inc eax
	spop
	jz newchan.r	;?; kbd-chan already set
	call siocons	; io-cons
	call stdinc	; stdin		{ c
	spush		; dup
	call consq	; cons?		{ fl  c
	inc eax
	spop
	jz .c		;?; stdin is console, else..
	mov eax,ttyt-Y	; "/dev/tty"
	spush		; count		{ u p
	mov eax,ttyt.e-ttyt.a
	call rbywf	; r/w		{ m u p
	or eax,O_NONBLOCK
	call openf	; open-file
	inc eax		; 1+		{ f' c'
	spop
	jnz near message;?; error but don't <quit>!
.c:;			; stdin/newchan kbd to-chan
	or dword[kref edx+cdt.iofl-cdt],mcons|micon
	call kbdc
;-
;- to-chan	( c1 c2 -- )					'tochan'	forth
;-	copy c1 channel description to channel no. c2
tochan:GA;:ok:<is-chan)
	push eax
	spop
	call getchan
	spush
	pop eax
;-
;- set-chan	( .x. .nn. c -- .x. )				'setchan'	linux
;-	store file data to channel no. c datafield, clear flags & ptrs
setchan:GA;:ok:
	call chp
	mov ecx,eax	; dst
	lea eax,TOS(cdt_size/4+1)
	push eax
	sub eax,KR
	lea eax,[eax+4]	; src
.m:
	spush
	mov eax,ecx
	spush
	mov eax,cdt_size
	call xcmove
	pop PS
	mov eax,[PS]
.r:
	ret
;-
;- is-chan	( c -- )					'ischan'	forth
;-	assign work-channel data to channel no. c
ischan:GA;:ok:
	push eax
	mov eax,workch
	call getchan
	spush
	pop eax
	jr setchan
;-
;- get-chan	( .x. c -- .x. .nn. )				'getchan'	linux
;-	fetch file description of channel no. c, ready to {set-chan}
getchan:GA;:ok:
	call chp
	lea ecx,[PS]	; destn on PS
	lea PS,[PS+cdt_size-4]
	sub ecx,KR
	push PS
	jr setchan.m
;-
;- fd>chan	( fd c -- )					'fd2ch'		linux
;-	store file descriptor fd to channel c,
;-	close previously existent channel c
fd2ch:GA;:ok:
	call closef	; edx := chp
	mov ecx,TOS(1)
	spop 2
	mov [kref edx+cdt.chid],ecx
;;	xor ecx,ecx
;;	mov dword[kref edx+cdt.iofl],ecx
;;	mov dword[kref edx+cdt.fpos],ecx
;;	mov dword[kref edx+cdt.fpos+4],ecx
	ret
;-
;- work-num	( -- c )							linux
;-	find highest channel no. with fd currently in {work}
worknum:GA;:ok:
	call workid
	jns chnnum
	jmp rtrue
;-
;- chp>chan	( p -- c )					'chp2ch'	linux
;-	find channel number from chp - not for {work}-channel
chp2ch:GA;:ok:
	mov eax,[kref eax+cdt.chid]
;-
;- chn-num	( fd -- c )					'chnnum'	linux
;-	find highest channel no. which refers to file descriptor fd.
;-	find highest unused channel no. if fd = -1 passed - re {new-chan}
chnnum:GA;:ok:
; c: ecx,edx
	call tstclos
	mov eax,ecx
	ret
;-
;- xg-io  	( -- )				(4)		'xgio'		linux
;-	exchange stdin and stdout channel definitions
xgio:GA;:ok:
	call stdinc
	call stdoutc
;-
;- xg-chan	( c1 c2 -- )					'xgchan'	linux
;-	exchange channel defn-s c1 and c2
xgchan:GA;:ok:
	push eax
	push dword TOS(1)
	call getchan
	spush
	mov eax,[esp]
	call getchan
	spush
	mov eax,[esp+4]
	call setchan
	spush
	mov eax,[esp]
	lea esp,[esp+8]
	call setchan
	spop
	ret
;-
;- source-chan	( -- c )					'sourcechan'	forth
;-	current input source channel
sourcechan:GA;:ok:
	spush
	movzx eax,byte[byte uref uv.sourceid]
	and al,cdt_num-1
	ret
;-
%endif;__FILE_I
;-
;-=====================================================================;
;- l4file.inc <eof>
