;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-=====================================================================;
;-  file  	: l4init.inc
;-  created	: 10-jul-01
;-  modified	: -> re "version.inc"
;-  switch	: __INIT_I
;-  version	: 0.01(+)
;-  assembler	: nasm 0.98-3e
;-  description	: initial memory setup, yet all preliminary and highly 
;-		: experimental! prg initialization, jobs setup/control
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  requires	: lib4th package
;-=====================================================================;
;-
%ifndef __INIT_I
%define __INIT_I
; __INIT_I also for <i4th_entry> to not declaring its label as <global:data count> 
; which - according to nasm docs - would otherwise be linked to callers dataspace!
%define initinc

%include "console_h.inc"
;-

;-	
;-
;- crea4th	( a1 a2 a3 n1 a4 -- x )		(k)
;-		( a1:xec a2:nam a3:ss n1:sz a4:bss -- x:er|tor )
;-	allocate .bss & .ss memory,
;-	setup standard 4th job stack structure, put initial ptrs to jobstack
;-	copy caller's user-vari and link to own
;-	verify/enable initial r/w/x access rights for dictionary in .bss area
;-	a1... are non-relative addresses (use {fth2abs} for 4th ptrs)
;-		a4: top address of alterable (.bss) memory currently allocated
;-		n1: size in no. of bytes to allocate for clone
;-		a3: bottom address of .ss memory currently allocated
;-		a2: address of new job's name (asciz)
;-		a1: initial execution address
;-	ret x error or clone's esp
crea4th:GA;:ok:(-?-)
	call version
	jmp nimp
;;-;:HIER: -!-
	mov ecx,eax		; pass @uv.mtop
	spop			; n1 <taskmem>
	call allocbss		; => eax:=memtop|ernum, ecx:=old memtop
	jns .s
.x:
	TOSPULL(3)		; drop & ret error code
	ret
.s:
	call usercopy
	lea edx,[eax+(uv.link)]	;clone's uref
	spop			; a3 clone's .ss top
	mov ecx,esp
	mov esp,eax		; clone's returnstack
	push_ibyte(0)		; end of env's
	push_ibyte(0)		; end of arg's
	spop			; a2=addr of name
	push eax		; name ptr
	push_ibyte(0)		; argc
	spop			; a1=exec entry
	push eax		; exec
	push KR			; kref
	push edx		; task's UR
	mov eax,esp
	mov esp,ecx		; back to callers stack
	xor ecx,ecx		; Z, leave esp @tos
	ret
;-
;- actv4th	( n1 a1 -- n2 )			(s)
;-	activate 4th job from previously set up structure - re {crea4th}
;-	with sys_clone flags n1, ret error or clone's pid & enter clone
;-	syscall clone, -re- man 2 clone
actv4th:GA;:ok:
; o:	eax	clone:0, caller:error or clone's pid
;	KR=ebx	kref
;	UR	user ptr, clone or caller
;	eflags	set according to result in eax
	call version
	jmp nimp
;;-;:HIER: -!-
	stc		;;-; ;;-; ;;-; ;;-; :HIER: check!
	rcr byte[byte uref uv.aux+klok],1;lock kernel job (i/o)
	push KR			; for symmetric stack in/out
	push UR
	mov ebx,eax		; flags
	spop
	sys_clone ebx,eax	; start the clone, divert back to caller and into clone
	pop UR
	pop KR
	test eax,eax
	ret			; ret errnum/pid to caller, exec clone
;-
;- clon4th	( a1 -- a2 )			
;-	cloned 4th job initial data setup
;-	refers to data on initial esp, must be called from clone, un-nested
;-	a1 rel(kref) ref to ref to <quit> entry
;-	a2 rel(kref) ptr to clone's asciz name string
clon4th:GA;:ok:(-?-)
	call version
	jmp nimp
;;-;:HIER: -!-
	mov edi,eax	; <= nach crea4th verlegen und im stack mitliefern
;;-;;    mov byte[byte uref uv.aux+3],-1;lock kernel job (i/o)
	mov eax,[uref uv.mtop]	;top of tasks .bss memory
	mov ecx,[uref uv.mbot]	;old=owner's memtop, kernel:V.top
	lea esi,[esp+4]		; argp - lp
;    call iuser			; adjust clone's uvari
	add [uref uv.uesp],byte 4	; adjust for subroutine call
	call idsvs	; :HIER: idsvs.n @eax = .ss-size
;;-;;:or:	; ???
;;-;;    mov eax,--wasdenn-- ; <= nach crea4th verlegen und im stack mitliefern
;;-;;    call stacksini.n
	call iiocons
;not needed, already set up in <idsvs>
;    mov PS,[byte uref uv.s0]
;    lea PS,[kref PS+4]
	mov eax,[esp+4]
	mov [uref uv.uargc],eax
	mov [uref uv.uargn],eax
	mov eax,[esp+8]
	sub eax,KR
	mov [uref uv.uargp],eax
	shl byte[byte uref uv.aux+klok],1;;un-lock kernel job (i/o);-;; ;-;; ;:HIER: check!
	ret
;-	

;-
;- <inisiz>
;-	default "i4th" structure
inisiz:	i4th_ntry	; dft. initialization datafield

;-
;- ini4th		( -- )			(k)
;-	initiate base 4th program task
;-	returns with system regs, memory and user vari set up
;-	initial {current} and {context} is {root}
;-	returnstack on return is different to that on exit!
;-	{ini4th} thus cannot be called from 2ndary subroutine levels, 
;-	previously stacked data can be accessed via user-vari {(esp)} which
;-	after return from {ini4th} contains the esp value from before entry.
;- entry:
;-	edi := 0 or addr, ptr to struc w. address of application <quit>, or 0 for {quit} entry
;-	esi := 0 or addr, ptr to callers arguments
ini4th:GA;:ok: at init
;	PRNUM esi,l,':S:';bffff330
;	PRNUM edi,l,':D:'; 00
	call getrefb		; library reference address to ebx
	test edi,edi
	jnz .s
	lea edi,[kref inisiz-Y]
.s:
	call allocini		; allocate (taskmem) bytes r/w(/x) compile- & datamemory
;out: eax=.bss-bot, @eax=size,hndler,
	cmp eax,-4096		;eax:=.bss memtop, ecx:=size
	ja near byer		;?; alloc failed (edx now free for system use)
	mov edx,eax		; save .bss bot
	xor UR,UR
;L4PN eax,l,'UR>'
	call ustkini		; initiate .ss space, eax := .ss bottom, @eax := size, UR
;out: eax=.ss-bot, @eax=size,hnd,
	mov ecx,eax		; save .ss
	call linkumem		; init UR and linkage
	mov eax,edx		; pass .bss
; in: eax=bss-bot, @eax=.bss-size
	call linkdcmem		; initiate basic data-/codespace ref-s
;out: @(bot) and @(top); true addr
	mov eax,ecx		; pass .ss
	mov edx,edi		; save i4th addr
; in: eax=.ss-bot, @eax=.ss-size
	call linkuvari
;out: true addr PS=edi, UR=ebp and (ulink), @(ulink), @(esp); kref'd .ss top to @r0
	mov eax,esi
.u:
	call uenvini
;out: @(argc), @(argn), @(source-id), @blk and @(argp); true addr
	mov eax,edx		; address of i4th-struct.
	call quitini
;out: kref'd @(quit).
;=> esi should be preserved, ebx = kref always be restored, others free for initial use
; in: (top), (bot), UR
	call idsvs		; vari- and compilespace
	call iiocons		; system constants
	call ivecw		; vectored words defaults
	mov dword[byte uref uv.aux],0	; clear i/o flags
	mov dword[byte uref uv.lkindex],0; initial relocation index, init only!
	call ilink		; link kernel words
	call dfdini		; init deferred words linkage
	call inicdt		; intial channels definition tables, tattr structures, palette
;installed on demand:
;;	call ibbuf		; initial blockfile buffer & linkage -re- {block-lk}
	call stofence		; set fence to current top values
	call intro		; check whether stdin is console, display startup message
	call setty		; init single key no timeout reading mode if console
	call isegf		; setup signals redirection, rt-singnals inclusive
	call siocons		; check input mode, set (aux) flag correspondingly
	call setpty		; re-vector type/emit if stdout is a pty
	call lcignore		; {find} letter case independently
	call svcons		; save input console channel to chp #(chp_num)
;;	    PRSTG ':1:'
	call rsegwinch		; init main window's sizes
;;	    PRSTG ':2:'
;; -- ;-?-
	mov LP,PS		; init locals ptr
;; -- ;
	call only		; clear search order
	call forth		; init.	current := forth
	call definitions	;	context := forth
	call definitions	;	ocontext
%ifdef __ANS			; current: forth, context/order: ans, ans, ans, forth
	call fig
	call also
%elifdef __FIG			; current: forth, context/order: fig, fig, fig, forth
	call ans
	call also
%else				; current: forth, context/order: forth, forth, forth
	call forth
%endif
	call also
;dft is relocatible u.o.t. ref compiling mode
;    call cbdisp		; set {call-by-disp} mode
%ifdef __DBG_ini4th
	call cr
;;	    L4PN eax,l,'VL>'
	call words
	call cr
	call order
        call cr
	call current
        mov eax,[kref eax]
	call hexdot
	call bel
	call cr
	call bel
%endif
	call argcopy
;:HERE: secure app-s should now revert to real user-id :HERE: -?-
; edi	 if >0: true address, initialize and jmp into user supplied interpreter
;	     0: init and jmp into lib4th outer interpreter, {quit}, no return to application
; -?-       <0: clr bit 32, init and ret to application, store address from <vquit> to (quit) user-vari
	mov ecx,[uref uv.uesp]	; ret-ptr from entry
	mov ecx,[ecx]
	add dword[uref uv.uesp],byte 4;adjust to callers value after ret
	mov edx,[uref uv.uedi]
	test edx,edx
	jz .v
	mov ecx,[edx]		; user supplied interpreter ; 3ffcb60 <- :muell:
.v:
	mov ecx,[uref uv.uquit]
.r:
	jmp ecx

;-
;- getref  	( -- )				(k)
;-	fetch kernel library reference <kref> to ecx
;-	subroutines, 4th-words, all data refer to this address
;-	ecx := address of library base reference
getref:GA;:ok:(for kernel/asm access)
	call .r
.n:
	sub ecx,.n-Y
	ret
.r:
	mov ecx,[esp]
	ret
;-
;- getgot  	( -- p | 0 )							linux
;-	access to lib4th g.o.t.; restores kref, ret 0 if inactive.
;-	no subroutine fetching, programs must set up own got reference.
;-	re macro <GETGOT> in "reloc.inc"
getgot:GA;:ok:(for kernel/asm access)
;	fetch kref'd ptr to global offset table to eax = @tos
;	[kref eax] := address of global offset table
;	:got: should be read from the actual program's ELF header!
	call getref
	spush
%ifdef __startgot_omit
	xor eax,eax
%else
	GETGOT eax
	sub eax,KR
%endif
	ret
;-
;-================================================================
;- -- memory setup
;-
;-	initiating routines for programs setup, not suited
;-	to hi-level 4th access, except those marked "(k)".
;-
;-	

;-
;- <uvcopy>	initiate new 64K user area with old	(mc)
uvcopy:GA C;GA;:ok:
;	i: eax	new memtop
;	c: -/-
	pushad
	lea ecx,[uref uv.utop]
	lea esi,[uref uv.ubot]
	sub ecx,esi		; max no. of bytes
	mov edi,eax
	sub edi,ecx		; destn uv.ubot
	shr ecx,2
	rep movsd
	popad
C uvcopy
	ret
;-
;- usercopy	( addr1 -- addr2 )		(k)
;-	adjust bounds and copy old to new set of uservari
usercopy:GA
;	i: eax	new memtop
;	   mbot		bot. of current job's .bss area
;	   mtop		old top of all jobs' .bss
;	o: mbot		bot. of current job's .bss area
;	   mtop		new top of all jobs' .bss
;	   new mbot	bot. of clone's .bss area
;	   new mtop	new top of all jobs' .bss
;	c: -/-
%if 1
	jmp nimp	; this changed completely...
;;-;:HIER: -!-
%else
	push dword[byte uref uv.mbot]	; mbot:	save old
	xchg eax,[byte uref uv.mtop]	; mtop:	save old
	mov [byte uref uv.mbot],eax	; mbot:	store old mtop to new mbot
	mov eax,[byte uref uv.mtop]	; mtop:	store new top of .bss
	call uvcopy			; copy parent's initial user vari
	pop dword[byte uref uv.mbot]
	ret
%endif
;-
;- <linkdcmem>	( mbot -- mtop )		(k)
;-	init basic linkage of .bss section, data- and compilespace
;-	use UR
;-	set @(bot) and @(top); true addr
linkdcmem:GA
; i:	eax	.ss bot, heap ptr
; o:	eax	@(ulink)
	mov [byte uref uv.mbot],eax	; .bss bot, ptr to heap header
	add eax,[eax]
	mov [byte uref uv.mtop],eax	; .bss top
	ret
;-
;- <linkumem>	( ubot -- ulink )		(k)
;-	init basic linkage of .ss section for stacks, uvari, tib
;-	set/use @(ulink) and UR reg; true addr
linkumem:GA
; i:	eax	.ss bot, heap ptr
; o:	eax	@(ulink)
	lea eax,[eax+d_uarea+d_ntib]	; uvari top
	test UR,UR			; inintial dataset if zero
	jnz .u
	lea UR,[eax+(uv.link)]		; init user vari
	mov [UR],UR			;      & linkage
.u:
	mov eax,[byte uref uv.link]	; previous ptr from uvcopy
	mov [eax],UR			; store link to new uarea
	mov [byte uref uv.link],eax	; close linkage loop
	ret
;-
;- <linkuvari>	( ubot -- iesp )		(k)
;-	init stacks, tib & uarea ptrs
;-	use KR, UR
;-	store initial regs, kref'd @r0, @s0, preset @(tib)
;-	dft uv.tib, kref'd terminal input buf.
linkuvari:GA;:ok:
; i:	eax	.ss bot, heap ptr
; o:	eax	@(ulink)
	sub eax,KR
	add eax,[kref eax]
	mov [byte uref uv.r0],eax	; r0 is .ss bot (top address)
	lea eax,[eax-d_rstack-d_dstack+32];;for cpu L1 cache (K6/2:test showed no difference);;;+4];
	mov [byte uref uv.s0],eax	; botttom of data stack
	mov [byte uref uv.lp],eax	; and locals
	mov [uref uv.ucsp],eax		; compile-stack ptr
	lea PS,[kref eax]		; PS data-stack plus @tos local cell
	lea eax,[uref uv.utibot]	; terminal input buf.
	sub eax,KR
	mov [byte uref uv.tib],eax
	lea eax,[uref uv.ubot-4]
	mov [byte uref uv.sstop],eax
	mov eax,esp			; 	save caller's esp
	lea esp,[uref uv.utop]		; register storage down from top of job's .bss
	pushad				; save running tasks initial register set
	mov esp,eax			; back to callers esp
	lea eax,[eax+4]			; as valid after regular ret from <iuser>
	mov [uref uv.uesp],eax		; callers returnstack into reg storage
	ret
;-
;- <uenvini>	( argptr -- sourceid )		(k)
;-	initial env & arg count & ptrs
;-	use KR, UR
;-	set @(argc), @(argn), @(source-id), @blk and @(argp); true addr
;-	uv.uargc	cnt		of received arguments
;-	uv.uargn	preset		argc running counter
;-	uv.blk		-1		if args present, else 0 for terminal input
uenvini:GA
; i:	esi	ptr to base of arg/env count/ptrs
	push ecx
	mov ecx,eax
	test eax,eax
	jz .n				;?; no arguments
	mov eax,[ecx]			; fetch (remaining) argc
	sub ecx,KR			; rel kernel
.n:
	dec eax
	mov [uref uv.uargc],eax		;	 -> argc
	mov [uref uv.uargn],eax		; preset argc running counter
	lea ecx,[ecx+4]			; advance over @tos, for eax
	sar eax,31
	not eax
	shl eax,1
	mov [uref uv.uargp],ecx		;	 -> argp
	mov [byte uref uv.blk],eax	; -2 if args present, else 0 for terminal input
	mov [byte uref uv.sourceid],eax
	pop ecx
	ret
;-
;- <quitini>	( i4th.addr -- quit.ptr )	(k)
;-	initial program execution entry, {quit} if zero
;-	use @(esp), KR, UR
;-	set kref'd @(quit).
quitini:GA
; i:	eax	address of i4th structure
	push ecx
;	    PRNUM eax,l,'qi:'
	mov [uref uv.ubootp],eax
	lea ecx,[kref bquitb-Y]
	test eax,eax			; edi:=init entry address from kernel-cons vref
	jng .c
	mov eax,[eax]
	test eax,eax
	jnz .e
.c:
	mov eax,ecx
.e:
	mov ecx,[uref uv.uesp]
	mov [ecx],eax			; initial {quit} to tor
	mov [uref uv.uquit],eax		; (quit) <- initial true execution ptr
	pop ecx
	ret
;-
;- <idsvs>
;-	init compile- and dataspace in .bss memory
;-	set prior to entry:
;-		ebx	<Y>		kernel base address
;-			uv.mbot		tasks bottom of .bss memory
;-	setup of:
;-		edi	uv.d0		PS, datastack bottom and initial tos
;-			uv.dp		dataspace pointer
;-			uv.dtop		end of dataspace, init kref'd @uv.mtop
;-			uv.cp		codespace ptr
;-			uv.c0		bottom of codespace
;-			uv.head		compile/interpret-pointer, init @uv.cp
;-			uv.tail		compile/interpret-pointer, init @uv.cp
;-			uv.ctop		end of compilespace, init @uv.d0
idsvs:GA;				;<fully sized 4th job
; i:	ebx	kref
;	ebp	uref
; o:	edi	PS
;	esi	VP
; c:	ecx	.xx.
	mov eax,[byte uref uv.mbot]	; .bss membot
	sub eax,KR
	lea eax,[eax+hphead_size]	; advance over heap linkage
	mov codeptr,eax			; cp	 -> ptr into compilespace
	mov codebot,eax			; c0	 -> empty compilespace
	mov [byte uref uv.head],eax	; c-here -> initial head ptr {here}
	mov [byte uref uv.tail],eax	; c-here -> initial tail ptr
	mov [byte uref uv.bcp],eax
	mov [byte uref uv.btail],eax	; btail for {quit} entry
	lea eax,[eax+d_dictionary-hphead_size]
	mov codetop,eax			; -> top of this users compilespace
; :HERE: -?- split heap headers, leave only d0+ resizable -?- :HIER:
	mov databot,eax			; -> kref dp initial {here} rel kref
	add eax,[kref tophead-Y]	; initial dp after initially reserved vari-space
	mov dataptr,eax			; -> kref dp initial {here} rel kref
	mov eax,[byte uref uv.mtop]
	sub eax,KR
	mov datatop,eax
	call pidf
	mov [uref uv.upid],eax		; -> this jobs process id, r/o w. {4th-id}
	spop
	ret
;-
;- iiocons
;- setup of new user's i/o constants:
;-	(uvari)		(initial val)	(usage)
;-	uv.up		uv.vbot-(uv.link)	disp from <uref 0> down into user area
;-	uv.inchp	0		chp of latest input channel
;-	uv.outchp	0		chp of latest output channel
;-	uv.uiovtim	qtermnum<<8|qtermtimo	VMIN chars, VTIME timeout
;-	uv.utibmax	d_ntib-4	size of t.i.b., leave space for trailing <nul>
;-	uv.span		0
;-	uv.in		0
;-	uv.base		d_base		number conversion radix
;-	uv.ueol		d_ccr		<cr> ascii sequence up to 4 bytes =/= 0
;-	uv.upchr	d_pchr		ranges of printing chars
;-	uv.uescc	d_escc		{ptype} escape symbol
;-	uv.ucan		d_cmul<<16|d_can  hi-w.min-cnt of lo-w.termination char
;-	uv.untab	d_tab		<tab> spacing
;-	uv.ustimo]	d_ustimo	timeout[s] for accept, by sys-select, {wait4in}
;-	uv.ustimm]	0		timeout[s]
iiocons:GA;:ok:
; i:	ebx	<kref>
;	ebp	<uref>
; o:	ecx	0
	xor ecx,ecx
	mov [byte uref uv.voclink],ecx	; {voc-link} initial reference
	mov [byte uref uv.span],ecx	; init to zero
	mov [byte uref uv.in],ecx	;  ...
	mov [byte uref uv.inchp],ecx	; chp of latest in-channel
	mov [byte uref uv.outchp],ecx	; chp of latest out-channel
	mov [byte uref uv.locb],ecx	; local bytes counter
	mov [byte uref uv.locn],ecx	; local mem. size
	mov dword[byte uref uv.padsz],d_npad;pads size
	mov dword[byte uref uv.up],uv.vbot-(uv.link);disp from <uref 0> down into user area
	mov dword[byte uref uv.base],d_base;number conversion radix
	mov dword[uref uv.ustimm],ecx	;  intial s of timeout := 0
	mov dword[uref uv.ustimo],d_ustimo;intial timeout for accept, by sys-select, {wait4in}
	mov dword[uref uv.upchr],d_pchr	; ranges of printing chars
	mov dword[uref uv.uescc],d_escc	; escape symbol
	mov dword[uref uv.uiovtim],qtermnum<<8|qtermtimo
	mov dword[uref uv.ueol],d_ccr	; <cr> ascii sequence up to 4 bytes =/= 0
	mov dword[uref uv.utibmax],d_ntib-4;size of t.i.b., leave space for trailing <nul>
	mov dword[uref uv.ucan],d_cmul<<16|d_can; hi-w.cnt lo-w.termination char
	mov dword[uref uv.uprp],d_prp	; non-breaking spaces - <code 160> - to (r)
	mov dword[uref uv.udplm],d_frac	; numbers fractions marker chars, for {dpl}
	mov dword[uref uv.uwidth],d_width;max significant wordnames' length		
	mov dword[uref uv.untab],d_tab	; <tab> spacing
	mov dword[uref uv.ufperm],d_fperm;permission bits
	ret
;-
;- ivecw
;-	restore <kref>, init user vectored words by true addresses
;-	(word)		(uvari)		;	{name}s
;-	qterminal	uv.uekeyq	; ?terminal	<- (ekey?)
;-	emit		uv.uemit	; emit		<- (emit)
;-	type		uv.utype	; type		<- (type)
;-	osaccept	uv.uaccept	; accept	<- (accept)
;-	echo		uv.uecho	; echo		<- (echo)
;-	ok		uv.upokp	; [ok]		<- (ok)
;-	?error		uv.uqerror	; error		<- (?error)
;-	error		uv.uerror	; error		<- (error)
;-	eval		uv.ueval	; eval		<- (evaluate)
;-	number		uv.utonum	; [number]	<- (number)
;-	smbyrem		uv.umbym	; sm/rem	-> (um/mod)
;-	roottop		uv.last		;		-> last
;-	Vroot		uv.voclink	;		-> voc-link
;-	licc4thg	uv.icc4th	; 		-> <icc4th>
;-	locc4thg	uv.occ4th	;		-> <occ4th>
ivecw:GA;:ok:
; c: eax	xxx
;    ebx	kref
;    ecx,edx	xxx
	call getrefb			;>:KREF:
; executeables:
	lea eax,[kref qterminal-Y]	; ?terminal
	lea ecx,[kref bemitb-Y]		; [emit]
	lea edx,[kref dotype-Y]		; [type] deferred ( initially [etype] & dft [ctype]
	mov [uref uv.uekeyq],eax	; 	-> (ekey?)
	mov [uref uv.uemit],ecx		;	-> (emit)
	mov [uref uv.utype],edx		;
	lea eax,[kref osaccept-Y]	; osaccept
	lea ecx,[kref bemitb-Y]		; echo
	lea edx,[kref bokb-Y]		; [ok]
	mov [uref uv.uaccept],eax	;	-> (accept)
	mov [uref uv.uecho],ecx		; 
	mov [uref uv.upokp],edx		; 	-> (ok)
	lea eax,[kref berrb-Y]		; error
	lea ecx,[kref bevalb-Y]		; [evaluate]
	lea edx,[kref btonumb-Y]	; [number]
	mov [uref uv.uerror],eax	; 
	mov [uref uv.ueval],ecx		;	-> (evaluate)
	mov [uref uv.utonum],edx	;	-> (number)
	lea eax,[kref smbyrem-Y]	; sm/rem
	lea ecx,[kref binterpretb-Y]	; [interpret]
	lea edx,[kref bblockb-Y]	; [block]
	mov [uref uv.usmbym],eax	;	-> (um/mod)
	mov [uref uv.uinterpret],ecx	;	-> (interpret)
	mov [uref uv.ublock],edx	;	-> (block)
	lea eax,[kref bbufb-Y]		; [buffer]
	lea ecx,[kref bsourceb-Y]	; [source]
	lea edx,[kref smbyrem-Y]	; sm/rem
	mov [uref uv.ubuffer],eax	;	-> (buffer)
	mov [uref uv.usource],ecx	;	-> (source)
	mov [uref uv.upmbymp],edx	;	-> (m/mod)
	lea eax,[kref bqerrb-Y]		; [?error]
%ifdef __FIG
	lea edx,[kref fspstore-Y]	; sp!
	lea ecx,[kref fnumber-Y]	; fnumber, fig mode
%else
	lea edx,[kref aspstore-Y]	; sp!
	lea ecx,[kref anumber-Y]	; anumber, ans mode
%endif
	mov [uref uv.uqerror],eax	;	-> (?error)
	mov [uref uv.unumber],ecx	;	-> (number)
	mov [uref uv.ustosp],edx	;	-> (sp!)
	xor eax,eax
; inactive
	mov [uref uv.upause],eax	; context switching, after wait4... timeout
	mov [uref uv.updebugp],eax	; debugging intermediate call
	mov [uref uv.ubinterpret],eax	; interpreterr error handling vector
	mov [uref uv.uinterpretb],eax	; interpreterr user vector
	mov [uref uv.uscanwl],eax	; wordlists scanning 2ndary error hnd
; data ref.
	mov dword[uref uv.ulo2hi],thichar-Y;	-> (lo2hi)
	mov dword[uref uv.uhi2lo],tlochar-Y;	-> (hi2lo)
	mov dword[byte uref uv.icc4th],licc4thg-Y; input ctrl-code jump table
	mov dword[byte uref uv.occ4th],locc4thg-Y; output ctrl-code jump table
	ret
; after all linkage done, store/initiate variables in data-space
; initiate active words
; i:	eax	-ve disp to next lk
;	ecx	[esi-whead.l+whead.f]
;	edx	u.o.t. index
;	esi	lfa
; o:	eax	eax
;	esi	esi
iwlink:A
	push ecx			; save headerflags
	test ecx,pfax
	jz .v				;?; inactive pfa
;;	test ecx,imed
;;	jnz .v;;;
	mov dword[edx*4+uref uv.ultab],0; clr u.o.t. entry
.v:
	test ecx,varf
	jz near .r			;?; no data
	and ecx,xwfl			; cells count
	dec ecx
	jng near .c			;?; no extra cells, try <inif>
	push esi,edi
; transfer the word's kernel def'd data to alterable memory
	movzx edx,byte[esi-whead.l+whead.n]; name-length
	add edx,byte 4			; pfa
	and edx,byte -4
	lea esi,[esi+edx-whead.l+whead.x]
	mov edi,[esi]			; @pfa = disp to dataref
	add edi,databot
	add edi,KR			; data-space
	add esi,byte 4			; dataref @body
	rep movsd
	pop esi,edi
.c:
	test dword[esp],pfax|inif
	jz near .r
	pushad
; build active part in codespace, call to @pfa per <dodoes>, W = ecx := ptr to body
	mov edi,[esp+12+4 s_tor s_edi]
	spush 2
	mov ecx,codeptr			; code entry
	add ecx,KR
	movzx eax,word[esi-whead.l+whead.i]; ix
	mov [eax*4+uref uv.ultab],ecx	; <dodoes> to uot
	movzx eax,byte[esi-whead.l+whead.n]; name-legth
	lea eax,[eax+esi-whead.l+whead.n+4]; nfa+countbyte+disp to pfa
	and eax,byte -4			; pfa
	readad ecx,tor
	test ecx,inif
	jz .i
	lea ecx,[eax-whead.p+whead.b+4]	; >body 4+
	add ecx,[ecx]			; true, initial xec from 2nd-ary pfa
;>; init may change all regs, but should return <eax> w/ a kref'd pfa.
;>; in: eax:pfa ebx:KR ecx:own entrypoint edx:body esi:lfa edi:PS
	call ecx			; run initiation procedure
.i:
	push eax
	mov eax,dodoes-Y
	call cplicall			; cpl <dodoes>
	pop eax				; pfa
	call cpl4			; cpl <pfa>-address
	call csemis
	popad
.r:
	lea esp,[esp+4]
	ret
;-
;- alink					(k)
;-	adjust words linkage, subroutine by <ilink>
alink:A;:ok:
; i:	eax			  o:	-ve disp to next link
;	ebx	KR			KR
;	ecx,edx	-/-			..xx..
;	ebp	UR ptr to uv.link	UR
;	edi	PS			PS
;	esi	top lfa			1st lfa
	mov eax,[esi]			; disp to next lfa
	neg eax				; Z-flag at end of header list
	jz .r				; base ptr in voc-header
	movzx edx,word[esi-whead.l+whead.i]	; index in module
	add edx,[byte uref uv.lkindex]	; adjust to system index
	cmp KR,esi			; kernel bottom
	jc .a
	lea ecx,[kref YE-Y]		; top
	cmp esi,ecx
	jc .a				;?; kernel ref
	mov [esi-whead.l+whead.i],dx	; adjust index in loaded module
.a:
	movzx ecx,byte[esi-whead.l+whead.n]; countbyte
	lea ecx,[ecx+esi-whead.l+whead.x]; avance to nfa, add cnt.b, name, padding, to pfa
	and ecx,byte -4			; dword align
	add ecx,[ecx]			; execution ptr wrt 1st lfa of module
	mov [edx*4+uref uv.ultab],ecx	; store at disp to u.o.t.
	test dword[esi-whead.l+whead.f],vocf
	jnz .n				;?; vocabulary
	movzx ecx,word[esi-whead.l+whead.f]; headerflags
	test ecx,inif|varf|pfax
	jz .z				;?; nothing to initiate and not a variable
	test ecx,xwfl			; wordextension fields
	jz .z				;?; none
	call iwlink			; cpl initial (words w.) variable data, values, etc.
.z:
	test esi,esi			; force NZ
.n:
	lea esi,[esi+eax]		; next lfa
.r:; Z at end of chain
	ret
;-
;- task		( -- )								forth
;-	last word of kernel wordlists, a {noop}
task:GA;:ok:
	ret
; generate writable vocabulary linkage, <whead>&<vhead> structure
; i:	esi	wordlink addr
;	edi	voclink addr
ramvoc:A;:ok:
	push edi,esi
	lea esi,[edi-vhead.m+vhead.i]
	sub esi,[esi]			; lfa
	lea esi,[esi-whead.l+whead.i]	; beginning of header
	mov eax,xwfl
	and eax,[esi-whead.i+whead.f]	; xtn cells
	lea edx,[eax*4+4]		; ->bytes
	lea ecx,[edi+edx-vhead.m+vhead.p]; end of header, pf inclusive
	sub ecx,esi			; bytes
	mov edi,dataptr			; mem
	add [byte uref uv.dp],ecx
	add edi,KR
	shr ecx,2
	rep movsd			; edi/esi now past pfa of vhead
	mov ecx,esi			; source end
	sub ecx,edi			; destn -> disp to ram section
	sub edi,edx			; less xtn bytes -> voc-head pfa
	mov eax,[edi]
	sub eax,ecx
	mov [edi],eax		    	; relocate disp to top lfa
	lea edi,[edi-vhead.p+vhead.l]
	lea eax,[eax+vhead.l-vhead.p]
	mov [edi],eax			; link wordlist to library
; all:
	lea edx,[edi-vhead.l+vhead.m]	; voclink
	lea edi,[edi-vhead.l+vhead.i]
	sub edi,[edi]			; voc's word lfa
	lea eax,[edi-whead.l+whead.i]	; beginning of this header
	sub eax,KR
	cmp eax,databot
	jnz .n				;?; not 1st voc in ram
; 1st only:
	sub [edi],ecx			; relink to library
	mov dword[edx],0		; voc-link ends
	jr .l
.n:; all but 1st: link to preceding xhead
	mov eax,edx			; voclink
	sub eax,KR
	sub eax,[byte uref uv.voclink]	; disp to preceding header
	mov [edx],eax			; link to this
.l:
	sub edx,KR
	mov [byte uref uv.voclink],edx	; new voc-link
	pop edi,esi
	ret
;-
;- ilink
;-	system words initial linkage, 1st which may modify data-space
;-	for modules words linkage re {wlink}
ilink:GA;:ok:
; i: 	eax	Croot		  o:	eax
;	ebx	KR			KR
;	ebp	UR ptr to uv.link	UR
;	edi	PS			PS
	mov eax,Croot-Y			; initial words block
.w:	;<; {wlink} 2ndary modules entry
	call getrefb			;>:KREF:
	pushad
	lea esi,[kref eax]		; ifa, ptr to index(lo), flags(hi)
	movzx eax,byte[esi+whead.n-whead.l+whead.l-whead.i]			; 1st name length
	lea eax,[esi+eax+(whead.x-whead.n+whead.n-whead.l+whead.l-whead.i)*2]; advance to 2nd nfa
	and eax,byte -4			; dword aligned
	movzx ecx,byte[eax]		; dummy name length
	lea eax,[eax+ecx+whead.x-whead.n+8]; 2nd pfa + 2nd module xtn field := pc-rel top lfa
	and eax,byte -4			; <Tz> dword aligned
	lea ecx,[byte uref uv.fld]	; tmp. initial linkage
	mov edi,ecx
	add ecx,[eax]
	sub ecx,eax
	mov [edi],ecx			; module's {voc-link}
	lea esi,[eax-8]
	sub esi,[esi]			; pfa
	lea ecx,[eax-4]			; <Lz> last
	sub ecx,[ecx]
	movzx eax,word[ecx-whead.l+whead.i]; save top index for final adjustment
	push eax
	sub ecx,KR
	mov [byte uref uv.last],ecx	; {last}
.d:; voc linkage loop
	mov eax,[edi]			; voc-link... dup @
	test eax,eax
	jz near .r			;?; last voc
	cmp eax,byte -1
	jz near .r			;?; module ends
	sub edi,eax			; next voclink posn, at <vmfa>
	call ramvoc			; prepare writable voc linkage
	cmp dword[edi],0
	jz .r
	lea esi,[edi-vhead.m+vhead.p]	; {voc}top
	sub esi,[esi]			; last lfa in voc
.l:; words chain
	call alink
	jnz .l				;?;more, else try next voc
	cmp dword[esi-vhead.l+vhead.n],rgvnfa
	jnz .r				;?; not a voc's 2ndary header, "<vocnfa>"
	lea esi,[esi-vhead.l+vhead.i]
	sub esi,[esi]
	mov ecx,[esi-whead.l+whead.f]
	test ecx,vocf
	jnz near .d			;?; more, if vocabulary dummy name
.r:
	pop ecx
	inc ecx
	add [byte uref uv.lkindex],ecx	; store new top index
	writead eax,ecx
	lea ecx,[byte uref uv.voclink]
	mov eax,[ecx]
	lea eax,[kref eax]
	sub eax,ecx
	neg eax
	mov [ecx],eax			; store final voclink
	popad
	ret
callpcrel:equ ilink.l
;-
;- wlink  	( ptr -- ix )			(k)
;-	restore kref, link module
;-	NOTE:
;-	2ndary modules loading yet not orderly implemented (missing relocation)!
;-
;-	linkage at [kref ptr]:
;-	blockbase, 1st lfa is relocation reference
;-		1st header[zero.indx,flags|link|exec|name]
;-			     .---------------^--------------<------.
;-		2nd.header[disp.to.1st.lfa|voclink|0|name|toplink] |
;-		module xtn:	[last.lfa|top.voclink]             |
;-					   ,---------------->------'
;-		3rd.header[rel.index,flags|link|name|exec]
;-					   ,-^
;-		4th.header[rel.index,flags|link|name|exec]
;-		nxt.header[..more-words..]
;-		top.header[rel.index,flags|link|name|exec]
;-				toplink ----^
	global wlink:function
wlink:equ ilink.w
; i:	ecx	ref to module's 1st linkblock
; o:	eax	-ve link disp to next header

;-
;- <setpty>					(k)
;-	check whether stdout is to pty, ret immediately if not,
;-	else re-open stdout in blocking w/o mode.
;-	curently disabled (since not required):
;-	dependent on compileflag in "Makefile", __PTY_CAL,
;-	if fast displaying output remains incomplete, still,
;-	re-vector {type} and {emit} to delayed variant, e.g.
;-		{ ' [dtype] idx>xec 4th>abs (type) ! }
;-	delay applies only to stdout determined to be a pty,
;-	i.e. output to Linux console remaining at full speed.
setpty:A
	call outptyq
	test eax,eax
	jz .y		;?; stdout not a pty dev.
	call here
	spush
	mov eax,200	; maxlen h c
	spush
	mov eax,stdout
	call chname
	call wbyof
	or eax,O_SYNC
	call openf
	mov eax,stdout
	call ischan
	TOSPULL(1)
.y:
	spop
.r:
	ret
;-
;- <setkbd>					(k) (un-used)
;-	set {kbd-chan} to current input console
;-	open "/dev/tty" if neither of stdin, stdout, stderr is a console
setkbd:A
;re below, <svcons>
	call kbdc	; kbd
	call .q		; cons?
	jz setpty.y	;?; kbd is console
	call stdinc	; in-chan
	call .q		; cons?
	jz .c		; stdin is console
	mov eax,ttyt-Y	; "/dev/tty"
	spush		; count		{ u p
	mov eax,ttyt.e-ttyt.a; count
	call rbywf	; r/w (w for the "echo")
	or eax,O_NONBLOCK; enable single key input
	call openf	; open-file
	inc eax
	spop
	jnz setpty.y	; 1+ if drop exit endif
	call getwork
	mov edx,ecx
.c:;	edx := cdt
	or dword[edx+cdt.iofl-cdt],mcons|micon
	call kbdc
	jmp tochan
.q:A;	( c -- ) eflags
	spush
	call consq	; cons?
	inc eax
	spop
	ret
;-
;- <inicdt>					(k)
;-	initialize true addr <tattr> and ptr to <palette> dataspace, 
;-	set-up channels definition and relocation tables.
;-	k: immediately after initial words linkage procedure
inicdt:GA;:ok:
; c: ecx,edx,mm0,mm1
	call here
; data later fetched w/ <setty>
	lea eax,[kref eax+3]
	and eax,byte -4
	mov [uref uv.utattr],eax
	mov edx,termios_size+7
	and edx,byte -4
	add eax,edx
	mov [uref uv.ustattr],eax
	add eax,edx
	sub eax,KR
	mov [uref uv.uvpalette],eax
%if (cdt_size+palette_size-1)<128
%if (cdt_size+palette_size-1)>0
	add eax,byte cdt_size+palette_size-1
%else
%error "cdt_size or palette_size -?-"
%endif
%else
	add eax,cdt_size+palette_size-1
%endif
	_and eax,-(cdt_size)
	mov [byte uref uv.dp],eax
	mov [byte uref uv.chans],eax
	mov eax,cdtmem
	call allot
	spush
	mov eax,-1
	mov edx,edi
	mov edi,[byte uref uv.chans]
	add edi,KR
	mov ecx,cdtmem/4
	rep stosd
	mov edi,edx
	mov eax,STDIN
	call setcdt
	spush
	mov eax,STDOUT
	call setcdt
	spush
	mov eax,STDERR
setcdt:A
	mov ecx,eax
	shl eax,cdt_bsize+2
	add eax,[byte uref uv.chans]
	xor edx,edx
	lea eax,[kref eax]
	mov [eax+cdt.chid-cdt],ecx
	mov [eax+cdt.chpt-cdt],edx
	mov [eax+cdt.iofl-cdt],edx
	mov [eax+cdt.acfl-cdt],edx
	spop
	ret
;-
;- argcopy	( -- )				(4)(k)
;-	copies initial program arguments to tib, delimited by blanks
;-	and, optionally terminated by the "--" argument.
;-	if any args present {tib} will then be current input source
;-	with fetched length in {span} and {#tib}, and {in} set to 0.
argcopy:GA;:ok:
; i:	uv.uargc	arguments cnt
;	uv.uargp	ptr to 1st argument
; o:	uv.uargp	ptr to env-vari
;	uv.blk		0
;	uv.in		cleared if any args moved
;	uv.span		set to length of text in tib
; c: (all)
; also a test of some hi-level words, assembly would be much faster and shorter...
%define __testargs
%undef  __testargs
	mov dword[byte uref uv.span],0
.l:			; begin
	call source	;  source	{ cnt srcptr	(wrt next, single arg)
	cmp dword[byte uref uv.blk],byte 0;blk @ 
	jns near .r	; while		fetch arg to tib
	mov dword[byte uref uv.in],0
	call tib	;  tib		{ tib@ cnt argp
	call spanf	;  span @	{ span@ tib@ cnt argp
	spush		;  dup		{ span@ span@ tib@ cnt argp
	call tibmax	;  tib-max	{ #tib span@ span@ tib@ cnt argp
	call greater	;  >		{ flg span@ tib@ cnt argp
	call nzbra	; while		{ span@ tib@ cnt argp
	dd argcopy.r-$
	call rot	;  rot		{ cnt span@ tib@ argp
	call over	;  over		{ span@ cnt span@ tib@ argp
	call tibmax	;  tib-max	{ #tib span@ cnt span@ tib@ argp
	call ssub	;  -		{ span@-#tib cnt span@ tib@ argp
	neg eax		;  minus	{ #tib-span@ cnt span@ tib@ argp
	call min	;  min		{ min(#tib-span@,cnt) span@ tib@ argp
	call mrot	;  -rot		{ in@ tib@ mcount argp
	cmp dword TOS(2),byte 2
	mov ecx,TOS(3)
	jnz .s		;?; not "--"
	cmp word[kref ecx],'--'; terminator
	jz .e		;?; last active arg
.s:
%ifdef __testargs
	call over2
	call type
	call space
%endif
	call plus	;  +		{ in+tib mcount argp
	call dup2	;  2dup
	call plus	;  +
	call tor	;  >r
	call swap	;  swap		{ mcount in+tib argp
	spush		;  dup
	inc eax		;  1+
	call span	;  span
	call plsto	;  +!
	call move	;  move		{ }
	call bbl	;  bl
	call rfrom	;  r>
	call cstore	;  c!
	jmp .l		; repeat endif
.e:
	spop 2
.r:
	mov eax,[byte uref uv.span]
	mov ecx,eax
	add eax,[byte uref uv.tib]
	neg ecx
	sbb ecx,ecx	; -1 if span =/= 0
	add [byte uref uv.span],ecx
	lea eax,[eax+ecx]
	mov ecx,[byte uref uv.span]
	mov [uref uv.uintib],ecx
	mov byte[kref eax],0
	spop 2
	ret
;-
;- vers		( -- n )							root
;-	decimal 4 bytes version no.
vers:GA;:ok:
	spush
	mov eax,__VER
	ret
;-
;- lib4th  	( -- )				(uninitiated)			root
;-	rst kref, print library version
lib4th:GA;:ok:
	call getrefb	;>:KREF:
	lea ecx,[kref ht-Y]; or word counted stg at <versad>
	jr mquit.n
;-
;- --no-env-ini	( -- )								root
;-	pass as an argument to suppressing initial F8INI env-vari evaluation.

;-
;- --help 	( -- pid )			(uninitiated)	'ihelp'		root
;-	rst kref, print system-message, exit immediatelyl if {help} 
;-	was the single one arg passed w. program invocation.
ihelp:GA
	mov ecx,f8ht-Y
.p:
	call getrefb	;>:KREF:
	add ecx,KR
	call pidf
	cmp eax,[uref uv.upid]
	spop
	jnz .r
	cmp dword[uref uv.uargc],byte 1
	jg mquit.n
.s:
	call rscons
.r:
	push_ibyte(1)
	jmp bye.w
;-
;- mquit					(k)(uninitiated)
;-	rst kref, exit program w. zero error code
mquit:A
	call getrefb		;>:KREF:
	push_ibyte(0)		; exit-code
	lea eax,[kref bye.s-Y]	; uninitiated exit
	push eax
.n:
	call writezo
;-
;- newline					(k)(u)
;-	rst kref, send line feed & carriage return to stderr
newline:A
	push ecx
	call getrefb	;>:KREF:
	lea ecx,[kref nl-Y]
	call writezo
	pop ecx
	ret
;-
;- --version	( -- )				(u)				root
;-	display lib4th version and exit if no other args passed to program.
sversion:GA;:ok:
	mov ecx,nulst-Y
	cmp dword[uref uv.uargc],byte 1
	jng g32 ihelp.p
	call getrefb	;>:KREF:
	lea edx,[kref newline-Y]
	push edx
;-
;- version	( -- )				(u)				root
;-	display lib4th version
version:GA;:ok:
	call getrefb	;>:KREF:
	lea ecx,[kref vs-Y]
;-
;- wzo		( -- )				(k)(s)(u)(r)	'writezo'	novoc
;-	send asciz string <ecx> to stdout.
;-	hard coded destn is host STDOUT channel.
writezo:A
	pushad
	mov edx,ecx
	dec edx
.l:
	inc edx
	cmp byte[edx],1
	jnc .l
	sub edx,ecx
	sys_write STDOUT
	popad
	ret
;-	

;-
;- -- (i/o testing)
;-

;-
;- keycall	( -- ) -:test:- keyboard input
keycall:GA;:ok:
	call ppid
	call stdinq
	spop
	jnz .x		; exit on input error
	push esi
	push dword[uref uv.ucan]
	mov esi,[byte uref uv.tib]
.l:
	call key
	mov ecx,'  k:'
	call ersmsg
	cmp al,byte[esp];EM:ctr/y, FS: $1c:altr/ctrl"\"
	jz .t
	mov eax,[uref uv.ucan]
	mov [esp],eax
	inc word[esp+2]
.t:
	spop		; drop char
	dec word[esp+2]
	jz .r
	dec dword[byte uref uv.ierr]; fetch flag
	jns .l		;?; char received
.r:
	pop esi
	lea esp,[byte esp+4];flags!
.x:
	pushfd
	call ppid
	popfd
	ret
;-
;- eus		( -- )				(s)(u)(r)	'erustg'	novoc
;-	uninitiated, print 4 chars @ecx to stderr
erustg:A
	pushfd
	pushad
	push ecx
	mov ecx,esp
	mov edx,4
	sys_write STDERR
	lea esp,[esp+4]
	popad
	popfd
	ret
;-
;- esm		( n p -- )			(s)(k)		'ersmsg'	novoc
;-	send message no. and stg, -re- <erustg>, <erudot>
ersmsg:A
	call erustg
;-
;- erdot  	( n -- n )			(s)(k)(u)
;-	uninitiated, signed sedec number @eax output to stderr
;for uninitated erros only. native 4th-routines
erdot:A;:ok:
	pushfd
	pushad
	xor ecx,ecx
	mov edx,eax
	or edx,ecx	; print signed, (signbit preserved for result)
	jns erudot.v	; +ve
	neg edx		; -(abs)
	jr erudot.v
;-
;- ekm		( p -- )			(s)(k)		'erkmsg'	novoc
;-	fetch by ptr & send message stg, -re- <erustg>, <erudot>
erkmsg:A
	add eax,KR
;-
;- eum		( a -- )			(s)(k)		'erumsg'	novoc
;-	fetch by true address & send message stg, -re- <erustg>, <erudot>
erumsg:A
	call erustg
;-
;- eud	  	( u -- u )			(s)(k)(u)	'erudot'	novoc
;-	uninitiated, 8 digits unsigned sedec number @eax output to stderr
;-	for uninitated erros only; native 4th-routines.
erudot:A;:ok:
	pushfd
	pushad
	mov edx,eax
	xor ecx,ecx
	xor eax,eax
	mov ch,0x80
.v:
	mov cl,7	; no. of digits (nibbles)
	mov edi,esp
	push_ibyte(1) 	; cnt + trailing space
	mov esi,esp
	push_ibyte(0)
	lea ebx,[esp-1]
	lea esp,[esp-12]
	mov byte[ebx],' '
.p:
	inc dword[esi]
	shrd ax,dx,4
	shr ax,12
	inc ch
	shr edx,4
	jnz .z		;?; significant digit
	test ch,ch
	js .z		;?; fixed 8 digits size
	xor cl,cl	; insert "0" and exit
.z:
	cmp al,10
	jc .n
	add al,7
.n:
	add al,'0'
.r:
	dec ebx
	mov [ebx],al
	dec cl
	jns .p
	mov ecx,[esi]
	test eax,eax
	jns .s		; unsigned or +ve
	lea ebx,[ebx-2]
	lea ecx,[ecx+2]
	mov word[ebx],'$-'
.s:
	sys_write STDERR,ebx,ecx
	mov esp,edi	; drop loc. vari
	popad
	popfd
	ret
;-
%endif; __INIT_I
;- -- end of initial lo-level routines
;-
;-================================================================
;- l4init.inc <eof>
