;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-=====================================================================;
;-  file  	: l4ioport.inc
;-  created	: 04-aug-01
;-  modified	: -> re "version.inc"
;-  version	: 0.01(+)
;-  switches	: __IOPORT_I
;-  assembler	: nasm 0.98-3e (patched & bugs fixed 0.98)
;-  description	: "lib4th" shared library Forth kernel
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  source	: (me, hp)
;-  requires	: the "lib4th" package
;-=====================================================================;
;-
;-	
;-	

%ifndef __IOPORT_I
%define __IOPORT_I
%define ioportinc
;-
;-================================================================
;- -- i/o port access
;-

;-
;- ioperm 	( n1 n2 n3 -- er )		(s)		'sysioperm'	linux
;-	set access mode n3 of n2 ports beginning w. port no. n1.
;-	restricted to port 0..3ff, requires <root> access rights
;-	syscall ioperm -re- man 2 ...
sysioperm:GA;:ok:(w. level 3/0)
	push KR
	mov ebx,TOS(2)
	mov ecx,TOS(1)
	sys_ioperm eax
	pop KR
	TOSPULL(2)
	ret
;-
;- iopl		( n -- er )			(s)		'sysiopl'	linux
;-	set i/o permission level to n, requires <root> access rights
;-	syscall iopl -re- man 2 ...
sysiopl:GA;:ok:
	mov ecx,KR
	sys_iopl eax
	mov KR,ecx
	ret
;-
;- p@		( port -- n )					'pf'		linux
;-	read 32-bit value from port
pf:GA;:ok:
	mov edx,eax
	in eax,dx
	ret
;-
;- pw@		( port -- n )					'pwf'		linux
;-	read 16-bit value from port
pwf:GA;:ok:
	mov edx,eax
	in ax,dx
	movzx eax,ax
	ret
;-
;- pc@		( port -- n )					'pcf'		linux
;-	read 8-bit value from port
pcf:GA;:ok:
	mov edx,eax
	in al,dx
	movzx eax,al
	ret
;-
;- p@s		( ptr n port -- )				'pfs'		linux
;-	store n 32-bit values from port to memory at ptr
pfs:GA;:ok:
	push edi
	mov edx,eax	; port
	mov ecx,TOS(1)	; count
	mov edi,TOS(2)	; mem
	add edi,KR
	rep insd
	pop edi
	spop 3
	ret
;-
;- pw@s		( ptr n port -- )				'pwfs'		linux
;-	store n 16-bit values from port to memory at ptr
pwfs:GA;:ok:
	push edi
	mov edx,eax	; port
	mov ecx,TOS(1)	; count
	mov edi,TOS(2)	; mem
	add edi,KR
	mov edx,eax
	rep insw
	pop edi
	spop 3
	ret
;-
;- pc@s		( ptr n port -- )				'pcfs'		linux
;-	store n 8-bit values from port to memory at ptr
pcfs:GA;:ok:
	push edi
	mov edx,eax	; port
	mov ecx,TOS(1)	; count
	mov edi,TOS(2)	; mem
	add edi,KR
	mov edx,eax
	rep insb
	pop edi
	spop 3
	ret
;-
;- p!		( n port -- )					'ps'		linux
;-	store 32bit n data to port
ps:GA
	mov edx,eax
	spop
	out dx,eax
	spop
	ret
;-
;- pw!		( n port -- )					'pws'		linux
;-	store l.s. 16-bit of n to port
pws:GA
	mov edx,eax
	spop
	out dx,ax
	spop
	ret
;-
;- pc!		( n port -- )					'pcs'		linux
;-	store l.s. 8-bit of n to port
pcs:GA
	mov edx,eax
	spop
	out dx,al
	spop
	ret
;-
;- p!s		( ptr n port -- )				'pss'		linux
;-	store n 32-bit values from memory at ptr to port
pss:GA
	push esi
	mov edx,eax	; port
	mov ecx,TOS(1)	; count
	mov esi,TOS(2)	; mem
	add esi,KR
	mov edx,eax
	mov edx,eax
	mov edx,eax
	outsd
	pop esi
	spop 3
	ret
;-
;- pw!s		( ptr n port -- )				'pwss'		linux
;-	store n 16-bit values from memory at ptr to port
pwss:GA
	push esi
	mov edx,eax	; port
	mov ecx,TOS(1)	; count
	mov esi,TOS(2)	; mem
	add esi,KR
	mov edx,eax
	mov edx,eax
	mov edx,eax
	spop
	outsw
	pop esi
	spop 3
	ret
;-
;- pc!s		( ptr n port -- )				'pcss'		linux
;-	store n 8-bit values from memory at ptr to port
pcss:GA
	push esi
	mov edx,eax	; port
	mov ecx,TOS(1)	; count
	mov esi,TOS(2)	; mem
	add esi,KR
	mov edx,eax
	mov edx,eax
	outsb
	pop esi
	spop 3
	ret
%endif;__IOPORT_I
;-
;-=====================================================================;
;- l4ioport.inc <eof>
