;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-=====================================================================;
;-  file  	: l4jobs.inc
;-  created	: 04-aug-01
;-  modified	: -> re "version.inc"
;-  version	: 0.01(+)
;-  switches	: __JOBS_I
;-  assembler	: nasm 0.98-3e (patched & bugs fixed 0.98)
;-  description	: "lib4th" shared library Forth kernel
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  source	: (me, hp)
;-  requires	: the "lib4th" package
;-=====================================================================;
;-
;-	
;-	

%ifndef __JOBS_I
%define __JOBS_I
%define jobsinc
;-
;-================================================================
;- -- m-tasking
;-

;-
;- sh|		( p1 u1 p2 u2 -- )		n.i.				root
;-	execute an outer shell command by stg(p1,u1), pipe output to buffer(p2,u2)
shp:GA
	jmp nimp
;\
;\ sh|	( p1 u1 p2 u2 -- p3 u3 n )		(s)		root
;\	execute an outer shell command by stg(p1,u1),
;\	directing it's output via pipe to buffer(p1,u2), 
;\	ret ptr p3 to and count u3 of received data bytes and,
;\	n := -ve ernum or, +ve pid of executed 2nd-ary job.
;\	shell receives command and L4-jobs' environmental vari.
;\	note: char-size = byte = 8bits
;\	syscalls, re man(2): fork, dup2, execve, waitpid
;: sh|
;  over s0 @ $1001 dup >loc 0. locals| p1 p0 l lb br bu bp |
;\	locals:	p0,p1:pipe[2]; l:loc.cells; lb:loc.buf; bu,bp:out-buf.
;  lb 3 + dup path-max erase place	\ copy command into buf
;  lb 4+ 4th>abs rgs 8+ !		\ sto ptr to buf to argv struct
;  loc-ptr p0 4th>abs sp@ sys pipe
;  0if
;   -rot 2drop
;   new-chan p0 over fd>chan to p0 	\ create temp. channels
;   new-chan p1 over fd>chan to p1
;   0 sp@ sys fork dup
;   0if					\ <fork> ok
;    0 close-file 1 close-file 2drop
;    0 p0 ch-id sp@ sys dup2 >r 3drop
;    1 p1 ch-id sp@ sys dup2 >r 3drop r> r> or 0<
;    0if					\ both, <dup2> ok
;     p0 close-file p1 close-file 2drop
;     sh-envp sh-argp sh-prgp sp@ sys execve \ execve releases calling job!
;    endif
;   endif
;   dup 0< 
;   0if					\ no error from <fork>, @tos = pid
;    p1 close-file drop			\ close other end of pipe
;    bu #4096 /mod
;    -dup if				\ start w/ full size blocks
;     0 do				\ blocks
;      p0 ch-eof 
;      if leave
;      else
;       #4096 0 do			\ bytes of a block
;        p0 ch-eof 
;        if leave
;        else
;         p0 read-char if bp c! 1 +to bp -1 +to bu endif
;        endif
;       loop
;      endif
;     loop
;    endif
;    -dup if				\ remaining bytes
;     0 do
;      p0 ch-eof 
;      if leave
;      else
;       p0 read-char if bp c! 1 +to bp -1 +to bu endif
;      endif
;     loop
;    endif
;    sdrop 0 swap sp@ sys waitpid -rot 2drop \ wait until termination of 2nd-ary
;    $ffffff00 (aux) and! setty 		\ rst console state
;   endif
;  endif
;  bu 0> if 0 bp 1+ c! endif		\ terminate buffer data
;  -rot 2drop				\ pipe failure or parent return
;  br bp over- rot			\ ret buffer & count, pid/ernum
;  l negate >loc				\ discard local buffer

;-
;- sh		( p u -- )							root
;-	execute an outer shell command by stg(p,u)
sh:GA;:ok:
%assign sh_locals (PATH_MAX+7)/4
	spush
	push dword[byte uref uv.s0];=> 078
	mov eax,sh_locals;		p u l
	call toloc	;		p u
	spush
	mov eax,[esp]	; cmd buf	p u b	;=> b7f96f90
	add eax,byte 3
	spush		; dup
	spush
	mov eax,sh_locals*4;		p u b b m
	call erase	;		p u b
	call place	;		-.-
	mov edx,[esp]	; temp buf		;=> b7f96f90
	spush
	mov [esp],ebx	; protect KR in case of execve failure
	mov ecx,databot
	add ecx,[kref shargv-Y]
	add ecx,KR	;	sh-argp		=> c argp[]
	lea edx,[kref edx+4]; command..
	mov [ecx+8],edx	;  ..is 3rd arg
	lea edx,[kref rg1-Y]
	mov [ecx],edx	; shell's 1st arg
	lea edx,[kref rg2-Y]	; 2nd
	mov [ecx+4],edx
	mov edx,[uref uv.uargc]
	lea edx,[kref 8+edx*4]
	add edx,[uref uv.uargp]	; sh-envp	=> d envp[]
	pushad
	sys_fork	; create 2nd-ary job
	writead eax,eax
	popad
	test eax,eax
	mov ebx,[esp]	; KR back
	jnz .c		;?; caller
	spush
	lea ebx,[kref sht-Y]	; sh-prgp	=> b filename
;int execve (b:const char *filename,c:char *const argv [],d:char *const envp[]);
	sys_execve	; xec w/o return
.c:
	cmp eax,-4096
	ja .r		;?; error
	sys_waitpid eax,NULL,NULL;dword[PS],WUNTRACED	; -> eax := 'bad address'
.r:
	spush
	pop ebx
	mov byte[byte uref uv.aux+skey],0
	call setty	; rst/protect previous console state
	mov eax,-(sh_locals)
	jmp toloc
; <ss>, copy a channel description
sschan:A
	call newchan
	push eax
	call tochan
	add eax,databot
	pop ecx
	mov [kref eax],ecx
	spop
	ret
;-
;- syskill	( n1 +n2 -- er )		(s)(mc)				linux
;-	send signal +n2 to process(group) n1, receive error flag er.
;-	n1 +ve:job, n1=0:current process group, n1=-1:all but pid 0, n1 -ve:-(group)
;-	detailled description re man(2) kill, man(7) signal.
;-	syscall kill -re- man 2 ...
syskill:GA C;:ok:
	mov ecx,eax	; signal - ecx=signal, eax=pid -> eax:=ernum
	spop
	mov edx,ebx
	mov ebx,eax
	sys_kill
	mov ebx,edx
C syskill
	ret
;-
;- alarm   	( n -- )			(s)(4)		'calarm'	forth
;-	alarm signal after (n) seconds by syscall 'alarm', signal handler 
;-	executes deferred {(alarm)} which may be set to user supplied word.
;-	NOTE:	redirected calls due to till unknown reason could push/pop
;-		to/from datastack, and may even modify other ptrs/regs.
;-		check, before setting (alarm) to a self-calling 4th word!
;-	EXAMPLE: : a cur! 0. at-xy .time&date cur@ 10 alarm ;
;-		 ' a is (alarm)	1 alarm		\ enable
;-		 default-is (alarm)		\ disable
;-		-re- <4th/edit.f8>
calarm:GA;:ok:
	push ebx
	mov ebx,eax
	sys_alarm
	mov ecx,eax	; rmg time from previous, unfinished <alarm>
	pop ebx
	spop
	ret
;-
;-================================================================
;- -- self
;-
;-	

;-
;- uid@		( -- n )			(s)(m,8)	'uidf'		linux
;-	fetch real user id of calling job
;-	syscall getuid -re- man 2 ...
uidf:GA M;:ok:
	spush
	sys_getuid
M uidf
	ret
;-
;- gid@		( -- n )			(s)(m,8)	'gidf'		linux
;-	fetch real process-group id of calling job
;-	syscall getgid -re- man 2 ...
gidf:GA M;:ok:
	spush
	sys_getgid
M gidf
	ret
;-
;- uid!		( n -- er )			(s)(m,8)	'uids'		linux
;-	set real and effective user id of calling job
;-	syscall setuid -re- man 2 ...
uids:GA M;:ok:
	push ebx
	sys_setuid eax
	pop ebx
M uids
	ret
;-
;- gid!		( n -- er )			(s)(m,8)	'gids'		linux
;-	set real and effective process-group id of calling job
;-	syscall setgid -re- man 2 ...
gids:GA M;:ok:
	push ebx
	sys_setgid eax
	pop ebx
M gids
	ret
;-
;- real-user	( -- )				(s)		'ruser'		root
;-	if set, recover from setuid-mode: set effective user id equal to real one.
;-	syscalls getuid, setuid -re- man 2 ...
ruser:GA;:ok:
	push eax,ebx
	sys_getuid
	sys_setuid eax
	pop eax,ebx
	ret
;-
;- pid@		( -- n )			(s)(m,8)	'pidf'		linux
;-	fetch process-id of calling job
;-	re {4th-id} for main job-id
;-	syscall getpid -re- man 2 ...
pidf:GA M;:ok:
	spush
	sys_getpid
M pidf
	ret
;-
;- pause  	( -- )						'cpause'	system
;-	xec from @(pause) either by true address, by uot index or, by 'pfax' ptr.
;-	noop if zero, kref'd zero or, not in executeable program memory.
cpause:GA
	spush
	mov eax,[uref uv.upause]
	jmp execute
;-
;- [pause]  	( -- )				(s)		'bpauseb'	system
;-	force re-scheduling (nanosleep w. zero waiting time)
;-	syscall nanosleep -re- man 2 ...
bpauseb:GA;:ok:
	call dzero
;-
;- sleep-n  	( u1 u2 -- )			(s)		'nsleep'	linux
;-	sleep for u1 s + u2 ns
;-	syscall nanosleep -re- man 2 ...
nsleep:GA;:ok:
	mov edx,eax
	spop
	jr sleepm.s
;-
;- wait		( u -- )			(s)				forth
;-
;- sleep  	( u -- )			(s)				linux
;-	wait u seconds
;-	syscall nanosleep -re- man 2 ...
sleeps:GA;:ok:
	xor edx,edx
	jr sleepm.s
;-
;- ms		( u -- )			(s)(a:fx)			forth
;-	wait u milliseconds (accuracy greater than 2 o/oo, w. rt-linux).
;-	re DPANS 10.4.1.1/10.6.2.1905:
;-		repeatbility w/ rtl extension in range of nano-seconds, 
;-		otherwise deviation and min. time slice by about 10ms.
;-	syscall nanosleep -re- man 2 ...
ms:GA;:ok:
	mov edx,eax
	sar edx,31
	mov ecx,1000
	jr sleepm.w
;-
;- sleep-m	( u -- )			(s)(mc)				linux
;-	wait u microseconds
;-	syscall nanosleep -re- man 2 ...
sleepm:GA C;:ok:
	mov edx,eax	;cdq
	sar edx,31	;combined code is faster than cdq!
	mov ecx,1000000
.w:
	div ecx
.s:
	push ebx
	push edx
	push eax
	sys_nanosleep esp,esp
	lea esp,[esp+8]
	pop ebx
	spop
C sleepm
	ret
;-
;- tick>s  	( dn -- dn )					'tic2s'		forth
;-	convert cpu clocks to seconds
tic2s:GA;:ok:
	call tical	; ticks per second
	push eax
	spush
	xor eax,eax
	call udby
	pop ecx
	shr ecx,1
	cmp TOS(1),ecx
	jc .r
	inc dword TOS(1)
.r:
	ret
;-
;- tick		( -- dn )			(f6)(m,9)	'tic'		root
;-	read cpu hardware clock register, using "rdtsc" opr.
;-	re DPANS 10.4.1.1: can be used to determining duration of a system-clock tick.
tic:GA M;:ok:
; c: edx
	spush
	rdtsc
	spush
	mov eax,edx
M tic
	ret
;-
;- ?ms		( -- n )							ans
;-	ret no. of milli-seconds elapsed after host system start. not a standard 
;-	word! frequently used w/ certain (pseudo-)ansi-ish benchmark programs...
;-	initiall 1s delay - if neither {set-cal} nor {ti-cal} previously executed.
;-	NOTE: prefer {tick} and {ti-cal}, for reliable & exact time measurements.
qms:GA;:ok:
	call tic
	spush
	mov eax,1000
	call tical
	call mmulby
	spop
	ret
;-
;- set-cal	( -- )				(f6)(mc)	'setcal'	hidden
;-	find processor timing, 1s quiet + 1s for measurement.
;-	single (l.s.) cell result stored to user-vari (tick).
;-	multiple measurements accumulate to previous value, 1:1.
setcal:GA;:ok:
	spush 2
	pushad
	lea esp,[esp-8]
	push_ibyte(0)
	push_ibyte(1); 1s
	lea ecx,[esp+8]
	mov ebx,esp
	sys_nanosleep
	rdtsc
	push eax,edx
	sys_nanosleep
	rdtsc
	pop ebx,ecx
	lea esp,[esp+16]
	sub eax,ebx
	sbb edx,ecx
	mov TOS(1),eax
	mov [byte esp s_eax],edx
	popad
	spop
	mov ecx,[uref uv.utick]
	test ecx,ecx
	jz .s		;?; initial measurement
	add eax,ecx
	rcr eax,1	; accumulate average
.s:
	mov [uref uv.utick],eax; store timing value
	spop
	ret
;-
;:HIER: => locked datatransfer by basic/dedicated task, triggered by rt-signal :HIER: (n.i.)
;	suid programs, only! %define __lockthread in "constants.inc" to activate.
;- <srstosb>, <sstosb>, <srstosd>, <sstosd>, 
;- <srmovsd>, <smovsd>, <srmovsb>, <smovsb>
; -	locked data transfer suroutines,
; -	<sr...> w. decrementing ptrs, all end up in <cld>.
%ifdef __lockthread
srstosb:A
	std
sstosb:A
	rep stosb
	cld
	ret
srstosd:A
	std
sstosd:A
	rep stosd
	cld
	ret
srmovsd:A
	std
smovsd:A
	rep movsd
	cld
	ret
srmovsb:A
	std
smovsb:A
	rep movsb
	cld
	ret
%endif
;-
;- <rlock>					(k)
;-	exec routine on next on tor w. interrupts locked, port i/o enabled
;-	unlock, return to caller. - kernel routine, only.
rlock:A;:ok:
	push ecx		;		[ c r xa
	lea ecx,[kref mtunlock-Y]
	_xchg dword[esp+4],ecx	; c:=r		[ c u xa
	_xchg dword[esp+8],ecx	; c:=xa		[ c u r
	xchg [esp],ecx		; c:=c		[ xa u r
;-
;- mtlock  	( -- )								system
;-	lock multitasking, i.e. interrupts(!), enable global port i/o.
;-	use {mtunlock} or {xlock} to re-enable keyboard and files access.
;-	NOTE1: use PAIRED WITH {mtunlock}, else might leave OS un-accessible!
;-	NOTE2: interrupt locking active w/ root or suid root programs, only.
;-	%define __lockthread in "constants.inc" to locked data transfer mode.
mtlock:GA;:ok:
	pushad
	sys_getgid
	sys_iopl 3
	test eax,eax
	jnz .r
	cli
.r:
	popad
	ret
;-
;- xlock  	( ix -- )							system
;-	exec routine at ix while interrupts locked and port i/o enabled
;-	ix is uot index of word to execute. lock, exec, unlock, ret to caller.
;-	suid programs, only! %define __lockthread in "constants.inc" to activate.
xlock:GA;:ok:
	mov ecx,[uref uv.ultab+eax*4]
	spop
	call mtlock
	call ecx
;-
;- mtunlock	( -- )								system
;-	unlock multitasking: enable interrupts, disable global port i/o.
;-	a noop if not applicable, -re- {mtlock}
mtunlock:GA;:ok:
	mov ecx,KR
	mov edx,eax
	sys_iopl 3
	test eax,eax
	js .r
	sti
	sys_iopl 0
.r:
	mov KR,ecx
	mov eax,edx
	ret
;-
%endif;__JOBS_I
;-
;-================================================================
;- l4jobs.inc <eof>
