;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-=====================================================================;
;-  file  	: l4locals.inc
;-  created	: 04-aug-01
;-  modified	: -> re "version.inc"
;-  version	: 0.01(+)
;-  switches	: __LOCALS_I
;-  assembler	: nasm 0.98-3e (patched & bugs fixed 0.98)
;-  description	: "lib4th" shared library Forth kernel
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  source	: (me, hp)
;-  requires	: the "lib4th" package
;-=====================================================================;
;-
;-	
;-	

%ifndef __LOCALS_I
%define __LOCALS_I
%define localsinc
;-	
;-
;-----------------------------------------------------------------
;--- local memory
;-	<top> @s0[ data-stack ... tos]			- no locals
;-	<top> ..locals.. @s0[ data-stack ... tos]	- locals allocated
;-	most recent local data allocated @s0, stack content moved "up".
;-	ptr to <top> is absolute low limit for @s0 and locals and, can be
;-	used to control error situations if stack-ptrs became un-certain.
;-

;-	

;-
;- >loc		( n -- )							forth
;-	allocates and clears +n or de-allocates -n cells of local data-space,
;-	accordingly adjusts user vari {s0}, {(locb)} and {csp}.
;-	requires explicite removal by -ve n, before end of a compiled word, 
;-	use before {locals|} defn to keeping the rsp local values' ptrs valid.
;-	asm: LP register <esi> set to true addr @s0 after de-/allocation.
toloc:GA;:ok:<pathfile, sforget, plocalp, doloca, case)
%ifnidn LP,esi
%error "false LP register defn!"
%endif
%ifnidn PS,edi
%error "false PS register defn!"
%endif
	lea edx,[eax*4]	; bytes
	add [uref uv.ucsp],edx; adjust @csp
	test eax,eax
	jz .r		;?; noop
	js .f		;?; release space
	add LP,edx	; adjust LP to top address of local men
	push LP		; reg esi
	mov esi,[byte uref uv.s0]
	mov ecx,PS	; reg edi
	sub ecx,KR
	sub ecx,esi	; depth
	add [byte uref uv.s0],edx; new data-stack bottom == locals reference
	add [byte uref uv.locb],edx; error control
	mov esi,edi	; old data-stack top
	shr ecx,2	; depth in cells
	add edi,edx	; new tos
	mov edx,edi
	std		; top-down
	rep movsd	; copy stack content
	lea ecx,[eax+1]	; locals + @@s0
	mov eax,0
	test edi,7
	jz .c		;?; 8-aligned
	stosd
	dec ecx
	jng .x
.c:
	rep stosd	; clear local data-space
.x:
	cld		; back to bottom-up mode
	pop LP
	mov PS,edx	; new tos
.r:
	spop
	ret
.f:A
	neg eax
.d:;	;<dolocr (locals deallocation runtime), sforget, loforget, endcase)
	mov ecx,[byte uref uv.locb]
	test ecx,ecx
	lea edx,[eax*4]	; bytes to remove
	jz .r		;?; no locals present
	cmp edx,ecx
	jbe .s		;?; within reserved space
	mov edx,ecx
.s:
	sub LP,edx	; adjust
	sub [byte uref uv.locb],edx
	push LP
	mov ecx,PS	; PS = edi
	sub ecx,KR
	mov edi,[byte uref uv.s0]
	sub ecx,edi	; depth
	add edi,KR
	sub [byte uref uv.s0],edx; drop locals
	mov esi,edi
	shr ecx,2	; cells count
	sub edi,edx
	rep movsd	; edi := PS
	spop
	pop LP
	ret
; i: eax := stg count, stg ptr @nos
; o: ecx := 10 for 'comment', 0<=ecx<9 for no. of cells to allocate
;    edx :  ls.4chars
;    eflags Z if flag found
locspec:A;<plocalp):ok:
	cmp eax,byte 2
	jg .r		;?; not a flag, ret NZ*NS
	mov ecx,TOS(1)
	mov edx,[kref ecx]
	mov ecx,10;;;
	jz .m		;?; 2 chars stg
	inc ecx;;;11
	cmp dl,'|'
	jz .d		;?; end of LOCALS| list
	inc ecx;;;12
	cmp dl,';'
	jz .d		;?; end of stack order list (n.i.)
	inc ecx;;;13
	cmp dl,'}'
	jz .d		;?; end of uninitiated LOCALS{ -- ..
	ret
.m:
	cmp dx,'--'
;;	mov ecx,10;
	jz .d		;?; comment
	cmp dh,':' ;(58)
	jnz .r		;?; not an allocation instr.
	cmp dl,'9'
	mov cl,dl
	ja .r
	sub cl,'0'
	cmp ecx,ecx	; ret Z
.d:
	spop 2		; end of LOCALS| partial list
.r:
	ret
;-
;- (LOCAL)	( p u -- )			(e)		'plocalp'	ans
;-	builds a local wordheader w. name from string(p,u). 
;-	use not within a control structure!
;-	stores disp to local cell wrt LP = @s0 to 'body'.
;-	at compile-time allocates local memory as required, diff @s0 before 
;-	and after; single cell runtime reservation.
; ;-	and after; single cell runtime reservation or, as specified, below.
;-	reserved names:
; ;-		'0:'	no allocation, name follows, referring to previous posn
; ;-		'M:'	allocates 0 < M < 10 cells, name follows,
; ;-		's:'	default mode, sing local values follow
;-		'--'	introducing comment in " .. { .. | .. -- .. } "
;-		';'	terminator of other purpose ordered lists - n.i.
;-		'}'	terminator in " .. { .. | .. -- .. } "
;-		'|'	terminator in " .. locals|  ...  | " and,
;-			introducing zero-initiated locals in ".. { .. | .. -- .. }"
;-		';', 'M:' 
;-			reserved for other data structures (M = single decimal digit)
;-	(e: ret Z and char(s) in edx after reserved name, else NZ)
plocalp:GA;:ok:			; NZ after orderly return from <plocalp>
	call locspec
	jz locspec.r		;?;Z if stg is a reserved flag
	mov ecx,[byte uref uv.s0]
	sub ecx,[byte uref uv.lp]
	sub ecx,(whead_size+11)/4; max. len of a local value's word header, $118 bytes
	jns .n			;?; no allocation required
	spush
	mov eax,(whead_size+11)*8; enables about 30 reasonably named items
	call toloc		; >loc
.n:
	call lpxdp		; lp dp !!
	spush
	mov eax,[byte uref uv.s0]; s0 @
	call dtop		; d-top
	spush			; dup
	mov eax,[kref eax]	; @
	call tor		; >r
	call store		; !
	call here		; here
	call place		; place
	push dword[byte uref uv.ocurrent]
	push dword[byte uref uv.ocurrent-4]
; temporarily define in, i.e. link new word to, {local} wordlist
	call blocdefb		; { also local definitions }
	call here		; here
	spush
	mov eax,lochead-Y	; <lochead> >r
	call build		; build
	call unsmudge		; and ecx:=ffa
	add dword dataptr,byte 8; body+4, for xec & disp
	or word[ecx],locvf	; flags: xec from pfa, immediately, word has an extra datafield, non-optimizing
	movzx edx,word[ecx-whead.f+whead.i]
	mov dword[uref uv.ultab+4*edx],0; clr uot xec address
	lea edx,[ecx-whead.f+whead.n]; lfa->body
	movzx ecx,byte[edx]
	lea edx,[edx+ecx+whead.x-whead.n+whead.b-whead.p]; body
	and edx,byte -4
	mov dword[edx-4],dolocc-Y; wa at pfa
	mov ecx,[byte uref uv.locn]
	add ecx,byte 4		; bytecount
	mov [edx],ecx
	mov [byte uref uv.locn],ecx; count no. of used bytes
; -?- :HIER: locals' forget handler :HIER: -?-
; rst search order and defining vocabulary
	call prevdef
	call previous
	pop dword[byte uref uv.ocurrent-4]
	pop dword[byte uref uv.ocurrent]
	call rfrom
	call dtop
	call store
lpxdp:
	mov ecx,[byte uref uv.lp]
	mov edx,[byte uref uv.dp]
	test ecx,ecx		; set NZ, flag ordinary name
	mov [byte uref uv.lp],edx
	mov [byte uref uv.dp],ecx
	ret
; <lochead>
; name stg to local header at build-here = new word's nfa
lochead:A
	call cfetchp	; count
	call here
	push eax
	call place
	spush
	pop eax
	spush
	mov eax,0
	ret
; <qlocsq>
; for {locals}, {locals?}
qlocsq:A
; c: ecx, eflags
	push edx
	mov ecx,[byte uref uv.lp]
	mov edx,[byte uref uv.s0]
	add ecx,KR
	add edx,KR
	sub ecx,edx	; S if local dataspace available
	pop edx
	ret
;-
;- locals 	( -- n )							forth
;-	ret number n of currently available, reserved local cells.
locals:GA
	spush
	call qlocsq
	mov eax,ecx
	neg eax
	sar eax,2
	ret
;-
;- locals?  	( n -- flg )					'localsq'	forth
;-	tf if suffient no. of currently reserved local cells available.
localsq:GA;:ok:
; c: ecx
	call qlocsq
	lea eax,[ecx+eax*4]
	sar eax,31
	ret
;-
;- loc-body	ccc(C: -- )(X: -- p )		(i)		'locbody'	local
;-		ccc(I: -- p )
;-	find ptr to "body" of word ccc in {local} wordlist, return/compile literal ptr p.
;-	compiletime utility, ix invalid after word defn finished.
locbody:GA;:ok:
	call loctick
	call tobody
	jmp literal
;-
;- loc'		ccc(C: -- )( -- ix )		(i)		'tick'		local
;-	imed. get xt of a local name ccc, else abort-38 err.ni
;-	compiletime utility, ix invalid after word defn finished.
loctick:GA
	call BLWORD
	call cfetchp
	spush
	mov eax,Ilocal
	call idx2wid
	call wid2top
	call swlist
	spop
	jz near tick.r
	ret
;-
;- loc!!  	ccc ccc( -- )			(i)		'locxsto'	forth
;-	exchange two local values by names, use{ loc!! name1 name2 }.
locxsto:GA;:ok:
	call locptr
	call locptr
	call ccplq
	jnz .c		;?; compiling
.m:A;	;<locptr,locbody)
	mov edx,TOS(1)
	mov ecx,[kref eax]
	push ecx
	mov ecx,[kref edx]
	mov [kref eax],ecx
	pop ecx
	mov [kref edx],ecx
	spop 2
	ret
.c:
	mov ecx,codeptr
	spush
	mov eax,.m-Y
	jmp cplicall
;-
;- l!!		( p1 p2 -- )			(k)		'dolxsto'	novoc
;-	runtime code for {loc!!}
dolxsto:equ locxsto.m
;-
;- loc-ptr	ccc(C: -- )(X: -- p )		(i)		'locptr'	forth
;-	get literal ptr to runtime data-space of a local value
locptr:GA;:ok:;<locxsto)
	call loctick
	call tobody
	call ccplq
	jnz .c		;?; compiling
	mov ecx,[byte uref uv.s0]
	sub ecx,[kref eax]
	mov eax,ecx
	ret
.c:
	mov eax,[kref eax]
	jmp c_locp
;-
;- locals|	ccc( -- )(C: n1..nn -- )		(i)(a:lx) 'locbar'	forth
;-	parse list of names delimited by "|" and assign local values, accordingly.
;-	use at beginning of a colon definition, before any other control structure.
;-	accessing double items:
;-		.. locals| n1h n1l | .. loc2@ n1h d. .. loc-ptr n1l 2@ d. ..
;-	(Non-)Limits:
;-	Locals don't interfere w/ any other data access method, stacks, dictionary, 
;-	etc. and, next levels' locals can be accessed in the order of definition.
;-	The number of locals is not limited other than by available stack- and 
;-	data-space, locals' names are limited to the common 255 chars (bytes) as 
;-	for any words' names. A runtime local takes 4 bytes of locals area, "below" 
;-	data-stack, and 7 bytes in code-space. While compiling a local uses 8 cells 
;-	plus name-length in data space and an uot index.
;-	further description re {local:}, compile-mode, and ANS word {(LOCAL)}.
locbar:GA;:ok:
	call .b
.t:;	;<loccb.c, loccb.o)
	mov ecx,[uref uv.ulocvb]
	sub ecx,[byte uref uv.s0]; used local bytes, for de-allocation w/ exitf
	mov [uref uv.ulocvb],ecx
	ret
;-
;- locref{ ccc ... } ( -- )				(i)	'locref'	forth
;-	refer to a caller's locals in sequence of given names list such, that any
;-	group of forth words operating on locals can be factored to separate words
;-	w/o requiring repeatedly fetching and storeing just to pass the arguments.
;-	names by this list are local, used to compile the rsp. reference by index
;-	in sequence left to right, which coincides w/ the sequence of the caller's 
;-	words, regardless of their names, if set up with -re- "{".
;-	next levels' locals can be accessed in the order of definition.
;-	NOTE1: a thus defined word cannot allocate own local values!
;-	NOTE2: access to doubles as in the word the locals of which locref{ refers to.
locref:GA
	or dword[byte uref uv.state],mlocr
;-
;- {		ccc( -- )(C: n1..nn -- )		(i)	'loccb'		forth
;-	define local values in stack flow notation order, left to right.
;-	use "{ initiated locals | self-zeroing locals -- comment }"
;-	accessing double items:
;-		.. { n1l n1h } .. loc2@ n1l swap d. .. loc-ptr n1h 2@ swap d. ..
;-	NOTE:	this was a short 'hack' to enabling the apparently more 'fashionable'
;-		notation in stack flow order, where only(!) the initated locals cells 
;-		storage is in opposite order wrt that of {locals|}.
loccb:GA;:ok:
;(apparently, the more "fashionable" setup... to simplifying documentation,
;(compiles a bit slower, executes zero-initaliazation slightly faster.
	push dword[uref uv.ulocvc]
	call locbar.b
	spush
	pop eax
	cmp eax,[uref uv.ulocvc]; local locals counter
	jz .d			;?; no initated locals
	test dword[byte uref uv.state],mlocr;locref{}
	jnz .d			;?; locref{}
	push edx		; patch indices to reversed order
	xor eax,eax
	mov edx,codeptr
	lea edx,[kref edx-4]
	mov ecx,[edx]		; top index
.p:
	sub eax,byte 4
	mov [edx],eax
	sub edx,byte 9
	cmp ecx,eax
	jnz .p			;?; more in list
	pop edx
.d:
	spop
	cmp dl,'|'		; <ecx>=11
	jz .i			;?; uninitated values
.c:
	cmp dx,'--'		; <ecx>=10
	jnz locbar.t		;?; no comment, terminate locals defn
.o:
	spush
	mov eax,'}'		; <ecx>=13
	call xword		; discard comment
	jr locbar.t
.i:A
	call locol
	jz .c			;?; terminated
	mov ecx,codeptr		; patch to zero-initiating runtime code
	add dword[kref ecx-8],byte (dolocz-doloci)
	jr .i
locbar.b:A
	call qcomp
	mov ecx,[byte uref uv.s0]
	mov [uref uv.ulocvb],ecx; cpl-mode loc-mem
.l:
	call locol
.d:
	jnz .l
	ret
;-
;- local: 	ccc(C: -- )(C: p f ix -- )(X: -- n )	(i)(a:l) 'locol'	hidden
;-		ccc(I: n -- )		(X: -- n )
;-	define a single cell sized local value by name ccc. used by {locals:}.
;-	use outside any other control structure, preferrably at beginning of a 
;-	coln defn. words with a {locals|} group may be {exit}ted, out of order.
;-	While interpreting:
;-		constitute a {value} in local dataspace, in {local} wordlist
; -		which is accessible until {no-locals} or removed by {forget}.
; -		removing a local value does not modify any other wordlist.
;-	  execution of <ccc>:
;-		push local value to tos.
;-	While compiling:
;-		constitute a {value} in local dataspace, in {local} wordlist,
;-		accessible by name within the current colon-definition, only.
;-		initially push 3rd control item to tos, set <mlocal> state-bit.
;-	  runtime <ccc> declaration:
;-		assign local data-space, transfer cell from tos.
;-	  execution:
;-		push local value to tos.
;-	Data structure:
;-		memory	@s0-@(locb}[ local memory .. @last ... local value(s) ]@s0
;-		xec	[ header [@pfa=kref(xec)][@body=disp] ]
;-		value	@(@s0-disp)
;-	Storing a value
;-		1: value initially taken from @tos.
;-		2: {to} and {+to} designed to modify either, local or global {value}s.
;-		3: by ptr to local data-field ( nn -- ) { loc-ptr name ! }
;-		   multiple cells storage in descending order of locals assignation,
;-		   latest named local stores l.s.cell of the rsp. item, for instance
;-			{ ..locals| n1 n2 n3 n4 | loc-ptr n4 4!.. }
;-		4: fetch/store a double ( d1 -- d2 ) { ..loc2! name .. loc2@ name.. }
;-	NOTE1:	while compiling pushes a 3rd cell to control-stack (at data-stack)
;-		which will be required for locals resolution by {;}, therefore the 
;-		locals| group should not be cpl'd within a program flow structure.
;-	NOTE2:	due to indirection of local data access, global values, variables 
;-		or constants execute faster than locals; a short sequence of simple 
;-		stack operations may be much faster, still.
;-		also, consider utilizing the {pick} and {-pick} operations.
;-	NOTE3:	locals stored to contiguous data-space, thus linearly accessible
;-		across multiple, unlimited levels.
locol:GA;:ok:
;	defn while compiling			: interpreting
; i:	@tos	sp@ lp@	| ix sp@ lp@		: nn
; o:	@tos	ix sp@ lp@ (compiling)		: -/-
;	@lovcvc	inc by 1
;	@lp	advanced by header-length	| by cellsize 
	call BLWORD		; get name
	call cfetchp		; count
	call plocalp		; setup local data-space and named word-header
	jz .r
	call lastu		; last
	inc dword[uref uv.ulocvc]; local locals counter
	mov eax,[kref eax]	; @ - this word's lfa
	call lfa2pfa
	call ccplq
	jnz .c			;?; compiling
;interpreting:
; set up a local value, store @tos to value @(@s0-disp)
	mov dword[kref eax],dolocv-Y; fetch local value
	mov ecx,[byte uref uv.s0]
	sub ecx,[kref eax-whead.p+whead.b]; disp
	mov eax,TOS(1)
	mov [kref ecx],eax
	spop 2
.r:
	ret
.c:A;compiling:
;	cpl call to initiation procedure
; i:	@tos	@last
	call rrbrac
; --
	mov ecx,mlocl
	test dword[byte uref uv.state],ecx
	mov edx,eax
	jnz .t			;?; other locals exist
; initiate 'locals present' state
	or dword[byte uref uv.state],ecx; flag locals present
	mov eax,[byte uref uv.lkindex]
	dec eax			; ix of 1st local
	test dword[byte uref uv.state],mlocr;locref{}
	jnz .i			;locref{}
	spush
	mov eax,edx		; lfa
; accumulated locals memory allocation
	TICK doloca
	call compilec
	spush
	mov eax,codeptr		; store ref ptr
	mov [uref uv.ulocptr],eax
	xor eax,eax
	call cpl4		; no. of allocation units (cells)
.t:
	test dword[byte uref uv.state],mlocr;locref{}
	jnz .g			;locref{}
	mov eax,[kref eax+4]	; loc. disp
	neg eax			; -ve	{ ld ix sp@ lp@
	TICK doloci
	call compilec
	call cpl4		; and -ve disp
.i:;			;<locref{}
	mov [PS],eax
.l:
	jmp llbrac		;	{ ix sp@ lp@
.g:;			;<locref{}
	spop
	jr .l
;-
;- local values, runtimes
;-	

;-
;- lz:		( -- )				(k)		'dolocz'	novoc
;-	zero-initate single cell local vari, cpld by compiling "{"
dolocz:A;:ok:
; c: ecx
	mov ecx,[esp]		; addr of compiled disp
	add [byte uref uv.locn],byte 4
	mov [esp],edx
	mov edx,[ecx]		; disp
	mov dword[LP+edx],0
%ifdef __K6__
	lea ecx,[ecx+4]
	mov edx,[esp]
	mov [esp],ecx
	ret
%else
	add ecx,byte 4
	pop edx
	jmp ecx
%endif
;-
;- lv:		( n -- )			(k)		'doloci'	novoc
;-	initate single cell local vari, cpld by compiling {local:}
doloci:A;:ok:
; c: ecx
	mov ecx,[esp]		; addr of compiled disp
	add [byte uref uv.locn],byte 4
	mov [esp],edx
	mov edx,[ecx]		; disp
	mov [LP+edx],eax
%ifdef __K6__
	lea ecx,[ecx+4]
	mov edx,[esp]
	mov [esp],ecx
	spop
	ret
%else
	add ecx,byte 4
	pop edx
	spop
	jmp ecx
%endif
;-
;- loc2!	ccc( dn -- )			(i)(C)		'loc2s'		local
;-	cpl store double local vari, using named value's posn and next.
;-	little endian cells order wrt {locals|} setup, name ccc at l.s.cell.
loc2s:GA
;little endian cells order, i.e. @tos to smaller disp
	call qcomp
	call loctick
	call tobody
	mov eax,[kref eax]	; @body
	neg eax
	spush
	call c_locto		; m.s. cell 1st
	sub eax,byte 4
	jmp c_locto
;-
;- loc2@	ccc( -- dn )			(i)(C)		'loc2f'		local
;-	cpl fetch double local vari, using named value's posn and next.
;-	little endian cells order wrt {locals|} setup, name ccc at l.s.cell.
loc2f:GA
; c: ecx
	call qcomp
	call loctick
	call tobody
	mov eax,[kref eax]	; @body
	neg eax
	spush
	sub eax,byte 4		; l.s. cell 1st
	call c_locv
	jmp c_locv
;-
;- la:		( -- )				(k)(r)		'doloca'	novoc
;-	runtime local values' memory allocation, cpld by compiling {local:}
;-	local data-space erased. LP-reg := @s0 := @s0 + local bytes, by {>loc}.
doloca:A; -?- 
	spush
	mov ecx,[esp]
	mov LP,[byte uref uv.s0]
	add dword[esp],byte 4
	add LP,KR	; LP := @s0 true address
	mov eax,[ecx]
	jmp toloc
;-
;- lv>		( -- )				(k)(r)		'dolocc'	novoc
;-	fetch local value defined while compiling, cpl'd to pfa of (LOCAL) word
dolocc:A;:ok:
; i:	ecx	kref'd ptr to body
	spush
	mov eax,[kref ecx]	; @body
	neg eax
	jmp c_locv
;-
;- lv@		( -n1 -- n2 )			(k)(r)		'dolocv'	novoc
;-	fetch local value which was defined while interpreting, by {local:}
dolocv:A;:ok:
; i:	ecx	pfa, from find/execute
	spush
	mov eax,[byte uref uv.s0]
	sub eax,[kref ecx]
	mov eax,[kref eax]
	ret
;-
;- lv;		( -- )				(k)(r)		'dolocr'	novoc
;-	runtime remove local values. cpl'd by <locrmv> before ;s
dolocr:A;:ok:
	spush			; pass cells to deallocate to {>loc}
	mov ecx,[esp]
	mov eax,[ecx]		; local values' cells
	add dword[esp],byte 4	; advance to after disp data
	lea ecx,[eax*4]
	sub [byte uref uv.locn],ecx
	jmp toloc.d		; de-allocate
;-
;- locrmv 	(C: ps lp | ix ps lp -- )	(i)(c)				compiler
;-	cpl intermediate local values de-allocation, do-nothing if none exist; by {;s}
locrmv:GA;:ok:<exitf)
; 1)	cpl local mem de-location
;	uv.ulocvc: local locals counter
	call qcomp
	bt dword[byte uref uv.state],blocl
	jnc .r			;?; no locals exist
	bt dword[byte uref uv.state],blocr;locref{}
	jc .r			;?; reference, only
	spush
	mov ecx,[uref uv.ucsp]	; get cpl-stack
	mov eax,[kref ecx]	; copy control data
	spush 
	mov eax,[kref ecx+4]
	spush
	mov eax,[kref ecx+8]
	call .f			; cpl de-alloc, remove names
	spop 3
.r:
	ret
.f:A;	;<locrmv), <locres before loforget)
	spush			; dup			{ ix ix ps lp
	mov eax,[uref uv.ulocvc]; #locals
	mov ecx,[uref uv.ulocptr]
	mov [kref ecx],eax	; cells to allocate
	TICK dolocr		; de-allocation runtime
	call compilec
	jmp cpl4		; no. of bytes		{ ix ps lp
;- <locres>
;-	while compiling check whether locals defined, cpl final locals de-allocation
;- i:	@tos	{ sp@ lp@ } | locals{ ix sp@ lp@ } & <blocl> flag in @bits set
locres:A;:ok:<qcolon - by <semi>, terminating a <colon>-defn)
	btr dword[byte uref uv.state],blocl
	jc .f			;?; locals exist
	and dword[byte uref uv.state],~(mlocr);locref{}
	ret
.f:A
	btr dword[byte uref uv.state],blocr;locref{}
	jc .l			;locref{}
	call locrmv.f
.l:
	mov dword[uref uv.ulocvc],0; reset local locals counter
; 2)	clear compile-locals
;	@tos=1st local uot index
; <loforget>
;	compiling mode, forget local value(s) by ix 
; i:	@tos	ix xx lp
; o:	@tos	ix xx lp
;	-/-	@last, @lp, @lkindex adjusted
loforget:A;:ok:
	push eax		; >r					[ ix
	call idx2lfa		; local lfa		{ lf ps lp	[ ix
	push eax		; >r
	call lfa2head		; lfa>head
	mov [byte uref uv.lp],eax;lp !
	mov eax,[esp]		; r>
	sub eax,[kref eax]	; dup @ -		{ lf ps lp	[ ll ix
	mov [esp],eax		; >r		save last link
	mov eax,Ilocal		; ' local
	call idx2wid		; idx>wid in ram	{ wd ps lp	[ ll ix
	lea ecx,[eax-vhead.m+vhead.p];ptr to top lfa
	pop edx			; r>		last link
	mov [byte uref uv.last],edx;dup last !
	sub edx,ecx		; -
	neg edx			; negate
	mov [kref ecx],edx	; swap !	rst old link
; -- ; adjust count & local dp
	pop eax			; ix
	sub eax,[byte uref uv.lkindex]
	add [byte uref uv.lkindex],eax; discard locals
	sal eax,2
	add [byte uref uv.locn],eax
; --
	mov eax,[uref uv.ulocvb]
	sar eax,2		; +ve!
	jmp toloc.d
%endif;__LOCALS_I
;-
;-=====================================================================;
;- l4locals.inc <eof>
