;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-=====================================================================;
;-  file  	: l4sighnd.inc
;-  created	: 17-jul-01
;-  modified	: -> re "version.inc"
;-  version	: 0.01(+)
;-  switches	:
;-  assembler	: nasm 0.98-3e
;-  description	: sgnal handlers redirection
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	:
;-  source	: linux sources
;-  requires	: the "lib4th" package
;-=====================================================================;
;-

;-	
;-	
;-
;-================================================================
;- -- signal handlers & setup
;-

;-	

;sa_m, sa_x:
;    struc old_sigaction
;.hnd:	resd 1
;.msk:	resd 1
;.flg:	resd 1
;.rst:	resd 1
;rsa_m, rsa_x
;    struc rt_sigaction (added the "rt_", for asmutils [hp])
;.hnd:	resd 1	;handler
;.flg:	resd 1	;SA_SIGINFO;flags
;.rst:	resd 1	;NULL	; restorer ; (unused) -?- no! just glibc...
;.msk:	resd 1	;NULL	; mask
;.xtd:	resd 1	;NULL	; (extended)
; hnd blocks in persistent memory!
;and, yet another one, in 2.4. kernels:
;    struc new_sigaction
;.hnd:	resd 1	;
;.act:	resd 1	;
;.msk:	resd 1	;
;.flg:	resd 1	;
;.rst:	resd 1	;
sighndblk:A
sa_m:;	; signals which send a message
	dd rsigt-Y	; hnd
	dd NULL
	dd SA_SIGINFO	;flags
	dd NULL		; restorer - nee!?
	dd NULL		; (padding);;;
sa_x:;	; signals which exit
	dd rsigb-Y	; hnd
	dd NULL
	dd SA_SIGINFO	;flags
	dd NULL
	dd NULL		; (padding);;;
; rt-signals
rsa_m:
	dd rsigt-Y	; hnd
	dd SA_SIGINFO;flags
	dd NULL		; restorer ; (unused) -?- no! just glibc...
	dd NULL		; mask
	dd NULL		; (extended)
rsa_x:
	dd return-Y	; hnd
	dd SA_SIGINFO	;flags
	dd NULL		; restorer
	dd NULL		; mask
	dd NULL		; (extended)
sa_s:; silent: child
	dd rsigb-Y	; hnd	
	dd SA_SIGINFO	;flags
	dd NULL		; restorer
	dd NULL		; mask
	dd NULL		; (extended)
; arithmetic fault
sa_fpe:
	dd rfpesig-Y
	dd NULL
	dd SA_SIGINFO
	dd NULL
	dd NULL		; (padding);;;
; segfault
;%ifndef quit_sig	; muell..
;sa_quit:
;%endif
sa_segf:
	dd rsegsigh-Y
	dd NULL
	dd SA_SIGINFO
	dd NULL
	dd NULL		; (padding);;;
; winch
sa_winch:
	dd rsegwinch-Y
	dd NULL
	dd SA_SIGINFO
	dd NULL
.w:
	dw 0,0		; main cosole window, rigth and bottom max by char count
;%undef quit_sig
%define quit_sig
%define quit_rt_sig	; immerhin, (halbwegs) :ok:...
%ifdef quit_sig
; quit <CTR"\"> #3
sa_quit:
    %ifdef quit_rt_sig
	dd quits-Y
	dd SA_SIGINFO
	dd NULL
	dd NULL
	dd NULL		; (extended)
    %else
	dd quits-Y
	dd NULL
	dd SA_SIGINFO
	dd NULL
	dd NULL		; (padding);;;
    %endif
%endif
; alrm
sa_alrm:
	dd rsegalrm-Y
	dd NULL
	dd SA_SIGINFO
	dd NULL
	dd NULL		; (padding);;;
sighndblk.e:
;-
;- sighnd-size	( -- n )					'sighsz'	linux
;-	(unified) size of a signal handler definition block. -re- uvari {(sighnd)}.
sighsz:GA
	spush
	mov eax,sighndblk.e-sa_alrm
	ret
;-
;- <isegf>
;-	signal handlers setup in dataspace, from relative ptrs, 
;-	after system set up, before input mode determination and entry into hi-level 4th
isegf:A;:ok:
;:HERE: use <sigaltstack> for jobs and signals handlers separation -?- :HIER:
; user vari expected already set up!
	pushad
	call getrefb	;>:KREF:
	call falign
	lea esi,[kref sighndblk-Y]
	mov ecx,(sighndblk.e-sighndblk)
	mov edi,dataptr
	add dataptr,ecx	; advance to after hnd storage
	mov [byte uref uv.sigh],edi
	add edi,KR
	shr ecx,2
	push ebx	; save kref
	push edi	; & data-ref
	rep movsd	; hnd-descr. to data-mem
	mov edx,[esp]
	add [edx+sa_m-sighndblk],KR
	add [edx+sa_x-sighndblk],KR
	add [edx+rsa_m-sighndblk],KR
	add [edx+rsa_x-sighndblk],KR
	mov ebx,31	; available signal no's
.l:
	xor esi,esi
	mov edx,[esp]	; dataref
	mov edi,esi
	lea ecx,[edx+sa_x-sighndblk]; hndler for exit sgs
	mov eax,sgmask	; signals which exit
	bt eax,ebx
	jc .a
	mov eax,mgmask	; signals which send a message
	bt eax,ebx
	jnc .n		;?; neither exit nor message
	lea ecx,[edx+sa_m-sighndblk]; hndler for message sgs
.a:
	sys_sigaction EMPTY,EMPTY,0;;ebx,ecx,0;
.n:;	; rt signals
	mov ecx,[esp]
	lea ecx,[ecx+rsa_m-sighndblk]
	lea ebx,[ebx+SIGRTMIN]
;;	sys_rt_sigaction ebx,ecx,0,_NSIG/8; sig#,hnd,?,#sig bits
	sys_rt_sigaction EMPTY,EMPTY,0,_NSIG/8; sig#,hnd,?,#sig bits
	sub ebx,byte SIGRTMIN+1
	jnz .l
; - specific signal handlers -
	mov edx,[esp]
	mov ebx,[esp+4]
	lea ecx,[edx+sa_fpe-sighndblk]
	add [ecx],KR
	sys_sigaction SIGFPE,ecx,0
	mov edx,[esp]
	mov ebx,[esp+4]
	lea ecx,[edx+sa_segf-sighndblk]
	add [ecx],KR
	sys_sigaction SIGBUS,ecx,0
	sys_sigaction SIGILL,ecx,0
	sys_sigaction SIGSEGV,ecx,0
	mov edx,[esp]
	mov ebx,[esp+4]
	lea ecx,[edx+sa_winch-sighndblk]
	add [ecx],KR
	sys_sigaction SIGWINCH,EMPTY,0
%ifdef quit_sig;;taugt nix!;
	mov edx,[esp]
	mov ebx,[esp+4]
	lea ecx,[edx+sa_quit-sighndblk]
	add [ecx],KR
    %ifdef quit_rt_sig
	sys_rt_sigaction SIGQUIT,EMPTY,0,_NSIG/8
    %else
	sys_sigaction SIGQUIT,EMPTY,0
    %endif
%endif
	mov edx,[esp]
	mov ebx,[esp+4]
	lea ecx,[edx+sa_alrm-sighndblk]
	add [ecx],KR
	sys_sigaction SIGALRM,ecx,0
	lea esp,[esp+8]
	popad
	ret
;- 
;-  signals (checked w. 2.2.14-rtl2.0 debian2.2/rtlinux, 2.4.16 and, 2.2.5 redhat6.0)
;-	leaves the pc of where the signal was triggered on stack, (apparently) 
;-	at @{@{tos+8}+19*4} which can be used to job control and debugging.
sigtmsg:GA
;	Which is not at all reliable! i.e. there are three different definitions
;	of the <sigaction> structure in the manuals/kernel data. I'd whish those
;	system designers would make their mind up, some time, and explain(!)...
;	pc at signal time in @{@{tos+8}+19} (and @{@{tos+4}+33*4})
; 1st level subroutine from signal hnd
	push eax
	push ecx
	mov eax,[esp+16]
	neg eax
	call sigmsg		; send signal message to stderr
	pop ecx
	pop eax
	ret
; display process id to stderr ">p>num"
ppid:GA;:ok:
	pushfd
	pushad
	sys_getpid
	mov ecx,' >p>'
	call ersmsg
	popad
	popfd
	ret
; display pc where signal occurred to stderr " PC:(kref'd val) @:(code)"
; in:	eax	ptr to sig-stack
sigpc:A
	push eax,ecx
	mov eax,[eax+8]	; arg(2)
	mov eax,[eax+19*4]	; posn(19) -> pc at offending opr
	sub eax,KR
	mov ecx,' PC:'
	call erumsg
	call kprange
	jc .r
	mov ecx,'@:'
	call erkmsg
.r:
	pop eax,ecx
	ret
	; dump univ. regs to STDERR
dumpregs:A
	push eax,ecx
	mov ecx,'a:'<<8|AC_NL
	call erumsg		; eax
	mov ecx,'b:'
	mov eax,ebx
	call erumsg		; ebx
	mov ecx,'c:'
	mov eax,[esp]
	call erumsg		; ecx
	mov ecx,'d:'
	mov eax,edx
	call erumsg		; edx
	mov ecx,'S:'
	mov eax,esi
	call erumsg		; esi
	mov ecx,'D:'
	mov eax,edi
	call erumsg		; edi
	mov eax,ebp
	mov ecx,'B:'
	call erumsg		; ebp
	mov eax,esp
	mov ecx,'r:'
	call erumsg		; signals' esp
	mov ecx,AC_NL
	call erustg		; <nl>
	pop eax,ecx
	ret
;-
;- sgb		( -- )				(k)(r)		'rsigb'		novoc
;-	terminating/recovering signals hnd
rsigb:A
	push eax
	mov eax,[esp+8]	; sig# arg(1)
	cmp eax,SIGILL
	jz rsegsig		;?; illeg op
	pop eax
.r:
	call dumpregs
	call getrefb		;>:KREF:
	mov ecx,' s# '
	mov eax,[esp+4]		; sig# arg(1)
	call ersmsg
	lea eax,[esp+4]		; tor
	call sigpc
	jmp byes
; experimental, recovery from segfault :ok: (preliminary)
; 1:	1st occurrence re-vectors {quit} to <bsquitb>
;	and returns to <bquitb>, as default in {quit},
;	<bsquit> restores {quit} to <bquitb> executing.
; 2:	2nd occurrence immediately after 1st terminates,
;	which will be determined by {quit} vector address, which is 
;	<bsquitb> only after 2nd segfault immediately following 1st.
; doesn't catch all, but most segfaults which are due to false addressing, r>, etc.
rsegsigh:A
	push eax
rsegsig:A
	call getrefb	;>:KREF:
	lea eax,[esp+8]	; tor
	push ecx,edx
	mov ecx,'SF>'<<8|AC_BEL; ...to stderr
	call erustg
	call sigpc
	mov eax,[eax+8]	; arg(2)
	lea edx,[eax+19*4]; posn(19) -> pc at offending opr
	mov eax,[edx]	; pc
	lea ecx,[kref rsigb-Y]
	cmp eax,ecx
	jc .s
	lea ecx,[kref rsigt-Y]
	jc .b
.s:
	lea eax,[uref uv.uquit]
	lea ecx,[kref bquitb-Y]
	mov [edx],ecx	; ret to {quit}
	cmp ecx,[eax]
	lea ecx,[kref bsquitb-Y]
	mov [eax],ecx	; next quit entry, once only
.b:
	pop eax,ecx,edx
	jnz near rsigb.r
	ret
;-
;- sgt		( -- )				(k)(r)		'rsigt'		novoc
;-	messaging and rt-signals hnd, job continuing
rsigt:A
	call getrefb	;>:KREF:
	mov ecx,'SR>'<<8|AC_BEL; ...to stderr
	call erustg
	push eax
	mov eax,[esp+8]	; sig# arg(1)
	mov ecx,' s# '
	call ersmsg
	lea eax,[esp+8]	; tor
	call sigpc
	pop eax
	call dumpregs
	call ppid
	call sigtmsg
	jmp puvari
%ifdef quit_sig; ziemlich witzlos...
;-
;- <quits>
;-	sigquit, restart by <CTR"\"> key	- n.i., endless loop, either variant.. -
quits:A;:ok:
	call getrefb	;>:KREF:
	lea eax,[esp+4]
	call sigpc
	mov ecx,[byte uref uv.s0]
	mov edx,[byte uref uv.r0]
	lea PS,[kref ecx]
	lea RS,[kref ecx]
	push dword byes-Y
	add [esp],KR
;;	call empty;segfaults...
	jmp byes
;;	mov eax,[esp+12]; arg(2)
;;	mov dword[eax+19*4],squit-Y;cabort; posn(19) -> pc
;;	add dword[eax+19*4],KR
;;	ret
;;squit:A
;;	call empty
;;	jmp bye;;s
%endif
;-
;- <rfpesig>
;-	recovery from division-'fault'
;	division opcode should be in a separate subroutine such,
;	that eax/edx immediately after div are final ret-values
rfpesig:A;<1st from rsigb);div0
	pushad
	call getrefb	;>:KREF:
	lea eax,[esp s_tor+4]; tor
	mov eax,[eax+8]	; arg(2)
	lea edx,[eax+19*4]; posn(19) -> pc at offending opr
	mov eax,[edx]
	mov eax,[eax]
	readad ecx,ebx
	cmp ebx,ecx
	jnz .s		;?; supplied handler
	lea ecx,[kref fpecx-Y]; div error hnd, div by @ecx
	cmp ah,0xf1	; div
	jz .s		;?; ecx
	cmp ah,0xf9	; idiv
	jnz .b		;?; cannot recover
	lea ecx,[kref fpecxi-Y]; hnd idiv by @ecx
.s:
	mov [edx],ecx	; sto handler
	popad
	ret
.b:A
	popad
	jmp rsigb	; terminate after messages
;
; common fpe signal hnd - re mby.x for "/", "m/", "sm/mod" hnd-s
fpecx:A; unsigned div 0, div ovf
	cmp ecx,1
	jz rpureg	;?; ovf from div 1
	jc rzreg	;?; div 0
	push eax	; dvd.hi
	mov eax,edx	; dvd.hi
	xor edx,edx
	div ecx
	pop eax		; dvd.lo
	div ecx		; leave rmd
	ret
fpecxi:A; signed idiv 0, idiv ovf ; ret [PS]:=q.hi, eax:=q.lo edx:=rmd ecx:=dvd
	cmp ecx,-1
	jz rmureg	;?; ovf from div -1
	jl .d		;?; other -ve
	cmp ecx,1
	jz rpureg	;?; ovf from div 1
	jl rzreg	;?; div0
.d:
	push eax	; dvd.hi
	mov eax,edx	; dvd.hi
	xor edx,edx
	idiv ecx
	mov [PS],eax	; save q,hi
	pop eax		; dvd.lo
	idiv ecx	; leave rmd
	ret
ruureg:A
	inc edx
	jz rpureg
	dec edx
	jz rpureg.r
	neg edx
	mov eax,edx
rmureg:
	neg eax
rpureg:
	mov edx,0
.r:
	ret
rzreg:A
	or eax,edx
	jz .e		;?; 0/0
	sar edx,31
	not edx		; +ve:-1 -ve:0
	lea eax,[edx*2+0x80000001];q: +/- max
	mov edx,eax
	ret
.e:A
	inc eax
	ret
; SIGWINCH handler, updates main console window sizes for {max-xy}
rsegwinch:A;:ok:
	call getrefb	;>:KREF:
	call winsz
	mov edx,[byte uref uv.sigh]
	lea edx,[kref edx+sa_winch.w-sighndblk]; ptr to sizes
	mov [edx],ecx
	ret
winsz:A;<max-xy) c: ecx := x|y
	push KR
	call getstdin
	mov ebx,[byte kref ecx+cdt.chid]
	lea edx,[PS+4]
	mov ecx,TIOCGWINSZ
	sys_ioctl	; get window sizes
	xor ecx,ecx
	sar eax,31
	pop KR
	js .s
	mov ecx,[PS+4]
.r:
	ret
.s:A
	call maxlw.f	; dft for file i/o width from kernel vari, height:=0
	TOSPULL(1)
	jr .r
;-
;- <rsegalarm>	( -- )				(k)		'rsegalrm'	novoc
;-	saves all regs and executes deferred {(alarm)} by redirected 
;-	SIGALRM handler, dft { .rs [s] }.
;-	stack-ptr unsafe:
;-		e.g, though all regs saved w/ <pushad/popad> instr
;-		{words} drops one cell, while {vlist} is ok... -?-
rsegalrm:A;:ok: - data-stack is unsafe!
	call getrefb	;>:KREF:
	pushad
;;	spop 3;
	call palarmp	; deferred (alarm)
	popad
	ret
;-
;-=====================================================================;
;- l4sighnd.inc <eof>
