;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-=====================================================================;
;-  file  	: l4sys.inc
;-  created	: 04-aug-01
;-  modified	: -> re "version.inc"
;-  version	: 0.01(+)
;-  switches	: __SYS_I
;-  assembler	: nasm 0.98-3e (patched & bugs fixed 0.98)
;-  description	: basic system access, cpu control
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  source	: (me, hp)
;-  requires	: the "lib4th" package
;-=====================================================================;
;-
;-	

%ifndef __SYS_I
%define __SYS_I
%define sysinc

;-
;- allocf	(bytes oldtop -- newtop|ernum )	(k)
;-	page align and allocate memory in .bss/RAM
allocf:GA
	mov ecx,eax	; pass membot
	spop		; fetch memsize
	jr allocbss
;-
;- allocjob	( -- newtop|ernum )		(k)
;-	page align and allocate memory in .bss/RAM
allocjob:GA
	spush
	mov ecx,[uref uv.mtop]
	jr allocbss
;-	setup for a 'standard' job, after <stacksini> - new layout w. 0.0.61:
;- .ss		returnstack	top down,		64K
;-		datastack	bot.up,			64K
;-		tib		terminal input buf.	 4K
;-		user-vari	top down, variable size	64K
;- .bss		dataspace	bot.up, variable size
;-		codespace	bot. up			64K
allocini:GA;:ok:
; i:	eax	#bytes
; o:	eax	new .bss bot, ptr to heap-header
;	ecx	page+ aligned size
	mov ecx,ebx
	sys_brk 0	; current .bss top
	mov ebx,ecx
	call palignp	; adjust eax=mtop to next page bound
	mov ecx,eax	; pass .bss bottom
	mov eax,d_bssmem
;-
;- <allocbss>					(s)
;-	page align size and bounds, allocate memory in .bss/RAM
;-	syscalls brk & mprotect -re- man 2 brk, mprotect
allocbss:A;GA;:ok:
; i:	eax	bytes to allocate
;	ecx	current bottom
; o:	eax	new membot (old memtop)
;	ecx	size
;	other	reg's preserved
; - use same routine for <reloc> w. different ptr-s -
	call palignp	; page align memsize
.n:;		; eax=size, ecx=old-top=new-bot
	push ebx,eax,edx
	lea ebx,[ecx+eax]; requested top address
	mov ecx,eax	; save size
	sys_brk ebx	; .bss extend bot. up
	cmp eax,-4096
	ja .x		;?; error
;do for compile-space, only (dictionary) -?-
	sub eax,ecx
	sys_mprotect eax,ecx,PROT_READ|PROT_WRITE|PROT_EXEC
	cmp eax,-4096
	jna .h
;?;all other .bss memory just dataspace
	sys_mprotect ebx,ecx,PROT_READ|PROT_WRITE
	cmp eax,-4096
	jna .h
.x:
	pop ebx,ecx,edx
	ret
.h:
	mov eax,ebx
	pop ebx,ecx,edx	; eax=new memtop/ernum, saved ebx=<kref>, ecx=old memtop
;    jr heaphead	; clear and mark length/ownership
;:continues: in :heaphead:

;- <heaphead>						(k)
;-	clear memory block, store initial 'heap' structure
;-	len should be multiple of PAGE_SIZE,
;-	l.s. 2 bits: bit #1 is no-clear-flag if set
;-	[ len ][ handler ][ owner ][ flagptr ] at eax
;-	[ ecx ][ mmrechp ][  pid  ][    0    ] initial values
heaphead:A
; i:	eax	raw memory base address
;	ecx	allocation size
; o:	regs	all preserved
;:continues: from <stacksini>
	push ecx,edi,eax
	mov edi,eax
	shr ecx,2
	jc .c		; don't clear
	xor eax,eax
	rep stosd	; clear memory block
.c:
	sys_getpid
	mov ecx,eax
	pop edi,eax
	mov [eax+hphead.owner],ecx
	lea ecx,[kref hphnd-Y]
	mov [eax+hphead.drivr],ecx
	pop ecx
	and ecx,-4	; clr flagbits
	mov [eax+hphead.len],ecx
	ret
;-
;- <ustkini>
;-	initiate .ss range: stacks, tib, user-vari
;- <ustkini.n>
;-	i: eax := accumulated size
;-	o: eax := .ss bottom
;-	   ecx := page aligned size
ustkini:GA
	mov eax,d_ssmem
.n:
	push esi	; save reg
	call palignp	; size aligned up
	push eax	; save aligned size
	mov eax,esp	; .ss top
	call palignm	; align down, protect args & env
	mov ecx,eax	; .ss top
	sub eax,[esp]
	call palignm
	mov esi,esp	; save sp
	mov esp,eax	; .ss-space bottom
	pop eax		; r/w something...
	push eax
	mov eax,esp	; pass .ss-bot
	mov esp,esi	; rst sp
	pop esi,ecx	; rst reg and allocation size
	jr heaphead
;-
;-================================================================
;- -- hi-level accessible words
;-

;-
;-================================================================
;- -- kernel support, non-standard and f8 or system specific routines
;- -- register addressed primitives
;-
;-	any lo-level routines must save or set appropriately, rsp:
;-		ebx	kernel reference pointer
;-		edi	parameter stack
;-		esi	local dataspace base ptr
;-		ebp	user vari reference pointer
;-		esp	returnstack
;-	

;-
;- -- partially or uninitiated support routines,
;-	may be used but are not intended for hi-level access!
;-

;-
;- stty-s  	( c -- er ) 					'sttys'		linux
;-	set console channel c to known state - Linux "stty sane"
sttys:GA;:ok:<rsiocons)
	pushad
	call getrefb		;<:KREF:
	call chid		; eax:=fd ecx:=flags, edx:=chp
	js .r
	lea edx,[kref edx+cdt.iofl]
	push edx	;;;
	mov dword[edx],0
	mov byte[byte uref uv.aux+skey],0
	lea edx,[kref ttyst-Y]	; 'stty sane'
	mov ebx,eax
	sys_ioctl EMPTY,TCSETS
	pop edx		;;;
	test eax,eax
	jns .r
	and dword[edx],~(mcons|micon)	;;;
.r:
	writead eax,eax
	popad
	ret
;-
;- rstty  	( -- )								linux
;-	reset {work}-channel console to initial state,
;-	called once, with {bye} or when job/thread(?) killed
;-	<uref> expected valid.
rstty:GA;:ok:
; in: ecx = fd
	mov ecx,workch
.n:; ;<rscons)
	pushad
	spush
	mov eax,ecx
	call chid
	js .q
	mov dword[kref edx+cdt.chid-cdt],-1
	cmp byte[byte uref uv.aux+skey],0
	mov edx,[uref uv.ustattr]; initial, saved tty attributes
	js .c
	lea edx,[kref ttyst-Y]	; 'stty sane'
.c:
	mov ebx,eax
	sys_ioctl EMPTY,TCSETS
	sys_close
	mov byte[byte uref uv.aux+skey],0
.q:
	popad
.r:
return:	; default entry for ctrl codes uv.uctrl+
	ret
;-
;- otty		( -- )								linux
;-	open & init r/w channel to current console
;-	on succes store fs to stdin cdt, close previous stdin
;-	all regs preserved, ernum from open attempt in (ierr)
;-	NOTE:	open when input was file after program termination 
;-		leaves console in nowait and no-echo state -> why?
otty:GA;:ok::<key), <nky> at eof)
	pushad
	call inid			;a=fd c=flg d=chp
	lea ebx,[kref ttyt-Y]
	writead edx,edx			; save cdt
	push eax			; fd
	sys_open EMPTY,O_RDWR|O_NONBLOCK,S_IRWXU; open r/w, not waiting, user rwx perm-s
	pop ecx				; prev. fd
	writead ecx,eax			; ernum to saved ecx
	readad ebx,ebx			; kref
	readad edx,edx			; rst cdt
	mov [kref edx+cdt.chid-cdt],eax
	test eax,eax
	js .r				; exit on error
	or dword[kref edx+cdt.iofl-cdt],mcons|micon|mchrf
	mov ebx,ecx			; old fd
	mov ecx,eax			; new
	sys_close
	readad ebx,ebx
	call toutcons
	js .r
;	or dword[kref edx+cdt.iofl],(mchrf)
%if (mcons|micon) < 0
	cmp eax,eax			; prevent S flag
%endif
.r:
	popad
	js .q
	call .o
	pushad
	call inid
	add edx,KR;;;
	mov ebx,eax
	push edx
	sys_fcntl EMPTY,F_SETFL,O_RDONLY|O_NONBLOCK
	pop edx
	or dword[edx+cdt.iofl],(mcons|micon|mchrf)
	inc byte[byte uref uv.aux+skey]	; prepare -1 flag for rstty
	mov edx,[uref uv.utattr]
	jr setty.i
.o:A
	pushad
	call outid
	mov ebx,eax
	mov ecx,O_WRONLY|O_SYNC		; O_SYNC required if otput to pty device/X-terminal
	jr setty.o
.q:A
	mov [byte uref uv.ierr],ecx	; store ernum
	ret
;-
;- setty  	( -- )								linux
;-	prepare stdin to single key input,
;-	called once on init after intro,
;-	de-activated by byte @uv.aux =/= 0, set to -ve afterwd.
;-	can be executed to restoring tty state e.g, after a -re- {sh}ell command
;-	<uref> expected valid, but NO <kref>'d code
;-	all regs preserved
setty:GA;:ok:;<ini4th
	cmp byte[byte uref uv.aux+skey],0
	jz .s
	ret
.s:
	pushad
	call .f
	call outid
	mov [byte uref uv.outchp],edx
	push edx
	mov ebx,eax
	sys_fcntl EMPTY,F_SETFL,O_WRONLY|O_SYNC
	pop edx
	readad ebx,ebx
	and dword[kref edx+cdt.iofl],~(mchrf)
	call inid
	mov ebx,eax
	mov ecx,O_RDONLY|O_NONBLOCK
	mov [byte uref uv.inchp],edx
.o:;	;<otty)
	sys_fcntl EMPTY,F_SETFL,ecx				; to not suppress last portion of (fast) output when in X-terminal
.i:;	;<otty)
	mov edx,[uref uv.utattr]
	and dword[byte edx+termios.c_lflag],~(ICANON|ECHO)	; leave sig's enabled, disable erase/fill processing, echo
	or  dword[byte edx+termios.c_oflag],OPOST|ONLCR		; enable output processg, NL<-CR/NL
	and dword[byte edx+termios.c_iflag],~(INPCK|ISTRIP|IXON); disable parity chk, 8th bit strip,start/stop prot
	mov eax,[uref uv.uiovtim]
	mov byte[byte edx+termios.c_cc+VTIME],al; = qtermtimo	; timo * 1/10 s (if ~ICANON)
	mov byte[byte edx+termios.c_cc+VMIN],ah	; = qtermnum	; min no. of chars for a single read opr
	movzx eax,byte[byte edx+termios.c_cc+VEOF]		; fetch EOF character
	mov [uref uv.ueof],eax					; temporarily in uvari {(eof)}, until 1st i/o opr.
	sys_ioctl EMPTY,TCSETS					; set new tty mode
	dec byte[byte uref uv.aux+skey]				; -1 flag for rstty
	popad
	ret
.f:
	pushad
	call inid
	mov edx,[uref uv.uvpalette]
	add edx,KR
	sys_ioctl eax,GIO_CMAP
	mov edx,[uref uv.ustattr]
	sys_ioctl EMPTY,TCGETS					; saved until restore
	mov edx,[uref uv.utattr]
	sys_ioctl EMPTY,TCGETS					; will be modified
.r:
	popad
	ret
;-
;- fcntl  	( p op ch -- ernum )		(e)		'cfcntl'	linux
;-	fcntl system call
;-	p:=ptr to data structure, op:=fcntl operational flag, ch:=i/o channel
;-	(e: S on error)
cfcntl:GA C;:ok:
	call chid
	js .r
	pushad
	mov edx,eax		; save fd
	spop
	mov ecx,eax		; ioctl opr
	spop
	lea ecx,[kref eax]	; ptr's true address
	mov ebx,edx		; edx->ptr, ->ebx:=fd
	writead edi,edi		; pop from real stack (edi=PS)
	mov edx,eax
	sys_fcntl
	writead eax,eax		; ret ernum to tos
	test eax,eax
	popad
.r:
	ret
;-
;- ioctl  	( p op ch -- ernum )		(e)		'cioctl'	linux
;-	ioctl system call
;-	p ptr to data structure, op ioctl operational flag, ch i/o channel.
;-	NOTE:	console ioctls are not that useful, though they could, in a more 
;-		reasonable implementation. many of those nice features are simply 
;-		useless because the settings affect #all# consoles, globally...
;-	(e: S on error)
cioctl:GA;:ok:
	call chid
	js .r
	pushad
	mov edx,eax		; save fd
	spop
	mov ecx,eax		; ioctl opr
	spop
	lea ecx,[kref eax]	; ptr's true address
	mov ebx,edx		; edx->ptr, ->ebx:=fd
	writead edi,edi		; pop from real stack (edi=PS)
	mov edx,eax
	sys_ioctl
	writead eax,eax		; ret ernum to tos
	test eax,eax
	jns .r			;?; no error
	readad edx,edx		; cdt
	add edx,[esp s_ebx]	; cdt
	and dword[kref edx+cdt.iofl],~(mcons|micon); clr console flags, just in case...
	popad
.r:
	ret
;-
;- cstg		( n1 n2 -- p u )						linux
;-	index list# -- ptr count, u := 0 if n1,n2 out of range
;-	index 0..3 for terminal control:
;-		0:ctrls, 1:F-console, 2:F-xterm, 3:colours by [ ctrl stg <nul> ]
;-	{ 0 4 cstg } returns ptr & sum of length's of syscalls names
;-		by items of [ 16bit number | chars name <nul> ]
;-	{ 0 5 cstg } returns ptr & sum of length's of colour-strings
;-		asciz names in sequence of the rsp. numbers, for "sys".
;-	
;-	0 ctrl termcaps
;-		ho,le,nd,up,do,cl,cd,ce,bl,dc,dl,sf,sr,so,se,us,ue,md,
;-		mr,mb,me,blink off, reverse video off,xy,ris,sc,rc
;-	1 console termcaps
;-		k1,k2,k3,k4,k5,k6,k7,k8,k9,k0,kl,kr,ku,kd,kh,kH,kN,kP,kb,kD,kI
;-		F11..F20 is <\e[23~> ... <\e[34~> - \e[22~ apparently unused(?)
;-	2 xterm termcaps
;-		k1,k2,k3,k4,k5,k6,k7,k8,k9,k0,kl,kr,ku,kd,kh,kH,kN,kP,kb,kD,kI
;-	3 colours
;-		fg: black,red,green,brown,blue,magenta,cyan,white,underscore-on,-off
;-		bg: black,red,green,brown,blue,magenta,cyan,white,default,default
cstg:GA;:ok:
	lea edx,[kref cstrings-Y]
	cmp ax,[edx]		;n2 range
	jnc .o			;?; list# out of range
	lea ecx,[eax*2+edx+2]	;string#
	movsx edx,word[ecx]	;ptr to list indices
	mov eax,TOS(1)
	add ecx,edx		;list.enum
	cmp ax,[ecx]		;n1 range
	jnc .o			;?; stg# out of range
	lea ecx,[ecx+2*eax+2]	;ptr
	movsx edx,word[ecx]
	movsx eax,word[ecx+2]	;next
	add ecx,edx		;text
	sub eax,edx		;len
	inc eax
	sub ecx,KR
	mov TOS(1),ecx
	ret
.o:
	mov ecx,nulst-Y
	mov eax,0
	mov TOS(1),ecx
	ret
;-
;- (sys)  	( p u -- n | er )				'psysp'		linux
;-	fetch syscall-no. n by name(p,u)
;-	all linux 2.2 and 2.4. syscall names implemented.
psysp:GA;:ok:
	spush
	_mov eax,0
	spush
	_add eax,4
	call cstg
.s:
	call over2
	spush
	_mov eax,0
	call csearch
	test eax,eax
	jz .r		;?; name not found
	mov ecx,TOS(2)
	cmp byte[kref ecx-3],0
	jnz .n		;?; try next
	movzx eax,word[kref ecx-2];syscall no.
.r:
	TOSPULL(4)
	ret
.n:
	inc ecx
	spop		; drop flag
	dec eax
	mov TOS(1),ecx
	jg .s		;?; more text left
	_mov eax,0
	TOSPULL(3)
	ret
;
bsysb.c:A
	call literal
	TICK scall
	jmp compilec
;-
;- sys		ccc( p -- er )			(i)				linux
;-	xec/cpl literal syscall by name ccc -re- {syscall}, {(sys)}, {[sys]}
;-	rejects <sys mprotect> - re {mprotect}.
;-	example:{ pad 0x200 2dup erase over 4th>abs sp@ sys uname 3drop dump }
;-	NOTE:	{ 0 1 sp@ 4th>abs 0 swap sp@ sys nanosleep } kernel 2.2.19 requires 
;-		different ptrs for nanosleep, which might apply to more syscalls.
sys:GA;:ok:
	call BLWORD	; fetch syscall name - :continues: in <bsysb>
	call count
;-
;- [sys]  	( p a -- p er )			(i)		'bsysb'		linux
;-	execute syscall by name at <a> with register values at addr. <p>
;-	rejects <sys mprotect> - re {mprotect}.
;-	example: { 0 1 sp@ 4th>abs dup sp@ s" nanosleep" [sys] }
bsysb:GA;:ok:
	call psysp
	call ccplq
	jnz .c		;?; cpl - interp :continues: in <scall>
;-
;- syscall	( p n -- p er )			(mc)		'scall'		linux
;-	executes OS specific system call n, returns value/error code in er,
;-	syscall parameters from table at p, p pointing to top item in list:
;-		lo:[ ebp, edi, esi, edx, ecx, ebx ]:hi addr
;-	<ebx> corresponds to 1st arg in the rsp man(2)-pages description.
;-	sequence of pushed to return-stack arguments is in same order as "C" 
;-	functions parameter lists  but, wrt a structure in memory or, the L4 
;-	data-stack which grows towards higher addresses, the arguments should
;-	 be passed in reversed order, i,e. "right to left". -re- {sys}.
;-	
;-	NOTE:	addresses expected by true values, as after {4th>abs}.
;-		{syscall} rejects call to <SYS_mprotect> - re {mprotect}.
;-	
;-	example f8-forth access, all arguments but eax and sp@ are optional, 
;-	dependent on the rsp. system call:
;-		( edi esi edx ecx ebx sp@ eax -- edi esi edx ecx ebx eax2 )
;-	where eax2 is result, replacing the passed syscall number from eax on entry.
;-	for instance, reading a directory entry (file open, channel in work-id):
;-		{ 0x100 pad 4th>abs work-id sp@ #141 syscall }
;-	Further reading:
;-		Linux system calls libc access documentation in <man> section 2,
;-		numbers vs names, asmutils <os_linux.inc>, <linux/include/unistd.h>.
;-		http://home.snafu.de/phpr/lhpsycal.html (syscalls doc, en)
scall:GA C;:ok:;<- {sleep}
	cmp eax,SYS_mprotect
	push_ibyte(EACCES)
	jz near .r
	push ebp,edi,esi,ebx
	mov edi,TOS(1)	; ptr to args list bottom
	lea edi,[kref edi]
	mov ebx,[edi]
	mov ecx,[edi-4]
	mov edx,[edi-8]
	mov esi,[edi-12]
	mov ebp,[edi-20];if __KERNEL__ >= 24
	mov edi,[edi-16]
	sys_generic	; syscall no. eax=@tos -> eax := ernum/return value
	pop ebp,edi,esi,ebx
	mov [esp],eax
.r:
	pop eax
C scall
	ret
;-
;- argstg 	( u1 -- p u2 )							linux
;-	get program's passed asciz argument strings p,u2 by number u1.
;-	cnt begins at 1, 0 for program name. ovf & -ve returns <zero>
argstg:GA;:ok:
	mov ecx,eax
	xor eax,eax
	cmp ecx,[uref uv.uargc]
	ja .n
	mov eax,[uref uv.uargp]
	lea eax,[kref eax]
	mov eax,[eax+4*ecx]
.n:
	sub eax,KR
	jmp zcount
;-
;- envstg  	( u1 -- p u2 )							linux
;-	get ptr to program's asciz environment strings by number u
;-	cnt begins at 1, 0 and overflow return empty stg.
;-	program name is asciz string at { (argp) @ @ abs>4th }.
;-	display all env strings:
;-	{ -1 1 rshift 1  do i envstg dup if type cr else 2drop leave endif loop }
envstg:GA;:ok:<gtenv)
	test eax,eax
	jz .n		;?; 0 is empty string
	push edi
	mov ecx,eax
	mov edi,[uref uv.uargc]
	xor eax,eax
	lea edi,[kref edi*4+8]
	add edi,[uref uv.uargp]
	repnz scasd
	jz .p		;?; ovf
	mov eax,[edi-4]
.p:
	pop edi
.n:
	sub eax,KR
	jmp zcount
;-
;- path		( -- p u )					'epath'		forth
;-	ret ptr to string of PATH environmental variable.
;-	alternatively, fetch <nul>-terminated stg from @(path) if non-zero.
epath:GA
	spush
	mov ecx,patht-Y
	mov eax,[uref uv.upath]
	test eax,eax
	jnz near zcount
	jr eterm.p
;-
;- --env-ini	( -- )								system
;- f8ini   	( -- )								system
;-	evaluate F8INI environment variable. active word in {system} wordlist!
f8ini:GA
	lea ecx,[kref evaluate-Y]
	push ecx
ef8ini:
	mov ecx,f8init-Y
	jr eterm.n
;
ehome:A
	mov ecx,homet-Y
	jr eterm.n
;-
;- term		( -- p u )					'eterm'		linux
;-	ret terminal type from TERM env-vari
eterm:GA
	mov ecx,termt-Y
.n:
	spush
.p:
	lea eax,[ecx+1]
	spush
	movzx eax,byte[kref ecx]
;-
;- getenv  	( p1 u1 -- p2 u2 | p1 0 )	(4)		'gtenv'		linux
;-	get ptr p2 and cnt u2 to program's environment strings by name at p1,u1
;-	p2,u2 ptr to empty stg & u2 := 0 if env-vari name not found.
;-	searching case-in/dependently, as set w. {lc-depend} or {lc-ignore}.
gtenv:GA;:ok:
	push PS		; tos
	push eax	; u1
	call placeps	; p1,u1 -> asciz
	pop ecx		; u1
	mov word[eax+ecx],0+'=';	{ a1' .ccc.	[ PS
	sub eax,KR	;		{ p1'
	spush
	lea eax,[ecx+1]	;		{ u1' p1' .c.
	push_ibyte(0)	; 0 >r				[ n PS
.begin:
	inc dword[esp]
	spush
	mov eax,[esp]	; r> 1+ dup >r	{ n u1' p1' .c.	[ n+ PS
	call envstg	; ue pe		{ ue pe u1' p1' .c.
	test eax,eax
	jz .n		;?; end of env stg-s
	cmp eax,TOS(2)
	jc .u		;?; env is shorter
	call dup4	;		{ ue pe u1' p1' ue pe u1' p1'...
	mov eax,TOS(2)	; ue':= u1'	{ u1' pe u1' p1' ue pe u1' p1'...
	call compare	;		{ fl ue pe u1' p1'...
	test eax,eax	; 0=
	spop		; save ue
	mov ecx,eax	; ue
	mov edx,TOS(1)	; pe
.u:
	spop 2		;		{ u1' p1' .cc.
	jnz .begin	; until
	lea edx,[edx+eax]; cut name and '=' off string
	xchg eax,ecx
.r:
	lea esp,[esp+4]
	pop PS		; u1 p1
	sub eax,ecx	; ue
	mov TOS(1),edx	; pe		{ ue pe
	ret
.n:
	mov ecx,eax
	mov edx,TOS(1)
	jr .r
;-
;- .cpu		( -- )						'dotcpu'	forth
;-	display actual host system cpu type
dotcpu:GA;:ok:
	spush
	mov eax,0+'XL'
	call emit
	spush
	xor eax,eax
	inc eax
	call cpuidf
	spop 3
	and ah,15
	movzx eax,ah
	or eax,0+'086'
	jmp emit
;-
;-
;-================================================================
;- -- execution
;-

; reset in- and out-console to a state, linux "stty sane"
; c: ecx
rsiocons:A;:ok:
	spush
	mov eax,stdin
	call sttys	; eax=channel, reset linux console to defaults
.n:
	mov eax,stdout
	call sttys
.r:
	spop
	ret
;
rscons:A
	call getrefb	;<:KREF:;(eflags preserved)
	push ecx
	call siocons
	push dword[byte uref uv.aux+skey]
	call rsiocons	; (ecx:=out-cdt)
	call rstty.n	; (ecx=fd and valid uref expected)
;; "restores" to Linux #KERNEL# settings!
;; NO means to (orderly) reading the #actual# console data
;;	call rstpalette
	pop ecx
	test cl,cl
	pop ecx
	ret
;-
;- bye		( -- )				(s)(w)				root
;-	exit program, exitcode 0
;-	syscalls exit, getgid, kill, write -re- man 2 ...
bye:GA;:ok:
	push_ibyte(0)	; exit-code
.e:
	call rscons
	jns .s		;?; don't write to script output
	lea ecx,[kref tbye-Y]
.w:; <ihelp)
	call writezo
.s:
; :HIER: mandrake-7.1. kills caller also, no orderly sys-exit return! :HERE:
%ifndef __MDK
	call hupjobs
%endif
	pop ebx		; pass exit-code
	sys_exit	; and self
;
hupjobs:
	sys_getgid	; process group
	mov ebx,eax
	mov ecx,SIGHUP
	neg ebx
	sys_kill	; remove tasks but not caller
	ret
;-
;- bye-r  	( n -- ) 			(s)		'byer'		linux
;-	display pid & message if n<0
;-	terminate and pass exitcode |n| to caller.
;-	syscalls -re- {bye}
byer:GA;:ok:
	call getrefb	;<:KREF:;(eflags preserved)
	test eax,eax
	jns .s
	call ppid
	call terror
.s:
	push eax
.e:
	jr bye.e
;-
;- <byes>  	(R: x r -- )			
;-	exit by signal hnd invocation, ret signum
byes:A;GA;:ok:
	call getrefb	;<:KREF:;(eflags preserved)
	pop eax
	mov eax,[esp]	; leave sig-num for kill
	cmp eax,byte 11
	jz byer.s	;?; ret immediately, after segfault
	spush
	call ppid
.e:
	push eax	; exit-code
	neg eax
	call sigmsg
	jr byer.e
;-
;- <intro>					(k)(u)
;-	display startup message to STDERR
;-	do nothing if not stdin and stdout at console or, if any args pssed
;- o:	eax	:= 0x80000000
;-	eflags	Z: stdin is console, S stderr not writable
intro:GA;:ok:
	call getrefb	;<:KREF:;(eflags preserved)
	mov ecx,STDIN	; host system channel
	call toutcons
	js .r
	mov ecx,STDOUT
	call toutcons
	js .r
	cmp dword[uref uv.uargc],byte 0
	mov eax,0x80000000
	jz imessage	;?; no args and in is console?
.r:
	ret
;-
;- sigmsg  	( x -- x )			(s)(u)				linux
;-	display signal message to STDERR if -ve x in range
;-	syscall write -re- man 2 ...
sigmsg:GA;:ok:?
	call getrefb	;<:KREF:;(eflags preserved)
	test eax,eax
	jns intro.r
	call erdot
	neg eax
	cmp eax,[kref sm-Y]
	jbe .s
	mov eax,[kref sm-Y]
	inc eax
.s:
	lea ecx,[kref sr-Y]
	jr kmessage.c
;-
;- kerror  	( x -- )			(s)(k)(u)
;-	print message to STDERR if -ve x in range, else do nothing
;- o:	eflags	set accordingly
kerror:;A;:ok:;<; <nimp>, <terror>
	push ecx
	lea ecx,[kref drop-Y]
	_xchg dword[esp],ecx
;-
;- <terror>					(s)(u)
;-	exec <error> without referring to PS, uninitiated call
terror:GA;:ok:
	cmp eax,-4096
	ja kmessage
	ret
imessage:
	call curs
;-
;- kmessage	( x -- +x )			(s)(u)				hidden
;-	print to STDERR, message no. @tos, if -ve x in range
;-	flags & all regs but W, <ecx>, preserved, KR restored/set
;-	syscall write -re- man 2 ...
kmessage:GA;:ok:
; c: ecx
	call getrefb	;<:KREF:;(eflags preserved)
	lea ecx,[kref rn-Y]	; disp to base of disp table
	cmp eax,0x80000000
	jz .s
	call erdot
	test eax,eax
	jns .t
	neg eax
.t:
	cmp eax,dword[kref rm-Y]; upper bound of errno-s
	jna .c 		; within range
	mov eax,[kref rm-Y]
.c:
	test ecx,ecx	; force NZ
.s:
	pushfd		; flags
	pushad
	movsx eax,word[byte ecx+eax*2-2]
	lea ecx,[eax+ecx+3]	; advance past count.w & leading <nl>
	movzx edx,byte[ecx-3]
	dec edx		; adjust & check length, leave trailing <nl>
	jng .p		;?; zero or -ve length (which shouldn't happen)
	sys_write STDERR
	test eax,eax
.p:
	popad
	popfd
.r:
	ret
;-
;-----------------------------------------------------------------
;-	

;-
;- push4th	( -- )(R: -- LP UR SP KR )					system
;-	save (true) cpu regs used by kernel: KR (ebx), LP(esi), SP(edi), UR(ebp).
;-	supposed to preserving L4 state e.g, for usage w/ external libraries.
push4th:GA;:ok:
	mov ecx,[esp]
	mov [esp],esi	;LP
	push ebp	;UR
	push edi	;SP
	push ebx	;KR
	push ecx	; ret
	ret
;-
;- pop4th 	( -- )(R: LP UR SP KR -- )					system
;-	restore cpu regs which were saved to returnstack -re- {push4th}
pop4th:GA;:ok:
	pop ecx		; ret
	pop ebx		;KR
	pop edi		;SP
	pop ebp		;UR
	mov esi,[esp]	;LP
	mov [esp],ecx
	ret
;-
;- cpuid  	( n -- na nb nc nd )				'cpuidf'	system
;-	clear/sync cpu state.
;-	fetch level(n) register values eax..edx of <cpuid> instruction.
cpuidf:GA;:ok:
	push ebx
	cpuid
	spush
	mov eax,ebx
	pop ebx
	spush
	mov eax,ecx
	spush
	mov eax,edx
	ret
;-
;- emms		( -- )				(m,2)		'emmsf'		forth
;-	clear mmx cpu registers
emmsf:GA M;:ok:
	emms
M emmsf
	ret
;-
;- femms  	( -- )				(m,2)		'femmsf'	non-mmx
;-	clear floating point cpu registers
femmsf:GA M;:ok:
	femms
M femmsf
	ret
%endif;__SYS_I
;-
;-=====================================================================;
;- l4sys.inc <eof>
