;[list]
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-
;-  file  	: l4text.inc
;-  created	: 10-jul-01
;-  modified	: -> re "version.inc"
;-  version	: 0.01(+)
;-  switches	: __L4TI
;-		: for proper alignment: -D__OPTIMIZE__=__O_SPEED__
;-  assembler	: nasm 0.98-3e (patched & bugs fixed 0.98)
;-  description	: part of "lib4th", text & fixed data entries
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  source	: (me)
;-  requires	: lib4th.asm
;-=====================================================================;
;-
;-
%ifndef __L4TI
%define __L4TI
%define l4tiinc
;-	
;- -- constant data (which should not be modified)
;-
;[nolist]
	align 4
	ertstg	; error messages & symbols frm "errno.inc"
;[nolist]
	align 4
	ertdsp
;[list]
nbase:A
	db 1,2,0,4,0,0,0,8,0,10,0,12,0,0,0,16,8,-2,0
npref:A
.a:
	db '"%.!...&.#....$@\',0
.e:
	a
ttyt:N; standard i/o console, available in all jobs, by Linux/POSIX definition
.a:
	db '/dev/tty'
.e:
nulst:N; empty stg, counted as well as asciz
	db 0,0
	a
vovt:N
	db .e-$-1
	db "<Overflow>"
.e:	db 0
	a
eulert:N	; rational voc, euler(v)
	dd 1,5,61,1385,50521,2702765,199360981; next: 19391512145. -> 4,2211642961
bernullit:N	; rational voc, bernulli(v)
	dd 1,6, 1,30, 1,42, 1,30
	dd 5,66,691,2730,7,6,3617,510
	dd 43867,798,147611,330,854513,138
vs:N
	db __PROG
.e:
	db '-',.vers,0
ht:A
	db DATE,' ',__LIB,' Forth Kernel Library'
nl:N
	db 10,0
; dft commandline prompt, counted stg-s
; interpreting state prompt stg immediately before compiling state prompt stg!
toki:A
	db 1,'>'	; interpreting
	db 1,'='	; compiling
tbye:A
	db LF,'<f8',LF,0
f8ht:A
	db "hp'",DATE,', ',__LIB,' '
	db '{args} ... ',LF
	db TAB,'args: {command|number|word}...',LF
	db TAB,'<f8 forth words> for wordlist',LF
	db TAB,'running: help forthword',LF,0
	a
tijobn:N
	db '"F8in"',0
;-
;- <occ4th>	list of initial output cc4th actions			'locc4thg'
locc4thg:A
;-
;- <icc4th>	list of initial input cc4th actions			'licc4thg'
licc4thg:A;:ok:
	dd del-Y,0,0,0,0,0,0,bel-Y	;00..07	: ..<bel>
	dd bs-Y,0,0,0,clsc-Y,0,0,0	;08..0f	: <bs>
	dd 0,0,0,0,0,0,0,0		;10..17	:
	dd 0,0,0,0,0,0,home-Y,crgt-Y	;18..1f	: ^^,<_
;
; locals:	;lv	la:	lv>	lv:	lv@
loclt:A
	dw (loclt.e-loclt)/2-2
	dw Idolocr,Idoloca,Idolocc,Idoloci,Idolocv,Idolocz
.e:
; see: branch
brancht:A
	dw (brancht.e-brancht)/2-2
	dw Ibranch,Igtbra,Iplbra,Ilebra
	dw Imibra,Izbra,Izdupbra,Inzbra
	dw Inzdb,Ineqbra,Iploopp,Ipploopp
.e:
textt:A; text
	dw (textt.e-textt)/2-2
	dw Ipdotqtep,Ipqtep,Ipsqtep
	dw Ipqtep,Ipsqtep
.e:
regt:A;	0    1	 2   3	 4   5	 6    7
	dd 'eax-ecx-edx- KR- RS- UR- PS-edi-'
;	dd ' eax ecx edx ebx esp ebp esi edi'
;-
;- -- user modifiable text:
;-
;-  msgt
;-	internal message table, cnt begins at 196 for msg#0
;-	message: ptr < 0 os-msg., = 0 by num, > 0 f6-text
msgt:A
 dw nimpad-msgt,mptyad-msgt	; 0
 dw ENOMEM,adrsad-msgt		; 2.om
 dw xistad-msgt,hovfad-msgt	; 4-5
 dw EPROTO,sovfad-msgt		; 6 xt (prot.err)
 dw EBUSY,colder-msgt,locerr-msgt;8-10
 dw 0,EINVAL,0,0		;11-14 12:bad arg
 dw dcpuad-msgt,versad-msgt	;15
 dw compad-msgt,execad-msgt	;17
 dw nfndad-msgt,nfinad-msgt	;19
 dw fncdad-msgt,loadad-msgt	;21
 dw edisad-msgt,vocsad-msgt	;23
 dw ldecad-msgt,exvcad-msgt	;25
 dw trapad-msgt,nparad-msgt	;27
 dw 0,abtqnm-msgt		;29
 dw idnonm-msgt,msgnm-msgt	;31
.m:
 dd (msgt.m-msgt)/2-1; top message no.
; -1.nc -2.nj -3.om -4.or -5.bo -6.no -7.nf -8.ex -9.iu -10.ef -11.df -12.bn
; -13.te -14.ff(formt) -15.bp -16.fe(medium) -17.xp -18.ov -19.ni -20.ro
nimpad:wstring "not implemented"		; 0 <rni>
mptyad:wstring "empty stack"			; 1
; datsad:wstring "out of dictionary space"	; 2 <r.om>
adrsad:wstring "addressing mode"		; 3 <ram>, <r.am>
xistad:wstring "already exists"			; 4
hovfad:wstring "digit storage ovf"		; 5
; 7:'protocol error'
sovfad:wstring "stack overflow"			; 7
; 8:device busy
colder:wstring "fatal error - don't retry!"	; 9
locerr:wstring "too many locals"		;10
dcpuad:wstring "36818358"			;15
versad:wstring {.vers,'-',__FMODE__," ",__PROG," (C) .hpr ",DATE};16
compad:wstring "compilation only"		;17 <rco>
execad:wstring "executing only"			;18 <rxo>
nfndad:wstring "not found"			;19 <p.nf>
nfinad:wstring "definition not finished"	;20 <rdn>
fncdad:wstring "protected dictionary"		;21 <rpd>
loadad:wstring "use only when loading"		;22
edisad:wstring "off working area"		;23 <r.oa>,<m.oa>
vocsad:wstring "?vocabulary"			;24
ldecad:wstring "LIST arg not decimal"		;25
exvcad:wstring "execution vector undef'd"	;26 <rud>
trapad:wstring "system address error"		;27 <r.sa>
nparad:wstring "conditionals not paired"	;28
abtqnm:wstring "Bytes free, Job# "		;30
idnonm:wstring "neither name nor number "	;31 <rno>
msgnm: wstring "msg #"				;32
; --------------------------------------------- ;
; fig-ed: ( ERROR MESSAGES   )
; MSG # 1 : EMPTY STACK
; MSG # 2 : DICTIONARY FULL
; MSG # 3 : HAS INCORRECT ADDRESS MODE
; MSG # 4 : ISN'T UNIQUE
; MSG # 5 : WORD CANNOT HAVE NULL NAME
; MSG # 6 : DISK RANGE ?
; MSG # 7 : FULL STACK
; MSG # 8 : DISC ERROR !
; MSG # 9 : UNRESOLVED FORWARD REFERENCE
; MSG # 10: IMPROPER CHARACTER DENOTATION
; MSG # 11: UNKNOWN
; MSG # 12: UNKNOWN
; MSG # 13: UNKNOWN
; MSG # 14: SAVE/RESTORE MUST RUN FROM FLOPPY
; -
; -
; MSG # 17: COMPILATION ONLY, USE IN DEFINITION
; MSG # 18: EXECUTION ONLY
; MSG # 19: CONDITIONALS NOT PAIRED
; MSG # 20: DEFINITION NOT FINISHED
; MSG # 21: IN PROTECTED DICTIONARY
; MSG # 22: USE ONLY WHEN LOADING
; MSG # 23: OFF CURRENT EDITING SCREEN
; MSG # 24: DECLARE VOCABULARY
; MSG # 25: LIST EXPECTS DECIMAL
; --------------------------------------------- ;
;-
;- erbits
;-	bit pattern corresponding to error numbers, 256 bits
erbits:N,64
	dd 00000000000000000000000000000000b,00000000000000000000000000000000b
	  ;   MNDRINNUSIAHHCTTSNINCCNNNAAAP  OSPNPMDNUSRILLLLLRBNOBDMPCSANRNN
	  ;   EOQESAOCTNLOOOIOHOSOOOEEEDDFF  PORORSEOSTELIIIIIEAOVAOURORDOEOO
	  ;   DMUMNVTLAPRSSNMOUTCBNNTTTDDNN  NCOPOGSTERSSBBBBBMDTEDTLOMMVLMPN
	  ;   IEOOAANELRETTNEMTCOUNNRUDRROO  OKTRTSTSRPTEEMSBACFURMDTTMN IOKE
	  ;   UDTTMIAAEOAUDRDADONFRAENONISS  TTOOOIAOSIAQXACACHDNFSOIO T NTGT
	  ;   MI E LMN GDNOEONONNSEBSRWONUU  SNNTTZDC PR EXNDCG ILGTH    KE
	  ;   TU I     RYRWFUYWN  SOEENTUPP  UOOOYEDK ET C      QO  O
	  ;   YM O     E ENUTRN   ERTA ASPP  PSSOP R             W  P
	  ;   P        S A S E    TT C VEOO  PUUPE R
	  ;   E        S C E F     E H A RR   PPT  E
	  ;              H D S     D   I TT   PP   Q
	  ;                            L      OO
	  ;                                   RR
	  ;                                   TT
	dd 00000000000000000000000000000000b,00000000000000000000000000000000b,0,0,0,0
	  ;NTNNBDBBNXBBLNULLLLCINWLNNNNDRDP  MRSNFTNMNIINNXEBNFANACBN2NIISNP
	  ;OIOOFEAAOFAA2ONN332HDOOOOOOAEAOI  LOPOBXOFFNSOODXUOACOGHAOBXONROE
	  ;SMDSOADDAUDDHCARRHNRRMUOTSLMANMP  IFISITTIIVDTDEISTUCMAIDEII TCER
	  ;REATNDSRNLRELSTNSLSNMSLPEYCEDG E  NSPPGBTLLAIDEVSYBLEEILFXGO RHNM
	  ;  TRTLLQOL  TICGTTYG GD MSKTLE    K EC SYEELRIV T LTSMND E     T
	  ;  A  OTC      H   N   B P  OK          Y     R    K      C
	  ;     C            C   L T  O
	  ;     K                O Y  L
	  ;                      C    O
	  ;                      K    N
	  ;                           G
;-
;- irbits, for input from stdin
;-	unset bits corresponding to error numbers, 256 bits
irbits:N,64
	dd 00000000000000000000000000000000b,00000000000000000000000000000000b
	  ;   MNDRINNUSIAHHCTTSNINCCNNNAAAP  OSPNPMDNUSRILLLLLRBNOBDMPCSANRNN
	  ;   EOQESAOCTNLOOOIOHOSOOOEEEDDFF  PORORSEOSTELIIIIIEAOVAOURORDOEOO
	  ;   DMUMNVTLAPRSSNMOUTCBNNTTTDDNN  NCOPOGSTERSSBBBBBMDTEDTLOMMVLMPN
	  ;   IEOOAANELRETTNEMTCOUNNRUDRROO  OKTRTSTSRPTEEMSBACFURMDTTMN IOKE
	  ;   UDTTMIAAEOAUDRDADONFRAENONISS  TTOOOIAOSIAQXACACHDNFSOIO T NTGT
	  ;   MI E LMN GDNOEONONNSEBSRWONUU  SNNTTZDC PR EXNDCG ILGTH    KE
	  ;   TU I     RYRWFUYWN  SOEENTUPP  UOOOYEDK ET C      QO  O
	  ;   YM O     E ENUTRN   ERTA ASPP  PSSOP R             W  P
	  ;   P        S A S E    TT C VEOO  PUUPE R
	  ;   E        S C E F     E H A RR   PPT  E
	  ;              H D S     D   I TT   PP   Q
	  ;                            L      OO
	  ;                                   RR
	  ;                                   TT
	dd 00000000000000000000000000000000b,00000000000000000000100000110001b,0,0,0,0
	  ;NTNNBDBBNXBBLNULLLLCINWLNNNNDRDP  MRSNFTNMNIINNXEBNFANACBN2NIISNP
	  ;OIOOFEAAOFAA2ONN332HDOOOOOOAEAOI  LOPOBXOFFNSOODXUOACOGHAOBXONROE
	  ;SMDSOADDAUDDHCARRHNRRMUOTSLMANMP  IFISITTIIVDTDEISTUCMAIDEII TCER
	  ;REATNDSRNLRELSTNSLSNMSLPEYCEDG E  NSPPGBTLLAIDEVSYBLEEILFXGO RHNM
	  ;  TRTLLQOL  TICGTTYG GD MSKTLE    K EC SYEELRIV T LTSMND E     T
	  ;  A  OTC      H   N   B P  OK          Y     R    K      C
	  ;     C            C   L T  O
	  ;     K                O Y  L
	  ;                      C    O
	  ;                      K    N
	  ;                           G
;-
;- text constants
	a
f8glst:N
	db .e-$-1
	db 'glossary',0
.e:
	a
docf8t:N
	db .e-$-1
	db __DOCDIR
.e:	db 0
	a
libf8dt:N
	db .e-$-1
	db __LIBF8D
	db ':',__LIBF8D,'/app'
	db ':~/.f8:~/f8:~/.f8/app:~/f8/app'
	db ':',__LIBDIR
.e:	db 0
	a
er:N
	db 'error ',0
	a
mhelpt:N
	db .e-$-1
	db 10,9,'-?-'
	db 10,9,'generate help text w/ <make doc> in source dir,'
	db 10,9,'copy file "./doc/glossary" to "',__DOCDIR,'"',10
.e:	db 0
dayt:A
	db 'Su',0,'Mo',0,'Tu',0,'We',0,'Th',0,'Fr',0,'Sa',0,0,0
.d:
	db 'So',0,'Mo',0,'Di',0,'Mi',0,'Do',0,'Fr',0,'Sa',0,0,0
.e:
	db 'Sun',0,'Mon',0,'Tue',0,'Wed',0,'Thu',0,'Fri',0,'Sat',0,0,0
;-
;- -------------------------------------------------------------------------------
;- -- standard charset, linux console, iso-8559-1
;-    character conversion tables 
;-	wrt founts/mappings and terminal capabilities
;-	re man 8 mapscrn, setfont; man 5 term, terminfo; man 4 console; etc.
;(table of :true::char::codes: 0..256, :do::not::edit:)
; 32      33 !    34 "    35 #    36 $    37 %    38 &    39 '    40 (    41 )    42 *    43 +    44 ,    45 -    46 .    47 /
; 48 0    49 1    50 2    51 3    52 4    53 5    54 6    55 7    56 8    57 9    58 :    59 ;    60 <    61 =    62 >    63 ?
; 64 @    65 A    66 B    67 C    68 D    69 E    70 F    71 G    72 H    73 I    74 J    75 K    76 L    77 M    78 N    79 O
; 80 P    81 Q    82 R    83 S    84 T    85 U    86 V    87 W    88 X    89 Y    90 Z    91 [    92 \    93 ]    94 ^    95 _
; 96 `    97 a    98 b    99 c   100 d   101 e   102 f   103 g   104 h   105 i   106 j   107 k   108 l   109 m   110 n   111 o
;112 p   113 q   114 r   115 s   116 t   117 u   118 v   119 w   120 x   121 y   122 z   123 {   124 |   125 }   126 ~   127 
;128    129    130    131    132    133    134    135    136    137    138    139    140    141    142    143 
;144    145    146    147    148    149    150    151    152    153    154    155    156    157    158    159 
;160    161    162    163    164    165    166    167    168 "   169 C   170    171    172    173 -   174 R   175 
;176    177    178    179    180    181    182    183    184 ,   185    186    187    188    189    190    191 
;192 A   193 A   194 A   195 A   196    197    198    199    200 E   201    202 E   203 E   204 I   205 I   206 I   207 I
;208    209    210 O   211 O   212 O   213 O   214    215 x   216    217 U   218 U   219 U   220    221 Y   222     223 
;224    225    226    227 a   228    229    230    231    232    233    234    235    236    237    238    239 
;240    241    242    243    244    245 o   246    247    248    249    250    251    252    253 y   254    255 
;- standard charset, linux console
tcharchar:N;ranges
; 1:1 substitute if no conversion table defined
; macro <dbplus 1st,last+1>
	dbplus   0, 32	; ctrls
	dbplus  32, 48	; bl, pnct
	dbplus  48, 58	; num
	dbplus  58, 65	; pnct, at
	dbplus  65, 91	;< upper alpha
	dbplus  91, 97	; braces
	dbplus  97,123	;< lower alpha
	dbplus 123,127	; braces
	dbplus 127,161	; del, undefined
	dbplus 161,192	; text descr, form
	dbplus 192,223	;< upper accented
	dbplus 223,224	; sz
	dbplus 224,255	;< lower accented
	dbplus 255,256	; y"
;-	dft for (lo2hi) user vari.
thichar:N;:ok:; lo>hi
	dbplus   0, 32	; ctrls
	dbplus  32, 48	; bl, pnct
	dbplus  48, 58	; num
	dbplus  58, 65	; pnct, at
	dbplus  65, 91	;< upper alpha
	dbplus  91, 97	; braces
	dbplus  65, 91	;< upper alpha
	dbplus 123,127	; braces
	dbplus 127,161	; del, undefined
	dbplus 161,192	; text descr, form
	dbplus 192,223	;< upper accented
	dbplus 223,224	; sz
	dbplus 192,223	;< upper accented
	dbplus 255,256	; y"
;-	dft for (hi2lo) user vari.
tlochar:N;:ok:; hi>lo
	dbplus   0, 32	; ctrls
	dbplus  32, 48	; bl, pnct
	dbplus  48, 58	; num
	dbplus  58, 65	; pnct, at
	dbplus  97,123	;< lower alpha
	dbplus  91, 97	; braces
	dbplus  97,123	;< lower alpha
	dbplus 123,127	; braces
	dbplus 127,161	; del, undefined
	dbplus 161,192	; text descr, form
	dbplus 224,255	;< lower accented
	dbplus 223,224	; sz
	dbplus 224,255	;< lower accented
	dbplus 255,256	; y"
; blanks
blkst:N
	times 256 db ' '
;-
etypet:N; for {e\stg}
 	db 'abcefinrtv'
.e:
.t:A; - dword provisional for multi(ple)-byte chars extension -
 	dd __a;	\a	<bel>
	dd __b;	\b	<bs>
	dd   0; \c	- w/o trailing <lf>
	dd __e;	\e	<esc>
	dd __f;	\f	<ff>
	dd AC_CSI; \i	<csi>
	dd __n;	\n	<new line>
	dd __r;	\r	<cr>
	dd __t;	\t	<ht>
	dd __v;	\v	<vt>
; for time&date:
days:A;16bit op's faster than 32bit
	dw 31,28,31,30,31,30,31,31,30,31,30,31,365
daysl:A
	dw 31,29,31,30,31,30,31,31,30,31,30,31,365
escpt:A; vt charset switching
	db 'AB0UKZRH'
efsymt:A; eflags symbols for {flg>smb}
	db 'C',0,'P',0,'A',0,'ZSTIDOppM',0,'RVaipd',0,0,0,0,0,0,0,0,0,0
stdoutpt:A
	db '/proc/self/fd/'
.e:	db '1',0
ptst:A
	db '/dev/pts/'
.e:
ttypt:A
	db '/dev/ttyp'
.e:
f8init:A
	db 5,'F8INI'
homet:A
	db 4,'HOME'
patht:A
	db 4,'PATH'
termt:A
	db 4,'TERM'
; for {sh}
sht:A
    db "/bin/sh",0
rg1:A
    db "sh",0
rg2:A
    db "-c",0

%endif
;-
;-================================================================
;- l4text.inc <eof>
