;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-=====================================================================;
;-  file  	: l4tools.inc
;-  created	: 14-jul-01
;-  modified	: -> re "version.inc"
;-  version	: 0.01(+)
;-  switches	: __TOOLS_I
;-  assembler	: nasm 0.98-3e (patched & bugs fixed 0.98)
;-  description	: "lib4th" shared library Forth kernel
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  source	: (me, hp)
;-  requires	: the "lib4th" package
;-=====================================================================;
;-
%ifndef __TOOLS_I
%define __TOOLS_I
%define toolsinc
;-
;-----------------------------------
;---  tools
;-	

; header for {.rs} and {.r}
pdots:A; in: depth, out: maxdepth(0..32)
	spush 2	; dup
	mov eax,'['<<8	; [char] [
	mov al,cl
	call emit	; emit
	call sdecdot	; s#.
	call zmax	; 0max	{ +depth
	call ulitb
	db AC_BS
	call emit	; bs
	call basef	; base
	call ulitb
	db ':'
	call emit	; .":"
	call decdot	; #.	
	call lit	;
	dd (('] ')<<8)|AC_BS; bs [char] ]
	call emit	; emit space
	test eax,eax	; dup
	jng near drop	; 0> if ..
	cmp eax,byte 32	; lit  32
	jna .m
	mov eax,32	;  min	{ mdepth
.m:
	test eax,eax
.r:
	ret
; set up local dataspace for number conversion in .s, .rs, dump
%assign tl_refd  10
;%assign tl_dotd  1024*2+tl_refd
%assign tl_hld0  0
%assign tl_hld   4
%assign tl_dp    8
%assign tl_lnum  12
tolnum:A
	call padsize
	shr eax,2	; cells
	add eax,byte tl_refd
	push eax
	push dword[byte uref uv.s0]
	call toloc
	pop ecx	; s0
	mov edx,[byte uref uv.hld0]
	mov [kref ecx+tl_hld0],edx
	mov edx,[byte uref uv.hld]
	mov [kref ecx+tl_hld],edx
	mov edx,dataptr
	mov [kref ecx+tl_dp],edx
	pop edx	; lnum
	mov [kref ecx+tl_lnum],edx
	add ecx,byte tl_refd
	mov dataptr,ecx
	ret
lnumto:A
	spush
	mov ecx,dataptr
	mov eax,[kref ecx-tl_refd+tl_lnum]
	neg eax
	mov edx,[kref ecx-tl_refd+tl_dp]
	mov dataptr,edx
	mov edx,[kref ecx-tl_refd+tl_hld]
	mov [byte uref uv.hld],edx
	mov edx,[kref ecx-tl_refd+tl_hld0]
	mov [byte uref uv.hld0],edx
	jmp toloc
;-
;- [rs]		( -- )				(i)(4)		'dotrsi'	tools
;-	immediate variant of -re- {.rs}, {cr} appended.
;-	(asm debugging: eflags, all reg. and stack contents preserved)
dotrsi:GA;:ok:
	call dotrs
	pushad
	pushfd
	call cr
	popfd
	popad
	ret
;-
;- .rs		( -- )				(4)		'dotrs'		tools
;-	display returnstack content, topmost item to the left, w. leading 
;-	"R[#depth:#base]"; signed if @base = decimal, else unsigned.
;-	(asm debugging: eflags, all reg. and stack contents preserved)
;-	stack display variants use local data-space for numeric conversion.
;-	NOTE: system exceptions can lead to local- and data-space corruption,
;-		which may partly be recovered by exchanging dp and s0 values.
dotrs:GA;:ok:
%assign rpqmin 20+3
	pushad
	pushfd		;(for dedugging)
	call tolnum
	call rpfetch	; r0 @ rp@
	sub eax,[byte uref uv.r0]
	not eax
	sub eax,byte rpqmin s_tor
	sar eax,2	; r-depth
	push eax
	mov cl,'R'
	call pdots
	jng .r		; 0> if
	neg eax
.l:A			;   begin
	spush		;    dup
	add eax,[esp]
	mov eax,[esp+eax*4+12 s_tor]
	sub eax,KR
	cmp dword[byte uref uv.base],byte 10; base@ 10 =/=
	jz .s		;  if
	call udot	;    u.
	inc eax		;    1+ dup
	js .l		;   0< 0= until
	jr .q		;  else
.s:A
	call dot	;    u.
	inc eax
	js .s
.q:
	spop
.r:			; endif endif
	pop eax
	call lnumto
	popfd		; rst eflags
	popad
	ret
;-
;- [s]		( -- )				(i)(4)		'dotsi'		tools
;-	immediate variant of -re- {.s}, for debugging, reg/eflags preserved.
;-	displaying state@, rp@, lp@, sp@, before stack content; <cr> terminated.
;-	(asm debugging: eflags, all reg. and stack contents preserved)
dotsi:GA;:ok:
	pushfd
	pushad
	spush 4
	call cr
	mov eax,[byte esp s_tor]
	call flg2smb
	call type
	call statef
	mov ecx,' s@:'
	call erumsg
	lea eax,[byte esp s_tor+4]
	sub eax,KR
	mov ecx,'rp@:'
	call erumsg
	mov ecx,'lp@:'
	mov eax,[byte uref uv.lp]
	call erumsg
	readad edi,edi
	lea eax,[PS-4]
	sub eax,KR
	mov ecx,'sp@:'
	call erumsg
	readad edi,edi
	readad eax,eax
	call dots
	call cr
	popad
	popfd
	ret
;-
;- .s		( -- )				(4)		'dots'		forth
;-	display datastack content, topmost item to the left, w/ leading 
;-	">D[#depth:#base]"; signed if @base = decimal, else unsigned.
;-	1st char, ">" if interpreting, "=" while compiling, by system prompt.
;-	(asm debugging: eflags, all reg. and stack contents preserved)
;-	stack display variants use local data-space for numeric conversion.
;-	NOTE:	system exceptions can lead to local- and data-space corruption,
;-		which may partly be recovered by exchanging dp and s0 values.
dots:GA;:ok:
	pushad		;(save regs & flags
	pushfd		;(for dedugging
	call depth	; depth
	call tolnum
	mov cl,'D'
	call pdots	; print header
	jng .r
	call zero	;  0	{ 0 md		[ b
	call pdop	;   DO	{ ...
	cmp dword[byte uref uv.base],byte 10; bas@ 10 =/=
	jz .d		;  IF
.l:A
	call i		;    i
	not eax
	mov eax,[PS+4*eax];pick
	call udot	;    u.
.n:
	call ploopp	;   LOOP
	dd .l-$
	    jr .r
.d:A
	call i		;   i
	not eax		;
	mov eax,[PS+4*eax];pick
	call dot	;   .
	call ploopp	;  LOOP
	dd .d-$
.r:			; ENDIF
	call lnumto
	popfd		; rst eflags
	popad
.x:; ;<rdump)
	ret
;-
;- adump  	( a u -- )							tools
;-	dump from true address
adump:GA;:ok:
	call swap
	call abs2fth
	call swap
	jr dumpa
;-
;- bdump   	( -- )								tools
;-	continue dump towards lower addr.
bdump:GA;:ok:
	mov ecx,[uref uv.urdumpc]
	shl ecx,1
	jg .s
	neg ecx
.s:
	sub [uref uv.urdumpm],ecx
;-
;- ndump   	( -- )								tools
;-	continue dump
ndump:GA;:ok:
	mov ecx,[uref uv.urdumpc]
	test ecx,ecx
	jg .a
	neg ecx
.a:
	add [uref uv.urdumpm],ecx
;-
;- rdump  	( -- )				(f6)				tools
;-	repeat previous {dump} or {adump} action
rdump:GA;:ok:
	mov ecx,[uref uv.urdumpc]
	test ecx,ecx
	jz dots.x
	spush
	mov eax,[uref uv.urdumpm]
	spush
	mov eax,ecx
	neg eax
;-
;- dumpa  	( p n -- )			(4)(f6)				tools
;-	dump no. n bytes of contents at ptr p
;-	display w. true addresses
;-	executes {dump} if cnt is -ve
dumpa:GA;:ok:
	neg eax
;-
;- dump		( p n -- )			(4)(f6)				forth
;-	dump no. n bytes of contents at ptr p
;-	<space> to halt, <esc> key to abort display,
;-	<any other key> after <space> continues.
;-	stores p & n for {rdump}, executes {dumpa} if cnt is -ve
;-	all {dump} variants use local data-space for numeric conversion.
;-	NOTE: system exceptions can lead to local- and data-space corruption,
;-	      which may partly be recovered, examining dp, lp and s0 values, 
;-	      w/ { dp lp !! } and { last @ lfa>idx >body 4+ dp ! }.
dump:GA;:ok:
	mov [uref uv.urdumpc],eax;	{ n a
	mov ecx,TOS(1)
	mov [uref uv.urdumpm],ecx
;-
;- tdump  	( p n -- )			(4)				tools
;-	memory dump w.o. args storage - re {dump}
tdump:GA;:ok:
	call tolnum
	add eax,byte 17
	spush		; dup		{ n n a
	sar eax,31	; <0		{ 0|-1 n a
	and eax,KR	; 0 swap IF 4th>abs ENDIF
	call mrot	; -rot		{ n a kr|0
	call cabs	; abs		{ +n a k
	call mdup	; -dup		{ (+n +n|+n) a k
	call zbra	; IF		{ +n a k
	dd .r-$		;		{ a aa
	push dword[byte uref uv.base];base@ >r
	call cr		;  cr
	call hex	;  hex
	call tor	;  >r		{ a k		[ n
	call dup2	;  2dup		{ a k a k
	call plus	;  +		{ ak a k
	call udot	;  u.		{ a k
	call rfrom	;  r>		{ n a k		[ -/-
	mov ecx,TOS(1)	; adjust address down to multiple of 16
	add ecx,TOS(2)	;     \
	mov edx,ecx	; a    \
	and ecx,byte -16;	\swap dup -16 and
	push ecx
	sub ecx,TOS(2)
	mov TOS(1),ecx	;	/swap over - rot +
	pop ecx		;      /
	xor ecx,edx	;     /
	lea eax,[eax+ecx+15]; add no. of truncated bytes to cnt
	and eax,byte -16; and align to next 16-bytes boundary
	spush
	mov eax,ecx	;  rmd for rev-on/-off
	call space	;  space
	spush
	mov eax,16	;  16
	spush
	xor eax,eax	;  0
	call pdop	;  (do)
.hdo:
	call i		;   i
	call dup2	;   2dup
	call equal	;   =
	spush
	mov dword TOS(1),3; 3 swap
	call zbra	;   IF
	dd .else-$
	call revon	;    rev-on
	call dotr	;    .r
	call revoff	;    rev-off
	jr .endif
.else:			;   ELSE
	call dotr	;    .r
.endif:			;   ENDIF
	call ploopp	;  (loop)
	dd .hdo-$	;
	call cr		;  cr
	xor eax,eax	;  drop 0
	call pdop	;  (do)
.odo:
	call i		;   i
	add eax,TOS(1); over +
	add eax,TOS(2); 2 pick +
	call udot	;   u.
	call space	;   space
	spush
	mov eax,16	;   16
	spush
	xor eax,eax	;   0
	call pdop	;   (do)
.ido:
	spush		;  dup
	call i		;    i
	call j		;    j
	call plus	;    +
	call plus	;    +
	movzx eax,byte[kref eax]; c@
	call zero	;    0
	call ltsharp	;    <#
	call sharp	;    #
	call sharp	;    #
	call bbl	;    bl
	call hold	;    hold
	call sharpgt	;    #>
	call type	;    type
	call escq	;    esc?
	spop
	jnz near cabort	;  if abort endif
	call ploopp	;   (loop)
	dd .ido-$	;
	call space	;   space
	spush
	mov eax,16	;   16
	spush
	xor eax,eax	;   0
	call pdop	;   (do)
.cdo:
	spush		;  dup
	call i		;    i
	call j		;    j
	add eax,TOS(1)	;  +
	add eax,TOS(2)	;  +
	TOSPULL(2)	;
	movzx eax,byte[kref eax]; c@ s->c
	call ekey2char	;  ekey>char
	call nzbra	;    0= IF
	dd .c-$
	mov eax,'.'	;     drop [char] .
.c:		;    ENDIF
	call emit	;    emit
	call ploopp	;   (loop)
	dd .cdo-$	;
	call cr		;   cr
	spush
	mov eax,16	;  16
	call pploopp
	dd .odo-$	;  (+loop)
	pop dword[byte uref uv.base]; r> base!
.r:		; ENDIF
	spop 2	; 2drop ;s
	jmp lnumto
; --- see, decompiling & disassembly utils --- 
;
; ret Z if opr by ix belongs to a local value
dcmloc:A
	lea ecx,[kref loclt-Y]
	jr dcmbra.n
; ret Z if opr by ix belongs to a string
dcmstg:A;-:ok:
	lea ecx,[kref textt-Y]
	jr dcmbra.n
; ret Z if opr is a branch
dcmbra:A;-:ok:
	lea ecx,[kref brancht-Y]
.n:
	push edi
	lea edi,[ecx+2]
	movzx ecx,word[ecx]
.l:
	cmp ax,[edi]
	jz .r
	dec ecx
	lea edi,[edi+2]
	jns .l
.r:
	pop edi
	ret
; <disword>	( p1 w1 -- p1 w1 | p2 ix )
;	find uot index ix of hi-level call or jmp, advance p1 by 4 to p2, next opr
;	ret eflags Z or, NS after jmp into other word
;	ret unchanged (p1,w1) and S if not found
disword:A;-:ok:
	mov ecx,eax
	xor edx,edx	; flag
	cmp ax,x_ucall	; $95ff : call [uref disp]
	jz .u
	cmp al,x_dcall	; $e8
	jz .c
	inc edx		; +ve: jmp
	cmp ax,x_ujmp	; $a5ff : jmp [uref disp]
	jz .u
	cmp al,x_djmp	; $e9
	jz .c
;	cmp ax,x_dalea	;8d83
;	jz .e		;?; lea eax,[kref disp]
	dec edx
.n:
	dec edx		; force S
.q:
	mov eax,ecx
	ret
.c:A;call/jmp pc-rel :ok:
	mov eax,TOS(1)	; p		{ p2 p2
	dec eax
	call dsp2xec
	call xec2idx
	js .q		;?; not a hi-level word
	dec dword TOS(1)
.r:
	add dword TOS(1),byte 4
	test edx,edx	; NS
	ret
.u:A;call/jmp udisp :ok:
	mov eax,TOS(1)	; drop 1- dup
	mov eax,[kref eax]
	call uds2idx	; @ uds>idx
	cmp eax,[byte uref uv.lkindex]
	jc .r		;?; valid
	jr .n		; ret S
; ' call'
prcall:A
	spush
	mov eax,'call'
	jr prvar.e
; ' jmp'
prjmp:A
	spush
	mov eax,'jmp'
	jr prvar.e
; display 'up('<dword>')'
pruvar:A
	spush
	mov eax,'@up+'
	jr prval.e
; display '@($'<dword>')'
prval:A;-:ok:
	spush
	mov eax,'@'
.e:
	call emit
; display '($'<dword>')'
prvar:
	spush
	mov eax,'('
	call hxldsp.e
	spush
	mov eax,')'<<8|AC_BS
.e:
	jmp emit
; display 'tos=$'<dword>
prtos:A
	spush
	mov eax,'tos='
	jr hxldsp.e
; display 'lit $'<dword>
hxldsp:A;-:ok:
	spush
	mov eax,'lit '
.e:
	call emit
; display '$' and sedec dword
hxdsp:;-:ok: ( n -- )
	spush
	mov eax,'$'
	call emit
	jmp hexdot
; display "<string>"
stgdsp:A;-:ok: ( p -- p+ )
	call ccount
	call dup2
	spush
	call .p
	call type
	add TOS(1),eax
.p:
	mov eax,'"'
	jr prpop.e
prpop:A;-:ok:
	spush
	mov eax,' pop'
.e:
	jmp emit
prpush:A;-:ok:
	spush
	mov eax,'push'
	jr prpop.e
prfetch:A
	spush
	mov eax,'@tos'
	jr prpop.e
pnopp:A
	spush
	mov eax,' nop'
	jr prpop.e
; ( p2 w -- p3 w | p2 w ) ret S if no useable code found
discode:A;::-?-::
	xor edx,edx
	cmp ax,x_dalea	;8d83
	jz near .e	;?; lea eax,[kref disp]
; local tests fall back to <.nl> or <.nt>
	cmp ax,x_eaxc
	jz near .la	;?; check for mov eax,LP
.nt:
	cmp ax,x_lread
	jz near .lr	;?; fetch local
	cmp ax,x_lstor
	jz near .lt	;?; {to} local
	cmp ax,x_lpsto
	jz near .li	;?; {+to} local
	cmp ax,x_lptr1
	jz near .lp	;?; {loc-ptr}
.nl:; back to here if not a ptr to local
	cmp ax,x_ipush	;0xb8ab
	jz .i		;?; lit $num    : <stosd\;mov eax,imed>
	cmp ax,(x_rread&65535);0x03.048b
	jz near .f	;?; @tos        : <mov eax,[kref eax]>
.cd:
	cmp ax,x_drmov	;0x838b
	jz near .d	;?; @(tos)      : <mov eax,[dword kref+disp]> - {integer}, {VALUE}
	cmp ax,x_ubread	;0x458b
	jz .b		;?; @(up+byte)  : <mov eax,[byte UR+disp]> - @uvari
	cmp ax,x_udread	;0x858b
	jz .u		;?; @(up+dword) : <mov eax,[UR+disp]> - @uvari
	cmp ax,(x_dread&65535);0x03.448b
	jz .m		;?; @(tos+disp) : <mov eax,[kref eax+disp]>
	cmp ax,(x_spush<<1)|x_spush
	jz near .q	;?; spush 2
	cmp ax,word[kref .d-Y]
	jz near .s	;8D7F FC8B07 ; spop :
	cmp al,x_djmp	; $e9
	jz near .j	;?; jmp disp
	cmp al,x_dcall	; $e8
	jz near .c	;?; call disp
	mov ah,0xf0
	and ah,al
	cmp ah,0x50
	jz near .g	;?; push/pop reg
	cmp al,x_nop
	jz .n		;?; alignment
	cmp al,x_spush	;0xab
	jz .p		;?; <stosd>, push @tos, {DUP}
.r:
	dec edx		; NZ, S
	ret
.n:
	call pnopp
	jr .y
.i:; 'lit $<num>'
	spop
	call fetchp	; u p+
	call hxldsp	; lit $<num>
.x:
	spush		; p+ p+
.y:
	xor edx,edx	; Z, NS
	ret
.u:;x_udread w	<mov eax,[UR+disp]>, fetch uvari at dword-sized disp
	spop
	call fetchp
.v:
	call pruvar
	jr .x
.b:;x_ubread w	<mov eax,[byte UR+disp]>, fetch uvari at byte-sized disp
	spop
	call cfetchp
	jr .v
.m:;x_dread 3b	<mov eax,[kref eax+disp]>, fetch from kref'd memory w. dword disp
	mov ecx,TOS(1)
	cmp byte[kref ecx],x_rread>>16
	jnz near .cd
	spop
	inc eax
	call fetchp
	call prfetch	; '@tos'
	call prvar	; @(num)
	jr .x
.d:;x_drmov  w	<mov eax,[dword kref+disp]> fetch from dataspace - {integer}, {VALUE}
	spop
	call fetchp
	call prval
	jr .x
; lo-level disassembly: fetch/store/push/pop
.q:; 'push push'
	call .o
	call space
	jr .o
.p:; 'push'
	dec dword TOS(1)
.o:
	call prpush
.z:
	xor edx,edx
	ret
.f:A; '@tos'
	mov ecx,TOS(1)
	cmp byte[kref ecx],x_rread>>16
	jnz near .cd
	inc dword TOS(1)
	call prfetch
	jr .z
.s:A;-:ok:-8D7FFC 8B07 ; spop
	mov eax,TOS(1)
	mov eax,[kref eax]; xx078bnn
	mov ecx,eax	; disp
	xor eax,dword[kref .d-Y+2]; last bytes of <spop>
	xor al,al
	shl eax,8
	jnz near .r
	movsx eax,cl	; disp
	neg eax
	sar eax,2	; cells
	spush
	call prpop
	call hexdot
	add dword TOS(1),byte 3
	jr .z
.g:A;-:ok: push/pop reg
	dec dword TOS(1)
	spush
	movzx eax,al
	shl al,5
	lea ecx,[kref prpush-Y]
	jnc .t
	lea ecx,[kref prpop-Y]
.t:
	shr al,3
	mov eax,[kref regt-Y+eax]
	push ecx
	call emit
	jmp .z
.c:A; call disp
	call prcall
	call .k
	mov TOS(1),ecx
	ret
.j:A; jmp disp
	call prjmp
.k:
	spop
	dec eax
.ke:
	spush 2
	call dspword.j
	TOSPULL(1)
	mov ecx,eax
	add eax,[kref eax-4]
	mov TOS(1),eax
	cmp eax,eax	; Z
	ret
.e:; lea eax,[kref disp]
	call pdotqtep
	db 0,'[kref ',0
	mov eax,TOS(1)
	mov eax,[kref eax]
	spush 2
	call xec2lfa
	jz .w
	spush 2
	call iddot
	call space
.w:
	call dspword.e; lfa
	mov eax,']'<<8|AC_BS
	call emit
	add dword TOS(1),byte 5
	mov eax,TOS(1)
	ret
; local values
.la:A; test ld eax,LP
	mov ecx,TOS(1)
	mov ecx,[kref ecx]
	cmp ecx,dword[kref .d-Y]; 1st part of <spop>
	jnz .lq
	mov ecx,TOS(1)
	mov ecx,[kref ecx+4]; 07 89/01 8e xx
	and ch,0x77
	shl ecx,8
	cmp ecx,((x_lpsto)<<8|07)<<8
	jnz .lq
	mov ecx,TOS(1)
	mov ecx,[kref ecx+5]
	cmp cx,x_lstor
	jz .pt		;?; {to} local
	cmp cx,x_lpsto
	jz .pi		;?; {+to} local
.lq:
	jmp near .nt	; back to other tests
.lp:;{loc-ptr}
	mov ecx,TOS(1)
	mov ecx,[kref ecx]
	shl ecx,8
	cmp ecx,x_lptr2<<8
	jnz near .nl
	add dword TOS(1),byte 3
	mov eax,"l':-"
	jr .l
.pt:
	add dword TOS(1),byte 7
.lt:;{to}
	mov eax,'l! '
	jr .l
.pi:
	add dword TOS(1),byte 7
.li:;{+to}
	mov eax,'l+ '
	jr .l
.lr:
	mov eax,'l@ '
.l:
	call emit
	call fetchp
	sar eax,2	; index
	call dot
	spush
	xor edx,edx
	ret
; return by <ret>
retsem:A; ( -- )
	spush
	mov eax,' ;s'
	jr retjmp.e
; ret by jump into a word
retjmp:A; ( -- )
	spush
	mov eax,' >;'
.e:
	call emit
	inc eax
	xor edx,edx
	inc edx
	ret
;-
;- #dcm		( p1 -- p2 )			(4)(e)	'hdcm'			tools
;-	decompile from ref by ptr p1 to codespace, leave ptr p2 to next opr.
;-	(e: ret NZ at end of code section, after <ret> or <jmp ...>
hdcm:GA;:ok:
	call kprange
	jnc .w			;?; in program range
	call m.oa
.x:
	call space
	call cfetchp		; advance ptr
	call hexdot
	xor ecx,ecx
	dec ecx			; S
.r:
	ret
.o:A;<.w)
	inc eax
.w:; <qdcm)
	cmp byte[kref eax],x_nop
	jz .o			;?; advance over alignment
	cmp byte[kref eax],x_ret
	jz retsem
	call wfetchp		; w@+		{ w p2
	push eax		; save leading 2 bytes
	call disword		; find ix of 4th word	{ ix p3 | w p2
	pop ecx
	jns dspword		; display name & brach disp
	mov eax,ecx
	call discode		; lo-level code
	spop			; drop data at ptr
	jz .r
	lea eax,[eax-2]		; p2 > p1
	jr .x			;-> S
; ( p3 ix -- p+ ) #dcm 4th word, plus branch/lit/text
dspword:A;<hdcm)
	jz .s
	lea ecx,[kref retjmp-Y]
	push ecx		; ";"-return
.s:
	spush			; dup
	call iddot		; id.
	cmp ax,Ilit
	jz .n			;?; literal
	call dcmbra
	jnz .t			;?; not a branch
	spop			; drop index
.j:;:<dicode.ke) ;<jmp disp)
	call fetchp		; @+			{ n p+
	spush
	call space
	call dot		; display disp (at current @base)
	add eax,TOS(1)
	add eax,byte 4
	spush
.e:;:<discode.w)
	mov eax,('='<<8)|AC_BS
	call emit		; ..and branch destn. address
.p:;:<.n)
	call hxdsp		; display destn
.r:;:<.t)
	cmp eax,eax		; Z
	ret
.n:A; literal
	spop			; drop ix
	call fetchp		;			{ n p+
	jr .p
.t:A; text
	call dcmstg
	jnz .v			;?; try local value
	spop			; drop ix
	call stgdsp
	jr .r
.v:A; local de-/alloc or init, by index
	call dcmloc
	push eax		; save ix
	spop
	jnz .x			;?; not a value
	call fetchp
	call space
	mov ecx,[esp]
	cmp cx,Idolocr
	jz .f			;?; de-alloc cells
	cmp cx,Idoloca
	jz .f			;?; alloc cells
	sar eax,2
.f:;:<.v)
	call dot
.x:;:<.v)
	add esp,byte 4
	cmp eax,eax
	ret
;-
;- s						(4)	'nsee'			tools
;-	8 times repeat #see
nsee:GA;:ok:
	push_ibyte(8)
.l:
	call hsee
	dec dword[esp]
	jg .l
	lea esp,[esp+4]
	ret    
;-
;- #see		( -- )				(4)	'hsee'			tools
;-	continue where {see} terminated, from @fld, inc @fld at least by 1.
hsee:GA;:ok:
	spush
	mov eax,[byte uref uv.fld]
	inc dword[byte uref uv.fld]
	jr see.l
;-
;- see		ccc( -- )			(a:f)				forth
;-	(at most) decompile a hi-level word/soubroutine call by name.
;-	interrupt w. <esc>, halt display w. <space>, any other key to carry on.
;-	stores final ptr to {fld}, for continuation w. {#see}.
;-	NOTE: decompiles aliased words to names earliest in wordheaders list.
see:GA;:ok:
	call blwf	; bl word here find if
	jz .m
	spop
	push eax	; >rr idx>xec dup u. cr
	call idx2xec
	spush
	call udot
	call cr
	spush		; ."  : " r> id.
	mov eax,' : '
	call emit
	spush
	pop eax
	call iddot
.l:
	call space	; begin space esc? while #dcm until
	call escq
	spop
	jnz .r
	call .a
	call hdcm
	jz .l
.r:
	call .a
	call cr	; cr dup fld ! u.
	mov [byte uref uv.fld],eax
	jmp udot
.m:		; else dup c@ 1+ over c! print 0 message endif
	mov eax,[byte uref uv.dp]
	inc byte[kref eax]
	call print
	xor eax,eax
	jmp message
.a:; ; reset attrs, in case of embedded ctrls
	spush
	mov eax,-1	; 'me' termcap
	spush
	inc eax
	jmp vtcolour
;-
;- id.		( n -- ) 			(4)		'iddot'		forth
;-	display name of word by n uot index ("execution token") or lfa.
;-	imed words displayed at reversed video.
iddot:GA;:ok:
	call qlfa	;(slow but -hopefully- safe)
	jz .l
	mov eax,0xbad
	spush
.d:
	spop
	jmp hexdot
.l:
	push dword[kref eax+whead.f-whead.l]
	call lfa2nfa
	call cfetchp	; cnt
	call dup2
	call printingq
	spop		; drop flg	{ p u
	pop ecx
	jz .d		;?; non-printing chars
	test ecx,imed
	jz .c
	call getstdout
	test dword[kref ecx+cdt.iofl-cdt],mcons|micon; flags
	jz .c
	call revon
	lea ecx,[kref revoff-Y]
	push ecx
.c:
	jmp type
;-
;- voc.		( p -- )					'vocdot'	tools
;-	display name of wordlist which word pointed to by lfa p is in.
vocdot:GA;:ok:
	call wvoc
	jr iddot
;-
;- v		ccc( -- )			(4)		'vau'		root
;-	independently of search order, display which wordlist ccc belongs to, 
;-	display "-?-" if word doesn't exist.
vau:GA;:ok:
;all-find if ddup $. id. space tools voc. else ." -?-" drop endif space ;
	call allfind
	test eax,eax
	spop
	jz .x
	spush 2
	call hexdot
	call iddot
	call space
	call vocdot
	jmp space
.x:A
	mov eax,'-?- '
	jmp emit
;-
;- wvoc-r  	( p1 -- p2 )					'wvocr'		tools
;-	find 2ndary lfa p2 of wordlist which the word pointed to by lfa p1 is in.
wvocr:GA;:ok:
	call wvoc
	call lfa2idx
	call idx2wid
	jmp wid2lfa
;
wvoc.l:
	sub eax,ecx	; next link
;-
;- wvoc		( p1 -- p2 )					'wvoc'		tools
;-	find bottom lfa p2 of wordlist which the word pointed to by lfa p1 is in.
;-	get/verify RAM linkage w. { ( p1 ) wvoc lfa>idx idx>wid wid>lfa }.
wvoc:GA;:ok:
	call qlfa
	jnz near rtrue	;?; neither lfa nor alias
	mov ecx,[kref eax]
	test ecx,ecx
	jnz .l
	test dword[kref eax+whead.f-whead.l],vocf; find kernel-root of {root}
	jnz .n
	cmp word[kref eax+whead.i-whead.l],0; lfa>ifa @ 0< if 0 idx>lfa exit endif
	jns .n
;%if Iroot=0; which nasm won't do...
;    xor eax,eax
;%else
	mov eax,Iroot
;%endif
;    call idx2wid
	call idx2lfa
	call lfa2wid	; get kernel link
	lea eax,[eax+vhead.l-vhead.m]; 0 lfa>mfa - (reverse backlk to voc's name-lk)
.n:
	call lfa2ifa	; vocabulary's 2ndary link to name's linkfield
	movsx ecx,word[kref eax]
	sub eax,ecx
	ret
; check whether eax is valid lfa or ix (eflags=Z), taking aliased words into account
qlfa:A;:ok:;<id.,wvoc)
	spush		; dup
	call kdrange
	jc .i		;?; not in lfa range
	call lfa2xec
	test eax,eax
	jnz .q		;?; not a valid lfa
.i:
	mov eax,TOS(1)
	cmp eax,[byte uref uv.lkindex]
	jnc .q		;?; not an uot index
	call idx2uot
	mov eax,TOS(1)
	jz .l		;?; "pfax"-word
.x:
	call idx2xec
	test eax,eax
	mov eax,TOS(1)	; drop dup & force NZ
	jz .f		;?; not a valid index
.l:
	call idx2lfa	; convert to lfa
	mov TOS(1),eax
.q:
	xor eax,eax
.f:
	test eax,eax	; Z := found
	spop
	ret
;-
;- all-words  	( -- )								tools
;-	{vlist} all vocabularies.
;-	use keys <space> to halt, <esc> to terminate display.
allwords:GA;:ok:
	call cr
	lea ecx,[byte uref uv.voclink]
	sub ecx,KR
	push ecx
	jr .n
.l:
	spush
	mov [esp],ecx
	mov eax,ecx
	call vlist.w
	call cr
	mov ecx,[esp]
.n:
	mov edx,[kref ecx]
	test edx,edx
	jz .r		;?; no more vocs
	sub ecx,edx
	jnz .l		;?; in ram linkage
.r:
	lea esp,[esp+4]
	ret
;-
;- selected	ccc( .xx. -- .xx. )		(d)(i)				forth
;-	pass {words} selective output selection word. - preliminary -
;-	An example, selecting {words} output by a text segment:
;-		defer (t)			\ a string, used in (r)
;-		defer (w)			\ ( lfa -- flg ) selection
;-		s" *" dup stg s 
;-		' s is (t)
;-		: (r) lfa>nfa count (t) search -rot 2drop ;
;-		' (r) is (w)
;-		: sel begin dup 0= -exit dup (w) -exit dup @ - dup @ 0= until ;
;-		selected sel forth words	\ show words with "*" in their names
;-		forth words			\ next will be listing all words...
selected:GA;:ok:
;%if 0; 4th-:test:
;	defer (t) defer (w) here s" *" slit, =: (s)		' (s) is (t)
;	: (s) lfa>nfa count (t) count search -rot 2drop ;	' (s) is (w)
;	: sel begin dup 0= -exit dup (w) -exit dup @ - dup @ 0= until ;
;	selected sel forth words	\ show words with "*" in their names
;	forth words			\ next will be listing all words...
;%endif
	call tick
	call ccplq
	jnz pselectedp.c	;:continued:
;-
;- (selected)	( n1 lfa1 -- n2 lfa2 | .. 0 )	(d)(k)		'pselectedp'	util
;-	{words} selection, executed while collecting the nfa array to display.
;-	should return either the lfa, unchanged, or another lfa or, zero in which 
;-	case the array generation will be terminated, and adjust the array items 
;-	count value, accordingly.
pselectedp:GA;:ok:
    	mov ecx,[kref pselectedpv-Y]
	add ecx,databot
	mov [kref ecx],eax
	spop
	ret
.c:A
	TICK pselectedp
	jmp compilec
;-
;- [selected]	( lfa0 -- lfa0..lfa(n-1) n )	((d))(k)	'bselectedb'	util
;-	{words}' lfa collecting, w/ selection by deferred {(selected)}.
bselectedb:GA;:ok:
	push_ibyte(0)	; >r ; init count		[ count
.c:
	mov edx,eax
	mov eax,[esp]	; count
	spush
	mov ecx,pselectedpv-Y
	mov eax,edx	; lfa
	call pdodefer
	mov TOS(1),eax
	sub eax,[kref eax]
	inc dword[esp]	;				[ count'
	cmp [kref eax],byte 0
	jnz .c		;?; more
	spush
	pop eax		; ( lfa0 -- lfa-array count )
	ret
; -

;-
;- words  	( -- )				(f6)				forth
;-	alphabetically sorted list all names of {context} vocabulary,
;-	use keys <space> to halt, <esc> to terminate display.
;-	for once only(!) selective display -re- {selected}, 
;-	{words} returns w/ (selected) reset to it's default action.
words:GA;:ok:
	mov ecx,[kref precedesv-Y]
	add ecx,databot	; data-body of {precedes}
	lea edx,[kref pwp-Y]
	mov [kref ecx],edx
.s:;	;<entry if not {selected}
	call context
	mov eax,[kref eax]; wid		{ wid
; write the wordlist name
	spush
	call wid2lfa	;		{ voc-lfa wid
	call iddot	;		{ wid
.n:; fetch & count lfa-s of wordlist
	call wid2top	; 1st lfa	{ toplfa
	mov ecx,[uref uv.untab]
	push ecx
	mov dword[uref uv.untab],16
	call bselectedb	; [selected]
	push eax
	mov eax,' ('
	call emit
	spush
	mov eax,[esp]
	call decdot
	spush
	mov eax,AC_NL<<24|'):'<<8|AC_BS
	call emit
	mov ecx,[esp]	; nfa-count
	test ecx,1
	spush
	jz .p
	inc ecx
	spush
.p:
	mov eax,ecx
	inc eax
	spush
	inc eax		; locals count
	mov ecx,[byte uref uv.s0]
	push ecx	; base ptr			[ s0 count
	call toloc
	spush
	mov eax,[esp]
	call nstore
	spush
	mov eax,[esp]
	add eax,byte 4	; ptr
	mov [esp],eax	;				[ lfaptr count
	spush
	mov eax,[esp+4]	; count
; -
	call sort
	call maxlw
	sub eax,byte 8	; provide for <tab>, right margin
	mov ecx,[esp]	; lfa-ptr
	mov [esp],eax	; max line-width		[ maxlw count
	mov eax,[esp+4]	; save count for locals removal
	spush
	mov eax,ecx	; ptr to 1st lfa
.l:
	call escq	; ?esc
	spop
	jnz .q		;?; forcedly terminate
	call fetchp	; ( p -- p' nfa
	
	mov edx,[esp]	; pass max-lw
	call wcr
	call iddot	;  id.
	mov edx,[esp]
	call wtab
	dec dword[esp+4];				[ maxlw count'
	jg .l		;?; next name
.q:
	mov ecx,[kref pselectedpv-Y]
	add ecx,databot	; default-is (selected)
	mov edx,[kref ecx+4]
	mov [kref ecx],edx
	lea esp,[esp+8]
	mov eax,TOS(1)
	pop dword[uref uv.untab]
	TOSPULL(1)
	not eax		; ptrs + 1
	jmp toloc
; {sort} relation for {words}
; tf if 1st name < 2nd, else ff
pwp:A
	call lfa2nfa
	call count
	call rot
	call lfa2nfa
	call count
	call compare
	neg eax
	sar eax,1
	ret
; non-wrapping display tab-spacing for {words}
wtab:A; cr if @out + <tab> not < edx = max-lw
	mov ecx,[uref uv.untab]
	add ecx,[byte uref uv.nout]
	cmp ecx,edx	; max-lw
	jc near tab
.n:
	jmp cr		; ?cr
; non-wrapping display line-feed for {words}, {vlist}
wcr:A; ( nfa -- nfa )	; cr if @out + name not < edx = max-lw
	movzx ecx,byte[kref eax-whead.l+whead.n]
	add ecx,[byte uref uv.nout]
	cmp ecx,edx	; max-lw
	jnc wtab.n	; ?cr
	ret
;-
;- vlist  	( -- )				(fg)				forth
;-	consecutively list all names of {context} vocabulary,
;-	use keys <space> to halt, <esc> to terminate display.
vlist:GA;:ok:
	call context
	mov eax,[kref eax]; context @
	test eax,eax
	jz near .r	;?; vocstack empty
.w:;	;<words)	; @context
	call maxlw
	push eax	; max-x >r
	mov eax,TOS(1)	; drop dup
	call wid2lfa
	call iddot
	spush
	mov eax,AC_NL<<8|':'
	call emit
	call wid2top
	jr .n
.l:A
	call escq	; ?esc
	spop		;
	jnz .q		;?;forcedly terminate
	mov edx,[esp]	; pass max-lw
	mov ecx,[uref uv.untab]
	call wcr
	spush		; dup
	call iddot	;  id.
	call space
	sub eax,[kref eax]; dup @ -
.n:
	cmp dword[kref eax],byte 0
	jnz .l		;?;next lfa, else empty or end of voc
.q:
	lea esp,[esp+4]
.r:
	spop
	ret
; {help} support:
;-
;- all-find	ccc( -- lfa flg )				'allfind'	tools
;-	as {find}, searching all {voc-link}ed wordlists
allfind:GA;:ok:
	call BLWORD
	spush
	mov eax,.f-Y
	jmp bscanvb
; xec for <allfind>
.f:A;	( pw wid lfa lfa -- ix flg wid lfa 0 | pw wid 0 NZ )
	mov eax,TOS(3)	; ptr to name
	spush
	mov eax,TOS(2)	;		( pw wid lfa pw lfa --
	call pfindp	; (find)	( -- pw wid lfa ix NZ
; next wid	( pw wid lfa pw  0 --
	jz .c		;?; not found
; word found	( pw wid lfa ix NZ --
	mov ecx,TOS(1)	; lfa
	mov TOS(3),eax	; flg
	xor eax,eax	;		( -- ix NZ xx xx 0
	mov TOS(4),ecx
	ret
.c:; continue searching	( pw wid lfa pw 0 --
	mov ecx,TOS(3)	; wid
	sub ecx,[kref ecx]
	mov TOS(3),eax
	jz .p		;?; last voc	ret( pw 0 lfa 0 NZ --
	cmp eax,dword[kref ecx]
	jz .p		;?; last voc
	TOSPULL(1)	;		ret( pw wid lfa 0 --
.p:
	mov TOS(2),eax	; flg
	mov TOS(1),eax	; terminator
	dec eax		;		( -- pw 0 0 NZ
	ret
; <helpfind> for {help}, only, reverting to default find mode after execution
helpfind:GA
	mov ecx,allvhv-Y
	call pdodefer
	mov ecx,[kref allvhv-Y]
	add ecx,databot
	mov edx,[kref ecx+4]
	test eax,eax
	mov [kref ecx],edx
	ret
;-
;- hv		( -- )						'hvstack'	root
;-	restrict {help} to searching wordlists from stacked search order, only.
hvstack:GA;:ok:
	mov ecx,[kref allvhv-Y]
	add ecx,databot
	lea edx,[kref dfind-Y]
	mov [kref ecx],edx
	ret
;-
;- help		ccc( -- )			(i)				root
;-	Display help-text from glossary for word ccc or, @context if none given:
;-	1st occurrence of ccc in sequence of all {voc-link}ed wordlists will be 
;-	displayed; use { hv help } to searching the stacked search order, only. 
;-	{ vocs } displays the default search order specific to {help}.
;-	Searching can further be narrowed w/ {lc-depend} to letter case dependency.
;-	An error message will be returned, if word ccc or glossary file not found.
;-	
;-	The glossary file the name of which is stored in -re- {f8glo} is expected 
;-	in the documentation directory -re- {f8doc}, redirectable by ptrs to the 
;-	rsp strings in kernel-values {(f8doc)}, {(f8gls)}.
;-	
;-	{help} finds a word enclosed by leading <nl><bl> and trailing char <= <bl>
;-	in a glossary header line, w/ "( .. )" stack balance and ref to vocabulary
;-	and, reads/displays the rsp and any following lines until empty line found.
;-	By default, applicable to kernel words, only, and if the simple glossaries 
;-	were generated w/ e.g. <make doc>. Additional, conformant text may then be 
;-	appended to the file <glossary> in the installed documentation directory
;-	which becomes available to any lib4th programs, immediately after.
;-	plain ascii, un-escaped text displayed by -re- {[type]}.
;-	
;-	error messages:
;-		?vocabulary	 24	unknown or, voc-ref error in <glossary> file;
;-					try {v name} to verifying whether a word exists.
;-		invalid arg.	-22	<glossary> access or, text format error.
;-		no data avail.	-61	<glossary> reading error.
help:GA;:ok:
%assign __loc_help (((pthfsize)/4)+(256/4));w/voc-name
	spush
	mov eax,[byte uref uv.s0]
	spush
	mov eax,__loc_help
	spush		; 	( -- locp locn )
	call toloc
	call dup2
	call f8gls	;	( -- locp locn p.pth u.pth )
	test eax,eax
	jz near .f	;?; file not in doc-dir
	call rbyof
	call openf
	not eax
	call swap
	call qerror	;	( -- locp locn )
	call helpfind	; search all or stacked wordlists ( -- locp locn lfa flg
%if 1
	jnz .v		;?; word found
	mov eax,24	; '?vocabulary'
	mov ecx,dataptr
	cmp byte[kref ecx],0
	jnz near .m	;?; word not found
	mov eax,[byte uref uv.context]; display context-voc help
	call wid2idx
	call idx2lfa	; get lfa in RAM
	mov TOS(1),eax
.v:
%else
	mov eax,24	; '?vocabulary'
	jz near .m	;?; word not found
%endif
; vocabulary control
; fetch voc-name of found word, sto to end of local mem
	mov eax,TOS(1)	; lfa
	call wvoc	; the rsp. vocabulary kernel-lfa
	add eax,whead.n-whead.l; voc-nfa
	call ccount	;	( -- locp locn lfa vp vu
	spush
	mov eax,TOS(5)	;	( -- locp locn lfa vp vu locp
	add eax,((__loc_help)*4)-256; locpv
	call place	;	( -- locp locn lfa )
	call lfa2nfa	; name to find the glossary for
	call ccount	;	( -- locp locn wp wu )
	spush
	mov eax,TOS(4)	;	( -- locp locn wp wu locp )
	call place
	call psqtep
	db 0,d_ccr,d_bl,0
	neg eax
	spush
	mov eax,TOS(4)
	call pplace	;	( -- locp locn )
	spush
	xor eax,eax	; file ptr accu
	dec eax
	spush
.t:; search for the requested text
	add dword TOS(1),byte 1; count test-char
	adc eax,byte 0
	spush
	mov eax,TOS(4)
	call ccount	;	( -- locp locn p.text u.text )
	call workc                        
	call searchf	; search-file
	test eax,eax
	spop		;	( -- locp locn fpa.lo fpa.hi fp.lo fp.hi )
	jnz .d		;?; no entry found, EINVAL
	call dplus
	call workc
	call readchar	; check terminal char
	spop 2
	cmp cl,' '
	ja .t		;?; not the requested word
	mov ecx,TOS(3)
	movzx ecx,byte[kref ecx]
	dec ecx		; u w/o leading <nl>
	sub TOS(1),ecx
	sbb eax,byte 0	;	( -- locp locn fpa.lo fpa.hi )
	js .e		;?; file/stg size error, EINVAL
; test voc: read 1st line, 
; check for existence of "(" .. ")", " -- " stack notation, and voc-name at <eol>
	call .h		; test whether word's voc in header line
	js .e		;?; error, EINVAL
	jz .i		;?; vocname found
	jr .t		; continue searching
.l:
	call bctypeb	; [type], non-escaping variant
	call cr
.i:
	spush
	mov eax,TOS(2)
	spush 2		; over dup
	mov eax,200	; max line length
	call workc	;	( -- locp locn locp locp bufsiz chan )
	call readl
	test eax,eax
	spop 2		;	( -- locp locn locp stglen 
	jnz .n		;?; read error or stg too long(1.0.6+1)
	test eax,eax
	jnz .l		;?; display this line & continue
	spop		;	( -- locp locn locp
	call .w		; close file channel
.r:;		( -- locp locn locp
	mov eax,TOS(1)
	TOSPULL(2)
	neg eax
	jmp toloc
; entry in helpfile not found
.d:;	( -- locp locn fpa.lo fpa.hi fp.lo fp.hi )
	TOSPULL(2)	; drop fileptr accu
; file/stg size error, vocname not found
.e:;	( -- locp locn fpa.lo fpa.hi )
	mov eax,EINVAL	; -22 'invaild arg'
.m:; 4th word not found, msg #24
	call .w		; close file channel
	call message
	jr .r		;- discard locals, ready
.f:; file not in doc-dir
	call blword	; remove help subject
	mov eax,mhelpt-Y
	call print
	jr .r		;-
.n:; read error	( -- locp locn locp stglen 
	mov eax,ENODATA	; -61 "no data available"
	jr .m		;- discard locals, ready
.w:; close work-channel
	call workc
	call closef
	spop
	ret
.h:A;	;	(-- locp locn fpa.lo fpa.hi --)
	call dup2
	call .p		; rst file-ptr
	spush
	mov eax,TOS(4)	; locmem
	call ccount
	add eax,TOS(1)	; add search name length
	mov TOS(1),eax	; dup
	spush
	mov eax,200	; max line length
	call workc	;	( -- locp locn fpa.l fpa.h stgp stgp bufsiz chan )
	call readl	;	( -- locp locn fpa.l fpa.h stgp stglen flg  er
	test eax,eax
	spop 2		;	( -- locp locn fpa.l fpa.h stgp stglen
	jnz .q		;?; read error or stg too long(1.0.6+1)
	push eax	; save line length
	spush
	mov eax,TOS(6)	;
	call ccount
	add eax,3	; enclosing chars
	TOSPULL(1)
	call sstring	; cut off leading name
	spush		;	( -- locp locn fpa.l fpa.h stg len xx
	mov eax,TOS(6)
	add eax,((__loc_help)*4)-256; ptr to vocname
	call ccount	;	( -- locp locn fpa.l fpa.h stg len pvn uvn
	call search
	test eax,eax
	spop 3		; drop ret from {search}
	pop ecx		; line-len
	jz .c		;?; not found
.p:
	call workc
	call reposnf	; reposition-file
	xor ecx,ecx	; NS*Z if vocname found
	spop		; drop flg
	ret
.q:A
	spop 2		; drop stg
	ret
.c:A
	add TOS(1),ecx
	adc eax,0	; advance fileptr by line length
	inc ecx		; NZ*NS
	ret
;-	

;-
;-	
;- ----------------------------------------------------------------
;--- {sorted}, {sort}, {quick}, using {d!}, {d@}, {d!!}
;-	a tag-sort procedure, in {util} wordlist.
;-

;-	

;
sorted.c:A
	TICK psortedp
	jmp compilec
;-
;- sorted 	ccc( p n -- )			(i)(4)				util
;-	according to the relation ccc order array(p,n), n cells at ptr p.
;-	use{ SORTED <relation> } - 'relation' being stored to {precedes}.
sorted:GA;:ok:
	call tick
	call ccplq
	jnz .c
;-
;- srd		( p -- )			(k)		'psortedp'	novoc
psortedp:A
	mov ecx,[kref precedesv-Y]
	add ecx,databot
	mov [kref ecx],eax
	spop			;:continues: in {sort}
;-
;- sort		( ptr n1 -- )			(4)				util
;-	Modified "quicksort", sort an array by ptr p to array of n1 items.
;-	(from: R.Zech, Forth 83, Muenchen Franzis' 1987) -re- {quick}, {sorted}.
;-	An example application (on assembly level) is -re- {words}.
sort:GA;:ok:
; -dup IF ( 1-) cells over + quick ;S ENDIF drop ." empty list" ;
	test eax,eax
	jng near drop2
	dec eax
	mov ecx,TOS(1)
	lea eax,[ecx+eax*4]	;:continues: in {quick}
;-
;- quick  	( ptr1 ptr2 -- )		(4)				util
;-	sort arrays by ptrs, using deferred words to enabling virtual 
;-	memory addressing and task specific evaluation words:
;-	{precedes}	( p1 p2 -- flg ) comparison at p1,p2, tf if "lower"
;-	{d@}		( p -- n )	fetch sing n from ptr p
;-	{d!}		( n p1 -- )	store sing n to ptr p
;-	{d!!}		( p1 p2 -- )	exchange sings at p1,p2
quick:GA;:ok:
; 2dup over- cell/ even + @ >r 2dup swap   ( ptr1 ptr2 -- )
	mov ecx,eax	;c: n2
	mov edx,TOS(1)	;d: n1	2dup	( n1 n2 n1 n2
	spush
	mov eax,edx
	sub ecx,edx	; over-		( n1 n2 n2-n1
	sar ecx,1	; 2/
	and ecx,-4	; -cell and
	add eax,ecx	; +		( n1+(((n2-n1)/4+3)&-4)
	call dfetch	; d@
	push eax	; >r
	mov ecx,TOS(2)
	mov eax,TOS(1)	; 2dup
	spush
	mov eax,ecx	; swap
;  BEGIN-1
.begin1:
;   ENTER BEGIN-2 cell+ ENTRY dup  @ r precedes 0= UNTIL-2 swap
	jr .entry2
.begin2:A
	add eax,byte 4	; cell+
.entry2:
	spush		; dup
	call dfetch	; d@
	spush
	mov eax,[esp]	; r
	call precedes
	test eax,eax
	spop
	jnz .begin2
	call swap
.enter3:
	jr .entry3
;   ENTER BEGIN-3 cell- ENTRY r over @ precedes 0= UNTIL-3 swap
.begin3:A
	sub eax,byte 4	; cell-
.entry3:
	mov ecx,eax
	spush
	mov eax,[esp]	; r
	spush
	mov eax,ecx	; over
	call dfetch	; d@
	call precedes
	test eax,eax
	spop
	jnz .begin3
	call swap
;   2dup u< 0=
	cmp eax,TOS(1)	; NC: u<, C: u>=
;   IF-1 2dup - 
.if1:
	ja .endif1
;IF-2 2dup @ 2over @! swap ! ENDIF-2
.if2:
	jz .endif2
	spush
	mov eax,TOS(2)
	spush
	mov eax,TOS(2)	; 2dup
	call dxsto	; d!!
.endif2:
; swap cell- swap cell+ ENDIF-1
	sub dword TOS(1),byte 4
	add eax,byte 4
.endif1:
;  2dup u<
	cmp eax,TOS(1)
; UNTIL-1 rdrop rot 4dup - + u< 0=
	jc disp .begin1
	call rot
	mov ecx,eax
	sub ecx,TOS(1)	; 4dup - +
	add ecx,TOS(2)
	lea esp,[esp+4]	; rdrop
	cmp ecx,TOS(3)	; u< 0=
; IF-3 2swap ENDIF-3
.if3:
	jnz .endif3
	call swap2	; 2swap
.endif3:
;  2dup u< IF-4 recurse ELSE-4 2drop ENDIF-4
	cmp eax,TOS(1)
.if4:
	jc .else4
	call quick
	jr .endif4
.else4:A
	spop 2		; 2drop
.endif4:
;  2dup u< IF branch [ latest pfa here - , ] ENDIF 2drop ;
	cmp eax,TOS(1)
	jnc disp quick
	spop 2
	ret
;-
;- precedes	( p1 p2 -- f )			(d)				util
;-	comparison function in {sort}, should return tf for "lower".
precedes:A
	mov ecx,precedesv-Y
	jmp pdodefer
;-
;- d@		( p -- n )			(d)		'dfetch'	util
;-	deferred 'fetch' a sing, for virtual addressing in {sort}, etc.
dfetch:A
	mov ecx,dfetchv-Y
	jmp pdodefer
;-
;- d!		( n p -- )			(d)		'dstore'	util
;-	deferred 'store' a sing, for virtual addressing in {sort}, etc.
dstore:A
	mov ecx,dstorev-Y
	jmp pdodefer
;-
;- d!!		( p1 p2 -- )			(d)		'dxsto'		util
;-	deferred 'exchange' contents of equally sized storage places.
dxsto:A
	mov ecx,dxstov-Y
	jmp pdodefer
%endif;__TOOLS_I
;-
;-=====================================================================;
;- l4tools.inc <eof>
