;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-=====================================================================;
;-  file  	: l4tty.inc
;-  created	: 17-jul-01
;-  modified	: -> re "version.inc"
;-  version	: 0.01(+)
;-  switches	:
;-  assembler	: nasm 0.98-3e
;-  description	: tty & ascii ctrl data
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	:
;-  source	: linux src & man
;-  requires	: the "lib4th" package
;-=====================================================================;
;-
;-	
;-	

;-
;- ctrlchars, bytewise dft code translation
;-	in range [0...31], <del> substitutes <nul>
	a
ctrlchars:N
	db AC_DEL,AC_SOH,AC_STX,AC_ETX,AC_EOT,AC_ENQ,AC_ACK,AC_BEL,AC_BS, AC_HT, AC_LF,AC_VT, AC_FF,AC_CR,AC_SO,AC_SI
	db AC_DLE,AC_DC1,AC_DC2,AC_DC3,AC_DC4,AC_NAK,AC_SYN,AC_ETB,AC_CAN,AC_EM,AC_SUB,AC_ESC,AC_FS,AC_GS,AC_RS,AC_US
;-
;- ctrlbits, default pattern
;-	bit pattern of executeable ctrl actions, 256 bits
ctrlbits:N
;	    es cesnddddd        baeeessn	d
;	urgfsueatyacccclsscfvlhbecnottou	e
;	sssscbmnbnk4321eiorftftslkqtxxhl	l
	dd	00000000000000000000000000000000b,0,0,0x00000000,0,0,0,0


; stty sane :
;	cread -ignbrk brkint -inlcr -igncr icrnl
;	-ixoff -iuclc -ixany imaxbel opost -olcuc -ocrnl onlcr
;	-onocr -onlret -ofill -ofdel nl0 cr0 tab0 bs0 vt0 ff0
;	isig icanon iexten echo echoe echok -echonl -noflsh
;	-xcase -tostop -echoprt echoctl echoke, all special
;	characters to their default values.
; - pty.c -
; static char cchars[] = {
;	  VINTR, VQUIT, VERASE, VKILL, VEOF, VEOL, VSTART, VSTOP, VSUSP,
;    };
; load values individually rather than in static struct since
; the order of the members *doesn't* seem to be something that
; all posix systems agree on.
;     sane.c_iflag = IGNPAR|ICRNL|BRKINT|ISTRIP|IXON;
;     sane.c_oflag = OPOST|ONLCR;
;     sane.c_cflag = B9600|CS7|PARENB|CREAD;
;     sane.c_lflag = ISIG|ICANON|ECHO|ECHOE|ECHOK|ECHONL;
;     sane.c_line = 2;
;     bcopy(cchars, sane.c_cc, sizeof(cchars));
; - stty -g -
;    2102:5:4bf:8a3b:3:1c:7f:15:4:0:1:0:11:13:1a:0:12:f:17:16:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0
	a
ttyst:N
.iflag:
	dd 0x00002102
.oflag:
	dd 0x00000005
.cflag:
	dd 0x000004bf
.lflag:
	dd 0x00008A3B
.lineb:
	db 0
.termio:; do not use asmutils 0.14: values are char positions in structure!
	db CC_VINTR	;0x03
	db CC_VQUIT	;0x1C
	db CC_VERASE	;0x7F
	db CC_VKILL	;0x15
	db CC_VEOF	;0x4
	db CC_VTIME	;0x0
	db CC_VMIN	;0x1
	db CC_VSWTC	;0x0
	db CC_VSTART	;0x11
	db CC_VSTOP	;0x13
	db CC_VSUSP	;0x1A
	db CC_VEOL	;0x0
	db CC_VREPRINT	;0x12
	db CC_VDISCARD	;0x0F
	db CC_VWERASE	;0x17
	db CC_VLNEXT	;0x16
	db CC_VEOL2	;0x0
	times NCCS-($-.termio) db 0
;-
;-
;-================================================================
;- l4tty.inc <eof>
