;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-=====================================================================;
;-  file  	: l4vtseq.inc
;-  created	: 17-jul-01
;-  modified	: -> re "version.inc"
;-  version	: 0.01(+)
;-  assembler	: nasm 0.98-3e
;-  description	: vt control code sequences for the linux console
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	: doc re "glossary.txt" and "l4...html" in ./doc dir,
;-  source	: linux, src & man, xterm src; <include/linux/vt.h>
;-  requires	: the "lib4th" package
;-=====================================================================;
;-

;-
;- <vtht>
;- vt kernel ioctls, structure defn's, </usr/src/linux/include/linux/vt.h>
vtht:A
	db "/usr/src/linux/include/linux/vt.h"
;-	
;-	
; do not change names and sequence of non-local labels:
control:A; Some hardcoded console cmds (Linux/XTerm)
.ho: db 27,"[H",0		; cursor_home,             ho - home position
.le: db 27,"[D",0		; cursor_left,             le - cursor left
.nd: db 27,"[C",0		; cursor_right,            nd - right one column
.up: db 27,"[A",0		; cursor_up,               up - up one column
.do: db 27,"[B",0		; cursor_down,             do - down one column
.cl: db 27,"[H",27,"[J",0	; clear_screen,            cl - clear screen and home
.cd: db 27,"[J",0		; clr_eos,                 cd - clear down
.ce: db 27,"[K",0		; clr_eol,                 ce - clear to end of line
.bl: db 7,0			; bell,                    bl - bell 
.dc: db 27,"[P",0		; delete_character,        dc - delete character in line
.dl: db 27,"[M",0		; delete_line,             dl - delete line from screen
.sf: db 27,"D",0		; scroll_forward,          sf - scroll screen up (XTerm ??)
.sr: db 27,"M",0		; scroll_reverse,          sr - scroll screen down
.so: db 27,"[2m",0		; enter_standout_mode,     so - enter standout mode (half bright)
.se: db 27,"[22m",0		; exit_standout_mode,      se - normal intensity
.us: db 27,"[4m",0		; enter_underline_mode,    us - turn on underline mode
.ue: db 27,"[24m",0		; exit_underline_mode,     ue - turn off underline mode
.md: db 27,"[1m",0		; enter_bold_mode,         md - enter double bright mode
.mr: db 27,"[7m",0		; enter_reverse_mode,      mr - enter reverse video mode
.mb: db 27,"[5m",0		; enter_blink_mode,        mb - enter blinking mode (XTerm??)
.me: db 27,"[0m",0		; exit_attribute_mode,     me - turn off all appearance modes
;
.25: db 27,"[25m",0		; blink off
.27: db 27,"[27m",0		; reverse video off
.xy: db 27,'[6n',0		; ret cursor posn
.ris:db 27,'c',0		; reset
.sc: db 27,'7',0		; save state (attr, curs, charsets)
.rc: db 27,'8',0		; most recently saved state
.vi: db 27,'[?25l',0		; cursor invisible
.ve: db 27,'[?25h',0		; cursor visible
	align 2,db 0
.enum:;A
	dw (vtlinux-$)/2
	dw .ho-$
	dw .le-$
	dw .nd-$
	dw .up-$
	dw .do-$
	dw .cl-$
	dw .cd-$
	dw .ce-$
	dw .bl-$
	dw .dc-$
	dw .dl-$
	dw .sf-$
	dw .sr-$
	dw .so-$
	dw .se-$
	dw .us-$
	dw .ue-$
	dw .md-$
	dw .mr-$
	dw .mb-$
	dw .me-$
	dw .25-$
	dw .27-$
	dw .xy-$
	dw .ris-$
	dw .sc-$
	dw .rc-$
	dw .vi-$
	dw .ve-$
	dw .enum-$
vtlinux:A;_rawkey_string[] =	; Strings sent by function keys
.k1: db  27,"[[A",0		;00 .k1 - function keys 1 - 4
.k2: db  27,"[[B",0		;01 .k2
.k3: db  27,"[[C",0		;02 .k3
.k4: db  27,"[[D",0		;03 .k4
.k5: db  27,"[[E",0		;04 .k5
.k6: db  27,"[17~",0		;05 .k6
.k7: db  27,"[18~",0		;06 .k7
.k8: db  27,"[19~",0		;07 .k8
.k9: db  27,"[20~",0		;08 .k9
.k0: db  27,"[21~",0		;09 .k0
; f10..F19 [23...[34 - F10 = \e[23(!)
.kl: db  27,"[D",0		;20 .kl - arrow left
.kr: db  27,"[C",0		;21 .kr - arrow right
.ku: db  27,"[A",0		;22 .ku - arrow up
.kd: db  27,"[B",0		;23 .kd - arrow down
.kh: db  27,"[1~",0		;24 .kh - home key
.kH: db  27,"[4~",0		;25 .kH - home down key (end key)
.kN: db  27,"[6~",0		;26 .kN - next page
.kP: db  27,"[5~",0		;27 .kP - previous page
.kb: db  27,"[D",0		;28 .kb - backspace key
.kD: db  27,"[3~",0		;29 .kD - delete character key
.kI: db  27,"[2~",0		;30 .kI - insert character key
	align 2,db 0
.enum:;A
	dw (xterm-$)/2
	dw .k1-$
	dw .k2-$
	dw .k3-$
	dw .k4-$
	dw .k5-$
	dw .k6-$
	dw .k7-$
	dw .k8-$
	dw .k9-$
	dw .k0-$
	dw .kl-$
	dw .kr-$
	dw .ku-$
	dw .kd-$
	dw .kh-$
	dw .kH-$
	dw .kN-$
	dw .kP-$
	dw .kb-$
	dw .kD-$
	dw .kI-$
	dw .enum-$
xterm:A;_rawkey_string[] =	; Strings sent by function keys
.k1: db  27,"[11~",0		; .k1 - function keys 1 - 4
.k2: db  27,"[12~",0		; .k2
.k3: db  27,"[13~",0		; .k3
.k4: db  27,"[14~",0		; .k4
.k5: db  27,"[15~",0		; .k5
.k6: db  27,"[17~",0		; .k6
.k7: db  27,"[18~",0		; .k7
.k8: db  27,"[19~",0		; .k8
.k9: db  27,"[20~",0		; .k9
.k0: db  27,"[21~",0		; .k0
.kl: db  27,"OD",0		; .kl - arrow left
.kr: db  27,"OC",0		; .kr - arrow right
.ku: db  27,"OA",0		; .ku - arrow up
.kd: db  27,"OB",0		; .kd - arrow down
.kh: db  27,"[1~",0		; .kh - home key ??
.kH: db  27,"[4~",0		; .kH - end key ??
.kN: db  27,"[6~",0		; .kN - next page
.kP: db  27,"[5~",0		; .kP - previous page
.kb: db  27,"[D",0		; .kb - backspace key
.kD: db  27,"[3~",0		; .kD - delete character key ??
.kI: db  27,"[2~",0		; .kI - insert character key
	align 2,db 0
.enum:;A
	dw (colour-$)/2
	dw .k1-$
	dw .k2-$
	dw .k3-$
	dw .k4-$
	dw .k5-$
	dw .k6-$
	dw .k7-$
	dw .k8-$
	dw .k9-$
	dw .k0-$
	dw .kl-$
	dw .kr-$
	dw .ku-$
	dw .kd-$
	dw .kh-$
	dw .kH-$
	dw .kN-$
	dw .kP-$
	dw .kb-$
	dw .kD-$
	dw .kI-$
	dw .enum-$
colour:A
.28:
.29:
.30: db 27,"[30m",0; black foreground
.31: db 27,"[31m",0; red foreground
.32: db 27,"[32m",0; green foreground
.33: db 27,"[33m",0; brown foreground - (very, almost invisible) dark yellow
.34: db 27,"[34m",0; blue foreground
.35: db 27,"[35m",0; magenta foreground
.36: db 27,"[36m",0; cyan foreground
.37: db 27,"[37m",0; white foreground
.38: db 27,"[38m",0; underscore on, set default foreground color
.39: db 27,"[39m",0; underscore off, set default foreground color
.40: db 27,"[40m",0; black background
.41: db 27,"[41m",0; red background
.42: db 27,"[42m",0; green background
.43: db 27,"[43m",0; brown background
.44: db 27,"[44m",0; blue background
.45: db 27,"[45m",0; magenta background
.46: db 27,"[46m",0; cyan background
.47: db 27,"[47m",0; white background
.48:
.49: db 27,"[49m",0; default background color
	align 2,db 0
.enum:;A
	dw (cstrings-$)/2
	dw .30-$
	dw .31-$
	dw .32-$
	dw .33-$
	dw .34-$
	dw .35-$
	dw .36-$
	dw .37-$
	dw .38-$
	dw .39-$
	dw .40-$
	dw .41-$
	dw .42-$
	dw .43-$
	dw .44-$
	dw .45-$
	dw .46-$
	dw .47-$
	dw .48-$
	dw .49-$
	dw .enum-$
cstrings:A
.enum:
	dw (.e-$)/2
	dw control.enum-$	;0 console
	dw vtlinux.enum-$	;1 console F-keys
	dw xterm.enum-$		;2 xterm F-keys
	dw colour.enum-$	;3 colours
	dw sysc.enum-$		;4 syscalls names list
	dw .enum-$		;. end marker
.e:
; -
; - single vt100(etc) control strings
vt.revvn:equ control.mr	;:db 27,"[7m",0	; enter_reverse_mode
vt.revvf:equ control.27	;:db 27,"[27m",0; reverse video off
ttyrst.b:equ control.ris;:db 27,'c',0	; reset
;-
;-=====================================================================;
;- l4vtseq.inc <eof>
