;-===============;:ok:=================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file  	: l4words.inc
;-  created	: 10-jun-00
;-  modified	: 30-jun-00(+)
;-  version	; 0.22 (re "version.inc") - PRE-RELEASE test version
;-  assembler	: nasm 0.98-3e (patched & bugs fixed 0.98)
;-  description	: word headers for "lib4th"
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	: "lib4th" is a forth system sharable library
;-		: NEVER CHANGE ORDER OF WORDS in this header list!
;-		: else compiled 4th programs become non-functional.
;-		: preliminary words order wrt vocabularies.
;-  source	: (me)
;-  requires	: lib4th package
;-  switch	: __LIB4W_I
;-=====================================================================;
;-

;-
%ifndef __LIB4W_I
%define __LIB4W_I
%define lib4wordsinc
;-
; ------------- ;
;[nolist]
; ------------- ;

; doc: sort by topic 2-chars markers, def'd as empty stg's, neutral for assembly
;      insert pattern, between ";<glos" and ";glos>" below:
;	<beginnning of line=>%define<bl>cc<tab>;<bl>..text..
;<glos
%define aa	; arithmetic, sing numeric (cons, vari)
%define ac	; arithmetic, mixed sing w/ double or quad
%define ad	; arithmetic, double and mixed w/quad
%define af	; arithmetic, quad (-re- mixed sing & double) and 8-cells num
%define an	; bignum opr
%define ao	; bignum mixed praecision
%define ap	; bignum data-/return-stack opr
%define ar	; rational sing arithm & stack
%define as	; rational logic, all sizes
%define au	; rational double arith & stack
%define av	; rational quad arith & stack
%define aw	; rational cons, all sizes
%define ax	; numeric data, words
%define ay	; local memory, data opr
%define bb	; bit-opr, sing
%define bd	; bit-opr, double
%define bi	; bit-opr, quad & bignum
%define bz	; cpu-opr, all sizes
%define cc	; data conversion, misc.
%define cd	; data conversion, to display
%define ch	; data conversion, to text
%define cn	; data conversion, to numeric
%define co	; data structures disp's conversion
%define da	; specific to ans-voc and environmental queries
%define eo	; editor, screen-/block-file access
%define fa	; sequential file access
%define fb	; block-file access
%define fi      ; file or termial i/o, device independent
%define ft	; terminal i/o
%define fv	; vt control
%define hh	; hidden words not for regular use, apply w/ care
%define ho	; compiler runtimes & vari
%define hv	; vectored data, ptr's, words
%define hx	; vectored words' defaults
%define ic	; conditional interpreting
%define ii	; interpreter
%define kk	; uninitiated, initial L4 kernel
%define ll	; logic
%define ma	; memory arithmetic and logic opr
%define mg	; memory, sing
%define mm	; memory, string and multiple cells
%define mq	; memory, quad
%define mu	; memory, doubles
%define mx	; memory, vectored & miscelaneous
%define np	; floating pt. sing numbers (per double ranum)
%define nq	; floating pt. double numbers (per quad ranum)
%define og	; defining words
%define oo	; code compiler
%define os	; program flow control
%define ot	; data compiler
%define pa	; assembler
%define pp	; i/o port access
%define rr	; return-stack sing, doubles, quad
%define ss	; data-stack sing, doubles, quad
%define tt	; text, chars data, words
%define uu	; utilitiy words
%define vv	; vocabularies, relating opr
%define ww	; forth, other words...
%define xx	; linux specific, system
%define yy	; system related words
%define zz	; novoc, header-less or not implemented/not complete
;glos>
;-
;---------------------------------------------------------------------------------;
;-
;- NOTE:
;- Due to nasm specific issues (deficiencies?) DO NOT CHANGE the general structures
;- SETUP AND LOCATIONS! Current arrangement was found feasible after many (weeks of)
;- trials and errors and apparently is on a very narrow path of possible solutions!
;-
;- List Items
;-	may be ordered to suit. in Forth, last entries will be found first.
;-
;- Additional Words:
;-	add standard wordheader w. <crea> macro
;-		[mark]<tab>crea flags,findname,asmname,parentvoc ;<bl>[comment]
;-		strictly stick to the above pattern, for orderly doc's generation,
;-		assign words type kathegory (re %define-s, l4words) for the docs.
;-	add word's
;-		executeable code at <asmname> to the rsp file in src directory.
;-		if not already present %include filename into <lib4th.asm>.
;-	add comment
;-		4th word, stack flow, etc, else {help} won't help... - re below
;-
;- Synonyous Words:
;-	use <acrea> instead of <crea> and insert the new defn to the list after the 
;-		one it refers to - nasm can't forward refer to <equ>, %define, etc.
;-
;- Kernel Variables & Values:
;-	use the pattern of
;-	<[mark]<tab>crea pfax|varf|2,{'..name..'},runtime,parentvoc,default ;<bl>[comment]>
;-	where '2' in the flag item can be any higher value, corresponding to the
;-	number of additional, following cells, and passed one less to <nxvari ..>
;-	<label> points to the default data structure
;-		label: nxvari 1		; ptr w/ disp to dataspace after sys.init
;-			dd ..data..	; default datafield
;-	<label> can be referred from kernel code as <label>v, re the rsp runtimes.
;-	lo-level access by, e.g.
;-		mov reg,[kref <label>v-Y]
;-		add reg,databot		; ptr to 1st data cell by %defined <databot>
;- Kernel Deferred:
;-	deferred words require a provisional, additional field for the forget-linkage:
;-		<[mark]<tab>crea pfax|varf|4,{'..name..'},pdodefer,parentvoc,xeclabel
;-		label: dd I<dftword>,I<dftword>
;-	3rd datafield generated by kernel at system initiation time.
;-	<xeclabel> should point to deferred execution entry, e.g.
;-		mov ecx,<label>v-Y
;-		jmp pdodefer
;-	<dftword> required to be referrable by uot-index, thus requires a regular 
;-	word header or, in {novoc}. headerless words may be used at run-time, only.
;-
;-	NOTE1:	counting entries, "nxvari", required because 
;-		"nasm" neither can backpatch nor 'look' forward...
;-	NOTE2:	<pfax> words cannot be 'immediate'
;-
;- Additional vocabularies:
;-	add vocabulary type wordheader w. <cvoc> macro
;-		cvoc flags,findname,vocname,parentvoc
;-	add ref at/to end of wordlist after header list
;-		(name)link: equ (name)top-last(name)
;-		or w. macro, <endvoc vocname>.
;-	add vocabulary
;-		executeable, preferrably to "l4sorder.inc".
;-	add comment
;-		some general description of the rsp voc, for {help} w/o name.
;-
;-	flags	  re "lib4th.mac"
;-	findname  is text by which word can be found w. {find}
;-	asmname   label of executable in assembly source
;-		  which should be declared "global", for external prog refs.
;-	vocname	  ditto, defining a vocabulary
;-	parentvoc name of vocabulary in the wordlist of which the word
;-		  defined by this header will be found.
;--
;- root
;-	must remain the very 1st defn in wordlist.
;-	do not modify the <root> header.
;-
;- documentation
;-	<make html> uses a bash shell-script which is a bit funny with 'special' 
;-	characters, and other text evaluation. Thus pse, add new words by header 
;-	lines as below, exactly matching the explained pattern. 
;-	particularly, words the header-lines of which do not show a trailing 
;-	comment (at least the "; " part) might not appear in the html glossaries.
;-
;- { help forthword }
;-	takes its text from the rsp. glossary entries, which are extracted from 
;-	the assembly source, with <make doc>. {help} relies on a certain, very 
;-	simple text structure which is explained in it's glossary entry.
;-
;---------------------------------------------------------------------------------;
;-
; ----------------------------- ;
;-
%ifdef __LIB4TH
    global vocbase,toplink,topvoc,Iueax
    align PAGE_SIZE,db -1
%else
%ifndef versioninc
%define versioninc
%include "version.inc"
%endif
%ifndef systeminc
%include "system.inc"
%endif
;[nolist]
%ifndef relocinc
%include "reloc.inc"
%endif
;[nolist]
%ifndef constantsinc
%include "constants.inc"
%endif
;[nolist]
%ifndef lib4thinc
%include "lib4th.mac"
%endif
;[nolist]
%ifndef pushpopinc
%include "pushpop.mac"
%endif
    extern vocbase,toplink,topvoc,Iueax,Y
%endif
; ----------------------------- ; basic words linkage
vocbase:		; module		std-4th	; bot. of kernel headers, in <kdrange>
	dw -1		;			ifa
	dw 0		;			ffa
w.i:	dw w.i-w.l	; xifa			mfa	; { dup w@ w->s - } => voclink = lfa
w.f:	dw 0		; xffa			lfa
w.v:	dd w.v-w.l	; xmfa			nfa
;- prevlink, re <uv.voclink>
;-	initial vocabulary link in library .text segment,
;-	running asm-vari re previous linkaddress.
%xdefine prevlink w.v
w.l:	dd 0		; xlfa	voclink root	pfa	; bot. of all words linkage
;-
;- lastroot
;-	required initial link, base ref of voc-link
;-	running asm-vari re previous linkaddress
%xdefine lastroot w.l
w.n:	db 4,'root',0,0,0; xnfa
w.p:	dd rootlink	; xpfa
;- lkindex, re <uv.lindex>
;-	per word 16bit unsigned index into user offset table
%assign lkindex 0
;			; <Croot> ptr to root-lfa, base reference for module
vv	cvoc vocf|imed|3,{'root'},	root,		root	; basic voc, essential words, linkage base
; module header extn
Lz:	dd toplink	; mhead.s, == @topref, last lfa in module, {last}
Tz:	dd topvoc	; mhead.t, == @vocref, local voclink, to {voc-link}
	nxvari 0	; initate vari datafields counter
;>; vocabularies
ww	crea 0,		{'noop'},	noop,		root	; no action, just <ret>
vv	cvoc vocf|imed,	{'forth'},	forth,		root	; root-voc, main
vv	cvoc vocf|imed,	{'ans'},	ans,		forth	; forth-voc, words specific to ANS-4th
vv	cvoc vocf|imed,	{'fig'},	fig,		forth	; forth-voc, words specific f.i.g.-style 4th
vv	cvoc vocf|imed,	{'util'},	utility,	forth	; forth-voc, forth utiliy words
vv	cvoc vocf|imed,	{'blkfile'},	blkfile,	forth	; forth-voc, block-file special words
vv	cvoc vocf|imed,	{'assembler'},	assembler,	root	; root-voc, native code cpl. words
vv	cvoc vocf|imed,	{'compiler'},	compiler,	root	; root-voc, cpl control
vv	cvoc vocf|imed,	{'hidden'},	hidden,		root	; root-voc, used within other words
vv	cvoc vocf|imed,	{'linux'},	linux,		root	; root-voc, host access
vv	cvoc vocf|imed,	{'system'},	systm,		root	; root-voc, hardware specific
vv	cvoc vocf|imed,	{'bignum'},	bignum,		forth	; forth-voc, unlimited praecision integers
vv	cvoc vocf|imed,	{'vt'},		vt,		forth	; forth-voc, vt..-control
vv	cvoc vocf|imed,	{'editor'},	editor,		fig	; fig-forth-voc, editting
vv	cvoc vocf|imed,	{'tools'},	tools,		forth	; forth-voc, debugging
vv	cvoc vocf|imed,	{'local'},	local,		hidden	; hidden-voc, local memory control & names
vv	cvoc vocf|imed,	{'non-mmx'},	nonmmx,		forth	; forth-voc, non-mmx substitutes
vv	cvoc vocf|imed,	{'testvoc'},	testvoc,	hidden	; hidden-voc, (praeliminary tests)
vv	cvoc vocf|imed,	{'environment'},environment,	hidden	; hidden-voc, ansi-ish environment queries
vv	cvoc vocf|imed,	{'novoc'},	novoc,		systm	; system-voc, non-executeable, dummy names
%define system systm; prevent (my frequent) typing errors...
;>; laber-"optionen" fuer steppenrinder...
kk	crea 0,		{'--help'},	ihelp,		root	; minimalistic help
ww	crea 0,		{'--env-ini'},	f8ini,		systm	; evluate F8INI env vari
kk	acrea 0,	{'--env-ini'},	noop,		root	; a noop dummy, initially in search order
kk	crea 0,		{'--version'},	sversion,	root	; library version
;>; inactive, for internal compiling by ix and debugging purposes & {see},
;>; words can neither be executed nor found and are not globally available
; - ;
ho	crea 0,		{'(cd'},	pcdp,		novoc	; {cd} runtime
;zz	crea 1,		{'(ed'},	edit,		novoc	; deferred {edit} xec ntry
zz	crea 1,		{'(vl'},	pdoval,		novoc	; fetch a kernel-def'd value
zz	crea 1,		{'(vr'},	pdovar,		novoc	; fetch a kernel-def'd vari
zz	crea 1,		{'blw'},	BLWORD,		novoc	; { bl word find }, kernel only
zz	crea 1,		{'bwf'},	blwf,		novoc	; { bl word find }, kernel only
zz	crea 1,		{'ddf'},	dodfer,		novoc	; xec a deferred word
zz	crea 1,		{'ddk'},	pdodefer,	novoc	; xec a kernel-deferred word
zz	crea 1,		{'ddo'},	dodoes,		novoc	; xec <pfax>-words
zz	crea 1,		{'dfg'},	dfdfg,		novoc	; dft forget action for deferred word
zz	crea 1,		{'df?'},	dfder,		novoc	; undef'd deferred word error if ff
zz	crea 1,		{'dvo'},	dovoc,		novoc	; vocabulary
zz	crea 1,		{'dva'},	pdovar,		novoc	; pfax'ed value
zz	crea 1,		{'ekm'},	erkmsg,		novoc	; uninitiated error message
zz	crea 1,		{'esm'},	ersmsg,		novoc	; signed error no., message
kk	crea 1,		{'eud'},	erudot,		novoc	; unsigned error no., message
zz	crea 1,		{'eum'},	erumsg,		novoc	; 4th message
kk	crea 1,		{'eus'},	erustg,		novoc	; send a text
zz	crea 1,		{'fga'},	fga,		novoc	; {alias} forget-handler
ho	crea 1,		{'fgl'},	fgl,		novoc	; forget> runtime code
ho	crea 1,		{'[fn'},	pfnamep,	novoc	; [fname] runtime code
ho	crea 1|imed,	{'(i1'},	dointeger,	novoc	; {integer} runtime
ho	crea 1|imed,	{'(i2'},	dointeger2,	novoc	; {2integer} runtime
ho	crea 1|imed,	{'(i4'},	dointeger4,	novoc	; {4integer} runtime
zz	crea 1,		{'[kb'},	bkbdt,		novoc	; { kbd' name } xec name w. stdin from console
zz	crea 1,		{'kb]'},	kbdtb,		novoc	; { kbd' name } xec name w. stdin from console
ay	crea 1,		{';lv'},	dolocr,		novoc	; free local space
ay	crea 1,		{'la:'},	doloca,		novoc	; allocate local values' memory
ay	crea 1,		{'l!!'},	dolxsto,	novoc	; xchg 2 locals
ay	crea 1,		{'lv>'},	dolocc,		novoc	; cpl ref to local value
ay	crea 1,		{'lz:'},	dolocz,		novoc	; zero-init a local value
ay	crea 1,		{'lv:'},	doloci,		novoc	; init a local value
;-,'-
ay	crea 1,		{'lv@'},	dolocv,		novoc	; fetch interpreting defined locv.
zz	crea 1,		{'n.i'},	nimp,		novoc	; 'not implemented' in kernel
zz	crea 1,		{'ndf'},	ndferd,		novoc	; undef'd deferred word error
zz	crea 1,		{'sgt'},	rsigt,		novoc	; messaging/lib4th active signal hnd
zz	crea 1,		{'sgb'},	rsigb,		novoc	; exitting signals hnd
ho	crea 1,		{'srd'},	psortedp,	novoc	; by {sorted} compiled runtime
kk	crea 1,		{'wzo'},	writezo,	novoc	; send asciz-string
; forth utility words
uu	crea 0,		{'quick'},	quick,		utility	; sort datafield
uu	crea 0,		{'sort'},	sort,		utility	; tag sort array
uu	crea ihed,	{'sorted'},	sorted,		utility	; tag sort array by relation name
;>; pfax words, vari & values:
;	crea flags, nfa:name, pfa:ini-xec, wl:wordlist, pd:ptr to disp
;	[ .. | lfa | nfa .. | pfa-$ | pd:disp | data... ]
;	-re- above, "Kernel Variables & Values"
cc	crea pfax|varf|2,{'defer-lk'},	pdovar,	hidden,	dferlk	; base link of deferred words
dferlk: nxvari
	dd 0	; linkage initiated w/ 1st {is} or {deferred?}
uu	crea pfax|varf|4,{'fav'},	pdodefer,hidden,allvh	; {find}-mode, internal to {help}
allvh: nxvari 3
	dd Iallfind,Iallfind
uu	crea pfax|varf|4,{'(selected)'},pdodefer,utility,pselectedp; { .xx. -- .xx. ) {words} selection
pselectedp: nxvari 3
	dd Inoop,Inoop
uu	crea pfax|varf|4,{'[selected]'},pdodefer,utility,bselectedb; { .xx. n lfa -- .xx. n lfa ) {words}
bselectedb: nxvari 3
	dd Inoop,Inoop
uu	crea pfax|varf|4,{'precedes'},	pdodefer,utility,precedes; { x1 x2 -- f ) {sort} relation
precedes: nxvari 3
	dd Indferd,Indferd
mx	crea pfax|varf|4,{'d@'},	pdodefer,utility,dfetch	; ( p -- n ) deferred {@}
dfetch: nxvari 3
	dd Ifetch,Ifetch
mx	crea pfax|varf|4,{'d!'},	pdodefer,utility,dstore	; ( n p -- ) deferred {!}
dstore: nxvari 3
	dd Istore,Istore
mx	crea pfax|varf|3,{'d!!'},	pdodefer,utility,dxsto	; ( p1 p2 -- ) deferred {!!}
dxsto: nxvari 3
	dd Ixsto,Ixsto
xx	crea pfax|varf|4,{'(alarm)'},	pdodefer,linux,	palarmp	; SIGALRM redirection, dft { .s }
palarmp: nxvari 3
	dd Idotsi,Idotsi
;-?-;dfdtlk: dd 0; linkage will be initiated w/ 1st {is} or {deferred?}
fa	crea pfax|varf|2,{'(f8lib)'},	pdoval,	utility,pf8libp	; ptr to default support library dir
pf8libp: nxvari
	dd libf8dt-Y
fa	crea pfax|varf|2,{'(f8doc)'},	pdoval,	utility,pf8docp	; ptr to default documentation dir
pf8docp: nxvari
	dd docf8t-Y
fa	crea pfax|varf|2,{'(f8gls)'},	pdoval,	utility,pf8glsp	; ptr to default filename for {help}
pf8glsp: nxvari
	dd f8glst-Y
cc	crea pfax|varf|2,{'forget-lk'},	pdovar,	hidden,	forgetlk; base link of specific forget actions
forgetlk: nxvari
	dd 0
mx	crea pfax|varf|2,{'n-top'},	pdovar,	bignum,	ntop	; memtop for bignum to stg conversion
ntop: nxvari
	dd 0	; got to be initiated!
; {value}s
fa	crea pfax|varf|2,{'in-chan'},	pdoval,	root,	incn	; channel number of input channel
incn: nxvari
	dd stdin
fa	crea pfax|varf|2,{'out-chan'},	pdoval,	root,	outcn	; channel number of output channel
outcn: nxvari
	dd stdout
fa	crea pfax|varf|2,{'err-chan'},	pdoval,	root,	errcn	; channel number of error channel
errcn: nxvari
	dd stderr
fa	crea pfax|varf|2,{'prt-chan'},	pdoval,	linux,	prtcn	; no. of printer channel
prtcn: nxvari
	dd prtch
fb	crea pfax|varf|2,{'scr-chan'},	pdoval,	forth,	scrcn	; no. of screenfile channel
scrcn:nxvari
	dd scr1ch
fa	crea pfax|varf|2,{'work-chan'},	pdoval,	linux,	workcn	; default {work} channel no.
workcn: nxvari
	dd workch
xx	crea pfax|varf|3,{'wdw-lk'},	pdovar,	hidden,	wdwlk	; double linkage of window defn's
wdwlk: nxvari 2
	dd 0,0
; arguments ptr's list: args to shell, command-buf, terminator
uu	crea pfax|varf|5,{'sh-argp'},	pdovar,	systm,	sha	; shell command arguments ptr's
sharg: nxvari 4
	dd 0,0,0,0
uu	crea 0,		{'sh|'},	shp,		root	; xec shell cmd, pipe output to buf
uu	crea 0,		{'sh'},		sh,		root	; xec a shell command
;>; cpu opr's which are not in a Forth system description
;[list -];[nolist]
bb	crea 0,		{'bsf'},	bsff,		forth	; bit scan forward
bz	crea 0,		{'bsfm'},	bsfm,		forth	; {bsf} memory
bz	crea 0,		{'bsfr'},	bsfr,		forth	; {bsf} register
bb	crea 0,		{'bsr'},	bsrf,		forth	; bit scan reverse
bz	crea 0,		{'bsrm'},	bsrm,		forth	; {bsr} memory
bz	crea 0,		{'bsrr'},	bsrr,		forth	; {bsr} register
bz	crea 0,		{'bswap'},	bbswap,		forth	; swap bytes of a dword
bb	crea 0,		{'cplb'},	cplb,		forth	; complement bit
bz	crea 0,		{'cpuid'},	cpuidf,		systm	; cpu queries
bz	crea 0,		{'emms'},	emmsf,		forth	; clr cpu mmx/fp state
ss	crea 0,		{'pack'},	pack,		forth	; byte to packed nib
yy	crea nopt,	{'pop4th'},	pop4th,		systm	; (R regs -- ) rst saved cpu-regs -re- {push4th}
yy	crea nopt,	{'push4th'},	push4th,	systm	; (R -- regs ) save cpu regs used by L4 kernel
bb	crea 0,		{'resb'},	resb4,		forth	; reset (clear) bit
bb	crea 0,		{'setb'},	setb4,		forth	; set bit
bb	crea 0,		{'tstb'},	tstb,		forth	; test bit
ss	crea 0,		{'unpack'},	unpack,		forth	; packed nib to byte
;>; runtimes
;>; system cons
da	crea 0,		{'?null'},	qnull,		forth	; tf if 4th ptr is zero true address
ww	crea 0,		{'cell'},	pfour,		forth	; count of bytes per cell
;>; double cons
ax	crea 0,		{'-1.'},	dmone,		forth	; dcons -1
ax	crea 0,		{'-0.'},	dmzero,		forth	; dcons "-ve zero", only sign-bit set
ax	crea 0,		{'0.'},		dzero,		forth	; dcons zero
;>; cons
eo	crea 0,		{'(hichar)'},	phicharp,	hidden	; upper case char codes
eo	crea 0,		{'(lochar)'},	plocharp,	hidden	; upper case char codes
ax	crea 0,		{'-0'},		mzero,		forth	; cons $80000000
ax	crea 0,		{'bl'},		bbl,		forth	; cons 32
ax	crea 0,		{'false'},	zero,		forth	; cons 0
mg	crea 0,		{'on'},		on,		forth	; sto -1 to ptr
mg	crea 0,		{'off'},	off,		forth	; sto 0 to ptr	
ax	crea 0,		{'true'},	pone,		fig	; cons 1
ax	crea 0,		{'true'},	true,		forth	; cons -1
;>; environmental queries, non-present features handled by {environment?}, need not be listed
da	crea 0,		{'LIB4TH'},	l4e,		environment; flag, "lib4th" present
da	crea 0,		{'ADDRESS-UNIT-BITS'},aub,	environment; consecutive bits per address unit
da	crea 0,		{'/COUNTED-STRING'},scstg,	environment; max. length of a counted string
da	crea 0,		{'DATASTACK-SIZE'},dss,		environment; cells available for data-stack
da	crea 0,		{'FLOORED'},	floored,	environment; flag whether defaul div is 'floored'
da	crea 0,		{'/HOLD'},	shold,		environment; size of numeric stg conversion buffer
da	crea 0,		{'MAX-CHAR'},	mxc,		environment; highest character code
da	crea 0,		{'MAX-D'},	mxd,		environment; greatest signed double integer value
da	crea 0,		{'MAX-FLOAT'},	mxflt,		environment; greatest floating pt. integral value
da	crea 0,		{'MAX-N'},	mxn,		environment; greatest signed single integer value
da	crea 0,		{'MAX-U'},	mxu,		environment; greatest unsigned single integer value
da	crea 0,		{'MAX-UD'},	mxud,		environment; greatest unsigned double integer value
da	crea 0,		{'/PAD'},	spad,		environment; size of {pad} buffer
da	crea 0,		{'RETURNSTACK-CELLS'},rsc,	environment; cells available for return-stack
da	crea 0,		{'STACK-CELLS'},sss,		environment; cells available for data-stack
da	crea 0,		{'CORE'},	acore,		environment; wordset availabilty flag
da	crea 0,		{'CORE-EXT'},	acorex,		environment; wordset availabilty flag
da	crea 0,		{'BLOCK'},	bcore,		environment; wordset availabilty flag
da	crea 0,		{'BLOCK-EXT'},	bcorex,		environment; all w/o {THRU}
da	crea 0,		{'DOUBLE'},	dcore,		environment; wordset availabilty flag
da	crea 0,		{'DOUBLE-EXT'},	dcorex,		environment; wordset availabilty flag
da	crea 0,		{'EXCEPTION'},	xcore,		environment; (untested, hi-level substitutes available)
da	crea 0,		{'EXCEPTION-EXT'},xcorex,	environment; wordset availabilty flag
da	crea 0,		{'FACILITY'},	ccore,		environment; wordset availabilty flag
da	crea 0,		{'FACILITY-EXT'},ccorex,	environment; wordset availabilty flag
da	crea 0,		{'FLOATING'},	flting,		environment; wordset availabilty flag
da	crea 0,		{'FLOATING-EXT'},fltingx,	environment; wordset availabilty flag
da	crea 0,		{'FILE'},	fcore,		environment; wordset availabilty flag
da	crea 0,		{'FILE-EXT'},	fcorex,		environment; wordset availabilty flag
da	crea 0,		{'#LOCALS'},	nlocals,	environment; cells available for local data
da	crea 0,		{'LOCALS'},	lcore,		environment; wordset availabilty flag
da	crea 0,		{'LOCALS-EXT'},	lcorex,		environment; wordset availabilty flag
da	crea 0,		{'MEMORY-ALLOC'},mcore,		environment; RESIZE restricted to top alloc. block
da	crea 0,		{'MEMORY-ALLOC-EXT'},mcorex,	environment; n.i.
da	crea 0,		{'TOOLS'},	tcore,		environment; wordset availabilty flag
da	crea 0,		{'TOOLS-EXT'},	tcorex,		environment; wordset availabilty flag
da	crea 0,		{'SEARCH-ORDER'},score,		environment; wordset availabilty flag
da	crea 0,		{'SEARCH-ORDER-EXT'},scorex,	environment; wordset availabilty flag
da	crea 0,		{'STRING'},	gcore,		environment; wordset availabilty flag
da	crea 0,		{'ENVIRONMENT?'},envirq,	root	; ( p u -- .xx. f ) ans-4th environment query
;>; system, forth etc.
yy	crea 0,		{'--'},		slsl,		root	; active initial args terminator, no-op
yy	crea 0,		{'.cpu'},	dotcpu,		forth	; display cpu type
hv	crea 0,		{'[abort]'},	babortb,	hidden	; deferred {abort} dft
ww	crea pfax|varf|4,{'abort'},	pdodefer,root,	cabort	; deferred {abort}
cabort: nxvari 3
	dd Ibabortb,Ibabortb
uu	crea 0,		{'hv'},		hvstack,	root	; {help} mode modifier
ww	crea 0,		{'beep'},	beep,		forth	; controllable noise..
yy	crea ixec,	{'bye'},	bye,		root	; xit program w. 0 err code
yy	crea 0,		{'bye-r'},	byer,		linux	; xit program with code n
ww	crea 0,		{'error'},	errorf,		root	; send message# n, partially re-initiate
yy	acrea 0,	{'f8ini'},	f8ini,		systm	; evluate F8INI env vari
kk	crea 0,		{'getref'},	getrefb,	systm	; restore kernel reference
uu	crea imed,	{'help'},	help,		root	; help-text from glossary
kk	crea 0,		{'kmessage'},	kmessage,	hidden	; send message txt to STDOUT, uninitated
yy	crea 0,		{'lib4th'},	lib4th,		root	; display l4 cpl date
ww	crea 0,		{'quit'},	quit,		root	; outer interpreter, exit from loadfiles
yy	crea 0,		{'real-user'},	ruser,		root	; set process effective to real user id
kk	crea 0,		{'sigmsg'},	sigmsg,		linux	; send messgae, leave msg-no. at nos
yy	crea 0,		{'term'},	eterm,		linux	; TERM env vari
bz	crea 0,		{'tick'},	tic,		root	; get current cpu clock count
cc	crea 0,		{'tick>s'},	tic2s,		forth	; convert cpu clock count to seconds
yy	crea 0,		{'vers'},	vers,		root	; 4 bytes numeric library version
kk	crea 0,		{'version'},	version,	root	; display l4-version
;>; assembler
pa	crea 0,		{'<call>'},	lcallg,		assembler; x86 op-code
pa	crea 0,		{'<nop>'},	lnopg,		assembler; x86 op-code
pa	crea 0,		{'<ret>'},	lretg,		assembler; x86 op-code
;>; word-header flags
oo	crea 0,		{'cmac'},	hcmac,		compiler; h-flg, enable macroes cpl
oo	crea 0,		{'imed'},	himed,		compiler; h-flg, xec immediately
oo	crea 0,		{'ixec'},	hixec,		compiler; h-flg, xec always
oo	crea 0,		{'pfax'},	hpfax,		compiler; h-flg, pc-rel xec vector @pfa, data-field(s) follow
oo	crea 0,		{'nopt'},	hnopt,		compiler; h-flg, non-optimizing
oo	crea 0,		{'smud'},	hsmud,		compiler; h-flg, sumudged ("find" disabled)
oo	crea 0,		{'inif'},	hinif,		compiler; h-flg, init from header fields at system startup
oo	crea 0,		{'varf'},	hvarf,		compiler; h-flg, vari, 2nd header-field disp to dataspace
oo	crea 0,		{'vocf'},	hvocf,		compiler; h-flg, word is a vocabulary
oo	crea 0,		{'wcas'},	hwcas,		compiler; h-flg, search letter-case dependently, only
oo	crea 0,		{'xwfl'},	hxwfl,		compiler; h-flg, count of parameter fields, no-exec flag
;>; compiler special
oo	crea imed,	{'asciz'},	hasciz,		compiler; cpl next stg in asciz-mode
oo	crea 0,		{'call-by-disp?'},cbdispq,	forth	; query cpl mode
oo	crea imed,	{'call-by-disp'},cbdisp,	compiler; cpl relative calls by disp
oo	crea imed,	{'call-by-uot'},cbuot,		compiler; cpl indirect call by address in uot
oo	crea imed,	{'cmc?'},	cmcq,		compiler; state of optimizing token counter
oo	crea imed,	{'cpl'},	cpl,		hidden	; make compiled code permanent
oo	crea imed,	{'cpl;'},	csemis,		hidden	; terminate permanent code compilation
oo	crea imed,	{'end-macro'},	cendmacro,	compiler; terminate macro code-expansion cpl
oo	crea 0,		{'imed?'},	imedq,		compiler; tf if word (by lfa) is immediate
oo	crea imed,	{'mac-disp'},	macdisp,	compiler; ( ix -- n ) +n disp xec to start of macro code
oo	crea imed,	{'mac-size'},	macsize,	compiler; ( ix -- n ) no. of bytes cpl'd in macro mode
oo	crea imed,	{'macro'},	cmacro,		compiler; begin macro code-expansion cpl
;>; nonmmx voc., mmx substitutes
mu	crea 0,		{'2@!'},	twofstof,	nonmmx	; copy double
mu	crea 0,		{'2!!'},	twoxstof,	nonmmx	; xchg doubles
ss	crea 0,		{'2lshift'},	dlshiftf,	nonmmx	; 2lshift
ss	crea 0,		{'2rot'},	rot2f,		nonmmx	; 2rot
ss	crea 0,		{'2rotd'},	rotd2f,		nonmmx	; 2rot 2drop, duplicate 3rd on tos
ss	crea 0,		{'2rshift'},	drshiftf,	nonmmx	; 2rshift
ss	crea 0,		{'2rshifta'},	drshiftaf,	nonmmx	; 2rshifta
ss	crea 0,		{'2sdup'},	twosdupf,	nonmmx	; 2swap 2dup
ss	crea 0,		{'2sover'},	twosoverf,	nonmmx	; 2swap 2over
ss	crea 0,		{'2srot'},	srot2f,		nonmmx	; 2swap 2rot
ss	crea 0,		{'3dup'},	dup3f,		nonmmx	; dup 2over rot
mq	crea 0,		{'4!!'},	qxstof,		nonmmx	; xchg quad
ss	crea 0,		{'4-rot'},	mrot4f,		nonmmx	; -2 4roll
ss	crea 0,		{'4dup'},	dup4f,		nonmmx	; 4dup
ss	crea 0,		{'4over'},	over4f,		nonmmx	; 4over
ss	crea 0,		{'4rot'},	rot4f,		nonmmx	; 2 4roll
ss	crea 0,		{'4rotd'},	rot4df,		nonmmx	; 2 4roll 4drop
ss	crea 0,		{'4sdrop'},	sdrop4f,	nonmmx	; 4swap 4drop
ss	crea 0,		{'4sover'},	sover4f,	nonmmx	; 4swap 4over
ss	crea 0,		{'4swap'},	swap4f,		nonmmx	; 4swap
ss	crea 0,		{'8dup'},	dup8f,		nonmmx	; 4over 4over = 8 ndup
ss	crea 0,		{'8over'},	over8f,		nonmmx	; ( o1 o2 -- o1 o2 o1 )
ss	crea 0,		{'8sover'},	sover8f,	nonmmx	; ( o1 o2 -- o2 o1 o2 )
ss	crea 0,		{'8sdrop'},	sdrop8f,	nonmmx	; ( o1 o2 -- o2 )
bz	crea 0,		{'femms'},	femmsf,		nonmmx	; clr fp & mmx state, sync cpu
ss	crea 0,		{'rotd2s'},	rotd2sf,	nonmmx	; 2 pick -rot, duplicate 3rd on tos
ad	crea 0,		{'udsqrt'},	fudsqrt,	nonmmx	; +ve double square root of double, sing 'j'-flag
;>; user reg. storage
mx	crea 0,		{'<top>'},	utop,		hidden	; top address of user-vari space - don't read,store!
;	crea varf|2,	{'(eax)'},	ueax,		hidden	; initial register storage
;eax:	nxvari; :test:->:ok:
;	dd Iueax
hv	crea 0,		{'(eax)'},	ueax,		hidden	; initial reg storage
hv	crea 0,		{'(ecx)'},	uecx,		hidden	; initial reg storage
hv	crea 0,		{'(edx)'},	uedx,		hidden	; initial reg storage
hv	crea 0,		{'(ebx)'},	uebx,		hidden	; initial reg storage
hv	crea 0,		{'(ebp)'},	uebp,		hidden	; initial reg storage
hv	crea 0,		{'(esi)'},	uesi,		hidden	; initial reg storage
hv	crea 0,		{'(edi)'},	uedi,		hidden	; initial reg storage
hv	crea 0,		{'(esp)'},	uesp,		hidden	; initial reg storage
mx	crea 0,		{'(bot)'},	mbot,		hidden	; base job true addr of .bss bottom
mx	crea 0,		{'(sstop)'},	sstop,		hidden	; base job true addr of .bss top
mx	crea 0,		{'(top)'},	mtop,		hidden	; global true addr of .bss top
;>; job control
yy	crea 0,		{'[pause]'},	bpauseb,	systm	; dft {pause}
xx	crea 0,		{'(sys)'},	psysp,		linux	; find syscall-no. by name
xx	crea imed,	{'[sys]'},	bsysb,		linux	; execute syscall by namestring
bz	crea 0,		{'?ms'},	qms,		ans	; time in milli-seconds since host startup
yy	crea 0,		{'4th-id'},	fthid,		root	; initial job-id
xx	crea 0,		{'alarm'},	calarm,		forth	; send alarm signal after given time in seconds
zz	crea 0,		{'alcjob'},	allocjob,	linux	; -/-
yy	crea 0,		{'cstg'},	cstg,		linux	; control strings by indices
xx	crea 0,		{'envstg'},	envstg,		linux	; env vari by no.
xx	crea 0,		{'argstg'},	argstg,		linux	; prog args by no.
xx	crea 0,		{'getenv'},	gtenv,		linux	; env vari by strg
kk	crea 0,		{'getgot'},	getgot,		linux	; ptr to lib's ELF global offset table
xx	crea 0,		{'gid@'},	gidf,		linux	; fetch process group id
xx	crea 0,		{'gid!'},	gids,		linux	; set process group id
xx	crea 0,		{'mprotect'},	mprot,		linux	; memory access permissions
yy	crea 0,		{'mtlock'},	mtlock,		systm	; lock int's for block opr, enable ports access
yy	crea 0,		{'mtunlock'},	mtunlock,	systm	; un-lock int's, disable ports access
yy	crea 0,		{'ms'},		ms,		forth	; halt caller for given time in milliseconds
xx	crea 0,		{'pid@'},	pidf,		linux	; fetch own process id
ax	crea 0,		{'page-size'},	pagesize,	linux	; Linux kernel constant
yy	crea 0,		{'pause'},	cpause,		system	; enable re-scheduling of jobs from @(pause)
xx	crea 0,		{'prot-r'},	protr,		linux	; bitmask to disabling read-protection
xx	crea 0,		{'prot-w'},	protw,		linux	; bitmask to disabling write-protection
xx	crea 0,		{'prot-x'},	protx,		linux	; bitmask to disabling xec-protection
yy	crea 0,		{'set-cal'},	setcal,		hidden	; calibrate timer, find cpu clock rate
ax	crea 0,		{'sighnd-size'},sighsz,		linux	; size of a signal hnd definition block
yy	crea 0,		{'signo'},	signo,		linux	; convert signal name to number
da	crea 0,		{'signo?'},	signoq,		linux	; display known signal names
yy	crea 0,		{'sigstg'},	sigs,		linux	; convert signal number to name
xx	crea 0,		{'sleep-n'},	nsleep,		linux	; halt caller for given time in nano- and seconds
xx	crea 0,		{'sleep-m'},	sleepm,		linux	; halt caller for given time in microseconds
xx	crea 0,		{'sleep'},	sleeps,		linux	; halt caller for given time in seconds
yy	crea ihed,	{'sys'},	sys,		linux	; execute syscall by name
zz	crea 0,		{'ucopy'},	usercopy,	hidden	; copy user-vari from owner to cloned job
xx	crea 0,		{'uid@'},	uidf,		linux	; fetch process user id
xx	crea 0,		{'uid!'},	uids,		linux	; set process user id
xx	crea 0,		{'syscall'},	scall,		linux	; system call by number
xx	crea 0,		{'syskill'},	syskill,	linux	; send signal 
yy	crea nopt,	{'xlock'},	xlock,		systm	; exec word w. int's locked
;>; i/o resources & control
fa	crea 0,		{'lxfiles'},	lxfiles,	linux	; host definitions source-files
fa	crea 0,		{'lxpath'},	lxpath,		linux	; path to host definitions source
xx	crea 0,		{'fcntl'},	cfcntl,		linux	; syscall, files acces &c
xx	crea 0,		{'ioctl'},	cioctl,		linux	; syscall, limited i/o ports range
xx	crea 0,		{'iomode'},	iomode,		linux	; check and (re)set i/o-channel flags
pp	crea 0,		{'ioperm'},	sysioperm,	linux	; syscall, i/o permissions, interrupts
pp	crea 0,		{'iopl'},	sysiopl,	linux	; set i/o priority (root user, only)
ft	crea 0,		{'otty'},	otty,		linux	; open stdin at tty
pp	crea 0,		{'p@'},		pf,		linux	; fetch 32bit item from port
pp	crea 0,		{'p@s'},	pfs,		linux	; fetch multiple 32bit items from port
pp	crea 0,		{'p!'},		ps,		linux	; store 32bit item to port
pp	crea 0,		{'p!s'},	pss,		linux	; store multiple 32bit items to port
pp	crea 0,		{'pc@'},	pcf,		linux	; fetch 8bit item from port
pp	crea 0,		{'pc@s'},	pcfs,		linux	; fetch multiple 8bit items from port
pp	crea 0,		{'pc!'},	pcs,		linux	; store 8bit item to port
pp	crea 0,		{'pc!s'},	pcss,		linux	; store multiple 8bit items to port
pp	crea 0,		{'pw@'},	pwf,		linux	; fetch 16bit item from port
pp	crea 0,		{'pw@s'},	pwfs,		linux	; fetch multiple 16bit items from port
pp	crea 0,		{'pw!'},	pws,		linux	; store 16bit item to port
pp	crea 0,		{'pw!s'},	pwss,		linux	; store multiple 16bit items to port
ft	crea 0,		{'rstty'},	rstty,		linux	; reset stdin-console to initial state
ft	crea 0,		{'setty'},	setty,		linux	; prepare stdin console to single-key input
ft	crea 0,		{'stty-s'},	sttys,		linux	; simulates Linux cmd 'stty sane'
fa	crea 0,		{'wait4ch'},	wait4ch,	linux	; sys_select for any channel's input timeout
fa	crea 0,		{'wait4fd'},	wait4fd,	linux	; sys_select for any fd input timeout
fa	crea 0,		{'wait4in'},	wait4in,	linux	; sys_select for console stdin timeout
ft	crea 0,		{'wait4kbd'},	wait4kbd,	linux	; sys_select for keyboard stdin timeout
fa	crea 0,		{'wait4ti'},	wait4ti,	linux	; sys_select for any channel's timeout
fa	crea imed,	{"wait4'"},	wait4t,		linux	; xec by name w/ temp. timeout
fa	crea 0,		{'wait4x'},	wait4x,		linux	; xec by xt w/ temp. timeout
;>; memory, special
mm	crea 0,		{'?resize'},	qresizem,	forth	; allocate if required for -re- {allot}
mm	crea 0,		{'allocate'},	allocatem,	forth	; allocate data-space, extends into .bss section
mm	crea 0,		{'free'},	freem,		forth	; link mem back to .bss section
ax	crea 0,		{'heaphead-size'},hpheads,	linux	; size of a heap/device description header
mm	crea 0,		{'resize'},	resizem,	forth	; alloc/link back, w/o loss of data (as possible)
mm	crea 0,		{'top-mblock'},	topmblock,	forth	; allocate data-space, extends into .bss section
;>; local memory
hv	crea 0,		{'(locb)'},	locb,		hidden	; uvari, bytecount
hv	crea 0,		{'(locn)'},	locn,		hidden	; uvari, items per defn count
ay	crea 0,		{'(LOCAL)'},	plocalp,	ans	; local wordheader by supplied stg
ay	crea 0,		{'>loc'},	toloc,		forth	; de-/allocation
ay	crea ihed,	{'loc!!'},	locxsto,	local	; exchange two local values
ay	crea ihed,	{'loc2!'},	loc2s,		local	; sto double local; sing -re- {to}
ay	crea ihed,	{'loc2@'},	loc2f,		local	; fetch double local; sing by name
ay	crea 0,		{'locrmv'},	locrmv,		compiler; intermediate local values de-allocation
uu	crea 0,		{'[locdef]'},	blocdefb,	hidden	; [_] also [_] local definitions
ay	crea imed,	{'local:'},	locol,		hidden	; def. a local alterable constant
ay	crea imed,	{'locref{'},	locref,		forth	; define locals referring list
ay	crea imed,	{'locals|'},	locbar,		forth	; cpl initiated locals list
ay	crea imed,	{'{'},		loccb,		forth	; cpl locals list, un-/initiated & comment
;n.i.:
; {mem} voc for unrestricted access to memory
; {forth} providing protected storage, only, which cannot modify the uot, etc...
;>; error handling
ii	crea 0,		{'?comp'},	qcomp,		forth	; abort if not in permanently compiling state
ii	crea 0,		{'?csp'},	qcsp,		forth	; abort if data-stack out of balance
ii	crea 0,		{'?depth'},	qdepth,		forth	; abort if unsufficient data on stack
ii	crea 0,		{'?error'},	qerror,		forth	; abort if flag indicates an error
ii	crea 0,		{'?exec'},	qexec,		forth	; abort if not in execution of a word
ii	crea 0,		{'?pairs'},	qpairs,		forth	; abort if stacked compile-flags dont match
ii	crea 0,		{'?prog'},	qprog,		forth	; abort if ptr not in program or kernel space
ii	crea 0,		{'?stack'},	qstack,		forth	; abort if data-stack out of bounds
zz	crea 0,		{'[CATCH]'},	bcatchb,	ans	; -/-
zz	crea 0,		{'[THROW]'},	bthrowb,	ans	; -/-
yy	crea 0,		{'data?'},	dataq,		hidden	; tf if ptr points to data space
yy	crea 0,		{'depth?'},	depthq,		forth	; tf if sufficient data on stack
yy	crea 0,		{'kernel?'},	kernelq,	hidden	; tf if ptr points to kernel space
yy	crea 0,		{'kprog?'},	kprogq,		hidden	; tf if ptr points to kernel or program space
ay	crea 0,		{'locals?'},	localsq,	forth	; tf if suffient no. of local cells available
yy	crea 0,		{'prog?'},	progq,		hidden	; tf if ptr points to program space
yy	crea 0,		{'static?'},	staticq,	systm	; tf if prog statically linked
yy	crea 0,		{'udisp?'},	udispq,		forth	; ( n -- n f ) uot disp range check
yy	crea 0,		{'xec?'},	xecq,		forth	; ( n -- a f ) xec-addr from ix/ptr
;>; conditional xec
ic	crea ihed,	{'defined'},	defined,	forth	; immediate tf if name found
ic	crea ihed,	{'if-found'},	iffound,	root	; discard till eol if name not found
ic	crea ihed,	{'if-nfound'},	ifnfound,	root	; discard till eol if name found
ic	crea ihed,	{'if-true'},	iftrue,		root	; discard till eol if false flag
ic	acrea ihed,	{'[FALSE]'},	zero,		ans	; immediate cons 0
ic	crea ihed,	{'[0=]'},	izeq,		ans	; immediate flag inversion, {0=}
ic	acrea ihed,	{'[DEFINED]'},	defined,	ans	; re {defined}
ic	crea ihed,	{'[ELSE]'},	belseb,		root	; read input until [then] if flag to [if] was false
ic	crea ihed,	{'[IF]'},	bifb,		root	; read input until [else], discard till [then]
ic	crea ihed,	{'[THEN]'},	bthenb,		root	; terminate conditional input sequence [if]...
ic	acrea ihed,	{'[TRUE]'},	true,		ans	; immediate cons -1
;>; forth tools
cc	crea 0,		{'>time&date'},	totida,		forth	; cnv dn date to time&date format
uu	crea 0,		{'#dcm'},	hdcm,		tools	; decompile at given ptr
uu	crea 0,		{'#see'},	hsee,		tools	; continue decompiling at @fld
ch	crea 0,		{'"day'},	sday4,		forth	; stg w/ day of system time
ch	crea 0,		{'"date'},	sdate4,		forth	; stg w/ system date
ch	crea 0,		{'"time'},	stime4,		forth	; stg w/ time
ch	crea 0,		{'"time&date'},	stimedate,	forth	; stg w/ full size system date
uu	crea ihed,	{'[rs]'},	dotrsi,		tools	; immediate {.rs}, displaying returnstack
uu	crea ihed,	{'[s]'},	dotsi,		tools	; immediate {.s}, displaying datastack
uu	crea 0,		{'.rs'},	dotrs,		tools	; display returnstack content
uu	crea 0,		{'.s'},		dots,		forth	; dispay datastack content
cd	crea 0,		{'.time&date'},	dotimedate,	forth	; display full size system date
uu	crea 0,		{'adump'},	adump,		tools	; dump from true address
uu	crea 0,		{'all-find'},	allfind,	tools	; {find} trough all vocabularies
uu	crea 0,		{'all-words'},	allwords,	tools	; {vlist} all vocabularies
uu	crea 0,		{'bdump'},	bdump,		tools	; dump next, towards preceding addresses
cc	crea 0,		{'date'},	date4,		forth	; system time in seconds
cc	crea 0,		{'day'},	day4,		forth	; day of system time
ch	crea 0,		{'daystg'},	daystg,		forth	; convert day no. to text
uu	crea 0,		{'dump'},	dump,		forth	; dump memory at ptr
uu	crea 0,		{'dumpa'},	dumpa,		tools	; dump at ptr, display true addr.
cc	crea 0,		{'errno'},	erno,		forth	; cnv error name to number
da	crea 0,		{'errno?'},	ernoq,		forth	; display known error names
cc	crea 0,		{'errstg'},	errs,		forth	; cnv err number to name
yy	crea 0,		{'message'},	message,	forth	; display system message
yy	crea 0,		{'msgstg'},	msgstg,		forth	; fetch system message stg
uu	crea 0,		{'ndump'},	ndump,		tools	; dump next, towards ascending addr.
uu	crea 0,		{'rdump'},	rdump,		tools	; dump again, same range
uu	crea 0,		{'s'},		nsee,		tools	; 8 times {#see}
uu	crea 0,		{'see'},	see,		forth	; de-compiler
uu	crea 0,		{'tdump'},	tdump,		tools	; dump, don't store ptrs
yy	crea 0,		{'time'},	time4,		forth	; syscall gettimeofday
cc	crea 0,		{'time&date'},	timedate,	forth	; time & date in standard format
uu	crea 0,		{'vlist'},	vlist,		forth	; sequentially list context vocabulary
yy	acrea 0,	{'wait'},	sleeps,		forth	; wait given no. of seconds
uu	crea 0,		{'words'},	words,		forth	; sorted list context vocabulary
;>; search order, vocabularies, word header flags
vv	crea imed,	{'also'},	also,		root	; push vocs in search order one posn up
yy	crea 0,		{'casedep'},	casedep,	compiler; set latest word to case-dependent find mode
vv	crea 0,		{'definitions'},definitions,	root	; @current to ocurrent, @context to current
vv	crea 0,		{'forth-wordlist'},forthwl,	root	; wid of {forth}
vv	crea 0,		{'get-current'},gcurrent,	root	; @current
vv	crea 0,		{'GET-ORDER'},	gorder,		ans	; content + count of voc-stack
vv	crea 0,		{'get-vocflags'},gvocflags,	hidden	; fetch vocabulary-specific flags at voc-stack
vv	crea 0,		{'get-vocs'},	getvocs,	root	; fetch all wid-s + count from voc-stack
oo	crea 0,		{'immediate'},	immediate,	root	; set latest word to immediately executing
oo	crea ihed,	{'no-opt'},	noopt,		root	; modify latest to not substituting end-ret w/ jump
vv	crea imed,	{'only'},	only,		root	; minimal wordset
uu	crea 0,		{'order'},	order,		root	; display vocabulary names as in search order
vv	crea 0,		{'order?'},	orderq,		root	; item no of stacked voc by ix, or -1
vv	crea 0,		{'prevdef'},	prevdef,	root	; restore previous {current}
vv	crea imed,	{'previous'},	previous,	root	; pop and discard context voc fron voc-stack
vv	crea 0,		{'root-wordlist'},rootwl,	hidden	; wid of {root}
vv	crea imed,	{'rvoc'},	rvoc,		root	; restore previous {context}
vv	crea 0,		{'SEARCH-WORDLIST'},swlist,	ans	; find a name in given wordlist
vv	crea 0,		{'set-current'},scurrent,	root	; store wid to {current}
vv	crea 0,		{'set-order'},	sorder,		root	; store entire search order
vv	crea 0,		{'set-vocflags'},svocflags,	hidden	; (re)store vocabulary-specific flags at voc-stack
vv	crea 0,		{'set-vocs'},	setvocs,	root	; (re)store vocabulary ptrs at voc-stack
oo	crea 0,		{'smudge'},	smudge,		fig	; toggle find-ability of latest word
oo	crea 0,		{'unsmudge'},	unsmudge,	root	; enable finding of latest word
og	crea 0,		{'vocabulary'},	vocabulary,	forth	; define a vocabulary by name
uu	crea 0,		{'vocs'},	vocs,		root	; display all def'd voc-names
og	crea 0,		{'wordlist'},	wordlist,	forth	; define a 'wordlist'
vv	crea 0,		{'WORDLIST?'},	wordlq,		ans	; item no of stacked wordlist by wid, or -1
;>; channels
co	crea 0,		{'cdt-flags'},	cdtflags,	linux	; disp of channel flags to channel defn ptr
co	crea 0,		{'cdt-fptr'},	cdtfptr,	linux	; disp of file ptr double cell to cdt ptr
ax	crea 0,		{'cdt-size'},	cdtsize,	linux	; size of channel defn storage
co	crea 0,		{'cdt-xptr'},	cdtxptr,	linux	; disp of channel extn ptr to channel defn ptr
fa	crea 0,		{'ch-cons?'},	chconsq,	linux	; tf if echoing console flag set
fa	crea 0,		{'ch-eof'},	cheof,		linux	; tf if channel at eof
fa	crea 0,		{'ch-flags'},	chflagsf,	linux	; channel flags dword
fa	crea 0,		{'ch-id'},	chid,		linux	; channel identifier
fa	crea 0,		{'ch-name'},	chname,		forth	; a channel's file name
fa	crea 0,		{'ch-omode'},	chomodef,	linux	; channel open mode
fa	crea 0,		{'ch-perm'},	chpermf,	linux	; channel permission bits
fa	crea 0,		{'ch-pty?'},	chptyq,		linux	; tf if pty-device flag set
fa	crea 0,		{'ch-rnum'},	chrnum,		linux	; latest err code
fa	crea 0,		{'channel'},	channel,	forth	; id and i/o-flags
fa	crea 0,		{'chn-num'},	chnnum,		linux	; top chan a copy of which is in supplied ch-id
fa	crea 0,		{'chp'},	chp,		linux	; ptr to channel definition table
fa	crea 0,		{'chp>chan'},	chp2ch,		linux	; get channel no. by chp
ft	crea 0,		{'echo-off'},	echof,		forth	; suppress kbd input echo
ft	crea 0,		{'echo-on'},	echon,		forth	; enable kbd input echo
yy	crea 0,		{'err-id'},	errid,		linux	; channel-id of error channel
fa	crea 0,		{'fd>chan'},	fd2ch,		linux	; sto file descriptor to channel
fa	crea 0,		{'get-chan'},	getchan,	linux	; fetch channel description data
yy	crea 0,		{'in-id'},	inid,		linux	; channel-id of input channel
fa	crea 0,		{'is-chan'},	ischan,		forth	; copy {work}-channel description to supplied
ft	crea imed,	{"kbd'"},	kbdt,		forth	; xec fetched name w. stdin from console
ft	crea 0,		{'kbd-chan'},	kbdchan,	linux	; keyboard channel constant
ft	crea 0,		{'kbd-id'},	kbdid,		linux	; identifier of keyboard channel
fa	crea 0,		{'max-chan'},	maxchan,	linux	; max no. of supplied channel description tables
fa	crea 0,		{'new-chan'},	newchan,	forth	; get next free channel no.
yy	crea 0,		{'out-id'},	outid,		linux	; channel-id of output channel
ft	crea 0,		{'out-pty?'},	outptyq,	linux	; tf if stdout is a pty device
ft	crea 0,		{'pty?'},	ptyq,		linux	; tf if channel is a pty device
fa	crea 0,		{'set-chan'},	setchan,	linux	; store channel description from data-stack
fa	crea 0,		{'source-chan'},sourcechan,	forth	; channel of current input source
fa	crea 0,		{'to-chan'},	tochan,		forth	; copy a channel description
fa	crea 0,		{'work-num'},	worknum,	linux	; actual {work} no.
yy	crea 0,		{'work-id'},	workid,		linux	; work-channel identifier
fa	crea 0,		{'xg-chan'},	xgchan,		linux	; exchange two channel descriptions
fa	crea 0,		{'xg-io'},	xgio,		linux	; exchange stdin and stout channel descriptions
;>; file i/o
fa	crea ihed,	{'[fname]'},	bfnameb,	forth	; find file in F8DIR & PATH, ret path+file-name
hx	crea 0,		{'[source]'},	bsourceb,	hidden	; dft xec vec for {source}
fa	crea 0,		{'a-close'},	aclose,		utility	; close channels 5 till end of table
fa	crea 0,		{'app'},	appf,		linux	; file open modifier, "append"
fa	crea 0,		{'bin'},	binf,		forth	; useless, but ANS required file open modifier
fa	crea imed,	{'cd'},		cdf,		root	; change cwd
fa	crea 0,		{'chdir'},	chdirf,		linux	; change cwd to supplied
fa	crea 0,		{'close-file'},	closef,		forth	; close a file
fa	acrea 0,	{'close-dir'},	closef,		ans	; close a directory-file
fa	crea 0,		{'copy-file'},	copyf,		forth	; directly copy by names one file to another
fa	crea 0,		{'cre'},	cref,		linux	; file open modifier, "create"
fa	crea 0,		{'create-dir'},	cread,		linux	; create directory by supplied name
fa	crea 0,		{'create-file'},creaf,		forth	; overwriting open a file
fa	crea 0,		{'cwd@'},	cwdf,		linux	; get current working directory path-name
fa	crea 0,		{'delete-file'},deletf,		forth	; delete (not erase) a file
fa	crea 0,		{'dir'},	dirf,		linux	; file open modifier, "type directory"
fa	crea imed,	{'f"'},		fqte,		forth	; fname" w/ buffer at pad
fa	crea 0,		{'f-ok'},	fok,		forth	; file access query modifier
fa	crea 0,		{'f8dir'},	f8dir,		forth	; path to installed suppl. lib4th library files
fa	crea 0,		{'f8doc'},	f8doc,		utility	; path to installed documentation files
fa	crea 0,		{'f8glo'},	f8glo,		utility	; name of l4 glossary file
fa	crea 0,		{'f8gls'},	f8gls,		utility	; ( -- p u ) path+name of l4 glossary file
fa	crea 0,		{'faccess'},	faccessfd,	linux	; by channel test file access permissions
fa	crea 0,		{'file>file'},	f2file,		forth	; directly copy between two files
fa	crea 0,		{'file-access'},faccessf,	forth	; by name test file access permissions
fa	crea 0,		{'file-position'},fposf,	forth	; ( n1 -- d2 er ) file-pointer by channel no.
fa	crea 0,		{'file-size'},	fsizef,		forth	; ( n1 -- n2 ) size of file by channel no.
fa	crea 0,		{'file-status'},fstatf,		forth	; file state by supplied name
fa	crea 0,		{'flush-file'},	flushf,		forth	; store cached buffers back to file by channel no.
fa	crea 0,		{'fopen'},	fopenf,		forth	; open file by fetched name
fa	crea imed,	{'fname"'},	fnmqte,		forth	; find file in F8DIR & PATH, ret path+file-name
fa	crea 0,		{'fposre'},	fposre,		linux	; adjust file-ptr relative to current posn
fa	crea 0,		{'fsearch'},	fsearch,	linux	; -re- {search-file}, fast variant useing mmap
fa	crea 0,		{'fstat'},	ffstatf,	linux	; file status by channel no.
ii	crea 0,		{'include-file'},ifile,		forth	; (re dpans94) input from file by channel no.
ii	crea 0,		{'include'},	include,	forth	; input from file by <bl>-enclosed name
ii	crea 0,		{'include"'},	includeqte,	forth	; input from file by <">-terminated name
ii	crea 0,		{'include?'},	includeq,	forth	; {include} if specified word not found
ii	crea 0,		{'included'},	included,	forth	; input from file by supplied name
fa	crea 0,		{'llseek'},	llseekf,	linux	; abs/rel set posn of file-ptr (syscall)
fa	crea 0,		{'lock-file'},	lockf,		linux	; lock file, prevent write access
fa	crea 0,		{'mcreate-dir'},mcread,		linux	; create directory w/ supplied access mode
fa	crea 0,		{'mcreate-file'},mcreaf,	linux	; create file w/ supplied access mode
fa	crea 0,		{'mfopen'},	mfopen,		linux	; open file w/ supplied access mode by fetched stg
fa	crea 0,		{'mmap'},	mmap,		linux	; map a file into memory
fa	crea 0,		{'mopen-file'},	mopenf,		linux	; open file w/ supplied access mode by supplied stg
fa	crea 0,		{'msync'},	msync,		linux	; sync. memory data w/ mapped file
fa	crea 0,		{'munmap'},	munmap,		linux	; detach {mmap}ped file from memory
uu	crea imed,	{'name'},	name,		hidden	; fetch a <bl>-enclosed filename, { bl word count }
fa	crea 0,		{'nbl'},	nblf,		linux	; file access modifier to non-blocking
fa	crea 0,		{'nof'},	noff,		linux	; file access modifier to not following links
fa	crea 0,		{'open-dir'},	opendirf,	linux	; open directory-file by supplied name
fa	crea 0,		{'open-file'},	openf,		forth	; open a file by supplied name
fa	crea 0,		{'path'},	epath,		forth	; PATH env. vari at prog startup time
fa	crea 0,		{'path+file'},	pthfile,	linux	; find file in PATH, ret fully qualified path
fa	crea 0,		{'path-max'},	pathmax,	linux	; max len of path string
oo	crea ixec|nopt,	{'pop-io'},	popio,		forth	; restore i/o from tor
oo	crea ixec|nopt,	{'push-io'},	pushio,		forth	; save i/o to tor, assign local tib
fa	crea 0,		{'pwd'},	pwd,		linux	; ( -- ) print working directory
fa	crea 0,		{'r-ok'},	rok,		forth	; ( -- n ) file access query modifier
fa	crea 0,		{'r/o'},	rbyof,		forth	; ( -- n ) file open mode modifier
fa	crea 0,		{'r/w'},	rbywf,		forth	; ( -- n ) file open mode modifier
fa	crea 0,		{'read-char'},	readchar,	forth	; read a char from channel
fa	crea 0,		{'read-file'},	readf,		forth	; read file until buffer full or <eof>
fa	crea 0,		{'read-line'},	readl,		forth	; read file until <nl> or buffer full or <eof>
fa	crea 0,		{'readlink'},	readlk,		linux	; read a linked files' source name
fa	crea 0,		{'rename-file'},renamf,		forth	; assign new name to a file by names
fa	crea 0,		{'reposition-file'},reposnf,	forth	; set file ptr to supplied posn
fa	crea 0,		{'resize-file'},resizef,	forth	; truncate file at supplied posn
ii	crea 0,		{'restore-input'},restoreinput,	forth	; restore saved input
ii	crea 0,		{'save-input'},	saveinput,	forth	; save input descriptors
fa	crea 0,		{'search-file'},searchf,	forth	; search file fo a string
ax	crea 0,		{'stat-size'},	statsize,	forth	; size in bytes of file-status required buffer
fa	crea 0,		{'syn'},	synf,		linux	; file access modifier to blocking mode
fa	crea 0,		{'trn'},	trnf,		linux	; file access modifier to truncate after open
xx	crea 0,		{'umask'},	umaskf,		linux	; globally set new files default access mode
fa	crea 0,		{'unlock-file'},unlockf,	linux	; unlock file from preventing write access
fa	crea 0,		{'w-ok'},	wok,		forth	; file access query modifier
fa	crea 0,		{'w/o'},	wbyof,		forth	; file open mode modifier
fa	crea 0,		{'w-close'},	wclose,		forth	; close the work-channel
fa	crea 0,		{'write-char'},	writechar,	forth	; write (multi-byte) char to channel
fa	crea 0,		{'WRITE-FILE'},	awritefile,	ans	; write no. of bytes from buffer to file, ans-mode
fa	crea 0,		{'write-file'},	writefile,	forth	; write no. of bytes from buffer to file
fa	crea 0,		{'write-line'},	writeline,	forth	; write send string to file & append <lf> code
fa	crea 0,		{'x-ok'},	xok,		forth	; file access query modifier
;>; blockfile i/o
; cons/val/vari
fa	crea pfax|varf|2,{'block-lk'},	pdovar,	blkfile,blocklk	; base link of screenfile storage blocks
blocklk: nxvari
	dd 0
ax	crea pfax|varf|2,{'bufhead-size'},pdoval,blkfile,bufheadsz; size of a (kernel-)block buffer header
bufheadsz: nxvari
	dd blkbuf_size
ax	crea pfax|varf|2,{'blkhead-size'},pdoval,blkfile,blkheadsz; size of a per screenfile block header
blkheadsz: nxvari
	dd blkhead_size
fa	crea pfax|varf|2,{'[prev]'},	pdoval,	blkfile,bprevb	; ptr to most recently used block buffer
prev:	nxvari
	dd 0
fa	crea pfax|varf|2,{'[use]'},	pdoval,	blkfile,buseb	; ptr to block buffer to use next
use:	nxvari
	dd 0
fa	crea pfax|varf|2,{'[first]'},	pdoval,	blkfile,bfirstb	; bot. of 1st block buffer, 0 if unassigned
first:	nxvari
	dd 0
fa	crea pfax|varf|2,{'[limit]'},	pdoval,	blkfile,blimitb	; top+1 of last block buffer, 0 if unassigned
limit:	nxvari
	dd 0
eo	crea pfax|varf|2,{'#lmg'},	pdoval,	editor,	hlmg	; editor screen & printing, left margin
hlmg: nxvari
	dd 04
eo	crea pfax|varf|2,{'#rmg'},	pdoval,	editor,	hrmg	; editor screen & printing, right margin
hrmg: nxvari
	dd 06
eo	crea pfax|varf|2,{'#pcol'},	pdoval,	editor,	hcol	; text to file, chars/line
hcol: nxvari
	dd 080
eo	crea pfax|varf|2,{'#prow'},	pdoval,	editor,	hlin	; text to file, rows/page
hlin: nxvari
	dd 072
fb	crea pfax|varf|2,{'offset'},	pdoval,	fig,	offset	; block disp by multiple of -re- {b/scr} (1)
offset:	nxvari
	dd 0
eo	crea pfax|varf|2,{'c/scr'},	pdoval,	editor,	cbys	; chars per editor screen (1024)
cbys:	nxvari
	dd b_buf*b_scr
fi	crea pfax|varf|4,{'EDIT'},	pdodefer,root,	edit	; the screenfile editor, dft {[edit]}
edit: nxvari 3
	dd Ibeditb,Ibeditb
fi	crea pfax|varf|4,{'0m'},	pdodefer,hidden,m0	; re-display screenfile listing
m0: nxvari 3
	dd Ibm0b,Ibm0b
fb	crea pfax|varf|4,{'update'},	pdodefer,forth,	updt	; mark buffer to save before re-useage
updt: nxvari 3
	dd Ibupdb,Ibupdb
fb	crea pfax|varf|4,{'-->'},	pdodefer,root,	nxld	; -re- {load} next screen
nxld: nxvari 3
	dd Ibnxldb,Ibnxldb
fb	crea pfax|varf|4,{'load'},	pdodefer,forth,	load	; input from current screenfile, -re- {using}
load: nxvari 3
	dd Ibloadb,Ibloadb
; i/o words
fb	crea imed,	{'[-->]'},	bnxldb,		forth	; dft for {load} or, for immediate xec
hx	crea 0,		{'[0m]'},	bm0b,		hidden	; scr re-listing after {m} dft opr.
hx	crea 0,		{'[block]'},	bblockb,	hidden	; {block} default opr.
hx	crea 0,		{'[buffer]'},	bbufb,		hidden	; {buffer} default opr.
hx	crea 0,		{'[edit]'},	beditb,		editor	; {edit} default opr.
hx	crea imed,	{'[f]'},	bfb,		editor	; -find w/ forth voc preferrence
fb	crea 0,		{'[load]'},	bloadb,		hidden	; dft for deferred -re- {load}
fb	crea 0,		{'[upd]'},	bupdb,		hidden	; dft opr for {update}
fb	crea 0,		{'+buf'},	plusbuf,	fig	; next buffer
fb	crea 0,		{'block'},	block,		forth	; xec.vec
fb	crea 0,		{'buffer'},	buffer,		forth	; xec.vec
eo	crea 0,		{'b/b'},	bbyb,		systm	; bits per byte (8)
fb	crea 0,		{'b/buf'},	bbybuf,		forth	; bytes per buffer-block (1K)
eo	crea 0,		{'b/c'},	bbyc,		editor	; bytes per character (8)
eo	crea 0,		{'b/scr'},	bbyscr,		fig	; buffer blocks per screen(1)
fb	crea 0,		{'blk>lnk'},	blk2lnk,	blkfile	; ptr to buffer-block by block-no.
fb	crea 0,		{'buf>lnk'},	buf2lnk,	blkfile	; ptr to buffer-block by block-buffer ptr.
fb	crea 0,		{'blk>buf'},	blk2buf,	blkfile	; ptr to screenfile buffer by blk#
fb	crea 0,		{'blk>head'},	blk2head,	blkfile	; ptr to header of screenfile block by blk#
fb	crea 0,		{'buf>blk'},	buf2blk,	blkfile	; block no. assigned to a screenfile buffer
fb	crea 0,		{'buf>head'},	buf2head,	blkfile	; ptr to header of screenfile block by ptr
eo	crea 0,		{'c/l'},	cbyl,		fig	; chars per line (64)
fb	crea 0,		{'dr?'},	schq,		blkfile	; whether {scr-chan} is dr0, dr1 or neither one
fb	crea 0,		{'dr0'},	dr0c,		forth	; activate 1st screenfile channel
fb	crea 0,		{'dr1'},	dr1c,		forth	; activate 2nd screenfile channel
eo	crea 0,		{'editting'},	eding,		blkfile	; modify screenfile access to r/w
fb	crea 0,		{'empty-blk'},	emblk,		blkfile	; invalidate a single blockfile buffer
fb	crea 0,		{'empty-buffers'},embufs,	forth	; close scr-chan, make buffers available
zz	crea 1,		{'fgb'},	fgb,		novoc	; screenfile buffer blocks forget handler
fb	crea 0,		{'ibbuf'},	ibbuf,		blkfile	; initiate/install a buffer w/ 4 blocks
fb	crea 0,		{'flush'},	flush,		forth	; save updated blocks (ANS| & "unassign" buffers)
fb	crea 0,		{'first'},	first,		fig	; bot. of 1st block buffer, 0 if unassigned
fb	crea 0,		{'head>blk'},	head2blk,	blkfile	; ptr to buffer by ptr to header
fb	crea 0,		{'head>buf'},	head2buf,	blkfile	; block no. by ptr to header
fb	crea 0,		{'limit'},	limit,		fig	; top+1 of last block buffer, 0 if unassigned
fb	crea 0,		{'list'},	elist,		forth	; list screen
fb	crea 0,		{'lnk>num'},	lnk2num,	blkfile	; buffer block count of buffers
fb	crea 0,		{'lnk>chn'},	lnk2chn,	blkfile	; buffer block owner channel
fb	crea 0,		{'nextbuf'},	nextbuf,	blkfile	; {+buf} wrt by -re- {source-id} used blocks
fb	crea 0,		{'prev'},	prev,		fig	; screenfile blockbuffer currently in use
eo	crea 0,		{'reading'},	rding,		blkfile	; modify screenfile access to r/o
fb	crea 0,		{'ro?'},	roq,		blkfile	; query write protection mode
fb	crea 0,		{'rw!'},	rws,		blkfile	; aequivalent to f.i.g. { 0 r/w }
fb	crea 0,		{'rw@'},	rwf,		blkfile	; aequivalent to f.i.g. { 1 r/w }
fb	crea 0,		{'save-buffers'},sbufs,		forth	; store updated blocks back to file
fb	crea 0,		{'scrfpos'},	scrfpos,	blkfile	; scr-chan file-ptr at scr@+r#@
fb	crea 0,		{'thru'},	thru,		forth	; {load} a range of screens
fb	crea 0,		{'update-off'},	updateoff,	blkfile	; clear screenfile buffer update flag
fb	crea 0,		{'update?'},	updateq,	blkfile	; mark buffer to save before re-useage
fb	crea 0,		{'use'},	use,		fig	; least recently used screenfile blockbuffer
fb	crea 0,		{'using'},	using,		forth	; screenfile for {load} opr.
fb	crea 0,		{'where'},	where,		editor	; -n.i.-
;>; the f.i.g. line ditor
eo	crea 0,		{'(line)'},	plinep,		editor	; fetch line/screen
eo	crea 0,		{'#lag'},	hlag,		editor	; ptr & count after curs
eo	crea 0,		{'#lead'},	hlead,		editor	; ptr & count till curs
eo	crea 0,		{'#locate'},	hlocate,	editor	; line no, curpos
eo	crea 0,		{'.LINE'},	dotline,	editor	; display line/screen
eo	crea 0,		{'-move'},	mmove,		editor	; copy from ptr to line
eo	crea 0,		{'-text'},	mtext,		editor	; find text in stg
eo	crea 0,		{'1line'},	e1line,		editor	; find in curs-line
eo	crea 0,		{'B'},		eB,		editor	; backup by text len in pad
eo	crea 0,		{'C'},		eC,		editor	; indsert text
eo	crea 0,		{'CLEAR'},	clear,		editor	; fill screen w/ blanks
eo	crea 0,		{'COPY'},	copy,		editor	; copy 1st to 2nd screen
eo	crea 0,		{'D'},		eD,		editor	; push line to pad
eo	crea 0,		{'DELETE'},	delete,		editor	; del chars backward
eo	crea 0,		{'E'},		eE,		editor	; blank line
eo	crea 0,		{'F'},		eF,		editor	; find text
eo	crea 0,		{'FIND'},	efind,		editor	; find stg at pad in screen
eo	crea 0,		{'H'},		eH,		editor	; copy line to pad
eo	crea 0,		{'I'},		eI,		editor	; ins line from pad
eo	crea 0,		{'L'},		relist,		editor	; re-list @{scr}
eo	crea 0,		{'L+'},		relip,		editor	; list next @{scr}
eo	crea 0,		{'L-'},		relim,		editor	; list previous @{scr}
eo	crea 0,		{'LINE'},	line,		editor	; ptr to line or abort-16
eo	crea 0,		{'M'},		eM,		editor	; move curs
eo	crea 0,		{'match'},	match,		editor	; search mem for stg
eo	crea 0,		{'max-lw'},	maxlw,		editor	; max stdout line width
eo	crea 0,		{'N'},		eN,		editor	; next find
eo	crea 0,		{'P'},		eP,		editor	; put text to line
eo	crea 0,		{'R'},		eR,		editor	; replace line from pad
eo	crea 0,		{'r#'},		unr,		editor	; uvari, chars count till cursor
fb	crea 0,		{'r#@'},	rnf,		editor	; { r# @ } get cursor count
eo	crea 0,		{'S'},		eSe,		editor	; ins empty line
fb	crea 0,		{'scr@'},	scrf,		editor	; { scr @ } fetch screen no.
fb	crea 0,		{'scr!'},	scrs,		editor	; { scr ! } sto screen no.
eo	crea 0,		{'T'},		eT,		editor	; type and copy line to pad
eo	crea 0,		{'text'},	text,		editor	; fetch by char delimited text to pad
eo	crea 0,		{'TILL'},	till,		editor	; erase till text end
eo	crea 0,		{'TOP'},	etop,		editor	; cursor to top left
eo	crea 0,		{'TRUNCATE'},	truncate,	editor	; set size of screenfile
eo	crea 0,		{'X'},		eX,		editor	; delete text
eo	crea 0,		{'Y'},		eY,		editor	; insert stg
;>; vt specific control :preliminary: names may change, according to terminfo
;>; ctrl codes
ft	crea 0,		{'<bel>'},	lbelg,		vt	; ascii ctrl code
ft	crea 0,		{'<bs>'},	lbsg,		vt	; ascii ctrl code
ft	crea 0,		{'<ht>'},	lhtg,		vt	; ascii ctrl code
ft	crea 0,		{'<lf>'},	llfg,		vt	; ascii ctrl code
ft	crea 0,		{'<vt>'},	lvtg,		vt	; ascii ctrl code
ft	crea 0,		{'<ff>'},	lffg,		vt	; ascii ctrl code
ft	crea 0,		{'<cr>'},	lcrg,		vt	; ascii ctrl code
ft	crea 0,		{'<so>'},	lsog,		vt	; ascii ctrl code
ft	crea 0,		{'<si>'},	lsig,		vt	; ascii ctrl code
ft	crea 0,		{'<can>'},	lcang,		vt	; ascii ctrl code
ft	crea 0,		{'<sub>'},	lsubg,		vt	; ascii ctrl code
ft	crea 0,		{'<esc>'},	lescg,		vt	; ascii ctrl code
ft	crea 0,		{'<del>'},	ldelg,		vt	; ascii ctrl code
ft	crea 0,		{'<csi>'},	lcsig,		vt	; ascii ctrl code
;>; vt terminal control
fv	crea pfax|varf|2,{'vtstate'},	pdoval,		vt,vtstate; colour, fg/bg state of main window
vtstate: nxvari 2
	dd 0,0
fv	crea pfax|varf|2,{'none'},	pdoval,		vt,none	; noop argument
none: nxvari
	dd -1
fv	crea pfax|varf|2,{'black'},	pdoval,		vt,black; colour value
black: nxvari
	dd 0
fv	crea pfax|varf|2,{'red'},	pdoval,		vt,red	; colour value
red: nxvari
	dd 1
fv	crea pfax|varf|2,{'green'},	pdoval,		vt,green; colour value
green: nxvari
	dd 2
fv	crea pfax|varf|2,{'yellow'},	pdoval,		vt,yellow; colour value
yellow: nxvari
	dd 3
fv	crea pfax|varf|2,{'blue'},	pdoval,		vt,blue	; colour value
blue: nxvari
	dd 4
fv	crea pfax|varf|2,{'magenta'},	pdoval,		vt,magenta; colour value
magenta: nxvari
	dd 5
fv	crea pfax|varf|2,{'cyan'},	pdoval,		vt,cyan	; colour value
cyan: nxvari
	dd 6
fv	crea pfax|varf|2,{'white'},	pdoval,		vt,white; colour value
white: nxvari
	dd 7
; -. keep together, in sequence, and name length < 4, {bg}, {fg}, {[p]}, {[i]}
fv	crea pfax|varf|2,{'bg'},	pdoval,		vt,bg	; background assignation
bg: nxvari
	dd 4
fv	crea pfax|varf|2,{'fg'},	pdoval,		vt,fg	; foreground assignation
fg: nxvari
	dd 3
fv	crea pfax|varf|2,{'[p]'},	pdoval,		vt,bpb	; latest {paper} colour
bpb: nxvari
	dd 0
fv	crea pfax|varf|2,{'[i]'},	pdoval,		vt,bib	; latest {ink} colour
bib: nxvari
	dd 0
; -'
ft	crea pfax|varf|2,{'[r]'},	pdoval,		vt,brb	; latest reverse video state
brb: nxvari
	dd 0
ft	crea pfax|varf|2,{'[g0]'},	pdoval,		vt,bg0b	; latest g0 character set selection
bg0b: nxvari
	dd 0
ft	crea pfax|varf|2,{'[g1]'},	pdoval,		vt,bg1b	; latest g1 character set selection
bg1b: nxvari
	dd 0
fv	crea pfax|varf|3,{'me'},	pdo2val,	vt,me	; reset all vt attributes
me: nxvari 2
	dd -1,0
fv	crea pfax|varf|3,{'se'},	pdo2val,	vt,se	; normal intensity
se: nxvari 2
	dd 2,2
fv	crea pfax|varf|3,{'md'},	pdo2val,	vt,md	; bold
md: nxvari 2
	dd -1,1
fv	crea pfax|varf|3,{'so'},	pdo2val,	vt,so	; half-bright
so: nxvari 2
	dd -1,2
fv	crea pfax|varf|3,{'us'},	pdo2val,	vt,us	; underscore
us: nxvari 2
	dd -1,4
fv	crea pfax|varf|3,{'mb'},	pdo2val,	vt,mb	; blink
mb: nxvari 2
	dd -1,5
fv	crea pfax|varf|3,{'mr'},	pdo2val,	vt,mr	; reverse video
mr: nxvari 2
	dd -1,7
fv	crea pfax|varf|3,{'ue'},	pdo2val,	vt,ue	; underline off
ue: nxvari 2
	dd 4,2
ft	crea pfax|varf|3,{'vt0'},	pdo2val,	vt,vt0	; top of console co-ordinates (-1 unset)
vt0: nxvari 2
	dd -1,-1
;fv	crea pfax|varf|2,{'[a]'},	pdoval,		vt,bab	; abs/rel cursor adressing state
;bab: nxvari
;	dd 0
fv	crea 0,		{'@vtp'},	vtfp,		vt	; fetch a vt... decimal parameter
fv	crea 0,		{'!vtp'},	vtsp,		vt	; send a vt... decimal parameter
fv	crea 0,		{'abscur'},	abscur,		vt	; curs addr wrt top left of screen
fv	crea 0,		{'cdn'},	cdn,		vt	; cursor one row down
eo	crea 0,		{'col'},	col,		vt	; get cursor column
fv	crea 0,		{'colour'},	vtcolour,	vt	; console display colour, attr, etc. (ECMA-48)
fv	crea 0,		{'csr'},	csr,		vt	; set scrolling region
fv	crea 0,		{'cur@'},	curf,		vt	; restore cursor posn
fv	crea 0,		{'cur!'},	curs,		vt	; save cursor posn
fv	crea 0,		{'cur+'},	crgt,		vt	; cursor one posn to the right
fv	crea 0,		{'cur-'},	clft,		vt	; cursor one posn to the left
fv	crea 0,		{'cure'},	cure,		vt	; enable cursor 
fv	crea 0,		{'curd'},	curd,		vt	; disable cursor 
fv	crea 0,		{'cup'},	cup,		vt	; cursor one row up
ft	crea 0,		{'del'},	del,		vt	; <bs> and delete chr at cursor posn
ft	crea 0,		{'ff'},		ff,		vt	; form feed, <nl> for console
ft	crea 0,		{'home'},	home,		vt	; cursor to top left
ft	crea 0,		{'ink'},	vtink,		vt	; set foreground colour/vt-mode
ft	crea 0,		{'max-xy'},	maxxy,		vt	; console window size by count of chars
ft	crea 0,		{'g0'},		g0,		vt	; character set
ft	crea 0,		{'g1'},		g1,		vt	; character set
ft	crea 0,		{'max-x'},	maxx,		vt	; max console window width
fv	crea 0,		{'paper'},	vtpaper,	vt	; set background colour/vt-mode
ft	crea 0,		{'max-y'},	maxy,		vt	; max console window height
fv	crea 0,		{'relcur'},	relcur,		vt	; curs addr wrt top left of scrolling region
fv	crea 0,		{'reset-palette'},rstpalette,	vt	; rst console colours assignations from dft
fv	crea 0,		{'rev'},	rev,		vt	; by flag set display to non-/reversed
fv	crea 0,		{'rev-off'},	revoff,		vt	; standard mode display
fv	crea 0,		{'rev-on'},	revon,		vt	; display at inverse video
eo	crea 0,		{'row'},	row,		vt	; get cursor row
fv	crea 0,		{'set-palette'},setpalette,	vt	; assign a colour value
eo	crea 0,		{'to-col'},	tocol,		vt	; set cursor column
eo	crea 0,		{'to-row'},	torow,		vt	; set cursor row
fv	crea 0,		{'vt@state'},	vtf,		vt	; fetch latest saved console state
fv	crea 0,		{'vt!state'},	vts,		vt	; save console state
fv	crea 0,		{'vt?csi'},	wcsi,		vt	; wait for <esc>[ or <csi> vt response
fv	crea 0,		{'vt?esc'},	wesc,		vt	; wait for <esc> response to vt query
;>; common vt control
fi	crea 0,		{'?cr'},	qcr,		forth	; <nl> if no space left in display line
ft	crea 0,		{'?eol'},	qeol,		forth	; tf if display posn grater than window width
ft	crea 0,		{'?vt'},	qvt,		forth	; query terminal type
ft	crea 0,		{'at-xy'},	atxy,		forth	; hor and vert. cursor posn by chars
ft	crea 0,		{'bel'},	bel,		forth	; noise..
ft	crea 0,		{'bs'},		bs,		forth	; backspace, backup cursor by one column
ft	crea 0,		{'cls'},	cls,		forth	; clear console screen & home
ft	crea 0,		{'clsc'},	clsc,		forth	; clear console screen
ft	acrea 0,	{'page'},	ff,		forth	; ff
fv	crea 0,		{'rs'},		rs,		root	; reset console to 'sane' state
ft	crea 0,		{'tab'},	tab,		forth	; emit a <tab> char, adjust @out
eo	crea 0,		{'tab-to'},	tabto,		forth	; set cursor column, not less current posn
ft	crea 0,		{'xy'},		xy,		forth	; fetch cursor posn
;>; runtimes
hh	crea nopt,	{'-branch'},	nzbra,		hidden	; runtime branch if flg =/= 0
ho	crea nopt,	{'+branch'},	plbra,		hidden	; runtime branch if flg not < 0
ho	crea nopt,	{'?=branch'},	neqbra,		hidden	; runtime branch if @nos =/= @tos
ho	crea nopt,	{'?0branch'},	zdupbra,	hidden	; runtime branch if flg = 0, else dup
ho	crea nopt,	{'?1branch'},	nzdb,		hidden	; runtime branch and dup if flg =/= 0
ho	crea nopt,	{'0-branch'},	lebra,		hidden	; runtime branch if flg not > 0
ho	crea nopt,	{'0>branch'},	gtbra,		hidden	; runtime branch if flg > 0
ho	crea nopt,	{'0<branch'},	mibra,		hidden	; runtime branch if flg < 0
ho	crea nopt,	{'0branch'},	zbra,		hidden	; runtime branch if flg = 0
ho	crea nopt,	{'branch'},	branch,		hidden	; runtime branch unconditionally
ho	crea nopt,	{'(.")'},	pdotqtep,	hidden	; runtime display stg
ho	crea nopt,	{'(")'},	pqtep,		hidden	; runtime ptr to stg
ho	crea nopt,	{'(find)'},	pfindp,		hidden	; runtime find in specified vocabulary
ho	crea nopt,	{'(-exit)'},	pdexitp,	hidden	; runtime if tf leave current word
ho	crea nopt,	{'(?do)'},	pqdop,		hidden	; runtime ?do
ho	crea nopt,	{'(do)'},	pdop,		hidden	; runtime {do}
ho	crea nopt,	{'(loop)'},	ploopp,		hidden	; runtime loop
ho	crea nopt,	{'(+loop)'},	pploopp,	hidden	; runtime +loop
ho	crea nopt,	{'(leave)'},	pleavep,	hidden	; runtime leave
ho	crea nopt,	{'(-leave)'},	pmleavep,	hidden	; runtime -leave
ho	crea nopt,	{'(unloop)'},	rdrop2,		hidden	; runtime unloop
ho	crea nopt,	{'(s")'},	psqtep,		hidden	; runtime sliteral
hx	crea 0,		{'[>number]'},	btonumb,	hidden	; dft >number
hx	crea 0,		{'[?error]'},	bqerrb,		hidden	; dft ?error
hx	crea 0,		{'[accept]'},	osaccept,	hidden	; dft accept
hx	crea 0,		{'[ctype]'},	bctypeb,	hidden	; dft non-escaping type
hx	crea 0,		{'[emit]'},	bemitb,		hidden	; dft emit
hx	crea 0,		{'[etype]'},	betypeb,	hidden	; dft escaping type
hx	crea 0,		{'[error]'},	berrb,		hidden	; dft error
hx	crea 0,		{'[eval]'},	bevalb,		hidden	; dft evaluate
hx	crea 0,		{'[ok]'},	bokb,		hidden	; dft ok
hx	crea 0,		{'[squit]'},	bsquitb,	hidden	; dft quit entry after segfault
hx	crea 0,		{'[quit]'},	bquitb,		hidden	; dft quit
hx	creal pfax|varf|4,{'[type]'},	pdodefer,hidden,btypeb	; deferred, string to stdout
btypeb: nxvari 3
	dd Ibetypeb,Ibctypeb
ho	crea nopt,	{'nlit'},	nlit,		hidden	; runtime bliteral
ho	crea nopt,	{'lit'},	lit,		hidden	; runtime literal
ho	crea nopt,	{'dlit'},	dlit,		hidden	; runtime dliteral
ho	crea nopt,	{'flit'},	flit,		hidden	; runtime ANS dliteral
ho	crea nopt,	{'qlit'},	qlit,		hidden	; runtime qliteral
Lpunloopp:equ Lrdrop2
hh	crea nopt,	{'r+'},		rplus,		hidden	; fetch next cell from 2ndary subroutne level
;>; word-header pointers
; some might not be necessary, thus :preliminary:
co	crea 0,		{'dsp>xec'},	dsp2xec,	hidden	; xec ptr from pc-rel ref at ptr
;	ref by uot index
co	crea 0,		{'>body'},	tobody,		root	; ptr to datafield by ix, for CREATEd words
co	crea 0,		{'>data'},	todata,		root	; ptr to datafield by ix, wrt kernel-vari.
co	crea 0,		{'idx>do'},	idx2do,		hidden	; does>-entry per ix
co	crea 0,		{'idx>lfa'},	idx2lfa,	root	; lfa from uot index
co	crea 0,		{'idx>pfa'},	idx2pfa,	hidden	; pfa from uot index
co	crea 0,		{'idx>uds'},	idx2uds,	hidden	; disp to base of uot
co	crea 0,		{'idx>uot'},	idx2uot,	hidden	; ptr to uot entry from index
co	crea 0,		{'idx>wid'},	idx2wid,	hidden	; index to wordlist id
co	crea 0,		{'idx>xec'},	idx2xec,	hidden	; execution ptr from index
; ref by lfa
co	crea 0,		{'ifa>lfa'},	ifa2lfa,	hidden	; ptr to uot index from lfa
co	crea 0,		{'lfa>body'},	lfa2body,	hidden	; ptr to data-"body" from lfa
co	crea 0,		{'lfa>ffa'},	lfa2ffa,	hidden	; ptr to compileflags from lfa
co	crea 0,		{'lfa>head'},	lfa2head,	hidden	; beginning of word-header
co	crea 0,		{'lfa>ifa'},	lfa2ifa,	hidden	; ptr to uot index from lfa
co	crea 0,		{'lfa>idx'},	lfa2idx,	forth	; uot index from lfa
co	crea 0,		{'lfa>mfa'},	lfa2mfa,	hidden	; macro field from lfa
co	crea 0,		{'lfa>nfa'},	lfa2nfa,	hidden	; ptr to name from lfa
co	crea 0,		{'lfa>pfa'},	lfa2pfa,	forth	; ptr to execution ptr from lfa
co	crea 0,		{'lfa>wid'},	lfa2wid,	hidden	; vocabulary linkfield
co	crea 0,		{'lfa>xec'},	lfa2xec,	hidden	; execution ptr from lfa
ay	crea imed,	{'loc-body'},	locbody,	local	; >body wrt local value, ptr to disp wrt @s0 field
ay	crea imed,	{'loc-ptr'},	locptr,		forth	; ptr to local data-space { s0 @ loc-body @ - }
ay	crea imed,	{"loc'"},	loctick,	local	; find a local values xt by supplied name
; reverse ref.
co	crea 0,		{'nfa>lfa'},	nfa2lfa,	hidden	; ptr to linkfield from nfa
co	crea 0,		{'pfa>lfa'},	pfa2lfa,	hidden	; lfa from pfa
co	crea 0,		{'uds>idx'},	uds2idx,	hidden	; index from compiled disp to uot-ptr
co	crea 0,		{'uot>idx'},	uot2idx,	hidden	; index from uot-ptr
co	crea 0,		{'wid>lfa'},	wid2lfa,	hidden	; word-lfa from voc-link posn
co	crea 0,		{'wid>top'},	wid2top,	hidden	; ptr to top header in voc from voc-link posn
co	crea 0,		{'wid>idx'},	wid2idx,	hidden	; wordlist id to index
co	crea 0,		{'xec>idx'},	xec2idx,	hidden	; index from execution ptr
co	crea 0,		{'xec>lfa'},	xec2lfa,	hidden	; ptr to linkfield from execution ptr
co	crea 0,		{'xec>uot'},	xec2uot,	hidden	; ptr to execution ptr in uot from execution ptr
;>; interpreter
yy	crea imed,	{'#!'},		hb,		root	; begin scripting marker, synonym {include}
oo	crea imed,	{'['},		lbrac,		root	; dec cpl nesting level by one, interpret if < 1
oo	crea imed,	{'[['},		llbrac,		compiler; dec cpl nesting level by two, interpret if < 1
hx	crea 0,		{'[debug]'},	bdebugb,	compiler; default (debug) opr 
hx	crea 0,		{'[interpret]'},binterpretb,	compiler; default (interpret) opr
hx	crea 0,		{'[scanvocs]'},	bscanvb,	hidden	; execute vector by xec ptr on all wordlists
hv	crea 0,		{']interpret'},	binter,		compiler; xec (]interpret)
ii	crea 0,		{'-find'},	dfind,		forth	; find a word's lfa by fetched name
oo	crea imed,	{'c['},		clbrac,		root	; dec cpl nesting level by one, interpret if < 1
da	crea 0,		{'caps?'},	capsq,		forth	; tf if text interpreting letter-case dependently
yy	crea 0,		{'empty'},	empty,		forth	; forget all above fence
tt	crea 0,		{'enclose'},	enclose,	fig	; isolate a word from tib -?-
tt	crea 0,		{'enclose'},	enclose4,	forth	; isolate a word from tib -?-
ii	crea ixec|nopt,	{'evaluate'},	evaluate,	forth	; interpret supplied string
ii	crea 0,		{'-execute'},	dexecute,	forth	; execute from uot index if flg =/= 0
ii	crea 0,		{'execute'},	execute,	forth	; execute from uot index
ii	crea 0,		{'find'},	find,		forth	; find by supplied ptr to name
yy	crea 0,		{'forget'},	forget,		forth	; forget name and all newer words
uu	crea 0,		{'id.'},	iddot,		forth	; display a word's name by lfa or ix
yy	crea 0,		{'iforget'},	iforget,	hidden	; forget by ix
ii	crea 0,		{'interpret'},	interpret,	forth	; evaluate input stream
hv	crea 0,		{'interpret['},	interb,		compiler; xec (interpret[)
tt	crea 0,		{'lc-ignore'},	lcignore,	root	; stg comparison in letter case independent mode
tt	acrea 0,	{'LC-IGNORE'},	lcignore,	root	; stg comparison in letter case independent mode
tt	crea 0,		{'lc-depend'},	lcdepend,	forth	; stg comparison in letter case dependent mode
ii	crea 0,		{'lcase@'},	lcasef,		forth	; stg comparison letter case dependency flg
ii	acrea 0,	{'LCASE@'},	lcasef,		forth	; stg comparison letter case dependency flg
yy	crea 0,		{'marker'},	marker,		forth	; save/restore current dictionary ptrs
yy	acrea 0,	{'anew'},	marker,		ans	; {marker}, for 'common useage' compatibility...
tt	crea 0,		{'parse'},	parse,		forth	; isolate input field by (trailing) delimiter
tt	crea 0,		{'parsec'},	parsec,		forth	; parse from supplied string
ii	crea 0,		{'perform'},	perform,	forth	; execute from lfa
ii	crea 0,		{'query'},	query,		forth	; {accept} until <lf>
ii	crea 0,		{'refill'},	refill,		forth	; fill tib from input stream until <eof>
tt	crea 0,		{'rscan'},	rscan,		forth	; reverse scan stg for character
tt	crea 0,		{'rskip'},	rskip,		forth	; reverse skip characters from stg
tt	crea 0,		{'scan'},	scan,		forth	; scan stg for character
ww	crea 0,		{'scanvocs'},	scanvocs,	hidden	; execute a vector by ix on all wordlists
ww	crea 0,		{'scanwlist'},	scanwlist,	hidden	; execute a vector on stacked wordlists
uu	crea ihed,	{'selected'},	selected,	forth	; ccc{ -- ) activate {words} selection
yy	crea 0,		{'sforget'},	sforget,	hidden	; forget by supplied string and top ix
yy	crea 0,		{'ss'},		ss4,		root	; for #!-execution after exec. name
tt	crea 0,		{'skip'},	skip,		forth	; skip characters from stg
yy	crea 0,		{'uc-map'},	uclm,		linux	; map keyboard input to lower chars
yy	crea 0,		{'uc-unmap'},	uclu,		linux	; do not map keyboard input to lower chars
vv	crea 0,		{'wvoc-r'},	wvocr,		tools	; 2ndary vocabulary link by lfa of a word
uu	crea 0,		{'v'},		vau,		root	; display which wordlist a word is in
uu	crea 0,		{'voc.'},	vocdot,		tools	; by lfa display which wordlist a word is in
vv	crea 0,		{'wvoc'},	wvoc,		tools	; vocabulary link by lfa of a word
tt	crea 0,		{'word'},	XWORD,		forth	; fetch text enclosed by supplied char, ret ptr
tt	crea 0,		{'word'},	xword,		fig	; fetch text enclosed by supplied char to {here}
;>; code compiler
oo	crea nopt,	{'-compile'},	mcompile,	forth	; fetch name, xec if interpreting, else compile
oo	crea nopt,	{'-compile,'},	mcompilec,	forth	; xec by index else compile
oo	crea ihed,	{'-exit'},	dexit,		forth	; if tf leave current word
oo	crea 0,		{'1,'},		cpl1,		forth	; compile byte to c-here
oo	crea 0,		{'2,'},		cpl2,		forth	; compile l.s. half sing (2 bytes) to c-here
oo	crea 0,		{'4,'},		cpl4,		forth	; compile sing (4 bytes) to c-here
oo	crea 0,		{']'},		rbrac,		forth	; enter cpl state, inc nesting level by one
oo	crea 0,		{']]'},		rrbrac,		compiler; enter structure compiling state
oo	crea ihed,	{'[,]'},	bcompilecb,	root	; immediately compile from index
oo	crea ihed,	{'exit'},	exitf,		forth	; leave hi-level word, resolve locals
og	crea 0,		{':'},		colon,		forth	; begin a 'colon definition'
og	crea 0,		{':noname'},	noname,		forth	; begin a header-less hi-level word
;-,'-
oo	crea 0,		{'@csp'},	fcsp,		hidden	; restore sp from @csp
oo	crea 0,		{'!csp'},	scsp,		forth	; store sp to csp
os	crea 0,		{'>resolve'},	toresolve,	forth	; resolve forward branch
os	crea 0,		{'ahead'},	ahead,		forth	; prepare forward branch disp
os	crea 0,		{'back'},	back,		forth	; cpl backward disp to {here}
oo	crea 0,		{'c-allot'},	callot,		forth	; code-space & module non-modifyable data
oo	crea 0,		{'calign'},	calign,		forth	; align code-ptr up to next multiple of 4
oo	crea 0,		{'cfalign'},	cfalign,	forth	; align code-ptr up to next multiple of 8
oo	crea imed,	{'cmc-off'},	cmcoff,		root	; disable <call> to <jmp> conversion
oo	crea 0,		{'cnalign'},	cnalign,	forth	; align code-ptr up to next multiple supplied sing
oo	crea nopt,	{'compile'},	compile,	forth	; compile next word
oo	crea 0,		{'compile,'},	compilec,	forth	; compile by supplied ix
oo	crea 0,		{'csp@'},	cspf,		hidden	; fetch stored sp from csp to tos
hh	crea 0,		{'drop;s'},	drops,		hidden	; combined drop and ;s
ii	crea nopt,	{';s'},		semis,		forth	; terminate an execution sequence
os	crea 0,		{'mark'},	mark,		forth	; prepare back reference
;>; data compiler
ot	crea 0,		{','},		comma,		forth	; compile sing (4 bytes) to data-space
ot	crea 0,		{'b,'},		bcomma,		forth	; compile l.s. byte of sing to data-space
ot	crea 0,		{'c,'},		ccomma,		forth	; compile char (1 byte) to data-space
ot	crea 0,		{'w,'},		wcomma,		forth	; compile l.s. half sing (2 bytes) to data-space
ot	crea 0,		{'align'},	xalign,		forth	; align data-ptr up to next multiple of 4
ss	crea 0,		{'aligned'},	aligned,	forth	; align sing up to next multiple of 4
ot	crea 0,		{'allot'},	allot,		forth	; reserve space in data-memory
ay	crea 0,		{'l-allot'},	lallot,		forth	; local data-space
ss	crea 0,		{'naligned'},	naligned,	forth	; align sing up to next multiple of supplied sing
ss	crea 0,		{'paligned'},	palignp,	linux	; page align to next multiple of page size
ss	crea 0,		{'paligned-'},	palignm,	linux	; page align (truncate)
og	crea 0,		{':slist'},	colslist,	forth	; init ref/subst-list for {substitute}
;-,'-
ot	crea 0,		{'slist'},	slists,		forth	; cpl by suppl. char dlm. ref/subst stg
ot	crea 0,		{'slist,'},	slistc,		forth	; cpl ref/subst stg to data-space
ot	crea 0,		{'slist;'},	slistsemi,	forth	; terminate list of ref/subst stg-s
ot	crea 0,		{'slist"'},	slistqte,	forth	; cpl by {"} delimted ref/subst stg
;>; system state queries, compileflags:
ii	crea 0,		{'cpl?'},	cplq,		root	; tf if permanently compiling
;>; {case}:} etc constructs:
zz	crea 1,		{'(ch'},	ccasec,		novoc	; ( -- p ) build named list
zz	crea 1,		{'(da'},	doassoc,	novoc	; ( n1 p -- n2 ) {associative:} runtime
zz	crea 1,		{'(dc'},	docasec,	novoc	; ( ix p -- xx ) {case:} runtime
zz	crea 1,		{'(dd'},	ddi,		novoc	; ( n1 p -- n2 ) {is-default} runtime
zz	crea 1,		{'(di'},	dfi,		novoc	; ( n1 p -- n2 ) {default-is} runtime
zz	crea 1,		{'(dr'},	dorangec,	novoc	; ( n1 p -- n2 ) {range:} runtime
zz	crea 1,		{'(ic'},	doisc,		novoc	; ( n1 n2 ix -- ) {iscase} runtime
zz	crea 1,		{'(is'},	dois,		novoc	; ( n1 p -- n2 ) {is} runtime
;;zz	crea 1,		{'(ac'},	pdoassoc,	novoc	; ( ix p -- xx ) kernel-{associative:} runtime
zz	crea 1,		{'(kc'},	pdocasec,	novoc	; ( ix p -- xx ) kernel-{case:} runtime
;;zz	crea 1,		{'(rc'},	pdorangec,	novoc	; ( ix p -- xx ) kernel-{range:} runtime
ww	crea 0,		{'#case'},	ncase,		forth	; case-list index by which a word was called
og	crea ihed,	{'associative:'},assocc,	forth	; cpl an {associative:} list
;-,'-
ax	crea 0,		{'casehead-size'},caseheadsz,	hidden	; ( -- n ) size in bytes of {case:}-list header
ot	crea 0,		{'cases,'},	casesc,		hidden	; ( -- ) {case:} &c, cpl ix or sing until {;}
og	crea ihed,	{'case:'},	caseco,		forth	; cpl a {case:} list
;-,'-
cc	crea ihed,	{'is-case'},	iscase,		forth	; ccc( n1 n2 -- ) re-define item #n2 to n1
og	crea ihed,	{'range:'},	rangec,		forth	; cpl a {range:} list
;-,'-
;>; compiling -,'-
hx	crea nopt,	{'(code)'},	pcodep,		forth	; terminate colon defn, continue lo-level
ii	crea imed,	{';'},		semi,		forth	; terminate colon defn, clr locals, check
oo	crea ihed,	{'[compile]'},	bcb,		forth	; synonym {postpone}
oo	acrea ihed,	{'[_]'},	bcb,		root	; synonym [compile]/compile/POSTPONE
oo	crea ihed,	{'[CHAR]'},	char,		ans	; compile character value literal
ii	crea ihed,	{'\'},		bslash,		root	; ignore input until <eol>
ii	acrea ihed,	{'\\'},		quit,		root	; ignore input until <eof>
og	crea ihed,	{':forget'},	colforget,	forth	; define a word-specific forget-action
;-,'-
zz	crea ihed,	{'<with'},	ltwith,		forth	; (defn rules inheritage, re idx>do)
ii	crea imed,	{'('},		paren,		root	; in-active comment until next ")"
ii	crea imed,	{'.('},		commentp,	root	; printing comment until next ")"
ii	crea imed,	{'.\'},		dotbslash,	root	; printing comment until <eol>
ho	crea nopt,	{'(;code)'},	pscodep,	assembler; runtime for 'does>'
tt	crea imed,	{'."'},		dotquote,	forth	; display string
ii	crea nopt,	{"'"},		atick,		ans	; fetch xec token ix by name
oo	crea imed,	{"'"},		tick,		forth	; fetch xec token ix by name as a literal
ot	crea imed,	{'"'},		qte,		forth	; cpl stg, ret ptr to stg
pa	crea ihed|ixec,	{';CODE'},	scode,		ans	; terminate colon defn w/o {;s} -untested-
oo	acrea ihed,	{"[']"},	tick,		ans	; cpl xec token ix fetched by name
og	crea imed,	{'+to-stg'},	stgps,		forth	; append to stg value
oo	crea imed,	{'2literal'},	dliteral,	forth	; cpl double literal
oo	crea imed,	{'4literal'},	qliteral,	forth	; cpl quad literal
yy	crea imed,	{'abort"'},	abtqte,		forth	; if tf abort and prnt message
ii	acrea imed,	{'ascii'},	char,		forth	; fetch character value literal
ii	crea imed,	{'big'},	big,		root	; fetch next numeric input as a bignum
ot	crea imed,	{'c"'},		cqte,		forth	; ptr to stg
oo	crea 0,		{'cdepth'},	cdepth,		compiler; depth of compile-stack doubles
oo	acrea nopt,	{'CHAR'},	char,		ans	; cpl character value literal
oo	acrea imed,	{'dliteral'},	dliteral,	forth	; cpl double literal
ii	crea imed,	{'qf'},		double,		root	; next numeric input is quad rational num, double float
oo	crea ihed,	{'does>'},	doesgt,		forth	; begin runtime part of defining word
pa	crea 0,		{'end-code'},	endcode,	assembler; terminate -re- {code} defn
oo	crea imed,	{'2literal'},	adliteral,	ans	; cpl ANS mode (big endian) double literal
os	crea ihed,	{'forget>'},	forgetgt,	forth	; link a word to {forket-lk} chain
oo	crea imed,	{'forget,'},	fgcomma,	forth	; link a word to {forket-lk} chain
oo	crea imed,	{'literal'},	literal,	forth	; cpl single literal
ii	crea imed,	{'o('},		ocommentp,	root	; comment until next ")" if stdout is console
oo	acrea ihed,	{'POSTPONE'},	bcb,		ans	; delay execution
ii	crea imed,	{'quad'},	quad,		root	; fetch next numeric input as a quad integer
ii	crea imed,	{'df'},		ranum,		root	; next numeric input is double rational num, single float
ot	crea imed,	{'s"'},		sqte,		forth	; ptr to 1st cahr of stg and count
ii	crea imed,	{'sf'},		sing,		root	; next numeric input is single rational num
og	crea 0,		{'stg'},	stg4,		forth	; defines a string value
ot	crea imed,	{'string'},	stng,		forth	; cpl by supplied char delimited stg
ot	crea 0,		{'slit,'},	slitc,		forth	; store & allot string to data-space
oo	crea imed,	{'sliteral'},	sliteral,	forth	; cpl supplied stg
ot	crea 0,		{'szlit,'},	szlitc,		forth	; allot & store <nul>-terminated stg in data-space
oo	crea imed,	{'szliteral'},	szliteral,	forth	; cpl supplied <nul>-terminated stg
og	crea imed,	{'to-stg'},	stgs,		forth	; sto new stg value
ot	crea imed,	{'z"'},		zqte,		forth	; <nul>-terminated stg literal
;>; structured
os	crea imed,	{'?case'},	qcase,		forth	; enter true part if @tos = @nos
os	crea imed,	{'?do'},	qdo,		forth	; enter DO-loop if start =/= limit
os	crea imed,	{'+loop'},	ploop,		forth	; LOOP by explicit increment
os	crea imed,	{'-enter'},	mnter,		forth	; conditonally enter BEGIN structure at ENTRY
os	crea imed,	{'-leave'},	dleave,		fig	; LEAVE if @tos =/= 0
os	crea imed,	{'0if'},	nif,		forth	; enter true part if @tos = 0
os	crea imed,	{'again'},	again,		forth	; terminate endless loop after BEGIN
os	crea imed,	{'begin'},	begin,		forth	; begin a repeat/until/again structure
os	crea imed,	{'CASE'},	case,		ans	; begin a CASE decision sequence
os	acrea imed,	{'DEFAULT'},	noop,		ans	; last alternative in CASE sequence - a noop
os	crea imed,	{'do'},		do,		forth	; begin counted loop
os	crea imed,	{'else'},	else,		forth	; enter IF "false" alternative
os	crea imed,	{'else;'},	elses,		forth	; terminate xec before ELSE
os	crea imed,	{'ENDCASE'},	endcase,	ans	; terminate CASE sequence
os	crea imed,	{'endif'},	endif,		forth	; terminate IF/ELSE sequence
os	crea imed,	{'endif;'},	endifs,		forth	; terminate execution path before ENDIF
os	crea imed,	{'ENDOF'},	endof,		ans	; terminate OF-part in CASE sequence
os	crea imed,	{'enter'},	nter,		forth	; jump to after ENTRY in a BEGIN structure
os	crea imed,	{'entry'},	ntry,		forth	; destination after BEGIN from ENTER
os	crea imed,	{'if'},		if,		forth	; begin an IF/ELSE sequence
os	crea imed,	{'leave'},	xleave,		fig	; unconditionally leave DO-loop at next LOOP
os	acrea imed,	{'leave'},	xleave,		forth	; unconditionally leave DO-loop at next LOOP
os	crea imed,	{'loop'},	xloop,		forth	; terminate a DO-loop sequence
os	crea imed,	{'OF'},		of,		ans	; begin true decision part in a CASE sequence
os	crea ihed,	{'recurse'},	recurse,	forth	; call the caller
os	crea imed,	{'repeat'},	repeat,		forth	; terminate BEGIN/WHILE, loop back to BEGIN
os	acrea imed,	{'THEN'},	endif,		ans	; terminate IF/ELSE sequence
os	crea imed,	{'until'},	until,		forth	; REPEAT if @tos = 0 else leave BEGIN structure
os	crea imed|wcas,	{'WHILE'},	whilea,		ans	; if @tos = 0 leave BEGIN structure
os	crea imed,	{'while'},	while,		forth	; if @tos = 0 leave BEGIN structure
os	crea imed,	{'UNLOOP'},	unloop,		ans	; at runtime discard loop control data
;>; defining
mg	crea ihed,	{'+to'},	pltov,		forth	; add @tos to a value
mg	acrea ihed,	{'+>'},		pltov,		ans	; -re- {to} for "pforth" (etc)
og	crea ihed,	{'=:'},		valdef,		forth	; store integer to known or create new {value}
;-,'-
da	crea 0,		{'?deferred'},	qdferd,		forth	; abort if xt is not of a deferred word
og	crea 0,		{'2constant'},	twocons,	forth	; define non-alterable double constant
og	crea 0,		{'4constant'},	qconstant,	forth	; define non-alterable quad constant
og	crea 0,		{'2integer'},	integer2,	forth	; immediately compiled double cons
og	crea 0,		{'4integer'},	integer4,	forth	; immediately compiled quad cons
mg	crea ihed,	{'2to'},	to2,		forth	; store to alterable double cons
og	crea 0,		{'2value'},	value2,		forth	; double alterable 'constant'
og	crea 0,		{'2variable'},	twovari,	forth	; (un)initiated double variable
og	crea 0,		{'4variable'},	qvari,		forth	; (un)initiated quad variable
og	crea 0,		{'alias'},	alias,		tools	; defining a synonymous word
og	crea 0,		{'build'},	build,		hidden	; cpl a linked header name
og	crea nopt,	{'code'},	code,		forth	; begin lo-level word -useless w/ lib4th-
og	crea 0,		{'cons+'},	consp,		forth	; define constant increment
og	crea ixec,	{'constant'},	constant,	forth	; define non-alterable constant
og	crea ixec,	{'create'},	create,		forth	; build a 'variable'-type header
mx	crea ihed,	{'default-is'},	defaultis,	forth	; re-define a deferred word's default action
og	crea 0,		{'defer'},	defer,		forth	; stored true address or ix executing vari
ii	crea 0,		{'deferred?'},	dferdq,		forth	; tf if xt is of a deferred word
og	crea 0,		{'head'},	head,		hidden	; build a word header
og	crea 0,		{'integer'},	integer,	forth	; immediately compiled cons
mx	crea ihed,	{'is'},		is,		forth	; re-define a deferred word
ii	crea 0,		{'is?'},	isq,		forth	; display xec word of a deferred word
mx	crea 0,		{'is@'},	isf,		forth	; dft and xec ix's by ix of a deferred word
og	crea ihed,	{'is-default'},	isdefault,	forth	; reset deferred word to default action
mg	crea ihed,	{'to'},		tov,		forth	; store sing to alterable cons
mg	acrea ihed,	{'->'},		tov,		ans	; -re- {to} for "pforth" (etc)
og	crea 0,		{'val+'},	valp,		forth	; alterable increment
og	crea 0,		{'value'},	value,		forth	; alterable 'constant'
og	crea 0,		{'variable'},	variable,	forth	; uninitiated (set to 0) variable
;>; keybd, formatted i/o
cd	crea 0,		{'%.'},		bindot,		forth	; binary display unsigned sing
cd	crea 0,		{'&.'},		octdot,		forth	; octal display unsigned sing
cd	crea 0,		{'#.'},		decdot,		forth	; decimal display unsigned sing
ax	crea 0,		{'#tib'},	ntib,		forth	; no. of chars fetched to tib
cd	crea 0,		{'$.'},		hexdot,		forth	; sedecimal display unsigned sing
cd	crea 0,		{'?'},		ques,		forth	; display numeric content of cell at ptr
ft	crea 0,		{'?ekey'},	qekey,		forth	; tf if input byte available
fa	crea 0,		{'?input'},	qinput,		forth	; key/char input query by channel
ft	crea 0,		{'?key'},	qkey,		forth	; tf if char available
ft	crea 0,		{'?terminal'},	qterminal,	forth	; basic keyboard input query from stdin
fi	crea 0,		{'-cr'},	dcr,		forth	; if tf send <lf> to stdout
cd	crea 0,		{'.'},		dot,		forth	; display signed sing
cd	crea 0,		{'.r'},		dotr,		forth	; right aligned display signed sing
fi	crea 0,		{'accept'},	vaccept,	forth	; input from stdin, edittable if terminal
tt	crea 0,		{'can?'},	canq,		forth	; test input for <can> sequence
cc	crea 0,		{'cc4th'},	cc4th,		forth	; xec vectored control character 4th actions
ft	crea 0,		{'cons?'},	consq,		forth	; tf if channel is console
fi	crea 0,		{'cr'},		cr,		forth	; send <lf> to stdout
cd	crea 0,		{'d.'},		ddot,		forth	; display signed double
cd	crea 0,		{'d.r'},	ddotr,		forth	; right aligned display signed double
fi	crea 0,		{'edlin'},	edlin,		forth	; {accept}, after 1st <tab> edit text at buffer
fi	crea 0,		{'ekey'},	ekey,		forth	; get input byte
fi	crea 0,		{'ekey?'},	ekeyq,		forth	; test and get input byte and flag
fi	crea 0,		{'emit'},	emit,		forth	; send a char to stdout
fi	crea 0,		{'emit-m'},	emitm,		forth	; multiply send a char to stdout
fi	crea 0,		{'emit?'},	emitq,		forth	; tf if stdout can emit
fi	crea 0,		{'esc?'},	escq,		forth	; tf if key <esc>, wait after <bl> until next
fi	crea 0,		{'expect'},	expect,		forth	; accept max buffer size input, then terminate
ft	crea 0,		{'in-cons?'},	inconsq,	forth	; tf if stdin is console
ft	crea 0,		{'io-cons'},	siocons,	forth	; determine i/o mode
ft	crea 0,		{'io-cons?'},	ioconsq,	forth	; query i/o mode
ft	crea 0,		{'kbd!'},	kbdsto,		forth	; store last kbd char back (if char-buf empty)
ft	crea 0,		{'kbd-emit'},	kbdemit,	forth	; send a char to keyboard
ft	crea 0,		{'kbd-key'},	kbdkey,		forth	; wait until char from keyboard
ft	crea 0,		{'kbd?key'},	kbdqkey,	forth	; w/ zero timeout get a char from keyboard
ft	crea 0,		{'kbd-type'},	kbdtype,	forth	; send a string to keyboard channel
fi	crea 0,		{'key'},	key,		forth	; wait until character input
fi	crea 0,		{'key?'},	keyq,		forth	; tf if input char available
fi	crea 0,		{'key!'},	keysto,		forth	; store last input char back (if char-buf empty)
fi	crea 0,		{'o-cr'},	odcr,		forth	; <lf> if stdout is console
ft	crea 0,		{'out-cons?'},	outconsq,	forth	; tf if stdout is console
fi	crea 0,		{'print'},	print,		forth	; display stg, whether counted or <nul> terminated
cd	crea 0,		{'s#.'},	sdecdot,	forth	; signed #.
ww	crea 0,		{'source'},	source,		forth	; current input source descriptor
tt	crea 0,		{'space'},	space,		forth	; send a blank space
tt	crea 0,		{'spaces'},	spaces,		forth	; multiply send a blank space
fi	crea 0,		{'stdin?'},	stdinq,		forth	; tf if input from console
yy	crea 0,		{'tib'},	tib,		forth	; ptr to terminal input buffer
yy	crea 0,		{'tib>dft'},	tib2dft,	root	; reset t.i.b. to default location
ax	crea 0,		{'tib-dft'},	tibdft,		hidden	; default t.i.b. location
ax	crea 0,		{'tib-max'},	tibmax,		hidden	; storage size of t.i.b.
fi	crea 0,		{'type'},	type,		forth	; send a string
cd	crea 0,		{'u.'},		udot,		forth	; unsigned display a sing
cd	crea 0,		{'u?'},		uques,		forth	; unsigned display numeric content of cell at ptr
cd	crea 0,		{'u.r'},	udotr,		forth	; unsigned right aligned display a sing
cd	crea 0,		{'ud.'},	uddot,		forth	; unsigned display a double
cd	crea 0,		{'ud.r'},	uddotr,		forth	; unsigned right aligned display a double
fi	crea 0,		{'zprint'},	zprint,		forth	; display <nul> terminated stg
;>; text, number conversion
hh	crea 0,		{'(d.r)'},	pddotrp,	hidden	; stg to right aligned display a signed double
hh	crea 0,		{'(ud.r)'},	puddotrp,	hidden	; stg to right aligned display an unsigned double
ch	crea 0,		{'>number'},	tonumber,	forth	; convert stg to number till non-valid char
ch	crea 0,		{'<#'},		ltsharp,	forth	; begin number to stg conversion
ch	crea 0,		{'#>'},		sharpgt,	forth	; terminate number to stg conversion
ch	crea 0,		{'#s'},		sharps,		forth	; convert a double to numeric chars
ch	crea 0,		{'#'},		sharp,		forth	; extract l.s. digit char from a double
tt	crea 0,		{'-trailing'},	mtrailing,	forth	; truncate stg from trailing blanks
tt	crea 0,		{'+blanks'},	pblanks,	forth	; right align a string by blanks
tt	crea 0,		{'/string'},	sstring,	forth	; adjust stg parameters
tt	crea 0,		{'1/string'},	s1string,	forth	; adjust stg parameters by 1
cn	crea 0,		{'a-base'},	abase,		forth	; determine stg to number conversion radix
cn	crea 0,		{'a-number'},	anumber,	ans	; convert stg to number - ANS-mode
tt	crea 0,		{'bslice'},	bslice,		forth	; string slice by byte positions
hh	crea 0,		{'cbytes'},	cbytes4,	hidden	; count of l.s. significant chars/cell
tt	crea 0,		{'compare'},	compare,	forth	; compare two stgs
cn	crea wcas,	{'CONVERT'},	converta,	ans	; convert stg to number - ANS-mode
cn	crea 0,		{'convert'},	convert,	fig	; convert stg to number - f.i.g.-mode
cn	acrea 0,	{'convert'},	converta,	forth	; convert stg to number - ANS-mode
tt	crea 0,		{'csearch'},	csearch,	forth	; search by supplied char delimited stg
tt	crea 0,		{'cslice'},	cslice,		forth	; string slice by chars
ch	crea 0,		{'digit'},	digit,		forth	; convert char to digit + flag
tt	crea 0,		{'e\stg'},	estg,		forth	; convert escaped chars in stg
cc	crea 0,		{'enum?'},	enumq,		forth	; list asciz stgs of enum-list
cc	crea 0,		{'enum#'},	enumn,		forth	; find no. of asciz stg in list
cc	crea 0,		{'enum@'},	enumf,		forth	; find stg by item no. in list
cn	crea 0,		{'f-number'},	fnumber,	fig	; convert stg to double - f.i.g-mode
cn	crea 0,		{'h>a'},	h2a,		forth	; convert char to numeric value
cn	crea 0,		{'hold'},	hold,		forth	; store char to number conversion stg buffer
cn	acrea wcas,	{'NUMBER'},	anumber,	ans	; convert stg to double - ANS-mode
cn	acrea 0,	{'number'},	fnumber,	fig	; convert stg to double - f.i.g-mode
cn	crea 0,		{'number'},	number,		forth	; vectored stg to double conversion
tt	crea 0,		{'printing?'},	printingq,	forth	; tf if entire stg is printing chars
tt	crea 0,		{'replace'},	replace,	forth	; replace text section in a string
tt	acrea 0,	{'s='},		compare,	forth	; compare always case dependently
tt	crea 0,		{'search'},	search,		forth	; search for a string in memory
ch	crea 0,		{'SIGN'},	asign,		forth	; sign cell on tos
ch	crea 0,		{'sign'},	sign,		fig	; fig-variant, sign cell 3rd from tos
tt	crea 0,		{'sslice'},	sslice,		forth	; string slice by enclosing strings
tt	crea 0,		{'substitute'},	substitute,	forth	; substitute text from -re- {:slist}s
cn	crea 0,		{'[number]'},	abnumberb,	forth	; ANS mode stg to number conversion
cn	crea 0,		{'[number]'},	bnumberb,	fig	; f.i.g. mode stg to number conversion
;>; user-vari
hv	crea 0,		{'(#tab)'},	pntabp,		hidden	; tab spacing
hv	crea 0,		{'(#tib)'},	pntibp,		hidden	; #tib storage
hv	crea 0,		{'(>number)'},	utonum,		hidden	; xec. vec >number
hv	crea 0,		{'(?error)'},	uqerror,	hidden	; xec. vec ?error
hv	crea 0,		{'(?terminal)'},uqterminal,	hidden	; xec. vec ?terminal
ii	crea 0,		{'([debug])'},	updebugp,	hidden	; xec. vec, initially zero i.e. a noop
ii	crea 0,		{'(]interpret)'},ubinterpret,	hidden	; xec. vec, initially zero i.e. a noop
hv	crea 0,		{'(tib-max)'},	ptibmaxp,	hidden	; space of tib
hv	crea 0,		{'(accept)'},	uaccept,	hidden	; xec. vec
xx	crea 0,		{'(argc)'},	argc,		hidden	; program's arguments count
xx	crea 0,		{'(argn)'},	argn,		hidden	; 2nd-ary args count
xx	crea 0,		{'(argp)'},	argp,		hidden	; ptr to args to program
xx	crea 0,		{'(aux)'},	pauxp,		hidden	; i/o flags
hv	crea 0,		{'(bits)'},	bbitsb,		hidden	; system flags
hv	crea 0,		{'(block)'},	ublock,		hidden	; xec. vec
hv	crea 0,		{'(bootp)'},	ubootp,		hidden	; ptr to xec's data area
hv	crea 0,		{'(buffer)'},	ubuffer,	hidden	; xec. vec
hv	crea 0,		{'(can)'},	ucan,		hidden	; <can> code
hv	crea 0,		{'(cc4th)'},	icc4th,		hidden	; xec. vec
hv	crea 0,		{'(cmc)'},	ucmc,		hidden	; compiler control counter for back-patching bound
hv	crea 0,		{'(eol)'},	ueol,		hidden	; <eol> code
hv	crea 0,		{'(chans)'},	pchansp,	hidden	; ptr to base of channel description tables
hv	crea 0,		{'(compile)'},	ucompile,	hidden	; xec. vec
hv	crea 0,		{'(dpl)'},	pdplp,		hidden	; i/o flags
hv	crea 0,		{'(emit)'},	uemit,		hidden	; xec. vec
hv	crea 0,		{'(ekey?)'},	uekeyq,		hidden	; xec. vec
hv	crea 0,		{'(eof)'},	peofp,		hidden	; received chars count, zero at eof
hv	crea 0,		{'(error)'},	uerror,		hidden	; xec. vec
fi	crea 0,		{'(escc)'},	uescc,		hidden	; escape symbol for {etype}
hv	crea 0,		{'(eval)'},	ueval,		hidden	; xec. vec
hv	crea 0,		{'(fperm)'},	ufperm,		linux	; default new file access permissions
hv	crea 0,		{'(head)'},	pheadp,		hidden	; cpl head-ptr
hv	crea 0,		{'(hi>lo)'},	uhi2lo,		hidden	; ptr to table of lower case characters
fi	crea 0,		{'(ierr)'},	ierr,		hidden	; input opr. error code
ii	crea 0,		{'(interpret)'},uinterpret,	hidden	; xec. vec
ii	crea 0,		{'(interpret[)'},uinterpretb,	hidden	; xec. vec, initially zero i.e. a noop
fi	crea 0,		{'(inchp)'},	pinchpp,	hidden	; chp of latest used input channel
fi	crea 0,		{'(ioacc)'},	uioacc,		hidden	; received vt.. control chars -n.i.-
fi	crea 0,		{'(iolink)'},	iolink,		hidden	; i/o redirection linkage
oo	crea 0,		{'(lkindex)'},	plkindexp,	hidden	; cpl next u.o.t. index
hv	crea 0,		{'(lo>hi)'},	ulo2hi,		hidden	; ptr to table of upper case characters
hv	crea 0,		{'(m/mod)'},	upmbymp,	hidden	; xec. vec
hv	crea 0,		{'(number)'},	unumber,	hidden	; xec. vec
fi	crea 0,		{'(oerr)'},	oerr,		hidden	; output opr. error code
hv	crea 0,		{'(ok)'},	upokp,		hidden	; xec. vec
fi	crea 0,		{'(outchp)'},	poutchpp,	hidden	; chp of latest used output channel
hv	crea 0,		{'(padsz)'},	padsz,		hidden	; pads' and max+4 input stgs' sizes
hv	crea 0,		{'(path)'},	upath,		hidden	; ptr to PATH env. vari
hv	crea 0,		{'(pause)'},	upause,		hidden	; xec vec after {wait4..} timeout
fi	crea 0,		{'(pchr)'},	pchr,		hidden	; 4 bytes ranges of printing chars
hv	crea 0,		{'(quit)'},	uquit,		hidden	; xec. vec
cd	crea 0,		{'(r)'},	prp,		hidden	; formatted output fill char(s)
hv	crea 0,		{'(scanwl)'},	uscanwl,	hidden	; xec. vec
hv	crea 0,		{'(sighnd)'},	sigh,		linux	; base of signal handlers def.blocks
hv	crea 0,		{'(source)'},	usource,	hidden	; xec.vec of {source}, dft [source]
hv	crea 0,		{'(source-id)'},psourceidp,	hidden	; saved source-id
hv	crea 0,		{'(sp!)'},	ustosp,		hidden	; xec. vec
fi	crea 0,		{'(stimo)'},	ustimo,		hidden	; wait4.. timeout value
hv	crea 0,		{'(tail)'},	ptailp,		hidden	; cpl tail-ptr
fi	crea 0,		{'(tattr)'},	utattr,		hidden	; modified console attributes
fi	crea 0,		{'(tattr-s)'},	ustattr,	hidden	; saved console attributes
fi	crea 0,		{'(tib)'},	ptibp,		hidden	; ptr to terminal input buffer (t.i.b.)
yy	crea 0,		{'(tick)'},	ptickp,		hidden	; cpu-clocks per second
hv	crea 0,		{'(type)'},	utype,		hidden	; xec. vec
yy	crea 0,		{'(ulink)'},	plinkp,		hidden	; uvari link
yy	crea 0,		{'(uot)'},	ultab,		hidden	; "user offset table" 4th words' true xec addr.
mx	crea 0,		{'(vbot)'},	vbot,		hidden	; end of user area
fv	crea 0,		{'(vpal)'},	uvpalette,	hidden	; initial console colours storage
fi	crea 0,		{'(vtim)'},	uiovtim,	hidden	; keyboard input timeout, "VTIME" & "VMAX" values
hv	crea 0,		{'#vocs'},	nvocs,		forth	; max no. of items in voc-stack
ii	crea 0,		{'>in'},	xin,		forth	; parsed terminal input count
yy	crea 0,		{'!fence'},	stofence,	forth	; store current dictionary-ptrs to fence
hh	crea 0,		{'a-heap'},	aheap,		hidden	; allocated heap memory linkage base -n.i.-
aa	crea 0,		{'base'},	base,		forth	; number conversion radix
zz	crea 0,		{'blk'},	blk,		forth	; screenfile block number -n.i.-
mx	crea 0,		{'c0'},		c0,		forth	; ptr to base of code-space
yy	crea 0,		{'c-fence'},	cfence,		forth	; ptr to fenced code-space
yy	crea 0,		{'c-here'},	chere,		forth	; ptr to available code-space
yy	crea 0,		{'c-top'},	ctop,		forth	; ptr to top of available code-space
vv	crea 0,		{'context'},	context,	forth	; 1st wordlist in search order
yy	crea 0,		{'cp'},		cp,		forth	; storage of ptr into code-space
vv	crea 0,		{'current'},	current,	forth	; current defining vocabulary
oo	crea 0,		{'csp'},	csp,		forth	; compiling state saved data-stack ptr
mx	crea 0,		{'d-top'},	dtop,		forth	; ptr to top of available data-space
mx	crea 0,		{'d0'},		d0,		forth	; ptr to base of data-space
ii	crea 0,		{'dp'},		dp,		forth	; ptr to available data-space
aa	crea 0,		{'dpl'},	dpl,		forth	; decimal point location of just converted number
yy	crea 0,		{'fence'},	fence,		forth	; ptr to fenced data-space
yy	crea 0,		{'fence!'},	fences,		forth	; store @tos to fence-ptrs
yy	crea 0,		{'fence@'},	fencef,		forth	; set fence-values from supplied data
mx	crea 0,		{'f-heap'},	fheap,		hidden	; free heap memory linkage base -n.i.-
ww	crea 0,		{'fld'},	ufld,		forth	; user vari in dump, else free
ch	crea 0,		{'hld'},	hld,		forth	; ptr to bot. of used number conversion buffer
ch	crea 0,		{'hld0'},	hld0,		hidden	; initial hld after <#
yy	crea 0,		{'i-fence'},	ifence,		forth	; fenced no. next to rsp u.o.t. index
ii	acrea 0,	{'in'},		xin,		fig	; parsed terminal input count
ft	crea 0,		{'kbd'},	kbdc,		forth	; keyboard input channel no.
vv	crea 0,		{'last'},	lastu,		forth	; global last words nfa in dictionary
vv	crea 0,		{'latest'},	latest,		forth	; last words nfa in {current} voc.
ii	crea 0,		{'lp'},		lp,		local	; local memory running ptr
vv	crea 0,		{'ocurrent'},	ocurrent,	hidden	; previous {current}
vv	crea 0,		{'ocontext'},	ocontext,	hidden	; previous {context}, 2nd in search order
eo	crea 0,		{'out'},	nout,		forth	; count of bytes sent after latest <eol>
rr	crea 0,		{'r0'},		r0,		forth	; ptr to return-stack bottom
eo	crea 0,		{'rows'},	rows,		forth	; count of lines sent after latest {open}
ss	crea 0,		{'s0'},		s0,		forth	; ptr to data-stack bottom
eo	crea 0,		{'scr'},	scr,		forth	; 'screen' no. of current screenfile
ii	crea 0,		{'span'},	span,		forth	; #tib
ii	crea 0,		{'state'},	state,		forth	; compiler/interpreter flags
fi	crea 0,		{'stderr'},	stderrc,	forth	; stderr channel no.
fi	crea 0,		{'stdin'},	stdinc,		forth	; stdin channel no.
fi	crea 0,		{'stdout'},	stdoutc,	forth	; stdout channel no.
yy	crea 0,		{'ti-cal'},	tical,		forth	; measured cpu clock rate
ii	crea 0,		{'up'},		up,		forth	; ptr to next available user vari
vv	crea 0,		{'voc-link'},	voclink,	forth	; wordlists and vocabularies link-ptr
vv	crea 0,		{'width'},	width,		forth	; max count of a 4th name -n.i.-
fi	crea 0,		{'work'},	workc,		forth	; work-channel no. (for file opr's)
;>; uvari & derived
xx	crea 0,		{'argp'},	argpp,		hidden	; ptr to args to program
aa	crea 0,		{'base@'},	basef,		forth	; fetch {base} base value
aa	crea 0,		{'base!'},	bases,		forth	; sto to {base}
eo	crea 0,		{'blk@'},	blkfetch,	forth	; fetch {blk}
aa	crea 0,		{'binary'},	binary,		forth	; store 2 to base
cn	crea 0,		{'cc4cc@'},	cc4thf,		forth	; fetch ctrl char xec vector
cn	crea 0,		{'cc4cc!'},	cc4ths,		forth	; sto ctrl char xec vector
aa	crea 0,		{'decimal'},	decimal,	forth	; sto 10 to base
aa	crea 0,		{'dpl@'},	dplfetch,	forth	; fetch dpl
aa	crea 0,		{'edpl@'},	edplfetch,	forth	; fetch optional num. input exponent value
xx	crea 0,		{'envp'},	envpp,		hidden	; ptr to program's environmental vari
mx	crea 0,		{'here'},	here,		forth	; fetch dp, ptr to data-space
aa	crea 0,		{'hex'},	hex,		forth	; sto 16 to base
ii	crea 0,		{'in@'},	infetch,	forth	; fetch {in}
aa	crea 0,		{'octal'},	octal,		forth	; sto 8 to base
mx	crea 0,		{'pad'},	pad,		forth	; ptr to tmp. buffer in data-space
mx	crea 0,		{'pad2'},	pad2,		forth	; ptr to tmp. string-buffer in data-space
ax	crea 0,		{'pad-size'},	padsize,	forth	; size of tmp. buffers in data-space
rr	crea 0,		{'rp@'},	rpfetch,	forth	; fetch returnstack-ptr
fi	crea 0,		{'source-id'},	sourceid,	forth	; input source flags
ii	crea 0,		{'span@'},	spanf,		forth	; no. of last input chars
ss	crea 0,		{'sp@'},	spfetch,	forth	; fetch datastack-ptr
ii	crea 0,		{'state@'},	statef,		forth	; whether interpreting(0) or compiling(=/= 0)
ii	crea 0,		{'up+'},	upplus,		forth	; add disp to ptr to uservari-space
mx	crea 0,		{'uv@'},	uvfetch,	forth	; fetch uvari by disp
;>; verysillywords
ss	crea 0,		{'NIP'},	sdrop,		ans	; ( n1 n2 -- n2 ) ; swap drop
ss	crea 0,		{'TUCK'},	sover,		ans	; ( n1 n2 -- n2 n1 n2 ) ; swap over
;>; sillywords - for (later..) code-optimization - which not necessarily are always the faster alternatives! i.e. verify...
ll	crea 0,		{'@0='},	zeqf,		forth	; @ 0= ; tf if cell @ptr = zero
ll	crea 0,		{'-0='},	mzeq,		forth	; tf if only sign-bit set
ss	crea 0,		{'-drop'},	mdrop,		forth	; dup 0= -dup 2drop ; discard non-zero @tos
ss	crea 0,		{'-pick'},	mpick,		forth	; ( nn ... n2 n1 m -- nn..n1..n2 ) ; store into stack
ss	crea 0,		{'0drop'},	zdrop,		forth	; -dup drop ; discard zero cell @tos
ss	crea 0,		{'0max'},	zmax,		forth	; 0 max ; not less than 0
ss	crea 0,		{'2-pick'},	mpick2,		forth	; ( dn ... d2 d1 m -- dn..d1..d2 ) ; 2store into stack
ss	crea 0,		{'2-rot'},	mrot2,		forth	; ( d1 d2 d3 -- d3 d1 d2 ) ; 2rot 2rot
rr	crea nopt,	{'r>>r'},	rxchg,		forth	; ( n1 -- n2 )(R n2 -- n1 ) ; r> swap >r
ss	crea 0,		{'2dropd'},	dropd2,		forth	; ( d1 d2 -- d1 d1 ) ; 2drop 2dup
ss	crea 0,		{'2oswap'},	oswap2,		forth	; ( d1 d2 --  d1 d1 d2 ) ; 2over 2swap
rr	crea nopt,	{'2r>>2r'},	r2xchg,		forth	; ( d1 -- d2 )(R d2 -- d1 ) ; 2r> 2swap 2>r
rr	acrea nopt,	{'2rdrop'},	rdrop2,		forth	; (R dn -- ) ; 2r> 2drop
rr	crea nopt,	{'2rswap'},	rswap2,		forth	; (R d1 d2 -- d2 d1 ) ; 2r> 2r> 2swap 2>r 2>r
ss	crea 0,		{'2rotd'},	rotd2,		forth	; ( d1 d2 d3 -- d2 d3 ) ; 2rot 2drop
ss	crea 0,		{'2rots'},	rots2,		forth	; ( d1 d2 d3 -- d3 d2 d1 ) ; 2rot 2swap
ss	crea 0,		{'2sdrop'},	sdrop2,		forth	; ( d1 d2 -- d2 ) ; 2swap 2drop
ss	crea 0,		{'2sdup'},	sdup2,		forth	; ( d1 d2 -- d2 d1 d1 ) ; 2swap 2dup
ss	crea 0,		{'2sover'},	sover2,		forth	; ( d1 d2 -- d2 d1 d2 ) ; 2swap 2over
ss	crea 0,		{'2srot'},	srot2,		forth	; ( d1 d2 d3 -- d3 d2 d1 ) ; 2swap 2rot
ss	crea 0,		{'2third'},	third2,		forth	; ( d1 d2 d3 -- d1 d2 d3 d1 ) ; 2 2pick
ss	crea 0,		{'3drop'},	drop3,		forth	; ( n1 n2 n3 -- ) ; 2drop drop
ss	crea 0,		{'3dup'},	dup3,		forth	; ( d1 n1 -- d1 n1 d1 n1 ) ; dup 2over rot
rr	crea nopt,	{'!r'},		storer,		hidden	; ( p -- )(R n -- ) ; r> swap !
ss	crea 0,		{'?DUP'},	qdup,		ans	; ( n -- n n | 0 ) dup if dup endif ; {-dup}
ss	crea 0,		{'bounds'},	bounds,		forth	; ( n1 n2 -- n1+n2 n1 ) ; over + swap
ss	crea 0,		{'d2dup'},	d2dup,		forth	; ( d -- d d d ) ; 2dup 2dup
ss	crea 0,		{'ddup'},	ddup,		forth	; ( n -- n n n ) ; dup dup
ss	crea 0,		{'dropd'},	dropd,		forth	; ( n1 n2 -- n1 n1 ) ; drop dup
ac	crea 0,		{'2^'},		pow2,		forth	; ( n1 -- d1 ) 2^n sing -> double
bz	crea 0,		{'flg'},	flg,		tools	; ( -- n ) eflags, display w/ -re- {flg>smb}
ch	crea 0,		{'flg>smb'},	flg2smb,	tools	; ( n -- p u )convert eflags bits to symbolic chars
ll	crea 0,		{'l-and'},	land,		forth	; ( n1 n2 -- f ) ; logic AND
ll	crea 0,		{'l-or'},	lor,		forth	; ( n1 n2 -- f ) ; logic OR
aa	crea 0,		{'lg(base)'},	lgbase,		forth	; numerus of log at @base of item @nos
aa	crea 0,		{'lg2'},	lg2,		forth	; numerus of log at base 2 of item @tos
aa	crea 0,		{'log'},	log,		forth	; numerus of log at base @tos of item @nos
aa	crea 0,		{'over+'},	overp,		forth	; over +
aa	crea 0,		{'over-'},	overm,		forth	; over -
ss	crea 0,		{'oswap'},	oswap,		forth	; ( n1 n2 -- n1 n1 n2 ) ; over swap
bd	crea 0,		{'dparity'},	dparity,	forth	; ff if odd no of set bits in a double
bb	crea 0,		{'parity'},	parity,		forth	; ff if odd no of set bits in a sing
ll	crea 0,		{'pow2?'},	pow2q,		forth	; tf if item is a power of 2
rr	crea nopt,	{'rdrop'},	rdrop,		forth	; (R n -- ) ; r> drop
bb	crea 0,		{'rot-l'},	rotl,		forth	; bitwise rotate cell left
bb	crea 0,		{'rot-r'},	rotr,		forth	; bitwise rotate cell right
ss	crea 0,		{'rotd'},	rotd,		forth	; ( n1 n2 n3 -- n2 n3 ) ; rot drop
ss	crea 0,		{'rotd2s'},	rotd2s,		forth	; ( n1 n2 n3 -- n1 n1 n2 n3 ) ; rot dup 2swap
ss	crea 0,		{'rots'},	rots,		forth	; ( n1 n2 n3 -- n2 n1 n3 ) ; rot swap
rr	crea nopt,	{'rswap'},	rswap,		forth	; (R n1 n2 -- n2 n1 ) swap on returnstack
tt	crea 0,		{'s='},		seq,		forth	; -re- {compare}, always case dependently
ss	acrea 0,	{'sdrop'},	sdrop,		forth	; ( n1 n2 -- n2 ) ; swap drop (a 'nip')
ss	crea 0,		{'sdup'},	sdup,		forth	; ( n1 n2 -- n2 n1 n1 ) ; swap dup
ss	acrea 0,	{'sover'},	sover,		forth	; ( n1 n2 -- n2 n1 n2 ) ; swap over (a 'tuck')
ss	crea 0,		{'srot'},	srot,		forth	; ( n1 n2 n3 -- n3 n2 n1 ) ; swap rot
ss	crea 0,		{'swap2s'},	swap2s,		forth	; ( n1 n2 n3 n4 -- n4 n3 n2 n1 ) revert cells order 
ss	crea 0,		{'swap-'},	swsub,		forth	; { swap - } ; reversed cells subtract
ss	crea 0,		{'third'},	third,		forth	; ( n1 n2 n3 -- n1 n2 n3 n1 ) ; 2 pick
%ifdef __RATIONAL
; -- ranum:
vv	cvoc vocf|imed,	{'FLOAT'},	float,		ans	; ans-voc, real numbers
vv	cvoc vocf|imed,	{'rational'},	rational,	root	; root-voc, real numbers
vv	cvoc vocf|imed,	{'hidden'},	rahidden,	rational; rational-voc, support and quad ranum
vv	cvoc vocf|imed,	{'cons'},	racons,		rational; rational-voc, all sizes' constants
; --
ar	crea pfax|varf|2,{'#fd'},	pdoval,	rahidden,fdl	; ranum integral part delimiter, dft=<bl>
fdl: nxvari
	dd 0+' '
ar	crea pfax|varf|2,{'#dp'},	pdoval,	forth,	hdp	; floating pt. fraction marker char, dft=","
hdp: nxvari
	dd 0+','
ar	crea pfax|varf|2,{'#fplaces'},	pdoval,	forth,	hprec	; max no. of {f.} fraction digits, dft=14
hprec: nxvari
	dd 14
ar	crea pfax|varf|2,{'#n!v'},	pdoval,	rahidden,snfv	; max+1 for sing factorial calculations, dft=13
snfv: nxvari
	dd 13
ar	crea pfax|varf|2,{'#digits'},	pdoval,	rational,vdigits; max displayed no. of ranum fractional digits
vdigits: nxvari
	dd 5
ar	crea pfax|varf|2,{'truncation'},pdoval,	rational,vtrunc	; suppress trailing zeroes if non-zero(dft)
vtrunc: nxvari
	dd -1
ar	crea pfax|varf|2,{'#fround'},	pdoval,	rational,vfround; -ve(dft) or no. of f.p. fractional digits
vfround: nxvari
	dd -1
; -- :NOTE: {v...} leading "v"  praeliminary, may be removed after all words ok,
; -- preferred size is double ranum, sing might be eliminated after all doubles ready.
;;ar	crea 0,		{'+v+'},	vpl,		rational; ::: -:test:- ::: ::
ar	crea 0,		{'>double'},	todouble,	rational; convert stg to double number
tt	crea 0,		{'-zeroes'},	mzeroes,	rational; ( p u -- p u' ) trucate trailing zeroes
ar	crea 0,		{'v>dv'},	v2dv,		rational; ( v1 -- dv2 ) expand sing v1 to double dv2
    %ifdef __SRANUM
ar	crea 0,		{'#v'},		sharpv,		rational; ( +v -- 0 0 ) app stg to num output buf, for v.
ar	crea 0,		{'#vf'},	sharpvf,	rational; ( +v -- 0 0 ) app stg to num output buf, for f.
ar	crea 0,		{'1/v'},	vrecip,		rational; ( v1 -- v2 ) abs(1 div by v1)
ar	crea 0,		{'dv>v'},	dv2v,		rational; ( dv -- v ) convert double to sing ranum
ar	crea 0,		{'e^v'},	epowv,		rational; ( v1 -- v2 ) v2 <- e^v1
cd	crea 0,		{'f.'},		vdotf,		rational; ( v -- ) display ranum in floating pt format
cd	crea 0,		{'f.j'},	vdotfj,		rational; ( left right v -- ) justified disp. fp-ranum
av	crea 0,		{'qv>v'},	qv2v,		rational; ( qv -- v ) reduce quad, truncate, ret sing ranum
ar	crea 0,		{'s>v'},	s2v,		rational; ( n -- v ) signed sing to vulgar
ar	crea 0,		{'s>vfactorial'},s2vfac,	rational; ( +n -- v ) factorial of n
ar	crea 0,		{'v+'},		vplus,		rational; ( v1 v2 -- v3 ) sum of v1 and v2.
ar	crea 0,		{'v+-'},	vpm,		rational; ( v1 n -- v2 ) negate if -ve n
ar	crea 0,		{'v-'},		vsub,		rational; ( v1 v2 -- v3 ) v1 minus v2.
ar	crea 0,		{'v*'},		vmul,		rational; ( v1 v2 -- v3 ) product of v1 and v2.
ar	crea 0,		{'v/'},		vby,		rational; ( v1 v2 -- v3 ) quot of v1 divided by v2.
ar	crea 0,		{'v>s'},	v2s,		rational; ( v -- n ) floored, integral component of v.
as	crea 0,		{'v>'},		vgt,		rational; ( v1 v2 -- f ) tf if v1 greater than v2.
as	crea 0,		{'v<'},		vlt,		rational; ( v1 v2 -- f ) tf if v1 less than v2.
ll	crea 0,		{'v='},		veq,		rational; ( v1 v2 -- f ) tf if v1 exactly equal to v2.
ll	crea 0,		{'v~'},		vaeq,		rational; ( v1 v2 -- f ) tf if v1 approximately equal to v2.
ar	crea 0,		{'v.'},		vdot,		rational; ( v -- ) display rational number
ar	crea 0,		{'v.j'},	vdotj,		rational; ( left right v -- ) justified disp. ranum
ar	crea 0,		{'v@'},		vfetch,		rational; ( p -- v ) fetch ranum v from memory at p
ar	crea 0,		{'v!'},		vstore,		rational; ( v p -- ) store ranum v to memory at p
ar	crea 0,		{'v^n'},	vpown,		rational; ( v n -- ) raise ranum to the power of sing
ll	crea 0,		{'v0<'},	vzlt,		rational; ( v -- f ) tf if v negative.
ll	crea 0,		{'v0='},	vzeq,		rational; ( v -- f ) tf if v zero.
ar	crea 0,		{'v1+'},	vonep,		rational; ( v1 -- v2 ) v2 <- v1 + 1
ar	crea 0,		{'v1-'},	vonem,		rational; ( v1 -- v2 ) v2 <- v1 - 1
ar	crea 0,		{'v2*'},	v2mul,		rational; ( v1 -- v2 ) v2 <- v1*2
ar	crea 0,		{'v2/'},	v2div,		rational; ( v1 -- v2 ) v2 <- v1/2
ar	crea 0,		{'vabs'},	vabs,		rational; ( v1 -- v2 ) negate if v1 -ve
ar	crea 0,		{'vfrac'},	vfrac,		rational; ( v1 -- +v2 ) fractional component of v1
ar	crea 0,		{'vm*'},	vmmul,		rational; ( v1 v2 -- dv ) double product of v1 and v2.
ar	crea 0,		{'vmax'},	vmax,		rational; ( v1 v2 -- v3 ) the larger of v1 and v2.
ar	crea 0,		{'vmin'},	vmin,		rational; ( v1 v2 -- v3 ) the smaller of v1 and v2.
ar	crea 0,		{'vnegate'},	vnegate,	rational; ( v1 -- v2 ) v2 = -v1
ar	crea 0,		{'vnormal'},	vnormal,	rational; ( dv -- v ) approximate double to sing ranum
ar	crea 0,		{'voverflow'},	voverflow,	rational; ( v -- f ) tf if v was overflow indicator value
ar	crea 0,		{'vround'},	vround,		rational; ( v1 +n -- v2 ) v2 is an approximation to v1
ar	crea 0,		{'vsgn'},	vsgn,		rational; ( v1 -- -1|0|1 ) unit of v1
ar	crea 0,		{'vsplit'},	vsplit,		rational; ( v1 -- v2 v3 ) {v>s} & {vfrac}
ar	crea 0,		{'vsqrt'},	vsqrt,		rational; ( v1 -- v2 ) square root of a ranum
ar	crea 0,		{'vsimplify'},	vsimplify,	rational; ( v1 +n -- v2 ) v2 is an approximation to v1
; :spaeter: ohne v... (wenn hi-level-vorlage nicht mehr benoetigt)
au	crea 0,		{'v2dup'},	v2dup,		rational; ( v1 v2 -- v1 v2 v1 v2 )
ar	crea 0,		{'v-rot'},	vmrot,		rational; ( v1 v2 v3 -- v3 v1 v2 )
ar	crea 0,		{'vconstant'},	vconstant,	rational; ( -- v ) non-alterable constant
ar	crea 0,		{'vdrop'},	vdrop,		rational; ( v1 -- v1 v1 )
ar	crea 0,		{'vdup'},	vdup,		rational; ( v1 -- v1 v1 )
ar	crea 0,		{'vinteger'},	vinteger,	rational; ( -- v ) constant, alterable before being cpl'd
ar	crea 0,		{'vover'},	vover,		rational; ( v1 v2 -- v1 v2 v1 )
ar	crea imed,	{'vliteral'},	vliteral,	rational; ( v -- | v ) compile/interpret ranum as a dliteral
ar	crea 0,		{'vpick'},	vpick,		rational; ( ... n -- ... vn )
ar	crea 0,		{'vreduce'},	vreduce,	rational; ( v1 -- v2 ) normalize to prime components
ar	crea 0,		{'vrot'},	vrot,		rational; ( v1 v2 v3 -- v2 v3 v1 )
ar	crea 0,		{'vroll'},	vroll,		rational; ( ... n -- ... vn )
ar	crea 0,		{'vswap'},	vswap,		rational; ( v1 v2 -- v2 v1 )
ar	crea 0,		{'vvariable'},	vvariable,	rational; ( -- p ) 'ranum' (i.e. double) variable
; rahidden: (praeliminary, may be removed after all ok)
ar	crea 0,		{'<#v#>'},	ltvgt,		rahidden; ( v -- p u ) convert v to rational num stg
ar	crea 0,		{'<#vf#>'},	ltvfgt,		rahidden; ( v -- p u ) convert v to floating pt num stg
ar	crea 0,		{'>ch'},	gtch,		rahidden; ( p u c -- n ) find 1st occurrence of char c
as	crea 0,		{'small?'},	smallq,		rahidden; ( dv -- f ) tf if "normal"izeable
ar	crea 0,		{'ud>n?'},	ud2nq,		rahidden; ( ud -- +n f ) tf if ud not in range of +ve sing
ar	crea 0,		{'v>uv?'},	v2uvq,		rahidden; ( v -- +v f ) |v| and sign flag
    %endif;__SRANUM
ar	crea 0,		{'dv>udv?'},	dv2udvq,	rahidden; ( dv -- udv flg ) |dv| and sign flag
ar	crea 0,		{'vdigits>'},	vdigitsgt,	rahidden; ( -- un ) largest num w/ no. {digits} digits
; for/next runtimes
ho	crea nopt,	{'(+from)'},	ppfromp,	novoc	; runtime ranum {+FROM}
ho	crea nopt,	{'(for)'},	pforp,		novoc	; runtime ranum {FOR}
ho	crea nopt,	{'(from)'},	pfromp,		novoc	; runtime ranum {FROM}
ho	crea nopt,	{'(next)'},	pnextp,		novoc	; runtime ranum {NEXT}
ho	crea nopt,	{'(step)'},	pstepp,		novoc	; runtime ranum {STEP}
; double ranum (quad),
au	crea 0,		{'#dv'},	sharpdv,	rational; ( +dv -- 0 0 ) app stg to ranum output buf
au	crea 0,		{'#dvf'},	sharpdvf,	rational; ( +dv -- 0 0 ) app stg to float output buf
ii	crea imed,	{'-flt'},	fltq,		root	; false(!) flag if double ranum input mode
au	crea 0,		{'dv^'},	dvpowdv,	rational; ( dv1 dv2 -- dv3 ) double dv1 to the power of dv2
au	crea 0,		{'1/dv'},	dvrecip,	rational; ( dv1 -- dv2 ) abs(1 div by dv1)
au	crea 0,		{'10^dv'},	powdv10,	rational; ( dv1 -- dv2 ) dv1 to the power of ten
au	crea 0,		{'acos(dv)'},	acosdv,		rational; ( dv1 -- dv2 ) arcus cosinus
au	crea 0,		{'asin(dv)'},	asindv,		rational; ( dv1 -- dv2 ) arcus sinus
au	crea 0,		{'atg(dv)'},	atgdv,		rational; ( dv1 -- dv2 ) arcus tg
au	crea 0,		{'cos(dv)'},	cosdv,		rational; ( dv1 -- dv2 ) cosinus
au	crea 0,		{'d>dv'},	d2dv,		rational; ( dn -- dv ) double int signed to double ranum
cc	crea 0,		{'deg>rad'},	deg2rad,	rational; ( dv1 -- dv2 ) convert degrees to radians
au	crea 0,		{'df#.'},	dfdecdot,	rational; ( dv -- ) display ranum in floating pt format, decimal
cd	crea 0,		{'df.'},	dvdotf,		rational; ( dv -- ) display ranum in floating pt format
cd	crea 0,		{'df.j'},	dvdotfj,	rational; ( dv left right -- ) justified disp. fp-ranum
cd	crea 0,		{'dv.'},	dvdot,		rational; ( dv -- ) display rational number
cd	crea 0,		{'dv.j'},	dvdotj,		rational; ( left right dv -- ) justified disp. ranum
au	crea 0,		{'dv+'},	dvplus,		rational; ( dv1 dv2 -- dv3 ) sum
au	crea 0,		{'dv+-'},	dvpm,		rational; ( dv1 n -- dv2 ) negate if -ve n
au	crea 0,		{'dv-'},	dvsub,		rational; ( dv1 dv2 -- dv3 ) diff.
ll	crea 0,		{'dv='},	dveq,		rational; ( dv1 dv2 -- f ) tf if dv1, dv2 exactly equal
ll	crea 0,		{'dv~'},	dvaeq,		rational; ( dv1 dv2 -- f ) tf if dv1, dv2 approximately equal
ll	crea 0,		{'dv<'},	dvlt,		rational; ( dv1 dv2 -- f ) tf if dv1 < dv2
ll	crea 0,		{'dv>'},	dvgt,		rational; ( dv1 dv2 -- f ) tf if dv1 > dv2 
au	crea 0,		{'dv>qv'},	dv2qv,		rational; ( dv1 -- qv2 ) expand double dv1 to quad qv2
ll	crea 0,		{'dv0<'},	dvzlt,		rational; ( dv -- f ) tf if dv is -ve.
ll	crea 0,		{'dv0='},	dvzeq,		rational; ( dv -- f ) tf if dv zero.
au	crea 0,		{'dv1+'},	dvonep,		rational; ( dv1 -- dv2 ) add 1 to dv1
au	crea 0,		{'dv1-'},	dvonem,		rational; ( dv1 -- dv2 ) subtract 1 from dv1
au	crea 0,		{'dv2*'},	dv2mul,		rational; ( dv1 -- dv2 ) dv2 <- dv1*2
au	crea 0,		{'dv2/'},	dv2div,		rational; ( dv1 -- dv2 ) dv2 <- dv1/2
au	crea 0,		{'dv2dup'},	dv2dup,		rational; ( dv1 dv2 -- dv1 dv2 dv1 dv2 )
au	crea 0,		{'dv*'},	dvmul,		rational; ( dv1 dv2 -- dv3 ) double ranum product
au	crea 0,		{'dv-rot'},	dvmrot,		rational; ( dv1 dv2 dv3 -- dv3 dv1 dv2 )
au	crea 0,		{'dv/'},	dvby,		rational; ( dv1 dv2 -- dv3 ) div doubles
au	crea 0,		{'dv>d'},	dv2d,		rational; ( dv -- dn ) dv to floored double int
au	crea 0,		{'dv>dn'},	dv2dn,		rational; ( dv1 -- dn ) dv to signed double int
au	crea 0,		{'dv>floor'},	dv2floor,	rational; ( dv1 -- dv2 ) floored integral value
au	crea 0,		{'dv>int'},	dv2int,		rational; ( dv1 -- dv2 ) signed integral value
cc	crea 0,		{'dv>ieee'},	f2ieee,		rational; ( f1 -- d2 ) dpans 12.6.1.1470 
cc	crea 0,		{'ieee>dv'},	ieee2f,		rational; ( f1 -- d2 ) dpans 12.6.1.1470 
au	crea 0,		{'dv>s'},	dv2n,		rational; ( dv -- dn ) dv to signed sing
au	crea 0,		{'dv@'},	dvfetch,	rational; ( p -- dv ) fetch ranum dv from memory at p
au	crea 0,		{'dv!'},	dvstore,	rational; ( dv p -- ) store ranum dv to memory at p
au	crea 0,		{'dv^s'},	dvpows,		rational; ( dv1 n -- dv2 ) dv1 to the power of a sing
au	crea 0,		{'dvabs'},	dvabs,		rational; ( dv -- |dv| ) negate dv if -ve
au	crea 0,		{'dvcmp'},	dvcmp,		rational; ( dv1 dv2 -- dv1 dv2 n ) signum(dv1-dv2)
au	crea 0,		{'dvconstant'},	dvconstant,	rational; ( -- dv ) non-alterable constant
au	crea 0,		{'dvdepth'},	dvdepth,	rational; number of double ranum sized items on data-stack
au	crea 0,		{'dvdrop'},	dvdrop,		rational; ( dv1 -- dv1 dv1 )
au	crea 0,		{'dvdup'},	dvdup,		rational; ( dv1 -- dv1 dv1 )
au	crea 0,		{'dvfrac'},	dvfrac,		rational; ( dv -- dv ) fractional component of dv
au	crea 0,		{'dvfround'},	dvfround,	rational; ( dv1 -- dv2 ) round for floating point stg
au	crea 0,		{'dvinteger'},	dvinteger,	rational; ( -- dv ) constant, alterable before being cpl'd
au	crea imed,	{'dvliteral'},	dvliteral,	rational; ( dv -- | dv ) compile/interpret ranum as a dliteral
au	crea 0,		{'dvm*'},	dvmmul,		rational; ( dv1 dv2 -- qv3 ) quad ranum product
au	crea 0,		{'dvmax'},	dvmax,		rational; ( dv1 dv2 -- dv3 ) the larger of dv1 and dv2.
au	crea 0,		{'dvmin'},	dvmin,		rational; ( dv1 dv2 -- dv3 ) the smaller of dv1 and dv2.
au	crea 0,		{'dvnegate'},	dvnegate,	rational; ( dv1 -- dv2 ) negate dv1
au	crea 0,		{'dvover'},	dvover,		rational; ( dv1 dv2 -- dv1 dv2 dv1 )
au	crea 0,		{'dvoverflow'},	dvoverflow,	rational; ( dv -- f ) tf if dv was overflow indicator value
au	crea 0,		{'dvpick'},	dvpick,		rational; ( ... n -- ... dvn )
au	crea 0,		{'dvreduce'},	dvreduce,	rational; ( dv1 -- dv2 ) reduce by greatest common divisor
au	crea 0,		{'dvroll'},	dvroll,		rational; ( ... n -- ... dvn )
au	crea 0,		{'dvrot'},	dvrot,		rational; ( dv1 dv2 dv3 -- dv2 dv3 dv1 )
au	crea 0,		{'dvround'},	dvround,	rational; ( dv1 +dn -- dv2 ) approximation to dv1
au	crea 0,		{'dvsimplify'},	dvsimplify,	rational; ( dv1 +dn -- dv2 ) approximation
au	crea 0,		{'dvsqrt'},	dvsqrt,		rational; ( dv1 -- dv2 ) square root of a double ranum
au	crea 0,		{'dvsgn'},	dvsgn,		rational; ( dv -- n ) signum
au	crea 0,		{'dvsplit'},	dvsplit,	rational; ( dv1 -- dv2 dv3 ) integral dv2 and fractional dv3
au	crea 0,		{'dvswap'},	dvswap,		rational; ( dv1 dv2 -- dv2 dv1 )
au	crea 0,		{'dvm/'},	dvmby,		rational; ( dv1 v2 -- dv3 ) div double by sing
au	crea 0,		{'dvvariable'},	dvvariable,	rational; ( -- p ) 'ranum' (i.e. double) variable
au	crea 0,		{'e^dv'},	epowdv,		rational; ( dv1 -- dv2 ) double e to the power of dv1
ii	crea imed,	{'flt'},	fltf,		root	; set numeric input mode to double ranum
au	crea 0,		{'lg(dv)'},	lgdv,		rational; ( dv1 -- dv2 ) double ranum log dec.
au	crea 0,		{'ln(dv)'},	lndv,		rational; ( dv1 -- dv2 ) double ranum log naturalis
ii	crea imed,	{'int'},	intf,		root	; reset from {flt} to integer numeric input mode
cc	crea 0,		{'rad>deg'},	rad2deg,	rational; ( dv1 -- dv2 ) convert radians to (sexagesimal) degrees
ch	crea 0,		{'represent'},	frepresent,	rational; ( dv p u -- n flg1 flg2 ) normal ranum text representation
ar	crea 0,		{'s>dvfactorial'},s2dvfac,	rational; ( +n -- dv ) factorial of n
au	crea 0,		{'s>dv'},	s2dv,		rational; ( n -- dv ) sing int signed to double ranum
au	crea 0,		{'sin(dv)'},	sindv,		rational; ( dv1 -- dv2 ) sinus
au	crea 0,		{'sincos(dv)'},	sincosdv,	rational; ( dv1 -- dv2 dv3 ) sinus dv2, cosinus dv3
au	crea 0,		{'tg(dv)'},	tgdv,		rational; ( dv1 -- dv2 ) tangens
au	crea 0,		{'v>qv'},	v2qv,		rational; ( v1 -- qv2 ) expand sing v1 to quad qv2
; FOR..NEXT loop
np	crea imed,	{'+FROM'},	pfrom,		rational; ( f1 -- ) modify FOR-loop start and limit by displacement
np	crea 0,		{'!IDX'},	sidx,		rational; ( f1 -- ) store FOR-loop index
np	crea 0,		{'!INC'},	sinc,		rational; ( f1 -- ) store FOR-loop increment
np	crea 0,		{'@NX'},	fnx,		rational; ( n -- p ) indext level ptr to FOR-loop ctrl. data
np	crea 0,		{'END'},	fend,		rational; ( -- ) terminate FOR-loop at next NEXT
np	crea imed,	{'FOR'},	for,		rational; ( f1 -- ) begin a FOR .. NEXT loop 
np	crea imed,	{'FROM'},	from,		rational; ( f1 -- ) modify FOT-loop start
np	crea 0,		{'IDX'},	fidx,		rational; ( -- f1 ) innermost level FOR-loop index
np	crea 0,		{'INC'},	fstep,		rational; ( -- f1 ) FOR-loop increment
np	crea 0,		{'LIM'},	flim,		rational; ( -- f1 ) FOR-loop limit
np	crea imed,	{'NEXT'},	next,		rational; ( -- ) terminate a FOR .. NEXT loop 
np	crea 0,		{'NX'},		nx,		rational; ( n -- f1 ) n-th level FOR-loop index
np	crea imed,	{'STEP'},	step,		rational; ( f1 -- ) modify FOR-loop increment
; quad ranum
av	crea 0,		{'s>qv'},	s2qv,		rational; ( n -- qv ) sing int signed to quad ranum
av	crea 0,		{'qv>dv'},	qv2dv,		rational; ( qv -- dv ) reduce quad, truncate, ret double ranum
av	crea 0,		{'stg>qv'},	todfloat,	rational; convert stg to quad ranum, i.e. double 'float'
; rahidden double, support
au	crea 0,		{'<#dv#>'},	ltdvgt,		rahidden; ( dv -- p u ) convert dv to rational num stg
au	crea 0,		{'<#dvf#>'},	ltdvfgt,	rahidden; ( dv -- p u ) convert dv to floating pt num stg
; rahidden quad, words
av	crea 0,		{'>quad'},	toquad,		rahidden; ccc( -- q d f ) convert stg to quad number
av	crea 0,		{'-qvround'},	mqvround,	rahidden; ( qv1 +qn -- qv2 ) approx. qv1 if not in double range
ll	crea 0,		{'?qv0='},	qqvzeq,		rahidden; ( qv -- qv f ) tf if qv is zero.
av	crea 0,		{'1/qv'},	qvrecip,	rahidden; ( dv1 -- dv2 ) abs(1 div by dv1)
av	crea 0,		{'d>qv'},	d2qv,		rahidden; ( dn -- qv ) double int signed to quad ranum
av	crea 0,		{'n>qv'},	n2qv,		rahidden; ( n.N -- qv ) counted int trunc/signed to quad ranum
av	crea 0,		{'atg(qv)'},	atgqv,		rahidden; ( qv1 -- qv2 ) arcus tg
av	crea 0,		{'cos(qv)'},	cosqv,		rahidden; ( qv1 -- qv2 ) cosinus
av	crea 0,		{'dv>uqv'},	dv2uqv,		rahidden; ( dv1 -- qv2 ) unsigned expand double to quad qv2
ar	crea 0,		{'dv>uqv?'},	dv2uqvq,	rahidden; ( dv -- +qv f ) |dv| to quad and sign flag
av	crea 0,		{'e^qv'},	epowqv,		rahidden; ( qv1 -- qv2 ) quad e to the power of qv1
av	crea 0,		{'ln(qv)'},	lnqv,		rational; ( qv1 -- qv2 ) log naturalis
av	crea 0,		{'q>qv'},	q2qv,		rahidden; ( qn -- qv ) quad int signed to quad ranum
cd	crea 0,		{'qf#.'},	qfdecdot,	rahidden; ( qv -- ) display quad ranum in f.p. format, decimal
cd	crea 0,		{'qf.'},	qfdot,		rahidden; ( qv -- ) display quad ranum in f.p. format
cd	crea 0,		{'qf.j'},	qfdotj,		rahidden; ( qv n1 n2 -- ) l/r justified display quad ranum in f.p. format
av	crea 0,		{'qv.'},	qvdot,		rahidden; ( qv -- ) display quad ranum
av	crea 0,		{'qv>d'},	qv2dn,		rahidden; ( qv -- dn ) quad ranum signed to double int
av	crea 0,		{'qv>s'},	qv2n,		rahidden; ( qv -- n ) quad ranum signed to single int
av	crea 0,		{'qv>fq'},	qv2q,		rahidden; ( qv -- qn ) quad ranum floored to quad int
av	crea 0,		{'qv>q'},	qv2qn,		rahidden; ( qv -- qn ) quad ranum signed to quad int
av	crea 0,		{'qv>uqv?'},	qv2uqvq,	rahidden; ( qv -- uqv f ) |qv| and sign flag
av	crea 0,		{'qv*'},	qvmul,		rahidden; ( qv1 qv2 -- qv3 ) multiply quad ranums
av	crea 0,		{'qv/'},	qvdiv,		rahidden; ( qv1 qv2 -- qv3 ) divide quad ranums
av	crea 0,		{'qv+'},	qvplus,		rahidden; ( qv1 qv2 -- qv3 ) add quad ranums
av	crea 0,		{'qv-'},	qvsub,		rahidden; ( qv1 qv2 -- qv3 ) subtract quad ranums
av	crea 0,		{'qv-rot'},	qvmrot,		rahidden; ( qv1 qv2 qv3 -- qv3 qv1 qv2 ) -2 qvroll
ll	crea 0,		{'qv='},	qveq,		rahidden; ( qv1 qv2 -- f ) tf if q1 equal to q2
av	crea 0,		{'qv@'},	qvfetch,	rahidden; ( p -- qv ) fetch ranum qv from memory at p
av	crea 0,		{'qv!'},	qvstore,	rahidden; ( qv p -- ) store ranum qv to memory at p
av	crea 0,		{'qv^'},	qvpowqv,	rahidden; ( qv1 qv2 -- qv3 ) qv1 to the power of qv2
av	crea 0,		{'qv^s'},	qvpows,		rahidden; ( qv1 n -- qv2 ) qv1 to the power of a sing
av	crea 0,		{'qv~'},	qvaeq,		rahidden; ( qv1 qv2 -- f ) tf if q1 approx. equal to q2
av	crea 0,		{'qv1+'},	qvonep,		rahidden; ( qv1 -- qv2 ) add 1 to qv1
av	crea 0,		{'qv1-'},	qvonem,		rahidden; ( qv1 -- qv2 ) subtract 1 from qv1
av	crea 0,		{'qv2/'},	qv2div,		rahidden; ( qv1 -- qv2 ) signed divide by 2
av	crea 0,		{'qv2dup'},	qv2dup,		rahidden; ( qv1 qv2 -- qv1 qv2 qv1 qv2 )
av	crea 0,		{'qvabs'},	qvabs,		rahidden; ( qv1 -- qv2 ) negate if qv1 -ve
av	crea 0,		{'qvcmp'},	qvcmp,		rahidden; ( qv1 qv2 -- qv1 qv2 n ) signum of diff. qv1-qv2
av	crea 0,		{'qvdup'},	qvdup,		rahidden; ( qv -- qv qv ) duplicate quad ranum
av	crea 0,		{'qvfrac'},	qvfrac,		rahidden; ( qv1 -- qv2 ) fractional component of qv1
av	crea 0,		{'qv2*'},	qv2mul,		rahidden; ( qv1 -- qv2 ) multiply by 2
av	crea 0,		{'qvdround'},	qvdround,	rahidden; ( qv1 +qn -- qv2 ) approx. qv1 to doubles' range
av	crea 0,		{'qvinteger'},	qvinteger,	rahidden; ccc(C qv1 -- )(X -- qv ) quad ranum integer
av	crea imed,	{'qvliteral'},	qvliteral,	rahidden; ( qv -- | qv ) compile/interpret quad ranum as a literal
av	crea 0,		{'qvnegate'},	qvnegate,	rahidden; ( qv1 -- qv2 ) negate quad ranum qv1
av	crea 0,		{'qvover'},	qvover,		rahidden; ( qv1 qv2 -- qv1 qv2 qv1 )
av	crea 0,		{'qvpick'},	qvpick,		rahidden; +/- pick quad ranum, re {8pick}
av	crea 0,		{'qvreduce'},	qvreduce,	rahidden; ( qv1 -- qv2 ) reduce quad ranum by g.c.d.
av	crea 0,		{'qvroll'},	qvroll,		rahidden; +/- roll quad ranum, re {8roll}
av	crea 0,		{'qvrot'},	qvrot,		rahidden; ( qv1 qv2 qv3 -- qv2 qv3 qv1 ) 2 qvroll
av	crea 0,		{'qvround'},	qvround,	rahidden; ( qv1 +qn -- qv2 ) approximation to qv1
av	crea 0,		{'qvsgn'},	qvsgn,		rahidden; ( qv1 -- n ) signum of a quad
av	crea 0,		{'qvsover'},	qvsover,	rahidden; ( qv1 qv2 -- qv2 qv1 qv2 ) swap and over
av	crea 0,		{'qvsplit'},	qvsplit,	rahidden; ( qv1 -- qv2 qv3 ) integral qv2 and fractional qv3
av	crea 0,		{'qvsqrt'},	qvsqrt,		rahidden; ( qv1 -- qv2 ) square root of a quad
av	crea 0,		{'qvswap'},	qvswap,		rahidden; ( qv1 qv2 -- qv2 qv1 )
av	crea 0,		{'sincos(qv)'},	sincosqv,	rahidden; ( qv1 -- qv2 qv3 ) sinus qv2, cosinus qv3
av	crea 0,		{'sin(qv)'},	sinqv,		rahidden; ( qv1 -- qv2 ) sinus
av	crea 0,		{'tg(qv)'},	tgqv,		rahidden; ( qv1 -- qv2 ) tangens
;>; aritm. cons, by {rational} number cells pairs, ( -- numerator denominator )
    %ifdef __SRANUM
aw	crea 0,		{'-1v'},	vm1v,		racons	; ( -- v ) -1
aw	crea 0,		{'0v'},		v0v,		racons	; ( -- v ) 0
aw	crea 0,		{'1v'},		v1v,		racons	; ( -- v ) 1
aw	crea 0,		{'e'},		cae,		racons	; ( -- v ) natuerliche zahl
aw	crea 0,		{'e^6'},	cae6,		racons	; ( -- v ) 6 * lim (1+1/n)^n
aw	crea 0,		{'e^10'},	cae10,		racons	; ( -- v ) 10 * lim (1+1/n)^n
aw	crea 0,		{'vovf'},	vovf,		racons	; ( -- v ) sing overflow indicator
    %endif
aw	crea 0,		{'-1dv'},	vm1dv,		racons	; ( -- dv ) -1
aw	crea 0,		{'-1qv'},	vm1qv,		racons	; ( -- qv ) -1
aw	crea 0,		{'0dv'},	v0dv,		racons	; ( -- dv ) 0
aw	crea 0,		{'0qv'},	v0qv,		racons	; ( -- qv ) 0
aw	crea 0,		{'1dv'},	v1dv,		racons	; ( -- dv ) 1
aw	crea 0,		{'1qv'},	v1qv,		racons	; ( -- qv ) 1
aw	crea 0,		{'2^(1/12)'},	casqr12n2,	racons	; ( -- v )
aw	crea 0,		{'2^(1/2)'},	casqr2n2,	racons	; ( -- v )
aw	crea 0,		{'3^(1/2)'},	casqr2n3,	racons	; ( -- v )
aw	crea 0,		{'10^(1/2)'},	casqr2n10,	racons	; ( -- v )
aw	crea 0,		{'bernulli(v)'},bernulliv,	racons	; ( n -- v ) sing, bernulli'sche zahlen
aw	crea 0,		{'c'},		cac,		racons	; ( -- v ) speed of light
aw	crea 0,		{'dvovf'},	dvovf,		racons	; ( -- dv ) double overflow indicator
aw	crea 0,		{'dv.e'},	caed,		racons	; ( -- v ) 6 * the natural cons
aw	crea 0,		{'dv.e^6'},	cae6d,		racons	; ( -- v ) 6 * lim (1+1/n)^n
aw	crea 0,		{'dv.e^10'},	cae10d,		racons	; ( -- v ) 10 * lim (1+1/n)^n
aw	crea 0,		{'dv.ln(2)'},	cdvln2,		racons	; ( -- dv ) double, log 2 base e
aw	crea 0,		{'dv.ln(10)'},	cdvln10,	racons	; ( -- dv ) double, log 10 base e
aw	crea 0,		{'euler-c'},	caec,		racons	; ( -- v ) euler'sche zahl
aw	crea 0,		{'euler(v)'},	eulerv,		racons	; ( n -- v ) sing, euler'sche zahlen
aw	crea 0,		{'k(h)'},	cakphp,		racons	; ( -- v ) CORDIC hyperbolic correction
aw	crea 0,		{'k(t)'},	cakptp,		racons	; ( -- v ) CORDIC trigonometric correction
aw	crea 0,		{'lg(2)'},	calg2,		racons	; ( -- v ) log 2 base 10
aw	crea 0,		{'lg(e)'},	calge,		racons	; ( -- v ) log e base 10
aw	crea 0,		{'ln(2)'},	caln2,		racons	; ( -- v ) log 2 base e
aw	crea 0,		{'ln(10)'},	caln10,		racons	; ( -- v ) log 10 base e
aw	crea 0,		{'pi'},		capi,		racons	; ( -- v ) pi, kreiszahl
aw	crea 0,		{'qv.2/3pi'},	cqv23pi,	racons	; ( -- qv ) quad pi*2/3
aw	crea 0,		{'qv.2pi'},	cqv2pi,		racons	; ( -- qv ) quad pi*2
aw	crea 0,		{'qvovf'},	qvovf,		racons	; ( -- qv ) quad overflow indicator
aw	crea 0,		{'qv.pi/180'},	cqvpi180,	racons	; ( -- qv ) quad pi/180, for rad<->deg conversion
aw	crea 0,		{'qv.pi/2'},	cqvpi2,		racons	; ( -- qv ) quad pi/2
aw	crea 0,		{'qv.pi/4'},	cqvpi4,		racons	; ( -- qv ) quad pi/4
aw	crea 0,		{'qvrdv'},	qvmdv,		racons	; ( -- qn ) quad int limit for qvround to range of double
; --
%ifdef __ANSFLOAT; -- ;
np	crea 0,		{'>FLOAT'},	tofloat,	float	; ( p u -- f1 ) dpans 12.6.1.0558 
np	crea 0,		{'FALIGN'},	falign,		ans	; ( -- ) dpans 12.6.1.1479 
np	crea 0,		{'FALIGNED'},	faligned,	ans	; ( p1 -- p2 ) dpans 12.6.1.1483 
nq	crea 0,		{'DFALIGN'},	dfalign,	ans	; ( -- ) dpans 12.6.2.1205 
nq	crea 0,		{'DFALIGNED'},	dfaligned,	ans	; ( p1 -- p2 ) dpans 12.6.2.1207 
nq	crea 0,		{'DFATANH'},	dfatanh,	float	; ( df1 -- df2 ) area tanh double float
nq	crea 0,		{'DFLOAT+'},	dfloatp,	ans	; ( n1 -- n2 ) dpans 12.6.2.1208 
nq	crea 0,		{'DFLOATS'},	dfloats,	ans	; ( n1 -- n2 ) mul16 dpans 113 |12.6.2.1209  
np	crea 0,		{'FACOSH'},	facosh,		float	; ( f1 -- f2 ) area cosh, dpans 12.6.2.1477 
np	crea 0,		{'FASINH'},	fasinh,		float	; ( f1 -- f2 ) area sinh, dpans 12.6.2.1487 
np	crea 0,		{'FATANH'},	fatanh,		float	; ( f1 -- f2 ) area tanh, dpans 12.6.2.1491 
np	crea 0,		{'FCOSH'},	fcosh,		float	; ( f1 -- f2 ) area tanh, dpans 12.6.2.1494 
np	crea 0,		{'FLOATS'},	floats,		ans	; ( n1 -- n2 ) mul8 dpans 12.6.1.1556 
np	crea 0,		{'FROUND'},	fround,		float	; ( f1 -- f2 ) dpans 12.6.1.1612 
np	crea 0,		{'FEXPM1'},	fexpm1,		float	; ( f1 -- f2 ) dpans 12.6.2.1516 
np	crea 0,		{'FLNP1'},	flnp1,		float	; ( f1 -- f2 ) dpans 12.6.2.1554 
np	crea 0,		{'FLOAT+'},	floatp,		ans	; ( p1 -- p2 ) dpans 12.6.1.1555 
np	crea 0,		{'FSINH'},	fsinh,		float	; ( f1 -- f2 ) hyperbelsinus, dpans 12.6.2.1617 
np	crea 0,		{'FTANH'},	ftanh,		float	; ( f1 -- f2 ) hyperbeltangens, dpans 12.6.2.1626 
np	crea 0,		{'PRECISION'},	fprec,		float	; ( -- n ) -re- {fplaces} dpans 12.6.2.2035
np	crea 0,		{'SET-PRECISION'},sprec,	float	; ( n -- ) dpans 12.6.2.2200 - { to #fplaces }
np	crea 0,		{'SFALIGNED'},	sfaligned,	ans	; ( p1 -- p2 ) dpans 12.6.2.2206
np	crea 0,		{'SFLOATS'},	sfloats,	ans	; ( n1 -- n2 ) mul8 dpans 12.6.2.2208 
np	crea 0,		{'F~'},		faeq,		float	; ( f1 f2 f3 -- flg ) dpans 12.6.2.1640 (-?-)
%ifdef __ANSALIAS; -- ;
np	acrea 0,	{'>DFLOAT'},	todfloat,	float	; ( p u -- df2 ) convert stg to quad ranum, double 'float'
np	crea 0,		{'D>F'},	dtof,		float	; ( d1 -- f2 ) dpans 12.6.1.1130 
cc	acrea 0,	{'DEG>RAD'},	deg2rad,	float	; ( f1 -- f2 ) convert degrees to radians
nq	crea 0,		{'DF>F'},	dftof,		float	; ( df1 -- f2 ) dpans 12.6.1.1130 
nq	crea 0,		{'DFOVER'},	dfover,		float	; ( df1 df2 -- df1 df2 df1 )
nq	crea 0,		{'DFROT'},	dfrot,		float	; ( df1 df2 df3 -- df2 df3 df1 )
nq	crea 0,		{'DFPICK'},	dfpick,		float	; ( df1... n1 -- df1 ) pick double float
nq	crea 0,		{'DFSWAP'},	dfswap,		float	; ( df1 df2 -- df2 df1 )
np	crea 0,		{'F!'},		fstore,		float	; ( f1 p -- ) dpans 12.6.1.1400 
np	crea 0,		{'F*'},		fmulf,		float	; ( f1 f2 -- f3 ) dpans 12.6.1.1410 
np	crea 0,		{'F+'},		fplus,		float	; ( f1 f2 -- f3 ) dpans 12.6.1.1420 
np	crea 0,		{'F-'},		fsubf,		float	; ( f1 f2 -- f3 ) dpans 12.6.1.1425 
np	crea 0,		{'F/'},		fby,		float	; ( f1 f2 -- f3 ) dpans 12.6.1.1430 
np	crea 0,		{'F<'},		flt,		float	; ( f1 -- flg ) dpans 12.6.1.1460 
np	crea 0,		{'F>D'},	ftod,		float	; ( f1 -- d2 ) dpans 12.6.1.1470 
np	crea 0,		{'F>DF'},	ftodf,		float	; ( f1 -- df2 ) dpans 12.6.1.1470 
cc	acrea 0,	{'F>IEEE'},	f2ieee,		float	; ( f1 -- d2 ) dpans 12.6.1.1470 
np	crea 0,		{'F@'},		ffetch,		float	; ( p -- f1 ) dpans 12.6.1.1472 
ll	crea 0,		{'F0<'},	fzlt,		float	; ( f1 -- flg ) dpans 12.6.1.1440 
ll	crea 0,		{'F0='},	fzeq,		float	; ( f1 -- flg ) dpans 12.6.1.1450 
np	crea 0,		{'F1+'},	fonep,		float	; ( f1 -- f2 ) add one
np	crea 0,		{'F1-'},	fonem,		float	; ( f1 -- f2 ) subtract one
np	crea 0,		{'F2*'},	f2mul,		float	; ( f1 f2 -- f3 ) mul by two
np	crea 0,		{'F2/'},	f2by,		float	; ( f1 f2 -- f3 ) div by two
np	crea 0,		{'F2DUP'},	f2dup,		float	; ( f1 f2 -- f1 f2 f1 f2 )
np	crea 0,		{'FCONSTANT'},	fcons,		float	; ccc( f1 -- ) dpans 12.6.1.1492 
np	crea 0,		{'FDEPTH'},	fdepth,		float	; ( -- n ) dpans 12.6.1.1497 
np	crea 0,		{'FDROP'},	fdrop,		float	; ( f1 -- ) dpans 12.6.1.1500 
np	crea 0,		{'FDUP'},	fdup,		float	; ( f1 -- f1 f1 ) dpans 12.6.1.1510 
np	crea 0,		{'FLITERAL'},	fliteral,	float	; ( f1 -- ) dpans 12.6.1.1552 
np	crea 0,		{'FLOOR'},	floor,		float	; ( f1 -- dn ) dpans 12.6.1.1558 
np	crea 0,		{'FMAX'},	fmax,		float	; ( f1 f2 -- f3 ) dpans 12.6.1.1562 
np	crea 0,		{'FMIN'},	fmin,		float	; ( f1 f2 -- f3 ) dpans 12.6.1.1565 
np	crea 0,		{'FNEGATE'},	fnegate,	float	; ( f1 -- f2 ) dpans 12.6.1.1567 
np	crea 0,		{'FOVER'},	fover,		float	; ( f1 f2 -- f1 f2 f1 ) dpans 12.6.1.1600 
np	crea 0,		{'FPICK'},	fpick,		float	; ( f1... n1 -- f1 ) +/- pick float
np	crea 0,		{'FROT'},	frot,		float	; ( f1 f2 f3 -- f2 f3 f1 ) dpans 12.6.1.1610 
np	crea 0,		{'FSWAP'},	fswap,		float	; ( f1 f2 -- f2 f1 ) dpans 12.6.1.1620 
np	crea 0,		{'FVARIABLE'},	fvari,		float	; ccc( -- p ) dpans 12.6.1.1630 
cc	acrea 0,	{'IEEE>F'},	ieee2f,		float	; ( f1 -- d2 ) dpans 12.6.1.1470 
cc	acrea 0,	{'RAD>DEG'},	rad2deg,	float	; ( f1 -- f2 ) convert radians to sexagesimal degrees
ch	acrea 0,	{'REPRESENT'},	frepresent,	float	; ( f1 p u -- n1 flg1 flg2 ) dpans 12.6.1.2143 
os	acrea imed,	{'+FROM'},	pfrom,		float	; ( f1 -- ) modify FOR-loop start & limit by disp f1
os	acrea 0,	{'!IDX'},	sidx,		float	; ( f1 -- ) store FOR-loop index
os	acrea 0,	{'!INC'},	sinc,		float	; ( f1 -- ) store FOR-loop increment
os	acrea 0,	{'@NX'},	fnx,		float	; ( -- p ) ptr to n-th level FOR-loop ctrl data
os	acrea 0,	{'END'},	fend,		float	; ( -- ) terminate FOR-loop at next NEXT
os	acrea imed,	{'FOR'},	for,		float	; ( f1 -- ) begin FOR .. NEXT loop, set range
os	acrea imed,	{'FROM'},	from,		float	; ( f1 -- ) set FOR-loop start
os	acrea 0,	{'IDX'},	fidx,		float	; ( -- f1 ) innermost FOR-loop index
os	acrea 0,	{'INC'},	fstep,		float	; ( -- f1 ) FOR-loop increment
os	acrea 0,	{'LIM'},	flim,		float	; ( -- f1 ) FOR-loop limit
os	acrea imed,	{'NEXT'},	next,		float	; ( -- ) terminate a FOR-loop
os	acrea 0,	{'NX'},		nx,		float	; ( n -- f1 ) n-th level FOR-loop index
os	acrea imed,	{'STEP'},	step,		float	; ( f1 -- ) set FOR-loop increment
; ----------------------------------- ------------
nq	crea 0,		{'DF!'},	dfstore,	float	; ( f1 p -- ) dpans 12.6.2.1203 
nq	crea 0,		{'DF@'},	dffetch,	float	; ( p -- df1 ) dpans 12.6.2.1204 
nq	crea 0,		{'DF.'},	dfdotf,		float	; ( df1 -- ) print double float (quad ranum)
np	crea 0,		{'F**'},	fpow,		float	; ( f1 f2 -- f3 ) dpans 12.6.2.1415 
np	acrea 0,	{'F^'},		fpow,		float	; ( f1 f2 -- f3 ) f1 to the power of f2
cd	crea 0,		{'F.'},		fdot,		float	; ( f1 -- )	dpans 12.6.2.1427 
np	crea 0,		{'FABS'},	fabsf,		float	; ( f1 -- f2 )	dpans 12.6.2.1474 
np	crea 0,		{'FACOS'},	facos,		float	; ( f1 -- f2 )	dpans 12.6.2.1476 
np	crea 0,		{'FALOG'},	falogf,		float	; ( f1 -- f2 )	dpans 12.6.2.1484 
np	crea 0,		{'FASIN'},	fasin,		float	; ( f1 -- f2 )	dpans 12.6.2.1486 
np	crea 0,		{'FATAN'},	fatan,		float	; ( f1 -- f2 )	dpans 12.6.2.1488 
np	crea 0,		{'FATAN2'},	fatan2,		float	; ( f1 f2 -- f3 ) dpans 12.6.2.1489 
np	crea 0,		{'FCOS'},	fcosf,		float	; ( f1 -- f2 )	dpans 12.6.2.1493 
cd	crea 0,		{'FE.'},	fedot,		float	; n.i. - dpans 12.6.2.1513 
np	crea 0,		{'FEXP'},	fexp,		float	; ( f1 -- f2 )	dpans 12.6.2.1515 
np	crea 0,		{'FLN'},	fln,		float	; ( f1 -- f2 )	dpans 12.6.2.1553 
np	crea 0,		{'FLOG'},	flog,		float	; ( f1 -- f2 )	dpans 115 |12.6.2.1557 
cd	crea 0,		{'FS.'},	fsdot,		float	; n.i. - dpans 12.6.2.1613 
np	crea 0,		{'FSIN'},	fsinf,		float	; ( f1 -- f2 ) dpans 12.6.2.1614 
np	crea 0,		{'FSINCOS'},	fsc,		float	; ( f1 -- f2 f3 ) dpans 12.6.2.1616 
np	crea 0,		{'FSQRT'},	fsqrtf,		float	; ( f1 -- f2 ) dpans 12.6.2.1618 
np	crea 0,		{'FTAN'},	ftan,		float	; ( f1 -- f2 ) dpans 12.6.2.1625 
; single fp, nto double prec. aequivalent words  o -|------- o -o
np	crea 0,		{'SF!'},	sfstore,	float	; ( f1 p -- )	dpans 12.6.2.2202 
np	crea 0,		{'SF@'},	sffetch,	float	; ( p -- f1 )	dpans 12.6.2.2203 
np	crea 0,		{'SFALIGN'},	sfalign,	ans	; ( -- )	dpans 12.6.2.2204 
np	crea 0,		{'SFLOAT+'},	sfloatp,	ans	; ( n1 -- n2 )	dpans 12.6.2.2207 
%endif;__ANSALIAS
%endif;__ANSFLOAT
%endif;__RATIONAL
;>; multi-cell
rr	crea nopt,	{'m>r'},	mtor,		forth	; mem bytes to return-stack
ss	crea 0,		{'m>s'},	mtos,		forth	; mem bytes to data-stack
ss	crea 0,		{'ndrop'},	ndrop,		forth	; drop n cells
ss	crea 0,		{'ndup'},	ndup,		forth	; dup n cells
rr	crea nopt,	{'n>r'},	ntor,		forth	; push data-stack cells to return-stack
rr	crea nopt,	{'nr>'},	nrfrom,		forth	; pop return-stack cells to data-stack
rr	crea nopt,	{'nr@'},	nrfetch,	forth	; copy return-stack cells to data-stack
ss	crea 0,		{'nswap'},	nswap,		forth	; swap blocks of n cells
rr	crea nopt,	{'r>m'},	rtom,		forth	; return-stack bytes to mem
ss	crea 0,		{'s>m'},	stom,		forth	; stack bytes to mem
ss	crea 0,		{'swapn'},	swapn,		forth	; swap tos w. n-th cell
%ifdef __BIGNUM_I;>; multi-praecision, "bignum" counted integers
ch	crea 0,		{'(n.)'},	pndotp,		bignum	; convert signed counted int to stg
ch	crea 0,		{'(un.)'},	pundotp,	bignum	; convert unsigned counted int to stg
ao	crea 0,		{'2q->2n'},	q22n,		bignum	; quad pair to bignum
ao	crea 0,		{'2n->2q'},	n22q,		bignum	; bignum pair to quad
ao	crea 0,		{'2q->2un'},	q22un,		bignum	; quad pair unsigned to bignum
ao	crea 0,		{'2n->2uq'},	n22uq,		bignum	; bignum pair unsigned to quad
ao	crea 0,		{'lg(nn)'},	lgnn,		bignum	; sing numerus of log(bignum)(sing)
ch	crea 0,		{'n#'},		nh,		bignum	; extract l.s. digit of bignum to stg
ch	crea 0,		{'n#s'},	nhs,		bignum	; convert bignum to numeric chars
ch	crea 0,		{'n#?'},	nhq,		bignum	; ptr and flg whether stg conversion possible
ax	crea 0,		{'n#max'},	nhmax,		bignum	; max size for counted int to stg 
ax	crea 0,		{'n#size'},	nhsize,		bignum	; memory requirement for num to stg conversion
ch	crea 0,		{'n<#'},	nlth,		bignum	; prepare counted int stg conversion
ch	crea 0,		{'n#>'},	nhgt,		bignum	; finish counted int to stg conversion
cn	crea 0,		{'n>number'},	ntonumber,	bignum	; convert stg to bignum until invalid char
an	crea 0,		{'n*'},		nmul,		bignum	; multiply two counted ints
an	crea 0,		{'n*2^32'},	nm32,		bignum	; multiply counted int by 2^32
an	crea 0,		{'n/'},		nby,		bignum	; signed divide two counted ints
an	crea 0,		{'n/2^32'},	nd32,		bignum	; divide counted int by 2^32
an	crea 0,		{'n/mod'},	nbym,		bignum	; signed divide two counted ints w/ remainder
cd	crea 0,		{'n.'},		ndot,		bignum	; send numeric bignum stg to stdout
an	crea 0,		{'n-'},		nsub,		bignum	; normalize & subtract two bignums
an	crea 0,		{'n->'},	ntoq,		bignum	; signed reduce bignum to minimal cell size
an	crea 0,		{'n->n'},	nton,		bignum	; sign extend bignum
ao	crea 0,		{'n->q'},	n2q,		bignum	; bignum to quad
an	crea 0,		{'n->un'},	n2un,		bignum	; modify bignum to unsigned
an	crea 0,		{'n+'},		nadd,		bignum	; normalize & add two bignums
an	crea 0,		{'n+-'},	npm,		bignum	; apply sign of sing to bignum
ll	crea 0,		{'n='},		neq,		bignum	; signed compare two bignums
mg	crea 0,		{'n@'},		nfetch,		bignum	; fetch counted integer
ma	crea 0,		{'n@+'},	nfetchp,	bignum	; fetch counted int, leave advanced ptr
ap	crea 0,		{'n@sp'},	nnposn,		hidden	; cells disp to indexed 'bignum'
mg	crea 0,		{'n!'},		nstore,		bignum	; store counted integer
ma	crea 0,		{'n!+'},	nstorep,	bignum	; store counted int, leave advanced ptr
an	crea 0,		{'n^'},		npow,		bignum	; ( n.N m -- p.P ) n.N to the power of m
ll	crea 0,		{'?n0='},	qnzeq,		bignum	; non-destructively test counted int for zero
ll	crea 0,		{'?ncmp'},	qncmp,		bignum	; non-destr. ret sgn(diff of two counted ints)
ll	crea 0,		{'n0<'},	nzlt,		bignum	; test counted int for < zero
ll	crea 0,		{'n0='},	nzeq,		bignum	; test counted int for zero
ll	crea 0,		{'n0>'},	nzgt,		bignum	; test counted int for > zero
an	crea 0,		{'n1-'},	nonem,		bignum	; dec counted int by 1
an	crea 0,		{'n1+'},	nonep,		bignum	; inc counted int by 1
an	crea 0,		{'n2*'},	nn2mul,		bignum	; multiply counted int by 2
an	crea 0,		{'n2/'},	nn2div,		bignum	; divide counted int by 2
ap	crea 0,		{'n2dup'},	nn2dup,		bignum	; dup double counted int
an	crea 0,		{'nabs'},	nabs,		bignum	; abs value of counted int
an	crea 0,		{'ncmp'},	ncmp,		bignum	; ret sign of subtraction of two bignums
an	crea 0,		{'ngcd'},	ngcd,		bignum	; ret greatest common divisor of two bignums
og	crea 0,		{'ninteger'},	ninteger,	bignum	; counted int alterable constant
bi	crea 0,		{'ninvert'},	ninvert,	bignum	; 1's cpl counted int
bi	crea 0,		{'nlshift'},	nlshift,	bignum	; shift left counted int
oo	crea imed,	{'nliteral'},	nliteral,	bignum	; cpl multi-cell literal
an	crea 0,		{'nminus'},	nminus,		bignum	; 2's cpl of counted int
ap	acrea 0,	{'ndrop'},	ndrop,		bignum	; drop counted int
ap	crea 0,		{'nn-rot'},	nnmrot,		bignum	; rot back counted ints
ao	crea 0,		{'nn->dd'},	n22d,		bignum	; bignum pair to data
ap	crea nopt,	{'nn>r'},	nntor,		bignum	; counted int from data-stack to return-stack
ap	crea 0,		{'nndrop'},	nndrop,		bignum	; drop a number of counted ints
ap	crea 0,		{'nndup'},	nndup,		bignum	; dup counted int
cn	crea 0,		{'nnumber'},	nnumber,	bignum	; convert stg to counted int
an	acrea 0,	{'nnegate'},	nminus,		bignum	; negate counted int
an	crea 0,		{'nnorm'},	nnorm,		bignum	; normalize top two bignums to equal size
ap	crea nopt,	{'nnr>'},	nnrfrom,	bignum	; bignum from return-stack to data-stack
ap	crea 0,		{'nnover'},	nnover,		bignum	; over counted int
ap	crea 0,		{'nnpick'},	nnpick,		bignum	; pick counted int
ap	crea 0,		{'nnroll'},	nnroll,		bignum	; +/- roll counted ints
ap	crea 0,		{'nnrot'},	nnrot,		bignum	; ( n1.N m2.M o3.O -- m2.M o3.O n1.N ) rot counted ints
ap	crea 0,		{'nnsdrop'},	nnsdrop,	bignum	; ( n.N m.M -- m.M ) , -1 nnpick
ap	crea 0,		{'nnswap'},	nnswap,		bignum	; ( n1.N m2.M -- m2.M n1.N ) swap counted ints
bi	crea 0,		{'nrshift'},	nrshift,	bignum	; ( n1.N n2 -- n2.M ) shift right counted int
an	crea 0,		{'nsgn'},	nsgn,		bignum	; ( n1.N -- n2 ) signum of a counted int
bi	crea 0,		{'nshift'},	nshift,		bignum	; ( n1.N n2 -- n3.N ) shift bignum +n2 left, -n2 right
an	crea 0,		{'nsqrt'},	nsqrt,		bignum	; ( n1 -- n2.N ) square root of a counted int
ao	crea 0,		{'q->n'},	q2n,		bignum	; ( q1 -- n1.N ) quad to bignum
ao	crea 0,		{'s>nfactorial'},s2nfac,	bignum	; ( n1 -- n2.N ) counted int factorial of a sing
an	crea 0,		{'un->un'},	untoun,		bignum	; ( n1.N M -- n2.M ) unsigned extend counted int
cd	crea 0,		{'un.'},	undot,		bignum	; ( .n1.N -- ) send unsigned numeric bignum stg to stdout
ao	crea 0,		{'uns*'},	unsmul,		bignum	; ( n1.N n2 -- n3.(N+1) ) unsigned mul counted int by sing
ao	crea 0,		{'uns/mod'},	unsbym,		bignum	; ( n1.N n2 -- q3.Q n4r ) unsigned div counted int by sing
%endif;>; quad:
ss	crea 0,		{'-4dup'},	qdup4,		forth	; ( q1 -- q1 q1 | q0 ) 4dup @tos if non-zero
ll	crea 0,		{'?q0='},	qqzeq,		forth	; ( q1 -- q1 f ) non-destructive test, tf if quad = zero
ll	crea 0,		{'?uqcmp'},	quqcmp,		forth	; ( q1 q2 -- q1 q2 f ) unsgnd compare, f=1 if q2 u< q1
af	crea 0,		{'3rd-q1+'},	q1pt,		hidden	; ( q1 qx qy -- q2 qx qy ) inc quad q1 by one
af	crea 0,		{'3rd-q2*'},	qmul2t,		hidden	; ( q1 qx qy -- q2 qx qy ) mul quad q1 by two
af	crea 0,		{'3rd-uq2/'},	uqdiv2t,	hidden	; ( q1 qx qy -- q2 qx qy ) unsigned div quad q1 by two
mq	crea 0,		{'4!'},		store4,		forth	; ( q1 p -- ) sto quad to memory
mq	crea 0,		{'4@'},		fetch4,		forth	; ( p -- q1 ) fetch quad from memory
ss	crea 0,		{'4-rot'},	mrot4,		forth	; ( q1 q2 q3 -- q3 q1 q2 ) reverse rot quad
rr	crea nopt,	{'4>r'},	tor4,		forth	; ( -- q1 )(R q1 -- ) quad from return-stack
ss	crea 0,		{'4drop'},	drop4,		forth	; ( q1 -- ) drop 4 cells
ss	crea 0,		{'4dup'},	dup4,		forth	; ( q1 -- q1 q1 ) duplicate quad @tos
bi	crea 0,		{'4not'},	not4,		forth	; ( q1 -- q2 ) bitwise complement top 4 cells
ss	crea 0,		{'4sdrop'},	sdrop4,		forth	; ( q1 q2 -- q2 ) ; 4swap 4drop
ss	crea 0,		{'4sover'},	sover4,		forth	; ( q1 q2 -- q2 q1 q2 ) ; 4swap 4over
ss	crea 0,		{'4swap'},	swap4,		forth	; ( q1 q2 -- q2 q1 ) exchange top two quads
ss	crea 0,		{'4over'},	over4,		forth	; ( q1 q2 -- q1 q2 q1 ) push quad @nos to tos
ss	crea 0,		{'4pick'},	pick4,		forth	; ( qx..qn..q0 n -- qx..qn..q0 qn) +/- pick quad
rr	crea nopt,	{'4r'},		r4,		forth	; ( -- q1 )(R q1 -- q1 ) copy quad from RS to DS
rr	crea nopt,	{'4r>'},	rfrom4,		forth	; ( q1 -- )(R -- q1 ) quad to RS
rr	crea nopt,	{'4rdrop'},	rdrop4,		forth	; (R q1 -- ) ; drop four cells from RS
ss	crea 0,		{'4roll'},	roll4,		forth	; ( qn .. q1 n -- .. q1 qn | q1 qn .. ) +/- roll quads
ss	crea 0,		{'4rot'},	rot4,		forth	; ( q1 q2 q3 -- q2 q3 q1 ) rot quads
ss	crea 0,		{'4rotd'},	rot4d,		forth	; ( q1 q2 q3 -- q2 q3 ) rot drop quads
ss	crea 0,		{'8drop'},	drop8,		forth	; ( o1 -- ) drop top 8 cells, quad ranum
ss	crea 0,		{'8dup'},	dup8,		forth	; ( o1 -- o1 o1 ) dup top 8 cells item, quad ranum
bi	crea 0,		{'8not'},	not8,		hidden	; ( o1 -- o2 ) bitwise complement top 8-cells item
ss	crea 0,		{'8over'},	over8,		forth	; ( o1 o2 -- o1 o2 o1 ) over 8 cells item, quad ranum
ss	crea 0,		{'8pick'},	pick8,		forth	; ( .. o1 n -- .. o1 on | .. ) +/- pick 8 cells items
ss	crea 0,		{'8roll'},	roll8,		forth	; ( on .. o1 n -- .. o1 on | o1 on .. ) +/- roll by 8 cells
ss	crea 0,		{'8sdrop'},	sdrop8,		forth	; ( o1 o2 -- o2 ) drop @nos 8-cells item
ss	crea 0,		{'8sover'},	sover8,		forth	; ( o1 o2 -- o1 o2 o1 ) swap over quad ranums
ss	crea 0,		{'8swap'},	swap8,		forth	; ( o1 o2 -- o2 o1 ) swap 8-cells items
bi	crea 0,		{'nos-4not'},	not4n,		hidden	; ( q1 qx -- q2 qx ) bitwise complement quad @nos
af	crea 0,		{'nos-q1+'},	q1pn,		hidden	; ( q1 qx -- q2 qx ) inc quad @nos by one
af	crea 0,		{'nos-q1-'},	q1mn,		hidden	; ( q1 qx -- q2 qx ) dec quad @nos by one
af	crea 0,		{'nos-q2*'},	qmul2n,		hidden	; ( q1 qx -- q2 qx ) mul quad @nos by two
af	crea 0,		{'nos-q2/'},	qdiv2n,		hidden	; ( q1 qx -- q2 qx ) div quad @nos by two
af	crea 0,		{'nos-uq2/'},	uqdiv2n,	hidden	; ( q1 qx -- q2 qx ) unsigned div quad @nos by two
af	crea 0,		{'nos-qnegate'},qnegaten,	hidden	; ( q1 qx -- q2 qx ) negate quad @nos
ll	crea 0,		{'o0='},	ozeq,		hidden	; ( o1 -- flg ) test eight-cells for zero
af	crea 0,		{'o1+'},	o1p,		hidden	; ( o1 -- o2 ) inc eight-cells integer by one
af	crea 0,		{'o-'},		osub,		hidden	; ( o1 o2 -- o3 ) subtract 8-cells numbers
af	crea 0,		{'o+'},		oplus,		hidden	; ( o1 o2 -- o3 ) add 8-cells numbers
af	crea 0,		{'onegate'},	onegate,	hidden	; ( o1 -- o2 ) negate eight-cells integer
ch	crea 0,		{'q#'},		qsharp,		forth	; extract l.s. digit from a quad
ch	crea 0,		{'q#s'},	qsharps,	forth	; convert quad to chars in {hld} buffer
ch	crea 0,		{'q#>'},	qsharpgt,	forth	; terminate quad to stg conversion
hx	crea 0,		{'(q.)'},	pqdotp,		hidden	; ( q sgn fmt -- ) quad to string
ll	crea 0,		{'q<'},		qless,		forth	; ( q1 -- f ) tf if quad @tos less than quad next on stack
cd	crea 0,		{'q.'},		qdot,		forth	; signed display a quad
cd	crea 0,		{'uq.'},	uqdot,		forth	; unsigned display a quad
af	crea 0,		{'q-'},		qsub,		forth	; ( q1 q2 -- q3 ) subtract quad numbers
af	crea 0,		{'q+'},		qplus,		forth	; ( q1 q2 -- q3 ) add quad numbers
cd	crea 0,		{'q.r'},	qdotr,		forth	; ( q1 n2 -- ) signed display a quad right aligned
ll	crea 0,		{'q0<'},	qzless,		forth	; ( q1 -- f ) tf if quad -ve
ll	crea 0,		{'q0>'},	qzgreat,	forth	; ( q1 -- f ) tf if quad greater than zero
ll	crea 0,		{'q0='},	qzeq,		forth	; ( q1 -- f ) tf if quad is zero
af	crea 0,		{'q1-'},	qonem,		forth	; ( q1 -- q2 ) decrement quad by one
af	crea 0,		{'q1+'},	qonep,		forth	; ( q1 -- q2 ) increment quad by one
af	crea 0,		{'q2*'},	qmul2,		forth	; ( q1 -- q2 ) mul quad by 2
af	crea 0,		{'q2/'},	qdiv2,		forth	; ( q1 -- q2 ) signed 'round near zero' div quad by 2
af	crea 0,		{'q1abs'},	q1abs,		forth	; ( q1 -- q2 ) one-s complement if quad -ve
ll	crea 0,		{'q='},		qeq,		forth	; ( q1 q2 -- f ) tf if top two quads equal
af	crea 0,		{'q*'},		qmul,		forth	; ( q1 q2 -- o3 ) signed mul quad by quad to 8 cells prod 
af	crea 0,		{'qabs'},	qabs,		forth	; ( q1 -- q2 ) two-s complement if quad -ve
ad	crea 0,		{'qdfm/mod'},	qdfmbym,	forth	; ( q1 d2 -- d3r d4q ) floored q by d, ret doubles
af	crea 0,		{'qfm/mod'},	qfmbym,		forth	; ( q1 d2 -- d3r q4q ) floored q by d, ret quad,double
af	crea 0,		{'qgcd'},	qgcd,		forth	; ( q1 q2 -- q3 ) greatest common denominator
af	crea 0,		{'qlshift'},	qlshift,	forth	; ( q1 n2 -- q3 ) shift quad left
af	crea 0,		{'qnegate'},	qnegate,	forth	; ( q1 -- q2 ) negate quad
af	crea 0,		{'qrshift'},	qrshift,	forth	; ( q1 n2 -- q3 ) unsigned shift quad right
af	crea 0,		{'qsgn'},	qsgn,		forth	; ( q1 -- n2 ) sing sign value of a quad
af	crea 0,		{'qslbits'},	qslbits,	forth	; ( q1 -- q1 n ) no. of top zero-bits less 2
af	crea 0,		{'qsm+'},	qsmplus,	forth	; ( q1 n2 -- n3 ) signed add sing to quad
af	crea 0,		{'qsqrt'},	qsqrt,		forth	; ( q1 -- q2 n3 ) quad square root of quad, sing 'j'-flag
ll	crea 0,		{'qu<'},	quless,		forth	; ( q1 -- f ) tf if unsigned quad @tos smaller than @nos
ll	crea 0,		{'qu>'},	qugreat,	forth	; ( q1 -- f ) tf if unsigned quad @tos greater than @nos
cd	crea 0,		{'uq.r'},	uqdotr,		forth	; ( q1 n2 -- ) unsigned right aligned display a quad
ad	crea 0,		{'uqd/mod'},	uqdbym,		forth	; ( q1 d2 -- d3r d4q ) q by d, double quot & rmd
ad	crea 0,		{'uqm/mod'},	uqmbym,		forth	; ( q1 d2 -- d3r q4q ) q by d, quad quot, double rmd
af	crea 0,		{'uqmax'},	uqmax,		forth	; ( q1 q2 -- q3 ) unsigned greater of two quads
af	crea 0,		{'uqmin'},	uqmin,		forth	; ( q1 q2 -- q3 ) unsigned smaller of two quads
af	crea 0,		{'uq*'},	uqmul,		forth	; ( q1 q2 -- o3 ) unsigned mul q by q to 8 cells prod 
ad	crea 0,		{'uqd*'},	uqdmul,		forth	; ( q1 d2 -- q3 d4 ) mul quad by duble to 6 cells prod
ac	crea 0,		{'uqsm*'},	uqsmmul,	forth	; ( q1 n2 -- q3 n4 ) mul quad by sing to 5 cells prod
ac	crea 0,		{'uqsm/'},	uqsmby,		forth	; ( q1 n2 -- n3 q4 ) q by sing, ret quad quot, sing rmd
af	crea 0,		{'q/mod'},	qbym,		forth	; ( q1 q2 -- q3r q4q ) quot, rmd of quad div
af	crea 0,		{'q/'},		qby,		forth	; ( q1 q2 -- q3q ) quot of quad div
af	crea 0,		{'qf/mod'},	qfbym,		forth	; ( q1 q2 -- q3r q4q ) floored div q/q, ret q,q
af	crea 0,		{'qmod'},	qmod,		forth	; ( q1 q2 -- q3r ) rmd of quad div
af	crea 0,		{'uq2/'},	uqdiv2,		forth	; ( q1 -- q2 ) unsigned div quad by 2
af	crea 0,		{'uq/mod'},	uqbym,		forth	; ( q1 q2 -- q3r q4q )
;>; arithm+cons
aa	crea 0,		{'1+'},		add1,		forth	; inc sing by one
aa	crea 0,		{'1-'},		sub1,		forth	; dec sing by one
aa	crea 0,		{'1abs'},	abs1,		forth	; one-s complement if sing -ve
aa	crea 0,		{'2+'},		add2,		forth	; inc sing by two
aa	crea 0,		{'2-'},		sub2,		forth	; dec sing by two
aa	crea 0,		{'2*'},		mul2,		forth	; mul sing by two
da	crea 0,		{'2/'},		shr2,		ans	; signed shift sing right by one
aa	crea 0,		{'2/'},		div2,		forth	; div sing by two
aa	crea 0,		{'3*'},		mul3,		forth	; mul sing by three
aa	crea 0,		{'4+'},		add4,		forth	; inc sing by four
aa	crea 0,		{'4-'},		sub4,		forth	; dec sing by four
aa	crea 0,		{'4*'},		mul4,		forth	; mul sing by four
aa	crea 0,		{'4/'},		div4,		forth	; div sing by four
aa	crea 0,		{'5*'},		mul5,		forth	; mul sing by five
aa	crea 0,		{'6*'},		mul6,		forth	; mul sing by six
aa	crea 0,		{'7*'},		mul7,		forth	; mul sing by seven
aa	crea 0,		{'8+'},		add8,		forth	; inc sing by eight
aa	crea 0,		{'8-'},		sub8,		forth	; dec sing by eight
aa	crea 0,		{'8*'},		mul8,		forth	; mul sing by eight
aa	crea 0,		{'8/'},		div8,		forth	; div sing by eight
aa	crea 0,		{'9*'},		mul9,		forth	; mul sing by nine
aa	crea 0,		{'10*'},	mul10,		forth	; mul sing by ten
aa	crea 0,		{'16*'},	mul16,		forth	; mul sing by sixteen
aa	crea 0,		{'16/mod'},	div16m,		forth	; div/mod sing by sixteen
aa	acrea 0,	{'abits'},	mul8,		ans	; mul by no. of bits per address unit
aa	crea 0,		{'ABS'},	aabs,		ans	; two-s cpl if sing -ve, '-0' unchanged
aa	crea 0,		{'abs'},	cabs,		forth	; two-s cpl if sing -ve, '-0' -> 0
aa	acrea 0,	{'cell+'},	add4,		forth	; inc sing by no. of bytes per cell (4)
aa	acrea 0,	{'cell-'},	sub4,		forth	; dec sing by no. of bytes per cell (4)
aa	crea 0,		{'CELL/'},	cellby,		ans	; floored div sing by bytes per cell (4)
aa	acrea 0,	{'CELLS'},	mul4,		ans	; mul sing by bytes per cell (4)
aa	acrea 0,	{'char+'},	add1,		forth	; inc sing by bytes per char (1)
aa	acrea 0,	{'char-'},	sub1,		forth	; dec sing by bytes per char (1)
aa	acrea 0,	{'chars'},	noop,		forth	; mul sing by bytes per char (1)
;>; data conversion
aa	crea 0,		{'4th>abs'},	fth2abs,	forth	; ptr to address
aa	crea 0,		{'abs>4th'},	abs2fth,	forth	; address to ptr
ss	crea 0,		{'b->d'},	b2dn,		forth	; combine 8 cells ls.bytes to a double
ss	crea 0,		{'b->s'},	b2sn,		forth	; combine 4 cells ls.bytes to a sing
cc	crea 0,		{'c->s'},	c2sn,		forth	; l.s.byte to sing (cell)
ch	crea 0,		{'c>lower'},	c2lower,	forth	; convert char to lower-case
ch	crea 0,		{'c>upper'},	c2upper,	forth	; convert char to upper-case
cc	crea 0,		{'w->s'},	w2sn,		forth	; l.s.word to sing
cc	crea 0,		{'d->b'},	d2bn,		forth	; extract 8 bytes from double
cc	crea 0,		{'d->q'},	d2qn,		forth	; double to quad
cc	crea 0,		{'d->s'},	d2sn,		forth	; double to sing
cc	acrea 0,	{'d>s'},	d2sn,		forth	; double to sing
ss	crea 0,		{'s->b'},	s2bn,		forth	; extract 4 bytes from sing
cc	crea 0,		{'s->c'},	s2cn,		forth	; signed sing to byte
cc	crea 0,		{'s->w'},	s2wn,		forth	; signed sing to word
cc	crea 0,		{'s->d'},	s2dn,		forth	; signed sing to double
cc	acrea 0,	{'S>D'},	s2dn,		ans	; signed sing to double
ch	crea 0,		{'s>lower'},	s2lower,	forth	; convert stg to lower-case
ch	crea 0,		{'s>upper'},	s2upper,	forth	; convert stg to upper-case
cc	crea 0,		{'u->d'},	u2dn,		forth	; sing to unsigned double
cc	acrea 0,	{'U>D'},	u2dn,		ans	; sing to unsigned double
ch	crea 0,		{'ekey>asci'},	ekey2asci,	forth	; tf & char if code in 8bit ascii+ctrls range
ch	crea 0,		{'ekey>char'},	ekey2char,	forth	; tf & char if code in range of printing chars
;>; fetch/store
ma	crea 0,		{'(1+)'},	b1pb,		forth	; add 1 to cell at ptr
ma	crea 0,		{'(1-)'},	b1mb,		forth	; sub 1 from cell at ptr
ma	crea 0,		{'(d1+)'},	bd1pb,		forth	; add 1 to double cell at ptr
ma	crea 0,		{'(d1-)'},	bd1mb,		forth	; sub 1 from double cell at ptr
mg	crea 0,		{'!+'},		storep,		forth	; store dword & post-increment
mg	crea 0,		{'c+!'},	cplsto,		forth	; add byte to byte in memory
mg	crea 0,		{'c!+'},	cstorep,	forth	; store byte & post-increment
mg	crea 0,		{'w!+'},	wstorep,	forth	; store word & post-increment
mg	crea 0,		{'!-'},		storem,		forth	; pre-decrement & store dword
mg	crea 0,		{'c!-'},	cstorem,	forth	; pre-decrement & store byte
mg	crea 0,		{'w!-'},	wstorem,	forth	; pre-decrement & store word 
mg	crea 0,		{'@+'},		fetchp,		forth	; nos=tos+4,tos=@kref(tos)
mg	crea 0,		{'w@+'},	wfetchp,	forth	; nos=tos+2,tos=w@kref(tos)
mg	crea 0,		{'c@+'},	cfetchp,	forth	; nos=tos+1,tos=c@kref(tos)
mg	crea 0,		{'c@!'},	cfsto,		forth	; copy byte from/to memory
mg	crea 0,		{'w@!'},	wfsto,		forth	; copy half cell from/to memory
mg	crea 0,		{'@!'},		fsto,		forth	; copy cell from/to memory
mu	crea 0,		{'2@!'},	twofsto,	forth	; copy double from/to memory
mg	crea 0,		{'c!!'},	cxsto,		forth	; xchange bytes in memory
mg	crea 0,		{'w!!'},	wxsto,		forth	; xchange half cells in memory
mg	crea 0,		{'!!'},		xsto,		forth	; xchange cells in memory
mu	crea 0,		{'2!!'},	twoxsto,	forth	; xchange doubles in memory
mq	crea 0,		{'4!!'},	qxsto,		forth	; xchange quads in memory
ma	crea 0,		{'and!'},	ands,		forth	; and to cell in memory
ma	crea 0,		{'or!'},	ors,		forth	; or to cell in memory
ma	crea 0,		{'xor!'},	xors,		forth	; xor to cell in memory
mg	crea 0,		{'a@'},		afetch,		forth	; fetch cell from true addr
mg	crea 0,		{'a!'},		astore,		forth	; sto cell to true addr
mg	crea 0,		{'c@'},		cfetch,		forth	; fetch byte from memory
mg	crea 0,		{'w@'},		wfetch,		forth	; fetch half cell ("word") from memory
mg	crea 0,		{'@'},		fetch,		forth	; fetch cell ("dword") from memory
mu	crea 0,		{'2@'},		twofetcha,	ans	; fetch double, BIG ENDIAN (ANS!)
mu	crea 0,		{'2@'},		twofetch,	forth	; fetch double
mu	acrea 0,	{'2@'},		twofetch,	fig	; fetch double
mg	crea 0,		{'c!'},		cstore,		forth	; sto l.s.byte of sing to memory
mg	crea 0,		{'w!'},		wstore,		forth	; sto l.s. half cell of sing to memory
mg	crea 0,		{'!'},		store,		forth	; sto sing to memory
mu	crea 0,		{'2!'},		twostoa,	ans	; sto double to mem, BIG ENDIAN (ANS!)
mu	crea 0,		{'2!'},		twosto,		forth	; sto double to mem
mu	acrea 0,	{'2!'},		twosto,		fig	; sto double to mem
mg	crea 0,		{'+!'},		plsto,		forth	; add sing to cell in memory
mg	crea 0,		{'m+!'},	mplsto,		forth	; sign extended add sing to double in memory
mu	crea 0,		{'2+!'},	twoplsto,	forth	; ( d p -- ) add double to double in memory
;>; memory
tt	crea 0,		{'+place'},	pplace,		forth	; ( p1 n p2 -- ) pre-/append stg in memory
mm	crea 0,		{'>move<'},	movex,		forth	; ( p1 p2 +u -- ) copy reversed bytes order
tt	crea 0,		{'bl.r'},	bldotr,		forth	; right aligned fill field w. leading blanks
tt	crea 0,		{'blank'},	blanks,		forth	; ( p +u -- ) fill memory w. blanks
tt	acrea 0,	{'blanks'},	blanks,		fig	; ( p +u -- ) fill memory w. blanks
mm	crea 0,		{'c-xchg'},	cxchg,		forth	; (p1 p2 +u -- ) xchange memory content
mm	crea 0,		{'cmove'},	xcmove,		forth	; ( p1 p2 +u ) copy memory contents w/ ascending ptrs
mm	crea 0,		{'cmove>'},	cmovegt,	forth	; ( p1 p2 +u ) copy memory contents w/ descending ptrs
tt	crea 0,		{'count'},	ccount,		forth	; ( p1 -- p2 u ) ptr to 1st char and count
tt	crea wcas,	{'COUNT'},	count,		ans	; ( p1 -- p2 u ) chars(bytes?) count of a counted string
mm	crea 0,		{'erase'},	erase,		forth	; ( p +u -- ) fill memory range w/ <nul> bytes
mm	crea 0,		{'fill'},	fill,		forth	; ( p +u n -- ) fill memory range w/ supplied byte
mm	crea 0,		{'move'},	move,		forth	; ( p1 p2 +u ) copy non-overwriting
tt	crea 0,		{'place'},	place,		forth	; ( p1 +u1 p2 -- ) store stg to supplied buffer
ax	crea 0,		{'place-size'},	placesize,	forth	; ( -- n ) max. stg size for -re- {place}, {+place}
oo	crea 0,		{'toggle'},	toggle,		fig	; ( p c -- ) xor byte in memory - fig mode, reversed operands
tt	crea 0,		{'zcount'},	zcount,		forth	; ( p1 -- p2 u ) {count} wrt <nul>-terminated stg
;>; stack, double
rr	crea nopt,	{'2>R'},	ator2,		ans	; ( n1 n2 -- )(R -- n1 n2 ) push to r-stack, BIG ENDIAN (ANS!)
rr	crea nopt,	{'2>r'},	tor2,		forth	; ( n1 n2 -- )(R -- n2 n1 ) push double to return-stack
rr	crea nopt,	{'2>rr'},	torr2,		forth	; ( d -- )(R -- d ) copy double to return-stack
rr	crea nopt,	{'2R@'},	ar2f,		ans	; copy double from return-stack, BIG ENDIAN (ANS!)
rr	crea nopt,	{'2r'},		r2,		forth	; copy double from return-stack
rr	crea nopt,	{'2R>'},	arfrom2,	ans	; pop double from return-stack,BIG ENDIAN (ANS!)
rr	crea nopt,	{'2r>'},	rfrom2,		forth	; pop double from return-stack
ss	crea 0,		{'2roll'},	roll2,		forth	; ( .dd. n -- .. dn ) roll doubles
ss	crea 0,		{'2pick'},	pick2,		forth	; ( .dd. n -- .dd. dn ) pick double
ss	crea 0,		{'2dup'},	dup2,		forth	; ( d -- d d ) duplicate double
ss	crea 0,		{'2drop'},	drop2,		forth	; ( d -- ) drop two cells
ss	crea 0,		{'2over'},	over2,		forth	; ( d1 d2 -- d1 d2 d1 ) copy double @nos to tos
ss	crea 0,		{'2rot'},	rot2,		forth	; ( d1 d2 d3 -- d2 d3 d1 ) roll by 2
ss	crea 0,		{'2swap'},	swap2,		forth	; ( d1 d2 -- d2 d1 ) exchange double @tos w/ @nos
oo	crea 0,		{'cs-depth'},	csdepth,	forth	; ( -- n ) cpl-stack depth, less count from <colon>
oo	crea 0,		{'cs-drop'},	csdrop,		forth	; drop (double) item from compile-stack
oo	crea 0,		{'cs-pick'},	cspick,		forth	; pick (double) item from compile-stack
oo	crea 0,		{'cs-roll'},	csroll,		forth	; roll double on compile-stack
oo	crea 0,		{'ds-pick'},	dspick,		forth	; pick sing wrt saved data-stack
;>; double fast arithm
ad	crea 0,		{'d1+'},	donep,		forth	; ( d1 -- d2 ) inc double by one
ad	crea 0,		{'d1-'},	donem,		forth	; ( d1 -- d2 ) dec double by one  	
ad	crea 0,		{'d2+'},	dtwop,		forth	; ( d1 -- d2 ) inc double by two
ad	crea 0,		{'d2-'},	dtwom,		forth	; ( d1 -- d2 ) dec double by two  	
ad	crea 0,		{'d4+'},	dfourp,		forth	; ( d1 -- d2 ) inc double by four
ad	crea 0,		{'d4-'},	dfourm,		forth	; ( d1 -- d2 ) dec double by four 	
ad	crea 0,		{'d8+'},	deightp,	forth	; ( d1 -- d2 ) inc double by eight
ad	crea 0,		{'d8-'},	deightm,	forth	; ( d1 -- d2 ) dec double by eight	
ad	crea 0,		{'d2*'},	dmul2,		forth	; ( d1 -- d2 ) mul double by two	
ad	crea 0,		{'d4*'},	dmul4,		forth	; ( d1 -- d2 ) mul double by four	
ad	crea 0,		{'d8*'},	dmul8,		forth	; ( d1 -- d2 ) mul double by eight	
ad	crea 0,		{'d2/'},	dtwoby,		forth	; ( d1 -- d2 ) div double by two
ad	crea 0,		{'d4/'},	dfourby,	forth	; ( d1 -- d2 ) div double by four
ad	crea 0,		{'d8/'},	deightby,	forth	; ( d1 -- d2 ) div double by eight
;>; double arithm
bd	crea 0,		{'2and'},	twoand,		forth	; ( d1 d2 -- d3 ) bitwise AND doubles
bd	crea 0,		{'2invert'},	dnot,		forth	; ( d1 -- d2 ) bitwise complement a double
bd	crea 0,		{'2lshift'},	dlshift,	forth	; ( d1 n -- d2 ) shift left a double
bd	acrea 0,	{'2not'},	dnot,		fig	; ( d1 -- d2 ) one-s complement a double
bd	crea 0,		{'2or'},	twoor,		forth	; ( d1 d2 -- d3 ) bitwise OR doubles
bd	crea 0,		{'2rshift'},	drshift,	forth	; ( d1 n -- d2 ) shift right a double
bd	crea 0,		{'2rshifta'},	drshifta,	forth	; ( d1 n -- d2 ) sign preserving shift right a double
bd	crea 0,		{'2xor'},	twoxor,		forth	; ( d1 d2 -- d3 ) bitwise XOR doubles
ad	crea 0,		{'d+'},		dplus,		forth	; ( d1 d2 -- d3 ) add doubles
ad	crea 0,		{'d-'},		dsub,		forth	; ( d1 d2 -- d3 ) subtract doubles
ad	crea 0,		{'d*'},		dmul,		forth	; ( d1 d2 -- d3 ) d3=prod of mul
ad	crea 0,		{'d/'},		dby,		forth	; ( d1 d2 -- d3 ) d3=quot of div
ad	crea 0,		{'d/mod'},	dbym,		forth	; ( d1 d2 -- d3 ) d3=rmd of div
ad	crea 0,		{'d1abs'},	d1abs,		forth	; ( d1 -- d2 ) bitwise one-s cpl doubles if -ve
ad	crea 0,		{'dabs'},	dabs,		forth	; ( d1 -- d2 ) two-s cpl doubles if -ve
ad	crea 0,		{'df/mod'},	dfbym,		forth	; floored div doubles w/ remainder
ad	crea 0,		{'dmax'},	dmax,		forth	; ( d1 d2 -- d3 ) leave the greater of two doubles on tos
ad	crea 0,		{'dmin'},	dmin,		forth	; ( d1 d2 -- d3 ) leave the smaller of two doubles on tos
ad	crea 0,		{'dminus'},	dnegate,	fig	; ( d1 -- d2 ) negate a double
ad	crea 0,		{'dmod'},	dmod,		forth	; div doubles, leave double rmd
ad	acrea 0,	{'dnegate'},	dnegate,	forth	; ( d1 -- d2 ) two-s complement of a double
ad	crea 0,		{'dsgn'},	dsgn,		forth	; ( dn -- f ) f=signum(dn)
ad	crea 0,		{'dslbits'},	dslbits,	forth	; ( d1 -- d1 n ) no. of top zero-bits less 2
ad	crea 0,		{'ud*'},	udmul,		forth	; mul doubles, leave double prod
ad	crea 0,		{'ud/'},	udby,		forth	; div doubles, leave double quot
ad	crea 0,		{'ud/mod'},	udbym,		forth	; div doubles, leave double quot & rmd
ad	crea 0,		{'udsqrt'},	udsqrt,		forth	; ( d1 -- d2 n ) +ve double square root, sing 'j'-flag
;>; double a-logic
ll	crea 0,		{'?d0='},	qdzeq,		forth	; ( dn -- dn f ) tf if double @tos is zero
ll	crea 0,		{'?udcmp'},	qudcmp,		forth	; ( d1 d2 -- d1 d2 f ) f=(d1 u< d2)-(d2 u< d1)
ll	crea 0,		{'d>'},		dgreat,		forth	; tf if double @tos smaller than @nos
ll	crea 0,		{'du>'},	dugreat,	forth	; td if double @tos unsigned smaller than @nos
ll	crea 0,		{'d<'},		dless,		forth	; tf if double @tos smaller than @nos
ll	crea 0,		{'du<'},	duless,		forth	; td if double @tos unsigned smaller than @nos
ll	crea 0,		{'d='},		deq,		forth	; tf if double @tos and @nos equal
ll	crea 0,		{'d=/='},	dneq,		forth	; tf if doubles not equal
ll	acrea 0,	{'D<>'},	dneq,		ans	; tf if doubles not equal
ll	crea 0,		{'d0>'},	dzgt,		forth	; tf if double @tos -ve
ll	crea 0,		{'d0<'},	dzless,		forth	; tf if double @tos -ve
ll	crea 0,		{'d0='},	dzeq,		forth	; tf if double @tos is zero
ll	crea 0,		{'d0=/='},	dzneq,		forth	; ff if double @tos is zero
ll	acrea 0,	{'D0<>'},	dzneq,		ans	; ff if double @tos is zero
;>; mixed quad, double & sing
ac	crea 0,		{'^'},		pow,		forth	; double, sing to the power of sing
ac	crea 0,		{'d+-'},	dpm,		forth	; apply sign of sing to double @nos
ad	crea 0,		{'dgcd'},	dgcd,		forth	; greatest common denominator, doubles
ac	crea 0,		{'md*'},	mdmul,		forth	; mul doubles, leave quad prod.
ac	crea 0,		{'dm*'},	dmmul,		forth	; mul doubles, leave 3-cells prod.
ac	crea 0,		{'fm/mod'},	fmbymod,	forth	; ( d1 n2 -- n3r n4q ) floored div double by sing, ret sing rmd & qot
ac	crea 0,		{'m+'},		mplus,		forth	; ( d1 n2 -- d3 ) signed add sing to double @nos
ac	crea 0,		{'m*'},		mmul,		forth	; ( n1 n2 -- d3 ) mul sings, leave double prod
ac	crea 0,		{'m*/'},	mmulby,		forth	; ( d1 n2 n3 -- d4q ) d1 * n2 / n3
ac	crea 0,		{'um*/'},	ummulby,	forth	; ( n1 n2 n3 -- ud4q ) n1 u* n2 u/ n3
ac	crea 0,		{'udm*/mod'},	udmmulbym,	forth	; ( d1 n2 n3 -- u5r ud4q ) d1 u* n2 u/ n3
ac	crea 0,		{'m/'},		mby,		forth	; ( d1 n2 -- n3r d4q )
ac	crea 0,		{'m/mod'},	mbym,		forth	; ( d1 n2 -- n3r n4q ) vectored sm/rem(dft) or fm/mod
ac	crea 0,		{'q+-'},	qpm,		forth	; ( q1 n2 -- q3 ) apply sign of sing n1 to quad
ac	crea 0,		{'sm/rem'},	smbyrem,	forth	; ( d1 n2 -- n3r n4q ) div round near zero
ac	crea 0,		{'u^'},		upow,		forth	; ( n1 n2 -- ud3 ) unsigned double, n1 to the power of n2
ac	crea 0,		{'u+'},		uplus,		forth	; ( ud1 n2 -- ud3 ) unsigned add sing to double
ac	crea 0,		{'u*'},		umul,		forth	; ( un1 un2 -- ud3 )
ac	crea 0,		{'udm*'},	udmmul,		forth	; ( d1 n2 -- ud3 n4 ) treble prod, n4 = ovf
ac	acrea 0,	{'um*'},	umul,		forth	; ( n1 n2 -- ud3 )
ad	crea 0,		{'umd*'},	umdmul,		forth	; ( d1 d2 -- uq3 )
ac	crea 0,		{'um/'},	umby,		forth	; ( d1 n2 -- u3r ud4q )
ac	crea 0,		{'um/mod'},	umbymod,	forth	; ( d1 n2 -- u2r u3q  )
ac	crea 0,		{'umq^'},	umqpow,		forth	; ( n1 n2 -- uq3 ) unsigned quad n1^n2
;>; arithmetic
aa	crea 0,		{'+'},		plus,		forth	; ( n1 n2 -- n3 ) add sings
aa	crea 0,		{'+-'},		spm,		forth	; ( n1 n2 -- n3 ) apply sign of sing @tos to sing
aa	crea 0,		{'-'},		ssub,		forth	; ( n1 n2 -- n3 ) subtract sings
aa	crea 0,		{'*'},		smul,		forth	; ( n1 n2 -- n3 ) mul sings
aa	crea 0,		{'/mod'},	bymod,		forth	; ( n1 n2 -- n3r n4q ) div sings, leave quot & rmd
aa	crea 0,		{'/'},		by,		forth	; ( n1 n2 -- n3q ) div sings, leave quot
aa	crea 0,		{'mod'},	mod,		forth	; ( n1 n2 -- n3r ) div sings, leave rmd
aa	crea 0,		{'*/mod'},	mulbym,		forth	; ( n1 n2 n3 -- n4r n5q ) n1 / n2 * n3, rmd n4 & qot n5
aa	crea 0,		{'*/'},		mulby,		forth	; ( n1 n2 n3 -- n5q ) n1 / n2 * n3, qot n4
aa	acrea 0,	{'?NEGATE'},	spm,		ans	; ( n1 n2 -- n3 ) apply sign of sing n2 to sing n1
aa	crea 0,		{'gcd'},	gcd,		forth	; ( n1 n2 -- n3 ) greatest common denominator
;>; stack
ss	crea 0,		{'><'},		xgb,		forth	; ( n1 -- n2 ) swap l.s. two bytes of a sing
ss	crea 0,		{'>|<'},	w2b,		forth	; ( n1 -- n2 ) extract l.s. two bytes of a sing
ss	crea 0,		{'>||<'},	d2w,		forth	; ( n1 -- n2 n3 ) extract the two halves of a sing
rr	crea nopt,	{'>r'},		tor,		forth	; ( n -- ) push sing to return-stack
rr	crea nopt,	{'>rr'},	torr,		forth	; ( n -- n ) copy sing to return-stack
ss	crea 0,		{'-depth'},	mdepth,		forth	; ( -- n ) cells free in data-stack
ss	acrea 0,	{'-dup'},	qdup,		forth	; ( n | 0 -- n n | 0 ) dup @tos if non-zero
ss	crea 0,		{'-rot'},	mrot,		forth	; ( n1 n2 n3 -- n3 n2 n1 ) reverse rot, { -2 roll }
ss	crea 0,		{'depth'},	depth,		forth	; ( -- n ) count of cells on data-stack
ss	crea 0,		{'dup'},	cdup,		forth	; ( n -- n n ) duplicate @tos, { 0 pick }
ss	crea 0,		{'drop'},	drop,		forth	; ( n -- ) discard cell @tos
os	crea nopt,	{'i'},		i,		forth	; ( -- n ) copy loop index to tos
os	crea nopt,	{'j'},		j,		forth	; ( -- n ) copy 2nd order loop index to tos
os	crea nopt,	{'li'},		li,		forth	; ( n1 -- n2 ) n1-st  order loop limit to tos
ay	crea 0,		{'locals'},	locals,		forth	; ( -- n ) available cells for local data
os	crea nopt,	{'ni'},		ni,		forth	; ( n1 -- n2 ) n1-st order loop index to tos
ss	crea 0,		{'over'},	over,		forth	; ( n1 n2 -- n1 n2 n1 ) copy @nos to tos
ss	crea 0,		{'pick'},	pick,		forth	; ( .xx. n -- .xx. xn ) fetch cell wrt tos
rr	crea nopt,	{'r'},		r,		forth	; ( -- n )(R n -- n ) push @tor to @tos
rr	crea 0,		{'r+!'},	rps,		forth	; ( n -- )(R n2 -- n3 ) add to @RS
rr	crea nopt,	{'r>'},		rfrom,		forth	; ( -- n )(R n -- ) pop from ret-stack to tos
rr	acrea nopt,	{'r@'},		r,		forth	; ( -- n )(R n -- n ) push @tor to @tos (ans word)
ss	crea 0,		{'roll'},	roll,		forth	; ( .xx. n -- .. xn ) roll cells
ss	crea 0,		{'rot'},	rot,		forth	; ( n1 n2 n3 -- n2 n3 n1 ) 2 roll
rr	crea 0,		{'RP!'},	arpstore,	ans	; ( p -- )(R -- ) rst returnstack-ptr to ptr
rr	crea 0,		{'rp!'},	rpstore,	forth	; ( -- .xx. ) restore returnstack-ptr from uvari {r0}
ss	crea wcas,	{'SP!'},	aspstore,	ans	; ( p -- ) set datastack-ptr to kref'd supplied value
ss	crea 0,		{'sp!'},	fspstore,	fig	; ( -- .xx. ) rst datastack-ptr from uvari {r0}
ss	crea 0,		{'sp!'},	spstore,	forth	; ( .. -- .. ) vectored to fig or ans mode, dft fig
ss	acrea 0,	{'sp>'},	fspstore,	forth	; ( .xx. -- ) clr data-stack
ss	crea 0,		{'swap'},	swap,		forth	; ( n1 n2 -- n2 n1 ) exchange sings @tos w/ @nos
mm	crea 0,		{'unused'},	unused,		forth	; ( -- n ) free space in data-memory
ss	crea 0,		{'wswap'},	wswap,		forth	; ( n1 -- n2 ) swap hi & lo half of cell @tos
;>; b-logic, bit-opr
ma	crea 0,		{'@lshift'},	mlshift,	forth	; ( p n -- ) left shift cell in memory
ma	crea 0,		{'@rshift'},	mrshift,	forth	; ( p n -- ) right shift cell in memory
ma	crea 0,		{'@rshifta'},	mrshifta,	forth	; ( p n -- ) arithmetic shift cell in memory
bb	crea 0,		{'and'},	aand,		forth	; ( n1 n2 -- n3 ) bitwise AND sings
bb	crea 0,		{'andx'},	andx,		forth	; ( n1 n2 n3 -- n4 ) n1 n2 AND n3 XOR
bb	crea 0,		{'invert'},	invert,		forth	; ( n1 -- n2 ) 1-s complement
bb	crea 0,		{'lshift'},	lshift,		forth	; ( n1 n2 -- n3 ) shift left
bb	acrea 0,	{'not'},	invert,		forth	; ( n1 -- n2 ) flag inversion, bitwise invert, cpu opr
bb	crea 0,		{'or'},		oor,		forth	; ( n1 n2 -- n3 ) bitwise OR sings
bb	crea 0,		{'rshift'},	rshift,		forth	; ( n1 n2 -- n3 ) right shift
bb	crea 0,		{'rshifta'},	rshifta,	forth	; ( n1 n2 -- n3 ) arithmetic shift
bb	crea 0,		{'shift'},	shift,		forth	; ( n1 n2 -- n3 ) shift left
bb	crea 0,		{'xor'},	xxor,		forth	; ( n1 n2 -- n3 ) bitwise XOR sings
;>; arithm logic
ll	crea 0,		{'0>'},		zgreat,		forth	; ( n -- f ) tf if @tos > 0
ll	crea 0,		{'0='},		zeq,		forth	; ( n -- f ) tf if zero item, flag inversion
ll	crea 0,		{'0=/='},	zneq,		forth	; ( n -- f ) tf if non-zero sing
ll	acrea 0,	{'0<>'},	zneq,		ans	; ( n -- f ) tf if non-zero sing
ll	crea 0,		{'0<'},		zless,		forth	; ( n -- f ) tf if -ve sing
ll	crea 0,		{'0and'},	dng,		hidden	; ( n -- 0 ) replace @tos w/ 0
ll	crea 0,		{'='},		equal,		forth	; ( n1 n2 -- f ) tf if @tos = @nos
ll	crea 0,		{'=/='},	nequal,		forth	; ( n1 n2 -- f ) ff if @tos = @nos
ll	acrea 0,	{'<>'},		nequal,		ans	; ( n1 n2 -- f ) ff if @tos = @nos
ll	crea 0,		{'<'},		less,		forth	; ( n1 n2 -- f ) tf if @tos smaller than @nos
ll	crea 0,		{'>'},		greater,	forth	; ( n1 n2 -- f ) tf if @tos greater than @nos
aa	crea 0,		{'max'},	max,		forth	; ( n1 n2 -- f ) leave the greater of top two sings
aa	crea 0,		{'min'},	min,		forth	; ( n1 n2 -- f ) leave the smaller of top two sings
aa	crea 0,		{'minus'},	negate,		fig	; ( n1 -- n2 ) negate sing
aa	acrea 0,	{'negate'},	negate,		forth	; ( n1 -- n2 ) negate sing
aa	crea 0,		{'sgn'},	sgn,		forth	; ( n1 -- n2 ) sign of sing
bi	crea 0,		{'true='},	ftequ,		fig	; ( n -- f ) tf if cell is f.i.g.-mode 'true' value
bi	crea 0,		{'true='},	tequ,		forth	; ( n -- f ) tf if cell is ANS-mode 'true' value
ll	crea 0,		{'u>'},		ugreater,	forth	; ( n1 n2 -- f ) tf if unsigned @tos greater than @nos
ll	crea 0,		{'u<'},		uless,		forth	; ( n1 n2 -- f ) tf if unsigned @tos smaller than @nos
aa	crea 0,		{'umax'},	umax,		forth	; ( n1 n2 -- n3 ) leave unsigned greater of top two sings
aa	crea 0,		{'umin'},	umin,		forth	; ( n1 n2 -- n3 ) leave unsigned smaller of top two sings
aa	crea 0,		{'uwithin?'},	uwithinq,	forth	; unsigned test & adjust 3rd w/ range of 2nd..1st
ll	crea 0,		{'within'},	within,		forth	; un/signed test 3rd w/ range of 2nd..1st
aa	crea 0,		{'within?'},	withinq,	forth	; signed test & adjust 3rd w/ range of 2nd..1st
;[ list]
;;zz	crea 0,		{'p1'},		p1,		forth	; TEST
;ccas 6-*; args: name, wordlist,datalabel,type(0,ff), item(s); :test: {case:} :ok:
;;zz	ccas {'tcc'},testvoc,tcc,0,Idel,0,0,0,0,0,0,Ibel,Ibs,Itab,0,0,Iclsc,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,Ihome,Icrgt
; ---
ww	crea pfax|varf|4,{'task'},	task,		forth	; traditionally the forth kernel top word...
	nxvari 3	; reserve 3 dwords in data-space for reloc. data, etc
;			; pfa is kref'd pc-rel disp to xec, body stores 1st item ptr to data-space
;:
;: terminal header data :: :HIER: strt! an den anfang legen - falls der trottelige "nasm" da mitspielt...
;:
;;mincode:
.b:	dd minptr	; kref'd lowest executeable entry
.t:	dd vocbase-Y	; top of xec aerea
.n:	db '-ND-'
;
%ifdef __RATIONAL
	endvoc float
	endvoc rational
	endvoc rahidden
	endvoc racons
%endif
; ---
; vocabulary linkage, wordlist end, stored to <vhead.e> posn in voc. header
	endvoc ans
	endvoc assembler
	endvoc blkfile
	endvoc compiler
	endvoc vt
	endvoc editor
	endvoc fig
	endvoc nonmmx
	endvoc forth
	endvoc hidden
	endvoc bignum
	endvoc linux
	endvoc local
	endvoc root
	endvoc testvoc
	endvoc tools
	endvoc environment
	endvoc systm
	endvoc utility
	endvoc novoc
toplink:equ Lz-lastlink	; last word in system, <Lz>, in module header at mhead.s
topvoc:	equ Tz-prevlink	; latest wordlist, <Tz>, in module header at mhead.t

;:
;: terminal header data :: :HIER: strt! an den anfang legen - falls der trottelige "nasm" da mitspielt...
;:
mincode:
.b:	dd minptr	; kref'd lowest executeable entry
.t:	dd vocbase-Y	; top of xec aerea
.n:	db '-ND-'
tophead:		; end of kernel headers
	dd variptr	; initially reserved data-space
.i:
	dd lkindex
.e:
	dd '[.hpr01]'	; -END- marker
;
	align 128, db -1
%else;__LIB4W
%error "l4words.inc multiply included"
%endif
;-
;-
;-================================================================
;- l4words.inc <eof> ;[list]
